/*
 *      Web server handler routines for APP
 *      Authors: 
 *
 */

/*-- System inlcude files --*/
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <sys/wait.h>
#include <semaphore.h>
#ifdef EMBED
#include <linux/config.h>
#else
#include "../../../uClibc/include/linux/autoconf.h"
#endif

/* for ioctl */
#include <sys/ioctl.h>
#include <net/if.h>

#include "../webs.h"
#include "fmdefs.h"
#include "mib.h"
#include "utility.h"
#include "debug.h"
#include "../defs.h"
#include <config/autoconf.h>

/*****************************
** IGMP SNOOPING
*/
int initPageIgmpSnooping(int eid, webs_t wp, int argc, char_t ** argv)
{
	//IGMP Snooping:		
	unsigned char	igmpSnoopEnble = 1;	//1- ;  0- 
	int				lineno = __LINE__;
        unsigned char       vChar;
	_TRACE_CALL;

	/************Place your code here, do what you want to do! ************/
	
          mib_get(MIB_MPMODE, (void *)&vChar);
	  igmpSnoopEnble=(vChar>>2)&0x01;
	_PUT_BOOL(igmpSnoopEnble);

check_err:
	_TRACE_LEAVEL;
	return 0;
}

void formIgmpSnooping(webs_t wp, char_t *path, char_t *query)
{
	//IGMP Snooping:		
	unsigned char	igmpSnoopEnble = 0;	//1- ;  0- 
	char*			stemp = "";
	int				lineno = __LINE__;

	_TRACE_CALL;

	_GET_BOOL(igmpSnoopEnble, _NEED);
	
	/************Place your code here, do what you want to do! ************/
	/************Place your code here, do what you want to do! ************/
	
        char mode ;
	char origmode = 0;
	int igmp_changed_flag = 0;
	
		// bitmap for virtual lan port function
		// Port Mapping: bit-0
		// QoS : bit-1
		// IGMP snooping: bit-2
		mib_get(MIB_MPMODE, (void *)&mode);
		origmode = mode;
		
		if (igmpSnoopEnble) {
			mode |= 0x04;
			if(origmode != mode)
				igmp_changed_flag = 1;
			// take effect immediately
			
			//__dev_register_swport();
			
			__dev_setupIGMPSnoop(1);
			
		}
		else {
			mode &= 0xfb;
			if(origmode != mode)
				igmp_changed_flag = 1;
			__dev_setupIGMPSnoop(0);
			if (mode==0)
				__dev_setupVirtualPort(0); // disable virtual port
		}
		mib_set(MIB_MPMODE, (void *)&mode);
	  if(igmp_changed_flag)
               mib_update(CURRENT_SETTING, CONFIG_MIB_ALL);                     
       
	_COND_REDIRECT;
check_err:
	_TRACE_LEAVEL;
	return;
}

#ifdef CONFIG_USER_IGMPPROXY
/*****************************
** IGMP PROXY
*/

int igmproxyList(int eid, webs_t wp, int argc, char_t ** argv)
{
	struct igmproxy_entry	entry ;
	int				cnt = 2;
	int				index = 0;
	int				lineno = __LINE__;

        unsigned int entryNum, i;
		
	MIB_CE_ATM_VC_T Entry;
        char wanname[40];
        unsigned char igmp_proxy;
	_TRACE_CALL;
	
	entryNum = mib_chain_total(MIB_ATM_VC_TBL);
	for (i=0; i<entryNum; i++) 
	{
		if (!mib_chain_get(MIB_ATM_VC_TBL, i, (void *)&Entry))
		{
  			websError(wp, 400, T("Get chain record error!\n"));
			return -1;
		}
		
		if (Entry.enable == 0)
			continue;
		if(Entry.cmode == ADSL_MER1483||Entry.cmode == ADSL_PPPoA||Entry.cmode == ADSL_PPPoE||Entry.cmode == ADSL_RT1483)
		{
			memset(&entry, 0, sizeof(struct igmproxy_entry));
			memset(wanname, 0, sizeof(wanname));
			getWanName(&Entry, wanname);
			strcpy(entry.ifName,wanname);
			entry.enable= Entry.igmpproxyenable;
                       
			websWrite(wp, T("push(new it_nr(\"%d\"" _PTS _PTI "));\n"), 
			entryNum, _PME(ifName), _PME(enable));
		}	
		
	}
		
check_err:
	_TRACE_LEAVEL;
	return 0;
}

//ҳύaction:	
void formIgmproxy (webs_t wp, char_t *path, char_t *query)
{
	struct igmproxy_entry	entry;
	char*			stemp = "";
	int				index = 0;
	int				lineno = __LINE__;
	unsigned int entryNum, i;
	MIB_CE_ATM_VC_T Entry;
	char wanname[40];
	
	_BC_USE;
	
	_TRACE_CALL;

	_BC_INIT("bcdata");

	  while(_BC_NEXT())
	 {
		memset(&entry, 0, sizeof(struct igmproxy_entry));
		_BC_ENTRY_STR(ifName, _BC_NEED);
		_BC_ENTRY_INT(enable, _BC_NEED);
		if(entry.enable < 0 || entry.enable > 1){lineno = __LINE__; continue;}

		/************Place your code here, do what you want to do! ************/
		/************Place your code here, do what you want to do! ************/
               entryNum = mib_chain_total(MIB_ATM_VC_TBL);
		
		
	       
	        for (i=0; i<entryNum; i++) 
	       {
	      
	              if (!mib_chain_get(MIB_ATM_VC_TBL, i, (void *)&Entry))
		      {
  			 websError(wp, 400, T("Get chain record error!\n"));
			 return -1;
		       }
                      getWanName(&Entry, wanname);

		      if(!strcmp(entry.ifName,wanname)){
                        if(entry.enable){

				 Entry.igmpproxyenable =1;
						  
                       	}else 
			  Entry.igmpproxyenable =0;
			   
		       mib_chain_update(MIB_ATM_VC_TBL, (void *)&Entry,i);
		       break;
		       }
		 		
		 }
			
	      }
		   
#ifdef EMBED
	 startIgmproxy();
#endif

	 mib_update(CURRENT_SETTING, CONFIG_MIB_ALL);
	
	_COND_REDIRECT;
check_err:
	_BC_FREE();
	_TRACE_LEAVEL;
	return;
}

#endif

#ifdef CONFIG_USER_DDNS

#define	DDNS_ADD	0
#define DDNS_MODIFY	1
/*****************************
**DDNS
*/
int showDNSTable(int eid, webs_t wp, int argc, char_t **argv)
{
	//DDNS:		
	unsigned char	ddnsEnable = 1;	//1- ;  0- 
	struct ddns_entryx	entry = {"pro", "hostname", "INTERNET_R_0_0_32", "user", "user"};
	int				cnt = 2;
	int				index = 0;
	int				lineno = __LINE__;
	MIB_CE_DDNS_T Entry;
	int totalEntry,i;

	_TRACE_CALL;

	/************Place your code here, do what you want to do! ************/
	/************Place your code here, do what you want to do! ************/

	mib_get(MIB_DDNS_ENABLE,(void*)&ddnsEnable);

	_PUT_BOOL(ddnsEnable);

	memset(&entry,0,sizeof(entry));

	totalEntry=mib_chain_total(MIB_DDNS_TBL);

	for(i = 0; i < totalEntry; i++)
	{
		/************Place your code here, do what you want to do! ************/
		/************Place your code here, do what you want to do! ************/
		if(mib_chain_get(MIB_DDNS_TBL,i,(void*)&Entry)!=1)
			continue;

		strncpy(entry.provider,Entry.provider,10);
		strncpy(entry.username,Entry.username,35);
		strncpy(entry.hostname,Entry.hostname,35);
		strncpy(entry.ifname,Entry.ifname,32);
		
		websWrite(wp, T("push(new it_nr(\"%d\"" _PTS _PTS _PTS _PTS "));\n"), 
			index, _PME(provider), _PME(hostname), _PME(ifname), _PME(username));
	}
		
	
check_err:
	_TRACE_LEAVEL;
	return 0;
}
/*
 *	type:
 *		DDNS_ADD(0):	entry to add
 *		DDNS_MODIFY(1):	entry to modify
 *	Return value:
 *	-1	: fail
 *	0	: successful
 *	pMsg	: error message
 */
static int checkEntry(MIB_CE_DDNS_Tp pEntry, int type, char *pMsg)
{
	MIB_CE_DDNS_T tmpEntry;
	int num, i;
	
	num = mib_chain_total(MIB_DDNS_TBL); /* get chain record size */
	// check duplication
	for (i=0; i<num; i++) {
		mib_chain_get(MIB_DDNS_TBL, i, (void *)&tmpEntry);
		if (type == DDNS_MODIFY) { // modify
			if (pEntry->Enabled != tmpEntry.Enabled)
				continue;
		}
		if (gstrcmp(pEntry->provider, tmpEntry.provider))
			continue;
		if (gstrcmp(pEntry->hostname, tmpEntry.hostname))
			continue;
		if (gstrcmp(pEntry->interface, tmpEntry.interface))
			continue;
		if (gstrcmp(pEntry->username, tmpEntry.username))
			continue;
		if (gstrcmp(pEntry->password, tmpEntry.password))
			continue;
		if (pEntry->ServicePort != tmpEntry.ServicePort)
			continue;
		// entry duplication
		strcpy(pMsg, T("Entry already exists!"));
		return -1;
	}
	return 0;
}

static int  getifname(char *wanif, char *wanname, unsigned int ifidx)
{
	MIB_CE_ATM_VC_T Entry;
	int total,i;

	total = mib_chain_total(MIB_ATM_VC_TBL);

	for(i=0;i<total;i++){
		if(!mib_chain_get(MIB_ATM_VC_TBL,i,&Entry))
			continue;
		printf("\nEntry.ifindex=%d,ifidx=%d\n",Entry.ifIndex,ifidx);
		if(ifidx==Entry.ifIndex){
			if (Entry.cmode == ACC_PPPOE || Entry.cmode == ACC_PPPOA)
			{
				snprintf(wanif, 6, "ppp%u", PPP_INDEX(ifidx));
			}
			else
				{
				snprintf(wanif, 6, "vc%u", VC_INDEX(ifidx));
				
				}
			getWanName(&Entry,wanname);
			printf("\nname=%s %s\n",wanif,wanname);
			return 0;
		}
	}
	return -1;

}

//ҳύaction:		
void formDDNS(webs_t wp, char_t *path, char_t *query)
{
	//DDNS:		
	unsigned char	ddnsEnable = 1;	//1- ;  0- 
	struct ddns_entryx	entry;
	char*			stemp = "";
	int				index = 0;
	int				lineno = __LINE__;
	_BC_USE;

	MIB_CE_DDNS_T Entry;
	int totalEntry,i;
	char tmpBuf[100];
	char wan_lan_if[10];
	char wanname[32];
	unsigned int ifidx;

	_TRACE_CALL;

	FETCH_INVALID_OPT(stemp, "action", _NEED);

	memset(&entry,0,sizeof(entry));
	memset(&Entry,0,sizeof(Entry));
	
	if(strcmp(stemp, "sw") == 0)	//switch
	{
		_GET_BOOL(ddnsEnable, _NEED);

		/************Place your code here, do what you want to do! ************/
		/************Place your code here, do what you want to do! ************/
		if(!mib_set(MIB_DDNS_ENABLE,(void*)&ddnsEnable)){
			strcpy(tmpBuf, T("DDNSʹܴ!"));
			goto setErr_ddns;
		}
	}
	else if(strcmp(stemp, "rm") == 0)	//remove
	{
		_BC_INIT("bcdata");
		while(_BC_NEXT())
		{
			_BC_ENTRY_STR(provider, _NEED);
			_BC_ENTRY_STR(hostname, _NEED);
			_BC_ENTRY_STR(ifname, _NEED);
			_BC_ENTRY_STR(username, _NEED);


			/************Place your code here, do what you want to do! ************/
			/*please remove this entry from MIB */

			totalEntry=mib_chain_total(MIB_DDNS_TBL);

			for(i = 0; i < totalEntry; i++)
			{
				if(mib_chain_get(MIB_DDNS_TBL,i,(void*)&Entry)!=1)
					continue;

				if(!strcmp(entry.provider,Entry.provider)&&
					!strcmp(entry.username,Entry.username)&&
					!strcmp(entry.hostname,Entry.hostname)&&
					!strcmp(entry.ifname,Entry.ifname)){
					if(mib_chain_delete(MIB_DDNS_TBL, i) != 1) {
						strcpy(tmpBuf, T(strDelChainerror));
						goto setErr_ddns;
					}
					break;
				}
			}
		}
	}
	else if(strcmp(stemp, "ad") == 0)	//ad
	{
		_ENTRY_STR(provider, _NEED);
		_ENTRY_STR(hostname, _NEED);
		_ENTRY_STR(ifname, _NEED);

		/************Place your code here, do what you want to do! ************/
		/************Place your code here, do what you want to do! ************/
		strncpy(Entry.provider,entry.provider,10);
		strncpy(Entry.hostname,entry.hostname,35);
		
		if(!strcmp(entry.ifname,"LAN")){
				snprintf(wan_lan_if,"%s","br0");
				strncpy(wanname,entry.ifname,32);
		}
		else{
				sscanf(entry.ifname,"%u",&ifidx);

				int tmp=getifname(wan_lan_if,wanname,ifidx);

				if(tmp==-1){
					strcpy(tmpBuf, T("wan˿ڴ!"));
					goto setErr_ddns;
				}

				printf("\nifidx=%d,ifname=%s\n",ifidx,wan_lan_if);
		}
		strncpy(Entry.interface,wan_lan_if,10);
		strncpy(Entry.ifname,wanname,32);
		
		if(!strcmp(Entry.provider,"dyndns")){
			FETCH_INVALID_OPT(stemp, "dynusername", _NEED);
			strncpy(Entry.username,stemp,35);
			FETCH_INVALID_OPT(stemp, "dynpassword", _NEED);
			strncpy(Entry.password,stemp,35);
		}else if(!strcmp(Entry.provider,"gnudip")){
			FETCH_INVALID_OPT(stemp, "gnudipusername", _NEED);
			strncpy(Entry.username,stemp,35);
			FETCH_INVALID_OPT(stemp, "gnudippassword", _NEED);
			strncpy(Entry.password,stemp,35);
		}else{
			FETCH_INVALID_OPT(stemp, "tzoEmail", _NEED);
			strncpy(Entry.username,stemp,35);
			FETCH_INVALID_OPT(stemp, "tzoKey", _NEED);
			strncpy(Entry.password,stemp,35);
		}

		if (checkEntry(&Entry, DDNS_ADD, &tmpBuf[0]) == -1)
			goto setErr_ddns;

		Entry.Enabled=1;
		
		if(mib_chain_add(MIB_DDNS_TBL, (unsigned char*)&Entry) != 1){
			strcpy(tmpBuf, T("DDNS¼!"));
			goto setErr_ddns;
		}
		cmd_ddnsctrl("all");
	}
	//else {lineno = __LINE__; goto check_err;}

#ifdef WRITE_TO_FLASH
	mib_update(CURRENT_SETTING, CONFIG_MIB_ALL);
#endif
	
	_COND_REDIRECT;
	return;
check_err:
	_BC_FREE();
	_TRACE_LEAVEL;
	return;
setErr_ddns:
	ERR_MSG(tmpBuf);
}
#endif
#ifdef CONFIG_IP_NF_ALG_ONOFF
/*****************************
**߼NAT
*/
int showAlgConfig(int eid, webs_t wp, int argc, char_t **argv)
{
	//H.323:	
	unsigned char	algTypeH323 = 1;	//1- ;  0- 
	//RTSP:	
	unsigned char	algTypeRtsp = 1;
	//L2TP:	
	unsigned char	algTypeL2tp = 1;
	//IPSEC:	
	unsigned char	algTypeIpsec = 1;
	//SIP:		
	unsigned char	algTypeSip = 1;
	int				lineno = __LINE__;

	_TRACE_CALL;

	/************Place your code here, do what you want to do! ************/
	#ifdef CONFIG_IP_NF_H323
	mib_get(MIB_IP_ALG_H323,&algTypeH323);
	#endif
	#ifdef CONFIG_IP_NF_RTSP
	mib_get(MIB_IP_ALG_RTSP,&algTypeRtsp);
	#endif
	#ifdef CONFIG_IP_NF_L2TP
	mib_get(MIB_IP_ALG_L2TP,&algTypeL2tp);
	#endif
	#ifdef CONFIG_IP_NF_IPSEC
	mib_get(MIB_IP_ALG_IPSEC,&algTypeIpsec);
	#endif
	#ifdef CONFIG_IP_NF_SIP
	mib_get(MIB_IP_ALG_SIP,&algTypeSip);
	#endif
	/************Place your code here, do what you want to do! ************/

	_PUT_BOOL(algTypeH323);
	_PUT_BOOL(algTypeRtsp);
	_PUT_BOOL(algTypeL2tp);
	_PUT_BOOL(algTypeIpsec);
	_PUT_BOOL(algTypeSip);
	
check_err:
	_TRACE_LEAVEL;
	return 0;
}

//ҳύaction:		
void formALGOnOff(webs_t wp, char_t *path, char_t *query)
{
	//H.323:	
	unsigned char	algTypeH323;	//1- ;  0- 
	//RTSP:	
	unsigned char	algTypeRtsp;
	//L2TP:	
	unsigned char	algTypeL2tp;
	//IPSEC:	
	unsigned char	algTypeIpsec;
	//SIP:		
	unsigned char	algTypeSip;
	char*			stemp = "";
	int				lineno = __LINE__;

	_TRACE_CALL;

	_GET_BOOL(algTypeH323, _NEED);
	_GET_BOOL(algTypeRtsp, _NEED);
	_GET_BOOL(algTypeL2tp, _NEED);
	_GET_BOOL(algTypeIpsec, _NEED);
	_GET_BOOL(algTypeSip, _NEED);

	/************Place your code here, do what you want to do! ************/	
	#ifdef CONFIG_IP_NF_H323
	mib_set(MIB_IP_ALG_H323,&algTypeH323);
	#endif
	#ifdef CONFIG_IP_NF_RTSP
	mib_set(MIB_IP_ALG_RTSP,&algTypeRtsp);
	#endif
	#ifdef CONFIG_IP_NF_L2TP
	mib_set(MIB_IP_ALG_L2TP,&algTypeL2tp);
	#endif
	#ifdef CONFIG_IP_NF_IPSEC
	mib_set(MIB_IP_ALG_IPSEC,&algTypeIpsec);
	#endif
	#ifdef CONFIG_IP_NF_SIP
	mib_set(MIB_IP_ALG_SIP,&algTypeSip);
	#endif
	/************Place your code here, do what you want to do! ************/
	setupAlgOnOff();
	_COND_REDIRECT;
check_err:
	_TRACE_LEAVEL;
	return;
}

#endif
/*****************************
**DMZ
*/
#ifdef DMZ_SUPPORT
int showDmzConfig(int eid, webs_t wp, int argc, char_t **argv)
{
	//DMZ:		
	unsigned char	dmzEnable = 1;	//1- ;  0- 
	//DMZIP:		
	unsigned int	dmzIp = 0x88888888;
	int				lineno = __LINE__;

	_TRACE_CALL;

	/************Place your code here, do what you want to do! ************/
	mib_get(MIB_DMZ_ENABLE,&dmzEnable);
	mib_get(MIB_DMZ_IP,&dmzIp);
	/************Place your code here, do what you want to do! ************/

	_PUT_BOOL(dmzEnable);
	_PUT_IP(dmzIp);
	
check_err:
	_TRACE_LEAVEL;
	return 0;
}
#endif
//ҳύaction:	
#ifdef DMZ_SUPPORT
void formDMZ(webs_t wp, char_t *path, char_t *query)
{
	//DMZ:		
	unsigned char	dmzEnable = 0;	//1- ;  0- 
	//DMZIP:		
	unsigned int	dmzIp = 0;
	char*			stemp = "";
	int				lineno = __LINE__;

	_TRACE_CALL;

	_GET_BOOL(dmzEnable, _NEED);
	if(dmzEnable)
	{
		_GET_IP(dmzIp, _NEED);
	}
	//setupDMZ(DMZ_DISABLED);
	/************Place your code here, do what you want to do! ************/
	mib_set(MIB_DMZ_ENABLE,&dmzEnable);
	if(dmzEnable) mib_set(MIB_DMZ_IP,&dmzIp);
	/************Place your code here, do what you want to do! ************/
	//setupDMZ(DMZ_ENABLED);

#ifdef WRITE_TO_FLASH
	mib_update(CURRENT_SETTING, CONFIG_MIB_ALL);
#endif
	setupFirewall();
	
	_COND_REDIRECT;
check_err:
	_TRACE_LEAVEL;
	return;
}
#endif
#ifdef VIRTUAL_SERVER_SUPPORT
int virtualSvrLeft(int eid, webs_t wp, int argc, char_t **argv)
{
	websWrite(wp,"document.all(\"numleft\").innerHTML=\"%d\";\n",VIRTUAL_SERVER_RULES-mib_chain_total(MIB_VIRTUAL_SVR_TBL));
}
/*****************************
**
*/
int virtualSvrList (int eid, webs_t wp, int argc, char_t **argv)
{
	struct vtlsvr_entryx	entry ;
	char			serverIp[16];
	int				cnt = mib_chain_total(MIB_VIRTUAL_SVR_TBL);
	int				index = 0;
	int				lineno = __LINE__;

	_TRACE_CALL;

	/************Place your code here, do what you want to do! ************/
	/************Place your code here, do what you want to do! ************/

	for(index = 0; index < cnt; index++)
	{
		/************Place your code here, do what you want to do! ************/
		mib_chain_get(MIB_VIRTUAL_SVR_TBL,index,&entry);
		/************Place your code here, do what you want to do! ************/
		websWrite(wp, T("push(new it_nr(\"%d\"" _PTS _PTS _PTI _PTI _PTI _PTI "));\n"), 
			index, _PMEIP(serverIp), _PME(svrName), _PME(wanStartPort), _PME(wanEndPort),
			_PME(lanPort), _PME(protoType));
	}
		
check_err:
	_TRACE_LEAVEL;
	return 0;
}
#endif
//ҳύaction:	
#ifdef VIRTUAL_SERVER_SUPPORT
void formVrtsrv(webs_t wp, char_t *path, char_t *query)
{
	struct vtlsvr_entryx	entry;
	char*			stemp = "";
	int				index = 0;
	int				lineno = __LINE__;	
	_BC_USE;		
	_TRACE_CALL;

	FETCH_INVALID_OPT(stemp, "action", _NEED);
	//setupVtlsvr(VIRTUAL_SERVER_DELETE);
	if(strcmp(stemp, "rm") == 0)	//remove
	{
		_BC_INIT("bcdata");

		while(_BC_NEXT())
		{
			memset(&entry, 0, sizeof(struct vtlsvr_entryx));
			_BC_ENTRY_IP(serverIp, _BC_NEED);
			_BC_ENTRY_STR(svrName, _BC_NEED);
			_BC_ENTRY_INT(wanStartPort, _BC_NEED);
			if(entry.wanStartPort == 0){lineno = __LINE__; continue;}
			_BC_ENTRY_INT(wanEndPort, _BC_NEED);
			if(entry.wanStartPort < entry.wanStartPort || entry.wanStartPort > 65535){lineno = __LINE__; continue;}
			_BC_ENTRY_INT(lanPort, _BC_NEED);
			if(entry.lanPort == 0){lineno = __LINE__; continue;}
			_BC_ENTRY_INT(protoType, _BC_NEED);
			if(entry.protoType < 0 || entry.protoType > 3){lineno = __LINE__; continue;}

			/************Place your code here, do what you want to do! ************/
			/*look up*/
			//MIB_CHAIN_DELETE(MIB_VIRTUAL_SVR_TBL,struct vtlsvr_entryx,entry);
			int cnt=mib_chain_total(MIB_VIRTUAL_SVR_TBL);
			int mib_index=0;
			struct vtlsvr_entryx mibentry;
			for(mib_index=0;mib_index<cnt;mib_index++)
			{
			mib_chain_get(MIB_VIRTUAL_SVR_TBL,mib_index,&mibentry);			
			if(!memcmp(&mibentry,&entry,(sizeof(struct vtlsvr_entryx)-sizeof(entry.InstanceNum))))		
					{
					mib_chain_delete(MIB_VIRTUAL_SVR_TBL, mib_index);
					break;
				}
			}
			
			/************Place your code here, do what you want to do! ************/
		}
	}
	else if(strcmp(stemp, "ad") == 0)	//ad
	{
		_BC_INIT("bcdata");
		if(mib_chain_total(MIB_VIRTUAL_SVR_TBL)>=VIRTUAL_SERVER_RULES)
			{
			ERR_MSG("Բ,Ѵ!");
			goto check_err;
			}
		while(_BC_NEXT())
		{
			memset(&entry, 0, sizeof(struct vtlsvr_entryx));
			_BC_ENTRY_IP(serverIp, _BC_NEED);
			_BC_ENTRY_STR(svrName, _BC_NEED);
			_BC_ENTRY_INT(wanStartPort, _BC_NEED);
			if(entry.wanStartPort == 0){lineno = __LINE__; continue;}
			_BC_ENTRY_INT(wanEndPort, _BC_NEED);
			if(entry.wanStartPort < entry.wanStartPort || entry.wanStartPort > 65535){lineno = __LINE__; continue;}
			_BC_ENTRY_INT(lanPort, _BC_NEED);
			if(entry.lanPort == 0){lineno = __LINE__; continue;}
			_BC_ENTRY_INT(protoType, _BC_NEED);
			if(entry.protoType < 0 || entry.protoType > 3){lineno = __LINE__; continue;}

			/************Place your code here, do what you want to do! ************/
			/*add new*/			
			mib_chain_add(MIB_VIRTUAL_SVR_TBL,&entry);			
			/************Place your code here, do what you want to do! ************/
		}
	}
	else {lineno = __LINE__; goto check_err;}
	//setupVtlsvr(VIRTUAL_SERVER_ADD);
	setupFirewall();
	mib_update(CURRENT_SETTING, CONFIG_MIB_ALL);
	_COND_REDIRECT;
check_err:
	_BC_FREE();
	_TRACE_LEAVEL;
	return;
}
#endif
/*****************************
**˿ڴ
*/
#ifdef PORT_TRIGGER_SUPPORT
int portTriggerLeft(int eid, webs_t wp, int argc, char_t **argv)
{
	websWrite(wp,"document.all(\"numleft\").innerHTML=\"%d\";\n",PORT_TRIGGER_RULES-mib_chain_total(MIB_PORT_TRIGGER_TBL));
}
int PortTriggerList(int eid, webs_t wp, int argc, char_t **argv)
{
	struct porttrigger_entry	entry = {"msn", 80, 81, 1, 8080, 8081, 2};
	int				cnt = 3;
	int				index = 0;
	int				lineno = __LINE__;

	_TRACE_CALL;

	/************Place your code here, do what you want to do! ************/
	cnt=mib_chain_total(MIB_PORT_TRIGGER_TBL);
	/************Place your code here, do what you want to do! ************/

	for(index = 0; index < cnt; index++)
	{
		/************Place your code here, do what you want to do! ************/
		mib_chain_get(MIB_PORT_TRIGGER_TBL,index,&entry);
		/************Place your code here, do what you want to do! ************/
		
		websWrite(wp, T("rcs.push(new it_nr(\"%d\"" _PTS _PTI _PTI _PTI _PTI _PTI _PTI "));\n"), 
			index, _PME(appName), _PME(trigStartPort), _PME(trigEndPort), _PME(trigProto),
			_PME(openStartPort), _PME(openEndPort), _PME(openProto));
	}
		
	
check_err:
	_TRACE_LEAVEL;
	return 0;
}

//ҳύaction:		
void formPortTrigger(webs_t wp, char_t *path, char_t *query)
{
	struct porttrigger_entry	entry;
	char*			stemp = "";
	int				index = 0;
	int				lineno = __LINE__;
	_BC_USE;
	
	_TRACE_CALL;

	FETCH_INVALID_OPT(stemp, "action", _NEED);
	setupPortTrigger(PORT_TRIGGER_DELETE);
	if(strcmp(stemp, "rm") == 0)	//remove
	{
		_BC_INIT("bcdata");

		while(_BC_NEXT())
		{
			memset(&entry, 0, sizeof(struct porttrigger_entry));
			_BC_ENTRY_STR(appName, _BC_NEED);
			_BC_ENTRY_INT(trigStartPort, _BC_NEED);
			if(entry.trigStartPort == 0){lineno = __LINE__; goto check_err;}
			_BC_ENTRY_INT(trigEndPort, _BC_NEED);
			if(entry.trigEndPort < entry.trigStartPort){lineno = __LINE__; goto check_err;}
			_BC_ENTRY_INT(trigProto, _BC_NEED);
			if(entry.trigProto < 0 || entry.trigProto > 3){lineno = __LINE__; goto check_err;}
			_BC_ENTRY_INT(openStartPort, _BC_NEED);
			if(entry.openStartPort == 0){lineno = __LINE__; goto check_err;}
			_BC_ENTRY_INT(openEndPort, _BC_NEED);
			if(entry.openEndPort < entry.openStartPort){lineno = __LINE__; goto check_err;}
			_BC_ENTRY_INT(openProto, _BC_NEED);
			if(entry.openProto < 0 || entry.openProto > 3){lineno = __LINE__; goto check_err;}

			/************Place your code here, do what you want to do! ************/
			/*look up*/
			MIB_CHAIN_DELETE(MIB_PORT_TRIGGER_TBL,struct porttrigger_entry,entry);			
			/************Place your code here, do what you want to do! ************/
		}
	}
	else if(strcmp(stemp, "ad") == 0)	//ad
	{
		if(mib_chain_total(MIB_PORT_TRIGGER_TBL)>=PORT_TRIGGER_RULES)
			{
			ERR_MSG("Բ,Ѵ!");
			goto check_err;
			}
		_BC_INIT("bcdata");

		while(_BC_NEXT())
		{
			memset(&entry, 0, sizeof(struct porttrigger_entry));
			_BC_ENTRY_STR(appName, _BC_NEED);
			_BC_ENTRY_INT(trigStartPort, _BC_NEED);
			if(entry.trigStartPort == 0){lineno = __LINE__; goto check_err;}
			_BC_ENTRY_INT(trigEndPort, _BC_NEED);
			if(entry.trigEndPort < entry.trigStartPort){lineno = __LINE__; goto check_err;}
			_BC_ENTRY_INT(trigProto, _BC_NEED);
			if(entry.trigProto < 0 || entry.trigProto > 3){lineno = __LINE__; goto check_err;}
			_BC_ENTRY_INT(openStartPort, _BC_NEED);
			if(entry.openStartPort == 0){lineno = __LINE__; goto check_err;}
			_BC_ENTRY_INT(openEndPort, _BC_NEED);
			if(entry.openEndPort < entry.openStartPort){lineno = __LINE__; goto check_err;}
			_BC_ENTRY_INT(openProto, _BC_NEED);
			if(entry.openProto < 0 || entry.openProto > 3){lineno = __LINE__; goto check_err;}

			/************Place your code here, do what you want to do! ************/
			/*add new*/
			mib_chain_add(MIB_PORT_TRIGGER_TBL, &entry);
			/************Place your code here, do what you want to do! ************/
		}
	}
	else {lineno = __LINE__; goto check_err;}
	setupPortTrigger(PORT_TRIGGER_ADD);
	mib_update(CURRENT_SETTING, CONFIG_MIB_ALL);
	_COND_REDIRECT;
check_err:
	_BC_FREE();
	_TRACE_LEAVEL;
	return;
}
#endif

/*****************************
** UPNP
*/
int initPageUpnp(int eid, webs_t wp, int argc, char_t ** argv)
{
	//:			
	unsigned char	upnpEnable ;	//1- enable;  0- disable
	int				lineno = __LINE__;
      
	_TRACE_CALL;

	mib_get(MIB_UPNP_DAEMON, (void *)&upnpEnable);

	_PUT_BOOL(upnpEnable);

check_err:
	_TRACE_LEAVEL;
	return 0;
}

void formUpnp(webs_t wp, char_t *path, char_t *query)
{
	//:			
	unsigned char	upnpEnable ;	//1- enable;  0- disable
	char*			stemp = "";
	int				lineno = __LINE__;

	_TRACE_CALL;

	_GET_BOOL(upnpEnable, _NEED);
	
	mib_set(MIB_UPNP_DAEMON, (void *)&upnpEnable);
	
	_COND_REDIRECT;
check_err:
	_TRACE_LEAVEL;
	return;
}

/*****************************
** ճӦ
*/
/// This setting should sync with usbmount user tool
extern unsigned int file_read_number(const char *filename) ;
extern int usb_get_partition_name(int id, char *namebuf, int buflen) ;

int listUsbDevices(int eid, webs_t wp, int argc, char_t ** argv)
{
	unsigned int	mask;
	char			path[1024] = "/usb1";
	int				index = 0;
	int				errcode = 1, lineno = __LINE__;

	_TRACE_CALL;

	/************Place your code here, do what you want to do! ************/
	mask = file_read_number(USB_MNT_FILE);
	/************Place your code here, do what you want to do! ************/

	for(index = 0; index < 32; index++)
	{
		/************Place your code here, do what you want to do! ************/
		if (!(mask & (1 << index)))
			continue;
		if(usb_get_partition_name(index, path, sizeof(path)) < 0)continue;
		/************Place your code here, do what you want to do! ************/
		
		websWrite(wp, T("push(new it_nr(\"%d\"" _PTS "));\n"), \
			index, _PMEX(path));
	}		
	
check_err:
	_TRACE_LEAVEL;
	return 0;
}

int initPageApplication(int eid, webs_t wp, int argc, char_t ** argv)
{
	//FTP:				
	unsigned char	ftpEnable = 0;
	int				errcode = 1, lineno = __LINE__;
	int cnt;
	MIB_CE_ACC_T accEntry={0};
	int acc_nums=mib_chain_total(MIB_ACC_TBL);

	_TRACE_CALL;

	/************Place your code here, do what you want to do! ************/
	//mib_get(MIB_BFTPD_ENABLE, (void *) &ftpEnable);	
	for(cnt=0; cnt < acc_nums; cnt++)
	{
		memset(&accEntry, 0, sizeof(accEntry));
		mib_chain_get(MIB_ACC_TBL, cnt, (void*)&accEntry);
		if(accEntry.ftp & 0x2){//lan ftp enabled
			ftpEnable = 1;
			break;
		}
	}

	/************Place your code here, do what you want to do! ************/

	_PUT_BOOL(ftpEnable);
	
check_err:
	_TRACE_LEAVEL;
	return 0;
}

//ҳύaction:	
void formApplication(webs_t wp, char_t *path, char_t *query)
{
	//Ŀ¼:			
	char *			psaveDir = NULL;
	char				argPath[64];
	//û:			
	char			user[32];
	char				arguser[64];
	//:				
	char			passwd[32];
	char				argpasswd[64];
	//˿:				
	unsigned short	port = 0;
	//ԶURL:			
	char *			prmtURL = NULL;
	char*			stemp = "";
	int				errcode = 1, lineno = __LINE__;
	
	_TRACE_CALL;

	user[0] = passwd[0] = 0;
	strcpy(argPath, "path=" USB_MNT_DIR "/");
	strcpy(arguser, "user=");
	strcpy(argpasswd, "passwd=");

	_GET_PSTR(saveDir, _NEED);
	strcat(argPath, psaveDir);
	
	_GET_STR(user, _OPT);
	if(user[0])
	{
		strcat(arguser, user);
		_GET_STR(passwd, _OPT);
		if(passwd[0])strcat(argpasswd, passwd);
	}

	_GET_INT(port, _NEED);
	if(port == 0){lineno = __LINE__; goto check_err;}

	_GET_PSTR(rmtURL, _NEED);

	/************Place your code here, do what you want to do! ************/
	call_cmd("/bin/wget_manage", 4, 0, arguser, argpasswd, argPath, prmtURL);
	/************Place your code here, do what you want to do! ************/

	errcode = 0;
	_COND_REDIRECT;
check_err:
	_TRACE_LEAVEL;
	return;
}


/*hidden pages*/
const char	ftpconfig[] = "/var/run/bftpd/ftpdconfig";
int initServiceMgr(int eid, webs_t wp, int argc, char_t ** argv)
{
	//FTP:				
	unsigned char		ftpEnable = 1;
	int				errcode = 1, lineno = __LINE__;

	_TRACE_CALL;

	/************Place your code here, do what you want to do! ************/
	mib_get(MIB_BFTPD_ENABLE, (void *) &ftpEnable);	
	/************Place your code here, do what you want to do! ************/

	_PUT_BOOL(ftpEnable);
	
check_err:
	_TRACE_LEAVEL;
	return 0;
}

//ҳύaction:	
void formServiceMgr(webs_t wp, char_t *path, char_t *query)
{
	//FTP:				
	unsigned char		ftpEnable = 1;
	FILE*			fp = NULL;
	int				ival = 0;
	char*			stemp = "";
	int				errcode = 1, lineno = __LINE__;
	
	_TRACE_CALL;

	_GET_BOOL(ftpEnable, _NEED);
	if(mib_get(MIB_BFTPD_ENABLE, (void *) &ival) && (ival != (int)ftpEnable) && (fp = fopen(ftpconfig, "rb+")))
	{
		if(mib_set(MIB_BFTPD_ENABLE, (void *) &ftpEnable))
		{
			ftpEnable = (ftpEnable ?  '1' : '0');
			fseek(fp, strlen("ftp_enable="), SEEK_SET);
			fwrite(&ftpEnable, 1, 1, fp);
			fclose(fp);
			call_cmd("/bin/ftp_manage", 0, 1);
		}
		else fclose(fp);
	}
	

	errcode = 0;
	_COND_REDIRECT;
check_err:
	_TRACE_LEAVEL;
	return;
}

