/*
 *      Include file of form handler
 *      Authors: 
 *
 */


#ifndef _INCLUDE_FMDEFS_H
#define _INCLUDE_FMDEFS_H


#include "webform.h"
#include "strde.h"


#define _CGI_VER_TW10	1

#define _OPT				0
#define _NEED				1


#define	MAXIFNAMESIZE		30

#define _CGI_DEBUG_

#define CHECK_INVALID(s)	if(!(s[0])) {lineno = __LINE__; goto check_err;}
#define CHECK_INVALID_OPT(s, opt)	if(opt && (s == NULL || !(s[0]))) {lineno = __LINE__; goto check_err;}
#ifdef _CGI_DEBUG_
#define FETCH_INVALID(s, n)	{s = websGetVar(wp, T(n), T("")); printf("%s:%s\n", n, s?s:"");CHECK_INVALID(s);}
#define FETCH_INVALID_OPT(s, n, opt){s = websGetVar(wp, T(n), T("")); printf("%s:%s\n", n, s?s:"");CHECK_INVALID_OPT(s, opt);}
#define _TRACE_CALL			{printf("entering %s....\n", __FUNCTION__);}
#define _TRACE_LEAVEL		{printf("leaving %s.... final line:%d\n", __FUNCTION__, lineno);}
#define _TRACE_POINT		{printf("line:%d\n",  __LINE__);}
#else
#define FETCH_INVALID(s, n)	{s = websGetVar(wp, T(n), T("")); CHECK_INVALID(s);}
#define FETCH_INVALID_OPT(s, n, opt){s = websGetVar(wp, T(n), T("")); printf("%s:%s\n", n, s?s:"");CHECK_INVALID_OPT(s, opt);}
#define _TRACE_CALL
#define _TRACE_LEAVEL
#define _TRACE_POINT
#endif

#define _GET_STR(name, opt)		{FETCH_INVALID_OPT(stemp, #name, opt); strncpy(name, stemp, sizeof(name));}
#define _GET_PSTR(name, opt)	{FETCH_INVALID_OPT(p##name, #name, opt);}
#define _GET_IP(name, opt)		{FETCH_INVALID_OPT(stemp, #name, opt); name = inet_addr(stemp);}
#define _GET_INT(name, opt)		{FETCH_INVALID_OPT(stemp, #name, opt); name = atoi(stemp);}
#define _GET_BOOL(name, opt)	{FETCH_INVALID_OPT(stemp, #name, _OPT); name = (strcmp(stemp, "on") == 0 )? 1 : 0;}

#define _PUT_STR(name)			{websWrite(wp, "cgi."#name" = \"%s\";\n", name);}
#define _PUT_PSTR(name)			{websWrite(wp, "cgi."#name" = \"%s\";\n", p##name);}
#define _PUT_IP(name)			{websWrite(wp, "cgi."#name" = \"%s\";\n", inet_ntoa(*(struct in_addr*)&(name)));}
#define _PUT_INT(name)			{websWrite(wp, "cgi."#name" = %d;\n", name);}
#define _PUT_BOOL(name)			{websWrite(wp, "cgi."#name" = %s;\n", (name) ? "true" : "false");}

#define _PUT_ENTRY_STR(name)	{websWrite(wp, "cgi."#name" = \"%s\";\n", entry.name);}
#define _PUT_ENTRY_IP(name)		{websWrite(wp, "cgi."#name" = \"%s\";\n", inet_ntoa(*(struct in_addr*)&(entry.name)));}
#define _PUT_ENTRY_INT(name)	{websWrite(wp, "cgi."#name" = %d;\n", entry.name);}
#define _PUT_ENTRY_BOOL(name)	{websWrite(wp, "cgi."#name" = %d;\n", (entry.name) ? 1 : 0);}

#define _ENTRY_STR(name, opt)	{FETCH_INVALID_OPT(stemp, #name, opt); strncpy(entry.name, stemp, sizeof(entry.name));}
#define _ENTRY_IP(name, opt)	{FETCH_INVALID_OPT(stemp, #name, opt); *(unsigned long*)&(entry.name) = (*stemp?inet_addr(stemp):0);}
#define _ENTRY_INT(name, opt)	{FETCH_INVALID_OPT(stemp, #name, opt); entry.name = atoi(stemp);}
#define _ENTRY_BOOL(name, opt)	{FETCH_INVALID_OPT(stemp, #name, _OPT); entry.name = (strcmp(stemp, "on") == 0 )? 1 : 0;}

#define _COND_REDIRECT			{char_t *s = websGetVar(wp, T("submit-url"), T("")); if(s && *s) websRedirect(wp, s);}

#define _ERR_MSG(msg) if(errcode){ \
	websHeader(wp); \
   	websWrite(wp, T("<body><blockquote><h4>%s</h4>\n"), msg); \
	websWrite(wp, T("<form><input type=\"button\" onclick=\"history.go (-1)\" value=\"&nbsp;&nbsp;%s&nbsp;&nbsp\" name=\"OK\"></form></blockquote></body>"),IDS_RESULT_OK); \
   	websFooter(wp); \
	websDone(wp, 200); \
}
#define _ERR_MSG_WAN(msg,url) if(errcode){ \
	websHeader(wp); \
   	websWrite(wp, T("<body><blockquote><h4>%s</h4>\n"), msg); \
	websWrite(wp, T("<form><input type=\"button\" onclick=window.location.replace(\"%s\")  value=\"&nbsp;&nbsp;OK&nbsp;&nbsp\" name=\"OK\"></form></blockquote></body>"),url); \
   	websFooter(wp); \
	websDone(wp, 200); \
}

#define _OK_MSG(url) if(errcode){ \
	websHeader(wp); \
   	websWrite(wp, T("<body><blockquote><h4>%s</h4>\n"),IDS_RESULT_EFFECT); \
	if (url[0]) websWrite(wp, T("<form><input type=button value=\"  %s \" OnClick=window.location.replace(\"%s\")></form></blockquote></body>"), IDS_RESULT_OK,url);\
	else websWrite(wp, T("<form><input type=button value=\"  %s  \" OnClick=window.close()></form></blockquote></body>"),IDS_RESULT_OK);\
   	websFooter(wp); \
	websDone(wp, 200); \
}

#define _OK_MSG1(msg, url) if(errcode){ \
	websHeader(wp); \
   	websWrite(wp, T("<body><blockquote><h4>%s</h4>\n"), msg); \
	if (url) websWrite(wp, T("<form><input type=button value=\"  %s \" OnClick=window.location.replace(\"%s\")></form></blockquote></body>"), IDS_RESULT_OK,url);\
	else websWrite(wp, T("<form><input type=button value=\"  %s  \" OnClick=window.close()></form></blockquote></body>"),IDS_RESULT_OK);\
   	websFooter(wp); \
	websDone(wp, 200); \
}

/*
 * for strde
 */
#define _BC_OPT				_OPT
#define _BC_NEED			_NEED

#define _BC_USE				_bcode* bc = NULL; int bcindex = 0; const char *sbc = NULL; float bcv = 0.0f;

#define _BC_INIT(vname)		{\
	FETCH_INVALID_OPT(sbc, vname, _NEED); \
	bc = bc_decode(sbc);\
	if(bc == NULL) {lineno = __LINE__; goto check_err;}\
	}
#define _BC_ISLIST()				(bc->flag & _BC_FLAG_LIST)
#define _BC_ITCNT()					(bc->itcnt)
#define _BC_NEXT()					(bc_seek(bc, bcindex++, 0) >= 0)
#define _BC_FREE()					{if(bc){bc_free(bc); bc = NULL;}}
#ifdef _CGI_DEBUG_
#define _BC_ENTRY_STR(name, opt)	{if((sbc = bc_gets(bc, #name)) == NULL){lineno = __LINE__; continue;} printf("%s:%s\n", #name, sbc?sbc:""); strncpy(entry.name, sbc, sizeof(entry.name));}
#define _BC_ENTRY_IP(name, opt)		{if((sbc = bc_gets(bc, #name)) == NULL){lineno = __LINE__; continue;} printf("%s:%s\n", #name, sbc?sbc:""); entry.name = inet_addr(sbc);}
#define _BC_ENTRY_INT(name, opt)	{if(bc_getv(bc, #name, &bcv) == _BC_FALSE){lineno = __LINE__; continue;} printf("%s:%.2f\n", #name, bcv); entry.name = (int)bcv;}
#define _BC_ENTRY_INTX(name, opt)	{if(bc_getv(bc, #name, &bcv) == _BC_FALSE){lineno = __LINE__; continue;} printf("%s:%.2f\n", #name, bcv); name = (int)bcv;}
#else
#define _BC_ENTRY_STR(name, opt)	{if((sbc = bc_gets(bc, #name)) == NULL){lineno = __LINE__; continue;} strncpy(entry.name, sbc, sizeof(entry.name));}
#define _BC_ENTRY_IP(name, opt)		{if((sbc = bc_gets(bc, #name)) == NULL){lineno = __LINE__; continue;} *(unsigned long*)&(entry.name) = inet_addr(sbc);}
#define _BC_ENTRY_INT(name, opt)	{if(bc_getv(bc, #name, &bcv) == _BC_FALSE){lineno = __LINE__; continue;} entry.name = (int)bcv;}
#define _BC_ENTRY_INTX(name, opt)	{if(bc_getv(bc, #name, &bcv) == _BC_FALSE){lineno = __LINE__; continue;} name = (int)bcv;}
#endif

typedef enum _itty{_itt_int8, _itt_int16, _itt_int32, _itt_string} _itty;
typedef struct _itval
{
	char* 	key;	/*key name*/
	_itty	ty;		/*value type*/
	int		len;	/*pval size if ty == _itt_string*/
	int*	pval;	/*zero based address*/
	char	opt;	/*is optional ?*/
}_itval;

#define _OFFSETT(type, field)		((unsigned long)(long *)&(((type *)0)->field))
#define _OFFSETO(o, field)			((unsigned long)(long *)&(o->field))
#define _ITDEF(k, t, l, addr, opt)	{k, t, l, addr, opt}

#define _IT_TRUE		1
#define _IT_FALSE		0

#define _PTS			", new it(\"%s\", \"%s\")"
#define _PTI			", new it(\"%s\", %d)"
//jim added to print unsigned long format..
#define _PTUL			", new it(\"%s\", %lu)"

#define _PME(name)		#name, entry.name
#define _PMEX(name)		#name, name
#define _PMEIP(name)	#name, strcpy(name, inet_ntoa(*(struct in_addr*)&(entry.name)))
#define _PMEXIP(name)	#name, strcpy(name, inet_ntoa(*(struct in_addr*)&(name)))

int	it_batfetch(webs_t wp, char_t *path, char_t *query, _itval* pitval);
#define MIB_CHAIN_DELETE(id,type,entry) \
			int cnt=mib_chain_total(id);\
			int mib_index=0;\
			type mibentry;\
			for(mib_index=0;mib_index<cnt;mib_index++)\
			{\
			mib_chain_get(id,mib_index,&mibentry);	\			
			if(!memcmp(&mibentry,&entry,sizeof(type)))\			
					{\
					mib_chain_delete(id, mib_index);\
					break;\
				}\
			}
/******************************************
**ΪԶӵʱĽṹ壬web_cgi_interface
*/
typedef struct status_info {
	char servName[32];	//
	char ifname[16];		//ӿ( Port/VPI/VCI)
	char encaps[8];		//װʽ
	char servType[4];		//
	char protocol[10];	//Э
	char ipAddr[16];		//IPַ
	unsigned int vlanId;	// VLAN ID
	unsigned int connId;	// Con. ID (It seems constantly to be 1)
	int igmpEnbl;		// IGMP: 1-enable;  0-disable
	int qosEnbl;		// QoS: 1-enable;  0-disable
	int pvcEnbl;		// State: 1-enable;  0-disable
	char *strStatus;		//״̬
}status_info;

/*շ*/
typedef struct if_status_info
{
	char ifname[36];
	unsigned long rx_pkt;
	unsigned long rx_err;
	unsigned long rx_drop;
	unsigned long rx_byte;
	unsigned long tx_pkt;
	unsigned long tx_err;
	unsigned long tx_drop;
	unsigned long tx_byte;
}if_status_info;

typedef if_status_info wlif_status_info;
typedef if_status_info ehif_status_info;

/*dhcp豸Ϣ*/
typedef struct dhcp_device_info
{
	unsigned int	uIpAddr;
	char			devname[20];	//Computer; 
}dhcp_device_info;

#if _CGI_VER_TW10 //ʱ
typedef struct atmvc_entryx {
	unsigned char ifIndex __PACK__;	//nop
	unsigned char vpi __PACK__;	// VPI
	//mapped to "qos" of MIB_CE_ATM_VC_T and recorded in "svtype" of MIB_CE_ATM_VC_T for web display 
	/*
		 "UBR Without PCR" and UBR With PCR"  -->  ATMQOS_UBR
		"CBR"          -->       ATMQOS_CBR 
		"Non Realtime VBR"  --->    ATMQOS_VBR_NRT
		"Realtime VBR"  --->    ATMQOS_VBR_RT
	*/
	unsigned char svtype __PACK__;		//ͣ0-"UBR Without PCR", 1-"UBR With PCR", 2-"CBR", 3-"Non Realtime VBR", 4-"Realtime VBR"
	unsigned short vci __PACK__;	// VCI
	unsigned short pcr __PACK__;	// ֵԪ
	unsigned short scr __PACK__;	// Ԫ
	unsigned short mbs __PACK__;	// ͻԪС
	//unsigned int cdvt __PACK__;	// nop
	unsigned char encap __PACK__;	// װʽ: 1- LLC;  0- VC- Mux
	unsigned char napt __PACK__;	// NAT
	unsigned char cmode __PACK__;	//0- bridge; (1-2)- Route; 2- PPPoE
	unsigned char brmode __PACK__;	// 0: transparent bridging, 1: PPPoE bridging(PPPoE·Żģʽ)
	unsigned char pppUsername[MAX_NAME_LEN] __PACK__;	//û
	unsigned char pppPassword[MAX_NAME_LEN] __PACK__;	//
	unsigned char pppAuth __PACK__;	// 0:AUTO, 1:PAP, 2:CHAP
	//unsigned char pppACName[MAX_NAME_LEN] __PACK__;	// nop
	unsigned char pppServiceName[MAX_NAME_LEN] __PACK__;	//
	unsigned char pppCtype __PACK__;	//ŷʽ: 0- Զ;  1- ʱԶ
	//unsigned short pppIdleTime __PACK__;	// nop
	unsigned char ipDhcp __PACK__;		//0- Static, 1- DHCP
	//unsigned char rip __PACK__;		// nop
	unsigned char ipAddr[IP_ADDR_LEN] __PACK__;		//IPַ
	unsigned char remoteIpAddr[IP_ADDR_LEN] __PACK__;	//ȱʡ
	unsigned char dgw __PACK__;		//nop
	//unsigned int mtu __PACK__;			//nop
	//unsigned char enable __PACK__;		//nop
	unsigned char netMask[IP_ADDR_LEN] __PACK__;	//
	//unsigned char ipunnumbered __PACK__;	// nop
//#ifdef CONFIG_EXT_SWITCH
	// used for VLAN mapping
	unsigned char vlan __PACK__;	// VLAN
	unsigned short vid __PACK__;	// VLAN ID
	unsigned short vprio __PACK__;	// 802.1p priority bits
	unsigned char vpass __PACK__;	// vlan passthrough
	unsigned short itfGroup;			//bit0- LAN 1; bit1- LAN 2; ; bit 4- WLAN ROOT; bit5- WLAN SSID1; ...
//#endif
//unsigned long cpePppIfIndex;   // Mason Yu. Remote Management
//unsigned long cpeIpIndex;      // Mason Yu. Remote Management

	unsigned char qos __PACK__;	// QoS     mapped to "qosenable" of MIB_CE_ATM_VC_T 

	unsigned char PPPoEProxyEnable __PACK__;		//PPPoE
	unsigned int  PPPoEProxyMaxUser __PACK__;	//û
	unsigned int applicationtype __PACK__;  		//BOTH,INTERNET, TR069, Other
}atmvc_entryx;
#endif

typedef struct dhcpd_entry {
	unsigned int dhcpRangeStart;		//ʼIPַ
	unsigned int dhcpRangeEnd;		//ֹIPַ
	unsigned int ipMask;			//
	unsigned int ulTime;			//ʱ(λ: )
}dhcpd_entry;


#if _CGI_VER_TW10 //ʱ
typedef struct macBaseDhcp_entryx {
	unsigned char macAddr[20] __PACK__;	//MACַ
	unsigned char ipAddr[20] __PACK__;	//IPַ
}macBaseDhcp_entryx;
#endif

typedef struct dhcp_client_entry {
	unsigned int pcRangeStart;		//PCʼַ
	unsigned int pcRangeEnd;		//PCַֹ
	unsigned int cmrRangeStart;		//ͷʼַ
	unsigned int cmrRangeEnd;		//ͷַֹ
	unsigned int stbRangeStart;		//ʼַ
	unsigned int stbRangeEnd;		//ַֹ
}dhcp_client_entry;

#if 0//commented by penggenyao
typedef struct qos_entry {
	unsigned char ifIndex __PACK__;		//nop
	char ifname[16] __PACK__;			//ӿ
	char desc[20] __PACK__;			//
	unsigned char prior __PACK__;		//ȼ
	unsigned char queueKey __PACK__;	//Կ
	unsigned char enable __PACK__;		//
}qos_entry;

typedef struct qosrule_entry {
	char tcName[16] __PACK__;		//name		//
	//unsigned short index __PACK__;	//index		//
	char state __PACK__;			//state			//״̬(1- ;  0- ֹ)
	char m_ipprio __PACK__;		//prio			//IPȼ, Կֵ(0- ȱʡ;  1- 0; ,  8- 7)
	char m_dscp __PACK__;		//mdscp		//6 bits DSCP tag(0- ȱʡ)
	char m_1p __PACK__;			//m1p			//802.1p tag(0- ȱʡ;  1- 0; ; 8- 7)
	unsigned char vlan1p __PACK__;	//vlan1p		//802.1pȼ(-2)
	unsigned char phyPort __PACK__;	//phypt		//˿
	unsigned char prototype __PACK__;//proto		//Э
	unsigned char dscp __PACK__;	//dscp			//DSCP˶
	unsigned char typflag;
	//unsigned char dhcpop[] __PACK__;	//dhcpop		//DHCP Option 60
	unsigned int op77 __PACK__;	//op77		//DHCP option 77
	unsigned int srcIp __PACK__;	//sip			//ԴIPַ
	unsigned int srcMask __PACK__;	//smsk		//Դ
	unsigned int dstIp __PACK__;	//dip			//ĿIPַ
	unsigned int dstMask __PACK__;	//dmsk		//Ŀ
	unsigned short srcPortStart __PACK__;	//spts		//Դʼ˿
	unsigned short srcPortEnd __PACK__;	//spte		//Դֹ˿
	unsigned short dstPortStart __PACK__;	//dpts		//Ŀʼ˿
	unsigned short dstPortEnd __PACK__;	//dpte		//Ŀֹ˿
	/* ȥMACع
	unsigned char srcMac[20] __PACK__;	//smac	//ԴMACַ
	char * pSrcMacWildcard __PACK__;	//smacw	//ԴMACַͨ
	unsigned char dstMac[20] __PACK__;	//dmac	//ĿMACַ
	char * pDstMacWildcard __PACK__;	//dmacw	//ĿMACַͨ
	*/
}qosrule_entry;

typedef struct tc_entry {
	unsigned char ifIndex __PACK__;		//nop
	char ifname[32] __PACK__;			//ӿ
	unsigned int sip __PACK__;			//ԴIP
	unsigned int smask __PACK__;		//Դ
	unsigned int dip __PACK__;			//ĿIP
	unsigned int dmask __PACK__;		//Ŀ
	unsigned short sPort __PACK__;		//Դ˿
	unsigned short dPort __PACK__;		//ĿĶ˿
	unsigned char protoType __PACK__;	//Э(1- ICMP;  6- TCP;  17- UDP)
	unsigned int limitSpeed __PACK__;	//
}tc_entry;
#endif

#if _CGI_VER_TW10 //ʱ
typedef struct rip_entryx {
	unsigned char ifIndex __PACK__;		//nop
	char ifname[32] __PACK__;			//ӿ
	unsigned char version __PACK__;		//汾
	unsigned char operation __PACK__;	//: 1- Active;  0- Passive
	unsigned char enable __PACK__;		//
}rip_entryx;
#endif

typedef struct url_entryx {
	char url[128] __PACK__;			//URLַ
	unsigned short port __PACK__;		//˿ں
}url_entryx;





typedef struct ipfilter_blacklist_entry {
	char filterName[32] __PACK__;		//
	unsigned char protoType __PACK__;	//Э(0- ;  1- TCP/UDP;  2- TCP;  3- UDP;  4- ICMP)
	unsigned int sipStart __PACK__;		//ԴʼIP
	unsigned int sipEnd __PACK__;		//ԴֹIP
	unsigned int smask __PACK__;		//Դ
	unsigned short sportStart __PACK__;	//Դʼ˿
	unsigned short sportEnd __PACK__;	//Դֹ˿
	unsigned int dipStart __PACK__;		//ĿʼIP
	unsigned int dipEnd __PACK__;		//ĿֹIP
	unsigned int dmask __PACK__;		//Ŀ
	unsigned short dportStart __PACK__;	//Ŀʼ˿
	unsigned short dportEnd __PACK__;	//Ŀֹ˿
}ipfilter_blacklist_entry;

typedef struct ipfilter_whitelist_entry {
	char filterName[32] __PACK__;		//
	unsigned char protoType __PACK__;	//Э(0- ;  1- TCP/UDP;  2- TCP;  3- UDP;  4- ICMP)
	unsigned int sipStart __PACK__;		//ԴʼIP
	unsigned int sipEnd __PACK__;		//ԴֹIP
	unsigned int smask __PACK__;		//Դ
	unsigned short sportStart __PACK__;	//Դʼ˿
	unsigned short sportEnd __PACK__;	//Դֹ˿
	unsigned int dipStart __PACK__;		//ĿʼIP
	unsigned int dipEnd __PACK__;		//ĿֹIP
	unsigned int dmask __PACK__;		//Ŀ
	unsigned short dportStart __PACK__;	//Ŀʼ˿
	unsigned short dportEnd __PACK__;	//Ŀֹ˿
	unsigned char allport __PACK__;		//ȫѡ
	unsigned char portnum __PACK__;		//ѡж˿
	char **ifname;					//ѡж˿
}ipfilter_whitelist_entry;

#if _CGI_VER_TW10 //ʱ
typedef struct ddns_entryx {
	unsigned char provider[10] __PACK__;
	unsigned char hostname[35] __PACK__;	
	//unsigned char interface[32] __PACK__; //interface is a key for compiler
	unsigned char ifname[32] __PACK__;
	unsigned char username[35] __PACK__;
	unsigned char password[35] __PACK__; 
} ddns_entryx;
#endif
typedef struct igmproxy_entry {
	unsigned char ifName[40] __PACK__;	//ӿ
	unsigned char enable __PACK__;		//IGMP
}igmproxy_entry;
typedef struct access_syslog_entry {
	char date[32] __PACK__;		///ʱ
	char devName[16] __PACK__;	//豸
	char grade[16] __PACK__;		//س̶
	char *pInfo;				//Ϣ
}access_syslog_entry;

/*info*/
/*
extern int getvar(int eid, webs_t wp, int argc, char_t ** argv);
extern int cgivar(int eid, webs_t wp, int argc, char_t ** argv);
*/

/*status*/
extern int listWanConfig(int eid, webs_t wp, int argc, char_t ** argv);
extern int wlStatsList (int eid, webs_t wp, int argc, char_t **argv);
extern int pktStatsList(int eid, webs_t wp, int argc, char_t **argv);
extern int dhcpClientList(int eid, webs_t wp, int argc, char_t **argv);
extern int getifstatus(int eid, webs_t wp, int argc, char_t **argv);

/*net*/
extern int listWanif(int eid, webs_t wp, int argc, char_t ** argv);
extern int initPageAdsl(int eid, webs_t wp, int argc, char_t ** argv);
extern void formAdsl(webs_t wp, char_t *path, char_t *query);
extern void formAdslClt(webs_t wp, char_t *path, char_t *query);	//ͻ
extern void formSetAdsl(webs_t wp, char_t *path, char_t *query);
extern int init_dsl_page(int eid, webs_t wp, int argc, char_t **argv);
extern void formDhcpd(webs_t wp, char_t *path, char_t *query);
extern int init_dhcpmain_page(int eid, webs_t wp, int argc, char_t **argv);
extern void formIpRange(webs_t wp, char_t *path, char_t *query);
extern int init_dhcp_device_page(int eid, webs_t wp, int argc, char_t **argv);
extern void formMacBase(webs_t wp, char_t *path, char_t *query);
extern int showMACBaseTable(int eid, webs_t wp, int argc, char_t **argv);
extern void formWlanSetup(webs_t wp, char_t *path, char_t *query);
extern int init_wlan_page(int eid, webs_t wp, int argc, char_t **argv);
extern void formWlEncrypt(webs_t wp, char_t *path, char_t *query);
extern int init_wlanAdv_page(int eid, webs_t wp, int argc, char_t **argv);
extern void formTR069Config(webs_t wp, char_t *path, char_t *query);
extern void formCertcaInsert(webs_t wp, char_t *path, char_t *query);
extern int showCert(int eid, webs_t wp, int argc, char_t **argv);
extern void formTR069CertDel(webs_t wp, char_t *path, char_t *query);
extern void formTimezone(webs_t wp, char_t *path, char_t *query);
extern int init_sntp_page(int eid, webs_t wp, int argc, char_t **argv);
extern void formRoute(webs_t wp, char_t *path, char_t *query);
extern void formRip(webs_t wp, char_t *path, char_t *query);
extern int showRipIf(int eid, webs_t wp, int argc, char_t **argv);
extern int showStaticRoute(int eid, webs_t wp, int argc, char_t **argv);


/*security*/
extern int initPageURL(int eid, webs_t wp, int argc, char_t ** argv);
extern void formURL(webs_t wp, char_t *path, char_t *query);
extern int initPageFirewall(int eid, webs_t wp, int argc, char_t ** argv);
extern void formFirewall(webs_t wp, char_t *path, char_t *query);
extern int initPageDos(int eid, webs_t wp, int argc, char_t ** argv);
extern void formDos(webs_t wp, char_t *path, char_t *query);
extern int brgMacFilterList(int eid, webs_t wp, int argc, char_t ** argv);
extern void formBrgMacFilter(webs_t wp, char_t *path, char_t *query);
extern int rteMacFilterList(int eid, webs_t wp, int argc, char_t ** argv);
extern void formRteMacFilter(webs_t wp, char_t *path, char_t *query);
extern int ipPortFilterConfig(int eid, webs_t wp, int argc, char_t ** argv);
extern int ipPortFilterBlacklist (int eid, webs_t wp, int argc, char_t ** argv);
extern int ipPortFilterWhitelist (int eid, webs_t wp, int argc, char_t ** argv);
extern void formPortFilter(webs_t wp, char_t *path, char_t *query);
extern void formPortFilterWhite(webs_t wp, char_t *path, char_t *query);
extern void formPortFilterBlack(webs_t wp, char_t *path, char_t *query);


/*management*/
extern int initPageMgmUser(int eid, webs_t wp, int argc, char_t ** argv);
extern void formPasswordSetup(webs_t wp, char_t *path, char_t *query);
extern void formReboot(webs_t wp, char_t *path, char_t *query);
extern void formUSBbak(webs_t wp, char_t *path, char_t *query);
extern void formRestore(webs_t wp, char_t *path, char_t *query);
extern int initPageSysLog(int eid, webs_t wp, int argc, char_t ** argv);
extern void formSysLog(webs_t wp, char_t *path, char_t *query);
extern int accessSysLogList (int eid, webs_t wp, int argc, char_t ** argv);
extern int secureSysLogList  (int eid, webs_t wp, int argc, char_t ** argv);
extern int initPageSysLogConfig(int eid, webs_t wp, int argc, char_t ** argv);
extern void formSysLogConfig(webs_t wp, char_t *path, char_t *query);
extern int initPageMntMnt(int eid, webs_t wp, int argc, char_t ** argv);
extern void formDiagTest(webs_t wp, char_t *path, char_t *query);
extern int initPageUSBbak(int eid, webs_t wp, int argc, char_t ** argv);



/*application*/
extern int showDNSTable(int eid, webs_t wp, int argc, char_t **argv);
extern void formDDNS(webs_t wp, char_t *path, char_t *query);
#ifdef CONFIG_IP_NF_ALG_ONOFF
extern int showAlgConfig(int eid, webs_t wp, int argc, char_t **argv);
extern void formALGOnOff(webs_t wp, char_t *path, char_t *query);
#endif
#ifdef DMZ_SUPPORT
extern int showDmzConfig(int eid, webs_t wp, int argc, char_t **argv);
extern void formDMZ(webs_t wp, char_t *path, char_t *query);
#endif
#ifdef VIRTUAL_SERVER_SUPPORT
extern int virtualSvrList (int eid, webs_t wp, int argc, char_t **argv);
extern int virtualSvrLeft(int eid, webs_t wp, int argc, char_t **argv);
extern void formVrtsrv(webs_t wp, char_t *path, char_t *query);
#endif
#ifdef PORT_TRIGGER_SUPPORT
extern int PortTriggerList(int eid, webs_t wp, int argc, char_t **argv);
extern void formPortTrigger(webs_t wp, char_t *path, char_t *query);
extern int portTriggerLeft(int eid, webs_t wp, int argc, char_t **argv);
#endif
extern int initPageUpnp(int eid, webs_t wp, int argc, char_t ** argv);
extern void formUpnp(webs_t wp, char_t *path, char_t *query);
extern int initPageIgmpSnooping(int eid, webs_t wp, int argc, char_t ** argv);
extern void formIgmpSnooping(webs_t wp, char_t *path, char_t *query);
extern int igmproxyList(int eid, webs_t wp, int argc, char_t ** argv);
extern void formIgmproxy (webs_t wp, char_t *path, char_t *query);
extern int listUsbDevices(int eid, webs_t wp, int argc, char_t ** argv);
extern int initPageApplication(int eid, webs_t wp, int argc, char_t ** argv);
extern void formApplication(webs_t wp, char_t *path, char_t *query);
extern int initServiceMgr(int eid, webs_t wp, int argc, char_t ** argv);
extern void formServiceMgr(webs_t wp, char_t *path, char_t *query);

#define UNDOWAIT 0
#define DOWAIT 1
#define MAX_SPACE_LEGNTH 1024
#define DOCMDINIT \
        char cmdargvs[MAX_SPACE_LEGNTH]={0};\
        int argvs_index=1;\
        char *_argvs[32];
#ifdef _CGI_DEBUG_
#define DOCMDARGVS(cmd,dowait,format,args...) \
		argvs_index=1;\
                 memset(cmdargvs,0,sizeof(cmdargvs));\
                 memset(_argvs,0,sizeof(_argvs));\
                 snprintf(cmdargvs,sizeof(cmdargvs),format,##args);\
                 fprintf(stderr,"%s %s\n",cmd,cmdargvs);\                 
                 _argvs[argvs_index]=strtok(cmdargvs," ");\
                 while(_argvs[argvs_index]){\				
			_argvs[++argvs_index]=strtok(NULL," ");\			
                 	}\
                 do_cmd(cmd,_argvs,dowait);
#else
#define DOCMDARGVS(cmd,dowait,format,args...) \
		argvs_index=1;\
                 memset(cmdargvs,0,sizeof(cmdargvs));\
                 memset(_argvs,0,sizeof(_argvs));\
                 snprintf(cmdargvs,sizeof(cmdargvs),format,##args);\                
                 _argvs[argvs_index]=strtok(cmdargvs," ");\
                 while(_argvs[argvs_index]){\			
			_argvs[++argvs_index]=strtok(NULL," ");\			
                 	}\
                 do_cmd(cmd,_argvs,dowait);
#endif

#endif // _INCLUDE_FMDEFS_H
