
/*
 *      Web server handler routines for MAC-Base Assignment for DHCP Server stuffs
 *
 */


/*-- System inlcude files --*/
#include <net/if.h>
#include <sys/ioctl.h>
#include <sys/time.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/socket.h>
#include <net/route.h>

/*-- Local inlcude files --*/
#include "../webs.h"
#include "webform.h"
#include "mib.h"
#include "utility.h"


#if defined(ZTE_531B_BRIDGE_SC)||defined(ZTE_GENERAL_ROUTER_SC)
#define GOOD_MSG(url) { \
	websHeader(wp); \
	websWrite(wp, T("<body><blockquote><h5>%s<BR>" \
                "<BR><form><input type=button value=\"  %s  \" OnClick=window.location.replace(\"%s\")></form></blockquote></body>"),IDS_RESULT_EFFECT, IDS_RESULT_OK ,url);\
	websFooter(wp); \
	websDone(wp, 200); \
}
#else
#define GOOD_MSG(url) { \
	websHeader(wp); \
	websWrite(wp, T("<body><blockquote><h5>Change setting successfully!<BR>" \
                "<BR><form><input type=button value=\"  OK  \" OnClick=window.location.replace(\"%s\")></form></blockquote></body>"), url);\
	websFooter(wp); \
	websDone(wp, 200); \
}
#endif

///////////////////////////////////////////////////////////////////
void formmacBase(webs_t wp, char_t *path, char_t *query)
{
	char_t	*str, *submitUrl;
	char tmpBuf[100];	
#ifndef NO_ACTION
	int pid;
#endif	

//star: for take effect immediately
	int change_flag = 0;

	// Delete
	str = websGetVar(wp, T("delIP"), T(""));
	if (str[0]) {
		unsigned int i;
		unsigned int idx;
		unsigned int totalEntry = mib_chain_total(MIB_MAC_BASE_DHCP_TBL); /* get chain record size */		
		
		str = websGetVar(wp, T("select"), T(""));		
		//printf("str(select) = %s\n", str);
		
		if (str[0]) {
			for (i=0; i<totalEntry; i++) {
				idx = totalEntry-i-1;			
				snprintf(tmpBuf, 4, "s%d", idx);
				//printf("tmpBuf(select) = %s idx=%d\n", tmpBuf, idx);
				
				if ( !gstrcmp(str, T(tmpBuf)) ) {
					change_flag = 1;
					// delete from chain record
					if(mib_chain_delete(MIB_MAC_BASE_DHCP_TBL, idx) != 1) {
						strcpy(tmpBuf, T(strDelChainerror));
						goto setErr_route;
					}

					
				}
			} // end of for
		}		
		goto setOk_route;
	}

	// Add
	str = websGetVar(wp, T("addIP"), T(""));
	//printf("str=%s\n", str);	
	if (str[0]) {
		MIB_CE_MAC_BASE_DHCP_T entry,Entry;
		int mibtotal,i;
		
		str = websGetVar(wp, T("hostMac"), T(""));					
		strcpy(entry.macAddr, str);
		//printf("entry.macAddr = %s\n", entry.macAddr);
		
		str = websGetVar(wp, T("hostIp"), T(""));				
		strcpy(entry.ipAddr, str);
		//printf("entry.ipAddr = %s\n", entry.ipAddr);

		mibtotal = mib_chain_total(MIB_MAC_BASE_DHCP_TBL);
		for(i=0;i<mibtotal;i++)
		{
			mib_chain_get(MIB_MAC_BASE_DHCP_TBL, i, (void*)&Entry);
			if(!strcmp(entry.macAddr, Entry.macAddr) || !strcmp(entry.ipAddr, Entry.ipAddr)){
				strcpy(tmpBuf, T(strStaticipexist));
				goto setErr_route;
			}
				
		}

		change_flag = 1;
		
		if(mib_chain_add(MIB_MAC_BASE_DHCP_TBL, (unsigned char*)&entry) != 1){
			strcpy(tmpBuf, T(strAddChainerror));
			goto setErr_route;
		}	
	goto setOk_route;
	}

	//Mod
	str = websGetVar(wp, T("modIP"), T(""));
	//printf("str=%s\n", str);	
	if (str[0]) {
		unsigned int i;
		unsigned int idx;
		unsigned int totalEntry = mib_chain_total(MIB_MAC_BASE_DHCP_TBL); /* get chain record size */		
		
		str = websGetVar(wp, T("select"), T(""));		
		//printf("str(select) = %s\n", str);
		
		if (str[0]) {
			for (i=0; i<totalEntry; i++) {
				idx = totalEntry-i-1;			
				snprintf(tmpBuf, 4, "s%d", idx);
				//printf("tmpBuf(select) = %s idx=%d\n", tmpBuf, idx);
				
				if ( !gstrcmp(str, T(tmpBuf)) ) {
					change_flag = 1;
					MIB_CE_MAC_BASE_DHCP_T entry;				
		
					str = websGetVar(wp, T("hostMac"), T(""));					
					strcpy(entry.macAddr, str);
					//printf("entry.macAddr = %s\n", entry.macAddr);
					
					str = websGetVar(wp, T("hostIp"), T(""));				
					strcpy(entry.ipAddr, str);
					//printf("entry.ipAddr = %s\n", entry.ipAddr);
					
					if(mib_chain_update(MIB_MAC_BASE_DHCP_TBL, (unsigned char*)&entry, idx) != 1){
						strcpy(tmpBuf, T(strModChainerror));
						goto setErr_route;
					}	

					
				}
			} // end of for
		}
	}


setOk_route:
	/* upgdate to flash */
//	mib_update(CURRENT_SETTING);

#ifndef NO_ACTION
	pid = fork();
        if (pid)
                waitpid(pid, NULL, 0);
        else if (pid == 0) {
		snprintf(tmpBuf, 100, "%s/%s", _CONFIG_SCRIPT_PATH, _CONFIG_SCRIPT_PROG);
#ifdef HOME_GATEWAY
		execl( tmpBuf, _CONFIG_SCRIPT_PROG, "gw", "bridge", NULL);
#else
		execl( tmpBuf, _CONFIG_SCRIPT_PROG, "ap", "bridge", NULL);
#endif
                exit(1);
        }
#endif
	if(change_flag == 1)
	{
		unsigned char vChar;
#ifdef __CLOSE_INTERFACE_BEFORE_WRITE_
		/*to avoid the dead when wrriting the flash*/
		itfcfg("sar", 0);
		itfcfg("eth0", 0);
#ifdef WLAN_SUPPORT
		itfcfg("wlan0", 0);
#endif
#endif /*__CLOSE_INTERFACE_BEFORE_WRITE_*/
		mib_update(CURRENT_SETTING, CONFIG_MIB_ALL);

#ifdef __CLOSE_INTERFACE_BEFORE_WRITE_
		itfcfg("sar", 1);
		 itfcfg("eth0", 1);
#ifdef WLAN_SUPPORT
		vChar=0;
		mib_get( MIB_WLAN_DISABLED, (void *)&vChar);
		if( vChar==0 )	itfcfg("wlan0", 1);
#endif //WLAN_SUPPORT
#endif /*__CLOSE_INTERFACE_BEFORE_WRITE_*/

		restart_dhcp();
		submitUrl = websGetVar(wp, T("submit-url"), T(""));
		GOOD_MSG(submitUrl);
		return;
	}

	submitUrl = websGetVar(wp, T("submit-url"), T(""));
	if (submitUrl[0])
		websRedirect(wp, submitUrl);
	else
		websDone(wp, 200);
  	return;

setErr_route:
	ERR_MSG(tmpBuf);
	
}


#if defined(ZTE_531B_BRIDGE_SC)||defined(ZTE_GENERAL_ROUTER_SC)
#if 0
int showMACBaseTable(int eid, webs_t wp, int argc, char_t **argv)
{		
	int nBytesSent=0;
	unsigned int entryNum, i;
	MIB_CE_MAC_BASE_DHCP_T Entry;	
	
	entryNum = mib_chain_total(MIB_MAC_BASE_DHCP_TBL);	
	
	nBytesSent += websWrite(wp, T("<tr><font size=1>"
	"<td align=center width=\"15%%\" bgcolor=\"#808080\">%s</td>\n"
	"<td align=center width=\"40%%\" bgcolor=\"#808080\">%s</td>\n"
	"<td align=center width=\"40%%\" bgcolor=\"#808080\">%s</td></font></tr>\n"),
	Tselect,Thost_mac,Tassigned_ip);

	for (i=0; i<entryNum; i++) {

		if (!mib_chain_get(MIB_MAC_BASE_DHCP_TBL, i, (void *)&Entry))
		{
  			websError(wp, 400, T("%s\n"),Tget_chain_err);
			return;
		}		
	
		nBytesSent += websWrite(wp, T("<tr>"
		"<td align=center width=\"5%%\" bgcolor=\"#C0C0C0\"><input type=\"radio\" name=\"select\""
		" value=\"s%d\" onClick = \"onSelect('%s','%s')\"></td>\n"
		"<td align=center width=\"40%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%s</b></font></td>\n"
		"<td align=center width=\"40%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%s</b></font></td></tr>\n"),
		i, Entry.macAddr, Entry.ipAddr, Entry.macAddr, Entry.ipAddr);
	}
	
	return 0;
}

#else
int showMACBaseTable(int eid, webs_t wp, int argc, char_t **argv)
{		
	int nBytesSent=0;
	unsigned int entryNum, i;
	MIB_CE_MAC_BASE_DHCP_T Entry;	
	
	entryNum = mib_chain_total(MIB_MAC_BASE_DHCP_TBL);	
	
	nBytesSent += websWrite(wp, T("<tr><font size=1>"
	"<td align=center width=\"5%%\" bgcolor=\"#808080\">%s</td>\n"
	"<td align=center width=\"40%%\" bgcolor=\"#808080\">%s</td>\n"
	"<td align=center width=\"40%%\" bgcolor=\"#808080\">%s</td></font></tr>\n"),
	Tselect,Thost_mac,Tassigned_ip);

	for (i=0; i<entryNum; i++) {

		if (!mib_chain_get(MIB_MAC_BASE_DHCP_TBL, i, (void *)&Entry))
		{
  			websError(wp, 400, T("Get chain(MIB_MAC_BASE_DHCP_TBL) record error!\n"));
			return;
		}		
	
		nBytesSent += websWrite(wp, T("<tr>"
		"<td align=center width=\"5%%\" bgcolor=\"#C0C0C0\"><input type=\"radio\" name=\"select\""
		" value=\"s%d\"></td>\n"
		"<td align=center width=\"40%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%s</b></font></td>\n"
		"<td align=center width=\"40%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%s</b></font></td></tr>\n"),
		i, Entry.macAddr, Entry.ipAddr);
	}
	
	return 0;
}
#endif
#endif
