
/*
 *      Web server handler routines for MGM
 *      Authors: 
 *
 */

/*-- System inlcude files --*/
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <sys/wait.h>
#include <semaphore.h>
#ifdef EMBED
#include <linux/config.h>
#else
#include "../../../uClibc/include/linux/autoconf.h"
#endif

/* for ioctl */
#include <sys/ioctl.h>
#include <sys/syslog.h>
#include <net/if.h>

#include "../webs.h"
#include "fmdefs.h"
#include "mib.h"
#include "utility.h"
#include "debug.h"
#include "../defs.h"
#include <config/autoconf.h>
#ifdef CONFIG_MIDDLEWARE
#include <rtk/midwaredefs.h>
#endif
#include "../boa.h"
#include <dirent.h>
/*for socket api*/
#include <netinet/in.h>
#include <sys/socket.h>
#include "adsl_drv.h"

//add by ramen

#ifdef SYSLOG_SUPPORT_ENABLE
#if 0
struct monthstr{
	char str[8];
	int  monthnum;
};
const struct monthstr ms[12]={
	{"Jan",1},
	{"Feb",2},
	{"Mar",3},
	{"Apr",4},
	{"May",5},
	{"Jun",6},
	{"Jul",7},
	{"Aug",8},
	{"Sep",9},
	{"Oct",10},
	{"Nev",11},
	{"Dec",12}
};
int getMonthFromStr(const char* str)
{
    int i=0;
	for(i=0;i<sizeof(ms)/sizeof(struct monthstr);i++) {
		if(!strncasecmp(str,ms[i].str,3)) {
			return ms[i].monthnum;
		}
	}
	return -1;
}
	/*
convert the time format from one to another
such as:
Jan  1 00:01:18 2000===>2000-01-01 00:01:18
*/
void* timeFormatConvert(const char* timestr,char *buf)
{
   int year,month,day;
   int hour,minute,second;
   char monthstr[8]={0};
   sscanf(timestr,"%s  %d %d:%d:%d %d",&monthstr,&day,&hour,&minute,&second,&year);
  // printf("yead=%d,month=%d day=%d hour=%d minute=%d second=%d\n",year,getMonthFromStr(monthstr),day,hour,minute,second);
   sprintf(buf,"%4d-%02d-%02d %02d:%02d:%02d",year,getMonthFromStr(monthstr),day,hour,minute,second);
   return 0;
}	
#endif
const char *loggrade[]={"Emergency","Alert","Critical","Error","Warning","Notice","Informational","Debug"};
//modify the "==>\"
char* fixupLoginfo(char* info)
{
	static char loginfo[4096]={0};
	memset(loginfo,0,sizeof(loginfo));
	int i=0;
	int j=0;
	int info_length=strlen(info);
	for(i=0;i<info_length;i++)
		{
			if(info[i]=='"') {
				loginfo[j++]='\\';				
				}
			else if(info[i]=='\\')
				{
				loginfo[j++]='\\';				
				}
			loginfo[j++]=info[i];
		}
	return loginfo;
}
#endif
/*****************************
** û
*/
int initPageMgmUser(int eid, webs_t wp, int argc, char_t ** argv)
{
	char	issu = 0;
	struct user_info * pUser_info = NULL;
	//ԭû:		
	char  oldUserName[64];
	int	  lineno = __LINE__;

	_TRACE_CALL;

	oldUserName[0] = 0;
	
	pUser_info = search_login_list(wp);

	issu = ((pUser_info && pUser_info->priv) ? 1 : 0);

	/************Place your code here, do what you want to do! ************/
		strncpy(oldUserName, usName, 64);
	/************Place your code here, do what you want to do! ************/
	
	_PUT_BOOL(issu);
	_PUT_STR(oldUserName);
	
check_err:
	_TRACE_LEAVEL;
	return 0;
}


void formPasswordSetup(webs_t wp, char_t *path, char_t *query)
{
	char	issu = 0;
	char tmpBuf[100];
	struct user_info * pUser_info = NULL;
	//ԭû:		
	char *poldUserName = NULL;
	//û:		
	char *pnewUserName = NULL;
	//:		
	char *poldPasswd = NULL;
	//:		
	char *pnewPasswd = NULL;
	//ȷ:		
	char *paffirmPasswd = NULL;
	char* stemp = NULL;
	int	  lineno = __LINE__;
	char suname[64];
	_TRACE_CALL;

	pUser_info = search_login_list(wp);

	issu = ((pUser_info && pUser_info->priv) ? 1 : 0);

	if(issu)
	{
		_GET_PSTR(newUserName, _NEED);
	}
	else
	{
		_GET_PSTR(oldUserName, _OPT);
		_GET_PSTR(oldPasswd, _NEED);
	}
	_GET_PSTR(newPasswd, _NEED);
	_GET_PSTR(affirmPasswd, _NEED);
	strcpy(tmpBuf, T("趨!"));
	if(issu)
	{
		if(!mib_get(MIB_SUSER_NAME, (void*)suname))
			goto check_err;
		if(strcmp(pnewUserName, suname) ==0)
		{
			strcpy(tmpBuf, T("ûǷ!"));
			goto check_err;
		}
	}
	if(strcmp(pnewPasswd, paffirmPasswd) != 0) {lineno = __LINE__; goto check_err;} 
		
	/************Place your code here, do what you want to do! ************/
	if ( !mib_get(MIB_USER_PASSWORD, (void *)tmpBuf)) {
		goto check_err;
	}
	
	if ( !issu && strcmp(tmpBuf, poldPasswd) != 0 ) {
		strcpy(tmpBuf, T("!"));
		goto check_err;
	}else if ( !mib_set(MIB_USER_PASSWORD, (void *)pnewPasswd) ) {							
		goto check_err;
	}	
	if (issu && !mib_set(MIB_USER_NAME, (void *)pnewUserName) ) {							
		goto check_err;
	}	
	mib_update(CURRENT_SETTING, CONFIG_MIB_ALL);
#ifdef EMBED
	// Added by Mason Yu for take effect on real time
	writePasswdFile();
#endif
	/************Place your code here, do what you want to do! ************/
	
	_COND_REDIRECT;
check_err:
	_TRACE_LEAVEL;
	ERR_MSG(tmpBuf);
	return;
}


/*****************************
** 豸
*/
extern sem_t semSave;
void formReboot(webs_t wp, char_t *path, char_t *query)
{
	int				lineno = __LINE__;

		
	_TRACE_CALL;

	/************Place your code here, do what you want to do! ************/
	websHeader(wp);
	websWrite(wp, T("<META HTTP-EQUIV=Refresh CONTENT=\"120; URL=/admin/status.asp\">\n"));
   	websWrite(wp, T("<body><blockquote><h4>\n"));
   	/*
   	websWrite(wp, T("The System is Restarting ...</h4>\n"));
   	websWrite(wp, T("The DSL Router has been configured and is rebooting.<br><br>\n"));
   	websWrite(wp, T("Close the DSL Router Configuration window and wait"
   		" for 2 minutes before reopening your web browser."
   		" If necessary, reconfigure your PC's IP address to match"
   		" your new configuration.\n"));
   	*/
   	websWrite(wp, T("%s</h4>\n"), TAdmin_str_rebootWord0);
   	websWrite(wp, T("%s<br><br>\n"), TAdmin_str_rebootWord1);
   	websWrite(wp, T("%s\n"), TAdmin_str_rebootWord2);
   	websWrite(wp, T("</blockquote></body>"));
   	websFooter(wp);
	websDone(wp, 200);
	
#ifdef EMBED
	// wake up the Save/reboot thread
	// Mason Yu
#ifdef SYSLOG_SUPPORT_ENABLE
	SYSLOG_WRITE(LOG_INFO,"104001","Save configuration and System reboot!\n");
#endif
	// Mason Yu
	semSave.__sem_value=0;  // save/reboot configuration.

	sem_post(&semSave);
#endif
	/************Place your code here, do what you want to do! ************/
	
check_err:
	_TRACE_LEAVEL;
	return;
}

#if 0
static unsigned int file_read_number(const char *filename) {
	FILE *fp;
	char buffer[10];
	unsigned int mask = 0;
	
	fp = fopen(filename, "r");
	
	if (!fp) {		
		return 0;
	}

	fgets(buffer, sizeof(buffer), fp);
	if (1 != sscanf(buffer, "%u", &mask)) {
		goto out;
	}
	fclose(fp);
	return mask;
	
out:
	fclose(fp);
	return 0;
	
}

static int usb_get_partition_name(int id, char *namebuf, int buflen) {
	if (id == 0) {
		return snprintf(namebuf, buflen, "sda");
	} else if (id == 16) {
		return snprintf(namebuf, buflen, "sdb");
	} if (id < 16) {
		return snprintf(namebuf, buflen, "sda%d", id);
	} else if ((id > 16) && (id < 32)) {
		return snprintf(namebuf, buflen, "sdb%d", id - 16);
	}
	return -1;
}

/// This setting should sync with usbmount user tool
#define USB_MNT_DIR  "/tmp/usb"
char USB_MNT_FILE[] = USB_MNT_DIR"/mnt_map"; // file contains 32bit INT representing mounted paritions.

int initPageUSBbak(int eid, webs_t wp, int argc, char_t ** argv){
	int tmp;
	char buffer[10];
	unsigned int mask;

	mask = file_read_number(USB_MNT_FILE);

	for (tmp = 0; tmp < 32; tmp++) {
		if (!(mask & (1 << tmp)))
			continue;		
		usb_get_partition_name(tmp, buffer, sizeof(buffer));
		websWrite(wp, "cgi_usblst.push(new usb_obj(\"%s\", \"%d\"));", buffer, tmp);
	}

	
	
}

static void encode(char *buf, size_t *buflen) {
	/* do some encode task here... */
	
}
#endif
int initPageUSBbak(int eid, webs_t wp, int argc, char_t ** argv)
{
	return 0;
}


/*****************************
**USB
*/
extern const char USB_CFG_FILENAME[];
extern unsigned int file_read_number(const char *filename);
extern int usb_get_partition_name(int id, char *namebuf, int buflen);
extern void encode(char *buf, size_t *buflen);

void formUSBbak(webs_t wp, char_t *path, char_t *query)
{
	//USB
	char*			pusbdev = NULL;
	char 			buffer[10], dstname[60];
	DIR				*dirent = NULL;
	int 			rv = 0;
	struct file_pipe	pipe;
	unsigned char	cpbuf[256];
	char*			stemp = "";
	int				errcode = 1, lineno = __LINE__;
	int forcebackup=0; //jim used for remove exist config file in usb disk...
	_TRACE_CALL;


	if(file_read_number(USB_MNT_FILE) == 0)
	{
		goto err_dir;	//no usbdevice
	}
	
	_GET_PSTR(usbdev, _NEED);
	/************Place your code here, do what you want to do! ************/
	_GET_INT(forcebackup, _OPT);
	// create dir if necessary..	
	//snprintf(dstname, sizeof(dstname), "%s/%s/%s", USB_MNT_DIR, buffer, BACKUP_DIRNAME);
	//snprintf(dstname, sizeof(dstname), "%s/%s/%s", USB_MNT_DIR, pusbdev, BACKUP_DIRNAME);
	snprintf(dstname, sizeof(dstname), "%s/%s", USB_MNT_DIR, pusbdev);
	
	dirent = opendir(dstname);
	if (dirent) {
		closedir(dirent);
	} else {
		if (errno==ENOTDIR) {
			goto err_dir;
		}
		if (0 != mkdir(dstname, 0755))			
			goto err_dir;
	}

	//snprintf(dstname, sizeof(dstname), "%s/%s/%s/%s", USB_MNT_DIR, buffer, BACKUP_DIRNAME, CFG_FILENAME);
	//snprintf(dstname, sizeof(dstname), "%s/%s/%s/%s", USB_MNT_DIR, pusbdev, BACKUP_DIRNAME, USB_CFG_FILENAME);
	snprintf(dstname, sizeof(dstname), "%s/%s/%s", USB_MNT_DIR, pusbdev, USB_CFG_FILENAME);

	//fprintf(stderr, "%s(3) %s\n", __FUNCTION__, dstname);
	// check if dst file exist..
	if (is_file(dstname))
	{
		if(!forcebackup)
			goto err_exist;
		else
			{
				printf("%s: config file exist: %s\n", __FUNCTION__, dstname);
				call_cmd("/bin/rm", 1, 1, dstname);
			}
	}
	
	// prepare config file..
	call_cmd("/bin/CreatexmlConfig", 0, 1);	
	pipe.buffer = cpbuf;
	pipe.bufsize = sizeof(cpbuf);
	pipe.func = encode;
	
	rv = file_copy_pipe(CONFIG_XMLFILE, dstname, &pipe);
	if (rv != 0) {
		goto err_file;
	}
	chmod(dstname, S_IRUSR);

	call_cmd("/bin/rm", 1, 1, CONFIG_XMLFILE);
	
	errcode = 0;
	//_COND_REDIRECT;
	 websRedirect(wp, "/mgm_dev_usbbak.asp");
	
check_err:
	_TRACE_LEAVEL;
	return;
	
err_exist:
	printf("file already exist, remove it first");
	//websRedirect(wp, "mgm_dev_usbreply.asp");
	
	websHeader(wp); \
   	websWrite(wp, "<HTML>\
<HEAD>\
<META http-equiv=cache-control content=\"no-cache, must-revalidate\">\
<META http-equiv=content-type content=\"text/html; charset=gbk\">\
<META http-equiv=content-script-type content=text/javascript>\
<!--????css-->\
<STYLE type=text/css>\
@import url(style/default.css);\
</STYLE>\
<!--??????-->\
<SCRIPT language=\"javascript\" src=\"common.js\"></SCRIPT>\
<SCRIPT language=\"javascript\" type=\"text/javascript\">\
function on_submit(){\
	with ( document.forms[0] )\
   	{\
   		submit();\
	}\
}\
</SCRIPT>\
<body>\
<form action=\"/goform/admin/formUSBbak\" method=\"post\">\
<table align=center>\
<tr align=center>\
<td colspan=2 class=actionbuttons >\
<input type=\"hidden\" name=\"forcebackup\" value=\"1\" >\
<input type=\"hidden\" name=\"usbdev\" value=\"%s\" >\
<input type='button' onClick='on_submit()' value='ɾ󱸷'></TD>\
<td colspan=2 class=actionbuttons ><input type='button' onClick='history.back()' value='˳'></TD>\
</tr>\
</table>\
</form>\
</body>\
</html>",pusbdev);
	websDone(wp, 200); 
	//snprintf(dstname, sizeof dstname, "ͬļڣɾ");
	//_ERR_MSG(dstname);
	return;
	
err_file:
	call_cmd("/bin/rm", 1, 1, CONFIG_XMLFILE);
	printf("fail to copy, disk full? code %d", rv);
	snprintf(dstname, sizeof dstname, "ʧ, ռ䲻");
	_ERR_MSG(dstname);
	return;
	// file related erro;
	
err_dir:
	//printf("Cannot access directory %s", BACKUP_DIRNAME);
	snprintf(dstname, sizeof dstname, "ʧܣ");
	_ERR_MSG(dstname);
	return;
	 // directory related error.	
}
#if 0
void formUSBbak(webs_t wp, char_t *path, char_t *query)
{
	int				lineno = __LINE__;
	char*			stemp = "";
	 int 				partition_id, rv;
	 char 			buffer[10], dstname[60], *submitUrl;
	DIR				*dirent;
	struct file_pipe	pipe;
	unsigned char		cpbuf[256];
		
	_TRACE_CALL;

	/************Place your code here, do what you want to do! ************/
	FETCH_INVALID(stemp, "usbsubarea");
	partition_id = atoi(stemp);

	//fprintf(stderr, "%s(1) %d\n", __FUNCTION__, partition_id);
	usb_get_partition_name(partition_id, buffer, sizeof(buffer));
	
	// create dir if necessary..	
	snprintf(dstname, sizeof(dstname), "%s/%s/%s", USB_MNT_DIR, buffer, BACKUP_DIRNAME);
	//fprintf(stderr, "%s(2) %s\n", __FUNCTION__, dstname);
	dirent = opendir(dstname);
	if (dirent) {
		closedir(dirent);
	} else {
		if (errno==ENOTDIR) {
			goto err_dir;
		}
		if (0 != mkdir(dstname, 0755))			
			goto err_dir;
	}

	snprintf(dstname, sizeof(dstname), "%s/%s/%s/%s", USB_MNT_DIR, buffer, BACKUP_DIRNAME, USB_CFG_FILENAME);
	//fprintf(stderr, "%s(3) %s\n", __FUNCTION__, dstname);
	// check if dst file exist..
	if (is_file(dstname))
		goto err_exist;
	
	// prepare config file..
	call_cmd("/bin/CreatexmlConfig", 0, 1);	


	pipe.buffer = cpbuf;
	pipe.bufsize = sizeof cpbuf;
	pipe.func = encode;
	
	rv = file_copy_pipe(CONFIG_XMLFILE, dstname, &pipe);
	if (rv != 0) {
		goto err_file;
	}

	call_cmd("/bin/rm", 1, 1, CONFIG_XMLFILE);
	
	submitUrl = websGetVar(wp, T("submit-url"), T(""));
	OK_MSG(submitUrl);
	return;
	
	/************Place your code here, do what you want to do! ************/
err_exist:
	snprintf(dstname, sizeof dstname, "file already exist, remove it first");
	ERR_MSG(dstname);
	return;
	
err_file:
	call_cmd("/bin/rm", 1, 1, CONFIG_XMLFILE);
	snprintf(dstname, sizeof dstname, "fail to copy, disk full? code %d", rv);
	ERR_MSG(dstname);
	return;
	// file related erro;
	
err_dir:
	snprintf(dstname, sizeof dstname, "Cannot access directory %s", BACKUP_DIRNAME);
	ERR_MSG(dstname);
	return;
	 // directory related error.	
	
check_err:
	_TRACE_LEAVEL;
	return;
}

int usbRestore() {
	FILE*	fp_input = NULL;
	int 		rv = 0;
	int tmp;
	char buffer[10], dstname[60];
	unsigned int mask;
	struct file_pipe	pipe;
	unsigned char	cpbuf[256];

	mask = file_read_number(USB_MNT_FILE);

	for (tmp = 0; tmp < 32; tmp++) {
		if (!(mask & (1 << tmp)))
			continue;		
		usb_get_partition_name(tmp, buffer, sizeof(buffer));
		snprintf(dstname, sizeof(dstname), "%s/%s/%s/%s", USB_MNT_DIR, buffer, BACKUP_DIRNAME, USB_CFG_FILENAME);
		if (!is_file(dstname))
			continue;

		// prepare config file..
		fp_input=fopen(CONFIG_XMLFILE,"w");
		if (!fp_input)
		{
			printf("Create config file fail!\n");
			return -1;
		}
		fclose(fp_input);
		// do restore here...
		pipe.buffer = cpbuf;
		pipe.bufsize = sizeof cpbuf;
		pipe.func = encode;
		
		rv = file_copy_pipe(dstname, CONFIG_XMLFILE, &pipe);
		if (rv != 0) {
			return -1;
		}

		rv = call_cmd("/bin/LoadxmlConfig", 0, 1);
		if (rv != 0) {
			return -1;
		}

		return 0;
	}

	return -1;	

}
#endif

/*****************************
**ָ
*/
void formRestore(webs_t wp, char_t *path, char_t *query)
{
	int				lineno = __LINE__;

		
	_TRACE_CALL;

	/************Place your code here, do what you want to do! ************/
#ifdef CONFIG_MIDDLEWARE
	if(sendSetDefaultFlagMsg2MidProcess() == 0 && sendSetDefaultRetMsg2MidIntf() == 0)
	{
		sleep(10);	//wait reboot command from middleware
	}
#endif
	/************Place your code here, do what you want to do! ************/
	websHeader(wp);
	websWrite(wp, T("<META HTTP-EQUIV=Refresh CONTENT=\"120; URL=/admin/status.asp\">\n"));
	websWrite(wp, T("<body><blockquote><h4>\n"));
	websWrite(wp, T("%s</h4>\n"), TAdmin_str_rebootWord0);
	websWrite(wp, T("%s<br><br>\n"), TAdmin_str_rebootWord1);
	websWrite(wp, T("%s\n"), TAdmin_str_rebootWord2);
	websWrite(wp, T("</blockquote></body>"));
	websFooter(wp);
	websDone(wp, 200);
		
#ifdef EMBED
//	va_cmd("/bin/flash", 2, 1, "default", "cs");
	
	semSave.__sem_value=SEM_DEFAULT;
	sem_post(&semSave);
#endif
	
check_err:
	_TRACE_LEAVEL;
	return;
}

#ifdef SYSLOG_SUPPORT_ENABLE
/*****************************
**־
*/
int initPageSysLog(int eid, webs_t wp, int argc, char_t ** argv)
{
	int					lineno = __LINE__;
	char				issu = 0;
	struct user_info *	pUser_info = NULL;
	
	pUser_info = search_login_list(wp);

	_TRACE_CALL;

	/************Place your code here, do what you want to do! ************/
	/************Place your code here, do what you want to do! ************/
	
	_PUT_BOOL(issu);
	
check_err:
	_TRACE_LEAVEL;
	return 0;
}

void writeLogFileHeader(FILE* fp)
{
	unsigned char dev_id_buf[256];
	unsigned char *bufptr;

#ifdef _CWMP_MIB_
	strcpy(dev_id_buf, MANUFACTUREROUI_STR);
	bufptr=dev_id_buf+strlen(MANUFACTUREROUI_STR);
	*bufptr='-';
	bufptr++;
	mib_get( CWMP_SERIALNUMBER, (void *)bufptr);
#else
    strcpy(dev_id_buf, devId);
#endif
    
    fprintf(fp, "Manufacturer:%s;\nProductClass:%s;\nSerialNumber:%s;\nIP:%s;\nHWVer:%s;\nSWVer:%s;\n\n", 
            manufacture, devModel, dev_id_buf, log_ip, hdVer, stVer);
}

void formSysLog(webs_t wp, char_t *path, char_t *query)
{
	char*			stemp = "";
	int				lineno = __LINE__;

	_TRACE_CALL;

	FETCH_INVALID_OPT(stemp, "action", _NEED);
	
	if(strcmp(stemp, "new") == 0)	// create new log file
	{
		/************Place your code here, do what you want to do! ************/
		/************Place your code here, do what you want to do! ************/
	}
	else if(strcmp(stemp, "clr") == 0)	//clear all log
	{
		/************Place your code here, do what you want to do! ************/
		unsigned char syslogEnable=0;
		mib_get(MIB_SYSLOG_ENABLE,&syslogEnable);
		if(syslogEnable){
			 FILE* fp=NULL;
			 fp=fopen("/var/config/syslogd.txt","w");
			 if(fp)
			 {
                writeLogFileHeader(fp);
			 	fclose(fp);
			 }
			 va_cmd("/bin/flatfsd",1,1,"-s");
			}
		/************Place your code here, do what you want to do! ************/
	}
	else {lineno = __LINE__; goto check_err;}
	
	_COND_REDIRECT;
check_err:
	_TRACE_LEAVEL;
	return;
}


/*****************************
**ʼ¼
*/
int accessSysLogList (int eid, webs_t wp, int argc, char_t ** argv)
{
	struct access_syslog_entry	entry;
	int				cnt = 0;
	int				index = 0;
	int				lineno = __LINE__;

	_TRACE_CALL;
		/************Place your code here, do what you want to do! ************/
		unsigned char displayLevel=0;
		mib_get(MIB_SYSLOG_SHOW_GRADE,&displayLevel);
		/************Place your code here, do what you want to do! ************/
		for(index = 0; index < 1; index++)
	{
		/************Place your code here, do what you want to do! ************/
		/************Place your code here, do what you want to do! ************/
		//add by ramen
		FILE *fp=NULL;
		int infograde=0;
		if((fp=fopen("/var/config/syslogd.txt","r"))==NULL)
						goto check_err;
		char tmpbuf[1024]={0};

        /* Pass the log file header */
		while(fgets(tmpbuf,sizeof(tmpbuf),fp))
		{
            if (1 == strlen(tmpbuf))
            {
                /* empty line, next is log */
                break;
            }
		}
        
		while(fgets(tmpbuf,sizeof(tmpbuf),fp))
		{
		tmpbuf[strlen(tmpbuf)-1]='\0';
		memset(&entry,0,sizeof(entry));		
		//<46> Jan  1 00:01:18 2000 syslogd started: BusyBox v0.60.4 (2008.02.18-06:10+0000)
		//<46> Mar 18 17:25:30 2008 syslogd started: BusyBox v0.60.4 (2008.03.18-08:11+0000)
		//get grade
		char *tmp1=tmpbuf;
		char *tmp2=tmpbuf;
#if 0
		tmp1=strstr(tmpbuf,"<");
		tmp2=strstr(tmpbuf,">");
		tmp1+=1;
		memcpy(entry.grade,tmp1,tmp2-tmp1);		
		infograde=atoi(entry.grade)&0x07;
		if(infograde>displayLevel) continue;				
		memset(entry.grade,0,sizeof(entry.grade));
		memcpy(entry.grade,loggrade[infograde],strlen(loggrade[infograde]));
		//get  date
		char date[32]={0};
		tmp1=tmp2+1;
		tmp2=strstr(tmp2+1," ");	
		tmp2=strstr(tmp2+1," ");
		 if (tmp2[0]==' ')   tmp2=tmp2+1;
		tmp2=strstr(tmp2+1," ");
		tmp2=strstr(tmp2+1," ");
		tmp2=strstr(tmp2+1," ");
		memcpy(date,tmp1,tmp2-tmp1);	
		//printf("date=%s\n",date);
		timeFormatConvert(date,entry.date);
		//get devName
		tmp1=tmp2+1;
		tmp2=strstr(tmp1," ");
		memcpy(entry.devName,tmp1,tmp2-tmp1);				
		//get info
		tmp1=tmp2+1;		
		//printf("tmp1=%s\n",tmp1);	
		entry.pInfo=fixupLoginfo(tmp1);
		//printf("pInfo=%s\n",entry.pInfo);	
#else
		/* get time */
		memcpy(entry.date,tmp1,sizeof("YYYY-MM-DD HH:MM:SS")-1);

        /* get grade */
		tmp1=strstr(tmp1,"[") + 1;		
		tmp2=strstr(tmp1,"]");
        memcpy(entry.grade, tmp1, tmp2 - tmp1);

        int loglevel;
        for (loglevel = 0; loglevel < sizeof(loggrade)/sizeof(char *); loglevel++)
        {
            if (0 == strcmp(loggrade[loglevel], entry.grade))
            {
                break;
            }
        }

        if ((loglevel >= sizeof(loggrade)/sizeof(char *)) || (loglevel > displayLevel))
        {
            continue;
        }

		/* get devName */
		tmp1=tmp2+2;
		tmp2=strstr(tmp2, ":");
        if (NULL != tmp2)
        {
    		memcpy(entry.devName,tmp1,tmp2-tmp1);
    		tmp1=tmp2+1;
        }

        /* get info */
		entry.pInfo=fixupLoginfo(tmp1);
#endif
        
		websWrite(wp, T("rcs.push(new Array(\"%s\", \"%s\", \"%s\", \"%s\"));\n"), entry.date, entry.devName, entry.grade, entry.pInfo);
		}
	}
		
	
check_err:
	_TRACE_LEAVEL;
	return 0;
}


/*****************************
**ȫ¼
*/
int secureSysLogList  (int eid, webs_t wp, int argc, char_t ** argv)
{
	struct access_syslog_entry	entry;
	int				cnt = 0;
	int				index = 0;
	int				lineno = __LINE__;

	_TRACE_CALL;

	/************Place your code here, do what you want to do! ************/
	/************Place your code here, do what you want to do! ************/

	for(index = 0; index < cnt; index++)
	{
		/************Place your code here, do what you want to do! ************/
		/************Place your code here, do what you want to do! ************/
		
		websWrite (wp, T ("rcs.push(new Array(\"%s\", \"%s\", , \"%s\", \"%s\"));\n"), entry.date, entry.devName, entry.grade, entry.pInfo);
	}
		
	
check_err:
	_TRACE_LEAVEL;
	return 0;
}


/*****************************
**дȼ
*/
int initPageSysLogConfig(int eid, webs_t wp, int argc, char_t ** argv)
{
	//¼:		
	unsigned char 	syslogEnable = 0;	//1- ;  0- 
	//¼ȼ:		
	unsigned char 	recordLevel = 0;	//0- Emergency;  1- Alert; ; 7- Debugging
	//ʾȼ:		
	unsigned char 	dispLevel = 0;	//0- Emergency;  1- Alert; ; 7- Debugging
	//ģʽ:			
	unsigned char 	sysMode = 0;	//0- Local;  1- Remote;  2- Both
	unsigned long	logAddr = 0;
	unsigned short	logPort = 0;
	int				lineno = __LINE__;
	
	_TRACE_CALL;

	/************Place your code here, do what you want to do! ************/
	//add by ramen
	mib_get(MIB_SYSLOG_ENABLE,(void*)&syslogEnable);	
	mib_get(MIB_SYSLOG_RECORDE_GRADE,(void*)&recordLevel);
	mib_get(MIB_SYSLOG_SHOW_GRADE,(void*)&dispLevel);
	mib_get(MIB_SYSLOG_MODE,(void*)&sysMode);	
	if(sysMode){
		mib_get(MIB_SYSLOG_REMOTE_IP,(void*)&logAddr);
		mib_get(MIB_SYSLOG_REMOTE_PORT,(void*)&logPort);		
	}
	/************Place your code here, do what you want to do! ************/
	
	_PUT_BOOL(syslogEnable);
	_PUT_INT(recordLevel);
	_PUT_INT(dispLevel);
	_PUT_INT(sysMode);
	_PUT_IP(logAddr);
	_PUT_INT(logPort);

check_err:
	_TRACE_LEAVEL;
	return 0;
}

void formSysLogConfig(webs_t wp, char_t *path, char_t *query)
{
	//¼:		
	unsigned char 	syslogEnable = 0;	//1- ;  0- 
	//¼ȼ:		
	unsigned char 	recordLevel = 0;	//0- Emergency;  1- Alert; ; 7- Debugging
	//ʾȼ:		
	unsigned char 	dispLevel = 0;	//0- Emergency;  1- Alert; ; 7- Debugging
	//ģʽ:			
	unsigned char 	sysMode = 0;	//0- Local;  1- Remote;  2- Both
	unsigned long	logAddr = 0;
	unsigned short	logPort = 0;
	char*			stemp = "";
	int				lineno = __LINE__;

	_TRACE_CALL;

	_GET_BOOL(syslogEnable, _NEED);
	if(syslogEnable < 0 || syslogEnable > 1){lineno = __LINE__; goto check_err;}
	if(syslogEnable)
	{
		_GET_INT(recordLevel, _NEED);
		if(recordLevel < 0 || recordLevel > 7){lineno = __LINE__; goto check_err;}
		_GET_INT(dispLevel, _NEED);
		if(dispLevel < 0 || dispLevel > 7){lineno = __LINE__; goto check_err;}
		_GET_INT(sysMode, _NEED);
		if(sysMode < 0 || sysMode > 2){lineno = __LINE__; goto check_err;}

		if(sysMode >= 1)
		{
			_GET_IP(logAddr, _NEED);
			if(logAddr == 0 || logAddr == 0xFFFFFFFF){lineno = __LINE__; goto check_err;}
			_GET_INT(logPort, _NEED);
			if(logPort <= 0 || logPort > 65535){lineno = __LINE__; goto check_err;}
		}
	}

	
	/************Place your code here, do what you want to do! ************/
	setupSyslog(SYSLOG_DISABLED);
	mib_set(MIB_SYSLOG_ENABLE,(void*)&syslogEnable);
	mib_set(MIB_SYSLOG_RECORDE_GRADE,(void*)&recordLevel);
	mib_set(MIB_SYSLOG_SHOW_GRADE,(void*)&dispLevel);	
	mib_set(MIB_SYSLOG_MODE,(void*)&sysMode);	
	if(sysMode)
		{
		mib_set(MIB_SYSLOG_REMOTE_IP,(void*)&logAddr);
		mib_set(MIB_SYSLOG_REMOTE_PORT,(void*)&logPort);
		}
	setupSyslog(SYSLOG_ENABLED);
	/************Place your code here, do what you want to do! ************/
	
	_COND_REDIRECT;

#ifdef WRITE_TO_FLASH
	mib_update(CURRENT_SETTING, CONFIG_MIB_ALL);
#endif

check_err:
	_TRACE_LEAVEL;
	return;
}

#endif

/*****************************
**ά
*/

/**************
**Part 1: get Ethernet ports status...
**input para: port, the switch port index, ordered by 1,2,3,4
**return val:  1, link up, 0, link down;
cmd data: 31-39 is reserved from ethctl.c for status polling...
cmd2 data: is port num, arranged from 0...
cmd3, cmd4 data is reserved.
*/
#ifdef _LINUX_2_6_
#define SIOCETHTEST	0x89b1
#else
#define SIOCETHTEST	0x89a1
#endif
struct arg{
	unsigned char cmd;
	unsigned int cmd2;
	unsigned int cmd3;
	unsigned int cmd4;
}pass_arg;
int enetStatus(int port)
{
	int fd;
	char *pEnd;
  	struct ifreq		ifr;
	if(port<1 || port >4)
		return 0;
	fd = socket(AF_INET, SOCK_DGRAM, 0);
  	if(fd< 0){
		printf("Error!Socket create fail in ethctl.\n");
  	}
	memset(&pass_arg, 0, sizeof(pass_arg));
	memset(&ifr, 0, sizeof(ifr));
	pEnd="eth0";	
	strncpy(ifr.ifr_name, pEnd, IFNAMSIZ);
	pass_arg.cmd=31;   //polling link status...
	pass_arg.cmd2=port-1; // which port to poll.
	ifr.ifr_data = (void *)&pass_arg;	
	if (ioctl(fd, SIOCETHTEST, &ifr) < 0) {
		printf("Error ioctl in ethctl\n");
		close(fd);
		return 0;
	};
	close(fd);
	if(pass_arg.cmd==1) // up
	{
		return 1;
	}else
		return 0;

	
}

static char 			wanifName[MAXIFNAMESIZE]={0};
static int 				wanifIndex=0;
static char			wanifprev[MAXIFNAMESIZE]={0};
static char			wanifnext[MAXIFNAMESIZE]={0};
int initPageMntMnt(int eid, webs_t wp, int argc, char_t ** argv)
{
	//ӿ:			

	//ENET1Ӳ:	
	unsigned char 	enet1link = 0;		//1- PASS;  0- FAIL
	//ENET2Ӳ:	
	unsigned char 	enet2link = 0;
	//ENET3Ӳ:	
	unsigned char 	enet3link = 0;
	//ENET4Ӳ:	
	unsigned char 	enet4link = 0;
	//:		
	unsigned char 	usblink = 0;
	//:		
	unsigned char 	wllink = 0;
	//ADSLͬ:	
	unsigned char 	adslSync = 0;
	//ATM OAM F5 segment ping:		
	unsigned char 	f5SegPing = 0;
	//ATM OAM F5 end-to-end ping:	
	unsigned char 	f5endPing = 0;
	//PPP:	
	unsigned char 	ppplink = 0;
	//ISP֤:		
	unsigned char 	ispAuthen = 0;
	//ԷIPַ:	
	unsigned char 	distrIp = 0;
	//pingȱʡ:		
	unsigned char 	defGwPing = 0;
	//ping:	
	unsigned char 	priDnsPing = 0;
	//ǰԷʽ
	char			type[10];
	unsigned char	usbts = 0;//ǷUSB
	unsigned char	wlants = 0; //Ƿ߲
	//unsigned char	ppppassthrough = 0; //Ƿ"PPPOE PassThrough"
	int				lineno = __LINE__;
	unsigned char buffer[256];
	MIB_CE_ATM_VC_T Entry;
	MIB_CE_ATM_VC_Tp pEntry;
	unsigned int vpi, vci;
	int entryNum;
	int lb5s;
	int lb5e;
	unsigned char ifPPPItf=0;   // ǷʾPPPϢ...
	int pppflag=0;
	_TRACE_CALL;
	strcpy(type, "f5");//default value

	strcpy(wanifName, "234234234");

	
	/************Place your code here, do what you want to do! ************/
	if(wanifName[0]==0 || (wanifprev[0]==0 && wanifName[0]==0 && wanifnext[0]==0))
	{
		//get the first wan interface...		
		wanifprev[0]=0;
		wanifnext[0]=0;
		wanifIndex=0;	
	}
	entryNum = mib_chain_total(MIB_ATM_VC_TBL);
	if(wanifIndex <0 || wanifIndex >= entryNum)
	{
		//out of mib chain range.... reset it
		wanifprev[0]=0;
		wanifnext[0]=0;
		wanifIndex=0;
		wanifName[0]=0;
	}

	if(wanifIndex !=0)
	{
		//not first one.
		mib_chain_get(MIB_ATM_VC_TBL, wanifIndex-1, (void *)&Entry);
		getWanName(&Entry, wanifprev);
	}else
		wanifprev[0]=0;
	
	if(wanifIndex != entryNum-1)
	{
		//not last one.
		mib_chain_get(MIB_ATM_VC_TBL, wanifIndex+1, (void *)&Entry);
		getWanName(&Entry, wanifnext);		
	}else
		wanifnext[0]=0;
	mib_chain_get(MIB_ATM_VC_TBL, wanifIndex, (void *)&Entry);
	getWanName(&Entry, wanifName);
	pEntry=&Entry;
	//ethernet port status;
	enet1link=enetStatus(1);
	enet2link=enetStatus(2);
	enet3link=enetStatus(3);
	enet4link=enetStatus(4);	

	// dsl sync status
	//getInfo("linkState")
	memset(buffer, 0, sizeof(buffer));
	getAdslInfo(ADSL_GET_STATE, buffer, sizeof(buffer));
	if(!strncmp(buffer, "SHOWTIME", 8))
	{
		adslSync=1;
	}else
	{
		adslSync=0;
	}
	//oam F5 loopback test...
	f5SegPing = testOAMLookback(pEntry, 0, 5);
	f5endPing = testOAMLookback(pEntry, 1, 5);
	//lb4s = testOAMLookback(pEntry, 0, 4);
	//lb4e = testOAMLookback(pEntry, 1, 4);

	//ppp test, if ppp type.
	if(pEntry->cmode == ADSL_PPPoE)
	{
		FILE *fp;
		char buff[10];
		int pppif;
		if (fp = fopen("/tmp/ppp_diag_log", "r")) {
			while (fgets(buff, sizeof(buff), fp) != NULL) {
				sscanf(buff, "%d:%d", &pppif, &pppflag);
				if (pppif == PPP_INDEX(Entry.ifIndex))
					break;
			}
			fclose(fp);
		}else
		{
			pppflag=0;
		}
		switch(pppflag)
		{
			case 1:
				ppplink = 1;
				ispAuthen = distrIp = 0;
				break;
			case 2:
				ppplink = ispAuthen = 1;
				distrIp = 0;
				break;
			case 3:
				ppplink = ispAuthen = distrIp = 1;
				break;
			case 0:
			default:
				ppplink = ispAuthen = distrIp = 0;
				break;
		}
		ifPPPItf=1;
	}

	//ping test for default gateway and dns server, if necessary
	if (pEntry->cmode > ADSL_BR1483) 
	{
		char pingaddr[16];
		memset(pingaddr, 0x00, 16);
		if (defaultGWAddr(pingaddr))
			defGwPing = 0;
		else
			defGwPing = testPing(pingaddr);
		memset(pingaddr, 0x00, 16);
		if (pdnsAddr(pingaddr))
			priDnsPing = 0;
		else
			priDnsPing = testPing(pingaddr);
	}
	/************Place your code here, do what you want to do! ************/
	
	_PUT_STR(type);
	if(wanifName[0])
	{
		_PUT_STR(wanifName);
		_PUT_INT(wanifIndex);
	}
	if(wanifprev[0])_PUT_STR(wanifprev);
	if(wanifnext[0])_PUT_STR(wanifnext);
	_PUT_BOOL(enet1link);
	_PUT_BOOL(enet2link);
	_PUT_BOOL(enet3link);
	_PUT_BOOL(enet4link);
	if(usbts)_PUT_BOOL(usblink);
	if(wlants)_PUT_BOOL(wllink);
	_PUT_BOOL(adslSync);
	_PUT_BOOL(f5SegPing);
	_PUT_BOOL(f5endPing);
	if(ifPPPItf)
	{
		_PUT_BOOL(ppplink);
		_PUT_BOOL(ispAuthen);
		_PUT_BOOL(distrIp);
	}
	if (pEntry->cmode > ADSL_BR1483) 
	{
		_PUT_BOOL(defGwPing);
		_PUT_BOOL(priDnsPing);
	}
check_err:
	_TRACE_LEAVEL;
	return 0;
}

void formDiagTest(webs_t wp, char_t *path, char_t *query)
{
	char*			stemp = "";
	char*			ptype = NULL;	//ͣF4 OR F5
	char*			pwanifName = NULL;
	int				lineno = __LINE__;
	_TRACE_CALL;

	FETCH_INVALID_OPT(stemp, "action", _NEED);
	
	if(strcmp(stemp, "fn") == 0)	// ά
	{
		/************Place your code here, do what you want to do! ************/
		pid_t  tr069_pid;
#ifdef CONFIG_MIDDLEWARE
		pid_t tmp_pid;
		// signal midware interface to inform midware that maintenance is finished
		tmp_pid = read_pid(CWMP_MIDPROC_RUNFILE);
		if ( tmp_pid > 0)
			kill(tmp_pid, SIGUSR2);
#endif
		// signal tr069 to inform ITMS that maintenance is finished
		tr069_pid = read_pid("/var/run/cwmp.pid");
		if ( tr069_pid > 0)
			kill(tr069_pid, SIGUSR1);
		/************Place your code here, do what you want to do! ************/
	}
	else if(strcmp(stemp, "rs") == 0)	//ϲ
	{
		_GET_PSTR(wanifName, _NEED);
		_GET_INT(wanifIndex, _NEED);
		_GET_PSTR(type, _NEED);
		/************Place your code here, do what you want to do! ************/
		/************Place your code here, do what you want to do! ************/
	}
	else {lineno = __LINE__; goto check_err;}

	
	_COND_REDIRECT;
check_err:
	_TRACE_LEAVEL;
	return;
}

