/*
 *      Web server handler routines for Routing stuffs
 *
 */


/*-- System inlcude files --*/
#include <net/if.h>
#include <sys/ioctl.h>
#include <sys/time.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/socket.h>
#include <net/route.h>

/*-- Local inlcude files --*/
#include "../webs.h"
#include "webform.h"
#include "mib.h"
#include "utility.h"


///////////////////////////////////////////////////////////////////
//add by chenzhuoxin
void formRoute(webs_t wp, char_t *path, char_t *query)
{
       char_t *strVal = NULL;
       typedef struct 
	{
	   unsigned char ifIndex __PACK__;		//ʹýӿʱ,Ϊ0
	   char ifname[32] __PACK__;			//ӿ
	   unsigned int gw __PACK__;			     //IPַ
	   unsigned int dip __PACK__;			    //Ŀַ
	   unsigned int dmask __PACK__;		     //
         }route_entry;
	   route_entry routeEntry;
	   char temp[25];
	   char *ptemp = NULL;
	   unsigned int i;
	   MIB_CE_IP_ROUTE_T Entry = {0};
	   unsigned int totalEntry ;
	   int mibTotal;
	   MIB_CE_ATM_VC_T vcEntry;
	   char interface_name[30];
	   
	printf("enter formRoute\n");
	//get action
	strVal = websGetVar(wp, T("action"), T(""));
       if(0 == strcmp(strVal,"sv"))
	{
	     /*
	       *routeEntry.ifIndex = Add code by Realtek using strVal
             */
	      //for debug 
	      routeEntry.ifIndex = 255;
	      printf("ifindex = %d\n",routeEntry.ifIndex);
		  
		/*get ifIndex*/
		Entry.ifIndex = 0xff;
		strVal = websGetVar(wp, T("ifStr"), T(""));
		if(!strcmp(strVal,"on")){
			strVal = websGetVar(wp, T("dstWanIf"), T(""));
			strcpy(routeEntry.ifname,strVal);
			printf("ifname = %s\n",routeEntry.ifname);
			
			mibTotal = mib_chain_total(MIB_ATM_VC_TBL);
			for (i=0; i<mibTotal; i++) {
				if (!mib_chain_get(MIB_ATM_VC_TBL, i, (void *)&vcEntry)) {
					printf("get mib_atm_vc_tbl error!\n");
					goto setOK;
				}
				//get name
				getWanName(&vcEntry, interface_name);
				if(!strcmp(interface_name,routeEntry.ifname)){
					Entry.ifIndex = vcEntry.ifIndex;
					break;
				}
			}
		}
		
		//get gateway
		strVal = websGetVar(wp, T("gwStr"), T(""));
		if(!strcmp(strVal,"on")){
			strVal = websGetVar(wp, T("dstGtwy"), T(""));
			if(strVal)
		 		if(0 != inet_aton(strVal,(struct in_addr *)&routeEntry.gw))
					printf("gateway = %x\n",routeEntry.gw);
		      		else
			       		routeEntry.gw = 0;
		}else{
			routeEntry.gw = 0;
		}
		
        	//get dstAddr
	      strVal = websGetVar(wp, T("dstAddr"), T(""));
	      if(strVal)
		       if(0 != inet_aton(strVal,(struct in_addr *)&routeEntry.dip))
			       printf("dstAddr = %x\n",routeEntry.dip);
		       else
			       routeEntry.dip = 0;

	      //get dstMask
	      strVal = websGetVar(wp, T("dstMask"), T(""));
	      if(strVal)
		      if(0 != inet_aton(strVal,(struct in_addr *)&routeEntry.dmask))
			       printf("dstMask = %x\n",routeEntry.dmask);
		      else
			       routeEntry.dmask = 0;

		*((unsigned int *)Entry.destID) =routeEntry.dip;
		*((unsigned int *)Entry.netMask) =routeEntry.dmask;
		*((unsigned int *)Entry.nextHop) =routeEntry.gw;
		Entry.FWMetric = 1;
		Entry.Enable=1;

		if((Entry.ifIndex == 0xff) && (*((unsigned int *)Entry.nextHop) == 0))
			goto setOK;
		
		if(mib_chain_add(MIB_IP_ROUTE_TBL, (unsigned char*)&Entry) != 1){
			goto setOK;
		}

		route_cfg_modify(&Entry, 0);
		
      }
	else if(0 == strcmp(strVal,"rm"))
      {
             // delete route
             //get ripEntry
	      strVal = websGetVar(wp, T("lst"), T(""));
	 
	      printf("strVal=%s\n",strVal);

       	while( ' ' != *strVal)
	      {
		       while('\0' != *strVal && ';' != *strVal)
		       {
		             //get dip
		 	      ptemp = temp;
		 	      while('|' != *strVal)
				   	 *ptemp++ = *strVal++;
			      if('|' == *strVal)
			      {
				      *ptemp = '\0';
				      strVal++;
				      if(0 != inet_aton(temp, (struct in_addr *)&routeEntry.dip))
					    printf("dip = %x\n",routeEntry.dip);
		                   else
					    routeEntry.dip = 0;
			        }

			        //get dmask
		 	        ptemp = temp;
		 	        while('|' != *strVal)
				   	 *ptemp++ = *strVal++;
			        if('|' == *strVal)
			       {
				        *ptemp = '\0';
				        strVal++;
				        if(0 != inet_aton(temp,(struct in_addr *)&routeEntry.dmask))
					        printf("dmask = %x\n",routeEntry.dmask);
		                     else
					        routeEntry.dmask = 0;
			         }

			         //get gw
		 	         ptemp = temp;
		 	         while('|' != *strVal)
				   	 *ptemp++ = *strVal++;
			         if('|' == *strVal)
			         {
				         *ptemp = '\0';
				          strVal++;
				          if(0 != inet_aton(temp,(struct in_addr *)&routeEntry.gw))
					          printf("gw = %x\n",routeEntry.gw);
		                       else
					          routeEntry.gw = 0;
			           }
				 
			           //get ifname
		 	           ptemp = temp;
		 	           while('|' != *strVal && '\0' != *strVal && ';' != *strVal)
				          *ptemp++ = *strVal++;
		                  if('|' == *strVal)
			           {
				           *ptemp = '\0';
				           strVal++;
				           strcpy(routeEntry.ifname,temp);
				            printf("ifname = %s\n",routeEntry.ifname);
			            }

			            //get ifindex
			           /*
			             *ripEntry.ifIndex = Add code by Realtek using routeEntry.ifname
			             */
			            //for debug 
		                  routeEntry.ifIndex = 255;
			            printf("ifindex = %d",routeEntry.ifIndex);
			    }

				totalEntry = mib_chain_total(MIB_IP_ROUTE_TBL); 
				for (i=0; i<totalEntry; i++) {
					if (!mib_chain_get(MIB_IP_ROUTE_TBL, i, (void *)&Entry)) {
						goto setOK;
					}
					if((*((unsigned int*)Entry.destID) == routeEntry.dip) && 
						(*((unsigned int*)Entry.netMask) == routeEntry.dmask) &&
						(*((unsigned int*)Entry.nextHop) == routeEntry.gw))
					{
						if(mib_chain_delete(MIB_IP_ROUTE_TBL, i) != 1) {
							goto setOK;
						}
						route_cfg_modify(&Entry, 1);
						break;
					}
				} // end of for

		           if('\0' == *strVal)           //the end
		 	           break;
		           if(';' == *strVal)            //the next recode
		          {
			            strVal++;
			            printf("\n");
			           printf("the next record\n");
		          }
	        }
       }
setOK:
	{REDIRECTSUBMITURL;}
#ifdef WRITE_TO_FLASH
	mib_update(CURRENT_SETTING, CONFIG_MIB_ALL);
#endif
	return ;
}
#if 0
void formRoute(webs_t wp, char_t *path, char_t *query)
{
	char_t	*str, *submitUrl;
	char tmpBuf[100];
	//struct rtentry rt;
	struct in_addr *addr;
	MIB_CE_IP_ROUTE_T entry;
	int xflag, isnet;
	int skfd;
	int intVal;
	//char ifname[16];
#ifndef NO_ACTION
	int pid;
#endif
	
	memset( &entry, 0, sizeof(MIB_CE_IP_ROUTE_T));

#ifdef DEFAULT_GATEWAY_V2
	// Jenny, Default Gateway setting
	str = websGetVar(wp, T("dgwSet"), T(""));
	if (str[0]) {
		unsigned char dgw;
		
		str = websGetVar(wp, T("droute"), T(""));
		dgw = (unsigned char)atoi(str);
		if (!mib_set(MIB_ADSL_WAN_DGW_ITF, (void *)&dgw)) {
			strcpy(tmpBuf, T("Set Default Gateway error!"));
			goto setErr_route;
		}
		goto setOk_route;
	}
#endif

	// Delete
	str = websGetVar(wp, T("delRoute"), T(""));
	if (str[0]) {
		unsigned int i;
		unsigned int idx;
		MIB_CE_IP_ROUTE_T Entry;
		unsigned int totalEntry = mib_chain_total(MIB_IP_ROUTE_TBL); /* get chain record size */
		str = websGetVar(wp, T("select"), T(""));
		
		if (str[0]) {
			for (i=0; i<totalEntry; i++) {
				idx = totalEntry-i-1;			
				snprintf(tmpBuf, 4, "s%d", idx);
				
				if ( !gstrcmp(str, T(tmpBuf)) ) {
					//struct sockaddr_in *s_in;
					/* get the specified chain record */
					if (!mib_chain_get(MIB_IP_ROUTE_TBL, idx, (void *)&Entry)) {
						strcpy(tmpBuf, errGetEntry);
						goto setErr_route;
					}
					
					// delete from chain record
					if(mib_chain_delete(MIB_IP_ROUTE_TBL, idx) != 1) {
						strcpy(tmpBuf, T("Delete chain record error!"));
						goto setErr_route;
					}
	
					route_cfg_modify(&Entry, 1);
					
					goto setOk_route;
				}
			} // end of for
		}
		
		goto setOk_route;
	}

	// parse input
	str = websGetVar(wp, T("destNet"), T(""));
	if (!inet_aton(str, (struct in_addr *)&entry.destID)) {
		snprintf(tmpBuf, 100, "Error: can't resolve dest %s", str);
		goto setErr_route;
	}
		
	str = websGetVar(wp, T("subMask"), T(""));
	if (!inet_aton(str, (struct in_addr *)&entry.netMask)) {
		snprintf(tmpBuf, 100, "Error: can't resolve mask %s", str);
		goto setErr_route;
	}	

	str = websGetVar(wp, T("metric"), T(""));
	if ( str[0] ) {
		if (strcmp(str, "-1") == 0 )
			intVal = -1;
		else if(!string_to_dec(str, &intVal)) {
			snprintf(tmpBuf, 100, "Error: Metric must be a number %s", str);
			goto setErr_route;	
		}

		if ((intVal < -1) || (intVal > 65535)) {
			snprintf(tmpBuf, 100, "Error: Metric must be -1 to 65525");
			goto setErr_route;	
		}
		entry.FWMetric = intVal;		
	}

	entry.ifIndex = 0xff;
	str = websGetVar(wp, T("interface"), T(""));
	if ( str ) {
		if (!string_to_dec(str, &intVal)) {
			snprintf(tmpBuf, 100, "Error: ifname error %s", str);
			goto setErr_route;	
		}
		entry.ifIndex = intVal;	
	}

	str = websGetVar(wp, T("nextHop"), T(""));
	if (!str && (entry.ifIndex == 0xff)) {
		snprintf(tmpBuf, 100, "Error: can't resolve next tHop %s", str);
		goto setErr_route;
	} else if (str[0]) {
		if (!inet_aton(str, (struct in_addr *)&entry.nextHop)) {
			snprintf(tmpBuf, 100, "Error: can't resolve next tHop %s", str);
			goto setErr_route;
		}
	}

	str = websGetVar(wp, T("enable"), T(""));
	if ( str && str[0] ) {
		entry.Enable = 1;
	}
		

	// Update
	str = websGetVar(wp, T("updateRoute"), T(""));
	if (str && str[0]) {		
		char *select, tmpBuf[8]; 
		int i, idx;
		MIB_CE_IP_ROUTE_T tmp;
		unsigned int totalEntry = mib_chain_total(MIB_IP_ROUTE_TBL); /* get chain record size */

		select = websGetVar(wp, T("select"), T(""));
		if (!select ) 
			goto setOk_route;

		for (i=0; i<totalEntry; i++) {
			idx = totalEntry-i-1;			
			snprintf(tmpBuf, 4, "s%d", idx);			

			if ( !gstrcmp(select, T(tmpBuf)) ) {																

				if (mib_chain_get(MIB_IP_ROUTE_TBL, idx, (void *)&tmp)) {
					route_cfg_modify(&tmp, 1);
					entry.InstanceNum = tmp.InstanceNum; /*keep old instancenum, jiunming*/
				}

				mib_chain_update(MIB_IP_ROUTE_TBL, &entry, idx);
				route_cfg_modify(&entry, 0);
				
				goto setOk_route;
			}
		} // end of for
		
		goto setOk_route;
	}

	// Add
	str = websGetVar(wp, T("addRoute"), T(""));
	if (str && str[0]) {	
		printf("add route\n");
		/* Clean out the RTREQ structure. */
		if(mib_chain_add(MIB_IP_ROUTE_TBL, (unsigned char*)&entry) != 1){
			websWrite(wp, T("%s"), "Error: Add chain record.");
			return;
		}

		route_cfg_modify(&entry, 0);
	}

setOk_route:
	/* upgdate to flash */
//	mib_update(CURRENT_SETTING);

#ifndef NO_ACTION
	pid = fork();
        if (pid)
                waitpid(pid, NULL, 0);
        else if (pid == 0) {
		snprintf(tmpBuf, 100, "%s/%s", _CONFIG_SCRIPT_PATH, _CONFIG_SCRIPT_PROG);
#ifdef HOME_GATEWAY
		execl( tmpBuf, _CONFIG_SCRIPT_PROG, "gw", "bridge", NULL);
#else
		execl( tmpBuf, _CONFIG_SCRIPT_PROG, "ap", "bridge", NULL);
#endif
                exit(1);
        }
#endif

	submitUrl = websGetVar(wp, T("submit-url"), T(""));
	if (submitUrl[0])
		websRedirect(wp, submitUrl);
	else
		websDone(wp, 200);
  	return;

setErr_route:
	ERR_MSG(tmpBuf);
}
#endif
void ShowDefaultGateway(int eid, webs_t wp, int argc, char_t **argv)
{
#ifdef DEFAULT_GATEWAY_V2
	websWrite(wp, T("<tr><hr size=1 noshade align=top></tr>\n"));
	websWrite(wp, T("<table border=0 width=600 cellspacing=4 cellpadding=0>\n"
					"	<tr>\n"
					"		<th align=left><font size=2><b>Default Gateway:</b></th>\n"
					"		<td><select name=\"droute\">\n"
					"			<option value=255>None</option>\n"));
	checkWrite(eid, wp, argc, argv);
#else
	websWrite(wp, T("<input type=\"hidden\"  name=\"droute\">\n"));
#endif
}

void ShowRouteInf(int eid, webs_t wp, int argc, char_t **argv)
{
#ifdef DEFAULT_GATEWAY_V2
	ifwanList(eid, wp, argc, argv);
	websWrite(wp, T("		</select></td>\n"
					"	</tr>\n"
					"</table>\n"
					"<input type=\"submit\" value=\"Apply Changes\" name=\"dgwSet\"><br><br>"));
#endif
}

void GetDefaultGateway(int eid, webs_t wp, int argc, char_t **argv)
{
#ifdef DEFAULT_GATEWAY_V2
	unsigned char dgw;
	mib_get( MIB_ADSL_WAN_DGW_ITF, (void *)&dgw);
	websWrite(wp, T("<script>\n"
					"	document.route.droute.value = %u;\n"
					"</script>"), dgw);
#endif
}
//add by chenzhuoxin
void formRip(webs_t wp, char_t *path, char_t *query)
{
	char_t *strVal = NULL;
	unsigned char ripEnble; // 1- ;  0- 
	typedef struct
	{
		unsigned char ifIndex __PACK__;		     //nop
		char ifname[32] __PACK__;			    //ӿ
		unsigned char version __PACK__;	   //汾
		unsigned char operation __PACK__;	   //: 1- Active;  0- Passive
		unsigned char enable __PACK__;		   //
	}rip_entry ;
	rip_entry ripEntry;                            //rip¼
	char temp[25];
	char *ptemp = NULL;
	int total, i;

	printf("enter formRip\n");
	//get ripEnble
	strVal = websGetVar(wp, T("gRipMode1"), T(""));
	if (0 == strcmp( strVal,"1"))
		ripEnble = 1;
	else
		ripEnble = 0;
	printf("wlEnbl=%d\n",ripEnble);
	if (!mib_set(MIB_RIP_ENABLE, (void *)&ripEnble)) {
		printf("set rip enable failed!\n");
		goto error;
	}

	//clear all mib entry
	if (!mib_chain_clear(MIB_RIP_TBL))
		printf("clear MIB_RIP_TBL failed!\n");
	
	//get ripEntry
	strVal = websGetVar(wp, T("lst"), T(""));
	printf("strVal=%s\n",strVal);

	while( ' ' != *strVal)
	{
		while('\0' != *strVal && ';' != *strVal)
		{
		 	//get ifindex
		 	ptemp = temp;
		 	while('|' != *strVal)
				*ptemp++ = *strVal++;
			if('|' == *strVal)
			{
				*ptemp = '\0';
				strVal++;
				/*
				* Add code by Realtek using temp
				*/
				ripEntry.ifIndex = atoi(temp);
				printf("ifindex = %d-- ",ripEntry.ifIndex);
			}

			//get ifname
			ptemp = temp;
			while('|' != *strVal)
				*ptemp++ = *strVal++;
			if('|' == *strVal)
			{
				*ptemp = '\0';
				strVal++;
				strcpy(ripEntry.ifname,temp);
				printf("ifiname = %s--",ripEntry.ifname);
			}

			//get version
			ptemp = temp;
			while('|' != *strVal)
				*ptemp++ = *strVal++;
			if('|' == *strVal)
			{
				*ptemp = '\0';
				strVal++;
				ripEntry.version = (unsigned int)atoi(temp);
				printf("version = %d--",ripEntry.version);
			}

			//get operation
			ptemp = temp;
			while('|' != *strVal)
				*ptemp++ = *strVal++;
			if('|' == *strVal)
			{
				*ptemp = '\0';
				strVal++;
				ripEntry.operation = (unsigned int)atoi(temp);
				printf("operation = %d--",ripEntry.operation);
			}

			//get enable
			ptemp = temp;
			while('|' != *strVal && ';' != *strVal && '\0' != *strVal)
				*ptemp++ = *strVal++;
			if('|' == *strVal)
			{
				*ptemp = '\0';
				strVal++;
				if (!strcmp(temp, "true"))
					ripEntry.enable = 1;
				else
					ripEntry.enable = 0;

				printf("enable = %d",ripEntry.enable);
			}
		}
		
		if (mib_chain_add(MIB_RIP_TBL, (void *)&ripEntry) != 1) {
			printf("add MIB_RIP_TBL error!\n");
			goto error;
		}
		
		if('\0' == *strVal)           //the end
			break;
		if(';' == *strVal)            //the next recode
		{
			strVal++;
			printf("\n");
			printf("the next record\n");
		}
	}

	//write to flash
	mib_update(CURRENT_SETTING, CONFIG_MIB_ALL);
	//take effect
	startRip();
	
error:
	REDIRECTSUBMITURL;
	return;
}
//add by chenhzuoxin
int showRipIf(int eid, webs_t wp, int argc, char_t **argv)
{
	char_t *strVal = NULL;
	unsigned char ripEnble = 1; // 1- ;  0- 
	typedef struct
	{
		unsigned char ifIndex __PACK__;		     //nop
		char ifname[32] __PACK__;			    //ӿ
		unsigned char version __PACK__;	   //汾
		unsigned char operation __PACK__;	   //: 1- Active;  0- Passive
		unsigned char enable __PACK__;		   //
	}rip_entry ;
	rip_entry ripEntry; //rip¼
	MIB_CE_ATM_VC_T mibEntry;
	int totalPvc, totalRip;
	int i, j;
	char wanName[40];
	char pTemp[20];

	if ( !mib_get( MIB_RIP_ENABLE, (void *)&ripEnble) ) {
		printf("get RIP state failed!\n");
		return -1;
	}

	//return ripEnble
	websWrite(wp, "ripEnble = \"%s\";\n", ripEnble ? "1" : "0");

	//add br0
	totalRip = mib_chain_total(MIB_RIP_TBL);
	for (j=0; j<totalRip; j++) {
		if (!mib_chain_get(MIB_RIP_TBL, j, (void *)&ripEntry)) {
			websError(wp, 400, T("Get MIB_RIP_TBL chain record error!\n"));
			return;
		}
		if (ripEntry.ifIndex == 0xff)
			break;
	}
	if (j >= totalRip) {
		websWrite(wp, "riplist.push(new it_devrec(%d, \"%s\", \"%s\", %d, %d, %d));\n",
			0xff, "br0", "(LAN)", 1, 1, 0);
	} else
		websWrite(wp, "riplist.push(new it_devrec(%d, \"%s\", \"%s\", %d, %d, %d));\n",
			0xff, "br0", "(LAN)", ripEntry.version, ripEntry.operation, ripEntry.enable);

	//add wan interface
	totalPvc = mib_chain_total(MIB_ATM_VC_TBL);
	for (i=0; i<totalPvc; i++) {
		if (!mib_chain_get(MIB_ATM_VC_TBL, i, (void *)&mibEntry)) {
			websError(wp, 400, T("Get MIB_ATM_VC_TBL chain record error!\n"));
			return;
		}

		if (mibEntry.cmode == ADSL_BR1483)
			continue;
		
		for (j=0; j<totalRip; j++) {
			if (!mib_chain_get(MIB_RIP_TBL, j, (void *)&ripEntry)) {
				websError(wp, 400, T("Get MIB_RIP_TBL chain record error!\n"));
				return;
			}
			if (ripEntry.ifIndex == mibEntry.ifIndex)
				break;
		}

		snprintf(pTemp, 20, "0/%d/%d", mibEntry.vpi, mibEntry.vci);

		if (j >= totalRip) {//didn't find, so rip is disabled
			getRipItfName(&mibEntry, wanName);
			websWrite(wp, "riplist.push(new it_devrec(%d, \"%s\", \"%s\", %d, %d, %d));\n", 
	  	         mibEntry.ifIndex, wanName, pTemp, 1, 1, 0);
		} else
			websWrite(wp, "riplist.push(new it_devrec(%d, \"%s\", \"%s\", %d, %d, %d));\n", 
	  	         ripEntry.ifIndex, ripEntry.ifname, pTemp, ripEntry.version, ripEntry.operation, ripEntry.enable);
	}
}
#ifdef CONFIG_USER_ROUTED_ROUTED
#if 0
void formRip(webs_t wp, char_t *path, char_t *query)
{
	char_t	*str, *submitUrl;
	char tmpBuf[100];
	unsigned char rip_if;
	unsigned int entryNum, i;
	MIB_CE_RIP_T Entry;
#ifndef NO_ACTION
	int pid;
#endif

	// RIP Add
	str = websGetVar(wp, T("ripAdd"), T(""));
	if (str[0]) {
		memset(&Entry, '\0', sizeof(MIB_CE_RIP_T));
		
		str = websGetVar(wp, T("rip_if"), T(""));
		rip_if = (unsigned char)atoi(str);
		Entry.ifIndex = rip_if;
		
		str = websGetVar(wp, T("receive_mode"), T(""));
		if ( str[0]=='0' ) {		
			Entry.receiveMode = RIP_NONE;    // None
		} else if ( str[0]=='1') {		
			Entry.receiveMode = RIP_V1;      // RIPV1
		} else if ( str[0]=='2') {		
			Entry.receiveMode = RIP_V2;      // RIPV2
		} else if ( str[0]=='3') {		
			Entry.receiveMode = RIP_V1_V2;   // RIPV1 and RIPV2
		} else {
			strcpy(tmpBuf, T("Set RIP receive mode error!"));
			goto setErr_rip;		
		}
		
		str = websGetVar(wp, T("send_mode"), T(""));
		if ( str[0]=='0' ) {		
			Entry.sendMode = RIP_NONE;    		// None
		} else if ( str[0]=='1') {		
			Entry.sendMode = RIP_V1;      		// RIPV1
		} else if ( str[0]=='2') {		
			Entry.sendMode = RIP_V2;      		// RIPV2
		} else if ( str[0]=='4') {		
			Entry.sendMode = RIP_V1_COMPAT;      	// RIPV1COMPAT
		} else {
			strcpy(tmpBuf, T("Set RIP send mode error!"));
			goto setErr_rip;		
		}
		
		if(mib_chain_add(MIB_RIP_TBL, (unsigned char*)&Entry) != 1){
			websWrite(wp, T("%s"), "Error: Add MIB_RIP_TBL chain record.");
			return;
		}
		goto setRefresh_rip;
	}
	
	// Delete
	str = websGetVar(wp, T("ripDel"), T(""));
	if (str[0]) {
		unsigned int i;
		unsigned int idx;
		MIB_CE_RIP_T Entry;
		unsigned int totalEntry = mib_chain_total(MIB_RIP_TBL); /* get chain record size */		
		
		str = websGetVar(wp, T("select"), T(""));		
		
		if (str[0]) {
			for (i=0; i<totalEntry; i++) {
				idx = totalEntry-i-1;			
				snprintf(tmpBuf, 4, "s%d", idx);
				
				if ( !gstrcmp(str, T(tmpBuf)) ) {					
					
					// delete from chain record
					if(mib_chain_delete(MIB_RIP_TBL, idx) != 1) {
						strcpy(tmpBuf, T("Delete MIB_RIP_TBL chain record error!"));
						goto setErr_rip;
					}					
				}
			} // end of for
		}		
		goto setRefresh_rip;
	}
	
	// RIP setting
	str = websGetVar(wp, T("ripSet"), T(""));
	if (str[0]) {
		unsigned char ripVal;
		
		str = websGetVar(wp, T("rip_on"), T(""));
		if (str[0] == '1')
			ripVal = 1;
		else
			ripVal = 0;	// default "off"
		if (!mib_set(MIB_RIP_ENABLE, (void *)&ripVal)) {
			strcpy(tmpBuf, T("Set RIP error!"));
			goto setErr_rip;
		}
		
		// Commented by Mason Yu
		/*
		str = websGetVar(wp, T("rip_ver"), T(""));
		if (str[0] == '0')
			ripVal = 0;
		else
			ripVal = 1;	// default "v2"
		if (!mib_set(MIB_RIP_VERSION, (void *)&ripVal)) {
			strcpy(tmpBuf, T("Set RIP error!"));
			goto setErr_rip;
		}
		*/
	}

setOk_rip:
	startRip();
	/* upgdate to flash */
//	mib_update(CURRENT_SETTING);

#ifndef NO_ACTION
	pid = fork();
        if (pid)
                waitpid(pid, NULL, 0);
        else if (pid == 0) {
		snprintf(tmpBuf, 100, "%s/%s", _CONFIG_SCRIPT_PATH, _CONFIG_SCRIPT_PROG);
#ifdef HOME_GATEWAY
		execl( tmpBuf, _CONFIG_SCRIPT_PROG, "gw", "bridge", NULL);
#else
		execl( tmpBuf, _CONFIG_SCRIPT_PROG, "ap", "bridge", NULL);
#endif
                exit(1);
        }
#endif

	submitUrl = websGetVar(wp, T("submit-url"), T(""));
	OK_MSG(submitUrl);
	return;

setRefresh_rip:
	startRip();
	submitUrl = websGetVar(wp, T("submit-url"), T(""));
	if (submitUrl[0])
		websRedirect(wp, submitUrl);
	else
		websDone(wp, 200);
	return;
	
setErr_rip:
	ERR_MSG(tmpBuf);
}
#endif
// List all the rip interface at web page.
// return: number of rip interface listed.
#if 0
int showRipIf(int eid, webs_t wp, int argc, char_t **argv)
{
	int nBytesSent=0;	
	unsigned int entryNum, i;
	MIB_CE_RIP_T Entry;
	char ifname[6], receive_mode[5], send_mode[5];	
	
	entryNum = mib_chain_total(MIB_RIP_TBL);
#if defined(ZTE_531B_BRIDGE_SC)||defined(ZTE_GENERAL_ROUTER_SC)
	nBytesSent += websWrite(wp, T("<tr><font size=1>"
	"<td align=center width=\"5%%\" bgcolor=\"#808080\">%s</td>\n"
	"<td align=center width=\"20%%\" bgcolor=\"#808080\">%s</td>"
	"<td align=center width=\"20%%\" bgcolor=\"#808080\">%s</td>"
	"<td align=center width=\"20%%\" bgcolor=\"#808080\">%s</td></font></tr>\n"),
	Tselect,Trip_interface,Trip_receive_mode,Trip_send_mode);
#else
	nBytesSent += websWrite(wp, T("<tr><font size=1>"
	"<td align=center width=\"5%%\" bgcolor=\"#808080\">%s</td>\n"
	"<td align=center width=\"20%%\" bgcolor=\"#808080\">%s</td>"
	"<td align=center width=\"20%%\" bgcolor=\"#808080\">%s</td>"
	"<td align=center width=\"20%%\" bgcolor=\"#808080\">%s</td></font></tr>\n"),
	Tselect,Trip_interface,Trip_receive_mode,Trip_send_mode);
 #endif

	for (i=0; i<entryNum; i++) {

		if (!mib_chain_get(MIB_RIP_TBL, i, (void *)&Entry))
		{
  			websError(wp, 400, T("Get MIB_RIP_TBL chain record error!\n"));
			return;
		}		
		
		if( Entry.ifIndex == 0xff) {
			strncpy(ifname, "br0", strlen("br0"));
			ifname[strlen("br0")] = '\0';
		} else {	
			if (PPP_INDEX(Entry.ifIndex) != 0x0f)
			{	// PPP interface
				snprintf(ifname, 6, "ppp%u", PPP_INDEX(Entry.ifIndex));
			}
			else
			{	// vc interface
				snprintf(ifname, 6, "vc%u", VC_INDEX(Entry.ifIndex));
			}
		}
		
		if ( Entry.receiveMode == RIP_NONE ) {
			strncpy(receive_mode, "None", strlen("None"));
			receive_mode[strlen("None")] = '\0';
		} else if ( Entry.receiveMode == RIP_V1 ) {
			strncpy(receive_mode, "RIP1", strlen("RIP1"));
			receive_mode[strlen("RIP1")] = '\0';
		} else if ( Entry.receiveMode == RIP_V2 ) {
			strncpy(receive_mode, "RIP2", strlen("RIP2"));
			receive_mode[strlen("RIP2")] = '\0';
		} else if ( Entry.receiveMode == RIP_V1_V2 ) {
			strncpy(receive_mode, "Both", strlen("Both"));
			receive_mode[strlen("Both")] = '\0';
		} else {
			websError(wp, 400, T("Get RIP Receive Mode error!\n"));
			return;
		}	
		
		if ( Entry.sendMode == RIP_NONE ) {
			strncpy(send_mode, "None", strlen("None"));
			send_mode[strlen("None")] = '\0';
		} else if ( Entry.sendMode == RIP_V1 ) {
			strncpy(send_mode, "RIP1", strlen("RIP1"));
			send_mode[strlen("RIP1")] = '\0';
		} else if ( Entry.sendMode == RIP_V2 ) {
			strncpy(send_mode, "RIP2", strlen("RIP2"));
			send_mode[strlen("RIP2")] = '\0';
		} else if ( Entry.sendMode == RIP_V1_COMPAT ) {
			strncpy(send_mode, "RIP1COMPAT", strlen("RIP1COMPAT"));
			send_mode[strlen("RIP1COMPAT")] = '\0';
		} else {
			websError(wp, 400, T("Get RIP Send Mode error!\n"));
			return;
		}
		
		nBytesSent += websWrite(wp, T("<tr>"
		"<td align=center width=\"5%%\" bgcolor=\"#C0C0C0\"><input type=\"radio\" name=\"select\""
		" value=\"s%d\""		
		"></td>\n"
		"<td align=center width=\"20%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%s</b></font></td>"
		"<td align=center width=\"20%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%s</b></font></td>"
		"<td align=center width=\"20%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%s</b></font></td>"
		"</tr>\n"),
		i, 		
		ifname, receive_mode, send_mode);
	}
	return 0;
}
#endif
int ifRipNum()
{	
	int ifnum=0;
	
	unsigned int entryNum, i;
	MIB_CE_ATM_VC_T Entry;	
	char_t  buffer[3];
		

	// check LAN
	if (mib_get(MIB_ADSL_LAN_RIP, (void *)buffer) != 0) {
		if (buffer[0] == 1) {			
			ifnum++;
		}
	}
	
	// check WAN
	entryNum = mib_chain_total(MIB_ATM_VC_TBL);
	for (i=0; i<entryNum; i++) {

		if (!mib_chain_get(MIB_ATM_VC_TBL, i, (void *)&Entry))
		{  			
			return -1;
		}
		
		if (Entry.enable == 0)
			continue;
		
		if (Entry.cmode != ADSL_BR1483 && Entry.rip)
		{			
			ifnum++;
		}
	}
	
	return ifnum;
}
#endif	// of CONFIG_USER_ROUTED_ROUTED
//add by chenzhuoxin
int showStaticRoute(int eid, webs_t wp, int argc, char_t **argv)
{
        char_t *strVal = NULL;
        typedef struct  
	{
	       unsigned char ifIndex __PACK__;		//ʹýӿʱ,Ϊ0
	       char ifname[32] __PACK__;			//ӿ
	       unsigned int gw __PACK__;			//IPַ
	       unsigned int dip __PACK__;			//Ŀַ
	       unsigned int dmask __PACK__;		//
      }route_entry;
	short maxSrRouteEntry = 32;
//	  route_entry routeEntry = {200,"ppp_0_0_35_3", 0x0b0b0b0b, 0x0b0b0b0b, 0xffffff00};                            //rip¼
      /*
	 *Add code by Realtek
	 */
	unsigned int entryNum, i;
	MIB_CE_IP_ROUTE_T Entry;
	char interface_name[30];
	MIB_CE_ATM_VC_T vcEntry;
	int j;
	int mibTotal;

	mibTotal = mib_chain_total(MIB_ATM_VC_TBL);
	entryNum = mib_chain_total(MIB_IP_ROUTE_TBL);

	//return MAX_StRoute_ENTRY 
	websWrite(wp, "MAX_StRoute_ENTRY = %d;\n",maxSrRouteEntry) ;

	for (i=0; i<entryNum; i++) {

		char destNet[16], subMask[16], nextHop[16];

		if (!mib_chain_get(MIB_IP_ROUTE_TBL, i, (void *)&Entry))
		{
  			websError(wp, 400, T("Get chain record error!\n"));
			return;
		}
			
		if ( Entry.ifIndex == 0xff )
		{
			strcpy( interface_name, "---" );
		}
		for (j=0; j<mibTotal; j++) {
			if (!mib_chain_get(MIB_ATM_VC_TBL, j, (void *)&vcEntry)) {
				printf("get mib_atm_vc_tbl error!\n");
				return -1;
			}

			if (vcEntry.ifIndex == Entry.ifIndex) {
				//get name
				getWanName(&vcEntry, interface_name);
				break;
			}
		}

		strcpy(destNet, inet_ntoa(*((struct in_addr *)Entry.destID)) );
		strcpy(nextHop, inet_ntoa(*((struct in_addr *)Entry.nextHop)) );
		strcpy(subMask, inet_ntoa(*((struct in_addr *)Entry.netMask)) );

		websWrite(wp, "stRoutelst.push(new it_devrec(\"%s\", \"%s\", \"%s\", \"%s\"));\n", 
	  	           destNet,subMask,nextHop,interface_name);
	}
	
}
#if 0
int showStaticRoute(int eid, webs_t wp, int argc, char_t **argv)
{
	int nBytesSent=0;
	
	unsigned int entryNum, i;
	MIB_CE_IP_ROUTE_T Entry;
	unsigned long int d,g,m;
	struct in_addr dest;
	struct in_addr gw;
	struct in_addr mask;
	char sdest[16], sgw[16];
	char interface_name[16];
	
	
	entryNum = mib_chain_total(MIB_IP_ROUTE_TBL);
#ifdef ZTE_GENERAL_ROUTER_SC
nBytesSent += websWrite(wp, T("<tr><font size=1>"
	"<td align=center width=\"5%%\" bgcolor=\"#808080\">%s</td>\n"
	"<td align=center width=\"5%%\" bgcolor=\"#808080\">%s</td>\n"
	"<td align=center width=\"8%%\" bgcolor=\"#808080\">%s</td>\n"
	"<td align=center width=\"8%%\" bgcolor=\"#808080\">%s</td>\n"
	"<td align=center width=\"8%%\" bgcolor=\"#808080\">%s</td>\n"
	"<td align=center width=\"8%%\" bgcolor=\"#808080\">%s</td>\n"
	"<td align=center width=\"8%%\" bgcolor=\"#808080\">%s</td>\n"
	"</font></tr>\n"),Tselect,Troute_stat,Troute_dIP,Troute_mask,Troute_nexthop,Troute_metric,Troute_interface);
#else
	nBytesSent += websWrite(wp, T("<tr><font size=1>"
	"<td align=center width=\"5%%\" bgcolor=\"#808080\">%s</td>\n"
	"<td align=center width=\"5%%\" bgcolor=\"#808080\">%s</td>\n"
	"<td align=center width=\"8%%\" bgcolor=\"#808080\">%s</td>\n"
	"<td align=center width=\"8%%\" bgcolor=\"#808080\">%s</td>\n"
	"<td align=center width=\"8%%\" bgcolor=\"#808080\">%s</td>\n"
	"<td align=center width=\"8%%\" bgcolor=\"#808080\">%s</td>\n"
	"<td align=center width=\"8%%\" bgcolor=\"#808080\">%s</td>\n"
	"</font></tr>\n"),Tselect,Troute_stat,Troute_dIP,Troute_mask,Troute_nexthop,Troute_metric,Troute_interface);
#endif

	for (i=0; i<entryNum; i++) {

		char destNet[16], subMask[16], nextHop[16];

		if (!mib_chain_get(MIB_IP_ROUTE_TBL, i, (void *)&Entry))
		{
  			websError(wp, 400, T("Get chain record error!\n"));
			return;
		}
			
		dest.s_addr = *(unsigned long *)Entry.destID;
		gw.s_addr   = *(unsigned long *)Entry.nextHop;
		mask.s_addr = *(unsigned long *)Entry.netMask;
		// inet_ntoa is not reentrant, we have to
		// copy the static memory before reuse it
		strcpy(sdest, inet_ntoa(dest));
		strcpy(sgw, inet_ntoa(gw));

		if ( Entry.ifIndex == 0xff )
		{
			strcpy( interface_name, "---" );
		}else if(  (Entry.ifIndex & 0xf0)==0xf0  )
		{
			sprintf( interface_name, "vc%u", VC_INDEX(Entry.ifIndex) );
		}else{
			sprintf( interface_name, "ppp%u", PPP_INDEX(Entry.ifIndex) );
		}

		strcpy(destNet, inet_ntoa(*((struct in_addr *)Entry.destID)) );
		strcpy(nextHop, inet_ntoa(*((struct in_addr *)Entry.nextHop)) );
		strcpy(subMask, inet_ntoa(*((struct in_addr *)Entry.netMask)) );
		
	
		nBytesSent += websWrite(wp, T("<tr>"
		"<td align=center width=\"5%%\" bgcolor=\"#C0C0C0\"><input type=\"radio\" name=\"select\""
		" value=\"s%d\" "
		"onClick=\"postGW(%d,  '%s','%s','%s',%d,%d,'select%d' )\""

		"></td>\n"
		"<td align=center width=\"8%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%s</b></font></td>\n"
		"<td align=center width=\"8%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%s</b></font></td>\n"
		"<td align=center width=\"8%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%s</b></font></td>\n"
		"<td align=center width=\"8%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%s</b></font></td>"
		"<td align=center width=\"8%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%d</b></font></td>"
		"<td align=center width=\"8%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%s</b></font></td>"
		"</tr>\n"),
		i, 
		Entry.Enable, destNet, subMask, nextHop, Entry.FWMetric, Entry.ifIndex, i, 
		Entry.Enable ? "Enable" : "Disable", sdest, inet_ntoa(mask), sgw, Entry.FWMetric, interface_name);
	}
	
	return 0;
}
#endif
#ifndef RTF_UP
/* Keep this in sync with /usr/src/linux/include/linux/route.h */
#define RTF_UP          0x0001	/* route usable                 */
#define RTF_GATEWAY     0x0002	/* destination is a gateway     */
#define RTF_HOST        0x0004	/* host entry (net otherwise)   */
#define RTF_REINSTATE   0x0008	/* reinstate route after tmout  */
#define RTF_DYNAMIC     0x0010	/* created dyn. (by redirect)   */
#define RTF_MODIFIED    0x0020	/* modified dyn. (by redirect)  */
#define RTF_MTU         0x0040	/* specific MTU for this route  */
#ifndef RTF_MSS
#define RTF_MSS         RTF_MTU	/* Compatibility :-(            */
#endif
#define RTF_WINDOW      0x0080	/* per route window clamping    */
#define RTF_IRTT        0x0100	/* Initial round trip time      */
#define RTF_REJECT      0x0200	/* Reject route                 */
#endif

int routeList(int eid, webs_t wp, int argc, char_t **argv)
{
	int nBytesSent=0;
	char buff[256];
	int flgs, metric;
	unsigned long int d,g,m;
	struct in_addr dest;
	struct in_addr gw;
	struct in_addr mask;
	char sdest[16], sgw[16], iface[6];
	FILE *fp;
	
	if (!(fp=fopen("/proc/net/route", "r"))) {
		fclose(fp);
		printf("Error: cannot open /proc/net/route - continuing...\n");
		websWrite(wp, T("%s"), "Error: cannot open /proc/net/route !!");
		return -1;
	}
	
	nBytesSent += websWrite(wp, T("<tr><font size=1>"
	"<td align=center width=\"8%%\" bgcolor=\"#808080\">%s</td>\n"
	"<td align=center width=\"8%%\" bgcolor=\"#808080\">%s</td>\n"
	"<td align=center width=\"8%%\" bgcolor=\"#808080\">%s</td>\n"
	"<td align=center width=\"8%%\" bgcolor=\"#808080\">%s</td>\n"
	"<td align=center width=\"8%%\" bgcolor=\"#808080\">%s</td></font></tr>\n"),
	Troute_dIP,Troute_mask,Troute_nexthop,Troute_metric,Troute_interface);

	fgets(buff, sizeof(buff), fp);
	
	while( fgets(buff, sizeof(buff), fp) != NULL ) {
		if(sscanf(buff, "%s%lx%lx%X%*d%*d%d%lx",
		   iface, &d, &g, &flgs, &metric, &m)!=6) {
			printf("Unsuported kernel route format\n");
			websWrite(wp, T("%s"), "Error: Unsuported kernel route format !!");
			return -1;
		}
		
		if(flgs & RTF_UP) {
			dest.s_addr = d;
			gw.s_addr   = g;
			mask.s_addr = m;
			// inet_ntoa is not reentrant, we have to
			// copy the static memory before reuse it
			strcpy(sdest, inet_ntoa(dest));
			strcpy(sgw,  (gw.s_addr==0   ? "*" : inet_ntoa(gw)));
		
			nBytesSent += websWrite(wp, T("<tr>"
			"<td align=center width=\"8%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%s</b></font></td>\n"
			"<td align=center width=\"8%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%s</b></font></td>\n"
			"<td align=center width=\"8%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%s</b></font></td>\n"
			"<td align=center width=\"8%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%d</b></font></td>\n"
			"<td align=center width=\"8%%\" bgcolor=\"#C0C0C0\"><font size=\"2\"><b>%s</b></font></td></tr>\n"),
			sdest, inet_ntoa(mask), sgw, metric, iface);
		}
	}
	
	fclose(fp);
	return 0;
}

/////////////////////////////////////////////////////////////////////////////
void formRefleshRouteTbl(webs_t wp, char_t *path, char_t *query)
{
	char_t *submitUrl;

	submitUrl = websGetVar(wp, T("submit-url"), T(""));
	if (submitUrl[0])
		websRedirect(wp, submitUrl);
}
