/*
 *      Web server handler routines for Status
 *      Authors: 
 *
 */

/*-- System inlcude files --*/
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <sys/wait.h>
#include <semaphore.h>
#ifdef EMBED
#include <linux/config.h>
#else
#include "autoconf.h"
#endif

/* for ioctl */

#include "../webs.h"
#include "webform.h"
#include "mib.h"
#include "utility.h"
#include "debug.h"
#include <sys/ioctl.h>
#include <net/if.h>
#include <linux/if_bridge.h>
#include "adsl_drv.h"
#include <stdio.h>
#include <fcntl.h>
#include "signal.h"
#include "../defs.h"
#include "../boa.h"
#include "fmdefs.h"

static const char IF_UP[] = "up";
static const char IF_DOWN[] = "down";
static const char IF_NA[] = "n/a";
#ifdef EMBED
static const char PROC_NET_ATM_BR[] = "/proc/net/atm/br2684";
static const char PPPOE_CONF[] = "/var/ppp/pppoe.conf";
static const char PPPOA_CONF[] = "/var/ppp/pppoa.conf";
static const char PPP_PID[] = "/var/run/spppd.pid";
#ifdef CTC_WAN_NAME
static const char PPP_CONF[] = "/var/ppp/ppp.conf";
#endif
#endif

#define __PME(entry,name)		#name, entry.name



#if 1 
int listWanConfig(int eid, webs_t wp, int argc, char_t ** argv)
{
	int nBytesSent=0;

	unsigned int data, data2;
	char	buff[256], tmp1[20], tmp2[20], tmp3[20], tmp4[20];
	char	*temp;
	int in_turn=0, vccount=0, ifcount=0, isPPP=0, pppConnectStatus=0, adslflag=0;
	int i, ifindices[256], br_socket_fd, spid;
	unsigned long arg[4];
	struct ifreq ifr;
	FILE *fp;
	struct flock flpoe, flpoa;
	int fdpoe, fdpoa;
	Modem_LinkSpeed vLs;
      int entryNum;
	entryNum = mib_chain_total(MIB_ATM_VC_TBL);
	
	struct status_info {
		char ifname[IFNAMSIZ];
		char devname[IFNAMSIZ];
		char encaps[8];
		char protocol[10];
		char ipAddr[20];
		char remoteIp[20];
		char *strStatus;
		char uptime[20];
		char totaluptime[20];
		char igmpEnbl;
		char qosEnbl;
		char servType[20];
		char servName[30];
		unsigned short vlanId;
		unsigned int tvpi;
		unsigned int tvci;

	};
	struct status_info sEntry[MAX_VC_NUM+MAX_PPP_NUM]={0};
	struct status_info vcEntry[MAX_VC_NUM]={0};

#ifdef EMBED
	// get spppd pid
	if ((fp = fopen(PPP_PID, "r"))) {
		fscanf(fp, "%d\n", &spid);
		fclose(fp);
	}
	else
		printf("spppd pidfile not exists\n");
	
	kill(spid, SIGUSR2);
#endif

	in_turn = 0;

       

	// check for xDSL link
	if (!adsl_drv_get(RLCM_GET_LINK_SPEED, (void *)&vLs, RLCM_GET_LINK_SPEED_SIZE) || vLs.upstreamRate == 0)
		adslflag = 0;
	else
		adslflag = 1;
	

//	for (i=0; i<ifcount; i++) {
       for(i=0;i<entryNum;i++){
		struct in_addr inAddr;
		int flags;
		pppConnectStatus = 0;
		isPPP=0;
             MIB_CE_ATM_VC_T entry;
		char vpistr[6];
		char vcistr[6];
		char username[MAX_NAME_LEN];
		char password[MAX_NAME_LEN];
		char interfacename[MAX_NAME_LEN];	
	       char ifname[6];
		char applicationname[30];
#ifdef _CWMP_MIB_ 
		char setname[30];
		memset(setname, 0, 30);
#endif
            char strNapt[10];

           if (!mib_chain_get(MIB_ATM_VC_TBL, i, (void *)&entry))
	    {
					printf("get MIB chain error\n");
					return -1;
	     }
            if(entry.cmode == ADSL_PPPoE || entry.cmode == ADSL_PPPoA)//star:for multi-ppp name
	     {
					snprintf(ifname, 6, "ppp%u", PPP_INDEX(entry.ifIndex));
                                 
	      }
		else
				snprintf(ifname, 6, "vc%u", VC_INDEX(entry.ifIndex)); 
		
	      strcpy(sEntry[i].ifname,ifname);
	      sEntry[i].tvci = entry.vci;
	      sEntry[i].tvpi = entry.vpi;
		  
	      switch(entry.cmode) {
					case ADSL_MER1483:
						memset(sEntry[i].protocol, 0, 10);
						strcpy(sEntry[i].protocol, "mer1483");
						break;
					case ADSL_PPPoE://patch for pppoe proxy
						strcpy(sEntry[i].protocol, "PPPoE");
						break;
					case ADSL_BR1483 :
						strcpy(sEntry[i].protocol, "br1483");
						break;
					case ADSL_PPPoA:
						 strcpy(sEntry[i].protocol, "PPPoA");
						break;
					default:
						break;
              }	
		  
 
#ifdef EMBED
		if (getInAddr( sEntry[i].ifname, IP_ADDR, (void *)&inAddr) == 1)
		{
			temp = inet_ntoa(inAddr);
			if (getInFlags( sEntry[i].ifname, &flags) == 1)
				if ((strcmp(temp, "10.0.0.1") == 0) && flags & IFF_POINTOPOINT)	// IP Passthrough or IP unnumbered
					strcpy(sEntry[i].ipAddr, STR_UNNUMBERED);
				else
					strcpy(sEntry[i].ipAddr, temp);
		}
		else
#endif
			strcpy(sEntry[i].ipAddr, "");
	
#ifdef EMBED
		if (getInAddr( sEntry[i].ifname, DST_IP_ADDR, (void *)&inAddr) == 1)
		{
			temp = inet_ntoa(inAddr);
			if (strcmp(temp, "10.0.0.2") == 0)
				strcpy(sEntry[i].remoteIp, STR_UNNUMBERED);
			else
				strcpy(sEntry[i].remoteIp, temp);
			if (getInFlags( sEntry[i].ifname, &flags) == 1)
				if (flags & IFF_BROADCAST) {
					unsigned char value[32];
					snprintf(value, 32, "%s.%s", (char *)MER_GWINFO, sEntry[i].ifname);
					if (fp = fopen(value, "r")) {
						fscanf(fp, "%s\n", sEntry[i].remoteIp);
						strcpy(sEntry[i].protocol, "mer1483");
						fclose(fp);
					}
					else
						strcpy(sEntry[i].remoteIp, "");
				}
		}
		else
#endif
			strcpy(sEntry[i].remoteIp, "");

							
		// set status flag
		if (getInFlags( sEntry[i].ifname, &flags) == 1)
		{
			if (flags & IFF_UP) {
				if (!adslflag)
					sEntry[i].strStatus = (char *)IF_DOWN;
				else {
					if (strcmp(sEntry[i].protocol, "br1483") == 0)
						sEntry[i].strStatus = (char *)IF_UP;
					else
						if (getInAddr( sEntry[i].ifname, IP_ADDR, (void *)&inAddr) == 1)
							sEntry[i].strStatus = (char *)IF_UP;
						else
							sEntry[i].strStatus = (char *)IF_DOWN;
				}
			}
			else
				sEntry[i].strStatus = (char *)IF_DOWN;
		}
		else
			sEntry[i].strStatus = (char *)IF_NA;
		
		if (strcmp(sEntry[i].protocol, "PPPoE")==0 || strcmp(sEntry[i].protocol, "PPPoA")==0)
			isPPP = 1;
		else
			isPPP = 0;
		if (isPPP){
			if (strcmp(sEntry[i].strStatus, (char *)IF_UP) == 0)
				pppConnectStatus = 1;
			else {
				pppConnectStatus = 0;
				sEntry[i].ipAddr[0] = '\0';
				sEntry[i].remoteIp[0] = '\0';
			}
		}
		memset(applicationname, 0, sizeof(applicationname));
		memset(vpistr, 0, sizeof(vpistr));
		memset(vcistr, 0, sizeof(vcistr));		
		memset(interfacename, 0, sizeof(interfacename));
		sprintf(vpistr, "%d", sEntry[i].tvpi);
		sprintf(vcistr, "%d", sEntry[i].tvci);
		#ifdef _CWMP_MIB_ 
					if(*(entry.WanName))
						strcpy(setname, entry.WanName);
		#endif
                                 getWanName(&entry, applicationname);
                                strcpy(sEntry[i].servName,applicationname);
								
					#ifdef CONFIG_EXT_SWITCH
					sEntry[i].vlanId = entry.vid;
					#endif
					
					#ifdef  CONFIG_IGMPPROXY_MULTIWAN
					sEntry[i].igmpEnbl = entry.igmpproxyenable;
					#endif
					
					sEntry[i].qosEnbl = entry.qosenable;
					
					if(entry.qos == 0){
						if(entry.svtype == 0){
							strcpy(sEntry[i].servType,"UBR Without PCR");
						}else{
							strcpy(sEntry[i].servType,"UBR With PCR");
						}
					}else if(entry.qos == 1){
						strcpy(sEntry[i].servType,"CBR");
					}else if(entry.qos == 2){
						strcpy(sEntry[i].servType,"Non Realtime VBR");
					}else if(entry.qos == 3){
						strcpy(sEntry[i].servType,"Realtime VBR");
					}

					if(entry.encap == 1)
					{
						strcpy(sEntry[i].encaps,"LLC");
					}else{
						strcpy(sEntry[i].encaps,"VCMUX");
					}
#if 0
#ifdef EMBED
		//jim determine china telecom's auto-generated WAN name...
		{
			

		#ifdef _CWMP_MIB_ 
		if(*setname)
			strcpy(applicationname, setname);
		#endif
	#ifdef _CWMP_MIB_ 
		if(*(entry.WanName))
			strcpy(applicationname, entry.WanName);
	#endif
	   //    printf("get wan Name ----%s\n",applicationname);
		getWanName(&entry, applicationname);
	#endif //EMBED
		
		

		}
#endif
		//found in mit 
	

		websWrite(wp, T("links.push(new it_nr(\"%d\"" _PTS  _PTS _PTS _PTS _PTS \
			_PTI  _PTI _PTI  _PTS "));\n"), 
			i, __PME(sEntry[i],servName),  __PME(sEntry[i],encaps), __PME(sEntry[i],servType), __PME(sEntry[i],protocol), __PME(sEntry[i],ipAddr), 
			__PME(sEntry[i],vlanId), __PME(sEntry[i],igmpEnbl), __PME(sEntry[i],qosEnbl),  __PME(sEntry[i],strStatus)
			);
	}

//	_TRACE_LEAVEL;
	return 0;

}

#else
/*****************************
** wan if list
*/
int listWanConfig(int eid, webs_t wp, int argc, char_t ** argv)
{
	int nBytesSent=0;

	unsigned int data, data2;
	char	buff[256], tmp1[20], tmp2[20], tmp3[20], tmp4[20];
	char	*temp;
	int in_turn=0, vccount=0, ifcount=0, isPPP=0, pppConnectStatus=0, adslflag=0;
	int i, ifindices[256], br_socket_fd, spid;
	unsigned long arg[4];
	struct ifreq ifr;
	FILE *fp;
	struct flock flpoe, flpoa;
	int fdpoe, fdpoa;
	Modem_LinkSpeed vLs;

	struct status_info {
		char ifname[IFNAMSIZ];
		char devname[IFNAMSIZ];
		char encaps[8];
		char protocol[10];
		char ipAddr[20];
		char remoteIp[20];
		char *strStatus;
		char uptime[20];
		char totaluptime[20];
		char igmpEnbl;
		char qosEnbl;
		char servType[20];
		char servName[30];
		unsigned short vlanId;
		unsigned int tvpi;
		unsigned int tvci;

	};
	struct status_info sEntry[MAX_VC_NUM+MAX_PPP_NUM]={0};
	struct status_info vcEntry[MAX_VC_NUM]={0};

#ifdef EMBED
	// get spppd pid
	if ((fp = fopen(PPP_PID, "r"))) {
		fscanf(fp, "%d\n", &spid);
		fclose(fp);
	}
	else
		printf("spppd pidfile not exists\n");
	
	kill(spid, SIGUSR2);
#endif

	in_turn = 0;
#ifdef EMBED
	if (!(fp=fopen(PROC_NET_ATM_BR, "r")))
		printf("%s not exists.\n", PROC_NET_ATM_BR);
	else {
		while ( fgets(buff, sizeof(buff), fp) != NULL ) {
			if (in_turn==0)
				if(sscanf(buff, "%*s%s", tmp1)!=1) {
					printf("Unsuported pvc configuration format\n");
					break;
				}
				else {
					vccount ++;
					tmp1[strlen(tmp1)-1]='\0';
					strcpy(vcEntry[vccount-1].ifname, tmp1);
					strcpy(vcEntry[vccount-1].devname, tmp1);
				}
			else
				if(sscanf(buff, "%*s%s%*s%s", tmp1, tmp2)!=2) {
					printf("Unsuported pvc configuration format\n");
					break;
				}
				else {
					sscanf(tmp1, "0.%u.%u:", &vcEntry[vccount-1].tvpi, &vcEntry[vccount-1].tvci);
					sscanf(tmp2, "%u,", &data);
					strcpy(vcEntry[vccount-1].protocol, "");
				//	if (data==1 || data == 4)
				//		strcpy(vcEntry[vccount-1].encaps, "LLC");
				//	else if (data==0 || data==3)
				//		strcpy(vcEntry[vccount-1].encaps, "VCMUX");
					if (data==3 || data==4)
						strcpy(vcEntry[vccount-1].protocol, "rt1483");
				}
			in_turn ^= 0x01;
		}
		fclose(fp);
	}

	// file locking
	fdpoe = open(PPPOE_CONF, O_RDWR);
	fdpoa = open(PPPOA_CONF, O_RDWR);
	if ((fdpoe != -1) && (fdpoa != -1)) {
		flpoe.l_type = flpoa.l_type = F_RDLCK;
		flpoe.l_whence = flpoa.l_whence = SEEK_SET;
		flpoe.l_start = flpoa.l_start = 0;
		flpoe.l_len = flpoa.l_len = 0;
		flpoe.l_pid = flpoa.l_pid = getpid();
		if (fcntl(fdpoe, F_SETLKW, &flpoe) == -1)
			printf("pppoe read lock failed\n");
		if (fcntl(fdpoa, F_SETLKW, &flpoa) == -1)
			printf("pppoa read lock failed\n");
	}
	
	if (!(fp=fopen(PPPOA_CONF, "r")))
		printf("%s not exists.\n", PPPOA_CONF);
	else {
		fgets(buff, sizeof(buff), fp);
		while ( fgets(buff, sizeof(buff), fp) != NULL )
			if (sscanf(buff, "%s%u%u%*s%s%*s%*d%*d%*d%s%s", tmp1, &data, &data2, tmp2, tmp3, tmp4) != 6) {
				printf("Unsuported pppoa configuration format\n");
				break;
			}
			else {
				ifcount ++;
				strcpy(sEntry[ifcount-1].ifname, tmp1);
			//	strcpy(sEntry[ifcount-1].encaps, tmp2);
				strcpy(sEntry[ifcount-1].protocol, "PPPoA");
				sEntry[ifcount-1].tvpi = data;
				sEntry[ifcount-1].tvci = data2;
				strcpy(sEntry[ifcount-1].uptime, tmp3);
				strcpy(sEntry[ifcount-1].totaluptime, tmp4);
			}
		fclose(fp);
	}

	if (!(fp=fopen(PPPOE_CONF, "r")))
		printf("%s not exists.\n", PPPOE_CONF);
	else {
		fgets(buff, sizeof(buff), fp);
		while ( fgets(buff, sizeof(buff), fp) != NULL )
			if(sscanf(buff, "%s%s%*s%*s%*s%s%s", tmp1, tmp2, tmp3, tmp4) != 4) {
				printf("Unsuported pppoe configuration format\n");
				break;
			}
			else
				for (i=0; i<vccount; i++)
					if (strcmp(vcEntry[i].devname, tmp2) == 0) {
						ifcount ++;
						strcpy(sEntry[ifcount-1].ifname, tmp1);
						strcpy(sEntry[ifcount-1].devname, vcEntry[i].devname);
					//	strcpy(sEntry[ifcount-1].encaps, vcEntry[i].encaps);
						strcpy(sEntry[ifcount-1].protocol, "PPPoE");
						sEntry[ifcount-1].tvpi = vcEntry[i].tvpi;
						sEntry[ifcount-1].tvci = vcEntry[i].tvci;
						strcpy(sEntry[ifcount-1].uptime, tmp3);
						strcpy(sEntry[ifcount-1].totaluptime, tmp4);
					}
		fclose(fp);
	}

	// file unlocking
	if ((fdpoe != -1) && (fdpoe != -1)) {
		flpoe.l_type = flpoa.l_type = F_UNLCK;
		if (fcntl(fdpoe, F_SETLK, &flpoe) == -1)
			printf("pppoe read unlock failed\n");
		if (fcntl(fdpoa, F_SETLK, &flpoa) == -1)
			printf("pppoa read unlock failed\n");
		close(fdpoe);
		close(fdpoa);
	}
	
	for (i=0; i<vccount; i++) {
		int j, vcfound=0;
		for (j=0; j<ifcount; j++)
			if (strcmp(vcEntry[i].ifname, sEntry[j].devname) == 0) {	// PPPoE-used device
				vcfound = 1;
				break;
			}
		if (!vcfound) {	// VC not used for PPPoE, add to list
			ifcount ++;
			strcpy(sEntry[ifcount-1].ifname, vcEntry[i].ifname);
		//	strcpy(sEntry[ifcount-1].encaps, vcEntry[i].encaps);
			strcpy(sEntry[ifcount-1].protocol, vcEntry[i].protocol);
			sEntry[ifcount-1].tvpi = vcEntry[i].tvpi;
			sEntry[ifcount-1].tvci = vcEntry[i].tvci;
		}
	}

#endif

	if ((br_socket_fd = socket(AF_INET, SOCK_STREAM, 0)) < 0)
		printf("socket not avaiable !!");
	arg[0] = BRCTL_GET_PORT_LIST;
	arg[1] = (unsigned long)ifindices;
	arg[2] = 0;
	arg[3] = 0;
	strncpy(ifr.ifr_name, BRIF, IFNAMSIZ);
	((unsigned long *)(&ifr.ifr_data))[0] = (unsigned long)arg;
	ioctl(br_socket_fd, SIOCDEVPRIVATE, &ifr);
	for (i=255; i>=0; i--) {
		unsigned int ifindex;
		int j;
		if (!ifindices[i])
			continue;
		ifindex = ifindices[i];
			for (j=0; j<ifcount; j++)
				if (if_nametoindex(sEntry[j].ifname) == ifindex) {
					strcpy(sEntry[j].protocol, "br1483");
				}
	}
	close(br_socket_fd);

	// check for xDSL link
	if (!adsl_drv_get(RLCM_GET_LINK_SPEED, (void *)&vLs, RLCM_GET_LINK_SPEED_SIZE) || vLs.upstreamRate == 0)
		adslflag = 0;
	else
		adslflag = 1;
		
	for (i=0; i<ifcount; i++) {
		struct in_addr inAddr;
		int flags;
		pppConnectStatus = 0;
		isPPP=0;

#ifdef EMBED
		if (getInAddr( sEntry[i].ifname, IP_ADDR, (void *)&inAddr) == 1)
		{
			temp = inet_ntoa(inAddr);
			if (getInFlags( sEntry[i].ifname, &flags) == 1)
				if ((strcmp(temp, "10.0.0.1") == 0) && flags & IFF_POINTOPOINT)	// IP Passthrough or IP unnumbered
					strcpy(sEntry[i].ipAddr, STR_UNNUMBERED);
				else
					strcpy(sEntry[i].ipAddr, temp);
		}
		else
#endif
			strcpy(sEntry[i].ipAddr, "");
	
#ifdef EMBED
		if (getInAddr( sEntry[i].ifname, DST_IP_ADDR, (void *)&inAddr) == 1)
		{
			temp = inet_ntoa(inAddr);
			if (strcmp(temp, "10.0.0.2") == 0)
				strcpy(sEntry[i].remoteIp, STR_UNNUMBERED);
			else
				strcpy(sEntry[i].remoteIp, temp);
			if (getInFlags( sEntry[i].ifname, &flags) == 1)
				if (flags & IFF_BROADCAST) {
					unsigned char value[32];
					snprintf(value, 32, "%s.%s", (char *)MER_GWINFO, sEntry[i].ifname);
					if (fp = fopen(value, "r")) {
						fscanf(fp, "%s\n", sEntry[i].remoteIp);
						strcpy(sEntry[i].protocol, "mer1483");
						fclose(fp);
					}
					else
						strcpy(sEntry[i].remoteIp, "");
				}
		}
		else
#endif
			strcpy(sEntry[i].remoteIp, "");

		if (!strcmp(sEntry[i].protocol, ""))
		{
			int mibCnt;
			int totalNum;
			MIB_CE_ATM_VC_T entry;
			
			totalNum = mib_chain_total(MIB_ATM_VC_TBL);
			for(mibCnt=0; mibCnt<totalNum; mibCnt++)
			{
				if (!mib_chain_get(MIB_ATM_VC_TBL, mibCnt, (void *)&entry))
				{
					printf("get MIB chain error\n");
					return -1;
				}
				if(entry.vpi==sEntry[i].tvpi && entry.vci==sEntry[i].tvci)
				{
					//found entry in mibs, get channel mode
					switch(entry.cmode) {
					case ADSL_MER1483:
						memset(sEntry[i].protocol, 0, 10);
						strcpy(sEntry[i].protocol, "mer1483");
						break;
					case ADSL_PPPoE://patch for pppoe proxy
						strcpy(sEntry[i].protocol, "PPPoE");
						break;
					default:
						break;
					}
					break;
				}
			}
		}

			
		// set status flag
		if (getInFlags( sEntry[i].ifname, &flags) == 1)
		{
			if (flags & IFF_UP) {
				if (!adslflag)
					sEntry[i].strStatus = (char *)IF_DOWN;
				else {
					if (strcmp(sEntry[i].protocol, "br1483") == 0)
						sEntry[i].strStatus = (char *)IF_UP;
					else
						if (getInAddr( sEntry[i].ifname, IP_ADDR, (void *)&inAddr) == 1)
							sEntry[i].strStatus = (char *)IF_UP;
						else
							sEntry[i].strStatus = (char *)IF_DOWN;
				}
			}
			else
				sEntry[i].strStatus = (char *)IF_DOWN;
		}
		else
			sEntry[i].strStatus = (char *)IF_NA;
		
		if (strcmp(sEntry[i].protocol, "PPPoE")==0 || strcmp(sEntry[i].protocol, "PPPoA")==0)
			isPPP = 1;
		else
			isPPP = 0;
		if (isPPP){
			if (strcmp(sEntry[i].strStatus, (char *)IF_UP) == 0)
				pppConnectStatus = 1;
			else {
				pppConnectStatus = 0;
				sEntry[i].ipAddr[0] = '\0';
				sEntry[i].remoteIp[0] = '\0';
			}
		}
		
#ifdef EMBED
		//jim determine china telecom's auto-generated WAN name...
		{
		char applicationname[30];
		MIB_CE_ATM_VC_T Entry;
		int entryNum;
		int mibcnt;
		char vpistr[6];
		char vcistr[6];
		char username[MAX_NAME_LEN];
		char password[MAX_NAME_LEN];
		char interfacename[MAX_NAME_LEN];
		entryNum = mib_chain_total(MIB_ATM_VC_TBL);
#ifdef _CWMP_MIB_ 
		char setname[30];
		memset(setname, 0, 30);
#endif
		char ifname[6];
		char strNapt[10];
		
		memset(applicationname, 0, sizeof(applicationname));
		memset(vpistr, 0, sizeof(vpistr));
		memset(vcistr, 0, sizeof(vcistr));		
		memset(interfacename, 0, sizeof(interfacename));
		sprintf(vpistr, "%d", sEntry[i].tvpi);
		sprintf(vcistr, "%d", sEntry[i].tvci);		
		if(!strcmp(sEntry[i].protocol, "br1483"))
		{
			//ql
			strcpy(strNapt, "--");
			
			//bridge mode
			//first found the mib info...
			for(mibcnt=0; mibcnt<entryNum; mibcnt++)
			{
				if (!mib_chain_get(MIB_ATM_VC_TBL, mibcnt, (void *)&Entry))
				{
  					websError(wp, 400, T("Get chain record error!\n"));
					return -1;
				}
				if(Entry.cmode == ADSL_PPPoE || Entry.cmode == ADSL_PPPoA)//star:for multi-ppp name
					snprintf(ifname, 6, "ppp%u", PPP_INDEX(Entry.ifIndex));
				else
					snprintf(ifname, 6, "vc%u", VC_INDEX(Entry.ifIndex));
				if(Entry.vpi==sEntry[i].tvpi && Entry.vci==sEntry[i].tvci && !strcmp(ifname,sEntry[i].ifname))
				{
					//found entry in mibs
					#ifdef _CWMP_MIB_ 
					if(*(Entry.WanName))
						strcpy(setname, Entry.WanName);
					#endif
					//setWanName(applicationname, Entry.applicationtype);
					getWanName(&Entry, applicationname);

					#ifdef CONFIG_EXT_SWITCH
					sEntry[i].vlanId = Entry.vid;
					#endif
					
					#ifdef  CONFIG_IGMPPROXY_MULTIWAN
					sEntry[i].igmpEnbl = Entry.igmpproxyenable;
					#endif
					
					sEntry[i].qosEnbl = Entry.qosenable;
					
					if(Entry.qos == 0){
						if(Entry.svtype == 0){
							strcpy(sEntry[i].servType,"UBR Without PCR");
						}else{
							strcpy(sEntry[i].servType,"UBR With PCR");
						}
					}else if(Entry.qos == 1){
						strcpy(sEntry[i].servType,"CBR");
					}else if(Entry.qos == 2){
						strcpy(sEntry[i].servType,"Non Realtime VBR");
					}else if(Entry.qos == 3){
						strcpy(sEntry[i].servType,"Realtime VBR");
					}

					if(Entry.encap == 1)
					{
						strcpy(sEntry[i].encaps,"LLC");
					}else{
						strcpy(sEntry[i].encaps,"VCMUX");
					}
					
					break;
				}
			}
		}
		else
		{ 
			//ql-- 070926
			memset(strNapt,0,sizeof(strNapt));
			for(mibcnt=0; mibcnt<entryNum; mibcnt++) {
				if (!mib_chain_get(MIB_ATM_VC_TBL, mibcnt, (void *)&Entry))
				{
  					websError(wp, 400, T("Get chain record error!\n"));
					return -1;
				}
				
				if(Entry.cmode == ADSL_PPPoE || Entry.cmode == ADSL_PPPoA)//star:for multi-ppp name
					snprintf(ifname, 6, "ppp%u", PPP_INDEX(Entry.ifIndex));
				else
					snprintf(ifname, 6, "vc%u", VC_INDEX(Entry.ifIndex));
				
				if(Entry.vpi==sEntry[i].tvpi && Entry.vci==sEntry[i].tvci/* && !strcmp(ifname,sEntry[i].ifname)*/)
				{
					//found entry in mibs
					//printf("ppp: vpi/vci:%d/%d cmode:%d ifname:%s-%s\n", 
					//	Entry.vpi, Entry.vci, Entry.cmode, ifname, sEntry[i].ifname);
					
					if (Entry.napt)
						strcpy(strNapt, ENABLESTR);
					else
						strcpy(strNapt, DISABLESTR);

					#ifdef CONFIG_EXT_SWITCH
					sEntry[i].vlanId = Entry.vid;
					#endif
					
					#ifdef  CONFIG_IGMPPROXY_MULTIWAN
					sEntry[i].igmpEnbl = Entry.igmpproxyenable;
					#endif
					
					sEntry[i].qosEnbl = Entry.qosenable;
					
					if(Entry.qos == 0){
						if(Entry.svtype == 0){
							strcpy(sEntry[i].servType,"UBR Without PCR");
						}else{
							strcpy(sEntry[i].servType,"UBR With PCR");
						}
					}else if(Entry.qos == 1){
						strcpy(sEntry[i].servType,"CBR");
					}else if(Entry.qos == 2){
						strcpy(sEntry[i].servType,"Non Realtime VBR");
					}else if(Entry.qos == 3){
						strcpy(sEntry[i].servType,"Realtime VBR");
					}

					if(Entry.encap == 1)
					{
						strcpy(sEntry[i].encaps,"LLC");
					}else{
						strcpy(sEntry[i].encaps,"VCMUX");
					}

					break;
				}
			}
			if(!strcmp(sEntry[i].protocol, "PPPoE") || !strcmp(sEntry[i].protocol, "PPPoA") )
			{
				memset(username, 0, sizeof(username));
				memset(password, 0, sizeof(password));
				if (!(fp=fopen(PPP_CONF, "r")))
					printf("%s not exists.\n", PPP_CONF);
				else {
					int mruxxx;
					int validelements;
					fgets(buff, sizeof(buff), fp);
					while ( fgets(buff, sizeof(buff), fp) != NULL )
					{
						validelements=sscanf(buff, "%s%*s%*s%*d%*s%s%s%d", interfacename, username, password, &mruxxx);
						 //jim since null username or password is valid setting for 531b zte, then the ppp.conf format will be changed
						switch (validelements) {
							case 2:  //both username and  password are NULL...
								memset(username, 0, sizeof(username));									
							case 3: //only  password are NULL...
								memset(password, 0, sizeof(password));
							case 4:
								if(!strcmp(sEntry[i].ifname, interfacename))
								{
									//found the ppp connection's username/password info
									goto found_ppp_local_0;
								}
								break;
							default:  //invalid format...
								printf("Unsuported ppp configuration format\n");
								goto found_ppp_local_0;
						}					
					}

found_ppp_local_0:					
					fclose(fp);
				}
				

				
			}
			
			
		}
		
		

		#ifdef _CWMP_MIB_ 
		if(*setname)
			strcpy(applicationname, setname);
		#endif
	#ifdef _CWMP_MIB_ 
		if(*(Entry.WanName))
			strcpy(applicationname, Entry.WanName);
	#endif
		getWanName(&Entry, applicationname);
	#endif //EMBED
		strcpy(sEntry[i].servName,applicationname);
		

		}
							//found in mit 
	

		websWrite(wp, T("links.push(new it_nr(\"%d\"" _PTS  _PTS _PTS _PTS _PTS \
			_PTI  _PTI _PTI  _PTS "));\n"), 
			i, __PME(sEntry[i],servName),  __PME(sEntry[i],encaps), __PME(sEntry[i],servType), __PME(sEntry[i],protocol), __PME(sEntry[i],ipAddr), 
			__PME(sEntry[i],vlanId), __PME(sEntry[i],igmpEnbl), __PME(sEntry[i],qosEnbl),  __PME(sEntry[i],strStatus)
			);
	}

//	_TRACE_LEAVEL;
	return 0;

#if 0
	{
	struct status_info	entry;
	int				cnt = 0;
	int				index = 0;
	int				lineno = __LINE__;

	_TRACE_CALL;
	/*test code*/
	cnt = 1;
	memset(&entry, 0, sizeof(entry));
	entry.connId = 1;
	strcpy(entry.servName, "INTERNET_R_0_32");
	strcpy(entry.ifname, "0/0/32");
	strcpy(entry.encaps, "LLC");
	strcpy(entry.servType, "UBR");
	strcpy(entry.protocol, "PPPoE");
	strcpy(entry.ipAddr, "10.0.0.2");
	entry.strStatus = "UP";
	/*test code*/

	/************Place your code here, do what you want to do! ************/
	/************Place your code here, do what you want to do! ************/
	
	for(index = 0; index < cnt; index++)
	{
		/************Place your code here, do what you want to do! ************/
		/************Place your code here, do what you want to do! ************/

		websWrite(wp, T("links.push(new it_nr(\"%d\"" _PTS _PTS _PTS _PTS _PTS _PTS \
			_PTI _PTI _PTI _PTI _PTI _PTS "));\n"), 
			index, _PME(servName), _PME(ifname), _PME(encaps), _PME(servType), _PME(protocol), _PME(ipAddr), 
			_PME(vlanId), _PME(connId), _PME(igmpEnbl), _PME(qosEnbl), _PME(pvcEnbl), _PME(strStatus)
			);
	}

check_err:
	_TRACE_LEAVEL;
	return 0;
	}
#endif
}
#endif

#define _PATH_PROCNET_DEV               "/proc/net/dev"
/*****************************
** wlan stats list
*/
#ifdef WLAN_SUPPORT
#ifdef WLAN_MBSSID
static void fix_wlan_itf_name(char *dst, char *src)
{
	char type=0;
	MIB_CE_MBSSIB_T entry;
	if(!strcmp(src,"wlan0")) type=0;
	else if(!strcmp(src,"wlan0-vap0")) type=1;
	else if(!strcmp(src,"wlan0-vap1")) type=2; 
	else if(!strcmp(src,"wlan0-vap2")) type=3;
	else if(!strcmp(src,"wlan0-vap3")) type=4;
	if(type){
		mib_chain_get(MIB_MBSSIB_TBL,type,&entry);
		strcpy(dst,entry.ssid);
	}else //root ssid
	mib_get(MIB_WLAN_SSID,dst);	
}
#endif
int wlStatsList (int eid, webs_t wp, int argc, char_t **argv)
{
	wlif_status_info	entry;
	int				cnt = 0;
	int				index = 0;
	int				lineno = __LINE__;
	FILE *fh;
	char buf[512];

	_TRACE_CALL;

	/*test code*/
	memset(&entry, 0, sizeof(entry));
	strcpy(entry.ifname, "wireless");
	/*test code*/

	/************Place your code here, do what you want to do! ************/
	/************Place your code here, do what you want to do! ************/
	fh = fopen(_PATH_PROCNET_DEV, "r");
	if (!fh) {
		fprintf(stderr, "Warning: cannot open %s (%s).\n",
			_PATH_PROCNET_DEV, strerror(errno));
		return;
	}
	fgets(buf, sizeof buf, fh);	/* eat line */
	fgets(buf, sizeof buf, fh);
	while (fgets(buf, sizeof buf, fh)) {
		char *s, name[IFNAMSIZ];
		int islan;
		s = get_name(name, buf);    
		islan=0;
		//modifed by ramen to filter the wlan0-wds* interface
		if (!strncmp("wlan0", name, 5)&&!strstr(name,"wds")) {	
			if (wlan_is_up()) {
				sscanf(s,"%lu %lu %lu %lu %*lu %*lu %*lu %*lu %lu %lu %lu %lu %*lu %*lu %*lu %*lu",
					&(_PME(rx_byte)), &(_PME(rx_pkt)), &(_PME(rx_err)), &(_PME(rx_drop)), &(_PME(tx_byte)), &(_PME(tx_pkt)), &(_PME(tx_err)), &(_PME(tx_drop)));
				islan=1;
				cnt++;
			};		
		}
		if (islan) {
			#ifdef WLAN_MBSSID
			fix_wlan_itf_name(entry.ifname, name);
			#else
			strcpy(entry.ifname, name);
			#endif
			websWrite(wp, T("rcs.push(new it_nr(\"%d\"" _PTS _PTUL _PTUL _PTUL _PTUL _PTUL _PTUL _PTUL _PTUL "));\n"), 
				index, _PME(ifname), _PME(rx_pkt), _PME(rx_err), _PME(rx_drop), _PME(rx_byte), 
				_PME(tx_pkt), _PME(tx_err), _PME(tx_drop), _PME(tx_byte));
			index++;
		}
	}
	
	fclose(fh);

	/************Place your code here, do what you want to do! ************/
	/************Place your code here, do what you want to do! ************/
	if (!cnt) {
		websWrite(wp, T("rcs.push(new it_nr(\"%d\"" _PTS _PTUL _PTUL _PTUL _PTUL _PTUL _PTUL _PTUL _PTUL "));\n"), 
			index, _PME(ifname), _PME(rx_pkt), _PME(rx_err), _PME(rx_drop), _PME(rx_byte), 
			_PME(tx_pkt), _PME(tx_err), _PME(tx_drop), _PME(tx_byte));
	}

check_err:
	_TRACE_LEAVEL;
	return 0;
}
#endif
/*****************************
** ethers stats list
*/
static char *get_name(char *name, char *p)
{
    while (isspace(*p))
	p++;
    while (*p) {
	if (isspace(*p))
	    break;
	if (*p == ':') {	/* could be an alias */
	    char *dot = p, *dotname = name;
	    *name++ = *p++;
	    while (isdigit(*p))
		*name++ = *p++;
	    if (*p != ':') {	/* it wasn't, backup */
		p = dot;
		name = dotname;
	    }
	    if (*p == '\0')
		return NULL;
	    p++;
	    break;
	}
	*name++ = *p++;
    }
    *name++ = '\0';
    return p;
}
int pktStatsList(int eid, webs_t wp, int argc, char_t **argv)
{
	ehif_status_info	entry;
	int				cnt = 0;
	int				index = 0;
	int				lineno = __LINE__;
	FILE *fh;
	char buf[512];
	_TRACE_CALL;

	/*test code*/
	cnt = 1;
	memset(&entry, 0, sizeof(entry));
	strcpy(entry.ifname, "ethernet");
	/*test code*/

	/************Place your code here, do what you want to do! ************/
	// Ethernet statistics
	fh = fopen(_PATH_PROCNET_DEV, "r");
	if (!fh) {
		fprintf(stderr, "Warning: cannot open %s (%s).\n",
			_PATH_PROCNET_DEV, strerror(errno));
		return;
	}
	fgets(buf, sizeof buf, fh);	/* eat line */
	fgets(buf, sizeof buf, fh);
	while (fgets(buf, sizeof buf, fh)) {
		char *s, name[IFNAMSIZ];
		s = get_name(name, buf);    
		if (!strcmp("eth0", name)) {
			//add and modify liuxiao 2008-01-29
			sscanf(s,
			"%lu %lu %lu %lu %*lu %*lu %*lu %*lu %lu %lu %lu %lu %*lu %*lu %*lu %*lu",
			&(_PME(rx_byte)), &(_PME(rx_pkt)), &(_PME(rx_err)), &(_PME(rx_drop)), &(_PME(tx_byte)), &(_PME(tx_pkt)), &(_PME(tx_err)), &(_PME(tx_drop)));
			break;		
		}
	}	
	fclose(fh);	
	/************Place your code here, do what you want to do! ************/
	
	//for(index = 0; index < cnt; index++)
	{
		/************Place your code here, do what you want to do! ************/
		/************Place your code here, do what you want to do! ************/

		websWrite(wp, T("ethers.push(new it_nr(\"%d\"" _PTS _PTUL _PTUL _PTUL _PTUL _PTUL _PTUL _PTUL _PTUL "));\n"), 
			index, _PME(ifname), _PME(rx_pkt), _PME(rx_err), _PME(rx_drop), _PME(rx_byte), 
			_PME(tx_pkt), _PME(tx_err), _PME(tx_drop), _PME(tx_byte)
			);
	}

check_err:
	_TRACE_LEAVEL;
	return 0;
}

/*****************************
** devices list
*/


#ifdef EMBED
static int getOneDhcpClient(char **ppStart, unsigned long *size, char *ip, char *mac, char *liveTime)
{
	struct dhcpOfferedAddr {
        	u_int8_t chaddr[16];
        	u_int32_t yiaddr;       /* network order */        	
        	u_int32_t expires;      /* host order */        	
	};

	struct dhcpOfferedAddr entry;
#if defined(ZTE_531B_BRIDGE_SC)||defined(ZTE_GENERAL_ROUTER_SC)
	u_int32_t day,hour,minute,second,time,len=0;
#endif

	if ( *size < sizeof(entry) )
		return -1;

	entry = *((struct dhcpOfferedAddr *)*ppStart);
	*ppStart = *ppStart + sizeof(entry);
	*size = *size - sizeof(entry);

	if (entry.expires == 0) 		
		return 0;
//star: conflict ip addr will not be displayed on web
	if(entry.chaddr[0]==0&&entry.chaddr[1]==0&&entry.chaddr[2]==0&&entry.chaddr[3]==0&&entry.chaddr[4]==0&&entry.chaddr[5]==0)
		return 0;
	
	strcpy(ip, inet_ntoa(*((struct in_addr *)&entry.yiaddr)) );
	#if defined(ZTE_531B_BRIDGE_SC)||defined(ZTE_GENERAL_ROUTER_SC)
	snprintf(mac, 20, "%02x-%02x-%02x-%02x-%02x-%02x",
			entry.chaddr[0],entry.chaddr[1],entry.chaddr[2],entry.chaddr[3],
			entry.chaddr[4], entry.chaddr[5]);
	#else
	snprintf(mac, 20, "%02x:%02x:%02x:%02x:%02x:%02x",
			entry.chaddr[0],entry.chaddr[1],entry.chaddr[2],entry.chaddr[3],
			entry.chaddr[4], entry.chaddr[5]);
	#endif

#if defined(ZTE_531B_BRIDGE_SC)||defined(ZTE_GENERAL_ROUTER_SC)
	time = ntohl(entry.expires);
	if(time == -1){
		strcpy(liveTime, strShowDhcptime);
		return 1;
	}
	day = time/86400;
	hour = (time%86400)/3600;
	minute = ((time%86400)%3600)/60;
	second = ((time%86400)%3600)%60;

	if(day!=0)
		len=snprintf(liveTime, 20, "%lu%s", day,Tpublic_day2);
	if(hour!=0)
		len+=snprintf(liveTime+len, 20, "%lu%s", hour,Tpublic_hour2);
	if(minute!=0)
		len+=snprintf(liveTime+len, 20, "%lu%s", minute,Tpublic_minute);
	if(second!=0)
		snprintf(liveTime+len, 20, "%lu%s", second,Tpublic_second);
	if(day == 0 && hour == 0 && minute == 0 && second == 0)
		snprintf(liveTime+len, 20, "0%s",Tpublic_second);
#else
	snprintf(liveTime, 10, "%lu", (unsigned long)ntohl(entry.expires));
#endif

	return 1;
}
#endif
#define _DHCPD_PID_FILE			T("/var/run/udhcpd.pid")
#define _DHCPD_LEASES_FILE		T("/var/udhcpd/udhcpd.leases")
int dhcpClientList(int eid, webs_t wp, int argc, char_t **argv)
{
	struct dhcp_device_info	entry;
	char			uIpAddr[16];
	int				cnt = 0;
	int				index = 0;
	int				lineno = __LINE__;

	_TRACE_CALL;

	/*test code*/
	cnt = 0;
	memset(&entry, 0, sizeof(entry));
	memset(uIpAddr, 0, sizeof(uIpAddr));
	/*test code*/

	/************Place your code here, do what you want to do! ************/
	#ifdef EMBED
	int pid;
	struct stat status;
	int nBytesSent=0;
	int element=0, ret;
	char ipAddr[40], macAddr[40], liveTime[80], *buf=NULL, *ptr;
	unsigned int minIpVal=0;
	unsigned int maxIpVal=0;	
	unsigned int ipVal=0;
	FILE *fp;

	// siganl DHCP server to update lease file
	pid = read_pid(_DHCPD_PID_FILE);
	if ( pid > 0)
		kill(pid, SIGUSR1);
	usleep(1000);

	if ( stat(_DHCPD_LEASES_FILE, &status) < 0 ) 		
		goto err;	
	
	// read DHCP server lease file
	buf = malloc(status.st_size);
	if ( buf == NULL ) goto err;
	fp = fopen(_DHCPD_LEASES_FILE, "r");
	if ( fp == NULL )goto err;
	fread(buf, 1, status.st_size, fp);
	fclose(fp);

	ptr = buf;
	while (1) {
		ret = getOneDhcpClient(&ptr, &status.st_size, ipAddr, macAddr, liveTime);		
		
		if (ret < 0)
			break;
		if (ret == 0)
			continue;
		inet_aton(ipAddr, (struct in_addr *)&ipVal);
		mib_get(CWMP_CT_PC_MINADDR, (void *)&minIpVal);
		mib_get(CWMP_CT_PC_MAXADDR, (void *)&maxIpVal);
		if( ipVal >= minIpVal   && ipVal <= maxIpVal)
		{
			// pc device...
			strcpy(entry.devname, "Computer");
		}else
		{
			mib_get(CWMP_CT_CMR_MINADDR, (void *)&minIpVal);
			mib_get(CWMP_CT_CMR_MAXADDR, (void *)&maxIpVal);
			if( ipVal >= minIpVal   && ipVal <= maxIpVal)
			{
				// Camera device...
				strcpy(entry.devname, "Camera");
			}else
			{
				mib_get(CWMP_CT_STB_MINADDR, (void *)&minIpVal);
				mib_get(CWMP_CT_STB_MAXADDR, (void *)&maxIpVal);
				if( ipVal >= minIpVal   && ipVal <= maxIpVal)
				{
					// Set Box device...
					strcpy(entry.devname, "STB");
				}else
				{
					//default
					strcpy(entry.devname, "Computer");
				}
			}
		}
			strncpy(uIpAddr, ipAddr, 20);
			printf("%s\n", entry,uIpAddr);
			websWrite(wp, T("clts.push(new it_nr(\"%d\"" _PTS _PTS "));\n"), cnt, _PME(devname), _PMEX(uIpAddr));
		cnt++;
	}

err:
	if (cnt == 0) {
		websWrite(wp, T("clts.push(new it_nr(\"%d\"" _PTS _PTS "));\n"), cnt, _PME(devname), _PMEX(uIpAddr));		
	}
	if (buf)
		free(buf);

	return 0;
#else
	return 0;
#endif

#if 0
	/************Place your code here, do what you want to do! ************/
	
	for(index = 0; index < cnt; index++)
	{
		/************Place your code here, do what you want to do! ************/
		/************Place your code here, do what you want to do! ************/

		websWrite(wp, T("clts.push(new it_nr(\"%d\"" _PTS _PTS "));\n"), index, _PME(devname), _PMEIP(uIpAddr));
	}
#endif
check_err:
	_TRACE_LEAVEL;
	return 0;
}
