/*
*  fmmenucreate.c is used to create menu
*  added by xl_yue
*/
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include "../webs.h"
#include "mib.h"
#include "webform.h"
#include "utility.h"
//add by ramen to include the autoconf.h created by kernel
#ifdef EMBED
#include <linux/config.h>
#else
#include "../../../../uClibc/include/linux/autoconf.h"
#endif
#ifdef WEB_MENU_USE_NEW
const char menuTitle[] = "Site contents:";
#ifdef CONFIG_DEFAULT_WEB_REALTEK	// default pages
/*
 *	2nd Layer Menu
 */
struct RootMenu childmenu_dns[] = {
  {"DNS Server", MENU_URL, "dns.asp", "DNS Server Configuration", 0, 0},
#ifdef CONFIG_USER_DDNS
  {"Dynamic DNS", MENU_URL, "ddns.asp", "DDNS Configuration", 0, 0},
#endif
  {0, 0, 0, 0, 0, 0}
};
struct RootMenu childmenu_fw[] = {
#ifdef CONFIG_IP_NF_ALG_ONOFF
  {"ALG", MENU_URL, "algonoff.asp", "ALG on-off", 0, 0},
#endif
  {"IP/Port Filtering", MENU_URL, "fw-ipportfilter.asp",
   "Setup IP/Port filering", 0, 0},
#ifdef MAC_FILTER
  {"MAC Filtering", MENU_URL, "fw-macfilter.asp", "Setup MAC filering", 0, 0},
#endif
  {"Port Forwarding", MENU_URL, "fw-portfw.asp", "Setup port-forwarding", 0,
   0},
#ifdef URL_BLOCKING_SUPPORT
  {"URL Blocking", MENU_URL, "url_blocking.asp", "URL Blocking Setting", 0,
   0},
#endif
#ifdef DOMAIN_BLOCKING_SUPPORT
  {"Domain Blocking", MENU_URL, "domainblk.asp", "Domain Blocking Setting", 0,
   0},
#endif
#ifdef PARENTAL_CTRL
  {"Parental Control", MENU_URL, "parental-ctrl.asp", "Parental Control Setting", 0,
   0},
#endif
#ifdef TCP_UDP_CONN_LIMIT
  {"Connection Limit", MENU_URL, "connlimit.asp", "Connection Limit Setting", 0,
   0},
#endif // TCP_UDP_CONN_LIMIT
#ifdef NATIP_FORWARDING
  {"NAT IP Forwarding", MENU_URL, "fw-ipfw.asp", "Setup NAT IP Mapping", 0,
   0},
#endif
#ifdef PORT_TRIGGERING
  {"Port Triggering", MENU_URL, "gaming.asp", "Setup Port Triggering", 0, 0},
#endif
  {"DMZ", MENU_URL, "fw-dmz.asp", "Setup DMZ",0, 0},  	
#ifdef ADDRESS_MAPPING
#ifdef MULTI_ADDRESS_MAPPING
 // Eric Chen add for True
  {"NAT Rule Configuration", MENU_URL, "multi_addr_mapping.asp", "Setup NAT Rule",0, 0},
#else //!MULTI_ADDRESS_MAPPING
 // Mason Yu on True
  {"NAT Rule Configuration", MENU_URL, "address_mapping.asp", "Setup NAT Rule",0, 0},
  #endif// end of !MULTI_ADDRESS_MAPPING
#endif
  {0, 0, 0, 0, 0, 0}

};

//ql 20081119 START
#ifdef NEW_IP_QOS_SUPPORT
struct RootMenu childmenu_qos[] = {
	{"QoS Classification", MENU_URL, "ipqos_sc.asp", "Setup IP QoS", 0, 0},
	{"Traffic Shape", MENU_URL, "ipqos_shape.asp", "traffic control", 0, 0},
	{0, 0, 0, 0, 0, 0}
};
#endif
#ifdef IP_QOS
struct RootMenu childmenu_qos[] = {
	{"Classification", MENU_URL, "ipqos.asp", "Traffic Configuration", 0, 0},
	{"QoS Queue", MENU_URL, "ipqos_queue.asp", "Queue Config", 0, 0},	
	{0, 0, 0, 0, 0, 0}
};
#endif

/*
 *	First Layer Menu
 */
struct RootMenu childmenu_lan[] = {
  {0, 0, 0, 0, 0, 0}
};
struct RootMenu childmenu_wlan[] = {
  {"Basic Settings", MENU_URL, "wlbasic.asp",   "Setup wireless basic configuration", 0, 0},
  {"Advanced Settings", MENU_URL, "wladvanced.asp",   "Setup wireless advanced configuration", 0, 0},
#ifdef WLAN_MBSSID
  {"Security", MENU_URL, "wlwpa_mbssid.asp", "Setup wireless security", 0, 0},
#else
  {"Security", MENU_URL, "wlwpa.asp", "Setup wireless security", 0, 0},
#endif
#ifdef WLAN_ACL
  {"Access Control", MENU_URL, "wlactrl.asp",   "Setup access control list for wireless clients", 0, 0},
#endif
#ifdef WLAN_WDS
  {"WDS", MENU_URL, "wlwds.asp", "WDS Settings", 0, 0},
#endif
#ifdef WLAN_CLIENT
  {"Site Survey", "wlsurvey.asp", "Wireless Site Survey", 0, 0},
#endif
#ifdef CONFIG_WIFI_SIMPLE_CONFIG	// WPS
  {"WPS", MENU_URL, "wlwps.asp", "Wireless Protected Setup", 0, 0},
#endif
#ifdef WLAN_MBSSID
  {"MBSSID", MENU_URL, "wlmbssid.asp", "Wireless Multiple BSSID Setting", 0,   0},
#endif
  {0, 0, 0, 0, 0, 0}
};
struct RootMenu childmenu_wan[] = {
  {"Channel Config", MENU_URL, "wanadsl.asp", "Setup Channel Mode", 0, 0},
  {"ATM Settings", MENU_URL, "wanatm.asp", "Setup ATM", 0, 0},
  {"ADSL Settings", MENU_URL, "/adv/adsl-set.asp", "Setup ADSL", 0, 0},
#ifdef CONFIG_USER_PPPOMODEM
  {"3G Settings", MENU_URL, "wan3gconf.asp", "Setup 3G WAN", 0, 0},
#endif //CONFIG_USER_PPPOMODEM
  {0, 0, 0, 0, 0, 0}
};
struct RootMenu childmenu_service[] = {
  //{"DHCP Mode", MENU_URL, "dhcpmode.asp", "DHCP Mode Configuration", 0, 0},
#ifdef IMAGENIO_IPTV_SUPPORT
  {"DHCP Settings", MENU_URL, "dhcpd_sc.asp", "DHCP Configuration", 0, 0},
#else
  {"DHCP Settings", MENU_URL, "dhcpd.asp", "DHCP Configuration", 0, 0},
#endif
  //{"DHCP Relay", MENU_URL, "dhcrelay.asp", "DHCP Relay Configuration", 0, 0},
  {"DNS", MENU_FOLDER, &childmenu_dns, "",
   sizeof (childmenu_dns) / sizeof (struct RootMenu) - 1, 0},
  {"Firewall", MENU_FOLDER, &childmenu_fw, "",
   sizeof (childmenu_fw) / sizeof (struct RootMenu) - 1, 0},
#if defined(CONFIG_USER_IGMPPROXY)&&!defined(CONFIG_IGMPPROXY_MULTIWAN)
  {"IGMP Proxy", MENU_URL, "igmproxy.asp", "IGMP Proxy Configuration", 0, 0},
#endif
#if defined(CONFIG_USER_UPNPD)||defined(CONFIG_USER_MINIUPNPD)
  {"UPnP", MENU_URL, "upnp.asp", "UPnP Configuration", 0, 0},
#endif
#ifdef CONFIG_USER_ROUTED_ROUTED
  {"RIP", MENU_URL, "rip.asp", "RIP Configuration", 0, 0},
#endif
#ifdef WEB_REDIRECT_BY_MAC
  {"Landing Page", MENU_URL, "landing.asp", "Landing Page Configuration", 0, 0},
#endif
  {0, 0, 0, 0, 0, 0}
};
struct RootMenu childmenu_adv[] = {
  {"ARP table", MENU_URL, "arptable.asp", "ARP table", 0, 0},
  {"Bridging", MENU_URL, "bridging.asp", "Bridge Configuration", 0, 0},
  {"Routing", MENU_URL, "routing.asp", "Routing Configuration", 0, 0},
#ifdef CONFIG_USER_SNMPD_SNMPD_V2CTRAP
  {"SNMP", MENU_URL, "snmp.asp", "SNMP Protocol Configuration", 0, 0},
#endif
// Mason Yu. combine_1p_4p_PortMapping
#if (defined( ITF_GROUP_4P) && defined(ITF_GROUP)) || (defined( ITF_GROUP_1P) && defined(ITF_GROUP))
  {"Port Mapping", MENU_URL, "eth2pvc.asp", "Assign Ethernet to PVC", 0, 0},
#endif
#ifdef VLAN_GROUP
  {"Port Mapping", MENU_URL, "eth2pvc_vlan.asp", "Port-vlan mapping", 0, 0},
#endif
#ifdef QOS_DIFFSERV
  {"DiffServ", MENU_URL, "diffserv.asp", "Differentiated Services Setting", 0, 0},
#endif
#ifdef NEW_IP_QOS_SUPPORT
  {"IP QoS", MENU_FOLDER, &childmenu_qos, "", 
    sizeof(childmenu_qos)/sizeof(struct RootMenu) - 1, 0},
#endif
#ifdef CONFIG_EXT_SWITCH
#ifdef ELAN_LINK_MODE
  {"Link Mode", MENU_URL, "lnkmode.asp", "Ethernet Link Mode Setting", 0, 0},
#endif
#else 
#ifdef ELAN_LINK_MODE_INTRENAL_PHY
    {"Link Mode", MENU_URL, "eth.asp", "Ethernet Link Mode Setting", 0, 0},
#endif
#endif
  {"Remote Access", MENU_URL, "rmtacc.asp", "Services Access Control", 0, 0},
  {"Others", MENU_URL, "others.asp", "Other advanced Configuration", 0, 0},
  {0, 0, 0, 0, 0, 0}
};
struct RootMenu childmenu_diag[] = {
  {"Ping", MENU_URL, "ping.asp", "Ping test", 0, 0},
  {"ATM Loopback", MENU_URL, "oamloopback.asp", "ATM OAM loopback test", 0,
   0},
  {"ADSL", MENU_URL, "/adv/adsl-diag.asp", "ADSL Tone Diagnostics", 0, 0},
#ifdef DIAGNOSTIC_TEST
  {"Diagnostic Test", MENU_URL, "diag-test.asp", "Diagnostic test", 0, 0},
#endif
  {0, 0, 0, 0, 0, 0}
};
struct RootMenu childmenu_admin[] = {
#ifdef FINISH_MAINTENANCE_SUPPORT
  {"Finish Maintenance", MENU_URL, "finishmaintenance.asp",
   "Finish Maintenance", 0, 0},
#endif
  {"Commit/Reboot", MENU_URL, "reboot.asp", "Commit/reboot the system", 0, 0},
#ifdef CONFIG_SAVE_RESTORE
  {"Backup/Restore", MENU_URL, "saveconf.asp",
   "Backup/restore current settings", 0, 0},
#endif
#ifdef ACCOUNT_LOGIN_CONTROL
  {"Logout", MENU_URL, "adminlogout.asp", "Logout", 0, 0},
#endif
#ifdef SYSLOG_SUPPORT
#ifndef SEND_LOG
  {"System Log", MENU_URL, "syslog.asp", "Show system log", 0, 0},
#else
  {"System Log", MENU_URL, "syslog_server.asp", "Show system log", 0, 0},
#endif
#endif
#ifdef DOS_SUPPORT
  {"DOS", MENU_URL, "dos.asp", "Denial of service", 0, 0},
#endif
#ifdef ACCOUNT_CONFIG
  {"User Account", MENU_URL, "userconfig.asp", "Setup user account", 0, 0},	// Jenny, user account config page
#else
  {"Password", MENU_URL, "password.asp", "Setup access password", 0, 0},
#endif
#ifdef WEB_UPGRADE
#ifdef UPGRADE_V1
  {"Upgrade Firmware", MENU_URL, "upload.asp", "Update firmware image", 0, 0},
#else
#ifdef UPGRADE_V2
  {"Upgrade Firmware", MENU_URL, "upload2.asp", "Update firmware image", 0,
   0},
#endif // of UPGRADE_V2
#ifdef UPGRADE_V3
  {"Upgrade Firmware", MENU_URL, "upload3.asp", "Update firmware image", 0,
   0},
#endif // of UPGRADE_V3
#endif // of UPGRADE_V1
#endif // of WEB_UPGRADE
#ifdef IP_ACL
  {"ACL Config", MENU_URL, "acl.asp", "ACL Setting", 0, 0},
#endif
#ifdef TIME_ZONE
  {"Time Zone", MENU_URL, "ntp.asp", "Setup Time Zone", 0, 0},
#endif
#ifdef AUTO_PROVISIONING
  {"Auto-Provisionning", MENU_URL, "autoprovision.asp",
   "Auto-Provisioning Configuration", 0, 0},
#endif
#ifdef _CWMP_MIB_
  {"TR-069 Config", MENU_URL, "tr069config.asp", "TR-069 Configuration", 0,
   0},
#endif
//added by xl_yue
#ifdef USE_LOGINWEB_OF_SERVER
  {"Logout", MENU_URL, "/admin/logout.asp", "Logout", 0, 0},
#endif
  {0, 0, 0, 0, 0, 0}
};
struct RootMenu childmenu_statis[] = {
  {"Interfaces", MENU_URL, "stats.asp", "Display packet statistics", 0, 0},
  {"ADSL", MENU_URL, "/adv/adsl-statis.asp", "Display ADSL statistics", 0, 0},
  {0, 0, 0, 0, 0, 0}
};

//added by eric for VOIP web pages  20070904
#ifdef VOIP_SUPPORT
struct RootMenu childmenu_VoIP[] = {
  {"Port1", MENU_URL, "voip_general.asp?port=0", "Setup VoIP Port 1", 0, 0},
  {"Port2", MENU_URL, "voip_general.asp?port=1", "Setup VoIP Port 2", 0, 0},
  {"FXO", MENU_URL, "voip_general.asp?port=2", "Configure FXO connection", 0, 0},  
  {"Tone", MENU_URL, "voip_tone.asp", "Configure SLIC tones", 0, 0},
  {"Ring", MENU_URL, "voip_ring.asp", "Configure Ring Types of Phone", 0, 0},

  {"Other", MENU_URL, "voip_other.asp", "Other Services", 0, 0},  
  {"Config", MENU_URL, "voip_config.asp", "Configuration Upload/Download", 0, 0},  
  {0, 0, 0, 0, 0, 0}
};

#endif
/*
 *	Root Menu
 */
struct RootMenu rootmenu[] = {
  {"Status", MENU_URL, "status.asp", "View the Status", 0, 0},
  {"LAN", MENU_URL, "tcpiplan.asp", "Setup LAN Interface", 0, 0},
#ifdef WLAN_SUPPORT
  {"Wireless", MENU_FOLDER, &childmenu_wlan, "",
   sizeof (childmenu_wlan) / sizeof (struct RootMenu) - 1, 0},
#endif
  {"WAN", MENU_FOLDER, &childmenu_wan, "",
   sizeof (childmenu_wan) / sizeof (struct RootMenu) - 1, 0},
  {"Services", MENU_FOLDER, &childmenu_service, "",
   sizeof (childmenu_service) / sizeof (struct RootMenu) - 1, 0},
#ifdef VOIP_SUPPORT
  {"VoIP", MENU_FOLDER, &childmenu_VoIP, "",
   sizeof (childmenu_VoIP) / sizeof (struct RootMenu) - 1, 0},
#endif
  {"Advance", MENU_FOLDER, &childmenu_adv, "",
   sizeof (childmenu_adv) / sizeof (struct RootMenu) - 1, 0},
  {"Diagnostic", MENU_FOLDER, &childmenu_diag, "",
   sizeof (childmenu_diag) / sizeof (struct RootMenu) - 1, 0},
  {"Admin", MENU_FOLDER, &childmenu_admin, "",
   sizeof (childmenu_admin) / sizeof (struct RootMenu) - 1, 0},
  {"Statistics", MENU_FOLDER, &childmenu_statis, "",
   sizeof (childmenu_statis) / sizeof (struct RootMenu) - 1, 0},
  {0, 0, 0, 0, 0, 0}
};
#endif // of CONFIG_DEFAULT_WEB_REALTEK

//add by lhj
#ifdef CONFIG_DEFAULT_WEB	// default pages
/*
 *	2nd Layer Menu
 */
 
//ql 20081119 START
#ifdef NEW_IP_QOS_SUPPORT
struct RootMenu childmenu_qos[] = {
	{"QoS Classification", MENU_URL, "ipqos_sc.asp", "Setup IP QoS", 0, 0},
	{"Traffic Shape", MENU_URL, "ipqos_shape.asp", "traffic control", 0, 0},
	{0, 0, 0, 0, 0, 0}
};
#endif
#ifdef IP_QOS
struct RootMenu childmenu_qos[] = {
	{"Classification", MENU_URL, "ipqos.asp", "Traffic Configuration", 0, 0},
	{"QoS Queue", MENU_URL, "ipqos_queue.asp", "Queue Config", 0, 0},	
	{0, 0, 0, 0, 0, 0}
};
#endif

struct RootMenu childmenu_wlan[] = {
  {"Basic Settings", MENU_URL, "wlbasic.asp",   "Setup wireless basic configuration", 0, 0},
#ifdef WLAN_MBSSID
  {"Security", MENU_URL, "wlwpa_mbssid.asp", "Setup wireless security", 0, 0},
#else
  {"Security", MENU_URL, "wlwpa.asp", "Setup wireless security", 0, 0},
#endif
#ifdef CONFIG_WIFI_SIMPLE_CONFIG	// WPS
  {"WPS", MENU_URL, "wlwps.asp", "Wireless Protected Setup", 0, 0},
#endif
  {0, 0, 0, 0, 0, 0}
};

struct RootMenu childmenu_wlanadv[] = {
 {"Advanced Settings", MENU_URL, "wladvanced.asp",   "Setup wireless advanced configuration", 0, 0},
#ifdef WLAN_ACL
  {"Access Control", MENU_URL, "wlactrl.asp",   "Setup access control list for wireless clients", 0, 0},
#endif
#ifdef WLAN_WDS
  {"WDS", MENU_URL, "wlwds.asp", "WDS Settings", 0, 0},
#endif
#ifdef WLAN_CLIENT
  {"Site Survey", "wlsurvey.asp", "Wireless Site Survey", 0, 0},
#endif
#ifdef WLAN_MBSSID
  {"MBSSID", MENU_URL, "wlmbssid.asp", "Wireless Multiple BSSID Setting", 0,   0},
#endif
  {0, 0, 0, 0, 0, 0}
};

/*
 *	First Layer Menu
 */
 
struct RootMenu childmenu_setup[] = {
//  {"Internet Setup (Channel Config)", MENU_URL, "wanadsl.asp", "Setup Channel Mode", 0, 0},
  {"Internet Setup", MENU_URL, "wanadsl.asp", "Setup Channel Mode", 0, 0},
  {"LAN Setup", MENU_URL, "tcpiplan.asp", "Setup LAN Interface ", 0, 0},  
#ifdef WLAN_SUPPORT
  {"Wireless", MENU_FOLDER, &childmenu_wlan, "",   sizeof (childmenu_wlan) / sizeof (struct RootMenu) - 1, 0},
#endif
  {"DHCP Settings", MENU_URL, "dhcpd.asp", "DHCP Configuration", 0, 0},
#ifdef TIME_ZONE
  {"Time Zone", MENU_URL, "ntp.asp", "Setup Time Zone", 0, 0},
#endif
  {0, 0, 0, 0, 0, 0}
};

//add by lhj
struct RootMenu childmenu_setup1[] = {
  {"LAN Setup", MENU_URL, "tcpiplan.asp", "Setup LAN Interface ", 0, 0},  
#ifdef WLAN_SUPPORT
  {"Wireless", MENU_FOLDER, &childmenu_wlan, "",   sizeof (childmenu_wlan) / sizeof (struct RootMenu) - 1, 0},
#endif
  {"DHCP Settings", MENU_URL, "dhcpd.asp", "DHCP Configuration", 0, 0},
#ifdef TIME_ZONE
  {"Time Zone", MENU_URL, "ntp.asp", "Setup Time Zone", 0, 0},
#endif
  {0, 0, 0, 0, 0, 0}
};

struct RootMenu childmenu_fw[] = {
#ifdef CONFIG_IP_NF_ALG_ONOFF
  {"ALG", MENU_URL, "algonoff.asp", "ALG on-off", 0, 0},
#endif
  {"IP/Port Filtering", MENU_URL, "fw-ipportfilter.asp",
   "Setup IP/Port filering", 0, 0},
#ifdef MAC_FILTER
  {"MAC Filtering", MENU_URL, "fw-macfilter.asp", "Setup MAC filering", 0, 0},
#endif
  {"Port Forwarding", MENU_URL, "fw-portfw.asp", "Setup port-forwarding", 0,
   0},
#ifdef URL_BLOCKING_SUPPORT
  {"URL Blocking", MENU_URL, "url_blocking.asp", "URL Blocking Setting", 0,
   0},
#endif
#ifdef DOMAIN_BLOCKING_SUPPORT
  {"Domain Blocking", MENU_URL, "domainblk.asp", "Domain Blocking Setting", 0,
   0},
#endif
#ifdef PARENTAL_CTRL
  {"Parental Control", MENU_URL, "parental-ctrl.asp", "Parental Control Setting", 0,
   0},
#endif
#ifdef TCP_UDP_CONN_LIMIT
  {"Connection Limit", MENU_URL, "connlimit.asp", "Connection Limit Setting", 0,
   0},
#endif // TCP_UDP_CONN_LIMIT
#ifdef NATIP_FORWARDING
  {"NAT IP Forwarding", MENU_URL, "fw-ipfw.asp", "Setup NAT IP Mapping", 0,
   0},
#endif
#ifdef PORT_TRIGGERING
  {"Port Triggering", MENU_URL, "gaming.asp", "Setup Port Triggering", 0, 0},
#endif
#ifdef NEW_PORT_TRIGGER //add by machuanjun  
{"Port Triggering", MENU_URL, "fw-trigger.asp", "Setup Port Triggering", 0, 0},
#endif
  {"DMZ", MENU_URL, "fw-dmz.asp", "Setup DMZ",0, 0},  	
#ifdef ADDRESS_MAPPING
#ifdef MULTI_ADDRESS_MAPPING
 // Eric Chen add for True
  {"NAT Rule Configuration", MENU_URL, "multi_addr_mapping.asp", "Setup NAT Rule",0, 0},
#else //!MULTI_ADDRESS_MAPPING
 // Mason Yu on True
  {"NAT Rule Configuration", MENU_URL, "address_mapping.asp", "Setup NAT Rule",0, 0},
  #endif// end of !MULTI_ADDRESS_MAPPING
#endif
  {0, 0, 0, 0, 0, 0}
};
struct RootMenu childmenu_adv[] = {
#ifdef WLAN_SUPPORT
  {"Wireless", MENU_FOLDER, &childmenu_wlanadv, "",   sizeof (childmenu_wlanadv) / sizeof (struct RootMenu) - 1, 0},
#endif
// lhj, delete DNS web
//  {"DNS Server", MENU_URL, "dns.asp", "DNS Server Configuration", 0, 0},
#ifdef CONFIG_USER_DDNS
  {"Dynamic DNS", MENU_URL, "ddns.asp", "DDNS Configuration", 0, 0},
#endif
  {"Bridging", MENU_URL, "bridging.asp", "Bridge Configuration", 0, 0},
  {"Routing", MENU_URL, "routing.asp", "Routing Configuration", 0, 0},
#ifdef CONFIG_USER_IGMPPROXY
  {"IGMP Proxy", MENU_URL, "igmproxy.asp", "IGMP Proxy Configuration", 0, 0},
#endif
#if defined(CONFIG_USER_UPNPD)||defined(CONFIG_USER_MINIUPNPD)
  {"UPnP", MENU_URL, "upnp.asp", "UPnP Configuration", 0, 0},
#endif
#ifdef CONFIG_USER_ROUTED_ROUTED
  {"RIP", MENU_URL, "rip.asp", "RIP Configuration", 0, 0},
#endif
#ifdef CONFIG_USER_SNMPD_SNMPD_V2CTRAP
  {"SNMP", MENU_URL, "snmp.asp", "SNMP Protocol Configuration", 0, 0},
#endif
#if (defined( CONFIG_EXT_SWITCH) && defined(ITF_GROUP)) || defined(CONFIG_RTL867X_COMBO_PORTMAPPING)
  {"Port Mapping", MENU_URL, "eth2pvc.asp", "Assign Ethernet to PVC", 0, 0},
#endif
#ifdef IP_QOS
  {"IP QoS", MENU_URL, "ipqos.asp", "IP QoS Configuration", 0, 0},
#endif
#ifdef CONFIG_EXT_SWITCH
#ifdef ELAN_LINK_MODE
  {"Link Mode", MENU_URL, "lnkmode.asp", "Ethernet Link Mode Setting", 0, 0},
#endif
#else 
#ifdef ELAN_LINK_MODE_INTRENAL_PHY
    {"Link Mode", MENU_URL, "eth.asp", "Ethernet Link Mode Setting", 0, 0},
#endif
#endif
  {"Remote Access", MENU_URL, "rmtacc.asp", "Services Access Control", 0, 0},
  {"ATM Settings", MENU_URL, "wanatm.asp", "Setup ATM", 0, 0},
  {"ADSL Settings", MENU_URL, "/adv/adsl-set.asp", "Setup ADSL", 0, 0},
  {"Others", MENU_URL, "others.asp", "Other advanced Configuration", 0, 0},
  {0, 0, 0, 0, 0, 0}
};
struct RootMenu childmenu_maintainance[] = {
#ifdef FINISH_MAINTENANCE_SUPPORT
  {"Finish Maintenance", MENU_URL, "finishmaintenance.asp",
   "Finish Maintenance", 0, 0},
#endif
//  {"Commit/Reboot", MENU_URL, "reboot.asp", "Commit/reboot the system", 0, 0},
#ifdef CONFIG_SAVE_RESTORE
  {"Backup/Restore", MENU_URL, "saveconf.asp",
   "Backup/restore current settings", 0, 0},
#endif
#ifdef SYSLOG_SUPPORT
#ifndef SEND_LOG
  {"System Log", MENU_URL, "syslog.asp", "Show system log", 0, 0},
#else
  {"System Log", MENU_URL, "syslog_server.asp", "Show system log", 0, 0},
#endif
#endif
#ifdef DOS_SUPPORT
  {"DOS", MENU_URL, "dos.asp", "Denial of service", 0, 0},
#endif
#ifdef ACCOUNT_CONFIG
  {"User Account", MENU_URL, "userconfig.asp", "Setup user account", 0, 0},	// Jenny, user account config page
#else
  {"Password", MENU_URL, "password.asp", "Setup access password", 0, 0},
#endif
#ifdef WEB_UPGRADE
#ifdef UPGRADE_V1
  {"Upgrade Firmware", MENU_URL, "upload.asp", "Update firmware image", 0, 0},
#else
#ifdef UPGRADE_V2
  {"Upgrade Firmware", MENU_URL, "upload2.asp", "Update firmware image", 0,
   0},
#endif // of UPGRADE_V2
#ifdef UPGRADE_V3
  {"Upgrade Firmware", MENU_URL, "upload3.asp", "Update firmware image", 0,
   0},
#endif // of UPGRADE_V3
#endif // of UPGRADE_V1
#endif // of WEB_UPGRADE
#ifdef IP_ACL
 // {"Access Controls (ACL Config)", MENU_URL, "acl.asp", "Access Controls Setting", 0, 0},
  {"Access Controls", MENU_URL, "acl.asp", "Access Controls Setting", 0, 0},
#endif
#ifdef AUTO_PROVISIONING
  {"Auto-Provisionning", MENU_URL, "autoprovision.asp",
   "Auto-Provisioning Configuration", 0, 0},
#endif
#ifdef _CWMP_MIB_
  {"TR-069 Config", MENU_URL, "tr069config.asp", "TR-069 Configuration", 0,
   0},
#endif
//added by xl_yue
#ifdef USE_LOGINWEB_OF_SERVER
  {"Logout", MENU_URL, "/admin/logout.asp", "Logout", 0, 0},
#endif
#ifdef ACCOUNT_LOGIN_CONTROL
  {"Logout", MENU_URL, "adminlogout.asp", "Logout", 0, 0},
#endif
  {0, 0, 0, 0, 0, 0}
};

//add by lhj
struct RootMenu childmenu_maintainance1[] = {
#ifdef FINISH_MAINTENANCE_SUPPORT
  {"Finish Maintenance", MENU_URL, "finishmaintenance.asp",
   "Finish Maintenance", 0, 0},
#endif
//  {"Commit/Reboot", MENU_URL, "reboot.asp", "Commit/reboot the system", 0, 0},
#ifdef CONFIG_SAVE_RESTORE
  {"Backup/Restore", MENU_URL, "saveconf.asp",
   "Backup/restore current settings", 0, 0},
#endif
#ifdef SYSLOG_SUPPORT
#ifndef SEND_LOG
  {"System Log", MENU_URL, "syslog.asp", "Show system log", 0, 0},
#else
  {"System Log", MENU_URL, "syslog_server.asp", "Show system log", 0, 0},
#endif
#endif
#ifdef ACCOUNT_CONFIG
  {"User Account", MENU_URL, "userconfig.asp", "Setup user account", 0, 0},	// Jenny, user account config page
#else
  {"Password", MENU_URL, "password.asp", "Setup access password", 0, 0},
#endif
#ifdef WEB_UPGRADE
#ifdef UPGRADE_V1
  {"Upgrade Firmware", MENU_URL, "upload.asp", "Update firmware image", 0, 0},
#else
#ifdef UPGRADE_V2
  {"Upgrade Firmware", MENU_URL, "upload2.asp", "Update firmware image", 0,
   0},
#endif // of UPGRADE_V2
#ifdef UPGRADE_V3
  {"Upgrade Firmware", MENU_URL, "upload3.asp", "Update firmware image", 0,
   0},
#endif // of UPGRADE_V3
#endif // of UPGRADE_V1
#endif // of WEB_UPGRADE
#ifdef AUTO_PROVISIONING
  {"Auto-Provisionning", MENU_URL, "autoprovision.asp",
   "Auto-Provisioning Configuration", 0, 0},
#endif
//added by xl_yue
#ifdef USE_LOGINWEB_OF_SERVER
  {"Logout", MENU_URL, "/admin/logout.asp", "Logout", 0, 0},
#endif
#ifdef ACCOUNT_LOGIN_CONTROL
  {"Logout", MENU_URL, "adminlogout.asp", "Logout", 0, 0},
#endif
  {0, 0, 0, 0, 0, 0}
};

struct RootMenu childmenu_diag[] = {
  {"Ping", MENU_URL, "ping.asp", "Ping test", 0, 0},
  {"ATM Loopback", MENU_URL, "oamloopback.asp", "ATM OAM loopback test", 0,
   0},
  {"ADSL", MENU_URL, "/adv/adsl-diag.asp", "ADSL Tone Diagnostics", 0, 0},
#ifdef DIAGNOSTIC_TEST
  {"Diagnostic Test", MENU_URL, "diag-test.asp", "Diagnostic test", 0, 0},
#endif
  {0, 0, 0, 0, 0, 0}
};

struct RootMenu childmenu_statis[] = {
  {"DHCP Clients", MENU_URL, "dhcptbl.asp", "Display current DHCP Clients",   0, 0},
  {"Routing Table", MENU_URL, "routetbl.asp", "Display current route table", 0, 0},
  {"ARP Table", MENU_URL, "arptable.asp", "Display current arp table",   0, 0},
  {"Bridge FDB Table", MENU_URL, "fdbtbl.asp", "Display current Bridge Forwarding Database Table",   0, 0},
  {"Interface Statistics", MENU_URL, "stats.asp", "Display packet statistics", 0, 0},
  {"ADSL Statistics", MENU_URL, "/adv/adsl-statis.asp", "Display ADSL statistics", 0, 0},
  {0, 0, 0, 0, 0, 0}
};
#ifdef VOIP_SUPPORT
struct RootMenu childmenu_VoIP[] = {
  {"Port1", MENU_URL, "voip_general.asp?port=0", "Setup VoIP Port 1", 0, 0},
  {"Port2", MENU_URL, "voip_general.asp?port=1", "Setup VoIP Port 2", 0, 0},
  {"FXO", MENU_URL, "voip_general.asp?port=2", "Configure FXO connection", 0, 0},  
  {"Tone", MENU_URL, "voip_tone.asp", "Configure SLIC tones", 0, 0},
  {"Ring", MENU_URL, "voip_ring.asp", "Configure Ring Types of Phone", 0, 0},

  {"Other", MENU_URL, "voip_other.asp", "Other Services", 0, 0},  
  {"Config", MENU_URL, "voip_config.asp", "Configuration Upload/Download", 0, 0},  
  {0, 0, 0, 0, 0, 0}
};
#endif
/*
 *	Root Menu
 */
struct RootMenu rootmenu[] = {
  {"Setup Wizard", MENU_URL, "wiz_multipvc.asp", "Setup Wizard", 0, 0},
  {"Status", MENU_URL, "status.asp", "View the Status", 0, 0},
  {"Setup", MENU_FOLDER, &childmenu_setup, "",
  sizeof (childmenu_setup) / sizeof (struct RootMenu) - 1, 0},
  {"Firewall", MENU_FOLDER, &childmenu_fw, "",
   sizeof (childmenu_fw) / sizeof (struct RootMenu) - 1, 0},
#ifdef VOIP_SUPPORT
  {"VoIP", MENU_FOLDER, &childmenu_VoIP, "",
   sizeof (childmenu_VoIP) / sizeof (struct RootMenu) - 1, 0},
#endif
  {"Advance", MENU_FOLDER, &childmenu_adv, "",
   sizeof (childmenu_adv) / sizeof (struct RootMenu) - 1, 0},
  {"Maintainance", MENU_FOLDER, &childmenu_maintainance, "",
   sizeof (childmenu_maintainance) / sizeof (struct RootMenu) - 1, 0},
  {"Diagnostic", MENU_FOLDER, &childmenu_diag, "",
   sizeof (childmenu_diag) / sizeof (struct RootMenu) - 1, 0},
  {"Monitoring", MENU_FOLDER, &childmenu_statis, "",
   sizeof (childmenu_statis) / sizeof (struct RootMenu) - 1, 0},
   {"Mode", MENU_URL, "mode.asp", "Device Mode", 0, 0},
   {"Reboot", MENU_URL, "reboot.asp", "Commit/reboot the system", 0, 0},
  {0, 0, 0, 0, 0, 0}
};

//add by lhj
//mcj : modem/br mode
struct RootMenu rootmenu1[] = {
  {"Setup Wizard", MENU_URL, "wiz_multipvc.asp", "Setup Wizard", 0, 0},
  {"Status", MENU_URL, "status.asp", "View the Status", 0, 0},
  {"Setup", MENU_FOLDER, &childmenu_setup1, "",
  sizeof (childmenu_setup1) / sizeof (struct RootMenu) - 1, 0},
//  {"Firewall", MENU_FOLDER, &childmenu_fw, "",
//   sizeof (childmenu_fw) / sizeof (struct RootMenu) - 1, 0},
#ifdef VOIP_SUPPORT
  {"VoIP", MENU_FOLDER, &childmenu_VoIP, "",
   sizeof (childmenu_VoIP) / sizeof (struct RootMenu) - 1, 0},
#endif
  {"Maintainance", MENU_FOLDER, &childmenu_maintainance1, "",
   sizeof (childmenu_maintainance1) / sizeof (struct RootMenu) - 1, 0},
  {"Diagnostic", MENU_FOLDER, &childmenu_diag, "",
   sizeof (childmenu_diag) / sizeof (struct RootMenu) - 1, 0},
  {"Monitoring", MENU_FOLDER, &childmenu_statis, "",
   sizeof (childmenu_statis) / sizeof (struct RootMenu) - 1, 0},
  {"Mode", MENU_URL, "mode.asp", "Device Mode", 0, 0},
  {"Reboot", MENU_URL, "reboot.asp", "Commit/reboot the system", 0, 0},
  {0, 0, 0, 0, 0, 0}
};

#endif // of CONFIG_DEFAULT_WEB

/*
 * return: number of menu folders
 */
int
calcFolderNum (struct RootMenu *menu, int *maxchild)
{
  int i;
  int num;
  num = 0;
  while (menu->u.addr)
    {
      if (menu->type == MENU_FOLDER)
	{
	  if (menu->childrennums > *maxchild)
	    *maxchild = menu->childrennums;
	  num++;
	  num += calcFolderNum ((struct RootMenu *) menu->u.addr, maxchild);
	}
      menu++;
    }
  return num;
}
int
addMenu (webs_t wp, struct RootMenu *menu, int layer, int *folder_id,
	 int isMenuEnd)
{
  struct RootMenu *pMenu, *pChild;
  int index;
  int bytes = 0;
  int fid;
  int i;
  unsigned int peol, mask;
  index = 0;
  fid = *folder_id;
  pMenu = menu;
  peol = pMenu->eol;
  // traverse this layer
  while (pMenu->u.addr != 0)
    {
      if (pMenu->type == MENU_FOLDER)
	{
	  if (layer == 0)
	    {
	      bytes +=
		websWrite (wp,
			   T
			   ("<div ID='Main%d' onClick=\"expandMenu('Submenu%d','Btn%d', 0); return false\">\n"
			    "<table border=0 cellpadding=0 cellspacing=0>\n"),
			   *folder_id, *folder_id, *folder_id);
	      bytes += websWrite (wp, T ("<tr>"));
	    }
	  else
	    {
	      bytes +=
		websWrite (wp,
			   T
			   ("<tr ID='Main%d' onClick=\"expandMenu('Submenu%d','Btn%d', %d); return false\">\n"),
			   *folder_id, *folder_id, *folder_id,
			   pMenu->childrennums);
	    }
	  for (i = 0; i < layer; i++)
	    {
	      bytes +=
		websWrite (wp, T ("<td width=18 height=18>%s</td>\n"),
			   (peol & (0x01 << i)) ? "" :
			   "<img src=menu-images/menu_bar.gif width=18 height=18>");
	    }
	  // display DIR
	  bytes +=
	    websWrite (wp,
		       T
		       ("<td width=18 height=18><img src=menu-images/%s width=18 height=18></td>\n"),
		       (pMenu +
			1)->u.addr ? "menu_tee.gif" : "menu_corner.gif");
	  bytes +=
	    websWrite (wp,
		       T
		       ("<td width=18 height=18><img src=menu-images/menu_folder_closed.gif id='Btn%d' width=18 height=18></td>\n"),
		       *folder_id);
	  bytes +=
	    websWrite (wp,
		       T
		       ("<td height=18 colspan=%d><a href=\"\"><span class=\"link\">%s</span></a></td>\n"),
		       3 - layer, pMenu->name);
	  if (layer == 0)
	    bytes += websWrite (wp, T ("</tr>\n</table></div>\n"));
	  else
	    bytes += websWrite (wp, T ("</tr>\n"));
	  // expanding ....
	  bytes +=
	    websWrite (wp,
		       T
		       ("<div ID='Submenu%dChild' style=\"display:none\">\n"),
		       *folder_id);
	  if (layer == 0)
	    bytes +=
	      websWrite (wp,
			 T
			 ("<table border=0 cellpadding=0 cellspacing=0>\n"));
	  //if (layer != 0 || index != 0)
	  *folder_id = *folder_id + 1;
	  pMenu->eol = peol;	// copy the eol history
	  // calculate my eol bit
	  // clear bit
	  mask = 0xffffffff ^ (0x01 << layer);
	  pMenu->eol &= mask;
	  // add bit
	  if ((pMenu + 1)->u.addr == 0)	// It's EoL
	    pMenu->eol |= (0x01 << layer);
	  pChild = (struct RootMenu *) pMenu->u.addr;
	  pChild->eol = pMenu->eol;	// deliver eol to the succeed
	  if ((pMenu + 1)->u.addr)
	    addMenu (wp, pChild, layer + 1, folder_id, 0);
	  else
	    addMenu (wp, pChild, layer + 1, folder_id, 1);
	  if (layer == 0)
	    bytes += websWrite (wp, T ("</table>"));
	  bytes += websWrite (wp, T ("</div>\n"));
	}
      else if (pMenu->type == MENU_URL)
	{
	  if (layer == 0)
	    {
	      bytes += websWrite (wp, T ("<div ID='Menu%dChild'>\n"), index);
	      bytes +=
		websWrite (wp,
			   T
			   ("<table border=0 cellpadding=0 cellspacing=0>\n"));
	      bytes += websWrite (wp, T ("<tr>"));
	    }
	  else
	    {
	      if (layer != 1)
		bytes +=
		  websWrite (wp, T ("<tr ID='Submenu%dChild%d'>\n"), fid - 1,
			     index);
	      else
		bytes += websWrite (wp, T ("<tr>\n"));
	    }
	  for (i = 0; i < layer; i++)
	    {
	      bytes +=
		websWrite (wp, T ("<td width=18 height=18>%s</td>\n"),
			   (peol & (0x01 << i)) ? "" :
			   "<img src=menu-images/menu_bar.gif width=18 height=18>");
	    }
	  // display URL
	  bytes +=
	    websWrite (wp,
		       T
		       ("<td width=18 height=18><img src=menu-images/%s width=18 height=18></td>\n"),
		       (pMenu +
			1)->u.addr ? "menu_tee.gif" : "menu_corner.gif");
	  bytes +=
	    websWrite (wp,
		       T
		       ("<td width=18 height=18><img src=menu-images/menu_link_default.gif width=18 height=18></td>\n"));
	  if (!strcmp(pMenu->name, "Setup Wizard"))
	  {
	  	 bytes +=
	    	websWrite (wp,
		       	T
		       	("<td height=18 colspan=%d><a href=%s target=\"_parent\" class=\"link\"><span title=\"%s\" class=\"link\">%s</span></a></td></tr>\n"),
		       	3 - layer, pMenu->u.url, pMenu->tip, pMenu->name);
	  }
	  else if (!strcmp(pMenu->name, "Reboot"))
	  {
	  	 bytes +=
	    	websWrite (wp,
		       T
		       ("<td height=18 colspan=%d><a href=%s target=\"view\" class=\"link\"><span title=\"%s\" class=\"link\">%s</font></span></a></td></tr>\n"),
		       3 - layer, pMenu->u.url, pMenu->tip, pMenu->name);
         		//<font style=\"FONT-SIZE: 20px\"><b>%s</b> //not large size & bold 
	  }
         else
	  {
	  	 bytes +=
	    	websWrite (wp,
		       T
		       ("<td height=18 colspan=%d><a href=%s target=\"view\" class=\"link\"><span title=\"%s\" class=\"link\">%s</span></a></td></tr>\n"),
		       3 - layer, pMenu->u.url, pMenu->tip, pMenu->name);
	  }
//	  bytes +=
//	    websWrite (wp,
//		       T
//		       ("<td height=18 colspan=%d><a href=%s target=\"_parent\" class=\"link\"><span title=\"%s\" class=\"link\">%s</span></a></td></tr>\n"),
//		       3 - layer, pMenu->u.url, pMenu->tip, pMenu->name);
	  if (layer == 0)
	    bytes += websWrite (wp, T ("</table></div>\n"));
	}
      index++;
      pMenu++;
    }				// of while()
  return bytes;
}
int
addMenuHead (webs_t wp, char *menuname, int index, unsigned char isEnd)
{
  int bytes = 0;
  bytes +=
    websWrite (wp,
	       T
	       ("<div ID='Main%d' onClick=\"expandMenu('Submenu%d','Btn%d','menuChildTable%d'); return false\" >\n"
		"<table  border=0 cellpadding=0 cellspacing=0>\n <tr>\n"
		" <td width=18 height=18><img src=\"menu-images/%s\" width=18 height=18></td>\n"
		" <td width=18 height=18><img src=menu-images/menu_folder_closed.gif id='Btn%d'  width=18 height=18></td>\n"
		"<td  height=18 colspan=3><a href=\"\"><span class=\"link\">%s</span></a></td>\n</tr>\n</table></div>\n"),
	       index, index, index, index,
	       ((isEnd) ? "menu_corner.gif" : "menu_tee.gif"), index,
	       menuname);
  bytes += websWrite (wp, T ("<div ID='Submenu%dChild' class='Child' >\n"
			     "<table   border=0 cellpadding=0 cellspacing=0 style=\"display:none\" id=\"menuChildTable%d\">\n"),
		      index, index);
  return bytes;
}
int
addinMenuHead (webs_t wp, char *menuname, int index, unsigned char nums,
	       unsigned char isChildEnd)
{
  int bytes = 0;
  bytes +=
    websWrite (wp,
	       T
	       ("<tr  ID='Main%d' onClick=\"onlyexpandMenu('Submenu%d','Btn%d','pbtn%d',%d,%d); return false\">\n"
		" <td width=18 height=18><img src=menu-images/menu_bar.gif width=18 height=18></td>\n"),
	       index, index, index, index, nums, isChildEnd);
  bytes +=
    websWrite (wp,
	       T
	       ("<td width=18 height=18><img src=\"menu-images/%s\" width=18 height=18 id='pbtn%d'></td>\n"
		"<td height=18 width=18><img src=menu-images/menu_folder_closed.gif width=18 height=18 id='Btn%d' ></td>\n"
		" <td height=18  colspan=2><span class=\"link\">%s</span></td>\n </tr>\n"),
	       ((isChildEnd) ? "menu_corner_plus.gif" : "menu_tee_plus.gif"),
	       index, index, menuname);
  return bytes;
}
int
addMenuTail (webs_t wp)
{
  return websWrite (wp, T ("</table></div>\n"));
}
int
addChildMenu (webs_t wp, char *menuname, char *url, char *tip,
	      unsigned char isEnd, unsigned char isRootMenuEnd)
{
  return websWrite (wp, T ("<tr><td width=18 height=18>%s</td>\n"
			   "<td width=18 height=18><img src=\"menu-images/%s\" width=18 height=18></td>\n<td width=18 height=18><img src=menu-images/menu_link_default.gif width=18 height=18></td>\n"
			   "<td  height=18 colspan=2><a href=%s target=\"view\" class=\"link\"><span title=\"%s\" class=\"link\">%s</span></a></td></tr>\n"),
		    ((isRootMenuEnd) ? "&nbsp&nbsp" :
		     "<img src=\"menu-images/menu_bar.gif\" width=18 height=18>"),
		    ((isEnd) ? "menu_corner.gif" : "menu_tee.gif"), url, tip,
		    menuname);
}
int
addInChildMenu (webs_t wp, char *menuname, char *url, char *tip, int index,
		int IdIndex, unsigned char isEnd, unsigned char isChildEnd)
{
  int nBytes = 0;
  if (index == 0)
    nBytes +=
      websWrite (wp, T ("<div ID='Submenu%dChild' class='Child'>\n"),
		 IdIndex);
  nBytes =
    websWrite (wp,
	       T ("<tr ID='Submenu%dChild%d' style=\"display:none\">"
		  "<td width=18 height=18><img src=menu-images/menu_bar.gif width=18 height=18></td>\n"
		  "<td width=18 height=18>%s</td>\n"
		  "<td width=18 height=18><img src=menu-images/%s width=18 height=18></td>\n"
		  "<td width=18 height=18><img src=menu-images/menu_link_default.gif width=18 height=18></td>\n"
		  "<td ><a href=%s target=\"view\" class=\"link\"><span title=\"%s\" >%s</span></a></td></tr>\n"),
	       IdIndex, index,
	       ((isChildEnd) ? "&nbsp&nbsp" :
		"<img src=menu-images/menu_bar.gif width=18 height=18>"),
	       ((isEnd) ? "menu_corner.gif" : "menu_tee.gif"), url, tip,
	       menuname);
  if (isEnd)
    websWrite (wp, T ("</div>\n"));
  return nBytes;
}
#else // of WEB_MENU_USE_NEW
// parm: 1 -> javascript support
//       0 -> no js
int
statusMenu (int eid, webs_t wp, int argc, char_t ** argv)
{
  char *parm;
  if (ejArgs (argc, argv, T ("%s"), &parm) < 1)
    {
      websError (wp, 400, T ("Insufficient args\n"));
      return -1;
    }
  if (parm[0] == '1')
    {
      websWrite (wp,
		 T
		 ("menu.addItem(\"Status\", \"/admin/status.asp\", \"\",\"Display current status\");\n"));
    }
  else
    {
      websWrite (wp,
		 T
		 ("<tr><td><a href=\"/admin/status.asp\" target=\"view\">Status</a></td></tr>\n"));
    }
  return 0;
}
int
lanMenu (int eid, webs_t wp, int argc, char_t ** argv)
{
  char *parm;
  if (ejArgs (argc, argv, T ("%s"), &parm) < 1)
    {
      websError (wp, 400, T ("Insufficient args\n"));
      return -1;
    }
  if (parm[0] == '1')
    {
      websWrite (wp,
		 T
		 ("menu.addItem(\"LAN Interface\", \"tcpiplan.asp\", \"\", \"Setup LAN Interface\");\n"));
    }
  else
    {
      websWrite (wp,
		 T
		 ("<tr><td><a href=\"tcpiplan.asp\" target=\"view\">LAN Interface</a></td></tr>\n"));
    }
  return 0;
}
int
wlanMenu (int eid, webs_t wp, int argc, char_t ** argv)
{
#ifdef WLAN_SUPPORT
  char *parm;
  if (ejArgs (argc, argv, T ("%s"), &parm) < 1)
    {
      websError (wp, 400, T ("Insufficient args\n"));
      return -1;
    }
  //if (wlan_is_up()) {
  if (parm[0] == '1')
    {
      websWrite (wp, T ("menu.addItem(\"Wireless\");\n"
			"wlan = new MTMenu();\n"
			"wlan.addItem(\"Basic Settings\", \"/admin/wlbasic.asp\", \"\", \"Setup wireless basic configuration\");\n"
			"wlan.addItem(\"Advanced Settings\", \"/admin/wladvanced.asp\", \"\", \"Setup wireless advanced configuration\");\n"
#ifdef WLAN_MBSSID
			"wlan.addItem(\"Security\", \"/admin/wlwpa_mbssid.asp\", \"\", \"Setup wireless security\");\n"));
#else
			"wlan.addItem(\"Security\", \"/admin/wlwpa.asp\", \"\", \"Setup wireless security\");\n"));
#endif
#ifdef WLAN_ACL
      websWrite (wp,
		 T
		 ("wlan.addItem(\"Access Control\", \"/admin/wlactrl.asp\", \"\", \"Setup access control list for wireless clients\");\n"));
#endif
#ifdef WLAN_WDS
      websWrite (wp,
		 T
		 ("wlan.addItem(\"WDS\", \"/admin/wlwds.asp\", \"\", \"WDS Settings\");\n"));
#endif
#ifdef WLAN_CLIENT
      websWrite (wp,
		 T
		 ("wlan.addItem(\"Site Survey\", \"/admin/wlsurvey.asp\", \"\", \"Wireless Site Survey\");\n"));
#endif
#ifdef CONFIG_WIFI_SIMPLE_CONFIG	//WPS def WLAN_CLIENT
      websWrite (wp,
		 T
		 ("wlan.addItem(\"WPS\", \"/admin/wlwps.asp\", \"\", \"Wireless Protected Setup\");\n"));
#endif
#ifdef WLAN_MBSSID
      websWrite (wp,
		 T
		 ("wlan.addItem(\"MBSSID\", \"/admin/wlmbssid.asp\", \"\", \"Wireless Multiple BSSID Setting\");\n"));
#endif
      websWrite (wp, T ("menu.makeLastSubmenu(wlan);\n"));
    }
  else
    {
      websWrite (wp, T ("<tr><td><b>Wireless</b></td></tr>\n"
			"<tr><td>&nbsp;&nbsp;<a href=\"/admin/wlbasic.asp\" target=\"view\">Basic Settings</a></td></tr>\n"
			"<tr><td>&nbsp;&nbsp;<a href=\"/admin/wladvanced.asp\" target=\"view\">Advanced Settings</a></td></tr>"
#ifdef WLAN_MBSSID
			"<tr><td>&nbsp;&nbsp;<a href=\"/admin/wlwpa_mbssid.asp\" target=\"view\">Security</a></td></tr>\n"));
#else
			"<tr><td>&nbsp;&nbsp;<a href=\"/admin/wlwpa.asp\" target=\"view\">Security</a></td></tr>\n"));
#endif
#ifdef WLAN_ACL
      websWrite (wp,
		 T
		 ("<tr><td>&nbsp;&nbsp;<a href=\"/admin/wlactrl.asp\" target=\"view\">Access Control</a></td></tr>\n"));
#endif
#ifdef WLAN_WDS
      websWrite (wp,
		 T
		 ("<tr><td>&nbsp;&nbsp;<a href=\"/admin/wlwds.asp\" target=\"view\">WDS Settings</a></td></tr>\n"));
#endif
#ifdef WLAN_CLIENT
      websWrite (wp,
		 T
		 ("<tr><td>&nbsp;&nbsp;<a href=\"/admin/wlsurvey.asp\" target=\"view\">Wireless Site Survey</a></td></tr>\n"));
#endif
#ifdef CONFIG_WIFI_SIMPLE_CONFIG	// WPS
      websWrite (wp,
		 T
		 ("<tr><td>&nbsp;&nbsp;<a href=\"/admin/wlwps.asp\" target=\"view\">Wireless Protected Setup</a></td></tr>\n"));
#endif
#ifdef WLAN_MBSSID
      websWrite (wp,
		 T
		 ("<tr><td>&nbsp;&nbsp;<a href=\"/admin/wlmbssid.asp\" target=\"view\">Wireless Multiple BSSID Setting</a></td></tr>\n"));
#endif
    }
  //};
#endif
  return 0;
}
int
wanMenu (int eid, webs_t wp, int argc, char_t ** argv)
{
  char *parm;
  if (ejArgs (argc, argv, T ("%s"), &parm) < 1)
    {
      websError (wp, 400, T ("Insufficient args\n"));
      return -1;
    }
  if (parm[0] == '1')
    {
      websWrite (wp, T ("menu.addItem(\"WAN Interface\");\n"
			"wan = new MTMenu();\n"
			"wan.addItem(\"Channel Config\", \"wanadsl.asp\", \"\", \"Setup Channel Mode\");\n"
			"wan.addItem(\"ATM Settings\", \"wanatm.asp\", \"\", \"Setup ATM\");\n"
			"wan.addItem(\"ADSL Settings\", \"/adv/adsl-set.asp\", \"\", \"Setup ADSL\");\n"
			"menu.makeLastSubmenu(wan);\n"));
    }
  else
    {
      websWrite (wp, T ("<tr><td><b>WAN Interface</b></td></tr>\n"
			"<tr><td>&nbsp;&nbsp;<a href=\"wanadsl.asp\" target=\"view\">Channel Config</a></td></tr>\n"
			"<tr><td>&nbsp;&nbsp;<a href=\"wanatm.asp\" target=\"view\">ATM Settings</a></td></tr>\n"
			"<tr><td>&nbsp;&nbsp;<a href=\"/adv/adsl-set.asp\" target=\"view\">ADSL Settings</a></td></tr>\n"));
    }
  return 0;
}
int
srvMenu (int eid, webs_t wp, int argc, char_t ** argv)
{
  char *parm;
  if (ejArgs (argc, argv, T ("%s"), &parm) < 1)
    {
      websError (wp, 400, T ("Insufficient args\n"));
      return -1;
    }
  if (parm[0] == '1')
    {
      websWrite (wp, T ("menu.addItem(\"Services\");\n"
			"service = new MTMenu();\n"
			"service.addItem(\"DHCP Mode\", \"dhcpmode.asp\", \"\", \"DHCP Mode Configuration\");\n"
			"service.addItem(\"DHCP Server\", \"dhcpd.asp\", \"\", \"DHCP Server Configuration\");\n"
			"service.addItem(\"DHCP Relay\", \"dhcrelay.asp\", \"\", \"DHCP Relay Configuration\");\n"));
      websWrite (wp, T ("service.addItem(\"DNS\");\n"
			"dns = new MTMenu();\n"
			"dns.addItem(\"DNS Server\", \"dns.asp\", \"\", \"DNS Configuration\");\n"
#ifdef CONFIG_USER_DDNS
			"dns.addItem(\"Dynamic DNS\", \"ddns.asp\", \"\", \"DDNS Configuration\");\n"
#endif
			"service.makeLastSubmenu(dns);\n"));
      websWrite (wp, T ("service.addItem(\"Firewall\");\n"
			"firewall = new MTMenu();\n"
			"firewall.addItem(\"IP/Port Filtering\", \"fw-ipportfilter.asp\", \"\", \"Setup IP/Port filering\");\n"
#ifdef MAC_FILTER
			"firewall.addItem(\"MAC Filtering\", \"/admin/fw-macfilter.asp\", \"\", \"Setup MAC filering\");\n"
#endif
			"firewall.addItem(\"Port Forwarding\", \"fw-portfw.asp\", \"\", \"Setup port-forwarding\");\n"));
#ifdef URL_BLOCKING_SUPPORT
      websWrite (wp,
		 T
		 ("firewall.addItem(\"URL Blocking\", \"url_blocking.asp\", \"\", \"URL Blocking Setting\");\n"));
#endif
#ifdef DOMAIN_BLOCKING_SUPPORT
      websWrite (wp,
		 T
		 ("firewall.addItem(\"Domain Blocking\", \"domainblk.asp\", \"\", \"Domain Blocking Setting\");\n"));
#endif
#ifdef NATIP_FORWARDING
      websWrite (wp,
		 T
		 ("firewall.addItem(\"NAT IP Forwarding\", \"fw-ipfw.asp\", \"\", \"Setup NAT IP Mapping\");\n"));
#endif
#ifdef PORT_TRIGGERING
      websWrite (wp,
		 T
		 ("firewall.addItem(\"Port Triggering\", \"gaming.asp\", \"\", \"Setup Port Triggering\");\n"));
#endif
#ifdef NEW_PORT_TRIGGER //add by machuanjun
      websWrite (wp,
		 T
		 ("firewall.addItem(\"Port Triggering\", \"fw-trigger.asp\", \"\", \"Setup Port Triggering\");\n"));
#endif
      websWrite (wp,
		 T
		 ("firewall.addItem(\"DMZ\", \"fw-dmz.asp\", \"\", \"Setup DMZ\");\n"
		  "service.makeLastSubmenu(firewall);\n"
#ifdef CONFIG_USER_IGMPPROXY
		  "service.addItem(\"IGMP Proxy\", \"igmproxy.asp\", \"\", \"IGMP Proxy Configuration\");\n"
#endif
//#ifdef CONFIG_USER_UPNPD
#if defined(CONFIG_USER_UPNPD)||defined(CONFIG_USER_MINIUPNPD)
		  "service.addItem(\"UPnP\", \"upnp.asp\", \"\", \"UPnP Configuration\");\n"
#endif
#ifdef CONFIG_USER_ROUTED_ROUTED
		  "service.addItem(\"RIP\", \"rip.asp\", \"\", \"RIP Configuration\");\n"
#endif
#ifdef WEB_REDIRECT_BY_MAC
		  "service.addItem(\"Landing Page\", \"landong.asp\", \"\", \"Landing Page Configuration\");\n"
#endif
		  "menu.makeLastSubmenu(service);\n"));
      websWrite (wp, T ("menu.makeLastSubmenu(service);\n"));
    }
  else
    {
      websWrite (wp, T ("<tr><td><b>Services</b></td></tr>\n"
			"<tr><td>&nbsp;&nbsp;<a href=\"dhcpmode.asp\" target=\"view\">DHCP Mode</a></td></tr>\n"
			"<tr><td>&nbsp;&nbsp;<a href=\"dhcpd.asp\" target=\"view\">DHCP Server</a></td></tr>\n"
			"<tr><td>&nbsp;&nbsp;<a href=\"dhcrelay.asp\" target=\"view\">DHCP Relay</a></td></tr>\n"
			"<tr><td>&nbsp;&nbsp;<a href=\"dns.asp\" target=\"view\">DNS</a></td></tr>\n"
#ifdef CONFIG_USER_DDNS
			"<tr><td>&nbsp;&nbsp;<a href=\"ddns.asp\" target=\"view\">Dynamic DNS</a></td></tr>\n"
#endif
		 ));
      websWrite (wp, T ("<tr><td>&nbsp;&nbsp;<b>Firewall</b></td></tr>\n"
			"<tr><td>&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"fw-ipportfilter.asp\" target=\"view\">IP/Port Filtering</a></td></tr>\n"
#ifdef MAC_FILTER
			"<tr><td>&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"/admin/fw-macfilter.asp\" target=\"view\">MAC Filtering</a></td></tr>\n"
#endif
			"<tr><td>&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"fw-portfw.asp\" target=\"view\">Port Forwarding</a></td></tr>\n"));
#ifdef URL_BLOCKING_SUPPORT
      websWrite (wp,
		 T
		 ("<tr><td>&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"url_blocking.asp\" target=\"view\">URL Blocking</a></td></tr>\n"));
#endif
#ifdef DOMAIN_BLOCKING_SUPPORT
      websWrite (wp,
		 T
		 ("<tr><td>&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"domainblk.asp\" target=\"view\">Domain Blocking</a></td></tr>\n"));
#endif
#ifdef NATIP_FORWARDING
      websWrite (wp,
		 T
		 ("<tr><td>&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"fw-ipfw.asp\" target=\"view\">NAT IP Forwarding</a></td></tr>\n"));
#endif
#ifdef PORT_TRIGGERING
      websWrite (wp,
		 T
		 ("<tr><td>&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"gaming.asp\" target=\"view\">Port Triggering</a></td></tr>\n"));
#endif
#ifdef NEW_PORT_TRIGGER  //add by machuanjun
      websWrite (wp,
		 T
		 ("<tr><td>&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"fw-trigger.asp\" target=\"view\">Port Triggering</a></td></tr>\n"));
#endif
      websWrite (wp,
		 T
		 ("<tr><td>&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"fw-dmz.asp\" target=\"view\">DMZ</a></td></tr>"
#ifdef CONFIG_USER_IGMPPROXY
		  "<tr><td>&nbsp;&nbsp;<a href=\"igmproxy.asp\" target=\"view\">IGMP Proxy</a></td></tr>"
#endif
//#ifdef CONFIG_USER_UPNPD
#if defined(CONFIG_USER_UPNPD)||defined(CONFIG_USER_MINIUPNPD)
		  "<tr><td>&nbsp;&nbsp;<a href=\"upnp.asp\" target=\"view\">UPnP</a></td></tr>"
#endif
#ifdef CONFIG_USER_ROUTED_ROUTED
		  "<tr><td>&nbsp;&nbsp;<a href=\"rip.asp\" target=\"view\">RIP</a></td></tr>"
#endif
#ifdef WEB_REDIRECT_BY_MAC
		  "<tr><td>&nbsp;&nbsp;<a href=\"landing.asp\" target=\"view\">Landing Page</a></td></tr>"
#endif
		 ));
    }
  return 0;
}
int
advanceMenu (int eid, webs_t wp, int argc, char_t ** argv)
{
  char *parm;
  if (ejArgs (argc, argv, T ("%s"), &parm) < 1)
    {
      websError (wp, 400, T ("Insufficient args\n"));
      return -1;
    }
  if (parm[0] == '1')
    {
      websWrite (wp, T ("menu.addItem(\"Advance\");\n"
			"advance = new MTMenu();\n"
			"advance.addItem(\"ARP table\", \"arptable.asp\", \"\", \"ARP table\");\n"
			"advance.addItem(\"Bridging\", \"bridging.asp\", \"\", \"Bridge Configuration\");\n"
			"advance.addItem(\"Routing\", \"routing.asp\", \"\", \"Routing Configuration\");\n"
#ifdef CONFIG_USER_SNMPD_SNMPD_V2CTRAP
			"advance.addItem(\"SNMP\", \"snmp.asp\", \"\", \"SNMP Protocol Configuration\");\n"
#endif
// Mason Yu. combine_1p_4p_PortMapping
#if (defined( ITF_GROUP_4P) && defined(ITF_GROUP)) || (defined( ITF_GROUP_1P) && defined(ITF_GROUP))
			"advance.addItem(\"Port Mapping\", \"eth2pvc.asp\", \"\", \"Assign Ethernet to PVC\");\n"
#endif
#ifdef IP_QOS
			"advance.addItem(\"IP QoS\", \"ipqos.asp\", \"\", \"IP QoS Configuration\");\n"
#elif defined(NEW_IP_QOS_SUPPORT)
			"advance.addItem(\"IP QoS\", \"ipqos_sc.asp\", \"\", \"IP QoS Configuration\");\n"
#endif
#ifdef CONFIG_EXT_SWITCH
#ifdef ELAN_LINK_MODE
			"advance.addItem(\"Link Mode\", \"lnkmode.asp\", \"\", \"Ethernet Link Mode Setting\");\n"
#endif
#endif
			"advance.addItem(\"Remote Access\", \"rmtacc.asp\", \"\", \"Services Access Control\");\n"
			"advance.addItem(\"Others\", \"others.asp\", \"\", \"Other advanced Configuration\");\n"
			"menu.makeLastSubmenu(advance);\n"));
    }
  else
    {
      websWrite (wp, T ("<tr><td><b>Advance</b></td></tr>\n"
			"<tr><td>&nbsp;&nbsp;<a href=\"arptable.asp\" target=\"view\">ARP Table</a></td></tr>\n"
			"<tr><td>&nbsp;&nbsp;<a href=\"bridging.asp\" target=\"view\">Bridging</a></td></tr>\n"
			"<tr><td>&nbsp;&nbsp;<a href=\"routing.asp\" target=\"view\">Routing</a></td></tr>\n"
#ifdef CONFIG_USER_SNMPD_SNMPD_V2CTRAP
			"<tr><td>&nbsp;&nbsp;<a href=\"snmp.asp\" target=\"view\">SNMP</a></td></tr>\n"
#endif
// Mason Yu. combine_1p_4p_PortMapping
#if (defined( ITF_GROUP_4P) && defined(ITF_GROUP)) || (defined( ITF_GROUP_1P) && defined(ITF_GROUP))
			"<tr><td>&nbsp;&nbsp;<a href=\"eth2pvc.asp\" target=\"view\">Port Mapping</a></td></tr>\n"
#endif
#ifdef IP_QOS
			"<tr><td>&nbsp;&nbsp;<a href=\"ipqos.asp\" target=\"view\">IP QoS</a></td></tr>\n"
#elif defined(NEW_IP_QOS_SUPPORT)
			"<tr><td>&nbsp;&nbsp;<a href=\"ipqos_sc.asp\" target=\"view\">IP QoS</a></td></tr>\n"
#endif
#ifdef CONFIG_EXT_SWITCH
#ifdef ELAN_LINK_MODE
			"<tr><td>&nbsp;&nbsp;<a href=\"lnkmode.asp\" target=\"view\">Link Mode</a></td></tr>\n"
#endif
#endif
			"<tr><td>&nbsp;&nbsp;<a href=\"rmtacc.asp\" target=\"view\">Remote Access</a></td></tr>\n"
			"<tr><td>&nbsp;&nbsp;<a href=\"others.asp\" target=\"view\">Others</a></td></tr>\n"));
    }
  return 0;
}
int
diagMenu (int eid, webs_t wp, int argc, char_t ** argv)
{
  char *parm;
  if (ejArgs (argc, argv, T ("%s"), &parm) < 1)
    {
      websError (wp, 400, T ("Insufficient args\n"));
      return -1;
    }
  if (parm[0] == '1')
    {
      websWrite (wp, T ("menu.addItem(\"Diagnostic\");\n"
			"diag = new MTMenu();\n"
			"diag.addItem(\"Ping\", \"ping.asp\", \"\", \"Ping test\");\n"
			"diag.addItem(\"ATM Loopback\", \"oamloopback.asp\", \"\", \"ATM OAM loopback test\");\n"
			"diag.addItem(\"ADSL\", \"/adv/adsl-diag.asp\", \"\", \"ADSL Tone Diagnostics\");\n"
#ifdef DIAGNOSTIC_TEST
			"diag.addItem(\"Diagnostic Test\", \"diag-test.asp\", \"\", \"Diagnostic test\");\n"
#endif
		 ));
      websWrite (wp, T ("menu.makeLastSubmenu(diag);\n"));
    }
  else
    {
      websWrite (wp, T ("<tr><td><b>Diagnostic</b></td></tr>\n"
			"<tr><td>&nbsp;&nbsp;<a href=\"ping.asp\" target=\"view\">Ping</a></td></tr>\n"
			"<tr><td>&nbsp;&nbsp;<a href=\"oamloopback.asp\" target=\"view\">ATM Loopback</a></td></tr>\n"
			"<tr><td>&nbsp;&nbsp;<a href=\"/adv/adsl-diag.asp\" target=\"view\">ADSL</a></td></tr>\n"
#ifdef DIAGNOSTIC_TEST
			"<tr><td>&nbsp;&nbsp;<a href=\"diag-test.asp\" target=\"view\">Diagnostic Test</a></td></tr>\n"
#endif
		 ));
    }
  return 0;
}
int
adminMenu (int eid, webs_t wp, int argc, char_t ** argv)
{
  char *parm;
  if (ejArgs (argc, argv, T ("%s"), &parm) < 1)
    {
      websError (wp, 400, T ("Insufficient args\n"));
      return -1;
    }
  if (parm[0] == '1')
    {
      websWrite (wp, T ("menu.addItem(\"Admin\");\n" "admin = new MTMenu();\n"
#ifdef FINISH_MAINTENANCE_SUPPORT
			//added by xl_yue
			"admin.addItem(\"Finish Maintenance\", \"/finishmaintenance.asp\", \"\", \"Finish Maintenance\");\n"
#endif
			"admin.addItem(\"Commit/Reboot\", \"/admin/reboot.asp\", \"\", \"Commit/reboot the system\");\n"
#ifdef CONFIG_SAVE_RESTORE
			"admin.addItem(\"Backup/Restore\", \"/admin/saveconf.asp\", \"\", \"Backup/restore current settings\");\n"
#endif
#ifdef ACCOUNT_LOGIN_CONTROL
			//added by xl_yue
			"admin.addItem(\"Logout\", \"/admin/adminlogout.asp\", \"\", \"Logout\");\n"
#endif
#ifdef SYSLOG_SUPPORT
#ifndef SEND_LOG
			"admin.addItem(\"System Log\", \"syslog.asp\", \"\", \"Show system log\");\n"
#else
			"admin.addItem(\"System Log\", \"syslog_server.asp\", \"\", \"Show system log\");\n"
#endif
#endif
#ifdef DOS_SUPPORT
			"admin.addItem(\"DOS\", \"dos.asp\", \"\", \"Denial of service\");\n"
#endif
			"admin.addItem(\"Password\", \"password.asp\", \"\", \"Setup access password\");\n"));
      websWrite (wp, T (
#ifdef WEB_UPGRADE
#ifdef UPGRADE_V1
			 "admin.addItem(\"Upgrade Firmware\", \"/admin/upload.asp\", \"\", \"Update firmware image\");\n"
#else
#ifdef UPGRADE_V2
			 "admin.addItem(\"Upgrade Firmware\", \"/admin/upload2.asp\", \"\", \"Update firmware image\");\n"
#endif // of UPGRADE_V2
#ifdef UPGRADE_V3
			 "admin.addItem(\"Upgrade Firmware\", \"/admin/upload3.asp\", \"\", \"Update firmware image\");\n"
#endif // of UPGRADE_V3
#endif // of UPGRADE_V1
#endif // of WEB_UPGRADE
			 /*
			    "admin.addItem(\"Remote Config\", \"rconfig.asp\", \"\", \"Remote configuration from WAN side\");\n"
			  */
#ifdef IP_ACL
			 "admin.addItem(\"ACL Config\", \"/admin/acl.asp\", \"\", \"ACL Setting\");\n"
#endif
#ifdef TIME_ZONE
			 "admin.addItem(\"Time Zone\", \"ntp.asp\", \"\", \"Setup Time Zone\");\n"
#endif
#ifdef AUTO_PROVISIONING
			 "admin.addItem(\"Auto-Provisionning\", \"autoprovision.asp\", \"\", \"Auto-Provisioning Configuration\");\n"
#endif
#ifdef _CWMP_MIB_
			 "admin.addItem(\"TR-069 Config\", \"tr069config.asp\", \"\", \"TR-069 Configuration\");\n"
#endif
//added by xl_yue
#ifdef USE_LOGINWEB_OF_SERVER
//                      "admin.addItem(\"Login\", \"/admin/login.asp\", \"\", \"Login\");\n"
			 "admin.addItem(\"Logout\", \"/admin/logout.asp\", \"\", \"Logout\");\n"
#endif
		 ));
      websWrite (wp, T ("menu.makeLastSubmenu(admin);\n"));
    }
  else
    {
      websWrite (wp, T ("<tr><td><b>Admin</b></td></tr>\n"
#ifdef FINISH_MAINTENANCE_SUPPORT
			//added by xl_yue
			"<tr><td>&nbsp;&nbsp;<a href=\"/finishmaintenance.asp\" target=\"view\">Finish Maintenance</a></td></tr>\n"
#endif
			"<tr><td>&nbsp;&nbsp;<a href=\"/admin/reboot.asp\" target=\"view\">Commit/Reboot</a></td></tr>\n"
			"<tr><td>&nbsp;&nbsp;<a href=\"/admin/saveconf.asp\" target=\"view\">Backup/Restore</a></td></tr>\n"
#ifdef ACCOUNT_LOGIN_CONTROL
			//added by xl_yue
			"<tr><td>&nbsp;&nbsp;<a href=\"/admin/adminlogout.asp\" target=\"view\">Logout</a></td></tr>\n"
#endif
#ifdef SYSLOG_SUPPORT
#ifndef
			"<tr><td>&nbsp;&nbsp;<a href=\"/admin/syslog.asp\" target=\"view\">System log</a></td></tr>\n"
#else
			"<tr><td>&nbsp;&nbsp;<a href=\"/admin/syslog_server.asp\" target=\"view\">System log</a></td></tr>\n"
#endif
#endif
#ifdef DOS_SUPPORT
			"<tr><td>&nbsp;&nbsp;<a href=\"/admin/dos.asp\" target=\"view\">DOS</a></td></tr>\n"
#endif
			"<tr><td>&nbsp;&nbsp;<a href=\"password.asp\" target=\"view\">Password</a></td></tr>\n"));
      websWrite (wp, T (
#ifdef WEB_UPGRADE
#ifdef UPGRADE_V1
			 "<tr><td>&nbsp;&nbsp;<a href=\"/admin/upload.asp\" target=\"view\">Upgrade Firmware</a></td></tr>\n"
#else
#ifdef UPGRADE_V2
			 "<tr><td>&nbsp;&nbsp;<a href=\"/admin/upload2.asp\" target=\"view\">Upgrade Firmware</a></td></tr>\n"
#endif // of UPGRADE_V2
#ifdef UPGRADE_V3
			 "<tr><td>&nbsp;&nbsp;<a href=\"/admin/upload3.asp\" target=\"view\">Upgrade Firmware</a></td></tr>\n"
#endif // of UPGRADE_V3
#endif // of UPGRADE_V1
#endif // of WEB_UPGRADE
/*
			"<tr><td>&nbsp;&nbsp;<a href=\"rconfig.asp\" target=\"view\">Remote Config</a></td></tr>\n"
*/
#ifdef IP_ACL
			 "<tr><td>&nbsp;&nbsp;<a href=\"/admin/acl.asp\" target=\"view\">ACL Config</a></td></tr>\n"
#endif
#ifdef TIME_ZONE
			 "<tr><td>&nbsp;&nbsp;<a href=\"ntp.asp\" target=\"view\">Time Zone Setting</a></td></tr>\n"
#endif
#ifdef AUTO_PROVISIONING
			 "<tr><td>&nbsp;&nbsp;<a href=\"autoprovision.asp\" target=\"view\">Auto-Provisioning Configuration</a></td></tr>\n"
#endif
#ifdef _CWMP_MIB_
			 "<tr><td>&nbsp;&nbsp;<a href=\"tr069config.asp\" target=\"view\">TR-069 Config</a></td></tr>\n"
#endif
//added by xl_yue
#ifdef USE_LOGINWEB_OF_SERVER
//                      "<tr><td>&nbsp;&nbsp;<a href=\"/admin/login.asp\" target=\"view\">Login</a></td></tr>\n"
			 "<tr><td>&nbsp;&nbsp;<a href=\"/admin/logout.asp\" target=\"view\">Logout</a></td></tr>\n"
#endif
		 ));
    }
  return 0;
}
int
statisticsMenu (int eid, webs_t wp, int argc, char_t ** argv)
{
  char *parm;
  if (ejArgs (argc, argv, T ("%s"), &parm) < 1)
    {
      websError (wp, 400, T ("Insufficient args\n"));
      return -1;
    }
  if (parm[0] == '1')
    {
      websWrite (wp, T ("menu.addItem(\"Statistics\");\n"
			"statis = new MTMenu();\n"
			"statis.addItem(\"Interfaces\", \"stats.asp\", \"\", \"Display packet statistics\");\n"
			"statis.addItem(\"ADSL\", \"/adv/adsl-statis.asp\", \"\", \"Display ADSL statistics\");\n"
			"menu.makeLastSubmenu(statis);\n"));
    }
  else
    {
      websWrite (wp, T ("<tr><td><b>Statistics</b></td></tr>\n"
			"<tr><td>&nbsp;&nbsp;<a href=\"stats.asp\" target=\"view\">Interfaces</a></td></tr>\n"
			"<tr><td>&nbsp;&nbsp;<a href=\"/adv/adsl-statis.asp\" target=\"view\">ADSL</a></td></tr>\n"));
    }
  return 0;
}
#endif // of WEB_MENU_USE_NEW
int
createMenu (int eid, webs_t wp, int argc, char_t ** argv)
{
#ifdef WEB_MENU_USE_NEW
  int i = 0, totalIdNums = 0, maxchildrensize = 0;
  int IdIndex = 0;
  unsigned char isRootMenuEnd = 0;
  //calc the id nums and the max children size
  //add by lhj
  unsigned char deviceMode;
 mib_get(MIB_DEVICE_MODE, (void *)&deviceMode);
//mcj
	
  if (deviceMode != '0')
    totalIdNums = calcFolderNum (rootmenu, &maxchildrensize);
  else
    totalIdNums = calcFolderNum (rootmenu1, &maxchildrensize);
    
  //product the js code
  addMenuJavaScript (wp, totalIdNums, maxchildrensize);
  //create the header
// <<<[stevechang]<+81204>
  websWrite (wp, T ("<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\n"));
// >>>[stevechang]<+81204>
// <<<[stevechang]<*81204>
  websWrite (wp, T("<body onload=\"initIt()\" bgcolor=\"#4b688b\">\n"));
  websWrite (wp, T("<table width=100%% border=0 cellpadding=5 cellspacing=2>\n<tr><td  width=100%% align=left>\n"));
  websWrite (wp, T("<table  border=0 cellpadding=0 cellspacing=0>\n"
  		"<tr><td width=18 height=18><img src=menu-images/menu_root.gif width=18 height=18></td>\n"
  		"<td  height=18 colspan=4 class=link><b>TEW-436BRM</b></td></tr>\n </table>\n"));	     
	     
  //websWrite (wp, T ("<body  onload=\"initIt()\" bgcolor=\"#000000\" >\n"));
  //websWrite (wp,
	     //T("<table width=100%% border=0 cellpadding=0 cellspacing=0>\n<tr><td  width=100%% align=left>\n"));
  //websWrite (wp, T ("<table  border=0 cellpadding=0 cellspacing=0>\n"
		    //"<tr><td width=18 height=18><img src=menu-images/menu_root.gif width=18 height=18></td>\n"
		    //"<td  height=18 colspan=4 class=link><font size=3>%s</font></td></tr>\n </table>\n"),
	     //menuTitle);
  if (deviceMode != '0')
  {
  if (rootmenu[1].u.addr)
    addMenu (wp, &rootmenu[0], 0, &IdIndex, 0);
  else
    addMenu (wp, &rootmenu[0], 0, &IdIndex, 1);
  }
  else
  {
    if (rootmenu[1].u.addr)
        addMenu (wp, &rootmenu1[0], 0, &IdIndex, 0);
    else
        addMenu (wp, &rootmenu1[0], 0, &IdIndex, 1);
  }
  websWrite (wp, T ("</td></tr>\n</table>\n"));
#else
  statusMenu (eid, wp, argc, argv);
  lanMenu (eid, wp, argc, argv);
  wlanMenu (eid, wp, argc, argv);
  wanMenu (eid, wp, argc, argv);
  srvMenu (eid, wp, argc, argv);
  advanceMenu (eid, wp, argc, argv);
  diagMenu (eid, wp, argc, argv);
  adminMenu (eid, wp, argc, argv);
  statisticsMenu (eid, wp, argc, argv);
#endif
  return 0;
}
