/*

*  fmmenucreate_user.c is used to create menu

*  added by xl_yue

*/





#include <string.h>

#include <stdlib.h>

#include <unistd.h>

#include <sys/types.h>

#include <sys/wait.h>



#include "../webs.h"

#include "mib.h"

#include "webform.h"

#include "utility.h"



#ifdef WEB_MENU_USE_NEW

const char menuTitle_user[] = "Site contents:";


#ifdef CONFIG_DEFAULT_WEB_REALTEK	// default pages



/*

 *	First Layer Menu

 */

struct RootMenu childmenu_wlan_user[] = {

	{"Basic Settings", MENU_URL, "wlbasic.asp", "Setup wireless basic configuration", 0, 0},

	{"Advanced Settings", MENU_URL, "wladvanced.asp", "Setup wireless advanced configuration", 0, 0},

#ifdef WLAN_MBSSID

	{"Security", MENU_URL, "wlwpa_mbssid.asp", "Setup wireless security", 0, 0},

#else

	{"Security", MENU_URL, "wlwpa.asp", "Setup wireless security", 0, 0},

#endif

#ifdef WLAN_ACL

	{"Access Control", MENU_URL, "wlactrl.asp", "Setup access control list for wireless clients", 0, 0},

#endif

#ifdef WLAN_WDS

	{"WDS", MENU_URL, "wlwds.asp", "WDS Settings", 0, 0},

#endif

#ifdef WLAN_CLIENT

	{"Site Survey", "wlsurvey.asp", "Wireless Site Survey", 0, 0},

#endif

#ifdef CONFIG_WIFI_SIMPLE_CONFIG	// WPS

	{"WPS", MENU_URL, "wlwps.asp", "Wireless Protected Setup", 0, 0},

#endif

#ifdef WLAN_MBSSID

	{"MBSSID", MENU_URL, "wlmbssid.asp", "Wireless Multiple BSSID Setting", 0, 0},

#endif

	{0, 0, 0, 0, 0, 0}

};



struct RootMenu childmenu_wan_user[] = {

	{"Channel Config", MENU_URL, "wanadsl_user.asp", "Setup Channel Mode", 0, 0},

#ifdef CONFIG_USER_PPPOMODEM
	{"3G Settings", MENU_URL, "wan3gconf.asp", "Setup 3G WAN", 0, 0},
#endif //CONFIG_USER_PPPOMODEM

	{0, 0, 0, 0, 0, 0}

};



struct RootMenu childmenu_fw_user[] = {

#ifdef MAC_FILTER

	{"MAC Filtering", MENU_URL, "fw-macfilter.asp", "Setup MAC filering", 0, 0},

#endif

	{0, 0, 0, 0, 0, 0}

};



struct RootMenu childmenu_admin_user[] = {

	{"Commit/Reboot", MENU_URL, "reboot.asp", "Commit/reboot the system", 0, 0},

#ifdef ACCOUNT_LOGIN_CONTROL

	{"Logout", MENU_URL, "adminlogout.asp", "Logout", 0, 0},

#endif

	{"Password", MENU_URL, "user-password.asp", "Setup access password", 0, 0},

#ifdef IP_ACL

	{"ACL Config", MENU_URL, "acl.asp", "ACL Setting", 0, 0},

#endif

//added by xl_yue

#ifdef USE_LOGINWEB_OF_SERVER

	{"Logout", MENU_URL, "/admin/logout.asp", "Logout", 0, 0},

#endif

	{0, 0, 0, 0, 0, 0}

};



/*

 *	Root Menu

 */

struct RootMenu rootmenu_user[] = {

	{"Status", MENU_URL, "status.asp", "Display Current Status", 0, 0},

#ifdef WLAN_SUPPORT

	{"Wireless", MENU_FOLDER, &childmenu_wlan_user, "", sizeof(childmenu_wlan_user) / sizeof(struct RootMenu) - 1, 0},

#endif

	{"WAN", MENU_FOLDER, &childmenu_wan_user, "", sizeof(childmenu_wan_user) / sizeof(struct RootMenu) - 1, 0},

	{"Firewall", MENU_FOLDER, &childmenu_fw_user, "", sizeof(childmenu_fw_user) / sizeof(struct RootMenu) - 1, 0},

	{"Admin", MENU_FOLDER, &childmenu_admin_user, "", sizeof(childmenu_admin_user) / sizeof(struct RootMenu) - 1, 0},

	{0, 0, 0, 0, 0, 0}

};

#endif				// of CONFIG_DEFAULT_WEB_REALTEK



//add by lhj
#ifdef CONFIG_DEFAULT_WEB	// default pages



/*

 *	First Layer Menu

 */

/*
 *	2nd Layer Menu
 */
 
struct RootMenu childmenu_wlan_user[] = { //adam
  {"Basic Settings", MENU_URL, "user-wlbasic.asp",   "Setup wireless basic configuration", 0, 0},
#ifdef WLAN_MBSSID
  {"Security", MENU_URL, "user-wlwpa_mbssid.asp", "Setup wireless security", 0, 0},
#else
  {"Security", MENU_URL, "wlwpa.asp", "Setup wireless security", 0, 0},
#endif
#ifdef CONFIG_WIFI_SIMPLE_CONFIG	// WPS
  {"WPS", MENU_URL, "user-wlwps.asp", "Wireless Protected Setup", 0, 0},
#endif
  {0, 0, 0, 0, 0, 0}
};

struct RootMenu childmenu_wlanadv_user[] = {
 {"Advanced Settings", MENU_URL, "user-wladvanced.asp",   "Setup wireless advanced configuration", 0, 0},
#ifdef WLAN_ACL
  {"Access Control", MENU_URL, "user-wlactrl.asp",   "Setup access control list for wireless clients", 0, 0},
#endif
#ifdef WLAN_WDS
  {"WDS", MENU_URL, "wlwds.asp", "WDS Settings", 0, 0},
#endif
#ifdef WLAN_CLIENT
  {"Site Survey", "wlsurvey.asp", "Wireless Site Survey", 0, 0},
#endif
#ifdef WLAN_MBSSID
  {"MBSSID", MENU_URL, "user-wlmbssid.asp", "Wireless Multiple BSSID Setting", 0,   0},
#endif
  {0, 0, 0, 0, 0, 0}
};

/*
 *	First Layer Menu
 */
 
struct RootMenu childmenu_setup_user[] = {
//  {"Internet Setup (Channel Config)", MENU_URL, "wanadsl_user.asp", "Setup Channel Mode", 0, 0},
  {"Internet Setup", MENU_URL, "user-wanadsl.asp", "Setup Channel Mode", 0, 0}, //adam
#ifdef WLAN_SUPPORT
  {"Wireless", MENU_FOLDER, &childmenu_wlan_user, "",   sizeof (childmenu_wlan_user) / sizeof (struct RootMenu) - 1, 0},
#endif
  {0, 0, 0, 0, 0, 0}
};

struct RootMenu childmenu_fw_user[] = {
#ifdef MAC_FILTER
	{"MAC Filtering", MENU_URL, "user-fw-macfilter.asp", "Setup MAC filering", 0, 0},
#endif
	{0, 0, 0, 0, 0, 0}
};

struct RootMenu childmenu_adv_user[] = {
#ifdef WLAN_SUPPORT
  {"Wireless", MENU_FOLDER, &childmenu_wlanadv_user, "",   sizeof (childmenu_wlanadv_user) / sizeof (struct RootMenu) - 1, 0},
#endif
  {0, 0, 0, 0, 0, 0}
};
struct RootMenu childmenu_maintainance_user[] = {
  //{"Commit/Reboot", MENU_URL, "reboot.asp", "Commit/reboot the system", 0, 0},
  {"Password", MENU_URL, "user-password.asp", "Setup access password", 0, 0},
#ifdef IP_ACL
  {"Access Controls", MENU_URL, "user-acl.asp", "Access Controls Setting", 0, 0}, //adam
//  {"Access Controls (ACL Config)", MENU_URL, "acl.asp", "Access Controls Setting", 0, 0},
#endif
#ifdef ACCOUNT_LOGIN_CONTROL
  {"Logout", MENU_URL, "/admin/userlogout.asp", "Logout", 0, 0},
#endif
  {0, 0, 0, 0, 0, 0}
};

/*
 *	Root Menu
 */
struct RootMenu rootmenu_user[] = {
  {"Status", MENU_URL, "status.asp", "View the Status", 0, 0},
  {"Setup", MENU_FOLDER, &childmenu_setup_user, "",
  sizeof (childmenu_setup_user) / sizeof (struct RootMenu) - 1, 0},
  {"Firewall", MENU_FOLDER, &childmenu_fw_user, "",
   sizeof (childmenu_fw_user) / sizeof (struct RootMenu) - 1, 0},
  {"Advance", MENU_FOLDER, &childmenu_adv_user, "",
   sizeof (childmenu_adv_user) / sizeof (struct RootMenu) - 1, 0},
  {"Maintainance", MENU_FOLDER, &childmenu_maintainance_user, "",
   sizeof (childmenu_maintainance_user) / sizeof (struct RootMenu) - 1, 0},
  {0, 0, 0, 0, 0, 0}
};

#endif				// of CONFIG_DEFAULT_WEB

#else				// of of WEB_MENU_USE_NEW



// parm: 1 -> javascript support

//       0 -> no js

int statusMenu_user(int eid, webs_t wp, int argc, char_t ** argv)
{

	char *parm;



	if (ejArgs(argc, argv, T("%s"), &parm) < 1)
	  {

		  websError(wp, 400, T("Insufficient args\n"));

		  return -1;

	  }



	if (parm[0] == '1')
	  {

		  websWrite(wp, T("menu.addItem(\"Status\", \"status.asp\", \"\", \"Display current status\");"));

	  }

	else
	  {

		  websWrite(wp, T("<tr><td><a href=\"status.asp\" target=\"view\">Status</a></td></tr>\n"));

	  }



	return 0;

}

/*

int lanMenu_user(int eid, webs_t wp, int argc, char_t **argv)

{

	char *parm;

	

	if (ejArgs(argc, argv, T("%s"), &parm) < 1) {

		websError(wp, 400, T("Insufficient args\n"));

		return -1;

	}

	

	if ( parm[0] == '1' ) {

		websWrite(wp, T("menu.addItem(\"LAN Interface\", \"tcpiplan.asp\", \"\", \"Setup LAN Interface\");"));

	}

	else {

		websWrite(wp, T("<tr><td><a href=\"tcpiplan.asp\" target=\"view\">LAN Interface</a></td></tr>\n"));

	}



	return 0;

}

*/

int wlanMenu_user(int eid, webs_t wp, int argc, char_t ** argv)
{

#ifdef WLAN_SUPPORT

	char *parm;



	if (ejArgs(argc, argv, T("%s"), &parm) < 1)
	  {

		  websError(wp, 400, T("Insufficient args\n"));

		  return -1;

	  }


	//if (wlan_is_up()) {

	if (parm[0] == '1')
	  {

		  websWrite(wp, T("menu.addItem(\"Wireless\");" "wlan = new MTMenu();" "wlan.addItem(\"Basic Settings\", \"/admin/wlbasic.asp\", \"\", \"Setup wireless basic configuration\");" "wlan.addItem(\"Advanced Settings\", \"/admin/wladvanced.asp\", \"\", \"Setup wireless advanced configuration\");"
#ifdef WLAN_MBSSID
				  "wlan.addItem(\"Security\", \"/admin/wlwpa_mbssid.asp\", \"\", \"Setup wireless security\");"));

#else
				  "wlan.addItem(\"Security\", \"/admin/wlwpa.asp\", \"\", \"Setup wireless security\");"));

#endif



#ifdef WLAN_ACL

		  websWrite(wp, T("wlan.addItem(\"Access Control\", \"/admin/wlactrl.asp\", \"\", \"Setup access control list for wireless clients\");"));

#endif

#ifdef WLAN_WDS

		  websWrite(wp, T("wlan.addItem(\"WDS\", \"/admin/wlwds.asp\", \"\", \"WDS Settings\");"));

#endif

#ifdef WLAN_CLIENT

		  websWrite(wp, T("wlan.addItem(\"Site Survey\", \"/admin/wlsurvey.asp\", \"\", \"Wireless Site Survey\");"));

#endif



#ifdef CONFIG_WIFI_SIMPLE_CONFIG	//WPS def WLAN_CLIENT

		  websWrite(wp, T("wlan.addItem(\"WPS\", \"/admin/wlwps.asp\", \"\", \"Wireless Protected Setup\");"));

#endif



#ifdef WLAN_MBSSID

		  websWrite(wp, T("wlan.addItem(\"MBSSID\", \"/admin/wlmbssid.asp\", \"\", \"Wireless Multiple BSSID Setting\");"));

#endif



		  websWrite(wp, T("menu.makeLastSubmenu(wlan);"));

	  }

	else
	  {



		  websWrite(wp, T("<tr><td><b>Wireless</b></td></tr>\n" "<tr><td>&nbsp;&nbsp;<a href=\"/admin/wlbasic.asp\" target=\"view\">Basic Settings</a></td></tr>\n" "<tr><td>&nbsp;&nbsp;<a href=\"/admin/wladvanced.asp\" target=\"view\">Advanced Settings</a></td></tr>"
#ifdef WLAN_MBSSID
				  "<tr><td>&nbsp;&nbsp;<a href=\"/admin/wlwpa_mbssid.asp\" target=\"view\">Security</a></td></tr>\n"));

#else
				  "<tr><td>&nbsp;&nbsp;<a href=\"/admin/wlwpa.asp\" target=\"view\">Security</a></td></tr>\n"));

#endif



#ifdef WLAN_ACL

		  websWrite(wp, T("<tr><td>&nbsp;&nbsp;<a href=\"/admin/wlactrl.asp\" target=\"view\">Access Control</a></td></tr>\n"));

#endif

#ifdef WLAN_WDS

		  websWrite(wp, T("<tr><td>&nbsp;&nbsp;<a href=\"/admin/wlwds.asp\" target=\"view\">WDS Settings</a></td></tr>\n"));

#endif

#ifdef WLAN_CLIENT

		  websWrite(wp, T("<tr><td>&nbsp;&nbsp;<a href=\"/admin/wlsurvey.asp\" target=\"view\">Wireless Site Survey</a></td></tr>\n"));

#endif



#ifdef CONFIG_WIFI_SIMPLE_CONFIG	// WPS

		  websWrite(wp, T("<tr><td>&nbsp;&nbsp;<a href=\"/admin/wlwps.asp\" target=\"view\">Wireless Protected Setup</a></td></tr>\n"));

#endif

#ifdef WLAN_MBSSID

		  websWrite(wp, T("<tr><td>&nbsp;&nbsp;<a href=\"/admin/wlmbssid.asp\" target=\"view\">Wireless Multiple BSSID Setting</a></td></tr>\n"));

#endif

	  }

	//};

#endif

	return 0;

}



int wanMenu_user(int eid, webs_t wp, int argc, char_t ** argv)
{

	char *parm;



	if (ejArgs(argc, argv, T("%s"), &parm) < 1)
	  {

		  websError(wp, 400, T("Insufficient args\n"));

		  return -1;

	  }



	if (parm[0] == '1')
	  {

		  websWrite(wp, T("menu.addItem(\"WAN Interface\");" "wan = new MTMenu();" "wan.addItem(\"Channel Config\", \"wanadsl_user.asp\", \"\", \"Setup Channel Mode\");" "menu.makeLastSubmenu(wan);"));

	  }

	else
	  {

		  websWrite(wp, T("<tr><td><b>WAN Interface</b></td></tr>\n" "<tr><td>&nbsp;&nbsp;<a href=\"wanadsl_user.asp\" target=\"view\">Channel Config</a></td></tr>\n"));

	  }



	return 0;

}



int firewallMenu_user(int eid, webs_t wp, int argc, char_t ** argv)
{

	char *parm;



	if (ejArgs(argc, argv, T("%s"), &parm) < 1)
	  {

		  websError(wp, 400, T("Insufficient args\n"));

		  return -1;

	  }



	if (parm[0] == '1')
	  {

		  websWrite(wp, T("menu.addItem(\"Firewall\");" "service = new MTMenu();" "service.addItem(\"MAC Filtering\", \"fw-macfilter.asp\", \"\", \"Setup MAC filering\");" "menu.makeLastSubmenu(service);"));

	  }

	else
	  {

		  websWrite(wp, T("<tr><td><b>Firewall</b></td></tr>\n" "<tr><td>&nbsp;&nbsp;<a href=\"fw-macfilter.asp\" target=\"view\">MAC Filtering</a></td></tr>\n"));

	  }



	return 0;

}



/*

int srvMenu_user(int eid, webs_t wp, int argc, char_t **argv)

{

	char *parm;

	

	if (ejArgs(argc, argv, T("%s"), &parm) < 1) {

		websError(wp, 400, T("Insufficient args\n"));

		return -1;

	}

	

	if ( parm[0] == '1' ) {

		websWrite(wp, T("menu.addItem(\"Services\");"

			"service = new MTMenu();"

			"service.addItem(\"DHCP Mode\", \"dhcpmode.asp\", \"\", \"DHCP Mode Configuration\");"

			"service.addItem(\"DHCP Server\", \"dhcpd.asp\", \"\", \"DHCP Server Configuration\");"

			"service.addItem(\"DHCP Relay\", \"dhcrelay.asp\", \"\", \"DHCP Relay Configuration\");"));

		websWrite(wp, T("service.addItem(\"DNS\");"

			"dns = new MTMenu();"

			"dns.addItem(\"DNS Server\", \"dns.asp\", \"\", \"DNS Configuration\");"

#ifdef CONFIG_USER_DDNS			

			"dns.addItem(\"Dynamic DNS\", \"ddns.asp\", \"\", \"DDNS Configuration\");"

#endif			

			"service.makeLastSubmenu(dns);"));

		websWrite(wp, T("service.addItem(\"Firewall\");"

			"firewall = new MTMenu();"

			"firewall.addItem(\"IP/Port Filtering\", \"fw-ipportfilter.asp\", \"\", \"Setup IP/Port filering\");"

#ifdef MAC_FILTER

			"firewall.addItem(\"MAC Filtering\", \"/admin/fw-macfilter.asp\", \"\", \"Setup MAC filering\");"

#endif

			"firewall.addItem(\"Port Forwarding\", \"fw-portfw.asp\", \"\", \"Setup port-forwarding\");"));

#ifdef URL_BLOCKING_SUPPORT

		websWrite(wp, T("firewall.addItem(\"URL Blocking\", \"url_blocking.asp\", \"\", \"URL Blocking Setting\");"));			

#endif	

#ifdef DOMAIN_BLOCKING_SUPPORT	

		websWrite(wp, T("firewall.addItem(\"Domain Blocking\", \"domainblk.asp\", \"\", \"Domain Blocking Setting\");"));		

#endif

#ifdef NATIP_FORWARDING

		websWrite(wp, T("firewall.addItem(\"NAT IP Forwarding\", \"fw-ipfw.asp\", \"\", \"Setup NAT IP Mapping\");"));

#endif

#ifdef PORT_TRIGGERING

		websWrite(wp, T("firewall.addItem(\"Port Triggering\", \"gaming.asp\", \"\", \"Setup Port Triggering\");"));

#endif

		websWrite(wp, T("firewall.addItem(\"DMZ\", \"fw-dmz.asp\", \"\", \"Setup DMZ\");"

			"service.makeLastSubmenu(firewall);"

#ifdef CONFIG_USER_IGMPPROXY

			"service.addItem(\"IGMP Proxy\", \"igmproxy.asp\", \"\", \"IGMP Proxy Configuration\");"

#endif

//#ifdef CONFIG_USER_UPNPD

#if defined(CONFIG_USER_UPNPD)||defined(CONFIG_USER_MINIUPNPD)

			"service.addItem(\"UPnP\", \"upnp.asp\", \"\", \"UPnP Configuration\");"			

#endif	

#ifdef CONFIG_USER_ROUTED_ROUTED

			"service.addItem(\"RIP\", \"rip.asp\", \"\", \"RIP Configuration\");"

#endif

			"menu.makeLastSubmenu(service);"));

		websWrite(wp, T("menu.makeLastSubmenu(service);"));

	}

	else {

		websWrite(wp, T("<tr><td><b>Services</b></td></tr>\n"

			"<tr><td>&nbsp;&nbsp;<a href=\"dhcpmode.asp\" target=\"view\">DHCP Mode</a></td></tr>\n"

			"<tr><td>&nbsp;&nbsp;<a href=\"dhcpd.asp\" target=\"view\">DHCP Server</a></td></tr>\n"

			"<tr><td>&nbsp;&nbsp;<a href=\"dhcrelay.asp\" target=\"view\">DHCP Relay</a></td></tr>\n"

			"<tr><td>&nbsp;&nbsp;<a href=\"dns.asp\" target=\"view\">DNS</a></td></tr>\n"

#ifdef CONFIG_USER_DDNS			

			"<tr><td>&nbsp;&nbsp;<a href=\"ddns.asp\" target=\"view\">Dynamic DNS</a></td></tr>\n"

#endif

			));

		websWrite(wp, T("<tr><td>&nbsp;&nbsp;<b>Firewall</b></td></tr>\n"

			"<tr><td>&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"fw-ipportfilter.asp\" target=\"view\">IP/Port Filtering</a></td></tr>\n"

#ifdef MAC_FILTER

			"<tr><td>&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"/admin/fw-macfilter.asp\" target=\"view\">MAC Filtering</a></td></tr>\n"

#endif

			"<tr><td>&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"fw-portfw.asp\" target=\"view\">Port Forwarding</a></td></tr>\n"));

#ifdef URL_BLOCKING_SUPPORT

		websWrite(wp, T("<tr><td>&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"url_blocking.asp\" target=\"view\">URL Blocking</a></td></tr>\n"));

#endif

#ifdef DOMAIN_BLOCKING_SUPPORT		

		websWrite(wp, T("<tr><td>&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"domainblk.asp\" target=\"view\">Domain Blocking</a></td></tr>\n"));

#endif

#ifdef NATIP_FORWARDING

		websWrite(wp, T("<tr><td>&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"fw-ipfw.asp\" target=\"view\">NAT IP Forwarding</a></td></tr>\n"));

#endif

#ifdef PORT_TRIGGERING

		websWrite(wp, T("<tr><td>&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"gaming.asp\" target=\"view\">Port Triggering</a></td></tr>\n"));

#endif

		websWrite(wp, T("<tr><td>&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"fw-dmz.asp\" target=\"view\">DMZ</a></td></tr>"

#ifdef CONFIG_USER_IGMPPROXY

			"<tr><td>&nbsp;&nbsp;<a href=\"igmproxy.asp\" target=\"view\">IGMP Proxy</a></td></tr>"

#endif

//#ifdef CONFIG_USER_UPNPD

#if defined(CONFIG_USER_UPNPD)||defined(CONFIG_USER_MINIUPNPD)

			"<tr><td>&nbsp;&nbsp;<a href=\"upnp.asp\" target=\"view\">UPnP</a></td></tr>"

#endif

#ifdef CONFIG_USER_ROUTED_ROUTED

			"<tr><td>&nbsp;&nbsp;<a href=\"rip.asp\" target=\"view\">RIP</a></td></tr>"

#endif

		));

	}

	return 0;

}

*/

/*

int advanceMenu_user(int eid, webs_t wp, int argc, char_t **argv)

{

	char *parm;

	

	if (ejArgs(argc, argv, T("%s"), &parm) < 1) {

		websError(wp, 400, T("Insufficient args\n"));

		return -1;

	}

	

	if ( parm[0] == '1' ) {

		websWrite(wp, T(

			"menu.addItem(\"Advance\");"

			"advance = new MTMenu();"

			"advance.addItem(\"ARP table\", \"arptable.asp\", \"\", \"ARP table\");"

			"advance.addItem(\"Bridging\", \"bridging.asp\", \"\", \"Bridge Configuration\");"

			"advance.addItem(\"Routing\", \"routing.asp\", \"\", \"Routing Configuration\");"

			"advance.addItem(\"SNMP\", \"snmp.asp\", \"\", \"SNMP Protocol Configuration\");"

#ifdef CONFIG_EXT_SWITCH

#ifdef ITF_GROUP

			"advance.addItem(\"Port Mapping\", \"eth2pvc.asp\", \"\", \"Assign Ethernet to PVC\");"

#endif

#endif

#ifdef IP_QOS

			"advance.addItem(\"IP QoS\", \"ipqos.asp\", \"\", \"IP QoS Configuration\");"

#endif

#ifdef CONFIG_EXT_SWITCH

#ifdef ELAN_LINK_MODE

			"advance.addItem(\"Link Mode\", \"lnkmode.asp\", \"\", \"Ethernet Link Mode Setting\");"

#endif

#endif

			"advance.addItem(\"Remote Access\", \"rmtacc.asp\", \"\", \"Services Access Control\");"

			"advance.addItem(\"Others\", \"others.asp\", \"\", \"Other advanced Configuration\");"

			"menu.makeLastSubmenu(advance);"

			));

	}

	else {

		websWrite(wp, T(

			"<tr><td><b>Advance</b></td></tr>\n"

			"<tr><td>&nbsp;&nbsp;<a href=\"arptable.asp\" target=\"view\">ARP Table</a></td></tr>\n"

			"<tr><td>&nbsp;&nbsp;<a href=\"bridging.asp\" target=\"view\">Bridging</a></td></tr>\n"

			"<tr><td>&nbsp;&nbsp;<a href=\"routing.asp\" target=\"view\">Routing</a></td></tr>\n"

			"<tr><td>&nbsp;&nbsp;<a href=\"snmp.asp\" target=\"view\">SNMP</a></td></tr>\n"

#ifdef CONFIG_EXT_SWITCH

#ifdef ITF_GROUP

			"<tr><td>&nbsp;&nbsp;<a href=\"eth2pvc.asp\" target=\"view\">Port Mapping</a></td></tr>\n"

#endif

#endif

#ifdef IP_QOS

			"<tr><td>&nbsp;&nbsp;<a href=\"ipqos.asp\" target=\"view\">IP QoS</a></td></tr>\n"

#endif

#ifdef CONFIG_EXT_SWITCH

#ifdef ELAN_LINK_MODE

			"<tr><td>&nbsp;&nbsp;<a href=\"lnkmode.asp\" target=\"view\">Link Mode</a></td></tr>\n"

#endif

#endif

			"<tr><td>&nbsp;&nbsp;<a href=\"rmtacc.asp\" target=\"view\">Remote Access</a></td></tr>\n"

			"<tr><td>&nbsp;&nbsp;<a href=\"others.asp\" target=\"view\">Others</a></td></tr>\n"

			));

	}



	return 0;

}

*/

/*

int diagMenu_user(int eid, webs_t wp, int argc, char_t **argv)

{

	char *parm;

	

	if (ejArgs(argc, argv, T("%s"), &parm) < 1) {

		websError(wp, 400, T("Insufficient args\n"));

		return -1;

	}

	

	if ( parm[0] == '1' ) {

		websWrite(wp, T("menu.addItem(\"Diagnostic\");"

			"diag = new MTMenu();"

			"diag.addItem(\"Ping\", \"ping.asp\", \"\", \"Ping test\");"

			"diag.addItem(\"ATM Loopback\", \"oamloopback.asp\", \"\", \"ATM OAM loopback test\");"

			"diag.addItem(\"ADSL\", \"/adv/adsl-diag.asp\", \"\", \"ADSL Tone Diagnostics\");"

#ifdef DIAGNOSTIC_TEST

			"diag.addItem(\"Diagnostic Test\", \"diag-test.asp\", \"\", \"Diagnostic test\");"

#endif

		));

		websWrite(wp, T("menu.makeLastSubmenu(diag);"));

	}

	else {

		websWrite(wp, T("<tr><td><b>Diagnostic</b></td></tr>\n"

			"<tr><td>&nbsp;&nbsp;<a href=\"ping.asp\" target=\"view\">Ping</a></td></tr>\n"

			"<tr><td>&nbsp;&nbsp;<a href=\"oamloopback.asp\" target=\"view\">ATM Loopback</a></td></tr>\n"

			"<tr><td>&nbsp;&nbsp;<a href=\"/adv/adsl-diag.asp\" target=\"view\">ADSL</a></td></tr>\n"

#ifdef DIAGNOSTIC_TEST

			"<tr><td>&nbsp;&nbsp;<a href=\"diag-test.asp\" target=\"view\">Diagnostic Test</a></td></tr>\n"

#endif

		));

	}

	return 0;

}

*/

int adminMenu_user(int eid, webs_t wp, int argc, char_t ** argv)
{

	char *parm;



	if (ejArgs(argc, argv, T("%s"), &parm) < 1)
	  {

		  websError(wp, 400, T("Insufficient args\n"));

		  return -1;

	  }



	if (parm[0] == '1')
	  {

		  websWrite(wp, T("menu.addItem(\"Admin\");" "admin = new MTMenu();" "admin.addItem(\"Commit/Reboot\", \"reboot.asp\", \"\", \"Commit/reboot the system\");" "admin.addItem(\"Password\", \"user-password.asp\", \"\", \"Setup access password\");" "admin.addItem(\"ACL Config\", \"acl.asp\", \"\", \"ACL Setting\");"
#ifdef ACCOUNT_LOGIN_CONTROL
				  "admin.addItem(\"Logout\", \"userlogout.asp\", \"\", \"Logout\");"
#endif
#ifdef USE_LOGINWEB_OF_SERVER
				  "admin.addItem(\"Logout\", \"/admin/logout.asp\", \"\", \"Logout\");"
#endif
				  "menu.makeLastSubmenu(admin);"));

	  }

	else
	  {

		  websWrite(wp, T("<tr><td><b>Admin</b></td></tr>\n" "<tr><td>&nbsp;&nbsp;<a href=\"reboot.asp\", target=\"view\">Commit/Reboot</a></td></tr>\n" "<tr><td>&nbsp;&nbsp;<a href=\"user-password.asp\" target=\"view\">Password</a></td></tr>\n" "<tr><td>&nbsp;&nbsp;<a href=\"acl.asp\" target=\"view\">ACL Config</a></td></tr>\n"
#ifdef ACCOUNT_LOGIN_CONTROL
				  "<tr><td>&nbsp;&nbsp;<a href=\"userlogout.asp\" target=\"view\">Logout</a></td></tr>\n"
#endif
#ifdef USE_LOGINWEB_OF_SERVER
				  "<tr><td>&nbsp;&nbsp;<a href=\"/admin/logout.asp\" target=\"view\">Logout</a></td></tr>\n"
#endif
			    ));

	  }

	return 0;

}



/*

int statisticsMenu_user(int eid, webs_t wp, int argc, char_t **argv)

{

	char *parm;

	

	if (ejArgs(argc, argv, T("%s"), &parm) < 1) {

		websError(wp, 400, T("Insufficient args\n"));

		return -1;

	}

	

	if ( parm[0] == '1' ) {

		websWrite(wp, T(

			"menu.addItem(\"Statistics\");"

			"statis = new MTMenu();"

			"statis.addItem(\"Interfaces\", \"stats.asp\", \"\", \"Display packet statistics\");"

			"statis.addItem(\"ADSL\", \"/adv/adsl-statis.asp\", \"\", \"Display ADSL statistics\");"

			"menu.makeLastSubmenu(statis);"

			));

	}

	else {

		websWrite(wp, T(

			"<tr><td><b>Statistics</b></td></tr>\n"

			"<tr><td>&nbsp;&nbsp;<a href=\"stats.asp\" target=\"view\">Interfaces</a></td></tr>\n"

			"<tr><td>&nbsp;&nbsp;<a href=\"/adv/adsl-statis.asp\" target=\"view\">ADSL</a></td></tr>\n"

			));

	}



	return 0;

}

*/

#endif				// of WEB_MENU_USE_NEW



int createMenu_user(int eid, webs_t wp, int argc, char_t ** argv)
{

#ifdef WEB_MENU_USE_NEW

	int i = 0, totalIdNums = 0, maxchildrensize = 0;

	int IdIndex = 0;

	unsigned char isRootMenuEnd = 0;



	//calc the id nums and the max children size

	totalIdNums = calcFolderNum(rootmenu_user, &maxchildrensize);

	//product the js code

	addMenuJavaScript(wp, totalIdNums, maxchildrensize);

	//create the header
/* add by yq_zhou 09.2.02 add sagem logo for 11n*/

	websWrite (wp, T ("<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\n"));
	websWrite (wp, T("<body onload=\"initIt()\" bgcolor=\"#4b688b\">\n"));
	websWrite (wp, T("<table width=100%% border=0 cellpadding=5 cellspacing=2>\n<tr><td  width=100%% align=left>\n"));
	websWrite (wp, T("<table  border=0 cellpadding=0 cellspacing=0>\n"
		"<tr><td width=18 height=18><img src=menu-images/menu_root.gif width=18 height=18></td>\n"
		"<td  height=18 colspan=4 class=link><b>TEW-436BRM</b></td></tr>\n </table>\n"));

//#ifdef CONFIG_11N_SAGEM_WEB
//  websWrite (wp, T ("<body  onload=\"initIt()\" bgcolor=\"#FFFFFF\" >\n"));
//#else
//  websWrite (wp, T ("<body  onload=\"initIt()\" bgcolor=\"#000000\" >\n"));
//#endif
//	websWrite(wp, T("<table width=100%% border=0 cellpadding=0 cellspacing=0>\n<tr><td  width=100%% align=left>\n"));

//	websWrite(wp, T("<table  border=0 cellpadding=0 cellspacing=0>\n" "<tr><td width=18 height=18><img src=menu-images/menu_root.gif width=18 height=18></td>\n" "<td  height=18 colspan=4 class=link><font size=3>%s</font></td></tr>\n </table>\n"), menuTitle_user);



	if (rootmenu_user[1].u.addr)

		addMenu(wp, &rootmenu_user[0], 0, &IdIndex, 0);

	else

		addMenu(wp, &rootmenu_user[0], 0, &IdIndex, 1);



	websWrite(wp, T("</td></tr>\n</table>\n"));


#else

	statusMenu_user(eid, wp, argc, argv);

//      lanMenu_user(eid, wp, argc, argv);

	wlanMenu_user(eid, wp, argc, argv);

	wanMenu_user(eid, wp, argc, argv);

	firewallMenu_user(eid, wp, argc, argv);

//      srvMenu_user(eid, wp, argc, argv);

//      advanceMenu_user(eid, wp, argc, argv);

//      diagMenu_user(eid, wp, argc, argv);

	adminMenu_user(eid, wp, argc, argv);

//      statisticsMenu_user(eid, wp, argc, argv);

#endif

	return 0;

}
