/*
 *      Utiltiy function to communicate with TCPIP stuffs
 *
 *      Authors: David Hsu	<davidhsu@realtek.com.tw>
 *
 *      $Id: utility.c,v 1.3 2008/03/24 12:02:07 xl Exp $
 *
 */

/*-- System inlcude files --*/
#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <ctype.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <signal.h>

#include <netinet/in.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <net/route.h>
#include <sys/ioctl.h>
#include <signal.h>
#include <errno.h>
#include <sys/wait.h>
#include <time.h>
#include <sys/sysinfo.h>

#include <netinet/if_ether.h>
#include <net/if.h>
#include <linux/sockios.h>
#ifdef EMBED
#include <linux/config.h>
#include <config/autoconf.h>
#else
#include "../../../uClibc/include/linux/autoconf.h"
#include "../../../config/autoconf.h"
#endif
//add by ramen to use struct PPPOE_DRV_CTRL for save_pppoe_sessionid()
#include "../../../spppd/pppoe.h"

/*-- Local include files --*/

#include "mib.h"
#include "utility.h"

/* for open(), lseek() */
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include "debug.h"

#include "wireless.h"
#ifdef CONFIG_ATM_CLIP
#include <linux/atmclip.h>
#include <linux/atmarp.h>
#endif

//xl_yue
#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
#include "../defs.h"
#endif

#include "fmdefs.h"

#include <linux/if_bridge.h>
#include <netdb.h>
#include <netinet/ip_icmp.h>
#ifdef CONFIG_MIDDLEWARE
#include <rtk/midwaredefs.h>
#endif


#include "options.h"



#ifdef ELAN_LINK_MODE_INTRENAL_PHY
typedef __uint64_t u64;
typedef __uint32_t u32;
typedef __uint16_t u16;
typedef __uint8_t u8;
#include <linux/ethtool.h>
#endif

#define PR_VC_START	1
#define	PR_PPP_START	16

const char LANIF[] = "br0";
const char LAN_ALIAS[] = "br0:0";	// alias for secondary IP
const char LAN_IPPT[] = "br0:1";	// alias for IP passthrough
const char WLANIF[] = "wlan0";
const char ELANIF[] = "eth0";
const char BRIF[] = "br0";
#ifdef WLAN_WDS
const char WDSIF[]="wlan0-wds0";
#endif
const char VC_BR[] = "0";
const char LLC_BR[] = "1";
const char VC_RT[] = "3";
const char LLC_RT[] = "4";
#ifdef CONFIG_ATM_CLIP
const char LLC_1577[] = "6";
#endif
const char PORT_DNS[] = "53";
const char PORT_DHCP[] = "67";
const char BLANK[] = "";
const char ARG_ADD[] = "add";
const char ARG_DEL[] = "del";
const char ARG_ENCAPS[] = "encaps";
const char ARG_QOS[] = "qos";
const char ARG_255x4[] = "255.255.255.255";
const char ARG_0x4[] = "0.0.0.0";
const char ARG_BKG[] = "&";
const char ARG_I[] = "-i";
const char ARG_O[] = "-o";
const char ARG_T[] = "-t";
const char ARG_TCP[] = "TCP";
const char ARG_UDP[] = "UDP";
#ifdef ZTE_GENERAL_ROUTER_SC
const char ARG_TCPUDP[] = "TCP/UDP";
#endif
const char ARG_ICMP[] = "ICMP";
const char FW_BLOCK[] = "block";
const char FW_INACC[] = "inacc";
const char FW_IPFILTER[] = "ipfilter";
const char FW_MACFILTER[] = "macfilter";
const char FW_APPFILTER[] = "appfilter";
const char FW_APP_P2PFILTER[] = "appp2pfilter";
const char FW_DROP[] = "DROP";
const char FW_ACCEPT[] = "ACCEPT";
const char FW_RETURN[] = "RETURN";
const char FW_FORWARD[] = "FORWARD";
const char FW_INPUT[] = "INPUT";
const char FW_PREROUTING[] = "PREROUTING";
const char FW_POSTROUTING[] = "POSTROUTING";
const char FW_DPORT[] = "--dport";
const char FW_SPORT[] = "--sport";
const char FW_ADD[] = "-A";
const char FW_DEL[] = "-D";
const char FW_INSERT[]="-I";
const char RMACC_MARK[] = "0x1000";
const char CONFIG_HEADER[] = "<Config_Information_File_8671>";
const char CONFIG_TRAILER[] = "</Config_Information_File_8671>";
const char CONFIG_XMLFILE[] = "/tmp/config.xml";
const char CONFIG_XMLENC[] = "/tmp/config.enc";
const char BACKUP_DIRNAME[] = "e8_Config_Backup";


const char ADSLCTRL[] = "/bin/adslctrl";
const char IFCONFIG[] = "/bin/ifconfig";
#ifdef SYSLOG_SUPPORT_ENABLE
const char SYSLOGD[]="/bin/syslogd";
const char KLOGD[]="/bin/klogd";
#endif
const char BRCTL[] = "/bin/brctl";
const char MPOAD[] = "/bin/mpoad";
const char MPOACTL[] = "/bin/mpoactl";
const char DHCPD[] = "/bin/udhcpd";
const char DHCPC[] = "/bin/udhcpc";
const char DNSRELAY[] = "/bin/dnsmasq";
const char SPPPD[] = "/bin/spppd";
const char SPPPCTL[] = "/bin/spppctl";
const char WEBSERVER[] = "/bin/boa";
const char UPGRADE_WEB[] = "/bin/httpd";
const char SNMPD[] = "/bin/snmpd";
const char ROUTE[] = "/bin/route";
const char IPTABLES[] = "/bin/iptables";
const char ZEBRA[] = "/bin/zebra";
const char RIPD[] = "/bin/ripd";
#ifdef MAC_FILTER_EBTABLES_SUPPORT
const char EBTABLES[]="/bin/ebtables";
#endif
#ifdef CONFIG_USER_ZEBRA_OSPFD_OSPFD
const char OSPFD[] = "/bin/ospfd";
#endif
const char ROUTED[] = "/bin/routed";
const char IGMPROXY[] = "/bin/igmpproxy";
#if (defined(CONFIG_RTL867X_NETLOG)  && defined (CONFIG_USER_NETLOGGER_SUPPORT))
const char NETLOGGER[]="/bin/netlogger";
#endif
const char TC[] = "/bin/tc";
#ifdef WLAN_SUPPORT
const char IWPRIV[] = "/bin/iwpriv";
const char AUTH[] = "/bin/auth";
const char IWCONTROL[] = "/bin/iwcontrol";
const char AUTH_PID[] = "/var/run/auth-wlan0.pid";
#endif
#if defined(TIME_ZONE) || defined(ZTE_GENERAL_ROUTER_SC)
const char SNTPC[] = "/bin/vsntp";
const char SNTPC_PID[] = "/var/run/vsntp.pid";
#endif
const char ROUTED_PID[] = "/var/run/routed.pid";
#ifdef CONFIG_USER_ZEBRA_OSPFD_OSPFD
const char ZEBRA_PID[] = "/var/run/zebra.pid";
const char OSPFD_PID[] = "/var/run/ospfd.pid";
#endif
const char IGMPPROXY_PID[] = "/var/run/igmp_pid";

const char PROC_DYNADDR[] = "/proc/sys/net/ipv4/ip_dynaddr";
const char PROC_IPFORWARD[] = "/proc/sys/net/ipv4/ip_forward";
const char PROC_NET_ATM_PVC[] = "/proc/net/atm/pvc";
const char PPP_CONF[] = "/var/ppp/ppp.conf";
const char PPPD_FIFO[] = "/tmp/ppp_serv_fifo";
const char MPOAD_FIFO[] = "/tmp/serv_fifo";
const char DHCPC_SCRIPT[] = "/etc/scripts/udhcpc.sh";
const char DHCPC_SCRIPT_NAME[] = "/var/udhcpc/udhcpc";
const char DHCPC_PID[] = "/var/run/udhcpc.pid";
const char IPOA_IPINFO[] = "/tmp/IPoAHalfBridge";
const char MER_GWINFO[] = "/tmp/MERgw";
#ifdef SYSLOG_SUPPORT_ENABLE
const char SYSLOGD_PID[]="/var/run/syslogd.pid";
const char KLOGD_PID[]="/var/run/klogd.pid";
#endif
#ifdef SNTP_SUPPORT_ENABLE
const char VSNTP_PID[]="/var/run/vsntp.pid";
const char VSNTP[]="/bin/vsntp";
#endif
#ifdef WLAN_SUPPORT
const char WLAN_AUTH_CONF[] = "/var/config/wlan0.conf";
#define WIRELESSAUTHPID  "/var/run/auth-wlan0.pid"
#define IWCONTROLPID  "/var/run/iwcontrol.pid"
#define WSCDPID  "/var/run/wscd-wlan0.pid"
#define MINI_UPNPDPID  "/var/run/mini_upnpd.pid"	//cathy
#define MINIUPNPDPID  "/var/run/linuxigd.pid"

char *WLANAPIF[] = {
	"wlan0", "wlan0-vap0", "wlan0-vap1", "wlan0-vap2", "wlan0-vap3", 0
};

const char *WLANAUTHPID[] = {
	"/var/run/auth-wlan0.pid", "/var/run/auth-wlan0-vap0.pid", "/var/run/auth-wlan0-vap1.pid", "/var/run/auth-wlan0-vap2.pid", "/var/run/auth-wlan0-vap3.pid", 0
};

const char *WLANAUTHCONF[] = {
	"/var/config/wlan0.conf", "/var/config/wlan0-vap0.conf", "/var/config/wlan0-vap1.conf", "/var/config/wlan0-vap2.conf", "/var/config/wlan0-vap3.conf", 0
};

const char *WLANAUTHFIFO[] = {
	"/var/auth-wlan0.fifo", "/var/auth-wlan0-vap0.fifo", "/var/auth-wlan0-vap1.fifo", "/var/auth-wlan0-vap2.fifo", "/var/auth-wlan0-vap3.fifo", 0
};
#endif
const char STR_DISABLE[] = "Disabled";
const char STR_ENABLE[] = "Enabled";
const char STR_AUTO[] = "Auto";
const char STR_MANUAL[] = "Manual";
const char STR_UNNUMBERED[] = "unnumbered";
const char STR_ERR[] = "err";
const char STR_NULL[] = "null";
#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
const char rebootWord0[] = "ϵͳ ...";
const char rebootWord1[] = "ϵͳѱã.";
const char rebootWord2[] = "رҳ2Ӻ´򿪣Ҫ趨PCIPַ!";



int prio2QoS[4]={1,3,2,0}; //mapping priority to ATM QoS     0---> CBR (1); 1---> rtvbr(3) 2 --->nrtvbr(2); 3---->ubr(0). 
int QoS2Prio[4]={3, 0, 2, 1};

#else
const char rebootWord0[] = "The System is Restarting ...";
const char rebootWord1[] = "The DSL Router has been configured and is rebooting.";
const char rebootWord2[] = "Close the DSL Router Configuration window and wait"
			" for a minute before reopening your web browser."
			" If necessary, reconfigure your PC's IP address to match"
			" your new configuration.";
#endif

//added by xl_yue: supporting wlcountry list
#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
struct wlCountryReg wlCountryRegList[] = {
	{strDefault,1},
	{strUSA,1},
	{strCHINA,3},
	{strHONGKONG,3},
	{strMACAO,3},
	{strTAIWAN,1},
	{strJAPAN,6},
	{strEUROPE,3},
	{strANTIGUA_BARBUDA,3},
	{strARGENTINA,3},
	{strARUBA,3},
	{strAUSTRALIA,3},
	{strAUSTRIA,3},
	{strBAHAMAS,3},
	{strBANGLADESH,3},
	{strBARBADOS,3},
	{strBELGIUM,3},
	{strBERMUDA,3},
	{strBOLIVIA ,3},
	{strBOSNIA_HERZEGOVINA,3},
	{strBRAZIL,3},
	{strBULGARIA,3},
	{strCANADA,1},
	{strCAYMAN_ISLANDS,3},
	{strCHILE,3},
	{strCOLOMBIA,3},
	{strCOSTA_RICA,3},
	{strCROATIA,3},
	{strCYPRUS,3},
	{strCZECH_REPUBLIC,3},
	{strDENMARK,3},
	{strDOMINICAN_REPUBLIC,3},
	{strECUADOR,3},
	{strEGYPT,3},
	{strEL_SALVADOR,3},
	{strESTONIA,3},
	{strFINLAND,3},
	{strFRANCE,3},
	{strGERMANY,3},
	{strGREECE,3},
	{strGUAM,3},
	{strGUATEMALA,3},
	{strHAITI,3},
	{strHONDURAS,3},
	{strHUNGARY,3},
	{strICELAND,3},
	{strINDIA,3},
	{strINDONESIA,3},
	{strIRELAND,3},
	{strISRAEL,3},
	{strITALY,3},
	{strJORDAN,3},
	{strKOREA,3},
	{strLATVIA,3},
	{strLIECHTENSTEIN,3},
	{strLITHUANIA,3},
	{strLUXEMBOURG,3},
	{strMALAYSIA,3},
	{strMALTA,3},
	{strMEXICO,3},
	{strMONACO,3},
	{strNETHERLANDS,3},
	{strNETHERLANDS_ANTILLES,3},
	{strNEW_ZEALAND,3},
	{strNICARAGUA,3},
	{strNIGERIA,3},
	{strNORWAY,3},
	{strPAKISTAN,3},
	{strPANAMA,1},
	{strPARAGUAY,3},
	{strPERU,3},
	{strPHILIPPINES,3},
	{strPOLAND,3},
	{strPORTUGAL,3},
	{strROMANIA,3},
	{strRUSSIAN_FEDERATION,3},
	{strSAUDI_ARABIA,3},
	{strSINGAPORE,3},
	{strSLOVAKIA,3},
	{strSLOVENIA,3},
	{strSOUTH_AFRICA,3},
	{strSPAIN,3},
	{strSWEDEN,3},
	{strSWITZERLAND,3},
	{strTANZANIA,3},
	{strTHAILAND,3},
	{strTUNISIA,3},
	{strTURKEY,3},
	{strUKRAINE,3},
	{strUNITED_ARAB_EMIRATES,3},
	{strUNITED_KINGDOM,3},
	{strURUGUAY,3},
	{strVENEZUELA,3},
	{strVIET_NAM,3},
	{"\0",0}
};
#endif

#ifndef ZTE_GENERAL_ROUTER_SC
const char errGetEntry[] = "Get table entry error!";
#else
const char errGetEntry[] = "ȡMIB entry !";
#endif
static char adslDevice[] = "/dev/adsl0";

static FILE* adslFp = NULL;

const char *ppp_auth[] = {
	"AUTO", "PAP", "CHAP"
};

const char *dhcp_mode[] = {
	"None", "DHCP Relay", "DHCP Server"
};

#ifdef IP_QOS
const char *n0to7[] = {
	"n/a", "0", "1", "2", "3", "4", "5", "6", "7"
};

/*
const char *prioLevel[] = {
	"High", "Medium", "Low"
};
*/
// Note: size of prioLevel depends on the IPQOS_NUM_PKT_PRIO
const char *prioLevel[] = {
	"p0", "p1", "p2", "p3", "p4", "p5", "p6", "p7"
};

//alex_huang
#ifdef CONFIG_8021P_PRIO
const char *set1ptable[]={"set1ptbl0","set1ptbl1","set1ptbl2","set1ptbl3","set1ptbl4","set1ptbl5","set1ptbl6","set1ptbl7"};
#endif
// priority mapping of packet priority against priority queue
// ex, priomap[3] == 2 means packet priority 3 is mapping to priority queue_2 by default
//const int priomap[8] = {3, 3, 2, 2, 2, 1, 1, 1};
const int priomap[8] = {4, 4, 3, 3, 2, 2, 1, 1};

const char *ipTos[] = {
	"n/a", "Normal Service", "Minimize Cost", "Maximize Reliability",
	"Maximize Throughput", "Minimize Delay"
};
#endif

#ifdef WLAN_SUPPORT
const char *wlan_band[] = {
	0, "2.4 GHz (B)", "2.4 GHz (G)", "2.4 GHz (B+G)", 0
};

const char *wlan_mode[] = {
	"AP", "Client", "AP+WDS"
};

const char *wlan_rate[] = {
	"1M", "2M", "5.5M", "11M", "6M", "9M", "12M", "18M", "24M", "36M", "48M", "54M"
};

const char *wlan_auth[] = {
	"Open", "Shared", "Auto"
};

//modified  by xl_yue
#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
const char *wlan_preamble[] = {
	"Long", "Short", "Auto"
};
#else
const char *wlan_preamble[] = {
	"Long", "Short"
};
#endif

const char *wlan_encrypt[] = {
#ifdef ENABLE_WPAAES_WPA2TKIP
	"None", "WEP", "WPA (TKIP)",  "WPA (AES)", "WPA2 (AES)", "WPA2 (TKIP)", "WPA2 Mixed"
#else
	"None", "WEP", "WPA (TKIP)", "WPA2 (AES)", "WPA2 Mixed"
#endif
};

const char *wlan_pskfmt[] = {
	"Passphrase", "Hex"
};

const char *wlan_wepkeylen[] = {
	"Disable", "64-bit", "128-bit"
};

const char *wlan_wepkeyfmt[] = {
	"ASCII", "Hex"
};
static int useAuth_wlan0=0;
static int wlan_num=0;
static char para_iwctrl[10][20];


#ifdef WLAN_MBSSID
void MBSSID_GetRootEntry(MIB_CE_MBSSIB_T *Entry) {
	Entry->idx = 0;

	mib_get(MIB_WLAN_ENCRYPT, &Entry->encrypt);
	mib_get(MIB_WLAN_ENABLE_1X, &Entry->enable1X);
	mib_get(MIB_WLAN_WEP, &Entry->wep);
	mib_get(MIB_WLAN_WPA_AUTH, &Entry->wpaAuth);
	mib_get(MIB_WLAN_WPA_PSK_FORMAT, &Entry->wpaPSKFormat);
	mib_get(MIB_WLAN_WPA_PSK, Entry->wpaPSK);
	mib_get(MIB_WLAN_RS_PORT, &Entry->rsPort);
	mib_get(MIB_WLAN_RS_IP, Entry->rsIpAddr);

	mib_get(MIB_WLAN_RS_PASSWORD, Entry->rsPassword);
	mib_get(MIB_WLAN_DISABLED, &Entry->wlanDisabled);
	mib_get(MIB_WLAN_SSID, Entry->ssid);
	mib_get(MIB_WLAN_AUTH_TYPE, &Entry->authType);
//added by xl_yue
#ifdef ENABLE_WPAAES_WPA2TKIP
	mib_get( MIB_WLAN_WPA_CIPHER_SUITE, &Entry->unicastCipher);
	mib_get( MIB_WLAN_WPA2_CIPHER_SUITE, &Entry->wpa2UnicastCipher);
#endif

}

void MBSSID_GetRootEntryWEP(MIB_CE_MBSSIB_WEP_T *Entry) {	
	mib_get(MIB_WLAN_WEP64_KEY1, Entry->wep64Key1);
	mib_get(MIB_WLAN_WEP64_KEY2, Entry->wep64Key2);
	mib_get(MIB_WLAN_WEP64_KEY3, Entry->wep64Key3);
	mib_get(MIB_WLAN_WEP64_KEY4, Entry->wep64Key4);

	mib_get(MIB_WLAN_WEP128_KEY1, Entry->wep128Key1);
	mib_get(MIB_WLAN_WEP128_KEY2, Entry->wep128Key2);
	mib_get(MIB_WLAN_WEP128_KEY3, Entry->wep128Key3);
	mib_get(MIB_WLAN_WEP128_KEY4, Entry->wep128Key4);

	mib_get(MIB_WLAN_WEP_KEY_TYPE, &Entry->wepKeyType);
	mib_get(MIB_WLAN_WEP_DEFAULT_KEY, &Entry->wepDefaultKey);
}

#endif



#endif	// of WLAN_SUPPORT

#ifdef CONFIG_EXT_SWITCH
#ifdef CONFIG_USBCLIENT
// mapping of virtual port to the board-level port number
#if defined(ZTE_GENERAL_ROUTER_SC) || defined(ZTE_531B_BRIDGE_SC)
const int virt2user[] = {
	1, 2, 3, 4, 5
};
#else
const int virt2user[] = {
	5, 4, 3, 2, 1
};
#endif
#else
// mapping of virtual port to the board-level port number
#if defined(ZTE_GENERAL_ROUTER_SC) || defined(ZTE_531B_BRIDGE_SC) || defined(_LINUX_2_6_)
const int virt2user[] = {
	1, 2, 3, 4
};
#else
const int virt2user[] = {
	4, 3, 2, 1
};
#endif
#endif
#endif

char *ifGetName(int ifindex, char *buffer, unsigned int len);

static int do_ioctl(unsigned int cmd, struct ifreq *ifr)
{
	int skfd, ret;
	
	if ((skfd = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
		perror("socket");
		return (-1);
	}
	
	ret = ioctl(skfd, cmd, ifr);
	close(skfd);
	return ret;
}

/*
 * Get Interface Addr (MAC, IP, Mask)
 */
int getInAddr( char *interface, ADDR_T type, void *pAddr )
{
	struct ifreq ifr;
	int found=0;
	struct sockaddr_in *addr;
	
	strcpy(ifr.ifr_name, interface);
	if (do_ioctl(SIOCGIFFLAGS, &ifr) < 0)
		return (0);
	
	if (type == HW_ADDR) {
		if (do_ioctl(SIOCGIFHWADDR, &ifr) >= 0) {
			memcpy(pAddr, &ifr.ifr_hwaddr, sizeof(struct sockaddr));
			found = 1;
		}
	}
	else if (type == IP_ADDR) {
		if (do_ioctl(SIOCGIFADDR, &ifr) == 0) {
			addr = ((struct sockaddr_in *)&ifr.ifr_addr);
			*((struct in_addr *)pAddr) = *((struct in_addr *)&addr->sin_addr);
			found = 1;
		}
	}
	else if (type == DST_IP_ADDR) {
		if (do_ioctl(SIOCGIFDSTADDR, &ifr) == 0) {
			addr = ((struct sockaddr_in *)&ifr.ifr_addr);
			*((struct in_addr *)pAddr) = *((struct in_addr *)&addr->sin_addr);
			found = 1;
		}
	}
	else if (type == SUBNET_MASK) {
		if (do_ioctl(SIOCGIFNETMASK, &ifr) >= 0) {
			addr = ((struct sockaddr_in *)&ifr.ifr_addr);
			*((struct in_addr *)pAddr) = *((struct in_addr *)&addr->sin_addr);
			found = 1;
		}
	}
	return found;
}

int getInFlags( char *interface, int *flags )
{
	struct ifreq ifr;
	int found=0;

#ifdef EMBED
	strcpy(ifr.ifr_name, interface);
	
	if (do_ioctl(SIOCGIFFLAGS, &ifr) == 0) {
		if (flags)
			*flags = ifr.ifr_flags;
		found = 1;
	}
#endif
	return found;
}

int setInFlags( char *interface, int flags )
{
	struct ifreq ifr;
	int ret=0;

#ifdef EMBED
	strcpy(ifr.ifr_name, interface);
	ifr.ifr_flags = flags;
	
	if (do_ioctl(SIOCSIFFLAGS, &ifr) == 0)
		ret = 1;
#endif
	return ret;
}

int INET_resolve(char *name, struct sockaddr *sa)
{
	struct sockaddr_in *s_in = (struct sockaddr_in *)sa;

	s_in->sin_family = AF_INET;
	s_in->sin_port = 0;

	/* Default is special, meaning 0.0.0.0. */
	if (strcmp(name, "default")==0) {
		s_in->sin_addr.s_addr = INADDR_ANY;
		return 1;
	}
	/* Look to see if it's a dotted quad. */
	if (inet_aton(name, &s_in->sin_addr)) {
		return 0;
	}
	/* guess not.. */
	return -1;
}

enum { ROUTE_ADD, ROUTE_DEL };
static int route_modify(struct rtentry *rt, int action) 
{
	int skfd;
	
	if (rt==0)
		return -1;
	
	rt->rt_flags = RTF_UP;
	if (((struct sockaddr_in *)(&rt->rt_gateway))->sin_addr.s_addr)
		rt->rt_flags |= RTF_GATEWAY;
	
	/* Create a socket to the INET kernel. */
	if ((skfd = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
		perror("socket");
		return -1;
	}
	
	// Added by Mason Yu. According the netmask, we input the correct dst address.
	((struct sockaddr_in *)(&rt->rt_dst))->sin_addr.s_addr = 
	(((struct sockaddr_in *)(&rt->rt_dst))->sin_addr.s_addr & ((struct sockaddr_in *)(&rt->rt_genmask))->sin_addr.s_addr );

	if (action == ROUTE_ADD) {
	/* Tell the kernel to accept this route. */
		if (ioctl(skfd, SIOCADDRT, rt) < 0) {
			perror("SIOCADDRT");
			close(skfd);
			return -1;
		}
	} else {
		if (ioctl(skfd, SIOCDELRT, rt) < 0) {
			perror("SIOCDELRT");
			close(skfd);
			return -1;
		}
	}
	
	/* Close the socket. */
	(void) close(skfd);
	return 0;

}

// update corresponding field of rtentry from MIB_CE_IP_ROUTE_T
static void updateRtEntry(MIB_CE_IP_ROUTE_T *pSrc, struct rtentry *pDst) {
	struct sockaddr_in *s_in;

	//pDst->rt_flags = RTF_UP;
	s_in = (struct sockaddr_in *)&pDst->rt_dst;
	s_in->sin_family = AF_INET;
	s_in->sin_port = 0;
	s_in->sin_addr = *(struct in_addr *)pSrc->destID;
					
	s_in = (struct sockaddr_in *)&pDst->rt_genmask;
	s_in->sin_family = AF_INET;
	s_in->sin_port = 0;
	s_in->sin_addr = *(struct in_addr *)pSrc->netMask;

	if (pSrc->nextHop[0]&&pSrc->nextHop[1]&&pSrc->nextHop[2]&&pSrc->nextHop[3]) {				
		s_in = (struct sockaddr_in *)&pDst->rt_gateway;	
		s_in->sin_family = AF_INET;
		s_in->sin_port = 0;
		s_in->sin_addr = *(struct in_addr *)pSrc->nextHop;
	}
	
}

/*del=>  1: delete the route entry, 
         0: add the route entry(skip ppp part), 
        -1: add the route entry*/
void route_cfg_modify(MIB_CE_IP_ROUTE_T *pRoute, int del) {
	struct rtentry rt;
	char ifname[16];

	if( pRoute==NULL ) return;
	if(!pRoute->Enable) return; 

	memset(&rt, 0, sizeof(rt));
	updateRtEntry(pRoute, &rt);
	rt.rt_dev = ifGetName(pRoute->ifIndex, ifname, sizeof(ifname));
	if (pRoute->FWMetric > -1)
		rt.rt_metric = pRoute->FWMetric + 1;


	if (del>0) {
		INET_delroute(&rt);
		return;
	}
	if(del==0)
	{
		// skip PPP interface, too. It will be create by PPP daemon.
		if (rt.rt_dev && !strncmp(rt.rt_dev, "ppp", 3))
			return;
	}
	
	INET_addroute(&rt);

}

void route_ppp_ifup(unsigned long pppGW) {
	unsigned int entryNum, i;
	char ifname0[16];//, *ifname;
	MIB_CE_IP_ROUTE_T Entry;
	struct rtentry rt;			

	entryNum = mib_chain_total(MIB_IP_ROUTE_TBL);
	
	for (i=0; i<entryNum; i++) {

		if (!mib_chain_get(MIB_IP_ROUTE_TBL, i, (void *)&Entry))
		{
			continue;
		}
		if( !Entry.Enable ) continue;

		memset(&rt, 0, sizeof(rt));

		rt.rt_dev = ifGetName(Entry.ifIndex, ifname0, sizeof(ifname0));

		if (rt.rt_dev && !strncmp(rt.rt_dev, "ppp", 3)) {
			updateRtEntry(&Entry, &rt);
			rt.rt_metric = Entry.FWMetric + 1;		
			route_modify(&rt, ROUTE_ADD);
		}
		else if (Entry.ifIndex == 0xff) {	// Interface "any"
			struct in_addr *addr;
			addr = (struct in_addr *)&Entry.nextHop;
			if (addr->s_addr == pppGW) {
				updateRtEntry(&Entry, &rt);
				rt.rt_metric = Entry.FWMetric + 1;		
				route_modify(&rt, ROUTE_ADD);
			}
		}
	}
#ifdef DNS_BIND_PVC_SUPPORT
	DnsBindPvcRoute(DELDNSROUTE);
	DnsBindPvcRoute(ADDDNSROUTE);
#endif
  
}
/*
*	Del a route
*/
int INET_delroute(struct rtentry *rt)
{
	return route_modify(rt, ROUTE_DEL);
}
/*
 *	Add a route
 */
int INET_addroute(struct rtentry *rt)
{
	return route_modify(rt, ROUTE_ADD);
#if 0
	int skfd;
	
	if (rt==0)
		return -1;
	
	rt->rt_flags = (RTF_UP | RTF_GATEWAY);
	
	/* Create a socket to the INET kernel. */
	if ((skfd = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
		perror("socket");
		return -1;
	}
	
	// Added by Mason Yu. According the netmask, we input the correct dst address.
	((struct sockaddr_in *)(&rt->rt_dst))->sin_addr.s_addr = 
	(((struct sockaddr_in *)(&rt->rt_dst))->sin_addr.s_addr & ((struct sockaddr_in *)(&rt->rt_genmask))->sin_addr.s_addr );
	
	// Mason Yu
	//printf("&rt->rt_dst=%x  &rt->rt_genmask=%x  &rt->rt_gateway)=%x\n", 
	//        ((struct sockaddr_in *)(&rt->rt_dst))->sin_addr.s_addr, 
	//        ((struct sockaddr_in *)(&rt->rt_genmask))->sin_addr.s_addr, 
	//        ((struct sockaddr_in *)(&rt->rt_gateway))->sin_addr.s_addr); 
	
	/* Tell the kernel to accept this route. */
	if (ioctl(skfd, SIOCADDRT, rt) < 0) {
		perror("SIOCADDRT");
		close(skfd);
		return -1;
	}
	
	/* Close the socket. */
	(void) close(skfd);
	return 0;
#endif
}


/*
* Convert ifIndex to system interface name, e.g. eth0,vc0...
*/
char *ifGetName(int ifindex, char *buffer, unsigned int len) {
	if ( ifindex == 0xff )
	{
		return 0;
	}else 
	if(  (ifindex & 0xf0)==0xf0  )
	{
		snprintf( buffer, len,  "vc%u", VC_INDEX(ifindex) );	

	}else{
		snprintf( buffer, len,  "ppp%u", PPP_INDEX(ifindex) );
		
	}
	return buffer;
}

#ifdef CONFIG_EXT_SWITCH
//-----------------------------------------------------------------
// register switch port 0 ~ 3 into system.
// This will fix the 4-ports vlan mapping, so that the user should
// not reconfig the switch vlan.
void __dev_register_swport()
{
#ifdef EMBED
	struct ifreq ifr;
	struct ifvlan ifvl;
	short mbr;
	int i;
	
	strcpy(ifr.ifr_name, "eth0");
	
	// set per-vlan id and member set
	// vlanIdx	VLAN	VID	MEMBER
	//	0	A	1	port 0,1,2,3,4
	//	1	B	2	port 0,1,2,3,4
	//	2	C	3	port 0,1,2,3,4
	//	3	D	4	port 0,1,2,3,4
	mbr = 0x10;	// set port 4 as member
	for (i=0; i<SW_PORT_NUM; i++) {
		ifvl.cmd=VLAN_SETINFO;
		ifvl.vlanIdx=i;
		// VID 0 is used to identify priority frames and VID 4095(0xFFF) is reserved
		ifvl.vid=i+1;
		//ifvl.member=mbr | (1<<i);
//		ifvl.member=0x1f; // member ports: 0,1,2,3,4
#ifdef CONFIG_USBCLIENT		
		ifvl.member=0x3f; //member ports :0,1,2,3,4,5
#else
		ifvl.member=0x1f; // member ports: 0,1,2,3,4
#endif		
		ifr.ifr_data = (char *)&ifvl;
		setVlan(&ifr);
	}
	
	// set port vlan mapping
	// port		vlanIdx
	//	0	0
	//	1	1
	//	2	2
	//	3	3
	for (i=0; i<SW_PORT_NUM; i++) {
		// set sw-port 0~3 vlan idex (vlan id) to let system tell the sw-ports
		ifvl.cmd=VLAN_SETPVIDX;
		ifvl.port=i;
		ifvl.vlanIdx=i;
		ifr.ifr_data = (char *)&ifvl;
		setVlan(&ifr);
	}
	
	// Setup port 4 (to 867x NIC) tx tag policy to be tag_replace.
	// The vlan tag would be replaced according to its source port
	// vlanIdx setting when output from port 4
	ifvl.cmd=VLAN_SETTXTAG;
#ifdef CONFIG_USBCLIENT	
	ifvl.port=5;
#else
        ifvl.port=4;
#endif	
	ifvl.txtag=TAG_REPLACE;
	ifr.ifr_data = (char *)&ifvl;
	setVlan(&ifr);
	
	__dev_setupVirtualPort(1);
#endif
}

// enable/disable IGMP snooping
void __dev_setupIGMPSnoop(int flag)
{
	struct ifreq ifr;
	struct ifvlan ifvl;
	
	strcpy(ifr.ifr_name, "eth0");
	ifr.ifr_data = (char *)&ifvl;
	ifvl.cmd=VLAN_SETIGMPSNOOP;
	ifvl.enable=flag;
	setVlan(&ifr);
	printf("IGMP Snooping: %s\n", flag?"enabled":"disabled");
}
	
// enable/disable IGMP snooping
void __dev_setupPortMapping(int flag)
{
#ifdef ITF_GROUP
	struct ifreq ifr;
	struct ifvlan ifvl;
	
	strcpy(ifr.ifr_name, "eth0");
	ifr.ifr_data = (char *)&ifvl;
	ifvl.cmd=VLAN_SETPORTMAPPING;
	ifvl.enable=flag;
	setVlan(&ifr);
	//printf("Port Mapping: %s\n", flag?"enabled":"disabled");
#endif
}
	
// enable/disable LAN virtual port
void __dev_setupVirtualPort(int flag)
{
	struct ifreq ifr;
	struct ifvlan ifvl;
	
	strcpy(ifr.ifr_name, "eth0");
	ifr.ifr_data = (char *)&ifvl;
	ifvl.cmd=VLAN_VIRTUAL_PORT;
	ifvl.enable=flag;
	setVlan(&ifr);
}
#ifdef CONFIG_IGMP_FORBID
void __dev_igmp_forbid(int flag)
{
     struct ifreq ifr;
	struct ifvlan ifvl;
	
	strcpy(ifr.ifr_name, "eth0");
	ifr.ifr_data = (char *)&ifvl;
	ifvl.cmd=IGMP_FORBID;
	ifvl.enable=flag;
	setVlan(&ifr);
}
#endif

int setVlan(struct ifreq *ifr)
{
	int ret=0;
	
#ifdef EMBED
	if (do_ioctl(SIOCS8305VLAN, ifr) == 0)
		ret = 1;
	
#endif
	return ret;
}

// enable rtl-8305 VLAN
static void setup_8305_vlan_enable()
{
	struct ifreq ifr;
	struct ifvlan ifvl;
	
	strcpy(ifr.ifr_name, "eth0");
	ifr.ifr_data = (char *)&ifvl;
	// enable rtl-8305 VLAN
	ifvl.cmd=VLAN_ENABLE;
	ifvl.enable=1;
	setVlan(&ifr);
	TRACE(STA_SCRIPT, "RTL8305 VLAN enabled\n");
}

/*------------------------------------------------------------------------
 *	Setup RTL8305 Vlan membership.
 *	Enable port-based Vlan and set the vlan membership with
 *	the following pre-requisite:
 *
 *	port		vlanIdx		Vlan	VID
 *	0		0		A	0
 *	1		1		B	1
 *	2		2		C	2
 *	3		3		D	3
 *
 *	The mbr is bit-map of the ports (interfaces)
 *	OLD Bit-map:  bit5  |  bit4  |  bit3  |  bit2  |  bit1  |  bit0
 *	              wlan  | device |  lan3  |  lan2  |  lan1  |  lan0
 
 * New Bit-map:  bit9 | bit8 | bit7 | bit6 | bit5  |  bit4  |  bit3  |  bit2  |  bit1  |  bit0
 *               vap3 | vap2 | vap1 | vap0 | wlan  | device |  lan3  |  lan2  |  lan1  |  lan0

  New Bit-map for 8306:  bit 10 | bit9  | bit8   | bit7   | bit6    | bit5   |  bit4  |  bit3  |  bit2  |  bit1  |  bit0
 *                                  vap3  | vap2 | vap1 | vap0 | wlan  | device| lan4  |  lan3  |  lan2  |  lan1  |  lan0
 */
 /*------------------------------------------------------------------------*/
static void setup_8305_vlan_member(int port, int mbr)
{
	int k;
	struct ifreq ifr;
	struct ifvlan ifvl;
	
	strcpy(ifr.ifr_name, "eth0");
	ifr.ifr_data = (char *)&ifvl;
	
	// set 8305 port-based vlan members
	// port		vlanIdx		Vlan	VID
	// 0		0		A	0
	// 1		1		B	1
	// 2		2		C	2
	// 3		3		D	3
	ifvl.cmd=VLAN_SETINFO;
	
	// This port is a member ?
	if (mbr & (1<<port)) {
		// set the membership
		ifvl.vlanIdx=port;
		// VID 0 is used to identify priority frames and VID 4095(0xFFF) is reserved
		ifvl.vid=port+1;
// Mason Yu
#ifndef WLAN_MBSSID
#ifdef CONFIG_RE8306
              ifvl.member=(mbr & 0x7f);	
#else
		ifvl.member=(mbr & 0x3f);
#endif
               	
#else
#ifdef CONFIG_RE8306
//#ifdef CONFIG_USBCLIENT
              ifvl.member=(mbr & 0x7ff);
#else
		ifvl.member=(mbr & 0x3ff);
#endif
		
#endif
		setVlan(&ifr);
		TRACE(STA_SCRIPT, "RTL8305 VLAN: vlanIdx=%d, vid=%d, member=0x%.2x\n", ifvl.vlanIdx, ifvl.vid, ifvl.member);
	}
}

#ifdef WLAN_SUPPORT
/*------------------------------------------------------------------------
 *	Setup wlan0 group membership.
 *	The mbr is bit-map of the ports (interfaces)
 *	Bit-map:  bit5  |  bit4  |  bit3  |  bit2  |  bit1  |  bit0
 *	          wlan  | device |  lan3  |  lan2  |  lan1  |  lan0
 * New Bit-map:  bit9 | bit8 | bit7 | bit6 | bit5  |  bit4  |  bit3  |  bit2  |  bit1  |  bit0
 *               vap3 | vap2 | vap1 | vap0 | wlan  | device |  lan3  |  lan2  |  lan1  |  lan0
 *------------------------------------------------------------------------*/
#define SIOSIWRTLITFGROUP		0x8B90

static void setup_wlan_group_member(int itf, int mbr)
{
	int skfd;
	struct iwreq wrq;
	int k;
	
	skfd = socket(AF_INET, SOCK_DGRAM, 0);
	
#ifndef WLAN_MBSSID	
	/* Set device name */
	strncpy(wrq.ifr_name, (char *)WLANIF, IFNAMSIZ);
	wrq.u.data.flags = 0;
#else
	strncpy(wrq.ifr_name, (char *)WLANAPIF[itf], IFNAMSIZ);		
	wrq.u.data.flags = itf;

#endif	
	wrq.u.data.pointer = (caddr_t)&mbr;
	wrq.u.data.length = sizeof(mbr);	
	
	ioctl(skfd, SIOSIWRTLITFGROUP, &wrq);
	close( skfd );
}
#endif

#ifdef ITF_GROUP
/*
 * Setup per-vc interface group member(bit mapped)
 * The bitmap for interface should follow this convention commonly shared
 * by sar driver (sar_send())
 * OLD Bit-map:  bit5  |  bit4  |  bit3  |  bit2  |  bit1  |  bit0
 *               wlan  | device |  lan3  |  lan2  |  lan1  |  lan0
 
 * New Bit-map:  bit9 | bit8 | bit7 | bit6 | bit5  |  bit4  |  bit3  |  bit2  |  bit1  |  bit0
 *               vap3 | vap2 | vap1 | vap0 | wlan  | device |  lan3  |  lan2  |  lan1  |  lan0
 if usb add 
    bit10 | bit9  |  bit8  | bit7   | bit6   | bit5    |  bit4 |  bit3   |  bit2   |  bit1   |  bit0
 * vap3 | vap2 | vap1 | vap0 | wlan  | device| lan4 (usb)|  lan3  |  lan2  |  lan1  |  lan0
 */
void setupEth2pvc()
{
	//MIB_CE_SW_PORT_Tp pPort;
	MIB_CE_SW_PORT_T Port;
	//MIB_CE_ATM_VC_Tp pvcEntry;
	MIB_CE_ATM_VC_T pvcEntry;
	int i, k, total, num;
	char str_br[]="br1";
	struct data_to_pass_st msg;
	char str_vc[5], wanif[5];
#ifdef WLAN_SUPPORT
	char wlangrp;
#ifdef WLAN_MBSSID	
	char wlanAPgrp[5];
#endif
#endif
	int mbr[MAX_VC_NUM], dft_mbr, pvc_dft_mbr=0;
	
	// register 8305 switch port to system
	//__dev_register_swport();
	
	// init vc group member to zero, device is mandatory
	for (i=0; i<MAX_VC_NUM; i++)
		mbr[i] = 0;
	// init default group member
	dft_mbr=0;
	
	// setup user-specified pvc interface group members
	total = mib_chain_total(MIB_ATM_VC_TBL);
	for (i=0; i<total; i++) {
		int vcIdx;
		
		if (!mib_chain_get(MIB_ATM_VC_TBL, i, (void *)&pvcEntry))
			continue;
		if (!pvcEntry.enable)
			continue;
		// check for LAN ports
		num = mib_chain_total(MIB_SW_PORT_TBL);
		vcIdx = VC_INDEX(pvcEntry.ifIndex);
		for (k=0; k<num; k++) {
			if (!mib_chain_get(MIB_SW_PORT_TBL, k, (void *)&Port))
				continue;
			if (Port.itfGroup == pvcEntry.itfGroup) {
				// this lan port shares the same group with pvc, add as pvc's member
				// TODO: check for pppoa (no VC_INDEX)
				if (vcIdx < MAX_VC_NUM) {
					mbr[vcIdx] |= (1<<k);
					#if 0
					// get rid of local dhcp server if mapping to bridge
					if ((REMOTE_ACCESS_T)pvcEntry.cmode == ACC_BRIDGED) {
						char phy[]="eth0_sw0";
						phy[7]='0'+k;
						// don't touch my dhcp server if mapping to bridge port
						// iptables -A inacc -i $LAN_IF -p UDP --dport 67 -j DROP
						va_cmd(IPTABLES, 10, 1, (char *)FW_ADD, (char *)FW_INACC,
						(char *)ARG_I, phy, "-p", (char *)ARG_UDP,
						(char *)FW_DPORT, (char *)PORT_DHCP, "-j", (char *)FW_DROP);
					}
					#else
					// get rid of local dhcp server if not belonging to default group
					// Commented by Mason Yu
					#if 0
					if (Port.itfGroup != 0) {
						char phy[]="eth0_sw0";
						phy[7]='0'+k;
						// iptables -A inacc -i $LAN_IF -p UDP --dport 67 -j DROP
						va_cmd(IPTABLES, 10, 1, (char *)FW_ADD, (char *)FW_INACC,
						(char *)ARG_I, phy, "-p", (char *)ARG_UDP,
						(char *)FW_DPORT, (char *)PORT_DHCP, "-j", (char *)FW_DROP);
					}
					#endif
					#endif
				}
			}
		}
#ifdef WLAN_SUPPORT
		// check for wlan0
		{
			mib_get(MIB_WLAN_ITF_GROUP, (void *)&wlangrp);
			if (wlangrp == pvcEntry.itfGroup) {
				// this lan port shares the same group with pvc, add as pvc's member
				if (vcIdx < MAX_VC_NUM) {
					mbr[vcIdx] |= (1<<IFWLAN_SHIFT);
					// get rid of local dhcp server if not belonging to default group
					// Commented by Mason Yu
					#if 0
					if (wlangrp != 0) {
						// iptables -A inacc -i $LAN_IF -p UDP --dport 67 -j DROP
						va_cmd(IPTABLES, 10, 1, (char *)FW_ADD, (char *)FW_INACC,
						(char *)ARG_I, (char *)WLANIF, "-p", (char *)ARG_UDP,
						(char *)FW_DPORT, (char *)PORT_DHCP, "-j", (char *)FW_DROP);
					}
					#endif
				}
			}
			
#ifdef WLAN_MBSSID
			for ( k=1; k<5; k++ ) {
				mib_get(MIB_WLAN_VAP0_ITF_GROUP+k-1, (void *)&wlangrp);
				if (wlangrp == pvcEntry.itfGroup) {
					// this lan port shares the same group with pvc, add as pvc's member
					if (vcIdx < MAX_VC_NUM) {
						mbr[vcIdx] |= (1<< (IFWLAN_SHIFT+k) );
						// get rid of local dhcp server if not belonging to default group
						// Commented by Mason Yu
						#if 0
						if (wlangrp != 0) {
							// iptables -A inacc -i $LAN_IF -p UDP --dport 67 -j DROP
							va_cmd(IPTABLES, 10, 1, (char *)FW_ADD, (char *)FW_INACC,
							(char *)ARG_I, (char *)WLANAPIF[k], "-p", (char *)ARG_UDP,
							(char *)FW_DPORT, (char *)PORT_DHCP, "-j", (char *)FW_DROP);
						}
						#endif
					}
				}
			}
#endif			
			
		}
#endif


		// device is mandatory
#ifdef CONFIG_USBCLIENT		
		mbr[vcIdx] |= 0x20;
#else
		mbr[vcIdx] |= 0x10;
#endif	
		
		/* set membership into vc */
		snprintf(wanif, 5, "vc%d", vcIdx);
		// mpoactl set vc0 group 1 member 3
		snprintf(msg.data, BUF_SIZE,
			"mpoactl set %s group 1 member %d",
			wanif, mbr[vcIdx]);
		TRACE(STA_SCRIPT, "%s\n", msg.data);
		write_to_mpoad(&msg);
		/* set membership into LAN ports */
		for (k=0; k<num; k++) {
			// Is this port a member ?
			if (mbr[vcIdx]&(1<<k)) {
				setup_8305_vlan_member(k, mbr[vcIdx]);
			}
		}
#ifdef WLAN_SUPPORT
#ifndef WLAN_MBSSID
		/* set membership into wlan0 */
		if (mbr[vcIdx]&(1<<IFWLAN_SHIFT))
			setup_wlan_group_member(0, mbr[vcIdx]);
			
#else
		for (k=0; k<5; k++) {
			if (mbr[vcIdx]&(1<<(IFWLAN_SHIFT+k)))
				setup_wlan_group_member(k, mbr[vcIdx]);
		}
#endif
#endif
	}
	
	// find the group which is not associated to the WAN port
	for (i=0; i<IFGROUP_NUM; i++) {
		int found, member;
		
		found = 0;
		total = mib_chain_total(MIB_ATM_VC_TBL);
		for (k=0; k<total; k++) {
			if (!mib_chain_get(MIB_ATM_VC_TBL, k, (void *)&pvcEntry))
				continue;
			if (!pvcEntry.enable)
				continue;
			if (pvcEntry.itfGroup == i)
				found = 1;
		}
		if (found)
			continue;
		// This is the outstanding group(i), do it ...
		member = 0;
		num = mib_chain_total(MIB_SW_PORT_TBL);
		for (k=0; k<num; k++) {
			if (!mib_chain_get(MIB_SW_PORT_TBL, k, (void *)&Port))
				continue;
			if (Port.itfGroup == i)
				member |= (1<<k);
		}
		
#ifdef WLAN_SUPPORT
		mib_get(MIB_WLAN_ITF_GROUP, (void *)&wlangrp);
		if (wlangrp == i)
			member |= (1<<IFWLAN_SHIFT);
			
#ifdef WLAN_MBSSID
		for ( k=1; k<5; k++) {
			mib_get( (MIB_WLAN_VAP0_ITF_GROUP+k-1), (void *)&wlanAPgrp[k]);
			if (wlanAPgrp[k] == i)
				member |= (1<< (IFWLAN_SHIFT+k) );
		}
#endif
#endif
		
		// device is mandatory
#ifdef CONFIG_USBCLIENT
             member |= 0x20;
		
#else
             member |= 0x10; 
#endif
		/* set membership into LAN ports */
		for (k=0; k<num; k++) {
			if (!mib_chain_get(MIB_SW_PORT_TBL, k, (void *)&Port))
				continue;
			if (Port.itfGroup == i)
				setup_8305_vlan_member(k, member);
		}
		
#ifdef WLAN_SUPPORT
#ifndef WLAN_MBSSID
		/* set membership into wlan0 */
		if (wlangrp == i)
			setup_wlan_group_member(0, member);
			
#else
		if (wlangrp == i)
			setup_wlan_group_member(0, member);
			
		for ( k=1; k<5; k++ ) {
			/* set membership into wlan0 */
			if (wlanAPgrp[k] == i)
				setup_wlan_group_member(k, member);
			
		}
#endif
#endif
	}
	// set port 4 member to all
#ifdef CONFIG_USBCLIENT
       setup_8305_vlan_member(5, 0x3f);
#else
	setup_8305_vlan_member(4, 0x1f);
#endif
	
	// enable Port Mapping
	__dev_setupPortMapping(1);
	// enable 8305 vlan
	setup_8305_vlan_enable();
	
	printf("Port Mapping: Ethernet to pvc mapping started\n");
}
#endif	// of ITF_GROUP
#endif // of CONFIG_EXT_SWITCH

// ioctl for direct bridge mode, jiunming
void __dev_setupDirectBridge(int flag)
{
	struct ifreq ifr;
	int ret;
	
	strcpy(ifr.ifr_name, "eth0");
	ifr.ifr_ifru.ifru_ivalue = flag;
#ifdef EMBED
	if( do_ioctl(SIOCDIRECTBR, &ifr)==0 ) {
		ret = 1;
		//printf("Set direct bridge mode %s!\n", flag?"enable":"disable" );
	}
	else {
		ret = 0;
		//printf("Set direct bridge mode error!\n");
	}
#endif

}

// Mason Yu, For Set IPQOS
#ifdef IP_QOS
int setIPQos(struct ifreq *ifr)
{
	int ret=0;
	
#ifdef EMBED		
	if (do_ioctl(SIOCSIPQOS, ifr) == 0)
		ret = 1;
	
#endif
	return ret;
}
#endif

// enable/disable IPQoS
void __dev_setupIPQoS(int flag)
{
#ifdef IP_QOS
	struct ifreq ifr;	
	struct ifIpQos ifipq;
	
	strcpy(ifr.ifr_name, "eth0");
	ifr.ifr_data = (char *)&ifipq;
	ifipq.cmd=SETIPQOS;
	ifipq.enable=flag;	
	setIPQos(&ifr);
	//printf("IPQoS: %s\n", flag?"enabled":"disabled");
#endif
}



#ifdef CONFIG_EXT_SWITCH
/*------------------------------------------------------------------
 * Set the group id into interface records.
 * where,
 * list: a list of interface id seperated by comma
 * grpnum: group id
 *-----------------------------------------------------------------*/
#ifdef ITF_GROUP
#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
void setitfPrio(int itfid,  enum PortMappingPriority prio)
{
	//interface id is  	0-255 physical lan port, 
	//				256- 1023   logic lan port, 
	//				1024.....      Wlans
	int itfdomain;
	int phyPort;
	int entryNum,i;
	ATM_QOS_T qos;
	//MIB_CE_IP_QOS_T Entry;
	//memset(&Entry, 0, sizeof(MIB_CE_IP_QOS_T));
	itfdomain = IF_DOMAIN(itfid);
	itfid = itfid&0x0ff;
	printf("setitfPrio: itfid=%08x, prio=%d\n ", itfid, prio);

	 if (itfdomain == DOMAIN_WAN) {
			MIB_CE_ATM_VC_T Entry;	
			MIB_CE_ATM_VC_T entry;	
			int k;
			int num;
			num = mib_chain_total(MIB_ATM_VC_TBL);
			for (i=0; i<num; i++) {
				if (!mib_chain_get(MIB_ATM_VC_TBL, i, (void *)&Entry))
					return;
				if (Entry.enable && Entry.ifIndex==itfid) {
					qos=prio2QoS[prio];
					Entry.qos=qos;
					switch(qos)
					{
						case ATMQOS_UBR:
							Entry.pcr=6000;
							break;
						case ATMQOS_CBR:
							Entry.pcr=6000;
							break;
						case ATMQOS_VBR_NRT:
						case ATMQOS_VBR_RT:
							Entry.pcr=6000;
							Entry.scr=5000;
							Entry.mbs=128;
							break;
						default:
							Entry.pcr=6000;
							break;
					}
					//Entry.itfGroup = grpnum;
					mib_chain_update(MIB_ATM_VC_TBL, (void *)&Entry, i);
					printf("QoS set: setitfPrio qos=%d\n", qos);
					// synchronize this vc across all interfaces
					for (k=i+1; k<num; k++) 
					{
						if (!mib_chain_get(MIB_ATM_VC_TBL, k, (void *)&entry)) 
						{
							return;
						}
						if (entry.vpi == Entry.vpi && entry.vci == Entry.vci) 
						{
							entry.qos = Entry.qos;
							entry.pcr = Entry.pcr;
							entry.cdvt = Entry.cdvt;
							entry.scr = Entry.scr;
							entry.mbs = Entry.mbs;
							// log message
							mib_chain_update(MIB_ATM_VC_TBL, (void *)&entry, k);
						}
					}
					break;
				}
			}
		}	
}
#endif



#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC) || defined(CONFIG_BOA_WEB_E8B_CH)
void setgroup(char *list, int grpnum, enum PortMappingPriority priority)
#else
void setgroup(char *list, int grpnum)
#endif
{
	int itfid, itfdomain;
	int i, num;
	char *arg0, *token;
	
	arg0=list;
	while ((token=strtok(arg0,","))!=NULL) {		
		itfid = atoi(token);		
#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
		setitfPrio(itfid, priority );
#endif		
		itfdomain = IF_DOMAIN(itfid);
		itfid = itfid&0x0ff;		

		if (itfdomain == DOMAIN_ELAN) {
			MIB_CE_SW_PORT_T Entry;
			
			num = mib_chain_total(MIB_SW_PORT_TBL);
			if (itfid < num) {
				if (!mib_chain_get(MIB_SW_PORT_TBL, itfid, (void *)&Entry))
					return;
				Entry.itfGroup = grpnum;
				mib_chain_update(MIB_SW_PORT_TBL, (void *)&Entry, itfid);
			}
		}
#ifdef WLAN_SUPPORT
		else if (itfdomain == DOMAIN_WLAN) {
			char mygroup;
			
			mygroup = (char)grpnum;			
			if (itfid == 0)
				mib_set(MIB_WLAN_ITF_GROUP, (void *)&mygroup);
				
			// Added by Mason Yu			
#ifdef WLAN_MBSSID
			for ( i=1; i<5; i++) {
				if (itfid == i) {// vap0								
					mib_set(MIB_WLAN_VAP0_ITF_GROUP+i-1, (void *)&mygroup);
				}
			}
			
#endif
		}
#endif		

		else if (itfdomain == DOMAIN_WAN) {
			MIB_CE_ATM_VC_T Entry;
			
			num = mib_chain_total(MIB_ATM_VC_TBL);
			for (i=0; i<num; i++) {
				if (!mib_chain_get(MIB_ATM_VC_TBL, i, (void *)&Entry))
					return;
				if (Entry.enable && Entry.ifIndex==itfid) {
					Entry.itfGroup = grpnum;
					mib_chain_update(MIB_ATM_VC_TBL, (void *)&Entry, i);
				}
			}
		}
		arg0=0;
	}
}

/*------------------------------------------------------------------
 * Get a list of interface info. (itfInfo) of group.
 * where,
 * info: a list of interface info entries
 * len: max length of the info list
 * grpnum: group id
 *-----------------------------------------------------------------*/
int get_group_ifinfo(struct itfInfo *info, int len, int grpnum)
{
	unsigned int swNum, vcNum;
	int i, num;
	char mygroup;
	char strlan[]="LAN0", strPPP[]="ppp0", strvc[]="vc0";
	MIB_CE_SW_PORT_T Entry;
	MIB_CE_ATM_VC_T pvcEntry;
#ifdef CTC_WAN_NAME
	char wanname[100];	
#endif

	// LAN ports
	swNum = mib_chain_total(MIB_SW_PORT_TBL);
	num=0;
	for (i=swNum; i>0; i--) {
		if (!mib_chain_get(MIB_SW_PORT_TBL, i-1, (void *)&Entry))
			return -1;
		if (Entry.itfGroup == grpnum) {
			strlan[3] = '0'+virt2user[i-1];
			info[num].ifdomain = DOMAIN_ELAN;
			info[num].ifid=i-1;
			strncpy(info[num].name, strlan, 8);
			num++;
		}
		if (num > len)
			break;
	}
	
#ifdef WLAN_SUPPORT
	// wlan0
	mib_get(MIB_WLAN_ITF_GROUP, (void *)&mygroup);
	if (mygroup == grpnum) {
		info[num].ifdomain = DOMAIN_WLAN;
		info[num].ifid=0;
#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
		sprintf(info[num].name, "SSID1(root)");
#else
		strncpy(info[num].name, (char *)WLANIF, 8);
#endif
		num++;
	}
#endif
	
#ifdef WLAN_MBSSID
	for (i=1; i<5; i++) {
		mib_get(MIB_WLAN_VAP0_ITF_GROUP+i-1, (void *)&mygroup);	
		if (mygroup == grpnum) {
			info[num].ifdomain = DOMAIN_WLAN;
			info[num].ifid=i;
			//strncpy(info[num].name, "vap0", 8);
#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
			sprintf(info[num].name, "SSID%d", i+1);
#else
			sprintf(info[num].name, "vap%d", i-1);
#endif
			num++;
		}
	}	

#endif	
	
	// vc
	vcNum = mib_chain_total(MIB_ATM_VC_TBL);
	
	for (i=0; i<vcNum; i++) {
		if (!mib_chain_get(MIB_ATM_VC_TBL, i, (void *)&pvcEntry))
		{
  			//websError(wp, 400, T("Get chain record error!\n"));
  			printf("Get chain record error!\n");
			return -1;
		}
		
		if (pvcEntry.enable == 0 || pvcEntry.itfGroup!=grpnum)
			continue;

#ifdef CTC_WAN_NAME
		getWanName(&pvcEntry, wanname);
		info[num].ifdomain = DOMAIN_WAN;
		info[num].ifid=pvcEntry.ifIndex;
		strncpy(info[num].name, wanname, 30);
		num++;
#else
		if (PPP_INDEX(pvcEntry.ifIndex) != 0x0f)
		{	// PPP interface
			strPPP[3] = '0'+PPP_INDEX(pvcEntry.ifIndex);
			info[num].ifdomain = DOMAIN_WAN;
			info[num].ifid=pvcEntry.ifIndex;
			strncpy(info[num].name, strPPP, 8);
			num++;
		}
		else
		{	// vc interface
			strvc[2] = '0'+VC_INDEX(pvcEntry.ifIndex);
			info[num].ifdomain = DOMAIN_WAN;
			info[num].ifid=pvcEntry.ifIndex;
			strncpy(info[num].name, strvc, 8);
			num++;
		}
#endif		
		if (num > len)
			break;
	}
	
	return num;
}
#endif	// of ITF_GROUP
#endif // of CONFIG_EXT_SWITCH

/*------------------------------------------------------------------
 * Get a list of interface info. (itfInfo) of the specified ifdomain.
 * where,
 * info: a list of interface info entries
 * len: max length of the info list
 * ifdomain: interface domain
 *-----------------------------------------------------------------*/
int get_domain_ifinfo(struct itfInfo *info, int len, int ifdomain)
{
	unsigned int swNum, vcNum;
	int i, num;
	char mygroup;
	char strlan[]="LAN0", strPPP[]="ppp0", strvc[]="vc0";
	//MIB_CE_SW_PORT_T Entry;
	//MIB_CE_ATM_VC_Tp pvcEntry;
	MIB_CE_ATM_VC_T pvcEntry;
	num=0;
	
	if (ifdomain&DOMAIN_ELAN) {
		// LAN ports
#if (defined(CONFIG_EXT_SWITCH)  && defined (IP_QOS_VPORT))
//#ifdef CONFIG_EXT_SWITCH
		swNum = mib_chain_total(MIB_SW_PORT_TBL);
		for (i=swNum; i>0; i--) {
			//if (!mib_chain_get(MIB_SW_PORT_TBL, i-1, (void *)&Entry))
			//	return -1
			strlan[3] = '0'+virt2user[i-1];
			info[num].ifdomain = DOMAIN_ELAN;
			info[num].ifid=i-1;
			strncpy(info[num].name, strlan, 8);
			num++;
			if (num > len)
				break;
		}
#else
		info[num].ifdomain = DOMAIN_ELAN;
		info[num].ifid=0;
		strncpy(info[num].name, strlan, 8);
		num++;
#endif
	}
	
#ifdef WLAN_SUPPORT
	if (ifdomain&DOMAIN_WLAN) {
		// wlan0
		mib_get(MIB_WLAN_ITF_GROUP, (void *)&mygroup);
		info[num].ifdomain = DOMAIN_WLAN;
		info[num].ifid=0;
#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
		sprintf(info[num].name, "SSID1(root)");
#else
		strncpy(info[num].name, (char *)WLANIF, 8);
#endif
		num++;
	}
//jim luo add it to support QoS on Virtual AP...

#ifdef WLAN_MBSSID
	for (i=1; i<5; i++) {
		mib_get(MIB_WLAN_VAP0_ITF_GROUP+i-1, (void *)&mygroup);	
		info[num].ifdomain = DOMAIN_WLAN;
		info[num].ifid=i;
		//strncpy(info[num].name, "vap0", 8);
#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
		sprintf(info[num].name, "SSID%d", i+1);
#else
		sprintf(info[num].name, "vap%d", i-1);
#endif
		num++;
	}	

#endif	


	
#endif
	
	if (ifdomain&DOMAIN_WAN) {
		// vc
		vcNum = mib_chain_total(MIB_ATM_VC_TBL);
		
		for (i=0; i<vcNum; i++) {
			if (!mib_chain_get(MIB_ATM_VC_TBL, i, (void *)&pvcEntry))
			{
  				//websError(wp, 400, T("Get chain record error!\n"));
  				printf("Get chain record error!\n");
				return -1;
			}
			
			if (pvcEntry.enable == 0)
				continue;
			
			if (PPP_INDEX(pvcEntry.ifIndex) != 0x0f)
			{	// PPP interface
				strPPP[3] = '0'+PPP_INDEX(pvcEntry.ifIndex);
				info[num].ifdomain = DOMAIN_WAN;
				info[num].ifid=pvcEntry.ifIndex;
				strncpy(info[num].name, strPPP, 8);
				num++;
			}
			else
			{	// vc interface
				strvc[2] = '0'+VC_INDEX(pvcEntry.ifIndex);
				info[num].ifdomain = DOMAIN_WAN;
				info[num].ifid=pvcEntry.ifIndex;
				strncpy(info[num].name, strvc, 8);
				num++;
			}
			
			if (num > len)
				break;
		}
	}
	
	return num;
}


short Max(short* array, int len)
{
	short rValue = array[0];
	int idx;

	for(idx=1;idx<len;idx++) {
		if(array[idx] > rValue)
			rValue = array[idx];
	}
		
	return rValue;	
}

short Min(short* array, int len)
{
	short rValue = array[0];
	int idx;

	for(idx=1;idx<len;idx++) {
		if(array[idx] < rValue)
			rValue = array[idx];
	}
		
	return rValue;	
}

int read_pid(char *filename)
{
	int fh;
	FILE *in;
	int pid;

	fh = open(filename, O_RDWR);
	if ( fh == -1 ) return -1;
	if ((in = fdopen(fh, "r")) == NULL) return -1;
	fscanf(in, "%d", &pid);
	fclose(in);
	close(fh);

	return pid;
}

// Added by Kaohj
//return 0:OK, other:fail
int do_cmd(const char *filename, char *argv [], int dowait)
{
	pid_t pid, wpid;
	int stat=0, st;
	
	if((pid = vfork()) == 0) {
		/* the child */
		char *env[3];
		
		signal(SIGINT, SIG_IGN);
		argv[0] = (char *)filename;
		env[0] = "PATH=/bin:/usr/bin:/etc:/sbin:/usr/sbin";
		env[1] = NULL;

		execve(filename, argv, env);

		printf("exec %s failed\n", filename);
		_exit(2);
	} else if(pid > 0) {
		if (!dowait)
			stat = 0;
		else {
			/* parent, wait till rc process dies before spawning */
			while ((wpid = wait(&st)) != pid)
				if (wpid == -1 && errno == ECHILD) { /* see wait(2) manpage */
					stat = 0;
					break;
				}
		}
	} else if(pid < 0) {
		printf("fork of %s failed\n", filename);
		stat = -1;
	}
	st = WEXITSTATUS(stat);
	return st;
}

//return 0:OK, other:fail
int va_cmd(const char *cmd, int num, int dowait, ...)
{
	va_list ap;
	int k;
	char *s;
	char *argv[24];
	int status;
	
	TRACE(STA_SCRIPT, "%s ", cmd);
	va_start(ap, dowait);
	
	for (k=0; k<num; k++)
	{
		s = va_arg(ap, char *);
		argv[k+1] = s;
		TRACE(STA_SCRIPT|STA_NOTAG, "%s ", s);
	}
	
	TRACE(STA_SCRIPT|STA_NOTAG, "\n");
	argv[k+1] = NULL;
	status = do_cmd(cmd, argv, dowait);
	va_end(ap);
	
	return status;
}

//return 0:OK, other:fail
/*same function as va_cmd(). Execute silently. 
  No print out command string in console.
*/
int va_cmd_no_echo(const char *cmd, int num, int dowait, ...)
{
	va_list ap;
	int k;
	char *s;
	char *argv[24];
	int status;
	
	//TRACE(STA_SCRIPT, "%s ", cmd);
	va_start(ap, dowait);
	
	for (k=0; k<num; k++)
	{
		s = va_arg(ap, char *);
		argv[k+1] = s;
		//TRACE(STA_SCRIPT|STA_NOTAG, "%s ", s);
	}
	
	//TRACE(STA_SCRIPT|STA_NOTAG, "\n");
	argv[k+1] = NULL;
	status = do_cmd(cmd, argv, dowait);
	va_end(ap);
	
	return status;
}

//return 0:OK, other:fail
int call_cmd(const char *filename, int num, int dowait, ...)
{
	va_list ap;
	char *s;
	char *argv[24];
	int status=0, st, k;
	pid_t pid, wpid;
	
	va_start(ap, dowait);
	
	for (k=0; k<num; k++)
	{
		s = va_arg(ap, char *);
		argv[k+1] = s;
	}
	
	argv[k+1] = NULL;
	if((pid = vfork()) == 0) {
		/* the child */
		char *env[3];
		
		signal(SIGINT, SIG_IGN);
		argv[0] = (char *)filename;
		env[0] = "PATH=/bin:/usr/bin:/etc:/sbin:/usr/sbin";
		env[1] = NULL;

		execve(filename, argv, env);

		printf("exec %s failed\n", filename);
		_exit(2);
	} else if(pid > 0) {
		if (!dowait)
			status = 0;
		else {
			/* parent, wait till rc process dies before spawning */
			while ((wpid = wait(&st)) != pid)
				if (wpid == -1 && errno == ECHILD) { /* see wait(2) manpage */
					break;
				}
		}
	} else if(pid < 0) {
		printf("fork of %s failed\n", filename);
		status = -1;
	}
	if (wpid>0)
		if (WIFEXITED(st))
			status = WEXITSTATUS(st);
//			printf("Child exited with RC=%d\n",WEXITSTATUS(st));
	va_end(ap);
	
	return status;
}

void write_to_pppd(struct data_to_pass_st *pmsg)
{
	int pppd_fifo_fd=-1;
	
	pppd_fifo_fd = open(PPPD_FIFO, O_WRONLY);
	if (pppd_fifo_fd == -1)
		fprintf(stderr, "Sorry, no spppd server\n");
	else
	{
		write(pppd_fifo_fd, pmsg, sizeof(*pmsg));
		close(pppd_fifo_fd);
	}
}

// return value:
// 0  : successful
// -1 : failed
int write_to_mpoad(struct data_to_pass_st *pmsg)
{
	int mpoad_fifo_fd=-1;
	int status=0;
	int ret=0;	
	
	mpoad_fifo_fd = open(MPOAD_FIFO, O_WRONLY);
	if (mpoad_fifo_fd == -1) {
		fprintf(stderr, "Sorry, no mpoad server\n");
		status = -1;
	} else
	{
		// Modified by Mason Yu
		//write(mpoad_fifo_fd, pmsg, sizeof(*pmsg));
REWRITE:
		ret = write(mpoad_fifo_fd, pmsg, sizeof(*pmsg));
		if(ret<0 && errno==EPIPE)
			 goto REWRITE;
		usleep(30*1000);
		
		close(mpoad_fifo_fd);
		// wait server to consume it
		usleep(1000);
	}
	return status;
}

static void WRITE_DHCPC_FILE(int fh, unsigned char *buf)
{
	if ( write(fh, buf, strlen(buf)) != strlen(buf) ) {
		printf("Write udhcpc script file error!\n");
		close(fh);
	}
}

static void write_to_dhcpc_script(char *fname, MIB_CE_ATM_VC_Tp pEntry)
{
	int fh;
	int mark;
	char buff[64];
#ifdef DEFAULT_GATEWAY_V2
	unsigned char dgw;
#endif
#ifdef IP_POLICY_ROUTING
	int i, num, found;
	MIB_CE_IP_QOS_T qEntry;
#endif
	
	fh = open(fname, O_RDWR|O_CREAT|O_TRUNC, S_IXUSR);
	
	if (fh == -1) {
		printf("Create udhcpc script file %s error!\n", fname);
		return;
	}
	
	WRITE_DHCPC_FILE(fh, "#!/bin/sh\n");
	WRITE_DHCPC_FILE(fh, "RESOLV_CONF=\"/var/udhcpc/resolv.conf\"\n");
	WRITE_DHCPC_FILE(fh, "[ \"$broadcast\" ] && BROADCAST=\"broadcast $broadcast\"\n");
	WRITE_DHCPC_FILE(fh, "[ \"$subnet\" ] && NETMASK=\"netmask $subnet\"\n");
	WRITE_DHCPC_FILE(fh, "ifconfig $interface $ip $BROADCAST $NETMASK -pointopoint\n");
	WRITE_DHCPC_FILE(fh, "MER_GW_INFO=\"/tmp/MERgw.\"$interface\n");	// Jenny, write MER1483 gateway info
	WRITE_DHCPC_FILE(fh, "\techo $router > $MER_GW_INFO\n");
	
#ifdef DEFAULT_GATEWAY_V2
	mib_get( MIB_ADSL_WAN_DGW_ITF, (void *)&dgw);	// Jenny, check default gateway
	if ((dgw == pEntry->ifIndex)
#ifdef AUTO_PPPOE_ROUTE
		 || (dgw == DGW_AUTO && (REMOTE_ACCESS_T)pEntry->cmode == ACC_MER)
#endif
	) {
#else
	if (pEntry->dgw) {
#endif
		WRITE_DHCPC_FILE(fh, "if [ \"$router\" ]; then\n");
		WRITE_DHCPC_FILE(fh, "\twhile route del -net default gw 0.0.0.0 dev $interface\n");
		WRITE_DHCPC_FILE(fh, "\tdo :\n");
		WRITE_DHCPC_FILE(fh, "\tdone\n\n");
		WRITE_DHCPC_FILE(fh, "\tfor i in $router\n");
		WRITE_DHCPC_FILE(fh, "\tdo\n");
		WRITE_DHCPC_FILE(fh, "\tifconfig $interface pointopoint $i\n");
		WRITE_DHCPC_FILE(fh, "\troute add -net default gw $i dev $interface\n");
		WRITE_DHCPC_FILE(fh, "\tdone\n");
		WRITE_DHCPC_FILE(fh, "\tifconfig $interface -pointopoint\n");
		WRITE_DHCPC_FILE(fh, "fi\n");
	}
	
	WRITE_DHCPC_FILE(fh, "if [ \"$dns\" ]; then\n");
	WRITE_DHCPC_FILE(fh, "\trm $RESOLV_CONF\n");
	WRITE_DHCPC_FILE(fh, "\tfor i in $dns\n");
	WRITE_DHCPC_FILE(fh, "\tdo\n");
	WRITE_DHCPC_FILE(fh, "\techo 'DNS=' $i\n");
	WRITE_DHCPC_FILE(fh, "\techo nameserver $i >> $RESOLV_CONF\n");
	WRITE_DHCPC_FILE(fh, "\tdone\n");
	WRITE_DHCPC_FILE(fh, "fi\n");
#ifdef IP_POLICY_ROUTING
	num = mib_chain_total(MIB_IP_QOS_TBL);
	found = 0;
	// set advanced-routing rule
	for (i=0; i<num; i++) {
		if (!mib_chain_get(MIB_IP_QOS_TBL, i, (void *)&qEntry))
			continue;
		if (qEntry.outif == pEntry->ifIndex) {
			
			found = 1;
			mark = get_classification_mark(i);
			if (mark != 0) {
				WRITE_DHCPC_FILE(fh, "if [ \"$router\" ]; then\n");
				snprintf(buff, 64, "\tip ru add fwmark %x table %d\n", mark, VC_INDEX(pEntry->ifIndex)+PR_VC_START);
				WRITE_DHCPC_FILE(fh, buff);
			}
		}
	}
	if (found) {
		snprintf(buff, 64, "\tip ro add default via $router dev $interface table %d\n", VC_INDEX(pEntry->ifIndex)+PR_VC_START);
		WRITE_DHCPC_FILE(fh, buff);
		WRITE_DHCPC_FILE(fh, "fi\n");
	}
#endif
	close(fh);
}

// DHCP client configuration
// return value:
// 1  : successful
int startDhcpc(char *inf, MIB_CE_ATM_VC_Tp pEntry)
{
	unsigned char value[32];
	FILE *fp;
	DNS_TYPE_T dnsMode;
	char * argv[9];
	unsigned int i, vcTotal, resolvopt;
	
	argv[1] = inf;
	argv[2] = "up";
	argv[3] = NULL;
	TRACE(STA_SCRIPT, "%s %s %s\n", IFCONFIG, argv[1], argv[2]);
	do_cmd(IFCONFIG, argv, 1);
	
	// udhcpc -i vc0 -p pid -s script
	argv[1] = (char *)ARG_I;
	argv[2] = inf;
	argv[3] = "-p";
#if defined(ZTE_GENERAL_ROUTER_SC)||defined(CONFIG_BOA_WEB_E8B_CH)
	unsigned char pidfile[32];
	snprintf(pidfile, 32, "/var/run/udhcpc%s.pid", inf);
//	printf("\nstartudhcpc:pidfile=%s\n",pidfile);
	argv[4] = pidfile;
#else
	argv[4] = (char *)DHCPC_PID;
#endif
	argv[5] = "-s";
	snprintf(value, 32, "%s.%s", (char *)DHCPC_SCRIPT_NAME, inf);
	write_to_dhcpc_script(value, pEntry);
	argv[6] = (char *)DHCPC_SCRIPT;
	argv[7] = NULL;
	
	if (strcmp(inf, LANIF) == 0)
	{
		// LAN interface
		// enable Microsoft auto IP configuration
		argv[7] = "-a";
		argv[8] = NULL;
	}
	
	TRACE(STA_SCRIPT, "%s %s %s %s ", DHCPC, argv[1], argv[2], argv[3]);
	TRACE(STA_SCRIPT, "%s %s %s\n", argv[4], argv[5], argv[6]);
	do_cmd(DHCPC, argv, 0);
	
	return 1;
}

#ifdef ADDRESS_MAPPING
#ifdef MULTI_ADDRESS_MAPPING

char* addrMap_str[5] = {"None","One_to_one","Many_to_one","Many_to_many","One_to_many"};
char* getaddrmappingstr( unsigned int idx)
{
	return addrMap_str[idx];
}
unsigned int getaddrmappingidx(char *str)
{
	unsigned int idx;
	for (idx = 0;idx<5;idx++)
	{
		if (!strcmp(str,addrMap_str[idx]))
			 return idx;
	}

	 return 0;
}


int GetIP_AddressMap(MIB_MULTI_ADDR_MAPPING_LIMIT_T *entry, ADDRESSMAP_IP_T *ip_info)
{
	unsigned char value[32];		     

        // Get Local Start IP
	if (((struct in_addr *)entry->lsip)->s_addr != 0)
	{
		strncpy(ip_info->lsip, inet_ntoa(*((struct in_addr *)entry->lsip)), 16);
		ip_info->lsip[15] = '\0';
	}
	else
		ip_info->lsip[0] = '\0';

	
	// Get Local End IP
	if (((struct in_addr *)entry->leip)->s_addr != 0)
	{
		strncpy(ip_info->leip, inet_ntoa(*((struct in_addr *)entry->leip)), 16);
		ip_info->leip[15] = '\0';
	}
	else
		ip_info->leip[0] = '\0';
	
	// Get Global Start IP
	if (((struct in_addr *)entry->gsip)->s_addr != 0)
	{
		strncpy(ip_info->gsip, inet_ntoa(*((struct in_addr *)entry->gsip)), 16);
		ip_info->gsip[15] = '\0';
	}
	else
		ip_info->gsip[0] = '\0';
	
	// Get Global End IP
	if (((struct in_addr *)entry->geip)->s_addr != 0)
	{
		strncpy(ip_info->geip, inet_ntoa(*((struct in_addr *)entry->geip)), 16);
		ip_info->geip[15] = '\0';
	}
	else
		ip_info->geip[0] = '\0';	
	
	sprintf(ip_info->srcRange, "%s-%s", ip_info->lsip, ip_info->leip);
	sprintf(ip_info->globalRange, "%s-%s", ip_info->gsip, ip_info->geip);
//	printf( "\r\nGetIP_AddressMap %s-%s", ip_info->lsip, ip_info->leip);
//	printf( "\r\nGetIP_AddressMap %s-%s", ip_info->gsip, ip_info->geip);
	return 1;
}

#else //!MULTI_ADDRESS_MAPPING
int GetIP_AddressMap(ADDRESSMAP_IP_T *ip_info)
{		
	unsigned char value[32];		
        
        // Get Local Start IP
        if (mib_get(MIB_LOCAL_START_IP, (void *)value) != 0)
	{
		if (((struct in_addr *)value)->s_addr != 0)
		{
			strncpy(ip_info->lsip, inet_ntoa(*((struct in_addr *)value)), 16);
			ip_info->lsip[15] = '\0';
		}
		else
			ip_info->lsip[0] = '\0';
	}
	
	// Get Local End IP
        if (mib_get(MIB_LOCAL_END_IP, (void *)value) != 0)
	{
		if (((struct in_addr *)value)->s_addr != 0)
		{
			strncpy(ip_info->leip, inet_ntoa(*((struct in_addr *)value)), 16);
			ip_info->leip[15] = '\0';
		}
		else
			ip_info->leip[0] = '\0';
	}
	
	// Get Global Start IP
	if (mib_get(MIB_GLOBAL_START_IP, (void *)value) != 0)
	{
		if (((struct in_addr *)value)->s_addr != 0)
		{
			strncpy(ip_info->gsip, inet_ntoa(*((struct in_addr *)value)), 16);
			ip_info->gsip[15] = '\0';
		}
		else
			ip_info->gsip[0] = '\0';
	}
	
	// Get Global End IP
	if (mib_get(MIB_GLOBAL_END_IP, (void *)value) != 0)
	{
		if (((struct in_addr *)value)->s_addr != 0)
		{
			strncpy(ip_info->geip, inet_ntoa(*((struct in_addr *)value)), 16);
			ip_info->geip[15] = '\0';
		}
		else
			ip_info->geip[0] = '\0';
	}	
	
	sprintf(ip_info->srcRange, "%s-%s", ip_info->lsip, ip_info->leip);
	sprintf(ip_info->globalRange, "%s-%s", ip_info->gsip, ip_info->geip);
	
	return 1;
}
#endif //end of !MULTI_ADDRESS_MAPPING
#endif

// Setup one NAT rule for a specfic interface
int startAddressMap(MIB_CE_ATM_VC_Tp pEntry)
{
	char wanif[6];
	char myip[16];
#ifdef ADDRESS_MAPPING
	ADDRESSMAP_IP_T ip_info;
#ifdef MULTI_ADDRESS_MAPPING
	MIB_MULTI_ADDR_MAPPING_LIMIT_T		entry;
	int		i,entryNum;


#else // ! MULTI_ADDRESS_MAPPING
	char vChar;
	ADSMAP_T mapType;
	
	GetIP_AddressMap(&ip_info);
	
	mib_get( MIB_ADDRESS_MAP_TYPE,  (void *)&vChar);
        mapType = (ADSMAP_T)vChar;
#endif  //end of !MULTI_ADDRESS_MAPPING		
#endif

	if ( !pEntry->enable || ((DHCP_T)pEntry->ipDhcp != DHCP_DISABLED)
		|| ((REMOTE_ACCESS_T)pEntry->cmode == ACC_BRIDGED)    
		|| ((REMOTE_ACCESS_T)pEntry->cmode == ACC_PPPOE)
		|| ((REMOTE_ACCESS_T)pEntry->cmode == ACC_PPPOA)
		|| (!pEntry->napt)
		)
		return -1;
	
	snprintf(wanif, 6, "vc%u", VC_INDEX(pEntry->ifIndex));
	strncpy(myip, inet_ntoa(*((struct in_addr *)pEntry->ipAddr)), 16);
	myip[15] = '\0';

#ifdef ADDRESS_MAPPING
#ifdef MULTI_ADDRESS_MAPPING
	entryNum = mib_chain_total(MULTI_ADDRESS_MAPPING_LIMIT_TBL);

	for (i = 0; i<entryNum; i++)
	{
		mib_chain_get(MULTI_ADDRESS_MAPPING_LIMIT_TBL, i, &entry);
		GetIP_AddressMap(&entry, &ip_info);

		// add customized mapping
		if ( entry.addressMapType == ADSMAP_ONE_TO_ONE ) {				
			va_cmd(IPTABLES, 12, 1, "-t", "nat", FW_ADD, "POSTROUTING", "-s", ip_info.lsip,
				ARG_O, wanif, "-j", "SNAT", "--to-source", ip_info.gsip);					
			
		} 
		else if ( entry.addressMapType == ADSMAP_MANY_TO_ONE ) {
			va_cmd(IPTABLES, 14, 1, "-t", "nat", FW_ADD, "POSTROUTING", "-m", "iprange", "--src-range", ip_info.srcRange,
				ARG_O, wanif, "-j", "SNAT", "--to-source", ip_info.gsip);
			
		} 
		else if ( entry.addressMapType == ADSMAP_MANY_TO_MANY ) {
			va_cmd(IPTABLES, 14, 1, "-t", "nat", FW_ADD, "POSTROUTING", "-m", "iprange", "--src-range", ip_info.srcRange,
				ARG_O, wanif, "-j", "SNAT", "--to-source", ip_info.globalRange);
			
		}
		else if ( entry.addressMapType == ADSMAP_ONE_TO_MANY ) {
			va_cmd(IPTABLES, 12, 1, "-t", "nat", FW_ADD, "POSTROUTING", "-s", ip_info.lsip,
				ARG_O, wanif, "-j", "SNAT", "--to-source", ip_info.globalRange);			
		}		
		
	}
#else //!MULTI_ADDRESS_MAPPING
	// add customized mapping
	if ( mapType == ADSMAP_ONE_TO_ONE ) {				
		va_cmd(IPTABLES, 12, 1, "-t", "nat", FW_ADD, "POSTROUTING", "-s", ip_info.lsip,
			ARG_O, wanif, "-j", "SNAT", "--to-source", ip_info.gsip);					
		
	} 
	else if ( mapType == ADSMAP_MANY_TO_ONE ) {		
		va_cmd(IPTABLES, 14, 1, "-t", "nat", FW_ADD, "POSTROUTING", "-m", "iprange", "--src-range", ip_info.srcRange,
			ARG_O, wanif, "-j", "SNAT", "--to-source", ip_info.gsip);
		
	} 
	else if ( mapType == ADSMAP_MANY_TO_MANY ) {
		va_cmd(IPTABLES, 14, 1, "-t", "nat", FW_ADD, "POSTROUTING", "-m", "iprange", "--src-range", ip_info.srcRange,
			ARG_O, wanif, "-j", "SNAT", "--to-source", ip_info.globalRange);
		
	}
	// Mason Yu on True
#if 1
	else if ( mapType == ADSMAP_ONE_TO_MANY ) {
		va_cmd(IPTABLES, 12, 1, "-t", "nat", FW_ADD, "POSTROUTING", "-s", ip_info.lsip,
			ARG_O, wanif, "-j", "SNAT", "--to-source", ip_info.globalRange);
		
	}
#endif
#endif //end of !MULTI_ADDRESS_MAPPING	
#endif
	// add default mapping
	va_cmd(IPTABLES, 10, 1, "-t", "nat", FW_ADD, "POSTROUTING",
		ARG_O, wanif, "-j", "SNAT", "--to-source", myip);


}

// Delete one NAT rule for a specfic interface
void stopAddressMap(MIB_CE_ATM_VC_Tp pEntry)
{
	char *argv[16];
	char wanif[6];
	char myip[16];

#ifdef ADDRESS_MAPPING
	ADDRESSMAP_IP_T ip_info;
#ifdef MULTI_ADDRESS_MAPPING
	MIB_MULTI_ADDR_MAPPING_LIMIT_T		entry;
	int		i,entryNum;


#else //MULTI_ADDRESS_MAPPING
	char vChar;
	ADSMAP_T mapType;
	
	GetIP_AddressMap(&ip_info);
	
	mib_get( MIB_ADDRESS_MAP_TYPE,  (void *)&vChar);
        mapType = (ADSMAP_T)vChar;
#endif //!MULTI_ADDRESS_MAPPING		
#endif

	if ( !pEntry->enable || ((DHCP_T)pEntry->ipDhcp != DHCP_DISABLED)
		|| ((REMOTE_ACCESS_T)pEntry->cmode == ACC_BRIDGED)    
		|| ((REMOTE_ACCESS_T)pEntry->cmode == ACC_PPPOE)
		|| ((REMOTE_ACCESS_T)pEntry->cmode == ACC_PPPOA)
		|| (!pEntry->napt)
		)
		return;
	
	snprintf(wanif, 6, "vc%u", VC_INDEX(pEntry->ifIndex));
	strncpy(myip, inet_ntoa(*((struct in_addr *)pEntry->ipAddr)), 16);
	myip[15] = '\0';
	
	if (pEntry->cmode != ACC_BRIDGED && pEntry->napt == 1)
	{	// Enable NAPT
		argv[1] = "-t";
		argv[2] = "nat";
		argv[3] = (char *)FW_DEL;
		argv[4] = "POSTROUTING";
		
		// remove default mapping
		argv[5] = "-o";
		argv[6] = wanif;
		argv[7] = "-j";
		if ((DHCP_T)pEntry->ipDhcp == DHCP_DISABLED) {
			strncpy(myip, inet_ntoa(*((struct in_addr *)pEntry->ipAddr)), 16);
			myip[15] = '\0';
			argv[8] = "SNAT";
			argv[9] = "--to-source";
			argv[10] = myip;
			argv[11] = NULL;
		}
		else {
			argv[8] = "MASQUERADE";
			argv[9] = NULL;
		}
		do_cmd(IPTABLES, argv, 1);

#ifdef ADDRESS_MAPPING
#ifdef MULTI_ADDRESS_MAPPING
		entryNum = mib_chain_total(MULTI_ADDRESS_MAPPING_LIMIT_TBL);

		for (i = 0; i<entryNum; i++)
		{			
			mib_chain_get(MULTI_ADDRESS_MAPPING_LIMIT_TBL, i, &entry);
			GetIP_AddressMap(&entry, &ip_info);
			
			// remove customized mapping
			if ( entry.addressMapType  == ADSMAP_ONE_TO_ONE ) {
				argv[5] = "-s";
				argv[6] = ip_info.lsip;
				argv[7] = "-o";
				argv[8] = wanif;			
				argv[9] = "-j";
				if ((DHCP_T)pEntry->ipDhcp == DHCP_DISABLED) {				
					argv[10] = "SNAT";
					argv[11] = "--to-source";
					argv[12] = ip_info.gsip;
					argv[13] = NULL;
				}
				else {
					argv[8] = "MASQUERADE";
					argv[9] = NULL;
				}			
				
			} else if ( entry.addressMapType  == ADSMAP_MANY_TO_ONE ) {		

				argv[5] = "-m";
				argv[6] = "iprange";
				argv[7] = "--src-range";
				argv[8] = ip_info.srcRange;	
				argv[9] = "-o";
				argv[10] = wanif;
				argv[11] = "-j";

				if ((DHCP_T)pEntry->ipDhcp == DHCP_DISABLED) {				
					argv[12] = "SNAT";
					argv[13] = "--to-source";
					argv[14] = ip_info.gsip;
					argv[15] = NULL;
				}
				else {
					argv[8] = "MASQUERADE";
					argv[9] = NULL;
				}			
				
			} else if ( entry.addressMapType  == ADSMAP_MANY_TO_MANY ) {			
				argv[5] = "-m";
				argv[6] = "iprange";
				argv[7] = "--src-range";
				argv[8] = ip_info.srcRange;	
				argv[9] = "-o";
				argv[10] = wanif;
				argv[11] = "-j";
				if ((DHCP_T)pEntry->ipDhcp == DHCP_DISABLED) {				
					argv[12] = "SNAT";
					argv[13] = "--to-source";
					argv[14] = ip_info.globalRange;
					argv[15] = NULL;
				}
				else {
					argv[8] = "MASQUERADE";
					argv[9] = NULL;
				}			
				
			} 
			
			else if ( entry.addressMapType  == ADSMAP_ONE_TO_MANY ) {
				argv[5] = "-s";
				argv[6] = ip_info.lsip;
				argv[7] = "-o";
				argv[8] = wanif;			
				argv[9] = "-j";			
				if ((DHCP_T)pEntry->ipDhcp == DHCP_DISABLED) {				
					argv[10] = "SNAT";
					argv[11] = "--to-source";
					argv[12] = ip_info.globalRange;
					argv[13] = NULL;
				}
				else {
					argv[8] = "MASQUERADE";
					argv[9] = NULL;
				}			
			}

			else
				return;
			TRACE(STA_SCRIPT, "%s %s %s %s %s ", IPTABLES, argv[1], argv[2], argv[3], argv[4]);
			TRACE(STA_SCRIPT, "%s %s %s %s\n", argv[5], argv[6], argv[7], argv[8]);		
			do_cmd(IPTABLES, argv, 1);
		}
#else //!MULTI_ADDRESS_MAPPING
		// remove customized mapping
		if ( mapType == ADSMAP_ONE_TO_ONE ) {
			argv[5] = "-s";
			argv[6] = ip_info.lsip;
			argv[7] = "-o";
			argv[8] = wanif;			
			argv[9] = "-j";
			if ((DHCP_T)pEntry->ipDhcp == DHCP_DISABLED) {				
				argv[10] = "SNAT";
				argv[11] = "--to-source";
				argv[12] = ip_info.gsip;
				argv[13] = NULL;
			}
			else {
				argv[8] = "MASQUERADE";
				argv[9] = NULL;
			}			
			
		} else if ( mapType == ADSMAP_MANY_TO_ONE ) {			
			argv[5] = "-m";
			argv[6] = "iprange";
			argv[7] = "--src-range";
			argv[8] = ip_info.srcRange;	
			argv[9] = "-o";
			argv[10] = wanif;
			argv[11] = "-j";
			if ((DHCP_T)pEntry->ipDhcp == DHCP_DISABLED) {				
				argv[12] = "SNAT";
				argv[13] = "--to-source";
				argv[14] = ip_info.gsip;
				argv[15] = NULL;
			}
			else {
				argv[8] = "MASQUERADE";
				argv[9] = NULL;
			}			
			
		} else if ( mapType == ADSMAP_MANY_TO_MANY ) {			
			argv[5] = "-m";
			argv[6] = "iprange";
			argv[7] = "--src-range";
			argv[8] = ip_info.srcRange;	
			argv[9] = "-o";
			argv[10] = wanif;
			argv[11] = "-j";
			if ((DHCP_T)pEntry->ipDhcp == DHCP_DISABLED) {				
				argv[12] = "SNAT";
				argv[13] = "--to-source";
				argv[14] = ip_info.globalRange;
				argv[15] = NULL;
			}
			else {
				argv[8] = "MASQUERADE";
				argv[9] = NULL;
			}			
			
		} 
		
		// Msason Yu on True
#if 1
		else if ( mapType == ADSMAP_ONE_TO_MANY ) {
			argv[5] = "-s";
			argv[6] = ip_info.lsip;
			argv[7] = "-o";
			argv[8] = wanif;			
			argv[9] = "-j";			
			if ((DHCP_T)pEntry->ipDhcp == DHCP_DISABLED) {				
				argv[10] = "SNAT";
				argv[11] = "--to-source";
				argv[12] = ip_info.globalRange;
				argv[13] = NULL;
			}
			else {
				argv[8] = "MASQUERADE";
				argv[9] = NULL;
			}			
		}
#endif
		else
			return;
		TRACE(STA_SCRIPT, "%s %s %s %s %s ", IPTABLES, argv[1], argv[2], argv[3], argv[4]);
		TRACE(STA_SCRIPT, "%s %s %s %s\n", argv[5], argv[6], argv[7], argv[8]);		
		do_cmd(IPTABLES, argv, 1);

#endif //end of !MULTI_ADDRESS_MAPPING
#endif // of ADDRESS_MAPPING
	}
	
}


// Config all NAT rules. 
// If action= ACT_STOP, delete all NAT rules.
// If action= ACT_START, setup all NAT rules.
void config_AddressMap(int action)
{
	unsigned int entryNum, i;
	MIB_CE_ATM_VC_T Entry;
	char wanif[6];
	char myip[16];
	
	entryNum = mib_chain_total(MIB_ATM_VC_TBL);			
	for (i = 0; i < entryNum; i++) {				
		/* Retrieve entry */
		if (!mib_chain_get(MIB_ATM_VC_TBL, i, (void *)&Entry)) {
			printf("restartAddressMap: cannot get ATM_VC_TBL(ch=%d) entry\n", i);
			return;
		}
		
		if (Entry.enable == 0)
			continue;
		if ( action == ACT_STOP )
			stopAddressMap(&Entry);
		else if ( action == ACT_START) {
			startAddressMap(&Entry);
		}
	}
	
	if ( action == ACT_START) {
		va_cmd("/bin/ethctl", 2, 1, "conntrack", "killall");
	}	
	
}

// IP interface: 1483-r or MER
// return value:
// 1  : successful
int startIP(char *inf, MIB_CE_ATM_VC_Tp pEntry, REMOTE_ACCESS_T ipEncap)
{
	char myip[16], remoteip[16], netmask[16];
	unsigned char buffer[7];
#ifdef IP_PASSTHROUGH
	unsigned char ippt_itf;
	int ippt=0;
	struct in_addr net;
	char netip[16];
#endif
#ifdef DEFAULT_GATEWAY_V2
	unsigned char dgw;
	int isdgw = 0;
#endif
	FILE *fp;
	// Mason Yu
	unsigned long broadcastIpAddr;	
	char broadcast[16];
	
	// Set MTU for 1483-r or MER
	sprintf(buffer, "%u", pEntry->mtu);
	va_cmd(IFCONFIG,3,1,inf, "mtu", buffer);
	
#ifdef IP_PASSTHROUGH
	// check IP passthrough
	if (mib_get(MIB_IPPT_ITF, (void *)&ippt_itf) != 0)
	{
		if (ippt_itf == pEntry->ifIndex)
			ippt = 1; // this interface enable the IP passthrough
	}
#endif
			
#ifdef DEFAULT_GATEWAY_V2
	// Jenny, check default gateway
	if (mib_get(MIB_ADSL_WAN_DGW_ITF, (void *)&dgw) != 0)
	{
		if (dgw == pEntry->ifIndex)
			isdgw = 1; // this interface is default gateway
	}
#endif

	if ((DHCP_T)pEntry->ipDhcp == DHCP_DISABLED)
	{
		// ifconfig vc0 ipaddr
		strncpy(myip, inet_ntoa(*((struct in_addr *)pEntry->ipAddr)), 16);
		myip[15] = '\0';
		strncpy(remoteip, inet_ntoa(*((struct in_addr *)pEntry->remoteIpAddr)), 16);
		remoteip[15] = '\0';
		strncpy(netmask, inet_ntoa(*((struct in_addr *)pEntry->netMask)), 16);
		netmask[15] = '\0';
		// Mason Yu
		broadcastIpAddr = ((struct in_addr *)pEntry->ipAddr)->s_addr | ~(((struct in_addr *)pEntry->netMask)->s_addr);
		strncpy(broadcast, inet_ntoa(*((struct in_addr *)&broadcastIpAddr)), 16);
		broadcast[15] = '\0';		
#ifdef CONFIG_ATM_CLIP
		if (ipEncap == ACC_ROUTED || ipEncap == ACC_IPOA)
#else
		if (ipEncap == ACC_ROUTED)
#endif
		{
#ifdef IP_PASSTHROUGH
			if (!ippt)
			{
#endif
				if (pEntry->ipunnumbered)	// Jenny, for IP unnumbered determination temporarily
					va_cmd(IFCONFIG, 8, 1, inf, "10.0.0.1", "-arp",
						"-broadcast", "pointopoint", "10.0.0.2",	
						"netmask", ARG_255x4);
				else
					// ifconfig vc0 myip -arp -broadcast pointopoint
					//   remoteip netmask 255.255.255.255
					va_cmd(IFCONFIG, 8, 1, inf, myip, "-arp",
						"-broadcast", "pointopoint", remoteip,
						"netmask", netmask);	// Jenny, subnet mask added
//						"netmask", ARG_255x4);
#ifdef IP_PASSTHROUGH
			}
			else	// IP passthrough
			{
				// ifconfig vc0 10.0.0.1 -arp -broadcast pointopoint
				//   10.0.0.2 netmask 255.255.255.255
				va_cmd(IFCONFIG, 8, 1, inf, "10.0.0.1", "-arp",
					"-broadcast", "pointopoint", "10.0.0.2",				// Jenny, for IP passthrough determination temporarily
					"netmask", netmask);
//				va_cmd(IFCONFIG, 8, 1, inf, "10.0.0.1", "-arp",
//					"-broadcast", "pointopoint", "10.0.0.2",
//					"netmask", ARG_255x4);
				// ifconfig br0:1 remoteip
				va_cmd(IFCONFIG, 2, 1, LAN_IPPT, remoteip);
				
				// Mason Yu. Add route for Public IP				
               			net.s_addr = (((struct in_addr *)pEntry->remoteIpAddr)->s_addr) & (((struct in_addr *)pEntry->netMask)->s_addr);
               			strncpy(netip, inet_ntoa(net), 16);
				netip[15] = '\0';				
				va_cmd(ROUTE, 7, 1, ARG_DEL, "-net", netip, "netmask", netmask, "dev", LANIF);
				va_cmd(ROUTE, 5, 1, ARG_ADD, "-host", myip, "dev", LANIF);
               			
				// write ip to file for DHCP server
				if (fp = fopen(IPOA_IPINFO, "w"))
				{
					fwrite( pEntry->ipAddr, 4, 1, fp);       	  
					fwrite( pEntry->remoteIpAddr, 4, 1, fp);      	  
					fwrite( pEntry->netMask, 4, 1, fp);      	  
					fclose(fp);
				}	
			}
#endif
#ifdef DEFAULT_GATEWAY_V2
			if (isdgw)
#else
			if (pEntry->dgw)
#endif
			 {
				// route add default vc0
				va_cmd(ROUTE, 3, 1, ARG_ADD, "default", inf);
				//va_cmd(ROUTE, 4, 1, ARG_ADD, "default", "gw", remoteip);
#ifdef UPNP_ONLY_GATEWAY
		mib_set(MIB_UPNP_EXT_ITF, (void *)&pEntry->ifIndex); 	
#endif			
			}
		}
		else
		{
			// Mason Yu. Set netmask and broadcast
			// ifconfig vc0 myip
			//va_cmd(IFCONFIG, 2, 1, inf, myip);
			va_cmd(IFCONFIG, 6, 1, inf, myip, "netmask", netmask, "broadcast",  broadcast);
			
#ifdef DEFAULT_GATEWAY_V2
			if (isdgw) {
#else
			if (pEntry->dgw) {
#endif
				// route add default gw remotip
				va_cmd(ROUTE, 4, 1, ARG_ADD, "default", "gw", remoteip);
#ifdef UPNP_ONLY_GATEWAY
		              mib_set(MIB_UPNP_EXT_ITF, (void *)&pEntry->ifIndex); 	
#endif	
			}
			if (ipEncap == ACC_MER) {
				unsigned char value[32];
				snprintf(value, 32, "%s.%s", (char *)MER_GWINFO, inf);
				if (fp = fopen(value, "w"))
				{
					fprintf(fp, "%s\n", remoteip);
					fclose(fp);
				}
			}
		}
		
		if (pEntry->napt == 1)
		{	
			// Setup one NAT Rule for the specfic interface
			startAddressMap(pEntry);
		}
	}
	else
	{
		int dhcpc_pid;
		// Enabling support for a dynamically assigned IP (ISP DHCP)...
		va_cmd(IPTABLES, 16, 1, FW_ADD, FW_INPUT, ARG_I, inf, "-p",
			ARG_UDP, FW_DPORT, "69", "-d", ARG_255x4, "-m",
			"state", "--state", "NEW", "-j", FW_ACCEPT);
		
		if (fp = fopen(PROC_DYNADDR, "w"))
		{
			fprintf(fp, "1\n");
			fclose(fp);
		}
		else
		{
			printf("Open file %s failed !\n", PROC_DYNADDR);
		}
		
		dhcpc_pid = read_pid((char*)DHCPC_PID);
		if (dhcpc_pid > 0)
			kill(dhcpc_pid, SIGTERM);
		if (startDhcpc(inf, pEntry) == -1)
		{
			printf("start DHCP client failed !\n");
		}
		
		if (pEntry->napt == 1)
		{	// Enable NAPT
			va_cmd(IPTABLES, 8, 1, "-t", "nat", FW_ADD, "POSTROUTING",
				ARG_O, inf, "-j", "MASQUERADE");
		}
	}
	
	return 1;
}

#ifdef USE_PPPD
static const char PPPD_OPTIONS[] = "/etc/ppp/options";
static const char PPPD_PAPFILE[] = "/etc/ppp/pap-secrets";
static const char PPPD_CHAPFILE[] = "/etc/ppp/chap-secrets";
#endif
#ifdef CONFIG_USER_PPPOE_PROXY
int pppoe_proxy_enable = 0;
static const char PPPD_PAPFILE[] = "/var/ppp/pap-secrets";

////alex_huang
static int has_pppoe_init;
 int ppp_proxy_ioctl(pppoe_proxy *if_pp_proxy,int cmd )
{
     
        int skfd, ret;  
        struct ifreq ifr;
       
        if ((skfd = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
 
                printf("ppp_proxy _ioctl error \n");
 
                return (-1);
 
        }

        strcpy(ifr.ifr_name, "ppp0");
        ifr.ifr_data= (char*)if_pp_proxy;
        ret = ioctl(skfd, cmd, &ifr);
        close(skfd);
  
        return ret;
}

#endif 

// Jenny, stop PPP
void stopPPP()
{
	int i;
	char tp[10];
	struct data_to_pass_st msg;
	for (i=0; i<MAX_PPP_NUM; i++) {
		sprintf(tp, "ppp%d", i);
		if (find_ppp_from_conf(tp)) {
			snprintf(msg.data, BUF_SIZE, "spppctl del %u", i);
			TRACE(STA_SCRIPT, "%s\n", msg.data);
			write_to_pppd(&msg);
		}
	}
}

// PPP connection
// Input: inf == "vc0","vc1", ...
// pppEncap: 0 : PPPoE, 1 : PPPoA
// return value:
// 1  : successful
int startPPP(char *inf, MIB_CE_ATM_VC_Tp pEntry, char *qos, REMOTE_ACCESS_T pppEncap)
{
	char ifIdx[3], pppif[6], stimeout[7];
#ifdef IP_PASSTHROUGH
	unsigned char ippt_itf;
	int ippt=0;
#endif
#ifdef USE_PPPD
	FILE *fp_options, *fp_pap, *fp_chap;
#else
	struct data_to_pass_st msg;
#endif
#ifdef DEFAULT_GATEWAY_V2
	unsigned char dgw;
	int isdgw = 0;
#endif
	int lastArg;
	
#ifdef IP_PASSTHROUGH
	// check IP passthrough
	if (mib_get(MIB_IPPT_ITF, (void *)&ippt_itf) != 0)
	{
		if (ippt_itf == pEntry->ifIndex)
			ippt = 1; // this interface enable the IP passthrough
	}
#endif

#ifdef  ZTE_GENERAL_ROUTER_SC
         if(pEntry->ipunnumbered)
		 ippt=2;       //ip unnumbered alex
#endif
			
#ifdef DEFAULT_GATEWAY_V2
	// Jenny, check default gateway
	if (mib_get(MIB_ADSL_WAN_DGW_ITF, (void *)&dgw) != 0)
	{
		if (dgw == pEntry->ifIndex)
			isdgw = 1; // this interface is default gateway
	}
#endif

	snprintf(ifIdx, 3, "%u", PPP_INDEX(pEntry->ifIndex));
	snprintf(pppif, 6, "ppp%u", PPP_INDEX(pEntry->ifIndex));
	if (pppEncap == ACC_PPPOE)	// PPPoE
	{
#ifdef USE_PPPD
		if ((fp_options = fopen(PPPD_OPTIONS, "w")) == NULL)
		{
			printf("Open file %s failed !\n", PPPD_OPTIONS);
			return -1;
		}
		
		if ((fp_pap = fopen(PPPD_PAPFILE, "w")) == NULL)
		{
			printf("Open file %s failed !\n", PPPD_PAPFILE);
			return -1;
		}
		
		if ((fp_chap = fopen(PPPD_CHAPFILE, "w")) == NULL)
		{
			printf("Open file %s failed !\n", PPPD_CHAPFILE);
			return -1;
		}
		
		fprintf(fp_options, "name \"%s\"\n", pEntry->pppUsername);
		fprintf(fp_pap, "\"%s\"	*	\"%s\"\n", pEntry->pppUsername, pEntry->pppPassword);
		fprintf(fp_chap, "\"%s\"	*	\"%s\"\n", pEntry->pppUsername, pEntry->pppPassword);

		fprintf(fp_options, "plugin pppoe\n");
		fprintf(fp_options, "tty %s\n", inf);
		fprintf(fp_options, "noipdefault\n");
		fprintf(fp_options, "hide-password\n");
		fprintf(fp_options, "defaultroute\n");
		fprintf(fp_options, "persist\n");
		fprintf(fp_options, "ipcp-accept-remote\n");
		fprintf(fp_options, "ipcp-accept-local\n");
		fprintf(fp_options, "nodetach\n");
		fprintf(fp_options, "usepeerdns\n");
		fprintf(fp_options, "lcp-echo-interval 20\n");
		fprintf(fp_options, "lcp-echo-failure 3\n");
		fprintf(fp_options, "lock\n");
		
		fclose(fp_options);
		fclose(fp_pap);
		fclose(fp_chap);

#else
 #ifdef CONFIG_USER_PPPOE_PROXY
              printf("enable pppoe proxy %d \n",pEntry->PPPoEProxyEnable);
              printf("maxuser = %d ...",pEntry->PPPoEProxyMaxUser);
		int pppoe_server_pid;	
		pppoe_proxy pp_proxy;
             if(pEntry->PPPoEProxyEnable)
	      {
                FILE  *fp_pap;		   		
                pppoe_proxy_enable =1;
	         if ((fp_pap = fopen(PPPD_PAPFILE, "a+")) == NULL)
		  {
			printf("Open file %s failed !\n", PPPD_PAPFILE);
			return -1;
		  }
		  fprintf(fp_pap, "%s * \"%s\"  *\n", pEntry->pppUsername, pEntry->pppPassword);
		  fclose(fp_pap);
		  
	         pppoe_server_pid = read_pid("/var/run/pppoe-server.pid");
                          if(pppoe_server_pid>0)
					kill(pppoe_server_pid,SIGUSR2);
                
		  if(!has_pppoe_init){
				pp_proxy.cmd =PPPOE_PROXY_ENABLE;
				ppp_proxy_ioctl(&pp_proxy,SIOCPPPOEPROXY);
				has_pppoe_init =1;
				
		   }	
		    pp_proxy.wan_unit =PPP_INDEX(pEntry->ifIndex) ;
		    pp_proxy.cmd =PPPOE_WAN_UNIT_SET;
		    strcpy(pp_proxy.user,pEntry->pppUsername);
		    strcpy(pp_proxy.passwd,pEntry->pppPassword);

				
		    pp_proxy.maxShareNum = pEntry->PPPoEProxyMaxUser;
		    ppp_proxy_ioctl(&pp_proxy,SIOCPPPOEPROXY);
    
         	    if (pEntry->napt == 1)
        	   {	// Enable NAPT
		      va_cmd(IPTABLES, 8, 1, "-t", "nat", FW_ADD, "POSTROUTING",
			 "-o", pppif, "-j", "MASQUERADE");
        	    }
	       
		       
		   	return 1;
             }
		else 
			{
			    pppoe_proxy_enable =0;
			    pp_proxy.cmd =PPPOE_PROXY_DISABLE;
			    ppp_proxy_ioctl(&pp_proxy,SIOCPPPOEPROXY); 
			}
            
#endif

		if (pEntry->pppCtype != MANUAL){	// Jenny
			// spppctl add 0 pppoe vc0 username USER password PASSWORD
			//         gw 1 mru xxxx acname xxx
			snprintf(msg.data, BUF_SIZE,
				"spppctl add %s pppoe %s username %s password %s"
				" gw %d mru %d acname %s ", ifIdx,
				inf, pEntry->pppUsername, pEntry->pppPassword,
#ifdef DEFAULT_GATEWAY_V2
				isdgw, pEntry->mtu, pEntry->pppACName);
#else
				pEntry->dgw, pEntry->mtu, pEntry->pppACName);
#endif
		}		
		else
			snprintf(msg.data, BUF_SIZE,
				"spppctl new %s pppoe %s username %s password %s"
				" gw %d mru %d acname %s", ifIdx,
				inf, pEntry->pppUsername, pEntry->pppPassword,
#ifdef DEFAULT_GATEWAY_V2
				isdgw, pEntry->mtu, pEntry->pppACName);
#else
				pEntry->dgw, pEntry->mtu, pEntry->pppACName);
#endif
#ifdef CONFIG_SPPPD_STATICIP
		// Jenny, set PPPoE static IP
		if (pEntry->pppIp) {
			unsigned long addr;
			addr = *((unsigned long *)pEntry->ipAddr);
			if (addr)
				snprintf(msg.data, BUF_SIZE, "%s staticip %x", msg.data, addr);
		}
#endif
#ifdef _CWMP_MIB_
		// Set Service Name
		if (strlen(pEntry->pppServiceName))
			snprintf(msg.data, BUF_SIZE, "%s servicename %s", msg.data, pEntry->pppServiceName);
#endif
#endif
	}
	else	// PPPoA
	{
#ifdef USE_PPPD
		// ...
#else
		if (pEntry->pppCtype != MANUAL)	// Jenny
			// spppctl add 0 pppoa vpi.vci encaps ENCAP qos xxx
			//         username USER password PASSWORD gw 1 mru xxxx
			snprintf(msg.data, BUF_SIZE,
				"spppctl add %s pppoa %u.%u encaps %d qos %s "
				"username %s password %s gw %d mru %d",
				ifIdx, pEntry->vpi, pEntry->vci, pEntry->encap,	qos,
#ifdef DEFAULT_GATEWAY_V2
				pEntry->pppUsername, pEntry->pppPassword, isdgw, pEntry->mtu);
#else
				pEntry->pppUsername, pEntry->pppPassword, pEntry->dgw, pEntry->mtu);
#endif
		else
			snprintf(msg.data, BUF_SIZE,
				"spppctl new %s pppoa %u.%u encaps %d qos %s "
				"username %s password %s gw %d mru %d",
				ifIdx, pEntry->vpi, pEntry->vci, pEntry->encap,	qos,
#ifdef DEFAULT_GATEWAY_V2
				pEntry->pppUsername, pEntry->pppPassword, isdgw, pEntry->mtu);
#else
				pEntry->pppUsername, pEntry->pppPassword, pEntry->dgw, pEntry->mtu);
#endif
#endif
	}
	
	// Set Authentication Method
	if ((PPP_AUTH_T)pEntry->pppAuth >= PPP_AUTH_PAP && (PPP_AUTH_T)pEntry->pppAuth <= PPP_AUTH_CHAP)
		snprintf(msg.data, BUF_SIZE, "%s auth %s", msg.data, ppp_auth[pEntry->pppAuth]);
	
#ifdef IP_PASSTHROUGH
	// Set IP passthrough
	snprintf(msg.data, BUF_SIZE, "%s ippt %d", msg.data, ippt);
#endif

	
#ifdef _CWMP_MIB_
	// Set Auto Disconnect Timer
	if (pEntry->autoDisTime > 0)
		snprintf(msg.data, BUF_SIZE, "%s disctimer %d", msg.data, pEntry->autoDisTime);
	// Set Warn Disconnect Delay
	if (pEntry->warnDisDelay > 0)
		snprintf(msg.data, BUF_SIZE, "%s discdelay %d", msg.data, pEntry->warnDisDelay);
#endif
	
	if (pEntry->pppCtype == CONTINUOUS)	// Continuous
	{
#ifdef USE_PPPD
		va_cmd("/bin/pppd", 0, 0);
#else
		TRACE(STA_SCRIPT, "%s\n", msg.data);
//printf("\ncmd=%s\n",msg.data);
		write_to_pppd(&msg);
#endif
		// set the ppp keepalive timeout
		snprintf(msg.data, BUF_SIZE,
			"spppctl katimer 100");
		TRACE(STA_SCRIPT, "%s\n", msg.data);
		
		write_to_pppd(&msg);
		printf("PPP Connection (Continuous)...\n");
	}
	else if (pEntry->pppCtype == CONNECT_ON_DEMAND)	// On-demand
	{
#ifdef USE_PPPD

#else
		snprintf(msg.data, BUF_SIZE, "%s timeout %u", msg.data, pEntry->pppIdleTime);
		TRACE(STA_SCRIPT, "%s\n", msg.data);
		write_to_pppd(&msg);
#endif
		printf("PPP Connection (On-demand)...\n");
	}
	else if (pEntry->pppCtype == MANUAL)	// Manual
	{
#ifdef USE_PPPD

#else
//		TRACE(STA_SCRIPT|STA_NOTAG, "\n");
		// Jenny, for PPP connecting/disconnecting manually
		TRACE(STA_SCRIPT, "%s\n", msg.data);
		write_to_pppd(&msg);
#endif
		printf("PPP Connection (Manual)...\n");
	}
	
	if (pEntry->napt == 1)
	{	// Enable NAPT
		va_cmd(IPTABLES, 8, 1, "-t", "nat", FW_ADD, "POSTROUTING",
			"-o", pppif, "-j", "MASQUERADE");
	}
#ifdef UPNP_ONLY_GATEWAY
#ifdef DEFAULT_GATEWAY_V2
         if(isdgw)
#else 
         if(pEntry->dgw)
		mib_set(MIB_UPNP_EXT_ITF, (void *)&pEntry->ifIndex); 	
#endif
#endif	
	return 1;
}

// find if pppif exists in /var/ppp/ppp.conf
int find_ppp_from_conf(char *pppif)
{
	char buff[256];
	FILE *fp;
	char strif[6];
	int found=0;
	
	if (!(fp=fopen(PPP_CONF, "r"))) {
		fclose(fp);
		printf("%s not exists.\n", PPP_CONF);
	}
	else {
		fgets(buff, sizeof(buff), fp);
		while( fgets(buff, sizeof(buff), fp) != NULL ) {
			if(sscanf(buff, "%s", strif)!=1) {
				found=0;
				printf("Unsuported ppp configuration format\n");
				break;
			}
			if ( !strcmp(pppif, strif) ) {
				found = 1;
				break;
			}
		}
		fclose(fp);
	}
	return found;
}

// find if vc exists in /proc/net/atm/pvc
static int find_pvc_from_running(int vpi, int vci)
{
	char buff[256];
	FILE *fp;
	int tvpi, tvci;
	int found=0;
	
	if (!(fp=fopen(PROC_NET_ATM_PVC, "r"))) {
		fclose(fp);
		printf("%s not exists.\n", PROC_NET_ATM_PVC);
	}
	else {
		fgets(buff, sizeof(buff), fp);
		while( fgets(buff, sizeof(buff), fp) != NULL ) {
			if(sscanf(buff, "%*d%d%d", &tvpi, &tvci)!=2) {
				found=0;
				printf("Unsuported pvc configuration format\n");
				break;
			}
			if ( tvpi==vpi && tvci==vci ) {
				found = 1;
				break;
			}
		}
		fclose(fp);
	}
	return found;
}

// calculate the 15-0(bits) Cell Rate register value (PCR or SCR)
// return its corresponding register value
static int cr2reg(int pcr)
{
	int k, e, m, pow2, reg;
	
	k = pcr;
	e=0;
	
	while (k>1) {
		k = k/2;
		e++;
	}
	
	//printf("pcr=%d, e=%d\n", pcr,e);
	pow2 = 1;
	for (k = 1; k <= e; k++)
		pow2*=2;
	
	//printf("pow2=%d\n", pow2);
	//m = ((pcr/pow2)-1)*512;
	k = 0;
	while (pcr >= pow2) {
		pcr -= pow2;
		k++;
	}
	m = (k-1)*512 + pcr*512/pow2;
	//printf("m=%d\n", m);
	reg = (e<<9 | m );
	//printf("reg=%d\n", reg);
	return reg;
}

/*
 *	get the mark value for a traffic classification
 */
 
int _get_classification_mark( int entryNo, MIB_CE_IP_QOS_T *p )
{
	int mark=0;
	
	if(p==NULL) return 0;

	// mark the packet:  8-bits(high) |   8-bits(low)
	//                    class id    |  802.1p (if any)
	mark = ((entryNo+1) << 8);	// class id
	#if 0
	#ifdef QOS_SPEED_LIMIT_SUPPORT
	//use the first 3 bit
	if(p->limitSpeedEnabled)
		{
			int tmpmark=p->limitSpeedRank;
			
		  	mark|=tmpmark<<12;
			printf("limitSpeedRank=%d,mark=%d\n",p->limitSpeedRank,mark);
		}
	
	#endif
	#endif
	if (p->m_1p != 0)
		mark |= (p->m_1p-1);	// 802.1p

	return mark;
}

int get_classification_mark(int entryNo)
{
	MIB_CE_IP_QOS_T qEntry;
	int i, num, mark;
	
	mark = 0;
	num = mib_chain_total(MIB_IP_QOS_TBL);
	if (entryNo >= num)
		return 0;
	// get fwmark
	if (!mib_chain_get(MIB_IP_QOS_TBL, entryNo, (void *)&qEntry))
		return 0;
	
#if 1
	mark =  _get_classification_mark( entryNo, &qEntry );
#else
	// mark the packet:  8-bits(high) |   8-bits(low)
	//                    class id    |  802.1p (if any)
	mark = ((entryNo+1) << 8);	// class id
	if (qEntry.m_1p != 0)
		mark |= (qEntry.m_1p-1);	// 802.1p
#endif
	
	return mark;
}

/*
 *	generate the ifup_ppp(vc)x script for WAN interface
 */
static int generate_ifup_script(unsigned char ifIndex)
{
	int mark, ret;
	FILE *fp;
	char wanif[6], ifup_path[32];
#ifdef IP_POLICY_ROUTING
	int i, num, found;
	MIB_CE_IP_QOS_T qEntry;
#endif
	
	ret = 0;
	
	if (PPP_INDEX(ifIndex) != 0x0f) {
		// PPP interface
		
		snprintf(wanif, 6, "ppp%u", PPP_INDEX(ifIndex));
		snprintf(ifup_path, 32, "/var/ppp/ifup_%s", wanif);
		if (fp=fopen(ifup_path, "w+") ) {
			fprintf(fp, "#!/bin/sh\n\n");
#if defined(CONFIG_USER_UPNPD)||defined(CONFIG_USER_MINIUPNPD)
			// Added by Mason Yu for Start upnpd.
			fprintf(fp, "/bin/upnpctrl down %s br0\n", wanif);
			//fprintf(fp, "/bin/upnpctrl up %s br0\n", wanif);
#endif
			
#ifdef CONFIG_USER_DDNS
			// Added by Mason Yu for Start updatedd.
			fprintf(fp, "/bin/updateddctrl %s\n", wanif);
#endif
#ifdef IP_POLICY_ROUTING
			num = mib_chain_total(MIB_IP_QOS_TBL);
			found = 0;
			// set advanced-routing rule
			for (i=0; i<num; i++) {
				if (!mib_chain_get(MIB_IP_QOS_TBL, i, (void *)&qEntry))
					continue;
				if (qEntry.outif == ifIndex) {
					
					found = 1;
					mark = get_classification_mark(i);
					if (mark != 0) {
						// Don't forget to point out that fwmark with
						// ipchains/iptables is a decimal number, but that
						// iproute2 uses hexadecimal number.
						fprintf(fp, "ip ru add fwmark %x table %d\n", mark, PPP_INDEX(ifIndex)+PR_PPP_START);
					}
				}
			}
			if (found) {
				fprintf(fp, "ip ro add default dev %s table %d\n", wanif, PPP_INDEX(ifIndex)+PR_PPP_START);
			}
#endif

#if defined(CONFIG_USER_UPNPD)||defined(CONFIG_USER_MINIUPNPD)
			// Added by Mason Yu for Start upnpd.
			//fprintf(fp, "/bin/upnpctrl down %s br0\n", wanif);
			fprintf(fp, "/bin/upnpctrl up %s br0\n", wanif);
#endif
			fclose(fp);
			chmod(ifup_path, 484);
		}
		else
			ret = -1;
	}
	else {
		// not supported till now
		return -1;
		// vc interface
		snprintf(wanif, 6, "vc%u", VC_INDEX(ifIndex));
	}
	
	return ret;
}

/*
 *	setup the policy-routing for static link
 */
#ifdef IP_POLICY_ROUTING
static int setup_static_PolicyRouting(unsigned char ifIndex)
{
	int i, num, mark, ret, found;
	char str_mark[8], str_rtable[8], ipAddr[32], wanif[8];
	struct in_addr inAddr;
	MIB_CE_IP_QOS_T qEntry;
	
	ret = -1;
	
	if (ifIndex == 0xff)
		return ret;
	else {
		if (PPP_INDEX(ifIndex) != 0x0f) {
			// PPP interface
			return ret;
		}
		else {
			// vc interface
			snprintf(wanif, 8, "vc%u", VC_INDEX(ifIndex));
			snprintf(str_rtable, 8, "%d", VC_INDEX(ifIndex)+PR_VC_START);
			if (getInAddr( wanif, DST_IP_ADDR, (void *)&inAddr) == 1)
			{
				strcpy(ipAddr, inet_ntoa(inAddr));
			}
			else
				return ret;
		}
		
		if (!getInFlags(wanif, 0))
			return ret;	// interface not found
	}
	
	num = mib_chain_total(MIB_IP_QOS_TBL);
	found = 0;
	// set advanced-routing rule
	for (i=0; i<num; i++) {
		if (!mib_chain_get(MIB_IP_QOS_TBL, i, (void *)&qEntry))
			continue;
		if (qEntry.outif == ifIndex) {
			
			found = 1;
			mark = get_classification_mark(i);
			if (mark != 0) {
				snprintf(str_mark, 8, "%x", mark);
				// Don't forget to point out that fwmark with
				// ipchains/iptables is a decimal number, but that
				// iproute2 uses hexadecimal number.
				// ip ru add fwmark xxx table 3
				va_cmd("/bin/ip", 6, 1, "ru", "add", "fwmark", str_mark, "table", str_rtable);
				// ip ro add default via ipaddr dev vc0 table 3
			}
		}
	}
	if (found) {
		// ip ro add default via ipaddr dev vc0 table 3
		va_cmd("/bin/ip", 9, 1, "ro", "add", "default", "via", ipAddr, "dev", wanif, "table", str_rtable);
		ret = 0;
	}
	
	return ret;
}
#endif

//Inform kernel the number of routing interface.
// flag = 1 to increase 1
// flag = 0 to decrease 1
void internetLed_route_if(int flag)
{
	FILE *fp;

	fp = fopen ("/proc/IntnetLED", "w");
	if (fp)
	{
		if (flag)
			fprintf(fp,"+");
		else
			fprintf(fp,"-");
		fclose(fp);
	}
}

// return value:
// 0  : successful
// -1 : failed
#if defined( ZTE_GENERAL_ROUTER_SC) || defined(CONFIG_BOA_WEB_E8B_CH)
unsigned char mac_compensate=0;
#endif
int startConnection(MIB_CE_ATM_VC_Tp pEntry)
{
	char *argv[5];
	struct data_to_pass_st msg;
	char *aal5Encap, qosParms[64], wanif[5];
	int brpppoe;
	int pcreg, screg;
	int status=0;
//#ifdef CONFIG_USER_UPNPD	
#if defined(CONFIG_USER_UPNPD)||defined(CONFIG_USER_MINIUPNPD)
	char ext_ifname[6];
#endif	

#ifdef CTC_WAN_NAME
	unsigned int applicationtype;
#endif
	
	if(pEntry == NULL)
	{
		return 0;
	}	
#if defined(ZTE_531B_BRIDGE_SC)||(ZTE_GENERAL_ROUTER_SC) || defined(CONFIG_BOA_WEB_E8B_CH)
//star
	if(pEntry->enable==0)
		return 0;
#endif	

#ifdef CTC_WAN_NAME
	memcpy(&applicationtype, &(pEntry->applicationtype), sizeof(applicationtype));
#endif

	if (pEntry->cmode != ADSL_BR1483)
		internetLed_route_if(1);//+1	
	// get the aal5 encapsulation
	if (pEntry->encap == ENCAP_VCMUX)
	{
#ifdef CONFIG_ATM_CLIP
		if ((REMOTE_ACCESS_T)pEntry->cmode == ACC_ROUTED || (REMOTE_ACCESS_T)pEntry->cmode == ACC_IPOA)
#else
		if ((REMOTE_ACCESS_T)pEntry->cmode == ACC_ROUTED)
#endif
			aal5Encap = (char *)VC_RT;
		else
			aal5Encap = (char *)VC_BR;
	}
	else	// LLC
	{
		if ((REMOTE_ACCESS_T)pEntry->cmode == ACC_ROUTED)
			aal5Encap = (char *)LLC_RT;
#ifdef CONFIG_ATM_CLIP
		else if ((REMOTE_ACCESS_T)pEntry->cmode == ACC_IPOA)
			aal5Encap = (char *)LLC_1577;
#endif
		else
			aal5Encap = (char *)LLC_BR;
	}		
	// calculate the 15-0(bits) PCR CTLSTS value
	pcreg = cr2reg(pEntry->pcr);
	
	if ((ATM_QOS_T)pEntry->qos == ATMQOS_CBR)
	{
		snprintf(qosParms, 64, "cbr:pcr=%u", pcreg);
	}
	else if ((ATM_QOS_T)pEntry->qos == ATMQOS_VBR_NRT)
	{
		screg = cr2reg(pEntry->scr);
		snprintf(qosParms, 64, "nrt-vbr:pcr=%u,scr=%u,mbs=%u",
			pcreg, screg, pEntry->mbs);
	}
	else if ((ATM_QOS_T)pEntry->qos == ATMQOS_VBR_RT)
	{
		screg = cr2reg(pEntry->scr);
		snprintf(qosParms, 64, "rt-vbr:pcr=%u,scr=%u,mbs=%u",
			pcreg, screg, pEntry->mbs);
	}
	else //if ((ATM_QOS_T)pEntry->qos == ATMQOS_UBR)
	{
		snprintf(qosParms, 64, "ubr:pcr=%u", pcreg);
	}		
	snprintf(wanif, 5, "vc%d", VC_INDEX(pEntry->ifIndex));
	
	// start this vc
	if (pEntry->cmode != ACC_PPPOA && !find_pvc_from_running(pEntry->vpi, pEntry->vci))
	{
		unsigned char devAddr[MAC_ADDR_LEN];
		char macaddr[MAC_ADDR_LEN*2+1];
		
		// mpoactl add vc0 pvc 0.33 encaps 4 qos xxx brpppoe x
#ifdef PPPOE_PASSTHROUGH			
		snprintf(msg.data, BUF_SIZE,
			"mpoactl add %s pvc %u.%u encaps %s qos %s brpppoe %d", wanif,
			pEntry->vpi, pEntry->vci, aal5Encap, qosParms, pEntry->brmode);			
#else
#ifdef CONFIG_ATM_CLIP
		if (pEntry->cmode != ACC_IPOA)
#endif
		snprintf(msg.data, BUF_SIZE,
			"mpoactl add %s pvc %u.%u encaps %s qos %s", wanif,
			pEntry->vpi, pEntry->vci, aal5Encap, qosParms);
#ifdef CONFIG_ATM_CLIP
		else
			snprintf(msg.data, BUF_SIZE,
				"mpoactl addclip %s pvc %u.%u encaps %s qos %s", wanif,
				pEntry->vpi, pEntry->vci, aal5Encap, qosParms);
#endif
#endif
		TRACE(STA_SCRIPT, "%s\n", msg.data);
		status|=write_to_mpoad(&msg);		
#ifdef _LINUX_2_6_
		{
			int repeat_i=0;
			//make sure the channel is created (ifconfig hw ether may fail because the vc# is not ready)
			while( (repeat_i<10) && (!find_pvc_from_running(pEntry->vpi, pEntry->vci)) )
			{
				usleep(50000);
				repeat_i++;
			}
		}
#endif //_LINUX_2_6_
			
#ifdef CONFIG_ATM_CLIP
		if (mib_get(MIB_ELAN_MAC_ADDR, (void *)devAddr) != 0 && pEntry->cmode != ACC_IPOA)
#else
		if (mib_get(MIB_ELAN_MAC_ADDR, (void *)devAddr) != 0)
#endif
		{
//add by ramen for ZTE 531B router
#if defined( ZTE_GENERAL_ROUTER_SC) || defined(CONFIG_BOA_WEB_E8B_CH)
#if 0
if(pEntry->cmode!=ADSL_BR1483)
{
	if(pEntry->cmode==ADSL_PPPoE||pEntry->cmode==ADSL_PPPoA)
	snprintf(macaddr, 13, "%1x%1x%02x%02x%02x%02x%02x",
					pEntry->cmode,((pEntry->ifIndex&0xF0)>>2), devAddr[1], devAddr[2],
					devAddr[3], devAddr[4], devAddr[5]);
	else snprintf(macaddr, 13, "%1x%1x%02x%02x%02x%02x%02x",
					pEntry->cmode,((pEntry->ifIndex&0x0f)<<2), devAddr[1], devAddr[2],
					devAddr[3], devAddr[4], devAddr[5]);
	
}else	
snprintf(macaddr, 13, "%02x%02x%02x%02x%02x%02x",
				devAddr[0], devAddr[1], devAddr[2],
	
#endif
//add by ramen to borrow the mac address from WLAN
if(pEntry->cmode!=ADSL_BR1483)
 {
      if(mac_compensate<5)
      	{
      		if(mac_compensate >6)
				mac_compensate=0; //reset back to zero...
		devAddr[5]+=mac_compensate++;	
      	}
}
	snprintf(macaddr, 13, "%02x%02x%02x%02x%02x%02x",
				devAddr[0], devAddr[1], devAddr[2],
				devAddr[3], devAddr[4], devAddr[5]);

#else
	snprintf(macaddr, 13, "%02x%02x%02x%02x%02x%02x",
				devAddr[0], devAddr[1], devAddr[2],
				devAddr[3], devAddr[4], devAddr[5]);
#endif
			argv[1]=wanif;
			argv[2]="hw";
			argv[3]="ether";
			argv[4]=macaddr;
			argv[5]=NULL;
			TRACE(STA_SCRIPT, "%s %s %s %s %s\n", IFCONFIG, argv[1], argv[2],
						argv[3], argv[4]);
			status|=do_cmd(IFCONFIG, argv, 1);
		}
	
		// ifconfig vc0 txqueuelen 10
		argv[1] = wanif;
		argv[2] = "txqueuelen";
                #ifdef MINIMIZE_RAM_USAGE
		argv[3] = "0";
                #else
                argv[3] = "10";
                #endif
		argv[4] = NULL;
		TRACE(STA_SCRIPT, "%s %s %s\n", IFCONFIG, argv[1], argv[2], argv[3]);
		status|=do_cmd(IFCONFIG, argv, 1);
		// ifconfig vc0 up
		argv[2] = "up";
		argv[3] = NULL;
		TRACE(STA_SCRIPT, "%s %s %s\n", IFCONFIG, argv[1], argv[2]);
		status|=do_cmd(IFCONFIG, argv, 1);
	}

#ifdef CONFIG_EXT_SWITCH
		// mpoactl set vc0 vlan 1 pvid 1
		snprintf(msg.data, BUF_SIZE,
			"mpoactl set %s vlan %d vid %d", wanif,
			pEntry->vlan, pEntry->vid);
#ifdef _PRMT_X_CT_COM_ETHLINK_  //star: for CT 802.1p mark set prameter: X_CT-COM_802-1pMark
		if(pEntry->vlan!=0){
			char *argv1p[12];
			char mark[5];
			snprintf(mark, 5, "%d", pEntry->pmark);
			argv1p[1]="-t";
			argv1p[2]="mangle";
			argv1p[3]="-A";
			argv1p[4]="POSTROUTING";
			argv1p[5]="-o";
			argv1p[6]=wanif;
			argv1p[7]="-j";
			argv1p[8]="MARK";
			argv1p[9]="--set-mark";
			argv1p[10]=mark;
			argv1p[11]=NULL;
			
			TRACE(STA_SCRIPT, "%s %s %s %s %s %s %s %s %s %s %s %s --set-mark %s\n",
				IPTABLES, argv1p[1], argv1p[2], argv1p[3], argv1p[4], argv1p[5], argv1p[6],
				argv1p[7], argv1p[8], argv1p[9], argv1p[10], argv1p[11],mark);
			do_cmd(IPTABLES, argv1p, 1);
		}
#endif

#endif
		
	if (pEntry->cmode == ACC_BRIDGED)
	{

  	//shlee turns on DIRECT_BRIDGE_MODE only bridge mode pvc 
  	//Avoiding pppoe passthrough will enter direct bridge
	 	unsigned char ch_no[32];	
		sprintf(ch_no,"%d",VC_INDEX(pEntry->ifIndex));
  	va_cmd("/bin/sarctl",2,1,"direct_bridge",ch_no);	// Turns on direct bridge mode

		// rfc1483-bridged
		// brctl addif br0 vc0
		printf("1483 bridged\n");
		// mpoactl set vc0 vlan 1 pvid 1
		TRACE(STA_SCRIPT, "%s\n", msg.data);
		status|=write_to_mpoad(&msg);
		
		// Mason Yu
		if ( pEntry->brmode != BRIDGE_DISABLE )
		{
#ifdef CTC_WAN_NAME
            if ((0 != pEntry->itfGroup) || (3 != applicationtype))
            /* Dial-up through 'other' type wan interface is disabled 
             * when 'other' type wan interface is not bound with lan interface.
             */
#endif                
            {
    			status|=va_cmd(BRCTL, 3, 1, "addif", BRIF, wanif); 
            }
		}
	}
	else if ((REMOTE_ACCESS_T)pEntry->cmode == ACC_MER)
	{
		// MAC Encapsulated Routing
		printf("1483 MER\n");
		// mpoactl set vc0 vlan 1 pvid 1
		TRACE(STA_SCRIPT, "%s\n", msg.data);
		status|=write_to_mpoad(&msg);
		
		if (startIP(wanif, pEntry, ACC_MER) == -1)
		{
			printf("start MER failed !\n");
			status=-1;
		}
#ifdef PPPOE_PASSTHROUGH
		//if (pEntry->brmode == BRIDGE_PPPOE)	// enable PPPoE pass-through
		if (pEntry->brmode != BRIDGE_DISABLE)	// enable bridge
			// brctl addif br0 vc0
#ifdef CTC_WAN_NAME
            if ((0 != pEntry->itfGroup) || (3 != applicationtype))
            /* Dial-up through 'other' type wan interface is disabled 
             * when 'other' type wan interface is not bound with lan interface.
             */
#endif                
            {
            	status|=va_cmd(BRCTL, 3, 1, "addif", BRIF, wanif);
            }
#endif
		if ( pEntry->ipDhcp == DHCP_DISABLED ) {
		// Added by Mason Yu for Start UPNPD
#if defined(CONFIG_USER_UPNPD)||defined(CONFIG_USER_MINIUPNPD)
			snprintf(ext_ifname, 5, "vc%u", VC_INDEX(pEntry->ifIndex));
			va_cmd("/bin/upnpctrl", 3, 1, "up",ext_ifname, "br0");
#endif		
#ifdef IP_POLICY_ROUTING
			setup_static_PolicyRouting(pEntry->ifIndex);
#endif
		}

	}
	else if ((REMOTE_ACCESS_T)pEntry->cmode == ACC_PPPOE)
	{
		// PPPoE
		printf("PPPoE\n");
		// mpoactl set vc0 vlan 1 pvid 1
		TRACE(STA_SCRIPT, "%s\n", msg.data);
		status|=write_to_mpoad(&msg);

		if (startPPP(wanif, pEntry, 0, ACC_PPPOE) == -1)
		{
			printf("start PPPoE failed !\n");
			status=-1;
		}
		
#ifdef PPPOE_PASSTHROUGH
		//if (pEntry->brmode == BRIDGE_PPPOE)	// enable PPPoE pass-through
		if (pEntry->brmode != BRIDGE_DISABLE)	// enable bridge
			// brctl addif br0 vc0
#ifdef CTC_WAN_NAME
            if ((0 != pEntry->itfGroup) || (3 != applicationtype))
            /* Dial-up through 'other' type wan interface is disabled 
             * when 'other' type wan interface is not bound with lan interface.
             */
#endif                
            {
            	status|=va_cmd(BRCTL, 3, 1, "addif", BRIF, wanif);
            }
#endif
	}
	else if ((REMOTE_ACCESS_T)pEntry->cmode == ACC_PPPOA)
	{
		// PPPoA
		printf("PPPoA\n");
		if (startPPP(wanif, pEntry, qosParms, ACC_PPPOA) == -1)
		{
			printf("start PPPoA failed !\n");
			status=-1;
		}
	}
	else if ((REMOTE_ACCESS_T)pEntry->cmode == ACC_ROUTED)
	{
		// rfc1483-routed
		printf("1483 routed\n");
		if (startIP(wanif, pEntry, ACC_ROUTED) == -1)
		{
			printf("start 1483-routed failed !\n");
			status=-1;
		}
		
#if defined(CONFIG_USER_UPNPD)||defined(CONFIG_USER_MINIUPNPD)
		// Added by Mason Yu for Start UPNPD		
		snprintf(ext_ifname, 5, "vc%u", VC_INDEX(pEntry->ifIndex));
		va_cmd("/bin/upnpctrl", 3, 1, "up",ext_ifname, "br0");		
#endif		
#ifdef IP_POLICY_ROUTING
		setup_static_PolicyRouting(pEntry->ifIndex);
#endif
	}
#ifdef CONFIG_ATM_CLIP
	else if ((REMOTE_ACCESS_T)pEntry->cmode == ACC_IPOA)
	{
		// rfc1577-routed
		printf("1577 routed\n");
		unsigned long addr;
		struct data_to_pass_st msg;
		if (startIP(wanif, pEntry, ACC_IPOA) == -1)
		{
			printf("start 1577-routed failed !\n");
			status=-1;
		}
		addr = *((unsigned long *)pEntry->ipAddr);
		snprintf(msg.data, BUF_SIZE, "mpoactl set %s cip %lu", wanif, addr);
		write_to_mpoad(&msg);
	}
#endif
	
	if (status >= 0)
		generate_ifup_script(pEntry->ifIndex);
	
	return status;
}

#if defined(ZTE_531B_BRIDGE_SC)||defined(ZTE_GENERAL_ROUTER_SC) || defined(CONFIG_BOA_WEB_E8B_CH)
#define DHCPCLIENTPID  "/var/run/udhcpc.pid"
#endif

void stopConnection(MIB_CE_ATM_VC_Tp pEntry)
{
	struct data_to_pass_st msg;
	char wanif[6];
	char *argv[16];
	char myip[16];

#ifdef CONFIG_USER_PPPOE_PROXY
              int pppoe_server_pid;
               
       	 pppoe_server_pid = read_pid("/var/run/pppoe-server.pid");
		 if(pppoe_server_pid>0){   	 
		     kill(pppoe_server_pid,SIGUSR1);
		 }
#endif
	
	// delete this vc
	if (pEntry->cmode == ACC_PPPOE || pEntry->cmode == ACC_PPPOA)
	{
		// spppctl del 0
		snprintf(msg.data, BUF_SIZE,
			"spppctl del %u", PPP_INDEX(pEntry->ifIndex));
		snprintf(wanif, 6, "ppp%u", PPP_INDEX(pEntry->ifIndex));
		TRACE(STA_SCRIPT, "%s\n", msg.data);
		write_to_pppd(&msg);
	}
	else
		snprintf(wanif, 6, "vc%u", VC_INDEX(pEntry->ifIndex));
	va_cmd(BRCTL, 3, 1, "delif", BRIF, wanif);   


	if (pEntry->cmode != ADSL_BR1483)
		internetLed_route_if(0);//-1

#if defined(ZTE_531B_BRIDGE_SC)||defined(ZTE_GENERAL_ROUTER_SC) || defined(CONFIG_BOA_WEB_E8B_CH)
//star: for dhcpc stop
	if(pEntry->cmode == ACC_MER && pEntry->ipDhcp != DHCP_DISABLED)
	{
		int dhcpcpid;
		unsigned char infname[6],pidfile[32];
		snprintf(infname, 6, "vc%u", VC_INDEX(pEntry->ifIndex));
		snprintf(pidfile, 32, "/var/run/udhcpc%s.pid", infname);
		dhcpcpid = read_pid(pidfile);

//		printf("\npidfile=%s,dhcpcpid=%d\n",pidfile,dhcpcpid);

		if(dhcpcpid > 0)
			kill(dhcpcpid, 15);
	}
#endif
#if 0
#if defined(ZTE_531B_BRIDGE_SC)||defined(ZTE_GENERAL_ROUTER_SC)
//star: for multi-ppp
	int found=0;
	if (pEntry->cmode == ACC_PPPOE || pEntry->cmode == ACC_PPPOA)
	{
		int mibtotal,i;
		MIB_CE_ATM_VC_T tmpentry;
		mibtotal=mib_chain_total(MIB_ATM_VC_TBL);
		for(i=0;i<mibtotal;i++)
		{
					if(!mib_chain_get(MIB_ATM_VC_TBL,i,(void*)&tmpentry))
						continue;
					if(tmpentry.vpi==pEntry->vpi&&tmpentry.vci==pEntry->vci&&(tmpentry.cmode==ADSL_PPPoE||tmpentry.cmode==ADSL_PPPoA)
						&&(tmpentry.ifIndex!=pEntry->ifIndex))
					{
						found=1;
						break;
					}		
		}	
	}
#endif
#endif
	if ((pEntry->cmode != ACC_PPPOA)
#if 0
#if defined(ZTE_531B_BRIDGE_SC)||defined(ZTE_GENERAL_ROUTER_SC)
	   &&found==0
#endif
#endif
	   )
	{
		// ifconfig vc0 down
		va_cmd(IFCONFIG, 2, 1, wanif, "down");
		// wait for sar to process the queueing packets
		usleep(1000);
		// mpoactl del vc0
		snprintf(msg.data, BUF_SIZE,
			"mpoactl del vc%u", VC_INDEX(pEntry->ifIndex));
		TRACE(STA_SCRIPT, "%s\n", msg.data);
		write_to_mpoad(&msg);
		// make sure this vc been deleted completely
		while (find_pvc_from_running(pEntry->vpi, pEntry->vci));
	}

	// delete one NAT rule for the specific interface
	stopAddressMap(pEntry);

}

#ifdef WLAN_SUPPORT
/////////////////////////////////////////////////////////////////////////////
static inline int
iw_get_ext(int                  skfd,           /* Socket to the kernel */
           char *               ifname,         /* Device name */
           int                  request,        /* WE ID */
           struct iwreq *       pwrq)           /* Fixed part of the request */
{
  /* Set device name */
  strncpy(pwrq->ifr_name, ifname, IFNAMSIZ);
  /* Do the request */
  return(ioctl(skfd, request, pwrq));
}

int getWlStaInfo( char *interface,  WLAN_STA_INFO_Tp pInfo )
{
    int skfd;
    struct iwreq wrq;

    skfd = socket(AF_INET, SOCK_DGRAM, 0);

    /* Get wireless name */
    if ( iw_get_ext(skfd, interface, SIOCGIWNAME, &wrq) < 0)
    {
    	close( skfd );
      /* If no wireless name : no wireless extensions */
        return -1;
    }

    wrq.u.data.pointer = (caddr_t)pInfo;
    wrq.u.data.length = sizeof(WLAN_STA_INFO_T) * (MAX_STA_NUM+1);

    if (iw_get_ext(skfd, interface, SIOCGIWRTLSTAINFO, &wrq) < 0)
    {
    	close( skfd );
	return -1;
    }

    close( skfd );

    return 0;
}

#ifdef WLAN_ACL
// return value:
// 0  : successful
// -1 : failed
int set_wlan_acl()
{
	char *argv[8];
	unsigned char value[32];
	char parm[64];
	int num, i;
	MIB_CE_WLAN_AC_T Entry;
	int status=0;
	
	argv[1] = (char*)WLANIF;
	argv[2] = "set_mib";
	
	// aclnum=0
	sprintf(parm, "aclnum=0");
	argv[3] = parm;
	argv[4] = NULL;
	TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
	status|=do_cmd(IWPRIV, argv, 1);
	
	// aclmode
	mib_get(MIB_WLAN_AC_ENABLED, (void *)value);
	sprintf(parm, "aclmode=%u", value[0]);
	argv[3] = parm;
	argv[4] = NULL;
	TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
	status|=do_cmd(IWPRIV, argv, 1);
	
	if (value[0] == 0) // ACL disabled
		return status;
	
	if ((num = mib_chain_total(MIB_WLAN_AC_TBL)) == 0)
		return status;
	
	for (i=0; i<num; i++) {
		if (!mib_chain_get(MIB_WLAN_AC_TBL, i, (void *)&Entry))
			return;
		
		// acladdr
		sprintf(parm, "acladdr=%.2x%.2x%.2x%.2x%.2x%.2x",
			Entry.macAddr[0], Entry.macAddr[1], Entry.macAddr[2],
			Entry.macAddr[3], Entry.macAddr[4], Entry.macAddr[5]);
		argv[3] = parm;
		argv[4] = NULL;
		TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
		status|=do_cmd(IWPRIV, argv, 1);
	}
	return status;
}
#endif

#ifdef WLAN_8185AG
#define RTL8185_IOCTL_READ_EEPROM	0x89f9
static int check_wlan_eeprom()
{
	int skfd,i;
	struct iwreq wrq;
	unsigned char tmp[162];
	char mode;
	char parm[64];
	char *argv[6];
	argv[1] = (char*)WLANIF;
	argv[2] = "set_mib";
	
	skfd = socket(AF_INET, SOCK_DGRAM, 0);
	/* Set device name */
	strncpy(wrq.ifr_name, (char *)WLANIF, IFNAMSIZ);
	strcpy(tmp,"RFChipID");
	wrq.u.data.pointer = (caddr_t)&tmp;
	wrq.u.data.length = 10;
	ioctl(skfd, RTL8185_IOCTL_READ_EEPROM, &wrq);
	if(wrq.u.data.length>0){
		printf("read eeprom success!\n");
		//return 1;
	}
	else{
		printf("read eeprom fail!\n");
		if(skfd!=-1) close(skfd);
		return 0;
	}
	//set TxPowerCCK from eeprom
	strcpy(tmp,"TxPowerCCK");
	wrq.u.data.pointer = (caddr_t)&tmp;
	wrq.u.data.length = 20;
	ioctl(skfd, RTL8185_IOCTL_READ_EEPROM, &wrq);
	sprintf(parm, "TxPowerCCK=");
	if ( mib_get( MIB_TX_POWER, (void *)&mode) == 0) {
   		printf("Get MIB_TX_POWER error!\n");		
	}

//added by xl_yue: 
//#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
#ifdef WLAN_TX_POWER_DISPLAY
	if ( mode==0 ) {          // 100%
		for(i=0; i<=13; i++)
		{
	//		value[i] = 8;
			sprintf(parm, "%s%02x", parm, wrq.u.data.pointer[i]);
		}
	}else if ( mode==1 ) {    // 80%
		for(i=0; i<=13; i++)
		{
		    	wrq.u.data.pointer[i] -= 1;
			sprintf(parm, "%s%02x", parm, wrq.u.data.pointer[i]);
		}

	}else if ( mode==2 ) {    // 50%
		for(i=0; i<=13; i++)
		{
		    	wrq.u.data.pointer[i] -= 3;
			sprintf(parm, "%s%02x", parm, wrq.u.data.pointer[i]);
		}
	}else if ( mode==3 ) {    // 25%
		for(i=0; i<=13; i++)
		{
		   	wrq.u.data.pointer[i] -= 6;
			sprintf(parm, "%s%02x", parm, wrq.u.data.pointer[i]);
		}
	}else if ( mode==4 ) {    // 10%
		for(i=0; i<=13; i++)
		{
		   	wrq.u.data.pointer[i] -= 10;
			sprintf(parm, "%s%02x", parm, wrq.u.data.pointer[i]);
		}
	}	
#else
	if ( mode==2 ) {          // 60mW
		for(i=0; i<=13; i++)
		{
	//		value[i] = 8;
			sprintf(parm, "%s%02x", parm, wrq.u.data.pointer[i]);
		}	
	}else if ( mode==1 ) {    // 30mW
		for(i=0; i<=13; i++)
		{
		    	wrq.u.data.pointer[i] -= 3;
			sprintf(parm, "%s%02x", parm, wrq.u.data.pointer[i]);
		}
	}else if ( mode==0 ) {    // 15mW
		for(i=0; i<=13; i++)
		{
		   	wrq.u.data.pointer[i] -= 6;
			sprintf(parm, "%s%02x", parm, wrq.u.data.pointer[i]);
		}
	}	
#endif
	argv[3] = parm;
	argv[4] = NULL;
	TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
	do_cmd(IWPRIV, argv, 1);	

	strcpy(tmp,"TxPowerOFDM");
	wrq.u.data.pointer = (caddr_t)&tmp;
	wrq.u.data.length = 20;
	ioctl(skfd, RTL8185_IOCTL_READ_EEPROM, &wrq);
	sprintf(parm, "TxPowerOFDM=");
	if ( mib_get( MIB_TX_POWER, (void *)&mode) == 0) {
   		printf("Get MIB_TX_POWER error!\n");		
	}

//added by xl_yue: 
//#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
#ifdef WLAN_TX_POWER_DISPLAY
	if ( mode==0 ) {          // 100%
		for(i=0; i<=13; i++)
		{
	//		value[i] = 8;
			sprintf(parm, "%s%02x", parm, wrq.u.data.pointer[i]);
		}	
	}else if ( mode==1 ) {    // 80%
		for(i=0; i<=13; i++)
		{
		    	wrq.u.data.pointer[i] -= 1;
			sprintf(parm, "%s%02x", parm, wrq.u.data.pointer[i]);
		}
	}else if ( mode==2 ) {    // 50%
		for(i=0; i<=13; i++)
		{
		    	wrq.u.data.pointer[i] -= 3;
			sprintf(parm, "%s%02x", parm, wrq.u.data.pointer[i]);
		}
	}else if ( mode==3 ) {    // 25%
		for(i=0; i<=13; i++)
		{
		   	wrq.u.data.pointer[i] -= 6;
			sprintf(parm, "%s%02x", parm, wrq.u.data.pointer[i]);
		}
	}else if ( mode==4 ) {    // 10%
		for(i=0; i<=13; i++)
		{
		   	wrq.u.data.pointer[i] -= 10;
			sprintf(parm, "%s%02x", parm, wrq.u.data.pointer[i]);
		}
	}
#else
	if ( mode==2 ) {          // 60mW
		for(i=0; i<=13; i++)
		{
	//		value[i] = 8;
			sprintf(parm, "%s%02x", parm, wrq.u.data.pointer[i]);
		}	
	}else if ( mode==1 ) {    // 30mW
		for(i=0; i<=13; i++)
		{
		    	wrq.u.data.pointer[i] -= 3;
			sprintf(parm, "%s%02x", parm, wrq.u.data.pointer[i]);
		}
	}else if ( mode==0 ) {    // 15mW
		for(i=0; i<=13; i++)
		{
		   	wrq.u.data.pointer[i] -= 6;
			sprintf(parm, "%s%02x", parm, wrq.u.data.pointer[i]);
		}
	}
#endif
	argv[3] = parm;
	argv[4] = NULL;
	TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
	do_cmd(IWPRIV, argv, 1);

	close( skfd );
	return 1;
}
#endif

int setupWDS()
{
#ifdef WLAN_WDS
	char *argv[6];
	unsigned char value[16];
	char macaddr[16];
	char vChar, wds_enabled;
	char parm[32];
	char wds_num;
	WDS_T Entry;
	char wdsif[10];
	int i;
	int status = 0;
	
	argv[1] = (char*)WLANIF;
	argv[2] = "set_mib";
	
	mib_get(MIB_WLAN_MODE, (void *)&vChar);
	mib_get(MIB_WLAN_WDS_ENABLED, (void *)&wds_enabled);
	if (vChar != AP_WDS_MODE || wds_enabled == 0) {
		argv[3] = "wds_num=0";
		argv[4] = NULL;
		TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
		status|=do_cmd(IWPRIV, argv, 1);
	
		sprintf(parm, "wds_enable=0");
		argv[3] = parm;
		argv[4] = NULL;
		TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
		status|=do_cmd(IWPRIV, argv, 1);
		
		for (i=0; i<MAX_WDS_NUM; i++) {
			strcpy(wdsif,(char *)WDSIF);
			wdsif[9]+=i;
			//ifconfig wlanX-wdsX down
			status|=va_cmd(IFCONFIG, 2, 1, wdsif, "down");
			//brctl delif br0 wlanX-wdsX
			status|=va_cmd(BRCTL, 3, 1, "delif", (char *)BRIF, wdsif);
		}
		return 0;
	}
	
	// wds_pure
	vChar = 0;	// AP + WDS
	sprintf(parm, "wds_pure=%u", vChar);
	argv[3] = parm;
	argv[4] = NULL;
	TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
	status|=do_cmd(IWPRIV, argv, 1);
	
	// wds_enable
	mib_get(MIB_WLAN_WDS_ENABLED, (void *)&vChar);
	sprintf(parm, "wds_enable=%u", vChar);
	argv[3] = parm;
	argv[4] = NULL;
	TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
	status|=do_cmd(IWPRIV, argv, 1);
		
	argv[3] = "wds_num=0";
	argv[4] = NULL;
	TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
	status|=do_cmd(IWPRIV, argv, 1);
	
	//mib_get(MIB_WLAN_WDS_ENABLED, (void *)&vChar);
	//if(vChar==1){
		for (i=0; i<MAX_WDS_NUM; i++) {
			strcpy(wdsif,(char *)WDSIF);
			wdsif[9]+=i;
			//ifconfig wlanX-wdsX down
			status|=va_cmd(IFCONFIG, 2, 1, wdsif, "down");
			//brctl delif br0 wlanX-wdsX
			status|=va_cmd(BRCTL, 3, 1, "delif", (char *)BRIF, wdsif);
		}
	//}
		
	mib_get(MIB_WLAN_WDS_NUM, &wds_num);
	
	strcpy(wdsif,(char *)WDSIF);
	for(i=0;i<wds_num;i++){
		if (!mib_chain_get(MIB_WDS_TBL, i, (void *)&Entry))
			continue;
		sprintf(parm, "wds_add=%02x%02x%02x%02x%02x%02x", 
			Entry.macAddr[0], Entry.macAddr[1], Entry.macAddr[2], 
			Entry.macAddr[3], Entry.macAddr[4], Entry.macAddr[5]);
		argv[3] = parm;
		argv[4] = NULL;
		TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
		status|=do_cmd(IWPRIV, argv, 1);	
		//ifconfig wlanX-wdsX hw ether 00e04c867001
		mib_get(MIB_ELAN_MAC_ADDR, (void *)value);
		snprintf(macaddr, 13, "%02x%02x%02x%02x%02x%02x",
			value[0], value[1], value[2], value[3], value[4], value[5]);		
		wdsif[9]='0'+i;
		status|=va_cmd(IFCONFIG, 4, 1, wdsif, "hw", "ether", macaddr);

		//brctl delif br0 wlanX-wdsX
		//va_cmd(BRCTL, 3, 1, "delif", (char *)BRIF, wdsif);
		//brctl addif br0 wlanX-wdsX
		status|=va_cmd(BRCTL, 3, 1, "addif", (char *)BRIF, wdsif);

		//ifconfig wlanX-wdsX up
		status|=va_cmd(IFCONFIG, 2, 1, wdsif, "up");
	}
	
	// wds_encrypt
	vChar = 0;
	sprintf(parm, "wds_encrypt=%u", vChar);
	argv[3] = parm;
	argv[4] = NULL;
	TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
	status|=do_cmd(IWPRIV, argv, 1);

	vChar = 1;
	sprintf(parm, "wds_priority=%u", vChar);
	argv[3] = parm;
	argv[4] = NULL;
	TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
	status|=do_cmd(IWPRIV, argv, 1);
	
	//for MOD multicast-filter
	mib_get(MIB_WLAN_WDS_ENABLED, (void *)&vChar);
	if (vChar) {
		//brctl clrfltrport br0
		va_cmd(BRCTL,2,1,"clrfltrport",(char *)BRIF);
		//brctl setfltrport br0 11111
		va_cmd(BRCTL,3,1,"setfltrport",(char *)BRIF,"11111");
		//brctl setfltrport br0 55555
		va_cmd(BRCTL,3,1,"setfltrport",(char *)BRIF,"55555");
		//brctl setfltrport br0 2105
		va_cmd(BRCTL,3,1,"setfltrport",(char *)BRIF,"2105");
		//brctl setfltrport br0 2105
		va_cmd(BRCTL,3,1,"setfltrport",(char *)BRIF,"2107");
	}
	
	return status;
#else
	return 0;
#endif
}

//added by xl_yue
#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
int isAllZero(unsigned char * buffer, int len)
{
	int i;
	for(i=0;i<len;i++)
	{
		if(buffer[i] != 0)
			return 0;
	}

	return 1;
}
#endif

// return value:
// 0  : success
// -1 : failed
int setupWLan()
{
	char *argv[6];
	unsigned char value[34];
	char parm[64], para2[15];
	int i, vInt, autoRate;
	// Added by Mason Yu for Set TxPower
	char mode=-1;
	int status=0;
	unsigned char stringbuf[MAX_SSID_LEN + 1];
	unsigned char rootSSID[MAX_SSID_LEN + 1];
#ifdef WLAN_MBSSID
	int j=0;
	MIB_CE_MBSSIB_T Entry;
	MIB_CE_MBSSIB_WEP_T EntryWEP;
#endif
	
	// ifconfig wlan0 hw ether 00e04c867002
	/*if (mib_get(MIB_WLAN_MAC_ADDR, (void *)value) != 0)
	{
		snprintf(macaddr, 13, "%02x%02x%02x%02x%02x%02x",
			value[0], value[1], value[2], value[3], value[4], value[5]);
		argv[1]=(char *)WLANIF;
		argv[2]="hw";
		argv[3]="ether";
		argv[4]=macaddr;
		argv[5]=NULL;
		TRACE(STA_SCRIPT, "%s %s %s %s %s\n", IFCONFIG, argv[1], argv[2], argv[3], argv[4]);
		do_cmd(IFCONFIG, argv, 1);
	}*/
	
	argv[1] = (char*)WLANIF;
	argv[2] = "set_mib";
	// regdomain
//added by xl_yue
#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
	mib_get(MIB_WLAN_REG_DOMAIN, (void *)value);
#else
	mib_get(MIB_HW_REG_DOMAIN, (void *)value);
#endif
	sprintf(parm, "regdomain=%u", value[0]);
	argv[3] = parm;
	argv[4] = NULL;
	TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
	status|=do_cmd(IWPRIV, argv, 1);
#if 0//cathy	
	// led_type
	mib_get(MIB_HW_LED_TYPE, (void *)value);
	sprintf(parm, "led_type=%u", value[0]);
	argv[3] = parm;
	argv[4] = NULL;
	TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
	status|=do_cmd(IWPRIV, argv, 1);
#endif
	// Root AP
//added by xl_yue
#ifdef ZTE_531B_BRIDGE_SC
	if (mib_get(MIB_ELAN_MAC_ADDR, (void *)value) != 0)
	{
		memset(stringbuf, 0, sizeof(stringbuf));
		if(mib_get(MIB_WLAN_SSID, (void*)stringbuf))
		{
			printf("get root ap ssid= %s\n", stringbuf);
			if(strlen(stringbuf)==0)
			{	
				value[0] = value[0]^value[2]^value[4];
				value[1] = value[1]^value[3]^value[5];
				snprintf((char *)(stringbuf), 9, "CTC-%02x%02x",value[0]+0xaa, value[1]+0xaa);
				if ( mib_set(MIB_WLAN_SSID, (void *)stringbuf ) == 0) 
				{
					printf("set root ssid error!\n");
				}
			}
			strcpy(rootSSID,stringbuf);	
		}
	}
#endif

#ifdef ZTE_GENERAL_ROUTER_SC
	if (mib_get(MIB_ELAN_MAC_ADDR, (void *)value) != 0)
	{
		memset(stringbuf, 0, sizeof(stringbuf));
		if(mib_get(MIB_WLAN_SSID, (void*)stringbuf))
		{
			printf("get root ap ssid= %s\n", stringbuf);
			if(strlen(stringbuf)==0)
			{	
				value[3] ^= value[0];
				value[4] ^= value[1];
				value[5] ^= value[2];
				snprintf((char *)(stringbuf), 12, "531B-%02x%02x%02x",value[3],value[4], value[5]);
				if ( mib_set(MIB_WLAN_SSID, (void *)stringbuf ) == 0) 
				{
					printf("set root ssid error!\n");
				}
			}
			strcpy(rootSSID,stringbuf);	
		}
	}
#endif

	// ssid
	// Modified by Mason Yu
	// Root AP's SSID
	mib_get(MIB_WLAN_SSID, (void *)value);
	sprintf(parm, "ssid=%s", value);
	argv[3] = parm;
	argv[4] = NULL;
	TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
	status|=do_cmd(IWPRIV, argv, 1);

#ifdef WLAN_MBSSID	
	// VAP's SSID
	for (j=1; j<=4; j++) {
		if (!mib_chain_get(MIB_MBSSIB_TBL, j, (void *)&Entry)) {  		
  			printf("Error! Get MIB_MBSSIB_TBL for VAP SSID error.\n");					
		}

//added by xl_yue: for createing random virtual SSID
#ifdef ZTE_531B_BRIDGE_SC
		if (mib_get(MIB_ELAN_MAC_ADDR, (void *)value) != 0)
		{
			if(strlen(Entry.ssid)==0)
			{
				printf("change virtual ssid%d from default: %s to ",j,Entry.ssid);
				value[0] = value[0]^value[2]^value[4];
				value[1] = value[1]^value[3]^value[5] ^ ((unsigned char)j);
				//snprintf((char *)(Entry.ssid), 9, "CTC-%02x%02x",value[0], value[1]);
				sprintf(Entry.ssid,"%s%d",rootSSID,j+1);
				printf("random: %s\n",Entry.ssid);
				mib_chain_update(MIB_MBSSIB_TBL, (void *)&Entry, j);
			}
		}
#endif
#ifdef ZTE_GENERAL_ROUTER_SC
		if (mib_get(MIB_ELAN_MAC_ADDR, (void *)value) != 0)
		{
			if(strlen(Entry.ssid)==0)
			{
				printf("change virtual ssid%d from default: %s to ",j,Entry.ssid);
				value[5] = value[5] +((unsigned char)j);
				//snprintf((char *)(Entry.ssid), 12, "531B-%02x%02x%02x",value[3], value[4],value[5]);
				sprintf(Entry.ssid,"%s%d",rootSSID,j+1);
				printf("random: %s\n",Entry.ssid);
				mib_chain_update(MIB_MBSSIB_TBL, (void *)&Entry, j);
			}
		}
#endif
 		//if ( Entry.wlanDisabled == 1 ) {
			sprintf(para2, "wlan0-vap%d", j-1);
			sprintf(parm, "ssid=%s", Entry.ssid);
			argv[1] = para2;
			argv[3] = parm;
			argv[4] = NULL;
			TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
			status|=do_cmd(IWPRIV, argv, 1);	
		//}		
	}
	argv[1] = (char*)WLANIF;
#endif	

	// opmode
	mib_get(MIB_WLAN_MODE, (void *)value);
	if (value[0] == CLIENT_MODE) 
		vInt = 8;	// client
	else	// 0(AP_MODE) or 3(AP_WDS_MODE)
		vInt = 16;	// AP

	sprintf(parm, "opmode=%u", vInt);
	argv[3] = parm;
	argv[4] = NULL;
	TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
	status|=do_cmd(IWPRIV, argv, 1);

	// RFChipID
	//12/16/04' hrchen, set to 0 for driver support auto select
	mib_get(MIB_HW_RF_TYPE, (void *)value);
	sprintf(parm, "RFChipID=%u", value[0]);
	argv[3] = parm;
	argv[4] = NULL;
	TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
	status|=do_cmd(IWPRIV, argv, 1);
	
	// Diversity
	mib_get(MIB_HW_ANT_DIVERSITY, (void *)value);
	sprintf(parm, "Diversity=%u", value[0]);
	argv[3] = parm;
	argv[4] = NULL;
	TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
	status|=do_cmd(IWPRIV, argv, 1);
	
	// DefaultAnt
	mib_get(MIB_HW_TX_ANT, (void *)value);
	sprintf(parm, "DefaultAnt=%u", value[0]);
	argv[3] = parm;
	argv[4] = NULL;
	TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
	status|=do_cmd(IWPRIV, argv, 1);
	
	//12/16/04' hrchen, according to David, set to 4
	// initialGain
	value[0] = 4;
	sprintf(parm, "initialGain=%u", value[0]);
	argv[3] = parm;
	argv[4] = NULL;
	TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
	status|=do_cmd(IWPRIV, argv, 1);

	// shortretry
	argv[3] = "shortretry=6";
	argv[4] = NULL;
	TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
	status|=do_cmd(IWPRIV, argv, 1);
	
	// longretry
	argv[3] = "longretry=6";
	argv[4] = NULL;
	TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
	status|=do_cmd(IWPRIV, argv, 1);
	
#ifdef WLAN_8185AG
	//12/16/04' hrchen, only need to set once
	// Added by Mason Yu for Set TxPower	

	//check if eeprom exist
	if(!check_wlan_eeprom()){
		//no eeprom
		if ( mib_get( MIB_TX_POWER, (void *)&mode) == 0) {
   			printf("Get MIB_TX_POWER error!\n");		
   			status=-1;
		}
		
		i=0;	
		mib_get(MIB_HW_TX_POWER_CCK, (void *)value);
		sprintf(parm, "TxPowerCCK=");

//added by xl_yue: 
//#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
#ifdef WLAN_TX_POWER_DISPLAY
		if ( mode==0 ) {          // 100%
			for(i=0; i<=13; i++)
			{
	//			    value[i] = 8;
				sprintf(parm, "%s%02x", parm, value[i]);
			}	
		}else if ( mode==1 ) {    // 80%
			for(i=0; i<=13; i++)
			{
			    	value[i] -= 1;
				sprintf(parm, "%s%02x", parm, value[i]);
			}
		}else if ( mode==2 ) {    // 50%
			for(i=0; i<=13; i++)
			{
			    	value[i] -= 3;
				sprintf(parm, "%s%02x", parm, value[i]);
			}
		}else if ( mode==3 ) {    // 25%
			for(i=0; i<=13; i++)
			{
			   	value[i] -= 6;
				sprintf(parm, "%s%02x", parm, value[i]);
			}
		}else if ( mode==4 ) {    // 10%
			for(i=0; i<=13; i++)
			{
			   	value[i] -= 10;
				sprintf(parm, "%s%02x", parm, value[i]);
			}
		}
#else

		if ( mode==2 ) {          // 60mW
			for(i=0; i<=13; i++)
			{
	//			    value[i] = 8;
				sprintf(parm, "%s%02x", parm, value[i]);
			}	
		}else if ( mode==1 ) {    // 30mW
			for(i=0; i<=13; i++)
			{
			    	value[i] -= 3;
				sprintf(parm, "%s%02x", parm, value[i]);
			}
		}else if ( mode==0 ) {    // 15mW
			for(i=0; i<=13; i++)
			{
			   	value[i] -= 6;
				sprintf(parm, "%s%02x", parm, value[i]);
			}
		}
#endif	
		argv[3] = parm;
		argv[4] = NULL;
//		printf("txpower mode = %u,set = %s\n",mode,parm);
		TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
		status|=do_cmd(IWPRIV, argv, 1);
			
		mib_get(MIB_HW_TX_POWER_OFDM, (void *)value);
		sprintf(parm, "TxPowerOFDM=");

//added by xl_yue: 
//#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
#ifdef WLAN_TX_POWER_DISPLAY
		if ( mode==0 ) {          // 100%
			for(i=0; i<=13; i++)
			{
//			    value[i] = 8;
				sprintf(parm, "%s%02x", parm, value[i]);
			}	
		}else if ( mode==1 ) {    // 80%
			for(i=0; i<=13; i++)
			{
			    	value[i] -= 1;
				sprintf(parm, "%s%02x", parm, value[i]);
			}
		}else if ( mode==2 ) {    // 50%
			for(i=0; i<=13; i++)
			{
			    	value[i] -= 3;
				sprintf(parm, "%s%02x", parm, value[i]);
			}
		}else if ( mode==3 ) {    // 25%
			for(i=0; i<=13; i++)
			{
			   	value[i] -= 6;
				sprintf(parm, "%s%02x", parm, value[i]);
			}
		}else if ( mode==4 ) {    // 10%
			for(i=0; i<=13; i++)
			{
			   	value[i] -= 10;
				sprintf(parm, "%s%02x", parm, value[i]);
			}
		}	
#else
		if ( mode==2 ) {          // 60mW
			for(i=0; i<=13; i++)
			{
//			    value[i] = 8;
				sprintf(parm, "%s%02x", parm, value[i]);
			}	
		}else if ( mode==1 ) {    // 30mW
			for(i=0; i<=13; i++)
			{
			    	value[i] -= 3;
				sprintf(parm, "%s%02x", parm, value[i]);
			}
		}else if ( mode==0 ) {    // 15mW
			for(i=0; i<=13; i++)
			{
			   	value[i] -= 6;
				sprintf(parm, "%s%02x", parm, value[i]);
			}
		}	
#endif	
		argv[3] = parm;
		argv[4] = NULL;
//		printf("txpower mode = %u,set = %s\n",mode,parm);
		TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
		status|=do_cmd(IWPRIV, argv, 1);
	}	
#endif
	
	// bcnint
	mib_get(MIB_WLAN_BEACON_INTERVAL, (void *)value);
	vInt = (int)(*(unsigned short *)value);
	sprintf(parm, "bcnint=%u", vInt);
	argv[3] = parm;
	argv[4] = NULL;
	TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
	status|=do_cmd(IWPRIV, argv, 1);
	
	// channel
	mib_get(MIB_WLAN_CHAN_NUM, (void *)value);
	sprintf(parm, "channel=%u", value[0]);
	argv[3] = parm;
	argv[4] = NULL;
	TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
	status|=do_cmd(IWPRIV, argv, 1);
	
#ifdef WIFI_TEST
	mib_get(MIB_WLAN_BAND, (void *)value);
	if (value[0] == 4) // WiFi-G
		sprintf(parm, "basicrates=%u", 0x15f);
	else if (value[0] == 5) // WiFi-BG
		sprintf(parm, "basicrates=%u", 0x00f);
	else {
#endif
	//jim do wifi test tricky, 
	//    1 for wifi logo test, 
	//    0 for normal case...
	mib_get(MIB_WIFI_SUPPORT, (void*)value);
	if(value[0]==1){
		mib_get(MIB_WLAN_BAND, (void *)value);
		if (value[0] == 2) // WiFi-G
			sprintf(parm, "basicrates=%u", 0x15f);
		else if (value[0] == 3) // WiFi-BG
			sprintf(parm, "basicrates=%u", 0x00f);
		else {	
			mib_get(MIB_WLAN_BASIC_RATE, (void *)value);
			vInt = (int)(*(unsigned short *)value);
			sprintf(parm, "basicrates=%u", vInt);
		}
	}
	else{
		// basicrates
		mib_get(MIB_WLAN_BASIC_RATE, (void *)value);
		vInt = (int)(*(unsigned short *)value);
		sprintf(parm, "basicrates=%u", vInt);
	}
#ifdef WIFI_TEST
	}
#endif
	argv[3] = parm;
	argv[4] = NULL;
	TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
	status|=do_cmd(IWPRIV, argv, 1);
	
#ifdef WIFI_TEST
	mib_get(MIB_WLAN_BAND, (void *)value);
	if (value[0] == 4) // WiFi-G
		sprintf(parm, "oprates=%u", 0xfff);
	else if (value[0] == 5) // WiFi-BG
		sprintf(parm, "oprates=%u", 0xfff);
	else {
#endif
	//jim do wifi test tricky, 
	//    1 for wifi logo test, 
	//    0 for normal case...
	mib_get(MIB_WIFI_SUPPORT, (void*)value);
	if(value[0]==1){
		mib_get(MIB_WLAN_BAND, (void *)value);
		if (value[0] == 2) // WiFi-G
			sprintf(parm, "oprates=%u", 0xfff);
		else if (value[0] == 3) // WiFi-BG
			sprintf(parm, "oprates=%u", 0xfff);
		else {
			mib_get(MIB_WLAN_SUPPORTED_RATE, (void *)value);
			vInt = (int)(*(unsigned short *)value);
			sprintf(parm, "oprates=%u", vInt);
		}
	}
	else{
		// oprates
		mib_get(MIB_WLAN_SUPPORTED_RATE, (void *)value);
		vInt = (int)(*(unsigned short *)value);
		sprintf(parm, "oprates=%u", vInt);
	}
#ifdef WIFI_TEST
	}
#endif
	argv[3] = parm;
	argv[4] = NULL;
	TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
	status|=do_cmd(IWPRIV, argv, 1);
	
	// autorate
	mib_get(MIB_WLAN_RATE_ADAPTIVE_ENABLED, (void *)value);
	autoRate = (int)value[0];
	sprintf(parm, "autorate=%u", autoRate);
	argv[3] = parm;
	argv[4] = NULL;
	TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
	status|=do_cmd(IWPRIV, argv, 1);
	
	// rtsthres
	mib_get(MIB_WLAN_RTS_THRESHOLD, (void *)value);
	vInt = (int)(*(unsigned short *)value);
	sprintf(parm, "rtsthres=%u", vInt);
	argv[3] = parm;
	argv[4] = NULL;
	TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
	status|=do_cmd(IWPRIV, argv, 1);
	
	// fragthres
	mib_get(MIB_WLAN_FRAG_THRESHOLD, (void *)value);
	vInt = (int)(*(unsigned short *)value);
	sprintf(parm, "fragthres=%u", vInt);
	argv[3] = parm;
	argv[4] = NULL;
	TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
	status|=do_cmd(IWPRIV, argv, 1);
	
	// expired_time
	mib_get(MIB_WLAN_INACTIVITY_TIME, (void *)value);
	vInt = (int)(*(unsigned long *)value);
	sprintf(parm, "expired_time=%u", vInt);
	argv[3] = parm;
	argv[4] = NULL;
	TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
	status|=do_cmd(IWPRIV, argv, 1);
	
	// preamble
	mib_get(MIB_WLAN_PREAMBLE_TYPE, (void *)value);

//modified  by xl_yue
#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
	if(value[0] == AUTO_PREAMBLE)
		value[0] = SHORT_PREAMBLE;
#endif

	sprintf(parm, "preamble=%u", value[0]);
	argv[3] = parm;
	argv[4] = NULL;
	TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
	status|=do_cmd(IWPRIV, argv, 1);
	
	// hiddenAP
	mib_get(MIB_WLAN_HIDDEN_SSID, (void *)value);
	sprintf(parm, "hiddenAP=%u", value[0]);
	argv[3] = parm;
	argv[4] = NULL;
	TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
	status|=do_cmd(IWPRIV, argv, 1);
	
	// dtimperiod
	mib_get(MIB_WLAN_DTIM_PERIOD, (void *)value);
	sprintf(parm, "dtimperiod=%u", value[0]);
	argv[3] = parm;
	argv[4] = NULL;
	TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
	status|=do_cmd(IWPRIV, argv, 1);
	
#ifdef WLAN_ACL
	status|=set_wlan_acl();
#endif
	
	// authtype
	// Modified by Mason Yu
	// Root AP's authtype
	mib_get(MIB_WLAN_AUTH_TYPE, (void *)value);
	mib_get(MIB_WLAN_ENCRYPT, (void *)&value[1]);
	
	if (value[0] == 1 && value[1] != 1)
		// shared-key and not WEP enabled, force to open-system
		value[0] = 0;
	
	sprintf(parm, "authtype=%u", value[0]);
	argv[3] = parm;
	argv[4] = NULL;
	TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
	status|=do_cmd(IWPRIV, argv, 1);


#ifdef WLAN_MBSSID	
	// VAP
	for (j=1; j<=4; j++) {
		if (!mib_chain_get(MIB_MBSSIB_TBL, j, (void *)&Entry)) {  		
  			printf("Error! Get MIB_MBSSIB_TBL for VAP SSID error.\n");					
		}
		
		//if ( Entry.wlanDisabled == 1 ) {
			sprintf(para2, "wlan0-vap%d", j-1);
			
			value[0] = Entry.authType;
			value[1] = Entry.encrypt;
			if (value[0] == 1 && value[1] != 1)
				// shared-key and not WEP enabled, force to open-system
				value[0] = 0;
	
			sprintf(parm, "authtype=%u", value[0]);
			argv[1] = para2;
			argv[3] = parm;
			argv[4] = NULL;
			TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
			status|=do_cmd(IWPRIV, argv, 1);				
		//}		
	}
	argv[1] = (char*)WLANIF;
#endif


#ifdef WLAN_WPA

	// Modified by Mason Yu
	// encmode
	// Root AP
//added by xl_yue: create random wep key for rootAP
#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
		if (mib_get(MIB_ELAN_MAC_ADDR, (void *)value) != 0)
		{
			value[0] = value[0]^value[2]^value[4];
			value[1] = value[1]^value[3]^value[5];
			mib_get(MIB_WLAN_WEP64_KEY1, (void *)stringbuf);
			if(isAllZero(stringbuf,5)){
				snprintf((char *)(stringbuf), 6, "%02x%02x%d",value[0], value[1], 1);
				mib_set(MIB_WLAN_WEP64_KEY1, (void *)stringbuf);
			}
			mib_get(MIB_WLAN_WEP64_KEY2, (void *)stringbuf);
			if(isAllZero(stringbuf,5)){
				snprintf((char *)(stringbuf), 6, "%02x%02x%d",value[0], value[1], 2);
				mib_set(MIB_WLAN_WEP64_KEY2, (void *)stringbuf);
			}
			mib_get(MIB_WLAN_WEP64_KEY3, (void *)stringbuf);
			if(isAllZero(stringbuf,5)){
				snprintf((char *)(stringbuf), 6, "%02x%02x%d",value[0], value[1], 3);
				mib_set(MIB_WLAN_WEP64_KEY3, (void *)stringbuf);
			}
			mib_get(MIB_WLAN_WEP64_KEY4, (void *)stringbuf);
			if(isAllZero(stringbuf,5)){
				snprintf((char *)(stringbuf), 6, "%02x%02x%d",value[0], value[1], 4);
				mib_set(MIB_WLAN_WEP64_KEY4, (void *)stringbuf);
			}
			mib_get(MIB_WLAN_WEP128_KEY1, (void *)stringbuf);
			if(isAllZero(stringbuf,13)){
				snprintf((char *)(stringbuf), 14, "%02x%02x%02x%02x%02x%02x%d",value[0], value[1], value[2], value[3], value[4], value[5], 1);
				mib_set(MIB_WLAN_WEP128_KEY1, (void *)stringbuf);
			}
			mib_get(MIB_WLAN_WEP128_KEY2, (void *)stringbuf);
			if(isAllZero(stringbuf,13)){
				snprintf((char *)(stringbuf), 14, "%02x%02x%02x%02x%02x%02x%d",value[0], value[1], value[2], value[3], value[4], value[5], 2);
				mib_set(MIB_WLAN_WEP128_KEY2, (void *)stringbuf);
			}
			mib_get(MIB_WLAN_WEP128_KEY3, (void *)stringbuf);
			if(isAllZero(stringbuf,13)){
				snprintf((char *)(stringbuf), 14, "%02x%02x%02x%02x%02x%02x%d",value[0], value[1], value[2], value[3], value[4], value[5], 3);
				mib_set(MIB_WLAN_WEP128_KEY3, (void *)stringbuf);
			}
			mib_get(MIB_WLAN_WEP128_KEY4, (void *)stringbuf);
			if(isAllZero(stringbuf,13)){
				snprintf((char *)(stringbuf), 14, "%02x%02x%02x%02x%02x%02x%d",value[0], value[1], value[2], value[3], value[4], value[5], 4);
				mib_set(MIB_WLAN_WEP128_KEY4, (void *)stringbuf);
			}
		}
#endif

	mib_get(MIB_WLAN_ENCRYPT, (void *)value);
	vInt = (int)value[0];
	
	if (vInt == 1)	// WEP mode
	{
		mib_get(MIB_WLAN_WEP, (void *)value);
		if (value[0] == 1) {
			// 64 bits
			// wepkey1
			mib_get(MIB_WLAN_WEP64_KEY1, (void *)value);
			sprintf(parm, "wepkey1=%02x%02x%02x%02x%02x", value[0],
				value[1], value[2], value[3], value[4]);
			argv[3] = parm;
			argv[4] = NULL;
			TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
			status|=do_cmd(IWPRIV, argv, 1);
			
			// wepkey2
			mib_get(MIB_WLAN_WEP64_KEY2, (void *)value);
			sprintf(parm, "wepkey2=%02x%02x%02x%02x%02x", value[0],
				value[1], value[2], value[3], value[4]);
			argv[3] = parm;
			argv[4] = NULL;
			TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
			status|=do_cmd(IWPRIV, argv, 1);
			
			// wepkey3
			mib_get(MIB_WLAN_WEP64_KEY3, (void *)value);
			sprintf(parm, "wepkey3=%02x%02x%02x%02x%02x", value[0],
				value[1], value[2], value[3], value[4]);
			argv[3] = parm;
			argv[4] = NULL;
			TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
			status|=do_cmd(IWPRIV, argv, 1);
			
			// wepkey4
			mib_get(MIB_WLAN_WEP64_KEY4, (void *)value);
			sprintf(parm, "wepkey4=%02x%02x%02x%02x%02x", value[0],
				value[1], value[2], value[3], value[4]);
			argv[3] = parm;
			argv[4] = NULL;
			TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
			status|=do_cmd(IWPRIV, argv, 1);
			
			// wepdkeyid
			mib_get(MIB_WLAN_WEP_DEFAULT_KEY, (void *)value);
			sprintf(parm, "wepdkeyid=%u", value[0]);
			argv[3] = parm;
			argv[4] = NULL;
			TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
			status|=do_cmd(IWPRIV, argv, 1);
		}
		else {
			// 128 bits
			vInt = 5; // encmode = 5
			// wepkey1
			mib_get(MIB_WLAN_WEP128_KEY1, (void *)value);
			sprintf(parm, "wepkey1=%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x",
				value[0], value[1], value[2], value[3], value[4],
				value[5], value[6], value[7], value[8], value[9],
				value[10], value[11], value[12]);
			argv[3] = parm;
			argv[4] = NULL;
			TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
			status|=do_cmd(IWPRIV, argv, 1);
			
			// wepkey2
			mib_get(MIB_WLAN_WEP128_KEY2, (void *)value);
			sprintf(parm, "wepkey2=%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x",
				value[0], value[1], value[2], value[3], value[4],
				value[5], value[6], value[7], value[8], value[9],
				value[10], value[11], value[12]);
			argv[3] = parm;
			argv[4] = NULL;
			TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
			status|=do_cmd(IWPRIV, argv, 1);
			
			// wepkey3
			mib_get(MIB_WLAN_WEP128_KEY3, (void *)value);
			sprintf(parm, "wepkey3=%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x",
				value[0], value[1], value[2], value[3], value[4],
				value[5], value[6], value[7], value[8], value[9],
				value[10], value[11], value[12]);
			argv[3] = parm;
			argv[4] = NULL;
			TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
			status|=do_cmd(IWPRIV, argv, 1);
			
			// wepkey4
			mib_get(MIB_WLAN_WEP128_KEY4, (void *)value);
			sprintf(parm, "wepkey4=%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x",
				value[0], value[1], value[2], value[3], value[4],
				value[5], value[6], value[7], value[8], value[9],
				value[10], value[11], value[12]);
			argv[3] = parm;
			argv[4] = NULL;
			TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
			status|=do_cmd(IWPRIV, argv, 1);
			
			// wepdkeyid
			mib_get(MIB_WLAN_WEP_DEFAULT_KEY, (void *)value);
			sprintf(parm, "wepdkeyid=%u", value[0]);
			argv[3] = parm;
			argv[4] = NULL;
			TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
			status|=do_cmd(IWPRIV, argv, 1);
		}
	}
	// Kaohj --- this is for driver level security.
	// ignoring it if using userland 'auth' security
	#if 0
	else if (vInt >= 2) {	// WPA setup
		char buf[1024];
		// psk_enable: 1: WPA, 2: WPA2, 3: WPA+WPA2
		sprintf(parm, "psk_enable=%d", vInt/2);
		argv[3] = parm;
		argv[4] = NULL;
		TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
		status|=do_cmd(IWPRIV, argv, 1);
		
		//if (vInt == ENCRYPT_WPA) {
			// wpa_cipher: fixed at TKIP:2
			sprintf(parm, "wpa_cipher=2");
			argv[3] = parm;
			argv[4] = NULL;
			TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
			status|=do_cmd(IWPRIV, argv, 1);
		//}
		//else if (vInt == ENCRYPT_WPA2) {
			// wpa2_cipher: fixed at AES:8
			sprintf(parm, "wpa2_cipher=8");
			argv[3] = parm;
			argv[4] = NULL;
			TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
			status|=do_cmd(IWPRIV, argv, 1);
		//}
		//else {// mixed mode
		//}
		// passphrase
		mib_get( MIB_WLAN_WPA_PSK, (void *)parm);
		sprintf(buf, "passphrase=%s", parm);
		argv[3] = buf;
		argv[4] = NULL;
		TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
		status|=do_cmd(IWPRIV, argv, 1);
	}
	#endif
	
	sprintf(parm, "encmode=%u", vInt);
	argv[3] = parm;
	argv[4] = NULL;
	TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
	status|=do_cmd(IWPRIV, argv, 1);

#ifdef WLAN_MBSSID
	// encmode	
	for (j=1; j<=4; j++) {
		if (!mib_chain_get(MIB_MBSSIB_TBL, j, (void *)&Entry)) {  		
  			printf("Error! Get MIB_MBSSIB_TBL error.\n");					
		}
		
		if (!mib_chain_get(MIB_MBSSIB_WEP_TBL, j, (void *)&EntryWEP)) {  		
  			printf("Error! Get MIB_MBSSIB_WEP_TBL error.\n");					
		}

//added by xl_yue: create random wep key
#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
		if (mib_get(MIB_ELAN_MAC_ADDR, (void *)value) != 0)
		{
			value[0] = value[0]^value[2]^value[4]^j;
			value[1] = value[1]^value[3]^value[5];
//			if(strlen(EntryWEP.wep64Key1) == 0){
			if(isAllZero((EntryWEP.wep64Key1),5)){
				snprintf((char *)(stringbuf), 6, "%02x%02x%d",value[0], value[1], 1);
				memcpy(EntryWEP.wep64Key1,stringbuf,WEP64_KEY_LEN);
			}
//			if(strlen(EntryWEP.wep64Key2) == 0){
			if(isAllZero((EntryWEP.wep64Key2),5)){
				snprintf((char *)(stringbuf), 6, "%02x%02x%d",value[0], value[1], 2);
				memcpy(EntryWEP.wep64Key2,stringbuf,WEP64_KEY_LEN);
			}
//			if(strlen(EntryWEP.wep64Key3) == 0){
			if(isAllZero((EntryWEP.wep64Key3),5)){
				snprintf((char *)(stringbuf), 6, "%02x%02x%d",value[0], value[1], 3);
				memcpy(EntryWEP.wep64Key3,stringbuf,WEP64_KEY_LEN);
			}
//			if(strlen(EntryWEP.wep64Key4) == 0){
			if(isAllZero((EntryWEP.wep64Key4),5)){
				snprintf((char *)(stringbuf), 6, "%02x%02x%d",value[0], value[1], 4);
				memcpy(EntryWEP.wep64Key4,stringbuf,WEP64_KEY_LEN);
			}
//			if(strlen(EntryWEP.wep128Key1) == 0){
			if(isAllZero((EntryWEP.wep128Key1),13)){
				snprintf((char *)(stringbuf), 14, "%02x%02x%02x%02x%02x%02x%d",value[0], value[1], value[2], value[3], value[4], value[5], 1);
				memcpy(EntryWEP.wep128Key1,stringbuf,WEP128_KEY_LEN);
			}
//			if(strlen(EntryWEP.wep128Key2) == 0){
			if(isAllZero((EntryWEP.wep128Key2),13)){
				snprintf((char *)(stringbuf), 14, "%02x%02x%02x%02x%02x%02x%d",value[0], value[1], value[2], value[3], value[4], value[5], 2);
				memcpy(EntryWEP.wep128Key2,stringbuf,WEP128_KEY_LEN);
			}
//			if(strlen(EntryWEP.wep128Key3) == 0){
			if(isAllZero((EntryWEP.wep128Key3),13)){
				snprintf((char *)(stringbuf), 14, "%02x%02x%02x%02x%02x%02x%d",value[0], value[1], value[2], value[3], value[4], value[5], 3);
				memcpy(EntryWEP.wep128Key3,stringbuf,WEP128_KEY_LEN);
			}
//			if(strlen(EntryWEP.wep128Key4) == 0){
			if(isAllZero((EntryWEP.wep128Key4),13)){
				snprintf((char *)(stringbuf), 14, "%02x%02x%02x%02x%02x%02x%d",value[0], value[1], value[2], value[3], value[4], value[5], 4);
				memcpy(EntryWEP.wep128Key4,stringbuf,WEP128_KEY_LEN);
			}

			mib_chain_update(MIB_MBSSIB_WEP_TBL, (void *)&EntryWEP, j);
		}
#endif
			
		if ( j != 0 ) {
			sprintf(para2, "wlan0-vap%d", j-1);			
			argv[1] = para2;				
		}	
		
		//mib_get(MIB_WLAN_ENCRYPT, (void *)value);
		//vInt = (int)value[0];
		vInt = (int)Entry.encrypt;
		
		if (vInt == 1)	// WEP mode
		{
			//mib_get(MIB_WLAN_WEP, (void *)value);
			value[0] = Entry.wep;
			if (value[0] == 1) {
				// 64 bits
				// wepkey1
				//mib_get(MIB_WLAN_WEP64_KEY1, (void *)value);				
				memcpy(value, EntryWEP.wep64Key1, WEP64_KEY_LEN);
				sprintf(parm, "wepkey1=%02x%02x%02x%02x%02x", value[0],
					value[1], value[2], value[3], value[4]);
				argv[3] = parm;
				argv[4] = NULL;
				TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
				status|=do_cmd(IWPRIV, argv, 1);
				
				// wepkey2
				//mib_get(MIB_WLAN_WEP64_KEY2, (void *)value);				
				memcpy(value, EntryWEP.wep64Key2, WEP64_KEY_LEN);
				sprintf(parm, "wepkey2=%02x%02x%02x%02x%02x", value[0],
					value[1], value[2], value[3], value[4]);
				argv[3] = parm;
				argv[4] = NULL;
				TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
				status|=do_cmd(IWPRIV, argv, 1);
				
				// wepkey3
				//mib_get(MIB_WLAN_WEP64_KEY3, (void *)value);				
				memcpy(value, EntryWEP.wep64Key3, WEP64_KEY_LEN);
				sprintf(parm, "wepkey3=%02x%02x%02x%02x%02x", value[0],
					value[1], value[2], value[3], value[4]);
				argv[3] = parm;
				argv[4] = NULL;
				TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
				status|=do_cmd(IWPRIV, argv, 1);
				
				// wepkey4
				//mib_get(MIB_WLAN_WEP64_KEY4, (void *)value);				
				memcpy(value, EntryWEP.wep64Key4, WEP64_KEY_LEN);
				sprintf(parm, "wepkey4=%02x%02x%02x%02x%02x", value[0],
					value[1], value[2], value[3], value[4]);
				argv[3] = parm;
				argv[4] = NULL;
				TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
				status|=do_cmd(IWPRIV, argv, 1);
				
				// wepdkeyid
				//mib_get(MIB_WLAN_WEP_DEFAULT_KEY, (void *)value);
				value[0] = EntryWEP.wepDefaultKey;
				sprintf(parm, "wepdkeyid=%u", value[0]);
				argv[3] = parm;
				argv[4] = NULL;
				TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
				status|=do_cmd(IWPRIV, argv, 1);
			}
			else {
				// 128 bits
				vInt = 5; // encmode = 5
				// wepkey1
				//mib_get(MIB_WLAN_WEP128_KEY1, (void *)value);				
				memcpy(value, EntryWEP.wep128Key1, WEP128_KEY_LEN);
				sprintf(parm, "wepkey1=%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x",
					value[0], value[1], value[2], value[3], value[4],
					value[5], value[6], value[7], value[8], value[9],
					value[10], value[11], value[12]);
				argv[3] = parm;
				argv[4] = NULL;
				TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
				status|=do_cmd(IWPRIV, argv, 1);
				
				// wepkey2
				//mib_get(MIB_WLAN_WEP128_KEY2, (void *)value);				
				memcpy(value, EntryWEP.wep128Key2, WEP128_KEY_LEN);
				sprintf(parm, "wepkey2=%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x",
					value[0], value[1], value[2], value[3], value[4],
					value[5], value[6], value[7], value[8], value[9],
					value[10], value[11], value[12]);
				argv[3] = parm;
				argv[4] = NULL;
				TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
				status|=do_cmd(IWPRIV, argv, 1);
				
				// wepkey3
				//mib_get(MIB_WLAN_WEP128_KEY3, (void *)value);				
				memcpy(value, EntryWEP.wep128Key3, WEP128_KEY_LEN);
				sprintf(parm, "wepkey3=%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x",
					value[0], value[1], value[2], value[3], value[4],
					value[5], value[6], value[7], value[8], value[9],
					value[10], value[11], value[12]);
				argv[3] = parm;
				argv[4] = NULL;
				TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
				status|=do_cmd(IWPRIV, argv, 1);
				
				// wepkey4
				//mib_get(MIB_WLAN_WEP128_KEY4, (void *)value);				
				memcpy(value, EntryWEP.wep128Key4, WEP128_KEY_LEN);
				sprintf(parm, "wepkey4=%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x",
					value[0], value[1], value[2], value[3], value[4],
					value[5], value[6], value[7], value[8], value[9],
					value[10], value[11], value[12]);
				argv[3] = parm;
				argv[4] = NULL;
				TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
				status|=do_cmd(IWPRIV, argv, 1);
				
				// wepdkeyid
				//mib_get(MIB_WLAN_WEP_DEFAULT_KEY, (void *)value);
				value[0] = EntryWEP.wepDefaultKey;
				sprintf(parm, "wepdkeyid=%u", value[0]);
				argv[3] = parm;
				argv[4] = NULL;
				TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
				status|=do_cmd(IWPRIV, argv, 1);
			}
		}
		// Kaohj --- this is for driver level security.
		// ignoring it if using userland 'auth' security	
		
		sprintf(parm, "encmode=%u", vInt);
		argv[3] = parm;
		argv[4] = NULL;
		TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
		status|=do_cmd(IWPRIV, argv, 1);	
	}
	argv[1] = (char*)WLANIF;	
#endif


	// Modified by Mason Yu
	// Set 802.1x flag
	mib_get(MIB_WLAN_ENCRYPT, (void *)value);
	vInt = (int)value[0];
	
	if (vInt < 2)
	//else if (vInt == 2)	// WPA mode
	{
		// 802_1x
		mib_get(MIB_WLAN_ENABLE_1X, (void *)value);
		sprintf(parm, "802_1x=%u", value[0]);
		argv[3] = parm;
		argv[4] = NULL;
		TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
		status|=do_cmd(IWPRIV, argv, 1);
		//vInt = 0;
	}
	else{
		vInt = 1;
		sprintf(parm, "802_1x=%u", vInt);
		argv[3] = parm;
		argv[4] = NULL;
		TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
		status|=do_cmd(IWPRIV, argv, 1);
	}


#ifdef WLAN_MBSSID
	// Set 802.1x flag
	for (j=1; j<=4; j++) {
		if (!mib_chain_get(MIB_MBSSIB_TBL, j, (void *)&Entry)) {  		
  			printf("Error! Get MIB_MBSSIB_TBL(802.1x) error.\n");					
		}
		
		if ( j != 0 ) {
			sprintf(para2, "wlan0-vap%d", j-1);			
			argv[1] = para2;				
		}
			
		//mib_get(MIB_WLAN_ENCRYPT, (void *)value);
		//vInt = (int)value[0];
		vInt = (int)Entry.encrypt;
		
		if (vInt < 2)
		//else if (vInt == 2)	// WPA mode
		{
			// 802_1x
			//mib_get(MIB_WLAN_ENABLE_1X, (void *)value);
			value[0] = Entry.enable1X;
			sprintf(parm, "802_1x=%u", value[0]);
			argv[3] = parm;
			argv[4] = NULL;
			TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
			status|=do_cmd(IWPRIV, argv, 1);
			//vInt = 0;
		}
		else{
			vInt = 1;
			sprintf(parm, "802_1x=%u", vInt);
			argv[3] = parm;
			argv[4] = NULL;
			TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
			status|=do_cmd(IWPRIV, argv, 1);
		}
	}
	argv[1] = (char*)WLANIF;
#endif


#endif
	
#ifdef WLAN_IAPP
	// iapp_enable
	mib_get(MIB_WLAN_IAPP_DISABLED, (void *)value);
	vInt = (int)(value[0] ^ 0x01);
	sprintf(parm, "iapp_enable=%u", vInt);
	argv[3] = parm;
	argv[4] = NULL;
	TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
	status|=do_cmd(IWPRIV, argv, 1);
#endif
	
#ifdef WLAN_8185AG
	// band
	mib_get(MIB_WLAN_BAND, (void *)value);
#ifdef WIFI_TEST
	if (value[0] == 4) // WiFi-G
		value[0] = 3; // 2.4 GHz (B+G)
	else if (value[0] == 5) // WiFi-BG
		value[0] = 3; // 2.4 GHz (B+G)
#endif
	//jim do wifi test tricky, 
	//    1 for wifi logo test, 
	//    0 for normal case...
	unsigned char vChar;
	mib_get(MIB_WIFI_SUPPORT, (void*)&vChar);
	if(vChar==1){
		if(value[0] == 2)
			value[0] = 3;
	}
	sprintf(parm, "band=%u", value[0]);
	argv[3] = parm;
	argv[4] = NULL;
	TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
	status|=do_cmd(IWPRIV, argv, 1);
	
	if (autoRate == 0)
	{
		// fixrate
		mib_get(MIB_WLAN_FIX_RATE, (void *)value);
		vInt = (int)(*(unsigned short *)value);
		sprintf(parm, "fixrate=%u", vInt);
		argv[3] = parm;
		argv[4] = NULL;
		TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
		status|=do_cmd(IWPRIV, argv, 1);
	}
#endif

#ifdef WLAN_WDS
	setupWDS();
#endif

//12/23/04' hrchen, these MIBs are for CLIENT mode, disable them
#if 0	
	//12/16/04' hrchen, disable nat25_disable
	// nat25_disable
	value[0] = 0;
	sprintf(parm, "nat25_disable=%u", value[0]);
	argv[3] = parm;
	argv[4] = NULL;
	TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
	status|=do_cmd(IWPRIV, argv, 1);
		
	//12/16/04' hrchen, disable macclone_enable
	// macclone_enable
	value[0] = 0;
	sprintf(parm, "macclone_enable=%u", value[0]);
	argv[3] = parm;
	argv[4] = NULL;
	TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
	status|=do_cmd(IWPRIV, argv, 1);
#endif

#if 0	
	//12/16/04' hrchen, debug flag
	// debug_err
	sprintf(parm, "debug_err=ffffffff");
	argv[3] = parm;
	argv[4] = NULL;
	TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
	status|=do_cmd(IWPRIV, argv, 1);
	// debug_info
	sprintf(parm, "debug_info=0");
	argv[3] = parm;
	argv[4] = NULL;
	TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
	status|=do_cmd(IWPRIV, argv, 1);
	// debug_warn
	sprintf(parm, "debug_warn=0");
	argv[3] = parm;
	argv[4] = NULL;
	TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
	status|=do_cmd(IWPRIV, argv, 1);
	// debug_trace
	sprintf(parm, "debug_trace=0");
	argv[3] = parm;
	argv[4] = NULL;
	TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
	status|=do_cmd(IWPRIV, argv, 1);
#endif
		
	//12/16/04' hrchen, for protection mode
	// cts2self
	sprintf(parm, "cts2self=1");
	argv[3] = parm;
	argv[4] = NULL;
	TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
	status|=do_cmd(IWPRIV, argv, 1);
		
	//12/16/04' hrchen, set 11g protection mode
	// disable_protection
	value[0] = 0;
	sprintf(parm, "disable_protection=%u", value[0]);
	argv[3] = parm;
	argv[4] = NULL;
	TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
	status|=do_cmd(IWPRIV, argv, 1);
		
	//12/16/04' hrchen, chipVersion
	// chipVersion
	/*
	sprintf(parm, "chipVersion=0");
	argv[3] = parm;
	argv[4] = NULL;
	TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
	status|=do_cmd(IWPRIV, argv, 1);
	*/
		
#if 0	// not necessary for AP
	//12/16/04' hrchen, defssid
	// defssid
	sprintf(parm, "defssid=\"defaultSSID\"");
	argv[3] = parm;
	argv[4] = NULL;
	TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
	status|=do_cmd(IWPRIV, argv, 1);
#endif
		
	//12/16/04' hrchen, set block relay
	// block_relay
	mib_get(MIB_WLAN_BLOCK_RELAY, (void *)value);
	sprintf(parm, "block_relay=%u", value[0]);
	argv[3] = parm;
	argv[4] = NULL;
	TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
	status|=do_cmd(IWPRIV, argv, 1);
	// Kaohj --- set the wireless block mode on bridging
	// defined at linux-2.4.x/net/bridge/br_private.h
	//#define	WLAN_BLOCK_DISABLE	0
	//#define	WLAN_BLOCK_ALL		1
	//#define	WLAN_BLOCK_ELAN		2
	//#define	WLAN_BLOCK_WAN		3
	mib_get(MIB_WLAN_BLOCK_ETH2WIR, (void *)value);
	va_cmd(BRCTL, 3, 1, "wlanblock", (char *)BRIF, value[0]==0?"0":"2");
#ifdef WIFI_TEST
	mib_get(MIB_WLAN_BAND, (void *)value);
	if (value[0] == 4 || value[0] == 5) {// WiFi-G or WiFi-BG
		// block_relay=0
		sprintf(parm, "block_relay=0");
		argv[3] = parm;
		argv[4] = NULL;
		TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
		status|=do_cmd(IWPRIV, argv, 1);
		// wifi_specific=1
		sprintf(parm, "wifi_specific=1");
		argv[3] = parm;
		argv[4] = NULL;
		TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
		status|=do_cmd(IWPRIV, argv, 1);
	}
#endif
	//jim do wifi test tricky, 
	//    1 for wifi logo test, 
	//    0 for normal case...
	mib_get(MIB_WIFI_SUPPORT, (void*)value);
	if(value[0]==1){
		mib_get(MIB_WLAN_BAND, (void *)value);
		if (value[0] == 2 || value[0] == 3) {// WiFi-G or WiFi-BG
			// block_relay=0
			sprintf(parm, "block_relay=0");
			argv[3] = parm;
			argv[4] = NULL;
			TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
			status|=do_cmd(IWPRIV, argv, 1);
			// wifi_specific=1
			sprintf(parm, "wifi_specific=1");
			argv[3] = parm;
			argv[4] = NULL;
			TRACE(STA_SCRIPT, "%s %s %s %s\n", IWPRIV, argv[1], argv[2], argv[3]);
			status|=do_cmd(IWPRIV, argv, 1);
		}
	}

#ifdef WLAN_QoS
	mib_get(MIB_WLAN_QoS, (void *)value);
	if(value[0]==0)
		va_cmd(IWPRIV, 3, 1, (char *)WLANIF, "set_mib", "qos_enable=0");
	else if(value[0]==1)
		va_cmd(IWPRIV, 3, 1, (char *)WLANIF, "set_mib", "qos_enable=1");		
#endif	
    return status;
}
#if 0
void restartWlan()
{
	char vChar;
	ENCRYPT_T encrypt;
	unsigned char no_wlan;
	unsigned char enable1x=0;
#ifdef WLAN_MBSSID
	int i;
	MIB_CE_MBSSIB_T Entry;
	char para[20];
#endif
	
// Mason Yu Test
#ifndef WLAN_MBSSID	
	mib_get( MIB_WLAN_ENCRYPT,  (void *)&vChar);
	encrypt = (ENCRYPT_T)vChar;
	mib_get(MIB_WLAN_DISABLED, (void *)&no_wlan);
#ifdef WLAN_1x
	mib_get( MIB_WLAN_ENABLE_1X, (void *)&enable1x);
#endif
	if (encrypt<=ENCRYPT_WEP && !enable1x && !no_wlan) {
		itfcfg((char *)WLANIF, 0);
		setupWLan();
		itfcfg((char *)WLANIF, 1);
	}
#else

//xl_yue:down wlan interface(root/vap)
for(i=0;i<5;i++){
	if(i == 0)
		strcpy(para, "wlan0");
	else
		sprintf(para, "wlan0-vap%d", i-1);
	itfcfg(para, 0);
}

for ( i=0; i<=4; i++) {
	if (!mib_chain_get(MIB_MBSSIB_TBL, i, (void *)&Entry)) {  		
  		printf("Error! Get MIB_MBSSIB_TBL(startWLan) error.\n");					
	}
	
	//mib_get( MIB_WLAN_ENCRYPT,  (void *)&vChar);
	//encrypt = (ENCRYPT_T)VCHAR;
	encrypt = (ENCRYPT_T)Entry.encrypt;
	
	//mib_get(MIB_WLAN_DISABLED, (void *)&no_wlan);
	if ( i == 0 ) {
		mib_get(MIB_WLAN_DISABLED, (void *)&no_wlan);
//		strcpy(para, "wlan0");
	} else {
		no_wlan = Entry.wlanDisabled;		
//		sprintf(para, "wlan0-vap%d", i-1);
	}
	
#ifdef WLAN_1x
	//mib_get( MIB_WLAN_ENABLE_1X, (void *)&enable1x);
	enable1x = Entry.enable1X;
#endif

	if (encrypt<=ENCRYPT_WEP && !enable1x && !no_wlan) {
		//itfcfg(para, 0);
		setupWLan();
		goto up_wlan_itf;
		//itfcfg(para, 1);
	}
}

up_wlan_itf:
//xl_yue:up wlan interface
for(i=0;i<5;i++){
	if(i == 0)
		strcpy(para, "wlan0");
	else
		sprintf(para, "wlan0-vap%d", i-1);
	itfcfg(para, 1);
}
#endif
}
#endif

// Added by Mason Yu
int stopwlan()
{		
	int status = 0;
	int wirelessauthpid=0,iwcontrolpid=0, wscdpid=0, upnppid=0;	
	int AuthPid[MAX_WLAN_VAP+1]= { 0, 0, 0, 0, 0};
	int i, flags;
	unsigned char no_wlan;
#ifdef	WLAN_MBSSID
	MIB_CE_MBSSIB_T Entry;
#endif	
	
	// Kill iwcontrol
	iwcontrolpid = read_pid((char*)IWCONTROLPID);
	if(iwcontrolpid > 0){
		kill(iwcontrolpid, 9);
		unlink(IWCONTROLPID);			
	}
	
	// Kill Auth
	for ( i=0; i<=MAX_WLAN_VAP; i++) {
		AuthPid[i] = read_pid((char*)WLANAUTHPID[i]);
		if(AuthPid[i] > 0) {
			kill(AuthPid[i], 9);
			unlink(WLANAUTHCONF[i]);
			unlink(WLANAUTHPID[i]);
			unlink(WLANAUTHFIFO[i]);
		}				
	}

	for ( i=0; i<=MAX_WLAN_VAP; i++) {		
		if (getInFlags( WLANAPIF[i], &flags) == 1){		
			if (flags & IFF_UP){
				status |= va_cmd(IFCONFIG, 2, 1, WLANAPIF[i], "down");
				status|=va_cmd(BRCTL, 3, 1, "delif", (char *)BRIF, WLANAPIF[i]);
			}			
		}
	}

#ifdef CONFIG_WIFI_SIMPLE_CONFIG // WPS	
	// Kill wscd-wlan0.pid
	wscdpid = read_pid((char*)WSCDPID);
	if(wscdpid > 0){
		kill(wscdpid, 9);
		unlink(WSCDPID);			
	}
	upnppid = read_pid((char*)MINI_UPNPDPID);	//cathy
//printf( "\n=======>stopwlan= upnppid=%d\n", upnppid );
	if(upnppid > 0){
		kill(upnppid, 9);
		unlink(MINI_UPNPDPID);
		upnppid = read_pid((char*)MINIUPNPDPID);
		if(upnppid > 0){
			va_cmd("/bin/mini_upnpd", 3, 1, "-igd", "/tmp/igd_config", "&");
		}
	}
#endif

}

int config_WLAN( int action_type )
{	
	switch( action_type )
	{
	case ACT_START:
		startWLan();
		break;
		
	case ACT_RESTART:
		stopwlan();
		startWLan();
		break;
		
	case ACT_STOP:
		stopwlan();		
		break;
		
	default:
		return -1;
	}
	return 0;
}

#endif

#ifdef WLAN_SUPPORT
// Wlan configuration
#ifdef WLAN_1x
static void WRITE_WPA_FILE(int fh, unsigned char *buf)
{
	if ( write(fh, buf, strlen(buf)) != strlen(buf) ) {
		printf("Write WPA config file error!\n");
		close(fh);
		//exit(1);
	}
}

// return value:
// 0  : success
// -1 : failed
#ifdef WLAN_MBSSID
static int generateWpaConf(char *outputFile, int isWds, MIB_CE_MBSSIB_T *Entry)
#else
static int generateWpaConf(char *outputFile, int isWds)
#endif
{
	int fh, intVal;
	unsigned char chVal, wep, encrypt, enable1x;
	unsigned char buf1[1024], buf2[1024];
	unsigned short sintVal;

	fh = open(outputFile, O_RDWR|O_CREAT|O_TRUNC);
	if (fh == -1) {
		printf("Create WPA config file error!\n");
		return -1;
	}
	if (!isWds) {

#ifdef  WLAN_MBSSID
	if (Entry->idx != 0) 
		encrypt = Entry->encrypt;
	else
#endif
	{
		mib_get( MIB_WLAN_ENCRYPT, (void *)&encrypt);
	}

	sprintf(buf2, "encryption = %d\n", encrypt);
	WRITE_WPA_FILE(fh, buf2);	

#ifdef  WLAN_MBSSID
	if (Entry->idx != 0) 
		strcpy(buf1, Entry->ssid);
	else
#endif
	{
		mib_get( MIB_WLAN_SSID,  (void *)buf1);
	}

	sprintf(buf2, "ssid = \"%s\"\n", buf1);
	WRITE_WPA_FILE(fh, buf2);

#ifdef  WLAN_MBSSID
	if (Entry->idx != 0) 
		enable1x = Entry->enable1X;
	else
#endif
	{
		mib_get( MIB_WLAN_ENABLE_1X, (void *)&enable1x);
	}

       	sprintf(buf2, "enable1x = %d\n", enable1x);
	WRITE_WPA_FILE(fh, buf2);

	//mib_get( MIB_WLAN_ENABLE_MAC_AUTH, (void *)&intVal);
	sprintf(buf2, "enableMacAuth = %d\n", 0);
	WRITE_WPA_FILE(fh, buf2);

/*
	mib_get( MIB_WLAN_ENABLE_SUPP_NONWPA, (void *)&intVal);
	if (intVal)
		mib_get( MIB_WLAN_SUPP_NONWPA, (void *)&intVal);
*/

	sprintf(buf2, "supportNonWpaClient = %d\n", 0);
	WRITE_WPA_FILE(fh, buf2);

#ifdef  WLAN_MBSSID
	if (Entry->idx != 0) 
		wep = Entry->wep;
	else
#endif
	{
		mib_get( MIB_WLAN_WEP, (void *)&wep);
	}

	sprintf(buf2, "wepKey = %d\n", wep);
	WRITE_WPA_FILE(fh, buf2);

/*
	if ( encrypt==1 && enable1x ) {
		if (wep == 1) {
			mib_get( MIB_WLAN_WEP64_KEY1, (void *)buf1);
			sprintf(buf2, "wepGroupKey = \"%02x%02x%02x%02x%02x\"\n", buf1[0],buf1[1],buf1[2],buf1[3],buf1[4]);
		}
		else {
			mib_get( MIB_WLAN_WEP128_KEY1, (void *)buf1);
			sprintf(buf2, "wepGroupKey = \"%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x\"\n",
				buf1[0],buf1[1],buf1[2],buf1[3],buf1[4],
				buf1[5],buf1[6],buf1[7],buf1[8],buf1[9],
				buf1[10],buf1[11],buf1[12]);
		}
	}
	else
*/
	strcpy(buf2, "wepGroupKey = \"\"\n");
	WRITE_WPA_FILE(fh, buf2);

	
#ifdef  WLAN_MBSSID
	if (Entry->idx != 0) 
		chVal = Entry->wpaAuth;
	else
#endif
	mib_get( MIB_WLAN_WPA_AUTH, (void *)&chVal);

	// Kaohj, PSK only
	sprintf(buf2, "authentication = %d\n", chVal); //1: radius 2:PSK
	WRITE_WPA_FILE(fh, buf2);

//added by xl_yue
#ifdef ENABLE_WPAAES_WPA2TKIP
#ifdef  WLAN_MBSSID
	if (Entry->idx != 0) 
		chVal = Entry->unicastCipher;
	else
#endif
#endif
	mib_get( MIB_WLAN_WPA_CIPHER_SUITE, (void *)&chVal);

	sprintf(buf2, "unicastCipher = %d\n", chVal);
	WRITE_WPA_FILE(fh, buf2);

//added by xl_yue
#ifdef ENABLE_WPAAES_WPA2TKIP
#ifdef  WLAN_MBSSID
	if (Entry->idx != 0) 
		chVal = Entry->wpa2UnicastCipher;
	else
#endif
#endif
	mib_get( MIB_WLAN_WPA2_CIPHER_SUITE, (void *)&chVal);

	sprintf(buf2, "wpa2UnicastCipher = %d\n", chVal);
	WRITE_WPA_FILE(fh, buf2);

/*
	mib_get( MIB_WLAN_WPA2_PRE_AUTH, (void *)&intVal);
	sprintf(buf2, "enablePreAuth = %d\n", intVal);
	WRITE_WPA_FILE(fh, buf2);
*/

#ifdef  WLAN_MBSSID
	if (Entry->idx != 0) 
		chVal = Entry->wpaPSKFormat;
	else
#endif
	mib_get( MIB_WLAN_WPA_PSK_FORMAT, (void *)&chVal);

	if (chVal==0)
		sprintf(buf2, "usePassphrase = 1\n");
	else
		sprintf(buf2, "usePassphrase = 0\n");
	WRITE_WPA_FILE(fh, buf2);


#ifdef  WLAN_MBSSID
	if (Entry->idx != 0) 
		strcpy(buf1, Entry->wpaPSK);
	else
#endif
	mib_get( MIB_WLAN_WPA_PSK, (void *)buf1);

	sprintf(buf2, "psk = \"%s\"\n", buf1);
	WRITE_WPA_FILE(fh, buf2);

	mib_get( MIB_WLAN_WPA_GROUP_REKEY_TIME, (void *)&intVal);
	sprintf(buf2, "groupRekeyTime = %d\n", intVal);
	WRITE_WPA_FILE(fh, buf2);

#if 1 // not support RADIUS

#ifdef  WLAN_MBSSID
	if (Entry->idx != 0) 
		sintVal = Entry->rsPort;
	else
#endif
	mib_get( MIB_WLAN_RS_PORT, (void *)&sintVal);

	sprintf(buf2, "rsPort = %d\n", sintVal);
	WRITE_WPA_FILE(fh, buf2);

#ifdef  WLAN_MBSSID
	if (Entry->idx != 0) 
		*((unsigned long *)buf1) = *((unsigned long *)Entry->rsIpAddr);
	else
#endif
	mib_get( MIB_WLAN_RS_IP, (void *)buf1);

	sprintf(buf2, "rsIP = %s\n", inet_ntoa(*((struct in_addr *)buf1)));
	WRITE_WPA_FILE(fh, buf2);

#ifdef  WLAN_MBSSID
	if (Entry->idx != 0) 
		strcpy(buf1, Entry->rsPassword);
	else
#endif
	mib_get( MIB_WLAN_RS_PASSWORD, (void *)buf1);

	sprintf(buf2, "rsPassword = \"%s\"\n", buf1);
	WRITE_WPA_FILE(fh, buf2);

	mib_get( MIB_WLAN_RS_RETRY, (void *)&chVal);
	sprintf(buf2, "rsMaxReq = %d\n", chVal);
	WRITE_WPA_FILE(fh, buf2);

	mib_get( MIB_WLAN_RS_INTERVAL_TIME, (void *)&sintVal);
	sprintf(buf2, "rsAWhile = %d\n", sintVal);
	WRITE_WPA_FILE(fh, buf2);

	mib_get( MIB_WLAN_ACCOUNT_RS_ENABLED, (void *)&chVal);
	sprintf(buf2, "accountRsEnabled = %d\n", chVal);
	WRITE_WPA_FILE(fh, buf2);

	mib_get( MIB_WLAN_ACCOUNT_RS_PORT, (void *)&sintVal);
	sprintf(buf2, "accountRsPort = %d\n", sintVal);
	WRITE_WPA_FILE(fh, buf2);

	mib_get( MIB_WLAN_ACCOUNT_RS_IP, (void *)buf1);
	sprintf(buf2, "accountRsIP = %s\n", inet_ntoa(*((struct in_addr *)buf1)));
	WRITE_WPA_FILE(fh, buf2);

	mib_get( MIB_WLAN_ACCOUNT_RS_PASSWORD, (void *)buf1);
	sprintf(buf2, "accountRsPassword = \"%s\"\n", buf1);
	WRITE_WPA_FILE(fh, buf2);

	mib_get( MIB_WLAN_ACCOUNT_UPDATE_ENABLED, (void *)&chVal);
	sprintf(buf2, "accountRsUpdateEnabled = %d\n", chVal);
	WRITE_WPA_FILE(fh, buf2);

	mib_get( MIB_WLAN_ACCOUNT_UPDATE_DELAY, (void *)&sintVal);
	sprintf(buf2, "accountRsUpdateTime = %d\n", sintVal);
	WRITE_WPA_FILE(fh, buf2);

	mib_get( MIB_WLAN_ACCOUNT_RS_RETRY, (void *)&chVal);
	sprintf(buf2, "accountRsMaxReq = %d\n", chVal);
	WRITE_WPA_FILE(fh, buf2);

	mib_get( MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME, (void *)&sintVal);
	sprintf(buf2, "accountRsAWhile = %d\n", sintVal);
	WRITE_WPA_FILE(fh, buf2);
#endif
	}

	else {
#if 0 // not support WDS
		apmib_get( MIB_WLAN_WDS_ENCRYPT, (void *)&encrypt);
		if (encrypt == WDS_ENCRYPT_TKIP)		
			encrypt = ENCRYPT_WPA;
		else if (encrypt == WDS_ENCRYPT_AES)		
			encrypt = ENCRYPT_WPA2;		
		else
			encrypt = 0;
	
		sprintf(buf2, "encryption = %d\n", encrypt);
		WRITE_WPA_FILE(fh, buf2);
		WRITE_WPA_FILE(fh, "ssid = \"REALTEK\"\n");
		WRITE_WPA_FILE(fh, "enable1x = 1\n");
		WRITE_WPA_FILE(fh, "enableMacAuth = 0\n");
		WRITE_WPA_FILE(fh, "supportNonWpaClient = 0\n");
		WRITE_WPA_FILE(fh, "wepKey = 0\n");
		WRITE_WPA_FILE(fh,  "wepGroupKey = \"\"\n");
		WRITE_WPA_FILE(fh,  "authentication = 2\n");

		if (encrypt == ENCRYPT_WPA)
			intVal = WPA_CIPHER_TKIP;
		else
			intVal = WPA_CIPHER_AES;
			
		sprintf(buf2, "unicastCipher = %d\n", intVal);
		WRITE_WPA_FILE(fh, buf2);

		sprintf(buf2, "wpa2UnicastCipher = %d\n", intVal);
		WRITE_WPA_FILE(fh, buf2);

		WRITE_WPA_FILE(fh, "enablePreAuth = 0\n");

		apmib_get( MIB_WLAN_WDS_PSK_FORMAT, (void *)&intVal);
		if (intVal==0)
			sprintf(buf2, "usePassphrase = 1\n");
		else
			sprintf(buf2, "usePassphrase = 0\n");
		WRITE_WPA_FILE(fh, buf2);

		apmib_get( MIB_WLAN_WDS_PSK, (void *)buf1);
		sprintf(buf2, "psk = \"%s\"\n", buf1);
		WRITE_WPA_FILE(fh, buf2);

		WRITE_WPA_FILE(fh, "groupRekeyTime = 0\n");
		WRITE_WPA_FILE(fh, "rsPort = 1812\n");
		WRITE_WPA_FILE(fh, "rsIP = 192.168.1.1\n");
		WRITE_WPA_FILE(fh, "rsPassword = \"\"\n");
		WRITE_WPA_FILE(fh, "rsMaxReq = 3\n");
		WRITE_WPA_FILE(fh, "rsAWhile = 10\n");
		WRITE_WPA_FILE(fh, "accountRsEnabled = 0\n");
		WRITE_WPA_FILE(fh, "accountRsPort = 1813\n");
		WRITE_WPA_FILE(fh, "accountRsIP = 192.168.1.1\n");
		WRITE_WPA_FILE(fh, "accountRsPassword = \"\"\n");
		WRITE_WPA_FILE(fh, "accountRsUpdateEnabled = 0\n");
		WRITE_WPA_FILE(fh, "accountRsUpdateTime = 1000\n");
		WRITE_WPA_FILE(fh, "accountRsMaxReq = 3\n");
		WRITE_WPA_FILE(fh, "accountRsAWhile = 1\n");
#endif
	}

	close(fh);
	
	return 0;
}

static int is8021xEnabled() {
#ifdef WLAN_1x
	
	unsigned char enable_1x = 0;

	
	
	mib_get( MIB_WLAN_ENABLE_1X, (void *)&enable_1x);

	if (enable_1x) {
		return 1;
	} else {
		unsigned char wpaAuth = 0;
		unsigned char encrypt = 0;
		mib_get( MIB_WLAN_ENCRYPT, (void *)&encrypt);
		//fprintf(stderr, "encrypt=%d\n", encrypt);
		if (encrypt & ENCRYPT_WPA2_MIXED) {
			
			mib_get( MIB_WLAN_WPA_AUTH, (void *)&wpaAuth);
			///fprintf(stderr, "wpaAuth=%d\n", wpaAuth);
			if (WPA_AUTH_AUTO == wpaAuth)
				return 1;

		}
	}

	
#endif
	return 0;
}

#ifdef CONFIG_WIFI_SIMPLE_CONFIG // WPS
int start_WPS()
{
	int status=0;	
	unsigned char encrypt;	
	unsigned char enable1x=0;
	
	int enableWsc = 1, retry;
	unsigned char wsc_disable;
	unsigned char wsc_upnp_enabled;
	unsigned char wlan_mode;
	unsigned char wlan_nettype;
	unsigned char wpa_auth;
	char *cmd_opt[16];
	int cmd_cnt = 0; int idx;
	int wscd_pid_fd = -1;
	
	mib_get(MIB_WSC_DISABLE, (void *)&wsc_disable);
	mib_get(MIB_WLAN_MODE, (void *)&wlan_mode);
	mib_get(MIB_WLAN_NETWORK_TYPE, (void *)&wlan_nettype);
	mib_get(MIB_WLAN_WPA_AUTH, (void *)&wpa_auth);
	mib_get(MIB_WSC_UPNP_ENABLED, (void *)&wsc_upnp_enabled);	

	fprintf(stderr, "START WPS SETUP!\n\n\n");
	cmd_opt[cmd_cnt++] = "";

	if (wsc_disable || is8021xEnabled())
		goto WSC_DISABLE;	
	
	if (wsc_disable || (wlan_mode == AP_WDS_MODE))
		enableWsc = 0;
	else if (wlan_mode == CLIENT_MODE) {
		if (wlan_nettype != INFRASTRUCTURE)
			enableWsc = 0;
	} else if (wlan_mode == AP_MODE) {
		if ((encrypt < ENCRYPT_WPA) && (enable1x != 0))
			enableWsc = 0;
		if ((encrypt >= ENCRYPT_WPA) && (wpa_auth == WPA_AUTH_AUTO))
			enableWsc = 0;		
	}	

	if (enableWsc) {
		useAuth_wlan0 = 1;		
	}

	if (wlan_mode == CLIENT_MODE) {
		cmd_opt[cmd_cnt++] = "-mode";
		cmd_opt[cmd_cnt++] = "2";
	} else {
		cmd_opt[cmd_cnt++] = "-start";
	}
		
	cmd_opt[cmd_cnt++] = "-c";
	cmd_opt[cmd_cnt++] = "/var/wscd.conf";
	cmd_opt[cmd_cnt++] = "-w";
	cmd_opt[cmd_cnt++] = "wlan0";
	//strcat(cmd, " -c /var/wscd.conf -w wlan0");
		
	if (1) { // use iwcontrol
		cmd_opt[cmd_cnt++] = "-fi";
		cmd_opt[cmd_cnt++] = "/var/wscd-wlan0.fifo";
		//strcat(cmd, " -fi /var/wscd-wlan0.fifo");
	}

	//cmd_opt[cmd_cnt++] = "-debug";
	//strcat(cmd, " -debug");
	//strcat(cmd, " &");
	#define TARGDIR "/var/wps/"
	#define SIMPLECFG "simplecfgservice.xml"
	//status |= va_cmd("/bin/flash", 3, 1, "upd-wsc-conf", "/etc/wscd.conf", "/var/wscd.conf");
	status |= va_cmd("/bin/mkdir", 2, 1, "-p", TARGDIR);
	status |= va_cmd("/bin/cp", 2, 1, "/etc/" SIMPLECFG, TARGDIR);

	cmd_opt[cmd_cnt] = 0;
	printf("CMD ARGS: ");
	for (idx=0; idx<cmd_cnt;idx++) 
		printf("%s ", cmd_opt[idx]);
	printf("\n");
	
	status |= do_cmd("/bin/wscd", cmd_opt, 0);

	retry = 0;
	while ((wscd_pid_fd = open("/var/run/wscd-wlan0.pid", O_WRONLY)) == -1)
	{
		usleep(30000);
		retry ++;

		if (retry > 10) {
			printf("wscd invoke timeout, abort\n");
			break;
		}
	}
	if(wscd_pid_fd!=-1) close(wscd_pid_fd);/*jiunming, close the opened fd*/
WSC_DISABLE:

	return status;
}
#endif	


int start_Auth()
{
	unsigned char encrypt, no_wlan;
	int auth_pid_fd=-1;
	unsigned char enable1x=0;
	int status=0;	
	
#ifdef  WLAN_MBSSID	
	int i=0;
	char para2[15];
	MIB_CE_MBSSIB_T Entry;
	
	char para_auth_conf[30];
	char para_itf_name[15];
	char para_auth_pid[30];	
#endif
#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
	unsigned char value[30];
	unsigned char stringbuf[MAX_PSK_LEN+1];
#endif
	
//#ifndef WLAN_MBSSID
	//added by xl_yue: create random wpa key for rootAP
#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
		if (mib_get(MIB_ELAN_MAC_ADDR, (void *)value) != 0)
		{
			value[0] = value[0]^value[4]^value[5];
			value[1] = value[1]^value[4]^value[5];
			value[2] = value[2]^value[4]^value[5];
			value[3] = value[3]^value[4]^value[5];
			mib_get(MIB_WLAN_WPA_PSK, (void *)stringbuf);
			if(strlen(stringbuf) < 8){
				snprintf((char *)(stringbuf), 9, "%02x%02x%02x%02x",value[0], value[1], value[2], value[3]);
				mib_set(MIB_WLAN_WPA_PSK, (void *)stringbuf);	
			}
		}
#endif
	
	mib_get(MIB_WLAN_DISABLED, (void *)&no_wlan);
	if (no_wlan == 0)	// WLAN enabled
	{
		// brctl addif br0 wlan0
		status|=va_cmd(BRCTL, 3, 1, "addif", (char *)BRIF, (char *)WLANIF);
		// ifconfig wlan0 up
		status|=va_cmd(IFCONFIG, 2, 1, (char *)WLANIF, "up");
#ifdef WLAN_1x		
		mib_get(MIB_WLAN_ENCRYPT, (void *)&encrypt);
		mib_get(MIB_WLAN_DISABLED, (void *)&no_wlan);

		mib_get( MIB_WLAN_ENABLE_1X, (void *)&enable1x);

		if ((encrypt >= 2 || enable1x==1) && no_wlan == 0) {// 802.1x enabled
			#ifndef WLAN_MBSSID
			status|=generateWpaConf((char *)WLAN_AUTH_CONF, 0);
			#else
			Entry.idx = 0;
			status|=generateWpaConf((char *)WLAN_AUTH_CONF, 0, &Entry);
			#endif
			status|=va_cmd(AUTH, 4, 0, (char *)WLANIF, (char *)LANIF, "auth", (char *)WLAN_AUTH_CONF);
			// fix the depency problem
			// wait for auth-xxx.pid to be created, the iwcontrol will check for it
			while ((auth_pid_fd = open(AUTH_PID, O_WRONLY)) == -1)
			{
				usleep(30000);
			}
			if(auth_pid_fd!=-1) close(auth_pid_fd);/*jiunming, close the opened fd*/
			useAuth_wlan0 = 1;		
		}
		
		//if (useAuth_wlan0) {
		//	status|=va_cmd(IWCONTROL, 1, 1, (char *)WLANIF);
		//}		
#endif
        	status = (status==-1)?-1:1;
	}
	else
		return 0;
	
	
//#else	//MBSSID
#ifdef WLAN_MBSSID
	// Modified by Mason Yu
	for ( i=1; i<=4; i++) {
		if (!mib_chain_get(MIB_MBSSIB_TBL, i, (void *)&Entry)) {  		
	  		printf("Error! Get MIB_MBSSIB_TBL(startWLan) error.\n");					
		}
	
	//added by xl_yue: create random wpa key
#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
		if (mib_get(MIB_ELAN_MAC_ADDR, (void *)value) != 0)
		{
			value[0] = value[0]^value[4]^value[5];
			value[1] = value[1]^value[4]^value[5];
			value[2] = value[2]^value[4]^value[5];
			value[3] = value[3]^value[4]^value[5]^i;
			if(strlen(Entry.wpaPSK) < 8){
				snprintf((char *)(stringbuf), 9, "%02x%02x%02x%02x",value[0], value[1], value[2], value[3]);
				memcpy(Entry.wpaPSK,stringbuf,9);
				printf("set MIB_MBSSIB_TBL entry%d wpaPSK = %s\n", i, Entry.wpaPSK);
			}
	
			mib_chain_update(MIB_MBSSIB_TBL, (void *)&Entry, i);
		}
#endif
			
		if ( i!=0 ) {		
			no_wlan = Entry.wlanDisabled;		
			sprintf(para2, "wlan0-vap%d", i-1);
			
		} else {	
			mib_get(MIB_WLAN_DISABLED, (void *)&no_wlan);
			strcpy(para2, "wlan0");		
		}
		
		if (no_wlan == 0)	// WLAN enabled
		{
			// brctl addif br0 wlan0
			//status|=va_cmd(BRCTL, 3, 1, "addif", (char *)BRIF, (char *)WLANIF);
			status|=va_cmd(BRCTL, 3, 1, "addif", (char *)BRIF, para2);
			
			// ifconfig wlan0 up
			//status|=va_cmd(IFCONFIG, 2, 1, (char *)WLANIF, "up");	
			sleep(2);
				
			status|=va_cmd(IFCONFIG, 2, 1, para2, "up");
#ifdef WLAN_1x
			//status|=startWLanDaemon(&Entry, ctrlFlags);			
			
			encrypt = Entry.encrypt;			
			enable1x = Entry.enable1X;
 	
			if ( Entry.idx !=0 ) {
				sprintf(para_auth_conf, "/var/config/wlan0-vap%d.conf", Entry.idx - 1); 
				sprintf(para_itf_name, "wlan0-vap%d", Entry.idx - 1);
				sprintf(para_auth_pid, "/var/run/auth-wlan0-vap%d.pid", Entry.idx - 1);
			} else {
				strcpy(para_auth_conf, "/var/config/wlan0.conf");
				strcpy(para_itf_name, "wlan0");
				strcpy(para_auth_pid, "/var/run/auth-wlan0.pid");
			}
	        	
			//if ((encrypt >= 2 || enable1x==1) && no_wlan == 0) {// 802.1x enabled
			if ((encrypt >= 2 || enable1x==1) ) {// 802.1x enabled	
				//status|=generateWpaConf((char *)WLAN_AUTH_CONF, 0);
				status|=generateWpaConf(para_auth_conf, 0, &Entry);				
				
				status|=va_cmd(AUTH, 4, 0, para_itf_name, (char *)LANIF, "auth", para_auth_conf);
				
				// fix the depency problem
				// wait for auth-xxx.pid to be created, the iwcontrol will check for it									
				while ((auth_pid_fd = open(para_auth_pid, O_WRONLY)) == -1)
				{			
					usleep(30000);
					
				}
				if(auth_pid_fd!=-1) close(auth_pid_fd);/*jiunming, close the opened fd*/						
				
				strcpy(para_iwctrl[wlan_num], para_itf_name);
				wlan_num++;	
				
			}		
#endif
	        	status = (status==-1)?-1:1;
		}		
	}	
#endif
	return status;
}

#ifdef WLAN_WEB_REDIRECT  //jiunming,web_redirect
int start_wlan_web_redirect(){

	int status=0;
	char tmpbuf[MAX_URL_LEN];
	char ipaddr[16], ip_port[32], redir_server[33];
	
	ipaddr[0]='\0'; ip_port[0]='\0';redir_server[0]='\0';
	if (mib_get(MIB_ADSL_LAN_IP, (void *)tmpbuf) != 0)
	{
		strncpy(ipaddr, inet_ntoa(*((struct in_addr *)tmpbuf)), 16);
		ipaddr[15] = '\0';
		sprintf(ip_port,"%s:%d",ipaddr,8080);
	}//else ??

	if( mib_get(MIB_WLAN_WEB_REDIR_URL, (void*)tmpbuf) )
	{
		char *p=NULL, *end=NULL;
		
		p = strstr( tmpbuf, "http://" );
		if(p)
			p = p + 7;
		else 
			p = tmpbuf;
			
		end = strstr( p, "/" );
		if(end)
			*end = '\0';
		
		snprintf( redir_server,32,"%s",p );
		redir_server[32]='\0';
	}//else ??
		
	// Enable Bridge Netfiltering					
	//status|=va_cmd("/bin/brctl", 2, 0, "brnf", "on");
	
	//iptables -t nat -N Web_Redirect
	status|=va_cmd(IPTABLES, 4, 1, "-t", "nat","-N","Web_Redirect");
	
	//iptables -t nat -A Web_Redirect -d 192.168.1.1 -j RETURN
	status|=va_cmd(IPTABLES, 8, 1, "-t", "nat","-A","Web_Redirect",
		"-d", ipaddr, "-j", (char *)FW_RETURN);
	
	//iptables -t nat -A Web_Redirect -d 192.168.2.11 -j RETURN
	status|=va_cmd(IPTABLES, 8, 1, "-t", "nat","-A","Web_Redirect",
		"-d", redir_server, "-j", (char *)FW_RETURN);	
	
	//iptables -t nat -A Web_Redirect -p tcp --dport 80 -j DNAT --to-destination 192.168.1.1:8080 
	status|=va_cmd(IPTABLES, 12, 1, "-t", "nat","-A","Web_Redirect",
		"-p", "tcp", "--dport", "80", "-j", "DNAT", 
		"--to-destination", ip_port);
	
	//iptables -t nat -A PREROUTING -p tcp --dport 80 -j Web_Redirect
	status|=va_cmd(IPTABLES, 12, 1, "-t", "nat","-A","PREROUTING",
		"-i", (char *)WLANIF,
		"-p", "tcp", "--dport", "80", "-j", "Web_Redirect");
		
	return status;	
}
#endif

int start_iwcontrol()
{
	int tmp, found = 0;
	int status = 0;
	
	// When (1) WPS enabled or (2) Root AP's encryption is WPA/WPA2 without MBSSID,
	// we should start iwcontrol with wlan0 interface.	
	if ( useAuth_wlan0 == 1 ) { 		
		for (tmp=0; tmp < wlan_num; tmp++) {
			if (strcmp(para_iwctrl[tmp], WLANIF)==0) {
				found = 1;
				break;
			}
		}

		if (!found) {
			strcpy(para_iwctrl[wlan_num], WLANIF);
			wlan_num++;
		}
	}	
	
	// Mason Yu
	// We have 5 AP(Root and vap0 ~ vap3., if we add a new vap, we must modified the following codes.
	printf("Total WPA/WPA2 number is %d\n", wlan_num);	
	if ( wlan_num == 1 ) {
		status|=va_cmd(IWCONTROL, wlan_num, 1, para_iwctrl[0]);
	} else if ( wlan_num == 2 ) {
		status|=va_cmd(IWCONTROL, wlan_num, 1, para_iwctrl[0], para_iwctrl[1]);
	} else if ( wlan_num == 3 ) {
		status|=va_cmd(IWCONTROL, wlan_num, 1, para_iwctrl[0], para_iwctrl[1], para_iwctrl[2]);
	} else if ( wlan_num == 4 ) {
		status|=va_cmd(IWCONTROL, wlan_num, 1, para_iwctrl[0], para_iwctrl[1], para_iwctrl[2], para_iwctrl[3]);
	} else if ( wlan_num == 5 ) {
		status|=va_cmd(IWCONTROL, wlan_num, 1, para_iwctrl[0], para_iwctrl[1], para_iwctrl[2], para_iwctrl[3], para_iwctrl[4]);
	} 
	
}

// return value:
// 0  : success
// -1 : failed
int startWLanDaemon()
{	
	int status=0;
		
#ifdef CONFIG_WIFI_SIMPLE_CONFIG
	status |= start_WPS();
#endif
	
	status |= start_Auth();
	
#ifdef WLAN_WEB_REDIRECT
	status |= start_wlan_web_redirect();
#endif

	return status;
}
#endif


//--------------------------------------------------------
// Wireless LAN startup
// return value:
// 0  : not start by configuration
// 1  : successful
// -1 : failed
int startWLan()
{
	unsigned char no_wlan;
	int status=0, upnppid=0;
	
	// Check wireless interface
	if (!getInFlags((char *)WLANIF, 0)) {
		printf("Wireless Interface Not Found !\n");
		return -1;	// interface not found
	}
	
	//1/17/06' hrchen, always start WLAN MIB, for MP test will use 
	// "ifconfig wlan0 up" to start WLAN
	// config WLAN
	status|=setupWLan();

	// Modified by Mason Yu
	wlan_num = 0; /*reset to 0,jiunming*/
	useAuth_wlan0 = 0;  /*reset to 0 */

	status|=startWLanDaemon();
	
	status|=start_iwcontrol();
#ifdef CONFIG_WIFI_SIMPLE_CONFIG	
	upnppid = read_pid((char*)MINI_UPNPDPID);	//cathy
//printf( "\n=======>startwlan= upnppid=%d\n", upnppid );
	if(upnppid > 0){
		kill(upnppid, 9);
		unlink(MINI_UPNPDPID);
		va_cmd("/bin/mini_upnpd", 5, 0, "-wsc", "/tmp/wscd_config", "-igd", "/tmp/igd_config", "&");
	}
	else {
		va_cmd("/bin/mini_upnpd", 3, 0, "-wsc", "/tmp/wscd_config", "&");
	}
#endif		
	return status;
}

#endif

#ifdef CONFIG_USER_IGMPPROXY
#ifdef CONFIG_IGMPPROXY_MULTIWAN
int startIgmproxy()
{
	unsigned char igmpEnable, igmpItf;
	char ifname[6];
	int igmpproxy_pid;
	MIB_CE_ATM_VC_T Entry;
	unsigned int entryNum, i;
	char igmpproxy_wan[100];
	char igmpproxy_cmd[120];
	int igmpenable =0;;


	// Kill old IGMP proxy
	igmpproxy_pid = read_pid((char *)IGMPPROXY_PID);
	if (igmpproxy_pid >= 1) {
		// kill it
		if (kill(igmpproxy_pid, SIGTERM) != 0) {
			printf("Could not kill pid '%d'", igmpproxy_pid);
		}
	}
	memset(igmpproxy_cmd,0,sizeof(igmpproxy_cmd));
	memset(igmpproxy_cmd,0,sizeof(igmpproxy_wan));
	snprintf(igmpproxy_wan,100,"/bin/igmpproxy");
	
	entryNum = mib_chain_total(MIB_ATM_VC_TBL);
		
	for (i=0; i<entryNum; i++) 
	{
		 if (!mib_chain_get(MIB_ATM_VC_TBL, i, (void *)&Entry))
		 {
  			printf("error get atm vc entry\n");
			return -1;
		 }
	       
	// check if IGMP proxy enabled ?
	    if(Entry.igmpproxyenable)
	   {
	        if(!igmpenable) 
			igmpenable =1;	
		if (Entry.ifIndex != 0xff)
		{
			if (PPP_INDEX(Entry.ifIndex) != 0x0f)
				snprintf(igmpproxy_wan, 100, "%s ppp%u  ",igmpproxy_wan, PPP_INDEX(Entry.ifIndex));	// PPP interface
			else
				snprintf(igmpproxy_wan, 100, "%s vc%u  ", igmpproxy_wan, VC_INDEX(Entry.ifIndex));
		}
		else
		{
			printf("Error: IGMP proxy interface not set !\n");
			return 0;
		}
	     }
        }
	if(igmpenable){
	
	   sprintf(igmpproxy_cmd," %s  br0 ",igmpproxy_wan);
	
	   system(igmpproxy_cmd);
	   
	}
	//va_cmd(IGMPROXY, 2, 0, ifname, (char *)LANIF);
	return 1;
}
#else
// IGMP proxy configuration
// return value:
// 1  : successful
// 0  : function not enable
// -1 : startup failed
int startIgmproxy()
{
	unsigned char igmpEnable, igmpItf;
	char ifname[6];
	int igmpproxy_pid;
	
	// Kill old IGMP proxy
	igmpproxy_pid = read_pid((char *)IGMPPROXY_PID);
	if (igmpproxy_pid >= 1) {
		// kill it
		if (kill(igmpproxy_pid, SIGTERM) != 0) {
			printf("Could not kill pid '%d'", igmpproxy_pid);
		}
	}
	
	// check if IGMP proxy enabled ?
	if (mib_get(MIB_IGMP_PROXY, (void *)&igmpEnable) != 0)
	{
		if (igmpEnable != 1)
			return 0;	// IGMP proxy not enable
	}
	if (mib_get(MIB_IGMP_PROXY_ITF, (void *)&igmpItf) != 0)
	{
		if (igmpItf != 0xff)
		{
			if (PPP_INDEX(igmpItf) != 0x0f)
				snprintf(ifname, 6, "ppp%u", PPP_INDEX(igmpItf));	// PPP interface
			else
				snprintf(ifname, 5, "vc%u", VC_INDEX(igmpItf));
		}
		else
		{
			printf("Error: IGMP proxy interface not set !\n");
			return 0;
		}
	}
	
	va_cmd(IGMPROXY, 2, 0, ifname, (char *)LANIF);
	return 1;
}
#endif
#endif // of CONFIG_USER_IGMPPROXY

void addStaticRoute()
{
	unsigned int entryNum, i;
	MIB_CE_IP_ROUTE_T Entry;
	//struct rtentry rt;
	//struct sockaddr_in *inaddr;
	//char	ifname[17];
	
	/* Clean out the RTREQ structure. */
	//memset((char *) &rt, 0, sizeof(struct rtentry));
	entryNum = mib_chain_total(MIB_IP_ROUTE_TBL);
	
	for (i=0; i<entryNum; i++) {

		if (!mib_chain_get(MIB_IP_ROUTE_TBL, i, (void *)&Entry))
		{
			return;
		}
		route_cfg_modify(&Entry, 0);
	}
}

void deleteStaticRoute()
{
	unsigned int entryNum, i;
	MIB_CE_IP_ROUTE_T Entry;
	//struct rtentry rt;
	//struct sockaddr_in *inaddr;
	//char	ifname[17];
	
	/* Clean out the RTREQ structure. */
	//memset((char *) &rt, 0, sizeof(struct rtentry));
	entryNum = mib_chain_total(MIB_IP_ROUTE_TBL);
	
	for (i=0; i<entryNum; i++) {

		if (!mib_chain_get(MIB_IP_ROUTE_TBL, i, (void *)&Entry))
		{
			return;
		}
		route_cfg_modify(&Entry, 1);
	}
}

int RegisterPVCnumber()
{
	int i, vInt, activePVC;
	MIB_CE_ATM_VC_T Entry;
	unsigned char value[32];
	
	vInt = mib_chain_total(MIB_ATM_VC_TBL);
	activePVC = 0;
	for (i = 0; i < vInt; i++)
	{
		/* get the specified chain record */
		if (!mib_chain_get(MIB_ATM_VC_TBL, i, (void *)&Entry))
			return -1;
		
		if (Entry.enable == 0)
			continue;
		
		activePVC ++;
	}
	sprintf(value,"%d",activePVC);
	if (va_cmd("/bin/sarctl",2,1,"pvcnumber",value))
		return -1;
	
}

// Added by Mason Yu
int deleteAllConnection()
{
	unsigned int entryNum, i, idx;
	MIB_CE_ATM_VC_T Entry;
	
	entryNum = mib_chain_total(MIB_ATM_VC_TBL);			
	for (i = 0; i < entryNum; i++) {				
		/* Retrieve entry */
		if (!mib_chain_get(MIB_ATM_VC_TBL, i, (void *)&Entry)) {
			printf("deleteAllConnection: cannot get ATM_VC_TBL(ch=%d) entry\n", i);
			return 0;
		}
        
		/* remove connection on driver*/		
		stopConnection(&Entry);				
	}
#if 0	
	for (i = 0; i < entryNum; i++) {		
		/* remove the mib setting */
		if(mib_chain_delete(MIB_ATM_VC_TBL, i) != 1) {
			printf("deleteAllConnection:Delete MIB_ATM_VC_TBL chain(ch=%d) record error!", i);
			return 0;					
		}
	}
#endif
}

// Added by Mason Yu
int executeAllConnection()
{
	unsigned int entryNum, i, idx;
	MIB_CE_ATM_VC_T Entry;
	
	entryNum = mib_chain_total(MIB_ATM_VC_TBL);			
	for (i = 0; i < entryNum; i++) {				
		/* Retrieve entry */
		if (!mib_chain_get(MIB_ATM_VC_TBL, i, (void *)&Entry)) {
			printf("deleteAllConnection: cannot get ATM_VC_TBL(ch=%d) entry\n", i);
			return 0;
		}
        
		/* execute connection on driver*/		
		startConnection(&Entry);				
	}
#if 0	
	for (i = 0; i < entryNum; i++) {		
		/* remove the mib setting */
		if(mib_chain_delete(MIB_ATM_VC_TBL, i) != 1) {
			printf("deleteAllConnection:Delete MIB_ATM_VC_TBL chain(ch=%d) record error!", i);
			return 0;					
		}
	}
#endif
}

void cleanAllFirewallRule()
{
	// Added by Mason Yu. Clean all Firewall rules.
	va_cmd(IPTABLES, 1, 1, "-F");
	va_cmd(IPTABLES, 3, 1, "-t", "nat", "-F");
#ifdef IP_ACL
	va_cmd(IPTABLES, 2, 1, "-X", "aclblock");
#endif
#ifdef DOMAIN_BLOCKING_SUPPORT
	va_cmd(IPTABLES, 2, 1, "-X", "domainblk");
#endif
	va_cmd(IPTABLES, 2, 1, "-X", (char *)FW_INACC);
	va_cmd(IPTABLES, 2, 1, "-X", (char *)FW_IPFILTER);
#ifdef MAC_FILTER
	va_cmd(IPTABLES, 2, 1, "-X", (char *)FW_MACFILTER);
#endif
#ifdef URL_BLOCKING_SUPPORT
	va_cmd(IPTABLES, 2, 1, "-X", "urlblock");
	va_cmd(IPTABLES, 2, 1, "-X", "urlallow");
#endif
#ifdef WEB_REDIRECT_BY_MAC
	va_cmd(IPTABLES, 2, 1, "-t", "nat", "-X", "WebRedirectByMAC");
#endif

}
#ifdef IP_FILTER_ONOFF_SUPPORT
//ret : 0, ip filter disabled, otherwise enabled.
int ipFilterEnabled()
{
	unsigned char enableorNot=0;
	mib_get(MIB_IPFILTER_ON_OFF, (void*)&enableorNot);
	return enableorNot;
}
#endif
int setupIPFilter()
{
	char *argv[20];
	unsigned char value[32], byte;
	int vInt, i, total;
	MIB_CE_IP_PORT_FILTER_T IpEntry;
	char *policy, *filterSIP, *filterDIP, srcPortRange[12], dstPortRange[12];
	char  srcip[20], dstip[20];
#ifdef IP_RANGE_FILTER_SUPPORT	
	char  srcip2[20], dstip2[20]; // jim support ip range options " iptables -m iprange --src-range xx.xx.xx.xx-yy.yy.yy.yy --dst-range a.a.a.a-b.b.b.b ..."
	char SIPRange[40]={0};
	char DIPRange[40]={0};	
	char *filterSIPRange=NULL;
	char *filterDIPRange=NULL;	
	filterSIP=filterDIP=NULL;
#endif	
	// Delete ipfilter rule
//	va_cmd(IPTABLES, 2, 1, "-F", (char *)FW_IPFILTER);
	
	// packet filtering
	// ip filtering
	total = mib_chain_total(MIB_IP_PORT_FILTER_TBL);
	// Add chain for ip filtering
	// iptables -N ipfilter
	//va_cmd(IPTABLES, 2, 1, "-N", (char *)FW_IPFILTER);
	/*va_cmd(IPTABLES, 8, 1, (char *)FW_ADD, (char *)FW_IPFILTER, "-m", "state",
		"--state", "ESTABLISHED,RELATED", "-j", (char *)FW_RETURN);
	// iptables -A ipfilter -d 224.0.0.0/4 -j RETURN
	va_cmd(IPTABLES, 6, 1, (char *)FW_ADD, (char *)FW_IPFILTER, "-d",
		"224.0.0.0/4", "-j", (char *)FW_RETURN);*/
	
	
	for (i = 0; i < total; i++)
	{
		int idx=0;
		/*
		 *	srcPortRange: src port
		 *	dstPortRange: dst port
		 */
		if (!mib_chain_get(MIB_IP_PORT_FILTER_TBL, i, (void *)&IpEntry))
			return -1;
		
		if (IpEntry.action == 0)
			policy = (char *)FW_DROP;
		else
			policy = (char *)FW_RETURN;
		
		// source port
		if (IpEntry.srcPortFrom == 0)
			srcPortRange[0]='\0';
		else if (IpEntry.srcPortFrom == IpEntry.srcPortTo)
			snprintf(srcPortRange, 12, "%u", IpEntry.srcPortFrom);
		else
			snprintf(srcPortRange, 12, "%u:%u",
				IpEntry.srcPortFrom, IpEntry.srcPortTo);
		
		// destination port
		if (IpEntry.dstPortFrom == 0)
			dstPortRange[0]='\0';
		else if (IpEntry.dstPortFrom == IpEntry.dstPortTo)
			snprintf(dstPortRange, 12, "%u", IpEntry.dstPortFrom);
		else
			snprintf(dstPortRange, 12, "%u:%u",
				IpEntry.dstPortFrom, IpEntry.dstPortTo);
		
		// source ip, mask
#ifdef IP_RANGE_FILTER_SUPPORT
	if(IpEntry.srcIp2[0] == 0)    // normal ip filter, no iprange supported
	{
#endif
		strncpy(srcip, inet_ntoa(*((struct in_addr *)IpEntry.srcIp)), 16);
		if (strcmp(srcip, ARG_0x4) == 0)
			filterSIP = 0;
		else {
			if (IpEntry.smaskbit!=0)
				snprintf(srcip, 20, "%s/%d", srcip, IpEntry.smaskbit);
			filterSIP = srcip;
		}
#ifdef IP_RANGE_FILTER_SUPPORT
	}else
	{
		strncpy(srcip, inet_ntoa(*((struct in_addr *)IpEntry.srcIp)), 16);
		strncpy(srcip2, inet_ntoa(*((struct in_addr *)IpEntry.srcIp2)),16);
		if(strcmp(srcip, ARG_0x4) ==0 || strcmp(srcip2, ARG_0x4) ==0)
			filterSIPRange=0;
		else
		{
			snprintf(SIPRange, 40, "%s-%s", srcip, srcip2);
			filterSIPRange=SIPRange;
		}
	}
#endif		
		// destination ip, mask
#ifdef IP_RANGE_FILTER_SUPPORT
	if(IpEntry.dstIp2[0] == 0)    // normal ip filter, no iprange supported
	{
#endif		
		strncpy(dstip, inet_ntoa(*((struct in_addr *)IpEntry.dstIp)), 16);
		if (strcmp(dstip, ARG_0x4) == 0)
			filterDIP = 0;
		else {
			if (IpEntry.dmaskbit!=0)
				snprintf(dstip, 20, "%s/%d", dstip, IpEntry.dmaskbit);
			filterDIP = dstip;
		}
#ifdef IP_RANGE_FILTER_SUPPORT
	}else
	{
		strncpy(dstip, inet_ntoa(*((struct in_addr *)IpEntry.dstIp)), 16);
		strncpy(dstip2, inet_ntoa(*((struct in_addr *)IpEntry.dstIp2)),16);
		if(strcmp(dstip, ARG_0x4) ==0 || strcmp(dstip2, ARG_0x4) ==0)
			filterDIPRange=0;
		else
		{
			snprintf(DIPRange, 40, "%s-%s", dstip, dstip2);
			filterDIPRange=DIPRange;
		}
	}
#endif
#ifdef IP_FILTER_PRIORITY_HIGHEST
		argv[1] = (char *)FW_INSERT;
		argv[2] = (char *)FW_IPFILTER;
		argv[3]="3";
		argv[4] = (char *)ARG_I;
		
		if (IpEntry.dir == DIR_OUT) {
			argv[5] = (char *)LANIF;
			idx = 6;
		}
		else {
			argv[5] = "!";
			argv[6] = (char *)LANIF;
			idx = 7;
		}
#else
		// interface
		argv[1] = (char *)FW_ADD;
		argv[2] = (char *)FW_IPFILTER;
		argv[3] = (char *)ARG_I;
		
		if (IpEntry.dir == DIR_OUT) {
			argv[4] = (char *)LANIF;
			idx = 5;
		}
		else {
			argv[4] = "!";
			argv[5] = (char *)LANIF;
			idx = 6;
		}
#endif
		
		// protocol
		if (IpEntry.protoType != PROTO_NONE) {
			argv[idx++] = "-p";
			if (IpEntry.protoType == PROTO_TCP)
				argv[idx++] = (char *)ARG_TCP;
			else if (IpEntry.protoType == PROTO_UDP)
				argv[idx++] = (char *)ARG_UDP;
			else //if (IpEntry.protoType == PROTO_ICMP)
				argv[idx++] = (char *)ARG_ICMP;
		}
		
		// src ip
		if (filterSIP != 0)
		{
			argv[idx++] = "-s";
			argv[idx++] = filterSIP;
			
		}
		
		// src port
		if ((IpEntry.protoType==PROTO_TCP ||
			IpEntry.protoType==PROTO_UDP) &&
			srcPortRange[0] != 0) {
			argv[idx++] = (char *)FW_SPORT;
			argv[idx++] = srcPortRange;
		}
		
		// dst ip
		if (filterDIP != 0)
		{
			argv[idx++] = "-d";
			argv[idx++] = filterDIP;
		}
#ifdef IP_RANGE_FILTER_SUPPORT
		if(filterSIPRange || filterDIPRange)
		{
			argv[idx++]="-m";
			argv[idx++]="iprange";
			if(filterSIPRange)
			{
				argv[idx++]="--src-range";
				argv[idx++]=filterSIPRange;
			}
			if(filterDIPRange)
			{
				argv[idx++]="--dst-range";
				argv[idx++]=filterDIPRange;
			}
		}
#endif
		// dst port
		if ((IpEntry.protoType==PROTO_TCP ||
			IpEntry.protoType==PROTO_UDP) &&
			dstPortRange[0] != 0) {
			argv[idx++] = (char *)FW_DPORT;
			argv[idx++] = dstPortRange;
		}
		
		// target/jump		
		argv[idx++] = "-j";
		argv[idx++] = policy;
		argv[idx++] = NULL;
		
		//printf("idx=%d\n", idx);
		TRACE(STA_SCRIPT, "%s %s %s %s %s %s %s ...\n", IPTABLES, argv[1], argv[2], argv[3], argv[4], argv[5], argv[6]);
		{
			int tempi;
			for(tempi=0; tempi < idx; tempi++)
			{
				printf("%s ", argv[tempi]);
			}
			printf("\n");
			
		}
		do_cmd(IPTABLES, argv, 1);
	}
	// default action
	if (mib_get(MIB_IPF_OUT_ACTION, (void *)value) != 0)
	{
		vInt = (int)(*(unsigned char *)value);
		if (vInt == 0)	// DROP
		{
			// iptables -A ipfilter -i $LAN_IF -j DROP
			va_cmd(IPTABLES, 6, 1, (char *)FW_ADD,
				(char *)FW_IPFILTER, (char *)ARG_I,
				(char *)LANIF, "-j", (char *)FW_DROP);			
		}
	}
#if 0	
#ifdef  CONFIG_USER_PPPOE_PROXY
       char ppp_proxyif[6];
	char ppp_proxynum[2];
	int proxy_index;
	
	for(proxy_index = WAN_PPP_INTERFACE; proxy_index< WAN_PPP_INTERFACE+LAN_PPP_INTERFACE;proxy_index++){
		snprintf(ppp_proxyif, 6, "ppp%u", proxy_index);
		va_cmd (IPTABLES, 6, 1, (char *) FW_ADD, (char *) FW_IPFILTER, (char *)
           ARG_I, ppp_proxyif, "-j", (char *) FW_RETURN);
		}
#endif
#endif
   
	if (mib_get(MIB_IPF_IN_ACTION, (void *)value) != 0)
	{
		vInt = (int)(*(unsigned char *)value);
		if (vInt == 0)	// DROP
		{
			// iptables -A ipfilter -i ! $LAN_IF -j DROP
			
				va_cmd(IPTABLES, 7, 1, (char *)FW_ADD,
				(char *)FW_IPFILTER, (char *)ARG_I, "!",
				(char *)LANIF, "-j", (char *)FW_DROP);
			
		}
	}

	// allow DMZ to pass
	#if 0
	if ((mib_get(MIB_DMZ_ENABLE, (void *)&byte) != 0) && byte) {
		if (mib_get(MIB_DMZ_IP, (void *)value) != 0)
		{
			char *ipaddr = srcip;
			strncpy(ipaddr, inet_ntoa(*((struct in_addr *)value)), 16);
			ipaddr[15] = '\0';
		
			total = mib_chain_total (MIB_IP_PORT_FILTER_TBL) + 3;
			snprintf(value, 8, "%d", total);
			// iptables -I ipfilter 3 -i ! $LAN_IF -o $LAN_IF -d $DMZ_IP -j RETURN
			va_cmd(IPTABLES, 12, 1, "-I",
				(char *)FW_IPFILTER, value, (char *)ARG_I, "!",
				(char *)LANIF, (char *)ARG_O,
				(char *)LANIF, "-d", ipaddr, "-j", (char *)FW_RETURN);
		}	
	}
	#endif
	// iptables -A FORWARD -j ipfilter
	//va_cmd(IPTABLES, 4, 1, (char *)FW_ADD, (char *)FW_FORWARD, "-j", (char *)FW_IPFILTER);
}

int setupMacFilter()
{
	unsigned char value[32];
	int vInt, i, total, vcNum;
	char *policy;
	char srcmacaddr[18], dstmacaddr[18];
#ifdef MAC_FILTER
	MIB_CE_MAC_FILTER_T MacEntry;
	char mac_in_dft, mac_out_dft;
	char eth_mac_ctrl=0, wlan_mac_ctrl=0;
#endif
	unsigned char vChar;
	MIB_CE_ATM_VC_T Entry;
	char str_vc[] = "vc0";
	
	// Delete all Macfilter rule
	va_cmd(IPTABLES, 2, 1, "-F", (char *)FW_MACFILTER);
#ifdef PARENTAL_CTRL
	parent_ctrl_table_init();
	parent_ctrl_table_rule_update();
#endif	
#ifdef MAC_FILTER
	// MAC filtering support in bridge mode only
	total = ifWanNum("br");
	vInt = mib_chain_total(MIB_MAC_FILTER_TBL);
	mib_get(MIB_MACF_OUT_ACTION, (void *)&mac_out_dft);
	mib_get(MIB_MACF_IN_ACTION, (void *)&mac_in_dft);
	mib_get(MIB_ETH_MAC_CTRL, (void *)&eth_mac_ctrl);
	mib_get(MIB_WLAN_MAC_CTRL, (void *)&wlan_mac_ctrl);
#endif
#ifdef IP_QOS
	// Added by Nason Yu for brnf enable/disable buttom	
	// If user set some rules on MAC Filtering or enable IPQos, we should enable Bridge netfilter.
	// And we enable/disable bridge netfilter once in order to avoid double setting.
	mib_get(MIB_MPMODE, (void *)&vChar);
#endif

	
#if (defined IP_QOS) || (defined MAC_FILTER)
	if (
#ifdef MAC_FILTER
		total >= 1 && ((mac_out_dft==0 || mac_in_dft==0) || vInt >= 1)
#endif
#ifdef IP_QOS
#ifdef MAC_FILTER
		||
#endif
		(vChar&0x02)
#endif
	) {
		// Enable Bridge Netfiltering					
		va_cmd("/bin/brctl", 2, 0, "brnf", "on");
	}else {
		// Disable Bridge Netfiltering
		va_cmd("/bin/brctl", 2, 0, "brnf", "off");
	}
#endif
	
#ifdef MAC_FILTER
	//if (total >= 1) 
	{
		total = mib_chain_total(MIB_MAC_FILTER_TBL);
		vcNum = mib_chain_total(MIB_ATM_VC_TBL);
		
		// Commented by Mason Yu
		//if (total >= 1) {
			// Add chain for MAC filtering
			// iptables -N macfilter
			//va_cmd(IPTABLES, 2, 1, "-N", (char *)FW_MACFILTER);
		//}
		
		for (i = 0; i < total; i++)
		{
			if (!mib_chain_get(MIB_MAC_FILTER_TBL, i, (void *)&MacEntry))
				return -1;
			
			if (MacEntry.action == 0)
				policy = (char *)FW_DROP;
			else
				policy = (char *)FW_RETURN;
				
			
			snprintf(srcmacaddr, 18, "%02x:%02x:%02x:%02x:%02x:%02x",
				MacEntry.srcMac[0], MacEntry.srcMac[1],
				MacEntry.srcMac[2], MacEntry.srcMac[3],
				MacEntry.srcMac[4], MacEntry.srcMac[5]);
			
			
				
			snprintf(dstmacaddr, 18, "%02x:%02x:%02x:%02x:%02x:%02x",
				MacEntry.dstMac[0], MacEntry.dstMac[1],
				MacEntry.dstMac[2], MacEntry.dstMac[3],
				MacEntry.dstMac[4], MacEntry.dstMac[5]);	
			
			
			
			// Added by Mason Yu for Incoming MAC filtering
			if (MacEntry.dir == DIR_OUT) {
				if (   MacEntry.dstMac[0]==0 && MacEntry.dstMac[1]==0
			    	    && MacEntry.dstMac[2]==0 && MacEntry.dstMac[3]==0
		 	    	    && MacEntry.dstMac[4]==0 && MacEntry.dstMac[5]==0 ) {
					if(mac_out_dft || eth_mac_ctrl)
						// iptables -A macfilter -i eth0  -m mac --mac-source $MAC -j ACCEPT/DROP
						va_cmd(IPTABLES, 10, 1, (char *)FW_ADD, (char *)FW_MACFILTER,
							(char *)ARG_I, (char *)ELANIF, "-m", "mac",
							"--mac-source",  srcmacaddr, "-j", policy);	
					if(mac_out_dft || wlan_mac_ctrl)
						// iptables -A macfilter -i wlan0  -m mac --mac-source $MAC -j ACCEPT/DROP
						va_cmd(IPTABLES, 10, 1, (char *)FW_ADD, (char *)FW_MACFILTER,
							(char *)ARG_I, (char *)WLANIF, "-m", "mac",
							"--mac-source",  srcmacaddr, "-j", policy);	
					
				}else if (   MacEntry.srcMac[0]==0 && MacEntry.srcMac[1]==0
			    	  	  && MacEntry.srcMac[2]==0 && MacEntry.srcMac[3]==0
		 	                  && MacEntry.srcMac[4]==0 && MacEntry.srcMac[5]==0 ) { 
				
					// iptables -A macfilter -i eth0  -m mac --mac-dst $MAC -j ACCEPT/DROP
					va_cmd(IPTABLES, 10, 1, (char *)FW_ADD, (char *)FW_MACFILTER,
						(char *)ARG_I, (char *)ELANIF, "-m", "mac",
						"--mac-dst",  dstmacaddr, "-j", policy);	
					// iptables -A macfilter -i wlan0  -m mac --mac-dst $MAC -j ACCEPT/DROP
					va_cmd(IPTABLES, 10, 1, (char *)FW_ADD, (char *)FW_MACFILTER,
						(char *)ARG_I, (char *)WLANIF, "-m", "mac",
						"--mac-dst",  dstmacaddr, "-j", policy);
				
				}else {
					// iptables -A macfilter -i eth0  -m mac --mac-source $MAC --mac-dst $MAC -j ACCEPT/DROP
					va_cmd(IPTABLES, 12, 1, (char *)FW_ADD, (char *)FW_MACFILTER,
						(char *)ARG_I, (char *)ELANIF, "-m", "mac",
						"--mac-source",  srcmacaddr, "--mac-dst",  dstmacaddr, "-j", policy);	
					// iptables -A macfilter -i wlan0  -m mac --mac-source $MAC --mac-dst $MAC -j ACCEPT/DROP
					va_cmd(IPTABLES, 12, 1, (char *)FW_ADD, (char *)FW_MACFILTER,
						(char *)ARG_I, (char *)WLANIF, "-m", "mac",
						"--mac-source",  srcmacaddr, "--mac-dst",  dstmacaddr, "-j", policy);
				}
					
			}
			else {
				for (vInt=0; vInt<vcNum; vInt++) {
					if (!mib_chain_get(MIB_ATM_VC_TBL, vInt, (void *)&Entry))
						continue;
					if (Entry.enable == 0)
						continue;
					#ifdef ZTE_GENERAL_ROUTER_SC
					  char WanIfName[64]={0};
					if(Entry.cmode==ADSL_PPPoA||Entry.cmode==ADSL_PPPoE)							
						  snprintf(WanIfName,sizeof(WanIfName),"ppp%d",PPP_INDEX(Entry.ifIndex));						
					else
						snprintf(WanIfName,sizeof(WanIfName),"vc%d",VC_INDEX(Entry.ifIndex));
					if(!memcmp(MacEntry.dstMac,"\x00\x00\x00\x00\x00\x00",MAC_ADDR_LEN))
						  	{
						  	va_cmd(IPTABLES, 10, 1, (char *)FW_ADD, (char *)FW_MACFILTER,
								(char *)ARG_I, WanIfName, "-m", "mac",
								"--mac-source",  srcmacaddr, "-j", policy);
						  	}
						  else   if(!memcmp(MacEntry.srcMac,"\x00\x00\x00\x00\x00\x00",MAC_ADDR_LEN))
						  	{
						  	va_cmd(IPTABLES, 10, 1, (char *)FW_ADD, (char *)FW_MACFILTER,
								(char *)ARG_I, WanIfName, "-m", "mac",
								"--mac-dst",  dstmacaddr, "-j", policy);
						  	}else{
						  		va_cmd(IPTABLES, 12, 1, (char *)FW_ADD, (char *)FW_MACFILTER,
								(char *)ARG_I, WanIfName, "-m", "mac",
								"--mac-source",  srcmacaddr, "--mac-dst",  dstmacaddr, "-j", policy);
						  		}
						
					#else
					if (Entry.cmode == ADSL_BR1483) {
						// vc index should be less than 10
						str_vc[2] = '0'+VC_INDEX(Entry.ifIndex);
						
						if (   MacEntry.dstMac[0]==0 && MacEntry.dstMac[1]==0
			    	    		    && MacEntry.dstMac[2]==0 && MacEntry.dstMac[3]==0
		 	    	    		    && MacEntry.dstMac[4]==0 && MacEntry.dstMac[5]==0 ) {
						
							// iptables -A macfilter -i vc0  -m mac --mac-source $MAC -j ACCEPT/DROP
							va_cmd(IPTABLES, 10, 1, (char *)FW_ADD, (char *)FW_MACFILTER,
								(char *)ARG_I, str_vc, "-m", "mac",
								"--mac-source",  srcmacaddr, "-j", policy);
								
						}else if (   MacEntry.srcMac[0]==0 && MacEntry.srcMac[1]==0
			    	  	  		  && MacEntry.srcMac[2]==0 && MacEntry.srcMac[3]==0
		 	                  		  && MacEntry.srcMac[4]==0 && MacEntry.srcMac[5]==0 ) { 
		 	                  		  		
							// iptables -A macfilter -i vc0  -m mac --mac-dst $MAC -j ACCEPT/DROP
							va_cmd(IPTABLES, 10, 1, (char *)FW_ADD, (char *)FW_MACFILTER,
								(char *)ARG_I, str_vc, "-m", "mac",
								"--mac-dst",  dstmacaddr, "-j", policy);
								
						}else {
							// iptables -A macfilter -i vc0  -m mac --mac-source $MAC --mac-dst $MAC -j ACCEPT/DROP
							va_cmd(IPTABLES, 12, 1, (char *)FW_ADD, (char *)FW_MACFILTER,
								(char *)ARG_I, str_vc, "-m", "mac",
								"--mac-source",  srcmacaddr, "--mac-dst",  dstmacaddr, "-j", policy);
						}	
						
							
					}
				#endif
				}
			}
		}
		
		// Commented by Mason Yu
		//if (total >= 1) {
			// default action
			if (mib_get(MIB_MACF_OUT_ACTION, (void *)value) != 0)
			{
				vInt = (int)(*(unsigned char *)value);
				if (vInt == 0 && eth_mac_ctrl )
				{
					// iptables -A macfilter -i eth0 -j DROP					
					va_cmd(IPTABLES, 6, 1, (char *)FW_ADD,
						(char *)FW_MACFILTER, (char *)ARG_I,
						(char *)ELANIF, "-j", (char *)FW_DROP);
				}
				if (vInt == 0 && wlan_mac_ctrl )
				{
					// iptables -A macfilter -i wlan0 -j DROP					
					va_cmd(IPTABLES, 6, 1, (char *)FW_ADD,
						(char *)FW_MACFILTER, (char *)ARG_I,
						(char *)WLANIF, "-j", (char *)FW_DROP);
				}				
			}
			
			if (mib_get(MIB_MACF_IN_ACTION, (void *)value) != 0)
			{
				vInt = (int)(*(unsigned char *)value);
				if (vInt == 0)	// DROP
				{
					for (vInt=0; vInt<vcNum; vInt++) {
						if (!mib_chain_get(MIB_ATM_VC_TBL, vInt, (void *)&Entry))
							continue;
						if (Entry.enable == 0)
							continue;
					#ifdef ZTE_GENERAL_ROUTER_SC
					  char WanIfName[64]={0};
					if(Entry.cmode==ADSL_PPPoA||Entry.cmode==ADSL_PPPoE)							
						  snprintf(WanIfName,sizeof(WanIfName),"ppp%d",PPP_INDEX(Entry.ifIndex));						
					else
						snprintf(WanIfName,sizeof(WanIfName),"vc%d",VC_INDEX(Entry.ifIndex));
					va_cmd(IPTABLES, 6, 1, (char *)FW_ADD,
								(char *)FW_MACFILTER, (char *)ARG_I,
								WanIfName, "-j", (char *)FW_DROP);
					#else
						if (Entry.cmode == ADSL_BR1483) {
							// vc index should be less than 10
							str_vc[2] = '0'+VC_INDEX(Entry.ifIndex);
							// iptables -A macfilter -i vc0 -j DROP							
							va_cmd(IPTABLES, 6, 1, (char *)FW_ADD,
								(char *)FW_MACFILTER, (char *)ARG_I,
								str_vc, "-j", (char *)FW_DROP);
						}
					#endif
					}
				}
			}
			// iptables -A FORWARD -j macfilter
			//va_cmd(IPTABLES, 4, 1, (char *)FW_ADD, (char *)FW_FORWARD, "-j", (char *)FW_MACFILTER);
		// Commented by Mason Yu
		//}
	}
#endif // of MAC_FILTER
	
}

#ifdef LAYER7_FILTER_SUPPORT
int setupAppFilter()
{
	int entryNum,i;
	LAYER7_FILTER_T Entry;

	// Delete all Appfilter rule
	va_cmd(IPTABLES, 2, 1, "-F", (char *)FW_APPFILTER);
	va_cmd(IPTABLES, 2, 1, "-F", (char *)FW_APP_P2PFILTER);
	va_cmd(IPTABLES, 4, 1, ARG_T, "mangle", "-F", (char *)FW_APPFILTER);

	entryNum = mib_chain_total(MIB_LAYER7_FILTER_TBL);

	for(i=0;i<entryNum;i++)
	{
		if (!mib_chain_get(MIB_LAYER7_FILTER_TBL, i, (void *)&Entry))
			return -1;

		if(!strcmp("smtp",Entry.appname)){
			//iptables -A appfilter -i br0 -p TCP --dport 25 -j DROP
			va_cmd(IPTABLES, 10, 1, (char *)FW_ADD, (char *)FW_APPFILTER, ARG_I, LANIF,
				"-p", ARG_TCP, FW_DPORT, "25", "-j", (char *)FW_DROP);
			continue;
		}
		else if(!strcmp("pop3",Entry.appname)){
			//iptables -A appfilter -i br0 -p TCP --dport 110 -j DROP
			va_cmd(IPTABLES, 10, 1, (char *)FW_ADD, (char *)FW_APPFILTER, ARG_I, LANIF,
				"-p", ARG_TCP, FW_DPORT, "110", "-j", (char *)FW_DROP);
			continue;
		}
		else if(!strcmp("bittorrent",Entry.appname)){
			//iptables -A appp2pfilter -m ipp2p --bit -j DROP
			va_cmd(IPTABLES, 7, 1, (char *)FW_ADD, (char *)FW_APP_P2PFILTER, "-m", "ipp2p",
				"--bit", "-j", (char *)FW_DROP);
			continue;
		}
		else if(!strcmp("chinagame",Entry.appname)){
			//iptables -A appfilter -i br0 -p TCP --dport 8000 -j DROP
			va_cmd(IPTABLES, 10, 1, (char *)FW_ADD, (char *)FW_APPFILTER, ARG_I, LANIF,
				"-p", ARG_TCP, FW_DPORT, "8000", "-j", (char *)FW_DROP);
			continue;
		}
		else if(!strcmp("gameabc",Entry.appname)){
			//iptables -A appfilter -i br0 -p TCP --dport 5100 -j DROP
			va_cmd(IPTABLES, 10, 1, (char *)FW_ADD, (char *)FW_APPFILTER, ARG_I, LANIF,
				"-p", ARG_TCP, FW_DPORT, "5100", "-j", (char *)FW_DROP);
			continue;
		}
		else if(!strcmp("haofang",Entry.appname)){
			//iptables -A appfilter -i br0 -p TCP --dport 1201 -j DROP
			va_cmd(IPTABLES, 10, 1, (char *)FW_ADD, (char *)FW_APPFILTER, ARG_I, LANIF,
				"-p", ARG_TCP, FW_DPORT, "1201", "-j", (char *)FW_DROP);
			continue;
		}
		else if(!strcmp("ourgame",Entry.appname)){
			//iptables -A appfilter -i br0 -p TCP --dport 2000 -j DROP
			va_cmd(IPTABLES, 10, 1, (char *)FW_ADD, (char *)FW_APPFILTER, ARG_I, LANIF,
				"-p", ARG_TCP, FW_DPORT, "2000", "-j", (char *)FW_DROP);
		}
			
		
		// iptables -t mangle -A appfilter -m layer7 --l7proto qq -j DROP
		va_cmd(IPTABLES, 10, 1, ARG_T, "mangle", (char *)FW_ADD, (char *)FW_APPFILTER, "-m", "layer7",
			"--l7proto", Entry.appname, "-j", (char *)FW_DROP);

	}

	return 0;
}
#endif
#ifdef PARENTAL_CTRL
//Uses Global variable for keep watching timeout
MIB_PARENT_CTRL_T parentctrltable[MAX_PARENTCTRL_USER_NUM] = {0};
/********************************
 *
 *	Initialization. load from flash
 *	
 ********************************/
//return if this mac should be filtered now!
static int parent_ctrl_check(MIB_PARENT_CTRL_T *entry)
{
	time_t tm;
	struct tm the_tm;
	int		tmp1,tmp2,tmp3;;
	
	time(&tm);
	memcpy(&the_tm, localtime(&tm), sizeof(the_tm));

	if (((entry->controlled_day) & (1 << the_tm.tm_wday))!=0)
	{
		tmp1 = entry->start_hr * 60 +  entry->start_min;
		tmp2 = entry->end_hr * 60 +  entry->end_min;
		tmp3 = the_tm.tm_hour *60 + the_tm.tm_min;
		if ((tmp3 >= tmp1) && (tmp3 <= tmp2) )
			return 1;	
	}

		return 0;

}
int parent_ctrl_table_init()
{
	int total,i;
	MIB_PARENT_CTRL_T	entry;

	memset(&parentctrltable[0],0, sizeof(MIB_PARENT_CTRL_T)*MAX_PARENTCTRL_USER_NUM);
	total = mib_chain_total(MIB_PARENTAL_CTRL_TBL);
	if (total >= MAX_PARENTCTRL_USER_NUM)
	{
		total = MAX_PARENTCTRL_USER_NUM -1;
		printf("ERROR, CHECK!");
	}
	 for ( i=0; i<total; i++)
	 {
		mib_chain_get(MIB_PARENTAL_CTRL_TBL, i, &parentctrltable[i]);
	 }
}
int parent_ctrl_table_add(MIB_PARENT_CTRL_T *addedEntry)
{
	int	i;

	for (i = 0; i < MAX_PARENTCTRL_USER_NUM; i++)
	{
		if (strlen(parentctrltable[i].username) == 0)
		{
			break;
		}
	}
	addedEntry->cur_state = 0;
	memcpy (&parentctrltable[i],addedEntry, sizeof(MIB_PARENT_CTRL_T));

	parent_ctrl_table_rule_update();
}
int parent_ctrl_table_del(MIB_PARENT_CTRL_T *addedEntry)
{
	int	i;
	char macaddr[20];
	
	for (i = 0; i < MAX_PARENTCTRL_USER_NUM; i++)
	{
		if ( !strcmp(parentctrltable[i].username, addedEntry->username)) 
		{
			if (parentctrltable[i].cur_state == 1)
			{
				//del the entry
					snprintf(macaddr, 18, "%02x:%02x:%02x:%02x:%02x:%02x",
					parentctrltable[i].mac[0], parentctrltable[i].mac[1],
					parentctrltable[i].mac[2], parentctrltable[i].mac[3],
					parentctrltable[i].mac[4], parentctrltable[i].mac[5]);	
				va_cmd(IPTABLES, 10, 1, (char *)FW_DEL, (char *)FW_MACFILTER,
						(char *)ARG_I, (char *)WLANIF, "-m", "mac",
						"--mac-source",  macaddr, "-j", "DROP");	
				va_cmd(IPTABLES, 10, 1, (char *)FW_DEL, (char *)FW_MACFILTER,
						(char *)ARG_I, (char *)ELANIF, "-m", "mac",
						"--mac-source",  macaddr, "-j", "DROP");				
			}
			//remove the iptable here if it exists
			memset(&parentctrltable[i],0, sizeof(MIB_PARENT_CTRL_T));			
			break;
		}
	}
}
int parent_ctrl_table_delall()
{
	int	i;
	char macaddr[20];

	for (i = 0; i < MAX_PARENTCTRL_USER_NUM; i++)
	{
		if (parentctrltable[i].cur_state == 1)
		{
			//del the entry
			snprintf(macaddr, 18, "%02x:%02x:%02x:%02x:%02x:%02x",
				parentctrltable[i].mac[0], parentctrltable[i].mac[1],
				parentctrltable[i].mac[2], parentctrltable[i].mac[3],
				parentctrltable[i].mac[4], parentctrltable[i].mac[5]);	
			va_cmd(IPTABLES, 10, 1, (char *)FW_DEL, (char *)FW_MACFILTER,
					(char *)ARG_I, (char *)WLANIF, "-m", "mac",
					"--mac-source",  macaddr, "-j", "DROP");	
			va_cmd(IPTABLES, 10, 1, (char *)FW_DEL, (char *)FW_MACFILTER,
					(char *)ARG_I, (char *)ELANIF, "-m", "mac",
					"--mac-source",  macaddr, "-j", "DROP");				
		}
				
	}	
	memset(&parentctrltable[0],0, sizeof(MIB_PARENT_CTRL_T)*MAX_PARENTCTRL_USER_NUM);
}

// update the rules to iptables according to current time
int parent_ctrl_table_rule_update()
{
	int i, check;
	char macaddr[20];
	
	for (i = 0; i < MAX_PARENTCTRL_USER_NUM; i++)
	{
		if (strlen(parentctrltable[i].username) > 0) 
		{
			
			check = parent_ctrl_check(&parentctrltable[i]);
			
			if (( check == 1) &&
				(parentctrltable[i].cur_state == 0))
			{
				parentctrltable[i].cur_state = 1;
			
				//add the entry
				snprintf(macaddr, 18, "%02x:%02x:%02x:%02x:%02x:%02x",
				parentctrltable[i].mac[0], parentctrltable[i].mac[1],
				parentctrltable[i].mac[2], parentctrltable[i].mac[3],
				parentctrltable[i].mac[4], parentctrltable[i].mac[5]);	

				//for debug							
				va_cmd(IPTABLES, 10, 1, (char *)FW_ADD, (char *)FW_MACFILTER,
						(char *)ARG_I, (char *)WLANIF, "-m", "mac",
						"--mac-source",  macaddr, "-j", "DROP");	
				va_cmd(IPTABLES, 10, 1, (char *)FW_ADD, (char *)FW_MACFILTER,
						(char *)ARG_I, (char *)ELANIF, "-m", "mac",
						"--mac-source",  macaddr, "-j", "DROP");	
			}
			else if ((check == 0) &&
				(parentctrltable[i].cur_state == 1))
			{
				parentctrltable[i].cur_state = 0;
				//del the entry
				snprintf(macaddr, 18, "%02x:%02x:%02x:%02x:%02x:%02x",
				parentctrltable[i].mac[0], parentctrltable[i].mac[1],
				parentctrltable[i].mac[2], parentctrltable[i].mac[3],
				parentctrltable[i].mac[4], parentctrltable[i].mac[5]);	

				va_cmd(IPTABLES, 10, 1, (char *)FW_DEL, (char *)FW_MACFILTER,
						(char *)ARG_I, (char *)WLANIF, "-m", "mac",
						"--mac-source",  macaddr, "-j", "DROP");	
				va_cmd(IPTABLES, 10, 1, (char *)FW_DEL, (char *)FW_MACFILTER,
						(char *)ARG_I, (char *)ELANIF, "-m", "mac",
						"--mac-source",  macaddr, "-j", "DROP");	
			}
			
		}
	}
}


#endif

#if 0
int setupVtlsvr()
{
	int i, total;
	MIB_CE_VTL_SVR_T Entry;
	char srcPortRange[12], dstPortRange[12], dstPort[12];
	char dstip[32];
	char ipAddr[20];
	//char *act;
	char ifname[16];
	
	total = mib_chain_total(MIB_VIRTUAL_SVR_TBL);
	// attach the vrtsvr rules to the chain for ip filtering
	
	for (i = 0; i < total; i++)
	{
		/*
		 *	srcPortRange: src port
		 *	dstPortRange: dst port
		 */
		if (!mib_chain_get(MIB_VIRTUAL_SVR_TBL, i, (void *)&Entry))
			return -1;

		// destination ip(server ip)
		strncpy(dstip, inet_ntoa(*((struct in_addr *)Entry.svrIpAddr)), 16);
		snprintf(ipAddr, 20, "%s/%d", dstip, 32);
		

		//wan port
		if (Entry.wanStartPort == 0)
			srcPortRange[0]='\0';
		else if (Entry.wanStartPort == Entry.wanEndPort)
			snprintf(srcPortRange, 12, "%u", Entry.wanStartPort);
		else
			snprintf(srcPortRange, 12, "%u:%u", 
				Entry.wanStartPort, Entry.wanEndPort);
		
		// server port
		if (Entry.svrStartPort == 0)
			dstPortRange[0]='\0';
		else {
			if (Entry.svrStartPort == Entry.svrEndPort) {
				snprintf(dstPortRange, 12, "%u", Entry.svrStartPort);
				snprintf(dstPort, 12, "%u", Entry.svrStartPort);
			} else {
				snprintf(dstPortRange, 12, "%u-%u",
					Entry.svrStartPort, Entry.svrEndPort);
				snprintf(dstPort, 12, "%u:%u", 
					Entry.svrStartPort, Entry.svrEndPort);
			}
			snprintf(dstip, 32, "%s:%s", dstip, dstPortRange);
		}
		
		//act = (char *)FW_ADD;
		// interface
		strcpy(ifname, LANIF);
			
		//printf("idx=%d\n", idx);
		if (Entry.protoType == PROTO_TCP || Entry.protoType == PROTO_UDPTCP)
		{
			// iptables -t nat -A PREROUTING -i ! $LAN_IF -p TCP --dport dstPortRange -j DNAT --to-destination ipaddr
			va_cmd(IPTABLES, 15, 1, "-t", "nat", "-I", (char *)FW_PREROUTING, (char *)ARG_I, "!", 
				(char *)ifname,	"-p", (char *)ARG_TCP, (char *)FW_DPORT, srcPortRange, "-j", "DNAT", 
				"--to-destination", dstip);
			
			// iptables -I ipfilter 3 -i ! $LAN_IF -o $LAN_IF -p TCP --dport dstPortRange -j RETURN
			va_cmd(IPTABLES, 16, 1, "-I", (char *)FW_IPFILTER, "3", (char *)ARG_I, "!", (char *)ifname, 
				(char *)ARG_O, (char *)ifname, "-p", (char *)ARG_TCP, (char *)FW_DPORT, dstPort, "-d", 
				(char *)ipAddr, "-j",(char *)FW_RETURN);
		}
		if (Entry.protoType == PROTO_UDP || Entry.protoType == PROTO_UDPTCP)
		{
			va_cmd(IPTABLES, 15, 1, "-t", "nat", "-I", (char *)FW_PREROUTING, (char *)ARG_I, "!", 
				(char *)ifname,	"-p", (char *)ARG_UDP, (char *)FW_DPORT, srcPortRange, "-j", "DNAT", 
				"--to-destination", dstip);
			// iptables -I ipfilter 3 -i ! $LAN_IF -o $LAN_IF -p UDP --dport dstPortRange -j RETURN
			va_cmd(IPTABLES, 16, 1, "-I", (char *)FW_IPFILTER, "3", (char *)ARG_I, "!", (char *)ifname, 
				(char *)ARG_O, (char *)LANIF, "-p", (char *)ARG_UDP, (char *)FW_DPORT, dstPort, "-d", 
				(char *)ipAddr, "-j",(char *)FW_RETURN);
		}
	}
		
	return 1;
}
#endif
#ifdef VIRTUAL_SERVER_SUPPORT
int setupVtlsvr(int type)
{

	int i, total;
	struct vtlsvr_entryx Entry;	
	total = mib_chain_total(MIB_VIRTUAL_SVR_TBL);
	DOCMDINIT;
#ifdef IP_FILTER_PRIORITY_HIGHEST
	int position=mib_chain_total(MIB_IP_PORT_FILTER_TBL)+3;
#else
	int position=3;
#endif
	for (i = 0; i < total; i++)
	{
		
		if (!mib_chain_get(MIB_VIRTUAL_SVR_TBL, i, (void *)&Entry))
			return -1;
		if (Entry.protoType == PROTO_TCP || Entry.protoType == 0)//0--TCP/UDP
			{
			
			// iptables -t nat -A PREROUTING -i ! $LAN_IF -p TCP --dport srcPortRange -j DNAT --to-destination ipaddr --to-ports 8080
			//DOCMDARGVS(IPTABLES, DOWAIT, "-t nat %s PREROUTING -i ! br0 -p TCP --dport %u:%u -j DNAT --to-destination %s --to-ports %d",action,Entry.wanStartPort, Entry.wanEndPort,
			//inet_ntoa(*((struct in_addr *)&(Entry.serverIp))),Entry.lanPort);
			DOCMDARGVS(IPTABLES, DOWAIT, "-t nat %s PREROUTING -i ! br0 -p TCP --dport %u:%u -j DNAT --to-destination %s:%u ",VIRTUAL_SERVER_ACTION_APPEND(type),
			Entry.wanStartPort, Entry.wanEndPort,	inet_ntoa(*((struct in_addr *)&(Entry.serverIp))),Entry.lanPort);
			// iptables -I ipfilter 3 -i ! $LAN_IF -o $LAN_IF -p TCP --dport dstPortRange -j ACCEPT
			DOCMDARGVS(IPTABLES, DOWAIT, "%s ipfilter %s -i ! br0 -o br0 -p TCP -d %s --dport %u -j ACCEPT",VIRTUAL_SERVER_ACTION_INSERT(type),
			VIRTUAL_SERVER_ACTION_PARAM_INT(type,position),inet_ntoa(*((struct in_addr *)&(Entry.serverIp))),Entry.lanPort);
			}	
			if (Entry.protoType == PROTO_UDP || Entry.protoType == 0)
			{
			
			// iptables -t nat -A PREROUTING -i ! $LAN_IF -p TCP --dport srcPortRange -j DNAT --to-destination ipaddr --to-ports 8080
			//DOCMDARGVS(IPTABLES, DOWAIT, "-t nat %s PREROUTING -i ! br0 -p TCP --dport %u:%u -j DNAT --to-destination %s --to-ports %d",action,Entry.wanStartPort, Entry.wanEndPort,
			//inet_ntoa(*((struct in_addr *)&(Entry.serverIp))),Entry.lanPort);
			DOCMDARGVS(IPTABLES, DOWAIT, "-t nat %s PREROUTING -i ! br0 -p UDP --dport %u:%u -j DNAT --to-destination %s:%u ",VIRTUAL_SERVER_ACTION_APPEND(type),
			Entry.wanStartPort, Entry.wanEndPort,	inet_ntoa(*((struct in_addr *)&(Entry.serverIp))),Entry.lanPort);
			// iptables -I ipfilter 3 -i ! $LAN_IF -o $LAN_IF -p TCP --dport dstPortRange -j ACCEPT
			DOCMDARGVS(IPTABLES, DOWAIT, "%s ipfilter %s -i ! br0 -o br0 -p UDP -d %s --dport %u -j ACCEPT",VIRTUAL_SERVER_ACTION_INSERT(type),
			VIRTUAL_SERVER_ACTION_PARAM_INT(type,position),inet_ntoa(*((struct in_addr *)&(Entry.serverIp))),Entry.lanPort);
			}
		
	}		

	return 1;
}
#endif
// Execute firewall rules
// return value:
// 1  : successful
int setupFirewall()
{
	char *argv[20];
	unsigned char value[32];
	int vInt, i, total, vcNum, min_mtu=1492;
	MIB_CE_IP_PORT_FILTER_T IpEntry;
#ifdef MAC_FILTER
	MIB_CE_MAC_FILTER_T MacEntry;
	char mac_in_dft, mac_out_dft;
	char eth_mac_ctrl=0, wlan_mac_ctrl=0;
#endif
	MIB_CE_PORT_FW_T PfEntry;
	MIB_CE_ATM_VC_T Entry;
	char *policy, *filterSIP, *filterDIP, srcPortRange[12], dstPortRange[12];
	char ipaddr[32], srcip[20], dstip[20], lanip[16], mmtu[5]="1492", mmtu_s[11];
	char ifname[16], extra[32];
	char srcmacaddr[18], dstmacaddr[18];
#ifdef IP_PASSTHROUGH
	unsigned char ippt_itf;
#endif
	int spc_enable, spc_ip;
	// Added by Mason Yu for ACL
	unsigned char aclEnable, domainEnable;	
	unsigned char dhcpvalue[32];
	unsigned char vChar;
	int dhcpmode;
	char str_vc[] = "vc0";
	// Added by Mason Yu for URL Blocking
#if defined( URL_BLOCKING_SUPPORT)||defined( URL_ALLOWING_SUPPORT)	
	unsigned char urlEnable, urlMode;
#endif		
#ifdef NAT_CONN_LIMIT
	unsigned char connlimitEn;
#endif

	
	/*
	**clear iptables all to start or restart iptables rules...
	*/
	DOCMDINIT;
	DOCMDARGVS(IPTABLES, DOWAIT, "-F");
	DOCMDARGVS(IPTABLES, DOWAIT, "-t nat -F PREROUTING");
	//-------------------------------------------------
	// Filter table
	//-------------------------------------------------
	//--------------- set policies --------------
	// iptables -P INPUT DROP
	va_cmd(IPTABLES, 3, 1, "-P", (char *)FW_INPUT, (char *)FW_DROP);
	
	// iptables -P FORWARD ACCEPT
	va_cmd(IPTABLES, 3, 1, "-P", (char *)FW_FORWARD, (char *)FW_ACCEPT);
	DOCMDARGVS(IPTABLES, DOWAIT, "-A %s -m state --state ESTABLISHED,RELATED -j ACCEPT", FW_INPUT);
	// Kaohj -- allowing RIP (in case of ACL blocking)
	// iptables -A INPUT -p udp --dport 520 -j ACCEPT
	va_cmd(IPTABLES, 8, 1, (char *)FW_ADD, (char *)FW_INPUT, "-p",
		"udp", (char *)FW_DPORT, "520", "-j", (char *)FW_ACCEPT);
#ifdef CONFIG_MIDDLEWARE
	mib_get(CWMP_TR069_ENABLE,(void *)&vChar);	//CWMP_TR069_ENABLE: 0-run midware;1-run normal tr069
	if(vChar == 0){
		va_cmd(IPTABLES, 8, 1, (char *)FW_ADD, (char *)FW_INPUT, "-p",
			"tcp", (char *)FW_DPORT, "9080", "-j", (char *)FW_ACCEPT);
		va_cmd(IPTABLES, 8, 1, (char *)FW_ADD, (char *)FW_INPUT, "-p",
			"tcp", (char *)FW_DPORT, "30005", "-j", (char *)FW_ACCEPT);
	}
#endif
#ifdef IP_ACL
	//  Add Chain(aclblock) for ACL
	va_cmd(IPTABLES, 2, 1, "-N", "aclblock");	
	mib_get(MIB_ACL_CAPABILITY, (void *)&aclEnable);
	if (aclEnable == 1)  // ACL Capability is enabled
		filter_set_acl(1);
	//iptables -A INPUT -j aclblock
	va_cmd(IPTABLES, 4, 1, (char *)FW_ADD, (char *)FW_INPUT, "-j", "aclblock");
#endif

#ifdef NAT_CONN_LIMIT
	//Add Chain(connlimit) for NAT conn limit
	va_cmd(IPTABLES, 2, 1, "-N", "connlimit");

	mib_get(MIB_NAT_CONN_LIMIT, (void *)&connlimitEn);
	if (connlimitEn == 1)
		set_conn_limit();

	//iptables -A FORWARD -j connlimit
	va_cmd(IPTABLES, 4, 1, (char *)FW_ADD, (char *)FW_FORWARD, "-j", "connlimit");
#endif
#ifdef TCP_UDP_CONN_LIMIT
	//Add Chain(connlimit) for NAT conn limit
	va_cmd(IPTABLES, 2, 1, "-N", "connlimit");

	mib_get(MIB_CONNLIMIT_ENABLE, (void *)&vChar);
	if (vChar == 1)
		set_conn_limit();
	//iptables -A FORWARD -j connlimit
	va_cmd(IPTABLES, 4, 1, (char *)FW_ADD, (char *)FW_FORWARD, "-j", "connlimit");
#endif



#ifdef DOMAIN_BLOCKING_SUPPORT
	//  Add Chain(domainblk) for ACL
	va_cmd(IPTABLES, 2, 1, "-N", "domainblk");	
	mib_get(MIB_DOMAINBLK_CAPABILITY, (void *)&domainEnable);
	if (domainEnable == 1)  // Domain blocking Capability is enabled
		filter_set_domain(1);
	//iptables -A INPUT -j domainblk
	va_cmd(IPTABLES, 4, 1, (char *)FW_ADD, (char *)FW_INPUT, "-j", "domainblk");
	
	//iptables -A FORWARD -j domainblk
	va_cmd(IPTABLES, 4, 1, (char *)FW_ADD, (char *)FW_FORWARD, "-j", "domainblk");
	
	//iptables -A OUTPUT -j domainblk
	va_cmd(IPTABLES, 4, 1, (char *)FW_ADD, "OUTPUT", "-j", "domainblk");
#endif
	
	//paccEntry = (MIB_CE_ACC_Tp) mib_chain_get(MIB_ACC_TBL, 0);
	//if (!paccEntry)
	//	return;
	
	// Add chain for remote access
	// iptables -N inacc
	va_cmd(IPTABLES, 2, 1, "-N", (char *)FW_INACC);
 #ifdef NEW_ACC_CTL_IMPL
 	setupAccessControl(0);
 #else
 	va_cmd(IPTABLES, 11, 1, "-A", (char *)FW_INACC, 
		(char *)ARG_I, "!", LANIF, "-m", "mark", "--mark", RMACC_MARK, "-j", FW_ACCEPT);
 	filter_set_remote_access(0);
 #endif
	
#ifdef IP_PASSTHROUGH
	// IP Passthrough, LAN access
	if (mib_get(MIB_IPPT_ITF, (void *)&ippt_itf) != 0)
		if (ippt_itf != 255) {	// IP passthrough
			mib_get(MIB_IPPT_LANACC, (void *)value);
			if (value[0] == 0)	// disable LAN access
				// iptables -A FORWARD -i $LAN_IF -o $LAN_IF -j DROP
				va_cmd(IPTABLES, 8, 1, (char *)FW_ADD,
					(char *)FW_FORWARD, (char *)ARG_I,
					(char *)LANIF, (char *)ARG_O,
					(char *)LANIF, "-j", (char *)FW_DROP);
		}
#endif		
	
	// Added by Mason Yu for dhcp Relay. Open DHCP Relay Port for Incoming Packets.
	if (mib_get(MIB_DHCP_MODE, (void *)dhcpvalue) != 0)
	{
		dhcpmode = (unsigned int)(*(unsigned char *)dhcpvalue);
		if (dhcpmode == 1 ){
			// iptables -A inacc -i ! br0 -p udp --dport 67 -j ACCEPT		
			va_cmd(IPTABLES, 11, 1, (char *)FW_ADD, (char *)FW_INACC, (char *)ARG_I, "!", "br0", "-p", "udp", (char *)FW_DPORT, (char *)PORT_DHCP, "-j", (char *)FW_ACCEPT);				
		}	
	}	
	
#ifdef CONFIG_USER_ROUTED_ROUTED
	// Added by Mason Yu. Open RIP Port for Incoming Packets.
	if (mib_get( MIB_RIP_ENABLE, (void *)&vChar) != 0)
	{	
		if (1 == vChar)	
		{	
			// iptables -A inacc -i ! br0 -p udp --dport 520 -j ACCEPT		
			va_cmd(IPTABLES, 11, 1, (char *)FW_ADD, (char *)FW_INACC, "-i", "!", "br0", "-p", "udp", (char *)FW_DPORT, "520", "-j", (char *)FW_ACCEPT);	
		}			
	}
#endif
							
	// iptables -A INPUT -j inacc
	va_cmd(IPTABLES, 4, 1, (char *)FW_ADD, (char *)FW_INPUT, "-j", (char *)FW_INACC);
	
	// Added by Mason Yu for accept packet with ip(127.0.0.1)
	va_cmd(IPTABLES, 6, 1, (char *)FW_ADD, (char *)FW_INPUT, "-d", "127.0.0.1", "-j", (char *)FW_ACCEPT);
	
	// Single PC mode
	if (mib_get(MIB_SPC_ENABLE, (void *)value) != 0)
	{
		if (value[0]) // Single PC mode enabled
		{
			spc_enable = 1;
			mib_get(MIB_SPC_IPTYPE, (void *)value);
			if (value[0] == 0) // single private IP
			{
				spc_ip = 0;
				mib_get(MIB_ADSL_LAN_IP, (void *)value);
				
				// IP pool start address
				// Kaohj
				#ifndef DHCPS_POOL_COMPLETE_IP
				mib_get(MIB_ADSL_LAN_CLIENT_START, (void *)&value[3]);
				strncpy(ipaddr, inet_ntoa(*((struct in_addr *)value)), 16);
				#else
				mib_get(MIB_DHCP_POOL_START, (void *)value);
				strncpy(ipaddr, inet_ntoa(*((struct in_addr *)value)), 16);
				#endif
				ipaddr[15] = '\0';
				// iptables -A FORWARD -i $LANIF -s ! ipaddr -j DROP
				va_cmd(IPTABLES, 9, 1, (char *)FW_ADD,
					(char *)FW_FORWARD, (char *)ARG_I,
					(char *)LANIF, "-s", "!", ipaddr,
					"-j", (char *)FW_DROP);
			}
			else // single IP passthrough
			{
				spc_ip = 1;
			}
		}
		else
			spc_enable = 0;
	}
				
#ifdef IP_PASSTHROUGH
	// check vc
	total = mib_chain_total(MIB_ATM_VC_TBL);
	for (i = 0; i < total; i++)
	{
		if (!mib_chain_get(MIB_ATM_VC_TBL, i, (void *)&Entry))
			return -1;
		
		if (spc_enable && (spc_ip == 1)) // single IP passthrough (public IP)
		{
			if ((REMOTE_ACCESS_T)Entry.cmode == ACC_ROUTED &&
				ippt_itf == Entry.ifIndex)
			{	// ippt WAN interface (1483-r)
				if ((DHCP_T)Entry.ipDhcp == DHCP_DISABLED)
				{
					strncpy(ipaddr, inet_ntoa(*((struct in_addr *)Entry.ipAddr)), 16);
					ipaddr[15] = '\0';
					// iptables -A FORWARD -i $LANIF -s ! ipaddr -j DROP
					va_cmd(IPTABLES, 9, 1, (char *)FW_ADD,
						(char *)FW_FORWARD, (char *)ARG_I,
						(char *)LANIF, "-s", "!", ipaddr,
						"-j", (char *)FW_DROP);
				}
			}
		}
	}
#endif

#if defined(URL_BLOCKING_SUPPORT)||defined(URL_ALLOWING_SUPPORT)
	//Add Chain(urlblock) for URL
	va_cmd(IPTABLES, 2, 1, "-N", "urlblock");
	//Add Chain(urlallow) for URL
	va_cmd(IPTABLES, 2, 1 ,"-N", "urlallow");
	//iptables -A FORWARD -j urlblock
	va_cmd(IPTABLES, 4, 1, (char *)FW_ADD, (char *)FW_FORWARD, "-j", "urlblock");
	//iptables -A FORWARD -j urlallow
	va_cmd(IPTABLES, 4, 1, (char *)FW_ADD, (char *)FW_FORWARD, "-j", "urlallow");
	
	mib_get(MIB_URL_FILTER_ENABLED, (void *)&urlEnable);
	if (urlEnable) {
		mib_get(MIB_URL_FILTER_MODE, (void *)&urlMode);
		if (urlMode) {//whitelist
			filter_set_url(2);
		} else { //whitelist
			filter_set_url(1);
		}
	}
#endif

#ifdef LAYER7_FILTER_SUPPORT
	//App Filter
	va_cmd(IPTABLES, 2, 1, "-N", (char *)FW_APPFILTER);
	va_cmd(IPTABLES, 2, 1, "-N", (char *)FW_APP_P2PFILTER);
	va_cmd(IPTABLES, 4, 1, ARG_T, "mangle", "-N", (char *)FW_APPFILTER);
	setupAppFilter();
	// iptables -A FORWARD -j appfilter
	va_cmd(IPTABLES, 4, 1, (char *)FW_ADD, (char *)FW_FORWARD, "-j", (char *)FW_APPFILTER);	
	// iptables -t mangle -A POSTROUTING -j appfilter
	va_cmd(IPTABLES, 6, 1, ARG_T, "mangle", (char *)FW_ADD, (char *)FW_POSTROUTING, "-j", (char *)FW_APPFILTER);	
#endif

	// IP Filter
	va_cmd(IPTABLES, 2, 1, "-N", (char *)FW_IPFILTER);
	// accept related
	// iptables -A ipfilter -m state --state ESTABLISHED,RELATED -j RETURN
	DOCMDARGVS(IPTABLES, DOWAIT, "-A %s -m state --state ESTABLISHED,RELATED -j ACCEPT", FW_IPFILTER);
	// iptables -A ipfilter -d 224.0.0.0/4 -j RETURN
	DOCMDARGVS(IPTABLES, DOWAIT, "-A %s -d 224.0.0.0/4 -j ACCEPT", FW_IPFILTER);
#ifdef IP_FILTER_ONOFF_SUPPORT
	if(ipFilterEnabled())
		setupIPFilter();
#else
	setupIPFilter();
#endif
	// iptables -A FORWARD -j ipfilter
	va_cmd(IPTABLES, 4, 1, (char *)FW_ADD, (char *)FW_FORWARD, "-j", (char *)FW_IPFILTER);	
	
	// Mac Filter	
	va_cmd(IPTABLES, 2, 1, "-N", (char *)FW_MACFILTER);
	setupMacFilter();
	// iptables -A FORWARD -j macfilter
	va_cmd(IPTABLES, 4, 1, (char *)FW_ADD, (char *)FW_FORWARD, "-j", (char *)FW_MACFILTER);	


#ifdef LAYER7_FILTER_SUPPORT
	// iptables -A FORWARD -j appp2pfilter
	va_cmd(IPTABLES, 4, 1, (char *)FW_ADD, (char *)FW_FORWARD, "-j", (char *)FW_APP_P2PFILTER);	
#endif

	// port forwarding
	vInt = 0;
	if (mib_get(MIB_PORT_FW_ENABLE, (void *)value) != 0)
		vInt = (int)(*(unsigned char *)value);
	
	if (vInt == 1)
	{

		int negate=0, hasRemote=0;
		char * proto = 0;
		char intPort[32], extPort[32];
		
		total = mib_chain_total(MIB_PORT_FW_TBL);

		for (i = 0; i < total; i++)
		{		
			if (!mib_chain_get(MIB_PORT_FW_TBL, i, (void *)&PfEntry))
				return -1;
			
			portfw_modify( &PfEntry, 0 );
		}
	}//if (vInt == 1)
#ifdef VIRTUAL_SERVER_SUPPORT
	//execute virtual server rules
	setupVtlsvr(VIRTUAL_SERVER_ADD);
#endif
	
#ifdef NATIP_FORWARDING
	fw_setupIPForwarding();
#endif

#ifdef PORT_TRIGGERING
	setupPortTriggering();
#endif
#ifdef PORT_TRIGGER_SUPPORT
	setupPortTrigger(PORT_TRIGGER_ADD);
#endif
#ifdef DMZ_SUPPORT
	setupDMZ(DMZ_ENABLED);
#endif
		printf("iptables firewall enabled !\n");
	
	
	total = mib_chain_total(MIB_ATM_VC_TBL);
	for (i=0; i<total; i++)
	{
		if (!mib_chain_get(MIB_ATM_VC_TBL, i, (void *)&Entry))
			return -1;
		if (Entry.enable == 0)
			continue;
		if(min_mtu > Entry.mtu)
			min_mtu = Entry.mtu;
	}
	sprintf(mmtu, "%d", min_mtu-40);
	// Added by Mason Yu
	sprintf(mmtu_s, "%d:1536", min_mtu-40);
	
	// for PPPoE Black Hole
	// iptables -A FORWARD -p tcp --tcp-flags SYN,RST SYN -j TCPMSS --clamp-mss-to-pmtu
	{ /* Since we should NOT modify the MSS of the inbound SYN packet, we should add this rule ONLY on PPP interface. */
		va_cmd(IPTABLES, 12, 1, (char *)FW_ADD, (char *)FW_FORWARD,
			"-p", "tcp", "-o", "ppp+", "--tcp-flags", "SYN,RST", "SYN", "-j",
			"TCPMSS", "--clamp-mss-to-pmtu");
		/* Because we don't want to change the br0's MTU, thus, we must patch ISP's MSS on the inbound packet. */
//		va_cmd(IPTABLES, 13, 1, (char *)FW_ADD, (char *)FW_FORWARD,
//			"-p", "tcp", "-i", "ppp+", "--tcp-flags", "SYN,RST", "SYN", "-j",
//			"TCPMSS", "--set-mss", "1452");		
			
		// Mason Yu.
		// When the receive interface is ppp,
		// if the incoming packet's mss is greater than WAN's min mss, the incoming packet's mss must be changed to WAN's min mss,
		// if the incoming packet's mss is smaller than WAN's min mss, the incoming packet's mss need not be changed.
		va_cmd(IPTABLES, 17, 1, (char *)FW_ADD, (char *)FW_FORWARD,
			"-p", "tcp", "-i", "ppp+", "--tcp-flags", "SYN,RST", "SYN", "-m" , "tcpmss", "--mss", mmtu_s, "-j",
			"TCPMSS", "--set-mss", mmtu);
	}
	
 	// for multicast
#if 0 // move ahead to ipfilter chain
	// iptables -A FORWARD -d 224.0.0.0/4 -j ACCEPT
	va_cmd(IPTABLES, 6, 1, (char *)FW_ADD, (char *)FW_FORWARD, "-d",
		"224.0.0.0/4", "-j", (char *)FW_ACCEPT);
#endif
	
	// Kaohj --- only the LAN ports in the same group with IGMP proxy upstream interface
	// be able to accept IGMP messages
#if (defined(CONFIG_EXT_SWITCH) && defined(ITF_GROUP) && defined(CONFIG_USER_IGMPPROXY))
#ifdef CONFIG_IGMPPROXY_MULTIWAN
        mib_get(MIB_MPMODE, (void *)&value[0]);
        if(value[0]&0x01){ //Port-mapping enable
	   total = mib_chain_total(MIB_ATM_VC_TBL);
	   for (i=0; i<total; i++) {
			if (!mib_chain_get(MIB_ATM_VC_TBL, i, (void *)&Entry))
				continue;
			if (!Entry.enable)
				continue;
			if (Entry.igmpproxyenable){ // igmpproxy upstream interface
                      int k; 
			  int swtotal;
			  MIB_CE_SW_PORT_T lanPort;
			  swtotal = mib_chain_total(MIB_SW_PORT_TBL);
			  for (k=0; k<swtotal; k++) {
				if (!mib_chain_get(MIB_SW_PORT_TBL, k, (void *)&lanPort))
					continue;
				if (lanPort.itfGroup != Entry.itfGroup){
					 //disable LAN IGMP input for other groups
					char phy[]="eth0_sw0";
					phy[7] = '0'+ k;
	//				printf("inport i = %d  phy %s \n",i,phy);
					// iptables -A INPUT -d 224.0.0.0/4 -i eth0_sw0 -j DROP
					// Note: the mark(nfmark) is tagged at NIC driver(re8670.c)
					va_cmd(IPTABLES, 8, 1, (char *)FW_ADD, (char *)FW_INPUT, "-d",
					"224.0.0.0/4", (char *)ARG_I,  phy, "-j", (char *)FW_DROP);
				} 
			  }
			}	
				
	   }
	}
#else
	mib_get(MIB_MPMODE, (void *)&value[0]);
	mib_get(MIB_IGMP_PROXY, (void *)&value[1]);
	if ((value[0]&0x01) && (value[1] == 1)) { // Port-mapping && igmp proxy enabled
		mib_get(MIB_IGMP_PROXY_ITF, (void *)&value[0]);
		total = mib_chain_total(MIB_ATM_VC_TBL);
		for (i=0; i<total; i++) {
			if (!mib_chain_get(MIB_ATM_VC_TBL, i, (void *)&Entry))
				continue;
			if (!Entry.enable)
				continue;
			if (Entry.ifIndex == value[0])	// igmpproxy upstream interface
				break;
		}
		if (i!=total) {	// found igmpproxy upstream interface
			MIB_CE_SW_PORT_T lanPort;
			total = mib_chain_total(MIB_SW_PORT_TBL);
			for (i=0; i<total; i++) {
				if (!mib_chain_get(MIB_SW_PORT_TBL, i, (void *)&lanPort))
					continue;
				if (lanPort.itfGroup != Entry.itfGroup) {
#if 0
					// disable LAN IGMP input for other groups
					char vp[] = "1";
					vp[0] = '1' + i;
					// iptables -A INPUT -d 224.0.0.0/4 -m mark --mark port+1 -j DROP
					// Note: the mark(nfmark) is tagged at NIC driver(re8670.c)
					va_cmd(IPTABLES, 10, 1, (char *)FW_ADD, (char *)FW_INPUT, "-d",
					"224.0.0.0/4", "-m", "mark", "--mark", vp, "-j", (char *)FW_DROP);
#endif
                             //disable LAN IGMP input for other groups
					char phy[]="eth0_sw0";
					phy[7] = '0'+ i;
	//				printf("inport i = %d  phy %s \n",i,phy);
					// iptables -A INPUT -d 224.0.0.0/4 -i eth0_sw0 -j DROP
					// Note: the mark(nfmark) is tagged at NIC driver(re8670.c)
					va_cmd(IPTABLES, 8, 1, (char *)FW_ADD, (char *)FW_INPUT, "-d",
					"224.0.0.0/4", (char *)ARG_I,  phy, "-j", (char *)FW_DROP);

                                  
				}
			}
		}
	}
#endif	
#endif
	// iptables -A INPUT -d 224.0.0.0/4 -j ACCEPT
	va_cmd(IPTABLES, 6, 1, (char *)FW_ADD, (char *)FW_INPUT, "-d",
		"224.0.0.0/4", "-j", (char *)FW_ACCEPT);
	// allowing ping to self
	mib_get(MIB_ADSL_LAN_IP, (void *)value);
	strncpy(ipaddr, inet_ntoa(*((struct in_addr *)value)), 16);
	ipaddr[15] = '\0';
	// iptables -A INPUT -s 192.168.1.1 -d 192.168.1.1 -j ACCEPT
	va_cmd(IPTABLES, 8, 1, (char *)FW_ADD, (char *)FW_INPUT, "-s",
		ipaddr, "-d", ipaddr, "-j", (char *)FW_ACCEPT);
	// iptables -A INPUT -m state --state ESTABLISHED,RELATED -j ACCEPT
	// andrew. moved to the 1st rule, or returning PING/DNS relay will be blocked.
	//va_cmd(IPTABLES, 8, 1, (char *)FW_ADD, (char *)FW_INPUT, "-m", "state",
	//	"--state", "ESTABLISHED,RELATED", "-j", (char *)FW_ACCEPT);

	// iptables -A INPUT -m state --state NEW -i $LAN_INTERFACE -j ACCEPT
	va_cmd(IPTABLES, 10, 1, (char *)FW_ADD, (char *)FW_INPUT, "-m", "state",
		"--state", "NEW", (char *)ARG_I, (char *)LANIF,
		"-j", (char *)FW_ACCEPT);
	
#if 0
	/*--------------------------------------------------------------------
	 * The following are the default action and should be final rules
	 -------------------------------------------------------------------*/
	// iptables -N block
	va_cmd(IPTABLES, 2, 1, "-N", (char *)FW_BLOCK);
	
	// default action
	if (mib_get(MIB_IPF_OUT_ACTION, (void *)value) != 0)
	{
		vInt = (int)(*(unsigned char *)value);
		if (vInt == 1)	// ACCEPT
		{
			// iptables -A block -i $LAN_IF -j ACCEPT
			va_cmd(IPTABLES, 6, 1, (char *)FW_ADD,
				(char *)FW_BLOCK, (char *)ARG_I,
				(char *)LANIF, "-j", (char *)FW_ACCEPT);
		}
	}
	
	if (mib_get(MIB_IPF_IN_ACTION, (void *)value) != 0)
	{
		vInt = (int)(*(unsigned char *)value);
		if (vInt == 1)	// ACCEPT
		{
			// iptables -A block -i ! $LAN_IF -j ACCEPT
			va_cmd(IPTABLES, 7, 1, (char *)FW_ADD,
				(char *)FW_BLOCK, (char *)ARG_I, "!",
				(char *)LANIF, "-j", (char *)FW_ACCEPT);
		}
	}
	
	// iptables -A block -m state --state ESTABLISHED,RELATED -j ACCEPT
	va_cmd(IPTABLES, 8, 1, (char *)FW_ADD, (char *)FW_BLOCK, "-m", "state",
		"--state", "ESTABLISHED,RELATED", "-j", (char *)FW_ACCEPT);
	
	/*
	// iptables -A block -m state --state NEW -i $LAN_INTERFACE -j ACCEPT
	va_cmd(IPTABLES, 10, 1, (char *)FW_ADD, (char *)FW_BLOCK, "-m", "state",
		"--state", "NEW", (char *)ARG_I, (char *)LANIF,
		"-j", (char *)FW_ACCEPT);
	*/
	
	// iptables -A block -j DROP
	va_cmd(IPTABLES, 4, 1, (char *)FW_ADD, "block", "-j", (char *)FW_DROP);
	
	/*
	// iptables -A INPUT -j block
	va_cmd(IPTABLES, 4, 1, (char *)FW_ADD, (char *)FW_INPUT, "-j", "block");
	*/
	
	// iptables -A FORWARD -j block
	va_cmd(IPTABLES, 4, 1, (char *)FW_ADD, (char *)FW_FORWARD, "-j", "block");
#endif
#ifdef ZTE_531B_BRIDGE_SC
unsigned char devAddr[MAC_ADDR_LEN];
if (mib_get(MIB_ELAN_MAC_ADDR, (void *)devAddr) != 0)
{
if(!memcmp(devAddr,"\x00\xE0\x4C\x86\x70\x01",MAC_ADDR_LEN))
{
va_cmd(IPTABLES, 10, 1, "-D", (char *)FW_INACC,
		(char *)ARG_I, (char *)LANIF, "-p", (char *)ARG_TCP,
		(char *)FW_DPORT, "23", "-j", (char *)FW_DROP);
}
}
#endif

//star: set acs url route and firewall setting for wan applicationtype are TR069 and INTERNET
#if defined(CTC_WAN_NAME)&&defined(_CWMP_MIB_)
	set_acsurl_route_fw(0);
#endif

//execute firewall grade rules
#ifdef FIREWALL_GRADE
	initFw();
	setFirewallGrade();
#endif
#ifdef MAC_FILTER_EBTABLES_SUPPORT
	setupEbtables(EBTABLES_ENABLED);
#endif
	return 1;
}
#ifdef CONFIG_IP_NF_ALG_ONOFF
//add by ramen return 1--sucessful
int setupAlgOnOff()
{
		unsigned char  value=0;
/*
#ifdef CONFIG_IP_NF_FTP
        	 if(mib_get(MIB_IP_ALG_FTP,&value)&& value==0)
                    system("/bin/echo 0 > /proc/ftp_algonoff");
	   	else
	   		system("/bin/echo 1 > /proc/ftp_algonoff");
#endif
*/
#ifdef CONFIG_IP_NF_H323   
        	 if(mib_get(MIB_IP_ALG_H323,&value)&& value==0)
                    system("/bin/echo 0 >/proc/algonoff_h323");
	  	 else
	   	 system("/bin/echo 1 >/proc/algonoff_h323");
#endif
#ifdef CONFIG_IP_NF_IRC
          	if(mib_get(MIB_IP_ALG_IRC,&value)&& value==0)
                    system("/bin/echo 0 >/proc/algonoff_irc");
		else
		system("/bin/echo 1 >/proc/algonoff_irc");
#endif
#ifdef CONFIG_IP_NF_RTSP
		if(mib_get(MIB_IP_ALG_RTSP,&value)&& value==0)
                    system("/bin/echo 0 >/proc/algonoff_rtsp");
		else
			 system("/bin/echo 1 >/proc/algonoff_rtsp");
#endif
#ifdef CONFIG_IP_NF_QUAKE3
		if(mib_get(MIB_IP_ALG_QUAKE3,&value)&& value==0)
			system("/bin/echo 0 > /proc/algonoff_quake3");     
		else
			system("/bin/echo 1 > /proc/algonoff_quake3");  
#endif
#ifdef CONFIG_IP_NF_CUSEEME
		if(mib_get(MIB_IP_ALG_CUSEEME,&value)&& value==0)
                    system("/bin/echo 0 > /proc/algonoff_cuseeme");  
		else
			system("/bin/echo 1 > /proc/algonoff_cuseeme");  
#endif
/*
#ifdef CONFIG_IP_NF_L2TP
		if(mib_get(MIB_IP_ALG_L2TP,&value)&& value==0)
                    system("/bin/echo 0 > /proc/algonoff_l2tp"); 
		else
			system("/bin/echo 1 > /proc/algonoff_l2tp"); 
#endif
*/
#ifdef CONFIG_IP_NF_IPSEC
		if(mib_get(MIB_IP_ALG_IPSEC,&value)&& value==0)
                    system("/bin/echo 0 > /proc/algonoff_ipsec");    
		else
			system("/bin/echo 1 > /proc/algonoff_ipsec");    
#endif
#ifdef CONFIG_IP_NF_SIP
		if(mib_get(MIB_IP_ALG_SIP,&value)&& value==0)
                    system("/bin/echo 0 > /proc/algonoff_sip");   
		else
			system("/bin/echo 1 > /proc/algonoff_sip");   
#endif
/*
#ifdef CONFIG_IP_NF_PPTP
		if(mib_get(MIB_IP_ALG_PPTP,&value)&& value==0)
                    system("/bin/echo 0 > /proc/algonoff_pptp");
		else
			system("/bin/echo 1 > /proc/algonoff_pptp");
#endif
*/
         return;
}

#endif


#ifdef WEB_REDIRECT_BY_MAC
int start_web_redir_by_mac(void)
{
	int status=0;
	char tmpbuf[MAX_URL_LEN];
	char ipaddr[16], ip_port[32], redir_server[33];
	int  def_port=WEB_REDIR_BY_MAC_PORT;
	
	ipaddr[0]='\0'; ip_port[0]='\0';redir_server[0]='\0';
	if (mib_get(MIB_ADSL_LAN_IP, (void *)tmpbuf) != 0)
	{
		strncpy(ipaddr, inet_ntoa(*((struct in_addr *)tmpbuf)), 16);
		ipaddr[15] = '\0';
		sprintf(ip_port,"%s:%d",ipaddr,def_port);
	}//else ??

	// Enable Bridge Netfiltering					
	//status|=va_cmd("/bin/brctl", 2, 0, "brnf", "on");
	
	//iptables -t nat -N Web_Redirect
	status|=va_cmd(IPTABLES, 4, 1, "-t", "nat","-N","WebRedirectByMAC");
	
	//iptables -t nat -A Web_Redirect -d 192.168.1.1 -j RETURN
	status|=va_cmd(IPTABLES, 8, 1, "-t", "nat","-A","WebRedirectByMAC",
		"-d", ipaddr, "-j", (char *)FW_RETURN);

	//iptables -t nat -A Web_Redirect -p tcp --dport 80 -j DNAT --to-destination 192.168.1.1:8080 
	status|=va_cmd(IPTABLES, 12, 1, "-t", "nat","-A","WebRedirectByMAC",
		"-p", "tcp", "--dport", "80", "-j", "DNAT", 
		"--to-destination", ip_port);
	
	//iptables -t nat -A PREROUTING -p tcp --dport 80 -j Web_Redirect
	status|=va_cmd(IPTABLES, 12, 1, "-t", "nat","-A","PREROUTING",
		"-i", "eth0",
		"-p", "tcp", "--dport", "80", "-j", "WebRedirectByMAC");


{
	int num,i;
	unsigned char tmp2[18];
	MIB_WEB_REDIR_BY_MAC_T	wrm_entry;

	num = mib_chain_total( MIB_WEB_REDIR_BY_MAC_TBL );
	//printf( "\nnum=%d\n", num );
	for(i=0;i<num;i++)
	{
		if( !mib_chain_get( MIB_WEB_REDIR_BY_MAC_TBL, i, (void*)&wrm_entry ) )
			continue;

		sprintf( tmp2, "%02X:%02X:%02X:%02X:%02X:%02X", 
				wrm_entry.mac[0], wrm_entry.mac[1], wrm_entry.mac[2], wrm_entry.mac[3], wrm_entry.mac[4], wrm_entry.mac[5] );
		//printf( "add one mac: %s \n", tmp2 );			
		// iptables -A macfilter -i eth0  -m mac --mac-source $MAC -j ACCEPT/DROP
		status|=va_cmd("/bin/iptables", 10, 1, "-t", "nat", "-I", "WebRedirectByMAC", "-m", "mac", "--mac-source", tmp2, "-j", "RETURN");
	}
}

	return 0;
}
#endif

//--------------------------------------------------------
// WAN startup
// return value:
// 1  : successful
// -1 : failed
int startWan(BOOT_TYPE_T mode)
{
	int vcTotal, i, ret;
	MIB_CE_ATM_VC_T Entry;
	int ipEnabled;
	FILE *fp;
	char vcNum[16];
	
	ret = 1;
	vcTotal = mib_chain_total(MIB_ATM_VC_TBL);
	
	ipEnabled = 0;
	
	for (i = 0; i < vcTotal; i++)
	{
		/* get the specified chain record */
		if (!mib_chain_get(MIB_ATM_VC_TBL, i, (void *)&Entry))
			return -1;
		
		if (Entry.enable == 0)
			continue;
		
		ret|=startConnection(&Entry);
		
#if defined(ZTE_531B_BRIDGE_SC)||defined(ZTE_GENERAL_ROUTER_SC)  || defined(CONFIG_BOA_WEB_E8B_CH)

                ipEnabled = 1;
#else
		if ((REMOTE_ACCESS_T)Entry.cmode != ACC_BRIDGED)
			ipEnabled = 1;
#endif


	}
	
	if (ipEnabled && mode == BOOT_LAST)
	{
		if (fp = fopen(PROC_IPFORWARD, "w"))
		{
			fprintf(fp, "1\n");
			fclose(fp);
		}
	
#ifdef CONFIG_USER_ROUTED_ROUTED		
		if (startRip() == -1)
		{
			printf("start RIP failed !\n");
			ret = -1;
		}
#endif

#ifdef CONFIG_USER_ZEBRA_OSPFD_OSPFD
		if (startOspf() == -1)
		{
			printf("start OSPF failed !\n");
			ret = -1;
		}
#endif

#ifdef CONFIG_USER_IGMPPROXY
		if (startIgmproxy() == -1)
		{
			printf("start IGMP proxy failed !\n");
			ret = -1;
		}
#endif

/*		
		// execute firewall rules
		if (setupFirewall() == -1)
		{
			printf("execute firewall rules failed !\n");
			ret = -1;
		}
*/
	}

	// execute firewall rules	
	if (setupFirewall() == -1)
	{
		printf("execute firewall rules failed !\n");
		ret = -1;
	}





#ifdef DNS_BIND_PVC_SUPPORT
         DnsBindPvcRoute(ADDDNSROUTE);
         printf("execute the DNS bind !!\n");
#endif	

	// Kaohj --- remove all conntracks
	va_cmd("/bin/ethctl", 2, 1, "conntrack", "killall");

#ifdef QSETUP_WEB_REDIRECT
	ret |= reset_qsetup_redirect();
#endif

#ifdef WEB_REDIRECT_BY_MAC
	if( -1==start_web_redir_by_mac() )
		ret=-1;
#endif

	return ret;
}

#ifdef _CWMP_MIB_ /*jiunming, mib for cwmp-tr069*/

void cwmpsetfirewall()
{
	char vChar=0;
	char strPort[16];
	unsigned int conreq_port=0;

	mib_get(CWMP_CONREQ_ENABLE, (void *)&vChar);
	if(vChar==1){
	mib_get(CWMP_CONREQ_PORT, (void *)&conreq_port);
	if(conreq_port==0) conreq_port=7547;
	sprintf(strPort, "%u", conreq_port );
	va_cmd(IPTABLES, 15, 1, ARG_T, "mangle", "-A", (char *)FW_PREROUTING,
			(char *)ARG_I, "!", (char *)LANIF, "-p", (char *)ARG_TCP,
			(char *)FW_DPORT, strPort, "-j", (char *)"MARK", "--set-mark", RMACC_MARK);
	}
/*
	sprintf(strPort, "%u", 30005 );
	va_cmd(IPTABLES, 15, 1, ARG_T, "mangle", "-A", (char *)FW_PREROUTING,
		(char *)ARG_I, "!", (char *)LANIF, "-p", (char *)ARG_TCP,
		(char *)FW_DPORT, strPort, "-j", (char *)"MARK", "--set-mark", RMACC_MARK);

#ifdef CONFIG_MIDDLEWARE
	sprintf(strPort, "%u", 9080 );
	va_cmd(IPTABLES, 15, 1, ARG_T, "mangle", "-A", (char *)FW_PREROUTING,
		(char *)ARG_I, "!", (char *)LANIF, "-p", (char *)ARG_TCP,
		(char *)FW_DPORT, strPort, "-j", (char *)"MARK", "--set-mark", RMACC_MARK);
#endif
*/
}
int startCWMP(void)
{
	char vChar=0;
	char strPort[16];
	unsigned int conreq_port=0;
	
	//lan interface enable or disable
	mib_get(CWMP_LAN_IPIFENABLE, (void *)&vChar);
	if(vChar==0)
	{
		va_cmd(IFCONFIG, 2, 1, "br0", "down");
		printf("Disable br0 interface\n");
	}
	//eth0 interface enable or disable
	mib_get(CWMP_LAN_ETHIFENABLE, (void *)&vChar);		
	if(vChar==0)
	{
		va_cmd(IFCONFIG, 2, 1, "eth0", "down");
		printf("Disable eth0 interface\n");
	}

	cwmpsetfirewall();
/*
	mib_get(CWMP_CONREQ_ENABLE, (void *)&vChar);
	if(vChar==1){
		mib_get(CWMP_CONREQ_PORT, (void *)&conreq_port);
		if(conreq_port==0) conreq_port=7547;
		sprintf(strPort, "%u", conreq_port );
		va_cmd(IPTABLES, 15, 1, ARG_T, "mangle", "-A", (char *)FW_PREROUTING,
			(char *)ARG_I, "!", (char *)LANIF, "-p", (char *)ARG_TCP,
			(char *)FW_DPORT, strPort, "-j", (char *)"MARK", "--set-mark", RMACC_MARK);
	}
/*

	sprintf(strPort, "%u", 30005 );
	va_cmd(IPTABLES, 15, 1, ARG_T, "mangle", "-A", (char *)FW_PREROUTING,
		(char *)ARG_I, "!", (char *)LANIF, "-p", (char *)ARG_TCP,
		(char *)FW_DPORT, strPort, "-j", (char *)"MARK", "--set-mark", RMACC_MARK);
#ifdef CONFIG_MIDDLEWARE
	sprintf(strPort, "%u", 9080 );
	va_cmd(IPTABLES, 15, 1, ARG_T, "mangle", "-A", (char *)FW_PREROUTING,
		(char *)ARG_I, "!", (char *)LANIF, "-p", (char *)ARG_TCP,
		(char *)FW_DPORT, strPort, "-j", (char *)"MARK", "--set-mark", RMACC_MARK);
#endif
*/
	/*start the cwmpClient program*/
#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
	mib_get(MIB_CWMP_AUTORUN, (void *)&vChar);
	if(vChar==1)
		va_cmd( "/bin/cwmpClient", 0, 0 );
#else
#if 1
	mib_get(CWMP_FLAG, (void *)&vChar);
	if( vChar&CWMP_FLAG_AUTORUN ){
#ifdef CTC_WAN_NAME
		set_acsurl_route_fw(1);
#endif
		va_cmd( "/bin/cwmpClient", 0, 0 );
	}
#ifdef CONFIG_MIDDLEWARE
	mib_get(CWMP_TR069_ENABLE,(void *)&vChar);	//CWMP_TR069_ENABLE: 0-run midware;1-run normal tr069
	if(vChar == 0){
		if(read_pid((char*)MWINTF_MAIN_RUNFILE) <= 0){ //midware interface is not started
			va_cmd( "/bin/midware_intf", 0, 0 );
		}
	}
#endif
#else
	mib_get(CWMP_NO_DEBUG_MSG, (void *)&vChar);
	if( vChar==1 )
		va_cmd( "/bin/cwmpClient", 2, 0, "-Delay", "-NoDebugMsg" );
	else
		va_cmd( "/bin/cwmpClient", 1, 0, "-Delay" );
#endif
#endif
	return 0;
}
#endif
static char open_adsl_drv(void)
{
	if ((adslFp = fopen(adslDevice, "r")) == NULL) {
		printf("ERROR: failed to open %s, error(%s)\n",adslDevice, strerror(errno));
		return 0;
	};
	return 1;
}

static void close_adsl_drv(void)
{
	if(adslFp)
		fclose(adslFp);

	adslFp = NULL;
}

char adsl_drv_get(unsigned int id, void *rValue, unsigned int len)
{
#ifdef EMBED
	if(open_adsl_drv()) {
		obcif_arg	myarg;
	    	myarg.argsize = (int) len;
	    	myarg.arg = (int) (rValue);

		if (ioctl(fileno(adslFp), id, &myarg) < 0) {
//	    	        printf("ADSL ioctl failed! id=%x\n",id );
			close_adsl_drv();
			return 0;
	       };

		close_adsl_drv();
		return 1;
	}
#endif
	return 0;
}

int getMIB2Str(unsigned int id, char *strbuf)
{
	unsigned char buffer[64];
	
	if (!strbuf)
		return -1;
	
	switch (id) {
		// INET address
		case MIB_ADSL_LAN_IP:
		case MIB_ADSL_LAN_SUBNET:
		case MIB_ADSL_LAN_IP2:
		case MIB_ADSL_LAN_SUBNET2:
		case MIB_ADSL_WAN_DNS1:
		case MIB_ADSL_WAN_DNS2:
		case MIB_ADSL_WAN_DNS3:
		case MIB_ADSL_WAN_DHCPS:
		case MIB_DMZ_IP:
		case MIB_SNMP_TRAP_IP:
		case MIB_DHCP_POOL_START:
		case MIB_DHCP_POOL_END:
		case MIB_DHCPS_DNS1:
		case MIB_DHCPS_DNS2:
		case MIB_DHCPS_DNS3:
#ifdef AUTO_PROVISIONING
		case MIB_HTTP_SERVER_IP:
#endif
#ifdef WLAN_1x
		case MIB_WLAN_RS_IP:
#endif
#if defined(ZTE_GENERAL_ROUTER_SC) || defined(TIME_ZONE)
		case MIB_NTP_SERVER_IP1:
		case MIB_NTP_SERVER_IP2:
#endif
		case MIB_ADSL_LAN_DHCP_GATEWAY:
#if 1
#if defined(_PRMT_X_CT_COM_DHCP_)||defined(IP_BASED_CLIENT_TYPE)
		case CWMP_CT_STB_MINADDR:
		case CWMP_CT_STB_MAXADDR:
		case CWMP_CT_PHN_MINADDR:
		case CWMP_CT_PHN_MAXADDR:
		case CWMP_CT_CMR_MINADDR:
		case CWMP_CT_CMR_MAXADDR:
		case CWMP_CT_PC_MINADDR:
		case CWMP_CT_PC_MAXADDR:
		case CWMP_CT_HGW_MINADDR:
		case CWMP_CT_HGW_MAXADDR:             
#endif //_PRMT_X_CT_COM_DHCP_		
#endif

#ifdef ADDRESS_MAPPING
#ifndef MULTI_ADDRESS_MAPPING
		case MIB_LOCAL_START_IP:
		case MIB_LOCAL_END_IP:
		case MIB_GLOBAL_START_IP:
		case MIB_GLOBAL_END_IP:
#endif //end of !MULTI_ADDRESS_MAPPING			
#endif	
#ifdef SYSLOG_SUPPORT
#ifdef SEND_LOG
		case MIB_LOG_SERVER_IP:
#endif
#endif
			if(!mib_get( id, (void *)buffer))
				return -1;
			// Mason Yu
			if ( ((struct in_addr *)buffer)->s_addr == INADDR_NONE ) {
				sprintf(strbuf, "%s", "");				
			} else {	
				sprintf(strbuf, "%s", inet_ntoa(*((struct in_addr *)buffer)));
			}			
			break;
		// Ethernet address
		case MIB_ELAN_MAC_ADDR:
		case MIB_WLAN_MAC_ADDR:
			if(!mib_get( id,  (void *)buffer))
				return -1;
			#if defined(ZTE_531B_BRIDGE_SC)||defined(ZTE_GENERAL_ROUTER_SC)
			sprintf(strbuf, "%02x-%02x-%02x-%02x-%02x-%02x", buffer[0], buffer[1],						
				buffer[2], buffer[3], buffer[4], buffer[5]);
			#else
			sprintf(strbuf, "%02x%02x%02x%02x%02x%02x", buffer[0], buffer[1],						
				buffer[2], buffer[3], buffer[4], buffer[5]);
			#endif
			break;
		// Char
		case MIB_ADSL_LAN_CLIENT_START:
		case MIB_ADSL_LAN_CLIENT_END:
		case MIB_IGMP_PROXY_ITF:
//#ifdef CONFIG_USER_UPNPD
#if defined(CONFIG_USER_UPNPD)||defined(CONFIG_USER_MINIUPNPD)		
		case MIB_UPNP_EXT_ITF:
#endif		
#ifdef IP_PASSTHROUGH
		case MIB_IPPT_ITF:
#endif
#ifdef WLAN_SUPPORT
		case MIB_WLAN_CHAN_NUM:
		case MIB_WLAN_DISABLED:

		// andrew. 2007/05/10
		case MIB_WLAN_ENABLE_1X:
		case MIB_WLAN_ENCRYPT:
		case MIB_WLAN_WPA_AUTH:
		case MIB_WLAN_NETWORK_TYPE:

#ifdef WLAN_WDS
		case MIB_WLAN_WDS_ENABLED:
#endif
		case MIB_WLAN_MODE:
#ifdef WLAN_QoS
		case MIB_WLAN_QoS:
#endif

#ifdef CONFIG_WIFI_SIMPLE_CONFIG // WPS
		case MIB_WSC_DISABLE:
		case MIB_WSC_CONFIGURED:
		case MIB_WSC_AUTH:
		case MIB_WSC_ENC:
		case MIB_WSC_PSK:
		case MIB_WSC_SSID:
#endif
#endif
#if 0
#if defined(_PRMT_X_CT_COM_DHCP_)||defined(IP_BASED_CLIENT_TYPE)
		case CWMP_CT_STB_MINADDR:
		case CWMP_CT_STB_MAXADDR:
		case CWMP_CT_PHN_MINADDR:
		case CWMP_CT_PHN_MAXADDR:
		case CWMP_CT_CMR_MINADDR:
		case CWMP_CT_CMR_MAXADDR:
		case CWMP_CT_PC_MINADDR:
		case CWMP_CT_PC_MAXADDR:
		case CWMP_CT_HGW_MINADDR:
		case CWMP_CT_HGW_MAXADDR:            
#endif //_PRMT_X_CT_COM_DHCP_
#endif
			if(!mib_get( id,  (void *)buffer))
				return -1;
	   		sprintf(strbuf, "%u", *(unsigned char *)buffer); 
	   		break;
	   	// Short
	   	case MIB_BRCTL_AGEINGTIME:
#ifdef WLAN_SUPPORT
	   	case MIB_WLAN_FRAG_THRESHOLD:
	   	case MIB_WLAN_RTS_THRESHOLD:
	   	case MIB_WLAN_BEACON_INTERVAL:
#ifdef WLAN_1x
	   	case MIB_WLAN_RS_PORT:
#endif
#endif
			if(!mib_get( id,  (void *)buffer))
				return -1;
			sprintf(strbuf, "%u", *(unsigned short *)buffer);
			break;
	   	// Interger
		case MIB_ADSL_LAN_DHCP_LEASE:
		
			// Mason Yu
			if(!mib_get( id,  (void *)buffer))
				return -1;			
			// if MIB_ADSL_LAN_DHCP_LEASE=0xffffffff, it indicate an infinate lease
			if ( *(unsigned long *)buffer == 0xffffffff )
				sprintf(strbuf, "-1");
			else						
				sprintf(strbuf, "%u", *(unsigned int *)buffer);
			break;
#ifdef IP_PASSTHROUGH
		case MIB_IPPT_LEASE:
#endif
		case MIB_MAXLOGLEN:
#ifdef _CWMP_MIB_
		case CWMP_INFORM_INTERVAL:
#endif
#ifdef DOS_SUPPORT
		case MIB_DOS_SYSSYN_FLOOD:
		case MIB_DOS_SYSFIN_FLOOD:
		case MIB_DOS_SYSUDP_FLOOD:
		case MIB_DOS_SYSICMP_FLOOD:
		case MIB_DOS_PIPSYN_FLOOD:
		case MIB_DOS_PIPFIN_FLOOD:
		case MIB_DOS_PIPUDP_FLOOD:
		case MIB_DOS_PIPICMP_FLOOD:
		case MIB_DOS_BLOCK_TIME:
#endif
#ifdef TCP_UDP_CONN_LIMIT
		case MIB_CONNLIMIT_UDP:
		case MIB_CONNLIMIT_TCP:
#endif 
#ifdef _CWMP_MIB_
		case CWMP_CONREQ_PORT:
#endif
#ifdef CONFIG_MIDDLEWARE
		case CWMP_MIDWARE_SERVER_PORT:
#endif
			if(!mib_get( id,  (void *)buffer))
				return -1;
			sprintf(strbuf, "%u", *(unsigned int *)buffer);
			break;
		// String
		case MIB_NTP_SERVER_HOST1:
		case MIB_NTP_SERVER_HOST2:
		case MIB_ADSL_LAN_DHCP_DOMAIN:
		case MIB_SNMP_SYS_NAME:
		case MIB_SNMP_SYS_DESCR:
		case MIB_SNMP_SYS_CONTACT:
		case MIB_SNMP_SYS_LOCATION:
		case MIB_SNMP_SYS_OID:
		case MIB_SNMP_COMM_RO:
		case MIB_SNMP_COMM_RW:
#ifdef WLAN_SUPPORT
		case MIB_WLAN_SSID:
#ifdef WLAN_1x
		case MIB_WLAN_RS_PASSWORD:
#endif
#endif
#ifdef AUTO_PROVISIONING
		case MIB_CONFIG_VERSION:
#endif
#if defined(TIME_ZONE) || defined(ZTE_GENERAL_ROUTER_SC)
		case MIB_NTP_TIMEZONE:
#endif
#ifdef ZTE_GENERAL_ROUTER_SC
		case MIB_NTP_ENABLED:
		case MIB_NTP_SERVER_ID:
#endif
#ifdef _CWMP_MIB_
		case CWMP_PROVISIONINGCODE:
		case CWMP_ACS_URL:
#ifdef CTC_WAN_NAME
		case CWMP_ACS_URL_OLD:
#endif
		case CWMP_ACS_USERNAME:
		case CWMP_ACS_PASSWORD:
		case CWMP_CONREQ_USERNAME:
		case CWMP_CONREQ_PASSWORD:
		case CWMP_CONREQ_PATH:
		case CWMP_LAN_CONFIGPASSWD:
		case CWMP_SERIALNUMBER:
		case CWMP_DL_COMMANDKEY:
		case CWMP_RB_COMMANDKEY:
		case CWMP_ACS_PARAMETERKEY:
		case CWMP_CERT_PASSWORD:
#ifdef _PRMT_USERINTERFACE_
		case UIF_AUTOUPDATESERVER:
		case UIF_USERUPDATESERVER:
#endif
		case CWMP_SI_COMMANDKEY:
		case CWMP_ACS_KICKURL:
		case CWMP_ACS_DOWNLOADURL:
//#ifdef _PRMT_X_CT_COM_ACCOUNT_
//		case CWMP_CT_ACC_USERNAME:
//		case CWMP_CT_ACC_PASSWORD:
//#endif
#ifdef _PRMT_X_CT_COM_PORTALMNT_
		case MIB_FP_PC_ADDR:
		case MIB_FP_STB_ADDR:
		case MIB_FP_MOB_ADDR:
#endif
#endif
#ifdef CONFIG_WIFI_SIMPLE_CONFIG //WPS
		case MIB_WSC_PIN:
#endif
#ifdef SYSLOG_SUPPORT
#ifdef SEND_LOG
		case MIB_LOG_SERVER_NAME:
#endif
#endif
#ifdef CONFIG_MIDDLEWARE
		case CWMP_MIDWARE_SERVER_ADDR:
#endif
#ifdef FTP_ACCOUNT_INDEPENDENT
		case MIB_FTP_USER:
		case MIB_FTP_PASSWD:
#endif
#ifdef TELNET_ACCOUNT_INDEPENDENT
		case MIB_TELNET_USER:
		case MIB_TELNET_PASSWD:
#endif
			if(!mib_get( id,  (void *)strbuf)){
				return -1;
			}
			break;		
			
		default:
			return -1;
	}
	
	return 0;		
}

int getSYS2Str(SYSID_T id, char *strbuf)
{
	unsigned char buffer[128], vChar;
	struct sysinfo info;
	int updays, uphours, upminutes, len, i;
	time_t tm;
	struct tm tm_time, *ptm_time;
	FILE *fp;
	unsigned char tmpBuf[64], *pStr;
	unsigned short vUShort;
	
	if (!strbuf)
		return -1;
	
	strbuf[0] = '\0';
	
	switch (id) {
		case SYS_UPTIME:
			sysinfo(&info);
			updays = (int) info.uptime / (60*60*24);
			if (updays)
				sprintf(strbuf, "%d day%s, ", updays, (updays != 1) ? "s" : "");
			len = strlen(strbuf);
			upminutes = (int) info.uptime / 60;
			uphours = (upminutes / 60) % 24;
			upminutes %= 60;
			if(uphours)
				sprintf(&strbuf[len], "%2d:%02d", uphours, upminutes);
			else
				sprintf(&strbuf[len], "%d min", upminutes);
			break;
		case SYS_DATE:
	 		time(&tm);
			memcpy(&tm_time, localtime(&tm), sizeof(tm_time));
			strftime(strbuf, 200, "%a %b %e %H:%M:%S %Z %Y", &tm_time);
			break;
		case SYS_YEAR:
	 		time(&tm);
			ptm_time = localtime(&tm);
			snprintf(strbuf, 64, "%d", (ptm_time->tm_year+ 1900));
			break;
		case SYS_MONTH:
	 		time(&tm);
			ptm_time = localtime(&tm);
			snprintf(strbuf, 64, "%d", (ptm_time->tm_mon+ 1));
			break;
		case SYS_DAY:
	 		time(&tm);
			ptm_time = localtime(&tm);
			snprintf(strbuf, 64, "%d", (ptm_time->tm_mday));
			break;
		case SYS_HOUR:
	 		time(&tm);
			ptm_time = localtime(&tm);
			snprintf(strbuf, 64, "%d", (ptm_time->tm_hour));
			break;
		case SYS_MINUTE:
	 		time(&tm);
			ptm_time = localtime(&tm);
			snprintf(strbuf, 64, "%d", (ptm_time->tm_min));
			break;
		case SYS_SECOND:
	 		time(&tm);
			ptm_time = localtime(&tm);
			snprintf(strbuf, 64, "%d", (ptm_time->tm_sec));
			break;
		case SYS_FWVERSION:
			#ifdef EMBED
			tmpBuf[0]=0;
			pStr = 0;
			fp = fopen("/etc/version", "r");
			if (fp!=NULL) {
				fgets(tmpBuf, sizeof(tmpBuf), fp);  //main version
				fclose(fp);
				pStr = strchr(tmpBuf, ' ');
				*pStr=0;
			#if 0
				fp = fopen("/proc/version", "r");  
				if (fp!=NULL) {  //build number
					int i;
					fgets(buffer, sizeof(buffer), fp);
					fclose(fp);
					pStr = strchr(buffer, '#');
					if (pStr!=NULL) {
						pStr++; i=0;
						while (pStr[i]!=' ') i++;
						pStr[i]=0;
					} else {
						pStr = buffer;
						buffer[0]=0;
					};
				}
			#endif
			};
			//sprintf(strbuf, "%s.%s", tmpBuf, pStr);
			sprintf(strbuf, "%s", tmpBuf);
			#else
			sprintf(strbuf, "%s.%s", "Realtek", "1");
			#endif
			break;
		case SYS_LAN_DHCP:
			if ( !mib_get( MIB_DHCP_MODE, (void *)buffer) )
				return -1;
			if (DHCP_LAN_SERVER == buffer[0])
				strcpy(strbuf, STR_ENABLE);
			else
				strcpy(strbuf, STR_DISABLE);
			break;
		case SYS_DHCP_LAN_IP:
#ifdef SECONDARY_IP
			mib_get(MIB_ADSL_LAN_ENABLE_IP2, (void *)&vChar);
			if (vChar)
				mib_get(MIB_ADSL_LAN_DHCP_POOLUSE, (void *)&vChar);
#else
			vChar = 0;
#endif
			if (vChar == 0) // primary LAN
				getMIB2Str(MIB_ADSL_LAN_IP, strbuf);
			else // secondary LAN
				getMIB2Str(MIB_ADSL_LAN_IP2, strbuf);
			break;
		case SYS_DHCP_LAN_SUBNET:
#ifdef SECONDARY_IP
			mib_get(MIB_ADSL_LAN_ENABLE_IP2, (void *)&vChar);
			if (vChar)
				mib_get(MIB_ADSL_LAN_DHCP_POOLUSE, (void *)&vChar);
#else
			vChar = 0;
#endif
			if (vChar == 0) // primary LAN
				getMIB2Str(MIB_ADSL_LAN_SUBNET, strbuf);
			else // secondary LAN
				getMIB2Str(MIB_ADSL_LAN_SUBNET2, strbuf);
			break;
			// Kaohj
		case SYS_DHCPS_IPPOOL_PREFIX:
#ifdef SECONDARY_IP
			mib_get(MIB_ADSL_LAN_ENABLE_IP2, (void *)&vChar);
			if (vChar)
				mib_get(MIB_ADSL_LAN_DHCP_POOLUSE, (void *)&vChar);
#else
			vChar = 0;
#endif
			if (vChar == 0) // primary LAN
				mib_get(MIB_ADSL_LAN_IP, (void *)&tmpBuf[0]) ;
				//getMIB2Str(MIB_ADSL_LAN_IP, strbuf);
			else // secondary LAN
				mib_get(MIB_ADSL_LAN_IP2, (void *)&tmpBuf[0]) ;
				//getMIB2Str(MIB_ADSL_LAN_IP2, strbuf);
			pStr = tmpBuf;
			sprintf(strbuf, "%d.%d.%d.", pStr[0], pStr[1], pStr[2]);
			break;
#ifdef WLAN_SUPPORT
		case SYS_WLAN:
			if ( !mib_get( MIB_WLAN_DISABLED, (void *)buffer) )
				return -1;
			if (0 == buffer[0])
				strcpy(strbuf, STR_ENABLE);
			else
				strcpy(strbuf, STR_DISABLE);
			break;
		case SYS_WLAN_BCASTSSID:
			if ( !mib_get( MIB_WLAN_HIDDEN_SSID, (void *)buffer) )
				return -1;
			if (0 == buffer[0])
				strcpy(strbuf, STR_ENABLE);
			else
				strcpy(strbuf, STR_DISABLE);
			break;
		case SYS_WLAN_BAND:
			if ( !mib_get( MIB_WLAN_BAND, (void *)buffer) )
				return -1;
			strcpy(strbuf, wlan_band[(BAND_TYPE_T)buffer[0]]);
			break;
		case SYS_WLAN_AUTH:
			if ( !mib_get( MIB_WLAN_AUTH_TYPE, (void *)buffer) )
				return -1;
			strcpy(strbuf, wlan_auth[(AUTH_TYPE_T)buffer[0]]);
			break;
		case SYS_WLAN_PREAMBLE:
			if ( !mib_get( MIB_WLAN_PREAMBLE_TYPE, (void *)buffer) )
				return -1;
			strcpy(strbuf, wlan_preamble[(PREAMBLE_T)buffer[0]]);
			break;
		case SYS_WLAN_ENCRYPT:
			if ( !mib_get( MIB_WLAN_ENCRYPT, (void *)buffer) )
				return -1;
#ifdef ENABLE_WPAAES_WPA2TKIP
			if(buffer[0] == ENCRYPT_WPA){
				mib_get( MIB_WLAN_WPA_CIPHER_SUITE, &vChar);
				if(vChar == WPA_CIPHER_AES)
					buffer[0] = 3;
				else
					buffer[0] = 2;
			}else if(buffer[0] == ENCRYPT_WPA2){
				mib_get( MIB_WLAN_WPA2_CIPHER_SUITE, &vChar);
				if(vChar == WPA_CIPHER_TKIP)
					buffer[0] = 5;
				else
					buffer[0] = 4;
			}else
				buffer[0] = 6;
#else
			if (buffer[0] == ENCRYPT_WPA2)
				buffer[0] = 3;
			else if (buffer[0] == ENCRYPT_WPA2_MIXED)
				buffer[0] = 4;
#endif
			strcpy(strbuf, wlan_encrypt[(ENCRYPT_T)buffer[0]]);
			break;
		case SYS_WLAN_PSKFMT:
			if ( !mib_get( MIB_WLAN_WPA_PSK_FORMAT, (void *)buffer) )
				return -1;
			strcpy(strbuf, wlan_pskfmt[buffer[0]]);
			break;
		case SYS_WLAN_PSKVAL:
			if ( !mib_get( MIB_WLAN_WPA_PSK, (void *)buffer) )
				return -1;
			for (len=0; len<strlen(buffer); len++)
				strbuf[len]='*';
			strbuf[len]='\0';
			break;
		case SYS_WLAN_WEP_KEYLEN:
			if ( !mib_get( MIB_WLAN_WEP, (void *)buffer) )
				return -1;
			strcpy(strbuf, wlan_wepkeylen[buffer[0]]);
			break;
		case SYS_WLAN_WEP_KEYFMT:
			if ( !mib_get( MIB_WLAN_WEP_KEY_TYPE, (void *)buffer) )
				return -1;
			strcpy(strbuf, wlan_wepkeyfmt[buffer[0]]);
			break;
		// Added by Jenny	
		case SYS_TX_POWER:
			if ( !mib_get( MIB_TX_POWER, (void *)&buffer) )
				return -1;
//add by xlyue to support ZTE more power requirement
//#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
#ifdef WLAN_TX_POWER_DISPLAY
			if (0 == buffer[0])
				strcpy(strbuf, "100%");
			else if(1 == buffer[0])
				strcpy(strbuf, "80%");
			else if(2 == buffer[0])
				strcpy(strbuf, "50%");
			else if(3 == buffer[0])
				strcpy(strbuf, "25%");
			else if(4 == buffer[0])
				strcpy(strbuf, "10%");
#else
			if (0 == buffer[0])
				strcpy(strbuf, "15 mW");
			else if(1 == buffer[0])
				strcpy(strbuf, "30 mW");
			else if(2 == buffer[0])
				strcpy(strbuf, "60 mW");
#endif
			break;	
		case SYS_WLAN_MODE:
			if ( !mib_get( MIB_WLAN_MODE, (void *)&buffer) )
				return -1;
			strcpy(strbuf, wlan_mode[(WLAN_MODE_T)buffer[0]]);
			break;	
		case SYS_WLAN_TXRATE:
			if ( !mib_get( MIB_WLAN_RATE_ADAPTIVE_ENABLED, (void *)&buffer) )
				return -1;
			if (0 == buffer[0]){
				if ( !mib_get( MIB_WLAN_FIX_RATE, (void *)&vUShort) )
					return -1;
				for (i=0; i<12; i++)
					if (1<<i == vUShort)
						strcpy(strbuf, wlan_rate[i]);
			}
			else if (1 == buffer[0])
				strcpy(strbuf, STR_AUTO);
			break;
		case SYS_WLAN_BLOCKRELAY:
			if ( !mib_get( MIB_WLAN_BLOCK_RELAY, (void *)buffer) )
				return -1;
			if (0 == buffer[0])
				strcpy(strbuf, STR_DISABLE);
			else
				strcpy(strbuf, STR_ENABLE);
			break;
		case SYS_WLAN_BLOCK_ETH2WIR:
			if ( !mib_get( MIB_WLAN_BLOCK_ETH2WIR, (void *)buffer) )
				return -1;
			if (0 == buffer[0])
				strcpy(strbuf, STR_DISABLE);
			else
				strcpy(strbuf, STR_ENABLE);
			break;
		case SYS_WLAN_AC_ENABLED:
			if ( !mib_get( MIB_WLAN_AC_ENABLED, (void *)&buffer) )
				return -1;
			if (0 == buffer[0])
				strcpy(strbuf, STR_DISABLE);
			else if(1 == buffer[0])
				strcpy(strbuf, "Allow Listed");
			else if(2 == buffer[0])
				strcpy(strbuf, "Deny Listed");
			else
				strcpy(strbuf, STR_ERR);
			break;	
		case SYS_WLAN_WDS_ENABLED:
			if ( !mib_get( MIB_WLAN_WDS_ENABLED, (void *)buffer) )
				return -1;
			if (0 == buffer[0])
				strcpy(strbuf, STR_DISABLE);
			else
				strcpy(strbuf, STR_ENABLE);
			break;
#ifdef WLAN_QoS
		case SYS_WLAN_QoS:
			if ( !mib_get( MIB_WLAN_QoS, (void *)buffer) )
				return -1;
			if (0 == buffer[0])
				strcpy(strbuf, STR_DISABLE);
			else
				strcpy(strbuf, STR_ENABLE);
			break;
#endif			
#endif
		case SYS_DNS_MODE:
			if ( !mib_get( MIB_ADSL_WAN_DNS_MODE, (void *)buffer) )
				return -1;
			if (0 == buffer[0])
				strcpy(strbuf, STR_AUTO);
			else
				strcpy(strbuf, STR_MANUAL);
			break;
			
		case SYS_DHCP_MODE:
			if(!mib_get( MIB_DHCP_MODE, (void *)buffer) )
				return -1;
			strcpy(strbuf, dhcp_mode[(DHCP_TYPE_T)buffer[0]]);
			break;

		case SYS_IPF_OUT_ACTION:
			if(!mib_get(MIB_IPF_OUT_ACTION, (void *)buffer) ){
				return -1;
			}
			if (0 == buffer[0])
				strcpy(strbuf, "Deny");
			else if(1 == buffer[0])
				strcpy(strbuf, "Allow");
			else
				strcpy(strbuf, "err");
			break;			
			
		case SYS_DEFAULT_PORT_FW_ACTION:
			if(!mib_get(MIB_PORT_FW_ENABLE, (void *)buffer) ){
				return -1;
			}
			if (0 == buffer[0])
				strcpy(strbuf, "Disable");
			else if(1 == buffer[0])
				strcpy(strbuf, "Enable");
			else
				strcpy(strbuf, "err");
			break;	
#ifdef CONFIG_EXT_SWITCH
		case SYS_MP_MODE:
			if(!mib_get(MIB_MPMODE, (void *)buffer) ){
				return -1;
			}
			if (0 == buffer[0])
				strcpy(strbuf, "None");
			else if(1 == buffer[0])
				strcpy(strbuf, "Port Mapping");
			else if(2 == buffer[0])
				strcpy(strbuf, "Vlan Enable");
			else if(3 == buffer[0])
				strcpy(strbuf, "IP QoS");
			else if(4 == buffer[0])
				strcpy(strbuf, "IGMP Snooping");
			else
				strcpy(strbuf, "err");
			break;	


		// Added by Jenny
		case SYS_IGMP_SNOOPING:
			if(!mib_get( MIB_MPMODE, (void *)&vChar)) {
				return -1;
			}
			if ((vChar>>2)&0x01)
				strcpy(strbuf, STR_ENABLE);
			else if (((vChar>>2)&0x01) == 0)
				strcpy(strbuf, STR_DISABLE);
			else
				strcpy(strbuf, STR_ERR);
			break;
		case SYS_PORT_MAPPING:
			if(!mib_get( MIB_MPMODE, (void *)&vChar)) {
				return -1;
			}
			if (vChar&0x01)
				strcpy(strbuf, STR_ENABLE);
			else if ((vChar&0x01) == 0)
				strcpy(strbuf, STR_DISABLE);
			else
				strcpy(strbuf, STR_ERR);
			break;
		case SYS_IP_QOS:
			if(!mib_get( MIB_MPMODE, (void *)&vChar)) {
				return -1;
			}
			if ((vChar>>1)&0x01)
				strcpy(strbuf, STR_ENABLE);
			else if (((vChar>>1)&0x01) == 0)
				strcpy(strbuf, STR_DISABLE);
			else
				strcpy(strbuf, STR_ERR);
			break;
#endif
		
		// Added by Mason Yu	
		case SYS_IPF_IN_ACTION:
			if ( !mib_get( MIB_IPF_IN_ACTION, (void *)buffer) )
				return -1;
			if (0 == buffer[0])
				strcpy(strbuf, "Deny");
			else if(1 == buffer[0])
				strcpy(strbuf, "Allow");
			else
				strcpy(strbuf, "err");
			break;		
		
#ifdef SECONDARY_IP
		case SYS_LAN_IP2:
			if (!mib_get( MIB_ADSL_LAN_ENABLE_IP2, (void *)&vChar))
				return -1;
			if (vChar == 0)
				strcpy(strbuf, STR_DISABLE);
			else
				strcpy(strbuf, STR_ENABLE);
			break;

		case SYS_LAN_DHCP_POOLUSE:
			if (!mib_get( MIB_ADSL_LAN_DHCP_POOLUSE, (void *)&vChar))
				return -1;
			if (vChar == 0)
				strcpy(strbuf, "Primary LAN");
			else
				strcpy(strbuf, "Secondary LAN");
			break;
#endif
			
		default:
			return -1;
	}
	
	return 0;
}

int ifWanNum(const char *name) 
{   	
	int ifnum=0;
	unsigned int entryNum, i;
	MIB_CE_ATM_VC_T Entry;	
	int type;
	
	if ( !strcmp(name, "all") )
		type = 0;
	else if ( !strcmp(name, "rt") )
		type = 1;	// route interface
	else if ( !strcmp(name, "br") )
		type = 2;	// bridge interface
	else
		type = 1;	// default to route
	
	entryNum = mib_chain_total(MIB_ATM_VC_TBL);
	
	for (i=0; i<entryNum; i++) {
		if (!mib_chain_get(MIB_ATM_VC_TBL, i, (void *)&Entry))
		{  			
			return -1;
		}
		
		if (Entry.enable == 0)
			continue;
		
		if (type == 2) {
			if (Entry.cmode == ADSL_BR1483)
			{				
				ifnum++;
			}
		}
		else {  // rt or all (1 or 0)
			if (type == 1 && Entry.cmode == ADSL_BR1483)
				continue;
			
			ifnum++;
		}
	}
		
	return ifnum;
}

#ifdef WLAN_CLIENT
int getWlStaNum( char *interface, int *num )
{
    int skfd;
    unsigned short staNum;
    struct iwreq wrq;

    skfd = socket(AF_INET, SOCK_DGRAM, 0);

    /* Get wireless name */
    if ( iw_get_ext(skfd, interface, SIOCGIWNAME, &wrq) < 0)
      /* If no wireless name : no wireless extensions */
      return -1;

    wrq.u.data.pointer = (caddr_t)&staNum;
    wrq.u.data.length = sizeof(staNum);

    if (iw_get_ext(skfd, interface, SIOCGIWRTLSTANUM, &wrq) < 0)
	return -1;

    *num  = (int)staNum;

    close( skfd );

    return 0;
}

/////////////////////////////////////////////////////////////////////////////
int getWlSiteSurveyResult(char *interface, SS_STATUS_Tp pStatus )
{
    int skfd;
    struct iwreq wrq;

    skfd = socket(AF_INET, SOCK_DGRAM, 0);

    /* Get wireless name */
    if ( iw_get_ext(skfd, interface, SIOCGIWNAME, &wrq) < 0)
      /* If no wireless name : no wireless extensions */
        return -1;

    wrq.u.data.pointer = (caddr_t)pStatus;

    if ( pStatus->number == 0 )
    	wrq.u.data.length = sizeof(SS_STATUS_T);
    else
        wrq.u.data.length = sizeof(pStatus->number);

    if (iw_get_ext(skfd, interface, SIOCGIWRTLGETBSSDB, &wrq) < 0)
	return -1;

    close( skfd );

    return 0;
}

/////////////////////////////////////////////////////////////////////////////
int getWlJoinRequest(char *interface, pBssDscr pBss, unsigned char *res)
{
    int skfd;
    struct iwreq wrq;

    skfd = socket(AF_INET, SOCK_DGRAM, 0);

    /* Get wireless name */
    if ( iw_get_ext(skfd, interface, SIOCGIWNAME, &wrq) < 0)
      /* If no wireless name : no wireless extensions */
        return -1;

    wrq.u.data.pointer = (caddr_t)pBss;
    wrq.u.data.length = sizeof(BssDscr);

    if (iw_get_ext(skfd, interface, SIOCGIWRTLJOINREQ, &wrq) < 0)
	return -1;

    close( skfd );
    
    *res = wrq.u.data.pointer[0];

    return 0;
}

/////////////////////////////////////////////////////////////////////////////
int getWlJoinResult(char *interface, unsigned char *res)
{
    int skfd;
    struct iwreq wrq;

    skfd = socket(AF_INET, SOCK_DGRAM, 0);

    /* Get wireless name */
    if ( iw_get_ext(skfd, interface, SIOCGIWNAME, &wrq) < 0)
      /* If no wireless name : no wireless extensions */
        return -1;

    wrq.u.data.pointer = (caddr_t)res;
    wrq.u.data.length = 1;

    if (iw_get_ext(skfd, interface, SIOCGIWRTLJOINREQSTATUS, &wrq) < 0)
	return -1;

    close( skfd );

    return 0;
}



/////////////////////////////////////////////////////////////////////////////
int getWlSiteSurveyRequest(char *interface, int *pStatus)
{
    int skfd;
    struct iwreq wrq;
    unsigned char result;

    skfd = socket(AF_INET, SOCK_DGRAM, 0);

    /* Get wireless name */
    if ( iw_get_ext(skfd, interface, SIOCGIWNAME, &wrq) < 0)
      /* If no wireless name : no wireless extensions */
        return -1;

    wrq.u.data.pointer = (caddr_t)&result;
    wrq.u.data.length = sizeof(result);

    if (iw_get_ext(skfd, interface, SIOCGIWRTLSCANREQ, &wrq) < 0)
	return -1;

    close( skfd );

    if ( result == 0xff )
    	*pStatus = -1;
    else
	*pStatus = (int) result;

    return 0;
}

/////////////////////////////////////////////////////////////////////////////
int getWlBssInfo(char *interface, bss_info *pInfo)
{
    int skfd;
    struct iwreq wrq;

    skfd = socket(AF_INET, SOCK_DGRAM, 0);

    /* Get wireless name */
    if ( iw_get_ext(skfd, interface, SIOCGIWNAME, &wrq) < 0)
      /* If no wireless name : no wireless extensions */
        return -1;

    wrq.u.data.pointer = (caddr_t)pInfo;
    wrq.u.data.length = sizeof(bss_info);

    if (iw_get_ext(skfd, interface, SIOCGIWRTLGETBSSINFO, &wrq) < 0)
	return -1;

    close( skfd );

    return 0;
}
#endif	// of WLAN_CLIENT

#ifdef WLAN_WDS
/////////////////////////////////////////////////////////////////////////////
int getWdsInfo(char *interface, char *pInfo)
{

    int skfd;
    struct iwreq wrq;

    skfd = socket(AF_INET, SOCK_DGRAM, 0);

    /* Get wireless name */
    if ( iw_get_ext(skfd, interface, SIOCGIWNAME, &wrq) < 0)
      /* If no wireless name : no wireless extensions */
        return -1;

    wrq.u.data.pointer = (caddr_t)pInfo;
    wrq.u.data.length = MAX_WDS_NUM*sizeof(WDS_INFO_T);

    if (iw_get_ext(skfd, interface, SIOCGIWRTLGETWDSINFO, &wrq) < 0)
	return -1;

    close( skfd );

    return 0;
}

#endif


#ifdef NEW_ACC_CTL_IMPL
#define LOG_ACCESS_CONTROL_INFO   "500001:Access-blocked "
//direction: 1 from lan, 2 from wan, 3 from lan or wan...
//protocol: 1 TCP, 2 UDP, 3 ICMP...
//port:       tcp/udp port num.
#if 0
static void setupServiceRule(unsigned int direction, unsigned int protocol, unsigned int portStart, unsigned int portEnd)
{
	char prot[4][10]={{0}, { "TCP"}, { "UDP"}, { "ICMP"} };
#ifdef LOG_ON_IPTABLES_RULE		
	char loginfo[]=LOG_ACCESS_CONTROL_INFO;
#endif
	DOCMDINIT;
	if(protocol >3)
		return;
	if(direction&0x01)
	{
		if(protocol == 3) //ICMP
		{
			DOCMDARGVS(IPTABLES, DOWAIT, "-I %s  -i ! br0  -p %s --icmp-type echo-request -m limit --limit 1/s  -j ACCEPT",FW_INACC, prot[protocol]);
#ifdef LOG_ON_IPTABLES_RULE			
			DOCMDARGVS(IPTABLES, DOWAIT, "-I %s  -i ! br0  -p %s --icmp-type echo-request -m limit --limit 1/s  -j LOG --log-level 4 --log-prefix %s ",FW_INACC,prot[protocol], loginfo);
#endif
		}else
		{
			DOCMDARGVS(IPTABLES, DOWAIT, "-I %s  -i ! br0  -p %s --dport %u:%u -j ACCEPT",FW_INACC, prot[protocol], portStart, portEnd);
#ifdef LOG_ON_IPTABLES_RULE		
			DOCMDARGVS(IPTABLES, DOWAIT, "-I %s  -i ! br0  -p %s --dport %u:%u -j LOG --log-level 4 --log-prefix %s",FW_INACC,prot[protocol], portStart, portEnd, loginfo);
#endif
		}
	}
	if (direction & 0x02) {	// can LAN access
			//Lan side access allow default. 
	}else
	{
			//close telnet server on lan side
		if(protocol == 3) //ICMP
		{
			DOCMDARGVS(IPTABLES, DOWAIT, "-I %s  -i  br0  -p %s  -j DROP",FW_INACC, prot[protocol]);
#ifdef LOG_ON_IPTABLES_RULE		
			DOCMDARGVS(IPTABLES, DOWAIT, "-I %s  -i  br0  -p %s  -j LOG --log-level 4 --log-prefix %s ",FW_INACC,prot[protocol], loginfo);
#endif
		}else
		{
			DOCMDARGVS(IPTABLES, DOWAIT, "-I %s  -i  br0  -p %s --dport %u:%u -j DROP",FW_INACC, prot[protocol], portStart, portEnd);
#ifdef LOG_ON_IPTABLES_RULE		
			DOCMDARGVS(IPTABLES, DOWAIT, "-I %s  -i  br0  -p %s --dport %u:%u -j LOG --log-level 4 --log-prefix %s ",FW_INACC, prot[protocol], portStart, portEnd, loginfo);
#endif
		}
	}
}
#endif
void setupAccessControl(int reStart)
{
	int acc_nums;
	int cnt;
	MIB_CE_ACC_T accEntry={0};
	DOCMDINIT;
	acc_nums=mib_chain_total(MIB_ACC_TBL);
	if(acc_nums <=0)
	{
		printf("acc mib table null\n");
		return;
	}
	DOCMDARGVS(IPTABLES, DOWAIT, "-F %s",FW_INACC);
	va_cmd(IPTABLES, 11, 1, "-A", (char *)FW_INACC, 
		(char *)ARG_I, "!", LANIF, "-m", "mark", "--mark", RMACC_MARK, "-j", FW_ACCEPT);
	for(cnt=0; cnt < acc_nums; cnt++)
	{
		memset(&accEntry, 0, sizeof(accEntry));
		mib_chain_get(MIB_ACC_TBL, cnt, (void*)&accEntry);
		remote_access_modify(accEntry, 1);
	}
	return;
	
}
#endif

void remote_access_modify(  MIB_CE_ACC_T accEntry, int enable)
{
	//MIB_CE_ACC_Tp paccEntry;
	//MIB_CE_ACC_T accEntry;
	char *act;
	char strPort[8];
	int ret;
#ifdef LOG_ON_IPTABLES_RULE		
	char loginfo[]=LOG_ACCESS_CONTROL_INFO;
#endif
	DOCMDINIT;
	if (enable)
		act = (char *)"-I";
	else
		act = (char *)FW_DEL;
	
	//if (!mib_chain_get(MIB_ACC_TBL, 0, (void *)&accEntry))
	//	return;
	// telnet service: bring up by inetd
	#ifdef CONFIG_USER_TELNETD_TELNETD
	if (!(accEntry.telnet & 0x02)) {	//  LAN access block...
		// iptables -A inacc -i $LAN_IF -p TCP --dport 23 -j DROP
		va_cmd(IPTABLES, 10, 1, act, (char *)FW_INACC,
		(char *)ARG_I, (char *)LANIF, "-p", (char *)ARG_TCP,
		(char *)FW_DPORT, "23", "-j", (char *)FW_DROP);
	#ifdef LOG_ON_IPTABLES_RULE		
		DOCMDARGVS(IPTABLES, DOWAIT, "-I %s  -i  br0  -p TCP --dport 23  -j LOG --log-level 4 --log-prefix %s ",FW_INACC, loginfo);
	#endif
	}
	if (accEntry.telnet & 0x01) {	// can WAN access
		snprintf(strPort, sizeof(strPort)-1, "%u", accEntry.telnet_port);
		va_cmd(IPTABLES, 15, 1, ARG_T, "mangle", act, (char *)FW_PREROUTING,
		(char *)ARG_I, "!", (char *)LANIF, "-p", (char *)ARG_TCP,
		(char *)FW_DPORT, strPort, "-j", (char *)"MARK", "--set-mark", RMACC_MARK);

		// redirect if this is not standard port
		if (accEntry.telnet_port != 23) {
			ret = va_cmd(IPTABLES, 15, 1, "-t", "nat",
					(char *)act, (char *)FW_PREROUTING,
					(char *)ARG_I, "!", (char *)LANIF,
					"-p", ARG_TCP,
					(char *)FW_DPORT, strPort, "-j",
					"REDIRECT", "--to-ports", "23");
		}
	}else
	{
		// WAN ACCESS BLOCK .LOG IT
		#ifdef LOG_ON_IPTABLES_RULE		
			DOCMDARGVS(IPTABLES, DOWAIT, "-I %s  -i ! br0  -p tcp --dport %u -j LOG --log-level 4 --log-prefix %s",FW_INACC,accEntry.telnet_port, loginfo);
		#endif
	}
	#endif

	
	//#ifdef CONFIG_USER_FTPD_FTPD
	#if defined(CONFIG_USER_BFTPD_BFTPD) || defined(CONFIG_USER_FTPD_FTPD)

	// ftp service: bring up by inetd
	if (!(accEntry.ftp & 0x02)) {	// not LAN access
		// iptables -A inacc -i $LAN_IF -p TCP --dport 21 -j DROP
		va_cmd(IPTABLES, 10, 1, act, (char *)FW_INACC,
		(char *)ARG_I, (char *)LANIF, "-p", (char *)ARG_TCP,
		(char *)FW_DPORT, "21", "-j", (char *)FW_DROP);
	#ifdef LOG_ON_IPTABLES_RULE		
		DOCMDARGVS(IPTABLES, DOWAIT, "-I %s  -i  br0  -p TCP --dport 21  -j LOG --log-level 4 --log-prefix %s ",FW_INACC, loginfo);
	#endif		
	}
	if (accEntry.ftp & 0x01) {	// can WAN access
		snprintf(strPort, sizeof(strPort)-1, "%u", accEntry.ftp_port);
		va_cmd(IPTABLES, 15, 1, ARG_T, "mangle", act, (char *)FW_PREROUTING,
		(char *)ARG_I, "!", (char *)LANIF, "-p", (char *)ARG_TCP,
		(char *)FW_DPORT, strPort, "-j", (char *)"MARK", "--set-mark", RMACC_MARK);

		// redirect if this is not standard port
		if (accEntry.ftp_port != 21) {
			ret = va_cmd(IPTABLES, 15, 1, "-t", "nat",
					(char *)act, (char *)FW_PREROUTING,
					(char *)ARG_I, "!", (char *)LANIF,
					"-p", ARG_TCP,
					(char *)FW_DPORT, strPort, "-j",
					"REDIRECT", "--to-ports", "21");
		}
	}else
	{
		// WAN ACCESS BLOCK .LOG IT
		#ifdef LOG_ON_IPTABLES_RULE		
			DOCMDARGVS(IPTABLES, DOWAIT, "-I %s  -i ! br0  -p tcp --dport %u -j LOG --log-level 4 --log-prefix %s",FW_INACC,accEntry.ftp_port, loginfo);
		#endif		
	}
	#endif
	#ifdef CONFIG_USER_TFTPD_TFTPD

	// tftp service: bring up by inetd
	if (!(accEntry.tftp & 0x02)) {	// not LAN access
		// iptables -A inacc -i $LAN_IF -p UDP --dport 69 -j DROP
		va_cmd(IPTABLES, 10, 1, act, (char *)FW_INACC,
		(char *)ARG_I, (char *)LANIF, "-p", (char *)ARG_UDP,
		(char *)FW_DPORT, "69", "-j", (char *)FW_DROP);
	#ifdef LOG_ON_IPTABLES_RULE		
		DOCMDARGVS(IPTABLES, DOWAIT, "-I %s  -i  br0  -p UDP --dport 69  -j LOG --log-level 4 --log-prefix %s ",FW_INACC, loginfo);
	#endif
	}
	/*
	if (paccEntry->tftp & 0x02) {	// can LAN access
		// iptables -A INPUT -i $LAN_IF -p UDP --dport 69 -j ACCEPT
		va_cmd(IPTABLES, 10, 1, act, (char *)FW_INPUT,
		(char *)ARG_I, (char *)LANIF, "-p", (char *)ARG_UDP,
		(char *)FW_DPORT, "69", "-j", (char *)FW_ACCEPT);
	}
	*/
	if (accEntry.tftp & 0x01) {	// can WAN access
		// iptables -A inacc -i ! $LAN_IF -p UDP --dport 69 -j ACCEPT
		va_cmd(IPTABLES, 11, 1, act, (char *)FW_INACC,
		(char *)ARG_I, "!", (char *)LANIF, "-p", (char *)ARG_UDP,
		(char *)FW_DPORT, "69", "-j", (char *)FW_ACCEPT);
	}else
	{
		// WAN ACCESS BLOCK .LOG IT
		#ifdef LOG_ON_IPTABLES_RULE		
			DOCMDARGVS(IPTABLES, DOWAIT, "-I %s  -i ! br0  -p UDP --dport 69 -j LOG --log-level 4 --log-prefix %s",FW_INACC, loginfo);
		#endif	
	}
	#endif

	// HTTP service
	//if (paccEntry->web !=0) {	// have web server
		if (!(accEntry.web & 0x02)) {	// not LAN access
			// iptables -A inacc -i $LAN_IF -p TCP --dport 80 -j DROP
			va_cmd(IPTABLES, 10, 1, act, (char *)FW_INACC,
			(char *)ARG_I, (char *)LANIF, "-p", (char *)ARG_TCP,
			(char *)FW_DPORT, "80", "-j", (char *)FW_DROP);
		#ifdef LOG_ON_IPTABLES_RULE		
			DOCMDARGVS(IPTABLES, DOWAIT, "-I %s  -i  br0  -p TCP --dport 80  -j LOG --log-level 4 --log-prefix %s ",FW_INACC, loginfo);
		#endif			
		}
		/*
		if (paccEntry->web & 0x02) {	// can LAN access
			// iptables -A INPUT -i $LAN_IF -p TCP --dport 80 -j ACCEPT
			va_cmd(IPTABLES, 10, 1, act, (char *)FW_INPUT,
			(char *)ARG_I, (char *)LANIF, "-p", (char *)ARG_TCP,
			(char *)FW_DPORT, "80", "-j", (char *)FW_ACCEPT);
		}
		*/
		if (accEntry.web & 0x01) {	// can WAN access
			snprintf(strPort, sizeof(strPort)-1, "%u", accEntry.web_port);
			// iptables -A inacc -i ! $LAN_IF -p TCP --dport 80 -j ACCEPT
			va_cmd(IPTABLES, 15, 1, ARG_T, "mangle", act, (char *)FW_PREROUTING,
				(char *)ARG_I, "!", (char *)LANIF, "-p", (char *)ARG_TCP,
				(char *)FW_DPORT, strPort, "-j", (char *)"MARK", "--set-mark", RMACC_MARK);
			#if 0
			va_cmd(IPTABLES, 11, 1, act, (char *)FW_INACC,
			(char *)ARG_I, "!", (char *)LANIF, "-p", (char *)ARG_TCP,
			(char *)FW_DPORT, "80", "-j", (char *)FW_ACCEPT);
			#endif
			if (accEntry.web_port != 80) {
				va_cmd(IPTABLES, 15, 1, "-t", "nat",
					(char *)act, (char *)FW_PREROUTING,
					(char *)ARG_I, "!", (char *)LANIF,
					"-p", ARG_TCP,
					(char *)FW_DPORT, strPort, "-j",
					"REDIRECT", "--to-ports", "80");
			}

		}else
		{
			// WAN ACCESS BLOCK .LOG IT
			#ifdef LOG_ON_IPTABLES_RULE		
				DOCMDARGVS(IPTABLES, DOWAIT, "-I %s  -i ! br0  -p TCP --dport %u -j LOG --log-level 4 --log-prefix %s",FW_INACC, accEntry.web_port ,loginfo);
			#endif	
		}

  #ifdef CONFIG_USER_BOA_WITH_SSL
  	  //HTTPS service
		if (!(accEntry.https & 0x02)) {	// not LAN access
			// iptables -A inacc -i $LAN_IF -p TCP --dport 443 -j DROP
			va_cmd(IPTABLES, 10, 1, act, (char *)FW_INACC,
			(char *)ARG_I, (char *)LANIF, "-p", (char *)ARG_TCP,
			(char *)FW_DPORT, "443", "-j", (char *)FW_DROP);
		#ifdef LOG_ON_IPTABLES_RULE		
			DOCMDARGVS(IPTABLES, DOWAIT, "-I %s  -i  br0  -p TCP --dport 443  -j LOG --log-level 4 --log-prefix %s ",FW_INACC, loginfo);
		#endif				
		}
		if (accEntry.https & 0x01) {	// can WAN access
			snprintf(strPort, sizeof(strPort)-1, "%u", accEntry.https_port);
			// iptables -t mangle  -I PREROUTING -i !$LAN_IF -p TCP --dport 443 -j MARK --set-mark 0x1000
			va_cmd(IPTABLES, 15, 1, ARG_T, "mangle", act, (char *)FW_PREROUTING,
				(char *)ARG_I, "!", (char *)LANIF, "-p", (char *)ARG_TCP,
				(char *)FW_DPORT, strPort, "-j", (char *)"MARK", "--set-mark", RMACC_MARK);

			if (accEntry.https_port != 443) {
				va_cmd(IPTABLES, 15, 1, "-t", "nat",
					(char *)act, (char *)FW_PREROUTING,
					(char *)ARG_I, "!", (char *)LANIF,
					"-p", ARG_TCP,
					(char *)FW_DPORT, strPort, "-j",
					"REDIRECT", "--to-ports", "443");
			}

		}else
		{
					// WAN ACCESS BLOCK .LOG IT
			#ifdef LOG_ON_IPTABLES_RULE		
				DOCMDARGVS(IPTABLES, DOWAIT, "-I %s  -i ! br0  -p TCP --dport %u -j LOG --log-level 4 --log-prefix %s",FW_INACC, accEntry.https_port ,loginfo);
			#endif	
		}
  #endif
  #ifdef CONFIG_USER_SNMPD_SNMPD_V2CTRAP

	// snmp service
	//if (accEntry.snmp !=0) {	// have snmp server		
		if (!(accEntry.snmp & 0x02)) {	// not LAN access
			// iptables -A inacc -i $LAN_IF -p UDP --dport 161:162 -j DROP			
			va_cmd(IPTABLES, 10, 1, act, (char *)FW_INACC,
			(char *)ARG_I, (char *)LANIF, "-p", (char *)ARG_UDP,
			(char *)FW_DPORT, "161:162", "-j", (char *)FW_DROP);
		}
		/*
		if (paccEntry->snmp & 0x02) {	// can LAN access
			// iptables -A INPUT -i $LAN_IF -p UDP --dport 161:162 -j ACCEPT
			va_cmd(IPTABLES, 10, 1, act, (char *)FW_INPUT,
			(char *)ARG_I, (char *)LANIF, "-p", (char *)ARG_UDP,
			(char *)FW_DPORT, "161:162", "-j", (char *)FW_ACCEPT);
		}
		*/
		if (accEntry.snmp & 0x01) {	// can WAN access
			// iptables -A inacc -i ! $LAN_IF -p UDP --dport 161:162 -m limit
			//  --limit 100/s --limit-burst 500 -j ACCEPT
			va_cmd(IPTABLES, 17, 1, act, (char *)FW_INACC,
				(char *)ARG_I, "!", (char *)LANIF, "-p",
				(char *)ARG_UDP, (char *)FW_DPORT, "161:162", "-m",
				"limit", "--limit", "100/s", "--limit-burst",
				"500", "-j", (char *)FW_ACCEPT);
		}
	#endif
	#ifdef CONFIG_USER_SSH_DROPBEAR
	
	// ssh service
	//if (paccEntry->ssh !=0) {	// have ssh server
		if (!(accEntry.ssh & 0x02)) {	// not LAN access
			// iptables -A inacc -i $LAN_IF -p TCP --dport 22 -j DROP
			va_cmd(IPTABLES, 10, 1, act, (char *)FW_INACC,
			(char *)ARG_I, (char *)LANIF, "-p", (char *)ARG_TCP,
			(char *)FW_DPORT, "22", "-j", (char *)FW_DROP);
		}
		/*
		if (paccEntry->ssh & 0x02) {	// can LAN access
			// iptables -A INPUT -i $LAN_IF -p TCP --dport 22 -j ACCEPT
			va_cmd(IPTABLES, 10, 1, act, (char *)FW_INPUT,
			(char *)ARG_I, (char *)LANIF, "-p", (char *)ARG_TCP,
			(char *)FW_DPORT, "22", "-j", (char *)FW_ACCEPT);
		}
		*/
		if (accEntry.ssh & 0x01) {	// can WAN access
			// iptables -A inacc -i ! $LAN_IF -p TCP --dport 22 -j ACCEPT
			va_cmd(IPTABLES, 11, 1, act, (char *)FW_INACC,
			(char *)ARG_I, "!", (char *)LANIF, "-p", (char *)ARG_TCP,
			(char *)FW_DPORT, "22", "-j", (char *)FW_ACCEPT);
		}
	#endif
	//}
	
	// ping service
	if (accEntry.icmp & 0x01) // can WAN access
	{
		// iptables -A inacc -i ! $LAN_IF  -p ICMP --icmp-type echo-request -m limit
		//   --limit 1/s -j ACCEPT
		va_cmd(IPTABLES, 15, 1, act, (char *)FW_INACC,
			(char *)ARG_I, "!", (char *)LANIF, "-p", "ICMP",
			"--icmp-type", "echo-request", "-m", "limit",
			"--limit", "1/s", "-j", (char *)FW_ACCEPT);
	}else
	{
		// WAN ACCESS BLOCK .LOG IT
		#ifdef LOG_ON_IPTABLES_RULE		
			DOCMDARGVS(IPTABLES, DOWAIT, "-I %s  -i ! br0  -p ICMP --icmp-type echo-request -m limit --limit 1/s  -j LOG --log-level 4 --log-prefix %s ",FW_INACC,  loginfo);
		#endif	
	}
}

void filter_set_remote_access(int enable)
{
        #ifdef ZTE_GENERAL_ROUTER_SC
	int rmtacc_index=0;
	int rmtacc_nums=mib_chain_total(MIB_ACC_TBL);
	MIB_CE_ACC_T accEntry;
	if(!rmtacc_nums) return;
	for(rmtacc_index=0;rmtacc_index<rmtacc_nums;rmtacc_index++)
	{
	memset(&accEntry,'\0',sizeof(MIB_CE_ACC_T));
	mib_chain_get(MIB_ACC_TBL,rmtacc_index,&accEntry);	
	if(accEntry.protocol!=ADSL_BR1483)
	remote_access_modify( accEntry, enable );	
	}	
	#else
	MIB_CE_ACC_T accEntry;
	if (!mib_chain_get(MIB_ACC_TBL, 0, (void *)&accEntry))
		return;
	remote_access_modify( accEntry, enable );	
	#endif
	return;
	
}

#ifdef IP_ACL
void filter_set_acl(int enable)
{
	int i, total;
	struct in_addr src;		
	char ssrc[40];
	MIB_CE_ACL_IP_T Entry;

#ifdef ACL_IP_RANGE
	struct in_addr start,end;		
	char sstart[16],send[16];
#endif

#ifdef MAC_ACL
	MIB_CE_ACL_MAC_T MacEntry;
	char macaddr[18];
#endif

	
	// Added by Mason Yu for ACL.
	// check if ACL Capability is enabled ?
	if (!enable)
		va_cmd(IPTABLES, 2, 1, "-F", "aclblock");
	else {
		// Add policy to aclblock chain
		total = mib_chain_total(MIB_ACL_IP_TBL);
		for (i=0; i<total; i++) {
			if (!mib_chain_get(MIB_ACL_IP_TBL, i, (void *)&Entry))
			{  				
				return;
			}

//    		printf("\nstartip=%x,endip=%x\n",*(unsigned long*)Entry.startipAddr,*(unsigned long*)Entry.endipAddr);
			
			// Check if this entry is enabled
			if ( Entry.Enabled == 1 ) {		
#ifdef ACL_IP_RANGE
				start.s_addr = *(unsigned long*)Entry.startipAddr;
				end.s_addr = *(unsigned long*)Entry.endipAddr;
				strcpy(sstart, inet_ntoa(start));
				strcpy(send, inet_ntoa(end));
				strcpy(ssrc,sstart);
				strcat(ssrc,"-");
				strcat(ssrc,send);
	
#else
				src.s_addr = *(unsigned long *)Entry.ipAddr;
		        	
				// inet_ntoa is not reentrant, we have to
				// copy the static memory before reuse it
				strcpy(ssrc, inet_ntoa(src));
				snprintf(ssrc, 20, "%s/%d", ssrc, Entry.maskbit);

#endif	        	
		        	if ( Entry.Interface == IF_DOMAIN_LAN ) {
		 			
#ifdef ACL_IP_RANGE
					if(*(unsigned long*)Entry.startipAddr != *(unsigned long*)Entry.endipAddr) 
					// iptables -A aclblock -m iprange --src-range x.x.x.x-1x.x.x.x -j RETURN 
						va_cmd(IPTABLES, 10, 1, (char *)FW_ADD, "aclblock", "-i", "br0", "-m", "iprange", "--src-range", ssrc, "-j", (char *)FW_RETURN);
					else
						va_cmd(IPTABLES, 8, 1, (char *)FW_ADD, "aclblock", "-i", "br0", "-s", sstart, "-j", (char *)FW_RETURN);
#else
					// iptables -A INPUT -s xxx.xxx.xxx.xxx	
					va_cmd(IPTABLES, 8, 1, (char *)FW_ADD, "aclblock", "-i", "br0", "-s", ssrc, "-j", (char *)FW_RETURN);
#endif
				} else {
					// iptables -A INPUT -s xxx.xxx.xxx.xxx		
					va_cmd(IPTABLES, 9, 1, (char *)FW_ADD, "aclblock", "-i", "!", "br0", "-s", ssrc, "-j", (char *)FW_RETURN);
				}
			}
		}
#ifdef MAC_ACL
		total = mib_chain_total(MIB_ACL_MAC_TBL);
		for (i=0; i<total; i++) {
			if (!mib_chain_get(MIB_ACL_MAC_TBL, i, (void *)&MacEntry))
			{
				return;
			}
			
			// Check if this entry is enabled
			if ( MacEntry.Enabled == 1 ) {			
				snprintf(macaddr, 18, "%02x:%02x:%02x:%02x:%02x:%02x",
					MacEntry.macAddr[0], MacEntry.macAddr[1],
					MacEntry.macAddr[2], MacEntry.macAddr[3],
					MacEntry.macAddr[4], MacEntry.macAddr[5]);
		        	
		        if ( MacEntry.Interface == IF_DOMAIN_LAN ) {
		 			// iptables -A aclblock -i br0  -m mac --mac-source $MAC -j RETURN
					va_cmd(IPTABLES, 10, 1, (char *)FW_ADD, "aclblock",
							(char *)ARG_I, "br0", "-m", "mac",
							"--mac-source",  macaddr, "-j", (char *)FW_RETURN);	
				} else {
					// iptables -A aclblock -i ! br0  -m mac --mac-source $MAC -j RETURN
					va_cmd(IPTABLES, 11, 1, (char *)FW_ADD, "aclblock",
							(char *)ARG_I, "!", "br0", "-m", "mac",
							"--mac-source",  macaddr, "-j", (char *)FW_RETURN);	
				}
			}
		}
#endif

		// allowing DNS request during ACL enabled
		// iptables -A aclblock -p udp -i br0 --dport 53 -j RETURN			
		va_cmd(IPTABLES, 10, 1, (char *)FW_ADD, "aclblock", "-p", "udp", "-i", "br0",(char*)FW_DPORT, (char *)PORT_DNS, "-j", (char *)FW_RETURN);
		// allowing DHCP request during ACL enabled
		// iptables -A aclblock -p udp -i br0 --dport 67 -j RETURN	
		va_cmd(IPTABLES, 10, 1, (char *)FW_ADD, "aclblock", "-p", "udp", "-i", "br0", (char*)FW_DPORT, (char *)PORT_DHCP, "-j", (char *)FW_RETURN);
#ifndef ZTE_GENERAL_ROUTER_SC
		// ipbables -A aclblock -i !br0 -j RETURN
		// andrew, removed. We use White-List policy here. 2007/11/07
		//va_cmd(IPTABLES, 7, 1, (char *)FW_ADD, "aclblock", "-i", "!", "br0",  "-j", (char *)FW_RETURN);
#endif
		// iptables -A aclblock -j DROP			
		va_cmd(IPTABLES, 4, 1, (char *)FW_ADD, "aclblock", "-j", (char *)FW_DROP);
	}
}
#endif

#ifdef NAT_CONN_LIMIT
void set_conn_limit()
{
	int i, total;
	char ssrc[20];
	char connNum[10];
	MIB_CE_CONN_LIMIT_T Entry;
	
	// Add policy to connlimit chain
	//iptables -A connlimit -m state --state RELATED,ESTABLISHED -j RETURN
	va_cmd(IPTABLES, 8, 1, (char *)FW_ADD, "connlimit", "-m", "state",
		"--state", "ESTABLISHED,RELATED", "-j", (char *)FW_RETURN);
	
	total = mib_chain_total(MIB_CONN_LIMIT_TBL);
	for (i=0; i<total; i++) {
		if (!mib_chain_get(MIB_CONN_LIMIT_TBL, i, (void *)&Entry))
			continue;
				
		// Check if this entry is enabled
		if ( Entry.Enabled == 1 ) { 		
			// inet_ntoa is not reentrant, we have to
			// copy the static memory before reuse it
			strncpy(ssrc, inet_ntoa(*((struct in_addr *)&Entry.ipAddr)), 16);
			ssrc[15] = '\0';

			snprintf(connNum, 10, "%d", Entry.connNum);
			
			// iptables -A connlimit -i br0 -s xxx.xxx.xxx.xxx 	
			va_cmd(IPTABLES, 12, 1, (char *)FW_ADD, "connlimit", "-s", ssrc, "-m", "iplimit", 
				"--iplimit-above", connNum, "--iplimit-mask", "255.255.255.255", "-j", "REJECT");
		}
	}
}
#endif
#ifdef TCP_UDP_CONN_LIMIT
void set_conn_limit()
{
	int 					i, total;
	char 				ssrc[20];
	char 				connNum[10];
	MIB_TCP_UDP_CONN_LIMIT_T Entry;
	
	// Add policy to connlimit chain, allow all established ~
	//iptables -A connlimit -m state --state RELATED,ESTABLISHED -j RETURN
	va_cmd(IPTABLES, 8, 1, (char *)FW_ADD, "connlimit", "-m", "state",
		"--state", "ESTABLISHED,RELATED", "-j", (char *)FW_RETURN);
	
	total = mib_chain_total(MIB_TCP_UDP_CONN_LIMIT_TBL);
	for (i=0; i<total; i++) {
		if (!mib_chain_get(MIB_TCP_UDP_CONN_LIMIT_TBL, i, (void *)&Entry))
			continue;				
		// Check if this entry is enabled and protocol is TCP
		if (( Entry.Enabled == 1 ) && ( Entry.protocol == 0 )) { 		
			// inet_ntoa is not reentrant, we have to
			// copy the static memory before reuse it
			strncpy(ssrc, inet_ntoa(*((struct in_addr *)&Entry.ipAddr)), 16);
			ssrc[15] = '\0';
			snprintf(connNum, 10, "%d", Entry.connNum);
			
			// iptables -A connlimit -p tcp -s 192.168.1.99 -m iplimit --iplimit-above 2 -j REJECT
			va_cmd(IPTABLES, 12, 1, (char *)FW_ADD, "connlimit","-p","tcp", "-s", ssrc, "-m", "iplimit", 
				"--iplimit-above", connNum, "-j", "REJECT");			
		}
		// UDP
		else if  (( Entry.Enabled == 1 ) && ( Entry.protocol == 1 )) { 		
			strncpy(ssrc, inet_ntoa(*((struct in_addr *)&Entry.ipAddr)), 16);
			ssrc[15] = '\0';
			snprintf(connNum, 10, "%d", Entry.connNum);
			
			//iptables -A connlimit -p udp -s 192.168.1.99 -m udplimit --udplimit-above 2 -j REJECT
			va_cmd(IPTABLES, 12, 1, (char *)FW_ADD, "connlimit","-p","udp", "-s", ssrc, "-m", "udplimit", 
				"--udplimit-above", connNum, "-j", "REJECT");			
		}
			
	}

	//The Global rules goes last ~
	//TCP 
	mib_get(MIB_CONNLIMIT_TCP, (void *)&i);
	if (i >0)
	{
		snprintf(connNum, 10, "%d", i);
		va_cmd(IPTABLES, 10, 1, (char *)FW_ADD, "connlimit","-p","tcp",  "-m", "iplimit", 
					"--iplimit-above", connNum, "-j", "REJECT");	
	}
	//UDP
	mib_get(MIB_CONNLIMIT_UDP, (void *)&i);
	if (i >0)
	{
		snprintf(connNum, 10, "%d", i);
		va_cmd(IPTABLES, 10, 1, (char *)FW_ADD, "connlimit","-p","udp",  "-m", "udplimit", 
					"--udplimit-above", connNum, "-j", "REJECT");	
	}

}
#endif//TCP_UDP_CONN_LIMIT

#ifdef URL_BLOCKING_SUPPORT
void filter_set_url(int mode)
{
	int i, total;
	struct url_entryx entry;
	char portStr[6];

	va_cmd(IPTABLES, 2, 1, "-F", "urlblock");
	va_cmd(IPTABLES, 2, 1, "-F", "urlallow");

	if(1 == mode) {//blacklist
		printf("urlblock\n");
		// Add URL policy to urlblock chain
		total = mib_chain_total(MIB_URL_TBL);

		for (i=0; i<total; i++) {
			if (!mib_chain_get(MIB_URL_TBL, i, (void *)&entry))
				return;

			snprintf(portStr, 6, "%d", entry.port);
		 	// iptables -A urlblock -p tcp --dport 80 -m string --url "tw.yahoo.com" -j DROP
			va_cmd(IPTABLES, 12, 1, (char *)FW_ADD, "urlblock", "-p", "tcp", "--dport", 
				portStr, "-m", "string", "--url", entry.url, "-j", (char *)FW_DROP);
		}
	}
	else if (2 == mode) {//whitelist
		printf("urlallow\n");
		// Add URL policy to urlblock chain
		total = mib_chain_total(MIB_URL_TBL);

		for (i=0; i<total; i++) {
			if (!mib_chain_get(MIB_URL_TBL, i, (void *)&entry))
				return;

			snprintf(portStr, 6, "%d", entry.port);
			// iptables -A urlallow -p tcp --dport 80 -m string --url "tw.yahoo.com" -j ACCEPT
			va_cmd(IPTABLES, 12, 1, (char *)FW_ADD, "urlallow", "-p", "tcp", "--dport", 
				portStr, "-m", "string", "--urlalw", entry.url, "-j", (char *)FW_ACCEPT);		
		}
		//&endofurl& is flag for drop other urls
		va_cmd(IPTABLES, 10, 1, (char *)FW_ADD, "urlallow", "-p", "tcp", "-m", "string", 
			"--urlalw", "endofurl" ,"-j", (char *)FW_DROP);
	}
}
#endif

#ifdef DOMAIN_BLOCKING_SUPPORT
// Added by Mason Yu for Domain Blocking
void filter_set_domain(int enable)
{
	int i, total;	
	MIB_CE_DOMAIN_BLOCKING_T Entry;
	unsigned char sdest[MAX_DOMAIN_LENGTH];
	int j, k;
    	unsigned char *needle_tmp, *str;
    	char len[MAX_DOMAIN_GROUP];
    	unsigned char seg[MAX_DOMAIN_GROUP][MAX_DOMAIN_SUB_STRING];    	
    	unsigned char cmpStr[MAX_DOMAIN_LENGTH]="\0";
	
	// check if Domain Blocking Capability is enabled ?
	if (!enable)
		va_cmd(IPTABLES, 2, 1, "-F", "domainblk");
	else {
		// Add policy to domainblk chain
		total = mib_chain_total(MIB_DOMAIN_BLOCKING_TBL);
		for (i=0; i<total; i++) {
			if (!mib_chain_get(MIB_DOMAIN_BLOCKING_TBL, i, (void *)&Entry))
			{  				
				return;
			}			
			
			// Mason Yu
			// calculate domain sub string lengh and form the compare sub string.
			// Foe example, If the domain is aa.bbb.cccc, the compare sub string 1 is 0x02 0x61 0x61.
			// The compare sub string 2 is 0x03 0x62 0x62 0x62. The compare sub string 3 is 0x04 0x63 0x63 0x63 0x63.
			needle_tmp = Entry.domain;
			
			for (j=0; (str =strchr(needle_tmp, '.'))!= NULL; j++)
    			{    				
    				*str = '\0';
    					
    				strncpy(seg[j]+1, needle_tmp, (MAX_DOMAIN_SUB_STRING - 1));    				
    				seg[j][MAX_DOMAIN_SUB_STRING - 1]='\0';
    				//printf(" seg[%d]= %s...(1)\n", j, seg[j]);
    				
    				//seg[j][0]= len[j];
    				seg[j][0] = strlen(needle_tmp);
    				//printf(" seg[%d]= %s...(2)\n", j, seg[j]);
    	   	
    				needle_tmp = str+1;
   			}	
    			
    			// calculate the laster domain sub string lengh and form the laster compare sub string    					   			
    			strncpy(seg[j]+1, needle_tmp, (MAX_DOMAIN_SUB_STRING - 1));
    			seg[j][MAX_DOMAIN_SUB_STRING - 1]='\0';
    			
    			seg[j][0]= strlen(needle_tmp);    			
    			//printf(" seg[%d]= %s...(3)\n", j, seg[j]);    
    			
    			// Merge the all compare sub string into a final compare string.
    			for ( k=0; k<=j; k++) {    				  
    				//printf(" seg[%d]= %s", k, seg[k]);
    				strcat(cmpStr, seg[k]);
    				//printf(" cmpStr=%s\n", cmpStr);
    			}
    			//printf("\n");
		 		
		 	// iptables -A domainblk -p udp --dport 53 -m string --domain yahoo.com -j DROP	
			va_cmd(IPTABLES, 12, 1, (char *)FW_ADD, "domainblk", "-p", "udp", "--dport", "53", "-m", "string", "--domain", cmpStr, "-j", (char *)FW_DROP);
			cmpStr[0] = '\0';			
		}		
		
	}
}
#endif

#ifdef LAYER7_FILTER_SUPPORT
//star: the name is get from *.pat files of the folder user/iptables/l7-protocols
#define APPNUM  20
#define WEB_NAME_FLAG  1
#define FILTER_NAME_FLAG  0
typedef struct app_name_entry{
	unsigned char * filtername;
	unsigned char * webname;
}app_name_str;

app_name_str apply_name[APPNUM]={
{"qq","QQQQϷ"},
{"msnmessenger","MSN messenger"},
{"yahoo","Żͨ"},
{"bittorrent","BT"},
{"ourgame","Ϸ"},
{"gameabc","߷Ϸ"},
{"chinagame","йϷ"},
{"haofang","Ʒսƽ̨"},
{"smtp","ʼ"},
{"pop3","ʼ"},
{"unknown","unknown"},
NULL
};
void getappname(int appnum, unsigned char * appname, int flag)
{
	int num=0,i;

	for(i=0;i<APPNUM;i++)
	{
		if(!strcmp(apply_name[i].filtername,"unknown"))
			break;
		num++;	
	}

	if(flag == FILTER_NAME_FLAG){
		if((appnum <0) || (appnum >= num))
			snprintf(appname, MAX_APP_NAME, "%s", "unknown");
		else
			snprintf(appname, MAX_APP_NAME, "%s", apply_name[appnum].filtername);
	}

	if(flag == WEB_NAME_FLAG){
		for(i=0;i<num;i++){
			if(!strcmp(appname,apply_name[i].filtername)){
				snprintf(appname, 2*MAX_APP_NAME, "%s", apply_name[i].webname);
				break;
			}
		}
	}
		
	return;
		
}

#endif

#if defined(CONFIG_USER_ROUTED_ROUTED) || defined(CONFIG_USER_ZEBRA_OSPFD_OSPFD)
static const char ROUTED_CONF[] = "/var/run/routed.conf";

int startRip()
{
	FILE *fp;
	unsigned char ripOn, ripInf, ripVer;	
	int rip_pid;
	
	unsigned int entryNum, i;
	MIB_CE_RIP_T Entry;
	char ifname[6], version[5], operation[5];
	
	if (mib_get(MIB_RIP_ENABLE, (void *)&ripOn) == 0)
		ripOn = 0;	
	rip_pid = read_pid((char *)ROUTED_PID);
	if (rip_pid >= 1) {
		// kill it
		if (kill(rip_pid, SIGTERM) != 0) {
			printf("Could not kill pid '%d'", rip_pid);
		}
	}
	
	if (!ripOn)
		return 0;

	printf("start rip!\n");
	if ((fp = fopen(ROUTED_CONF, "w")) == NULL)
	{
		printf("Open file %s failed !\n", ROUTED_CONF);
		return -1;
	}
	
	entryNum = mib_chain_total(MIB_RIP_TBL);
	
	for (i=0; i<entryNum; i++) {
		if (!mib_chain_get(MIB_RIP_TBL, i, (void *)&Entry))
		{
  			printf("Get MIB_RIP_TBL chain record error!\n");
			return;
		}		

		if (!Entry.enable)
			continue;
		
		if( Entry.ifIndex == 0xff) {
			strncpy(ifname, "br0", strlen("br0"));
			ifname[strlen("br0")] = '\0';
		} else {	
			if (PPP_INDEX(Entry.ifIndex) != 0x0f)
			{	// PPP interface
				snprintf(ifname, 6, "ppp%u", PPP_INDEX(Entry.ifIndex));
			}
			else
			{	// vc interface
				snprintf(ifname, 6, "vc%u", VC_INDEX(Entry.ifIndex));
			}
		}
		
		fprintf(fp, "network %s %d %d %d\n", ifname, Entry.version, Entry.version, Entry.operation);
	}
	
	fclose(fp);
	// Modified by Mason Yu for always as a supplier for RIP
	//va_cmd(ROUTED, 0, 0);
	va_cmd(ROUTED, 1, 0, "-s");
	return 1;
}
#endif	// of CONFIG_USER_ROUTED_ROUTED

#ifdef CONFIG_USER_ZEBRA_OSPFD_OSPFD
static const char ZEBRA_CONF[] = "/etc/config/zebra.conf";
static const char OSPFD_CONF[] = "/etc/config/ospfd.conf";

// OSPF server configuration
// return value:
// 0  : not enabled
// 1  : successful
// -1 : startup failed
int startOspf()
{
	FILE *fp;
	char *argv[6];
	int pid;
	unsigned char ospfOn;
	unsigned int entryNum, i, j;
	MIB_CE_OSPF_T Entry;
	char *netIp[20];
	unsigned int uMask;
	unsigned int uIp;

	if (mib_get(MIB_OSPF_ENABLE, (void *)&ospfOn) == 0)
		ospfOn = 0;
	//kill old zebra
	pid = read_pid((char *)ZEBRA_PID);
	if (pid >= 1) {
		if (kill(pid, SIGTERM) != 0) {
			printf("Could not kill pid '%d'\n", pid);
		}
	}
	//kill old ospfd
	pid = read_pid((char *)OSPFD_PID);
	if (pid >= 1) {
		if (kill(pid, SIGTERM) != 0)
			printf("Could not kill pid '%d'\n", pid);
	}

	if (!ospfOn)
		return 0;

	printf("start ospf!\n");
	//create zebra.conf
	if ((fp = fopen(ZEBRA_CONF, "w")) == NULL)
	{
		printf("Open file %s failed !\n", ZEBRA_CONF);
		return -1;
	}
	fprintf(fp, "hostname Router\n");
	fprintf(fp, "password zebra\n");
	fprintf(fp, "enable password zebra\n");
	fclose(fp);

	//create ospfd.conf
	if ((fp = fopen(OSPFD_CONF, "w")) == NULL)
	{
		printf("Open file %s failed !\n", OSPFD_CONF);
		return -1;
	}
	fprintf(fp, "hostname ospfd\n");
	fprintf(fp, "password zebra\n");
	fprintf(fp, "enable password zebra\n");
	fprintf(fp, "router ospf\n");
	//ql_xu test.
	//fprintf(fp, "network %s area 0\n", "192.168.2.0/24");
	entryNum = mib_chain_total(MIB_OSPF_TBL);
	
	for (i=0; i<entryNum; i++) {
		if (!mib_chain_get(MIB_OSPF_TBL, i, (void *)&Entry))
		{
  			printf("Get MIB_OSPF_TBL chain record error!\n");
			return -1;
		}

		uIp = *(unsigned int *)Entry.ipAddr;
		uMask = *(unsigned int *)Entry.netMask;
		uIp = uIp & uMask;
		strcpy(netIp, inet_ntoa(*((struct in_addr *)&uIp)));
		
		for (j=0; j<32; j++)
			if ((uMask>>j) & 0x01)
				break;
		uMask = 32 - j;

		sprintf(netIp, "%s/%d", netIp, uMask);
		fprintf(fp, "network %s area 0\n", netIp);
	}
	fclose(fp);

	//start zebra
	argv[1] = "-d";
	argv[2] = "-k";
	argv[3] = NULL;
	TRACE(STA_SCRIPT, "%s %s %s\n", ZEBRA, argv[1], argv[2]);
	do_cmd(ZEBRA, argv, 0);

	//start ospfd
	argv[1] = "-d";
	argv[2] = NULL;
	TRACE(STA_SCRIPT, "%s %s\n", OSPFD, argv[1]);
	do_cmd(OSPFD, argv, 0);
	
	return 1;
}
#endif

#ifdef WLAN_SUPPORT
//check flash config if wlan0 is up, called by BOA, 
//0:down, 1:up
int wlan_is_up(void)
{
  unsigned char vChar;
  int value=0;

    mib_get( MIB_WLAN_DISABLED, (void *)&vChar);
    if (vChar==0) {  // wlan0 is enabled
    	value=1;
    }
	return value;
}
#endif

#include <linux/atm.h>

//up_flag:0, itf down; non-zero: itf up
void itfcfg(char *if_name, int up_flag)
{
#ifdef EMBED
  int fd;

	if (strncmp(if_name, "sar", sizeof("sar"))==0) {  //sar enable/disable
		struct atmif_sioc mysio;
		
		if((fd = socket(PF_ATMPVC, SOCK_DGRAM, 0)) < 0){
			printf("socket open error\n");
			return;
		}
		mysio.number = 0;
		mysio.length = sizeof(struct SAR_IOCTL_CFG);
		mysio.arg = (void *)NULL;
		if (up_flag) ioctl(fd, SIOCDEVPRIVATE+2, &mysio);
		else         ioctl(fd, SIOCDEVPRIVATE+3, &mysio);
		if(fd!=(int)NULL)
		    close(fd);
	} else if ((fd = socket(AF_INET, SOCK_DGRAM, 0)) >= 0) {
		int flags;
		if (getInFlags(if_name, &flags) == 1) {
			if (up_flag)
				flags |= IFF_UP;
			else
				flags &= ~IFF_UP;
			
			setInFlags(if_name, flags);
		}
	}
#endif
}

#ifdef WLAN_SUPPORT
//disabled: 0--WLAN is enabled, nonZero--WLAN is disabled
int update_wlan_disable(unsigned char disabled)
{
  unsigned char vChar=disabled;
  unsigned char vCharget;
  int value=0;

	// Mason Yu 
	mib_get( MIB_WLAN_DISABLED, (void *)&vCharget);
	if ( vCharget != vChar) {
		//printf("Setting WLan interface up or down\n");
		mib_set( MIB_WLAN_DISABLED, (void *)&vChar);
		itfcfg("eth0", 0);
		itfcfg("sar", 0);
		itfcfg((char *)WLANIF, 0);
		
		if(mib_update(CURRENT_SETTING, CONFIG_MIB_ALL) == 0)
			printf("CS Flash error! \n");
		
		itfcfg("eth0", 1);
		itfcfg("sar", 1);
		if (!disabled) itfcfg((char *)WLANIF, 1);
//xl_yue: if disable wlan, wps should be disabled too
		mib_set(MIB_WSC_DISABLE, (void *)&vChar);
#ifdef REVERSE_WPS_LED
		if(vChar){
			system("echo 0 > /proc/gpio");
		}else{
			system("echo 1 > /proc/gpio");		}
#endif
	}
	return value;
}
#endif

#ifdef XOR_ENCRYPT
const char XOR_KEY[] = "tecomtec";
void xor_encrypt(char *inputfile, char *outputfile)
{
	FILE *input  = fopen(inputfile, "rb");
	FILE *output = fopen(outputfile, "wb");

	if(input != NULL && output != NULL) {
		unsigned char buffer[MAX_CONFIG_FILESIZE];
		size_t count, i, j = 0;
		do {
			count = fread(buffer, sizeof *buffer, sizeof buffer, input);
			for(i = 0; i<count; ++i) {
				buffer[i] ^= XOR_KEY[j++];
				if(XOR_KEY[j] == '\0')
					j = 0; /* restart at the beginning of the key */
			}
			fwrite(buffer, sizeof *buffer, count, output);
		} while (count == sizeof buffer);
		fclose(input);
		fclose(output);
	}
}
#endif



// FILE operation.
/*
This function copy one file to another and invoke a pipe function for additional process (e.g. encrypt)
*/
#define CHECK_NULL(x) if (0==x) return errno;
int file_copy_pipe(char *inputfile, char *outputfile, struct file_pipe *pipe) {
	FILE *input; 
	FILE *output; 
	//unsigned char buffer[256];
	size_t b_read, b_write;
	int quit = 0, rv = 0;
	
	input = fopen(inputfile, "rb");
	CHECK_NULL(inputfile);
	
	output = fopen(outputfile, "wb");
	CHECK_NULL(outputfile);

	do {
		b_read= fread(pipe->buffer, 1, pipe->bufsize, input);
		if (b_read < pipe->bufsize) {
			quit = 1;
		}

		if (pipe->func)
			pipe->func(pipe->buffer, &b_read);
		
		b_write = fwrite(pipe->buffer, 1, b_read, output);
		if (b_read != b_write) {
			rv = ferror(output);
			quit = 1;
		}
		
	} while (!quit);

	fflush(output);
	fclose(input);
	fclose(output);

	return rv;
}

int file_copy(char *inputfile, char *outputfile) {
	struct file_pipe pipe;
	unsigned char buffer[256];

	pipe.buffer = buffer;
	pipe.bufsize = sizeof buffer;
	pipe.func = 0;

	return file_copy_pipe(inputfile, outputfile, &pipe);
}

// return true is file exist and is a regular file.. else false.
int is_file(const char *filename) {
	struct stat statbuf;

	if (stat(filename, &statbuf))
		return 0;

	if (statbuf.st_mode & S_IFREG)
		return 1;

	return 0;
}




//#define uint16 unsigned short
unsigned short 
ipchksum(unsigned char *ptr, int count, unsigned short resid)
{
	register unsigned int sum = resid;
       if ( count==0) 
       	return(sum);
        
	while(count > 1) {
		//sum += ntohs(*ptr);	
		sum += (( ptr[0] << 8) | ptr[1] );
		if ( sum>>31)
			sum = (sum&0xffff) + ((sum>>16)&0xffff);
		ptr += 2;
		count -= 2;
	}

	if (count > 0) 
		sum += (*((unsigned char*)ptr) << 8) & 0xff00;

	while (sum >> 16)
		sum = (sum & 0xffff) + (sum >> 16);

	if (sum == 0xffff) 
		sum = 0;
	return (unsigned short)sum;
}

int getLinkStatus(struct ifreq *ifr)
{
	int status=0;

#ifdef __mips__
	if (do_ioctl(SIOCGMEDIALS, ifr) == 1)
		status = 1;
#endif
	return status;
}


/***port forwarding APIs*******/
/*move from startup.c:iptable_fw()*/
void iptable_fw( int del, int negate, const char *ifname, const char *proto, const char *remoteIP, const char *extPort, const char *dstIP)
{
	char *act;
	
	if(del) act = (char *)FW_DEL;
	else act = (char *)FW_ADD;

//	if (negate && remoteIP) {
	if (negate && remoteIP && extPort) {
		va_cmd(IPTABLES, 17, 1, "-t", "nat",
			(char *)act,	(char *)FW_PREROUTING,
			(char *)ARG_I, "!", (char *)ifname,
			"-p", (char *)proto,
			"-s", (char *)remoteIP,
			(char *)FW_DPORT, extPort, "-j",
			"DNAT", "--to-destination", dstIP);
	} else if (negate && remoteIP) {
		va_cmd(IPTABLES, 15, 1, "-t", "nat",
			(char *)act,	(char *)FW_PREROUTING,
			(char *)ARG_I, "!", (char *)ifname,
			"-p", (char *)proto,
			"-s", (char *)remoteIP,
			"-j", "DNAT", "--to-destination", dstIP);
//	} else if (negate) {
	} else if (negate && extPort) {
		va_cmd(IPTABLES, 15, 1, "-t", "nat",
			(char *)act,	(char *)FW_PREROUTING,
			(char *)ARG_I, "!", (char *)ifname,
			"-p", (char *)proto,
			(char *)FW_DPORT, extPort, "-j",
			"DNAT", "--to-destination", dstIP);
//	} else if (remoteIP) {
	} else if (remoteIP && extPort) {
		va_cmd(IPTABLES, 16, 1, "-t", "nat",
			(char *)act,	(char *)FW_PREROUTING,
			(char *)ARG_I, (char *)ifname,
			"-p", (char *)proto,
			"-s", (char *)remoteIP,
			(char *)FW_DPORT, extPort, "-j",
			"DNAT", "--to-destination", dstIP);
	} else if (negate) {
		va_cmd(IPTABLES, 13, 1, "-t", "nat",
			(char *)act,	(char *)FW_PREROUTING,
			(char *)ARG_I, "!", (char *)ifname,
			"-p", (char *)proto,
			"-j", "DNAT", "--to-destination", dstIP);
	} else if (remoteIP) {
		va_cmd(IPTABLES, 14, 1, "-t", "nat",
			(char *)act,	(char *)FW_PREROUTING,
			(char *)ARG_I, (char *)ifname,
			"-p", (char *)proto,
			"-s", (char *)remoteIP,
			"-j", "DNAT", "--to-destination", dstIP);
//	} else {
	} else if (extPort) {
		va_cmd(IPTABLES, 14, 1, "-t", "nat",
			(char *)act,	(char *)FW_PREROUTING,
			(char *)ARG_I, (char *)ifname,
			"-p", (char *)proto,
			(char *)FW_DPORT, extPort, "-j",
			"DNAT", "--to-destination", dstIP);
	} else {
		va_cmd(IPTABLES, 12, 1, "-t", "nat",
			(char *)act,	(char *)FW_PREROUTING,
			(char *)ARG_I, (char *)ifname,
			"-p", (char *)proto,
			 "-j", "DNAT", "--to-destination", dstIP);
	}
}

/*move from startup.c:iptable_filter()*/
void iptable_filter( int del, int negate, const char *ifname, const char *proto, const char *remoteIP, const char *intPort)
{
	char *strInsert="-I";
	char *strThird="3";
	char *act, *rulenum;
	
	if(del)
	{ 
		act = (char *)FW_DEL;

//		if (negate && remoteIP) {
		if (negate && remoteIP && intPort) {
			va_cmd(IPTABLES, 15, 1, act,
				(char *)FW_IPFILTER, (char *)ARG_I, "!", ifname,
				(char *)ARG_O,
				(char *)LANIF, "-p", (char *)proto,  
				"-s", remoteIP,
				(char *)FW_DPORT, intPort, 
				"-j",(char *)FW_RETURN);
		} else if (negate && remoteIP) {
			va_cmd(IPTABLES, 13, 1, act,
				(char *)FW_IPFILTER, (char *)ARG_I, "!", ifname,
				(char *)ARG_O,
				(char *)LANIF, "-p", (char *)proto,  
				"-s", remoteIP,
				"-j",(char *)FW_RETURN);
//		} else if (negate) {
		} else if (negate && intPort) {
			va_cmd(IPTABLES, 13, 1, act,
				(char *)FW_IPFILTER, (char *)ARG_I, "!", ifname,
				(char *)ARG_O,
				(char *)LANIF, "-p", (char *)proto,  
				(char *)FW_DPORT, intPort, 
				"-j",(char *)FW_RETURN);
//		} else if (remoteIP) {
		} else if (remoteIP && intPort) {
			va_cmd(IPTABLES, 14, 1, act,
				(char *)FW_IPFILTER, (char *)ARG_I, ifname,
				(char *)ARG_O,
				(char *)LANIF, "-p", (char *)proto,  
				"-s", remoteIP,
				(char *)FW_DPORT, intPort, 
				"-j",(char *)FW_RETURN);
		} else if (negate) {
			va_cmd(IPTABLES, 11, 1, act,
				(char *)FW_IPFILTER, (char *)ARG_I, "!", ifname,
				(char *)ARG_O,
				(char *)LANIF, "-p", (char *)proto,  
				"-j",(char *)FW_RETURN);
		} else if (remoteIP) {
			va_cmd(IPTABLES, 12, 1, act,
				(char *)FW_IPFILTER, (char *)ARG_I, ifname,
				(char *)ARG_O,
				(char *)LANIF, "-p", (char *)proto,  
				"-s", remoteIP,
				"-j",(char *)FW_RETURN);
//		} else {
		} else if (intPort) {
			va_cmd(IPTABLES, 12, 1, act,
				(char *)FW_IPFILTER, (char *)ARG_I, ifname,
				(char *)ARG_O,
				(char *)LANIF, "-p", (char *)proto,  
				(char *)FW_DPORT, intPort, "-j",
				(char *)FW_RETURN);
		} else {
			va_cmd(IPTABLES, 10, 1, act,
				(char *)FW_IPFILTER, (char *)ARG_I, ifname,
				(char *)ARG_O,
				(char *)LANIF, "-p", (char *)proto,  
				"-j", (char *)FW_RETURN);
		}
	}else
	{
		act = strInsert; //use insert, not append => need rulenum
		rulenum = strThird;
 
//		if (negate && remoteIP) {
		if (negate && remoteIP && intPort) {
			va_cmd(IPTABLES, 16, 1, act,
				(char *)FW_IPFILTER, rulenum, (char *)ARG_I, "!", ifname,
				(char *)ARG_O,
				(char *)LANIF, "-p", (char *)proto,  
				"-s", remoteIP,
				(char *)FW_DPORT, intPort, 
				"-j",(char *)FW_RETURN);
		} else if (negate && remoteIP) {
			va_cmd(IPTABLES, 14, 1, act,
				(char *)FW_IPFILTER, rulenum, (char *)ARG_I, "!", ifname,
				(char *)ARG_O,
				(char *)LANIF, "-p", (char *)proto,  
				"-s", remoteIP,
				"-j",(char *)FW_RETURN);
//		} else if (negate) {
		} else if (negate && intPort) {
			va_cmd(IPTABLES, 14, 1, act,
				(char *)FW_IPFILTER, rulenum, (char *)ARG_I, "!", ifname,
				(char *)ARG_O,
				(char *)LANIF, "-p", (char *)proto,  
				(char *)FW_DPORT, intPort, 
				"-j",(char *)FW_RETURN);
//		} else if (remoteIP) {
		} else if (remoteIP && intPort) {
			va_cmd(IPTABLES, 15, 1, act,
				(char *)FW_IPFILTER, rulenum, (char *)ARG_I, ifname,
				(char *)ARG_O,
				(char *)LANIF, "-p", (char *)proto,  
				"-s", remoteIP,
				(char *)FW_DPORT, intPort, 
				"-j",(char *)FW_RETURN);
		} else if (negate) {
			va_cmd(IPTABLES, 12, 1, act,
				(char *)FW_IPFILTER, rulenum, (char *)ARG_I, "!", ifname,
				(char *)ARG_O,
				(char *)LANIF, "-p", (char *)proto,  
				"-j",(char *)FW_RETURN);
		} else if (remoteIP) {
			va_cmd(IPTABLES, 13, 1, act,
				(char *)FW_IPFILTER, rulenum, (char *)ARG_I, ifname,
				(char *)ARG_O,
				(char *)LANIF, "-p", (char *)proto,  
				"-s", remoteIP,
				"-j",(char *)FW_RETURN);
//		} else {
		} else if (intPort) {
			va_cmd(IPTABLES, 13, 1, act,
				(char *)FW_IPFILTER, rulenum, (char *)ARG_I, ifname,
				(char *)ARG_O,
				(char *)LANIF, "-p", (char *)proto,  
				(char *)FW_DPORT, intPort, "-j",
				(char *)FW_RETURN);
		} else {
			va_cmd(IPTABLES, 11, 1, act,
				(char *)FW_IPFILTER, rulenum, (char *)ARG_I, ifname,
				(char *)ARG_O,
				(char *)LANIF, "-p", (char *)proto,  
				"-j", (char *)FW_RETURN);
		}
	}

}

/*move from startup.c ==> part of setupFirewall()*/
void portfw_modify( MIB_CE_PORT_FW_T *p, int del )
{
	int negate=0, hasRemote=0, hasLocalPort=0, hasExtPort=0;
	char * proto = 0;
	char intPort[32], extPort[32];
	char ipaddr[32], extra[32], ifname[16];

	if(p==NULL) return;

#if 0
	{
		fprintf( stderr,"<portfw_modify>\n" );
		fprintf( stderr,"\taction:%s\n", (del==0)?"ADD":"DEL" );
		fprintf( stderr,"\tifIndex:0x%x\n", p->ifIndex );
		fprintf( stderr,"\tenable:%u\n", p->enable );
		fprintf( stderr,"\tleaseduration:%u\n", p->leaseduration );
		fprintf( stderr,"\tremotehost:%s\n", inet_ntoa(*((struct in_addr *)p->remotehost))  );
		fprintf( stderr,"\texternalport:%u\n", p->externalport );
		fprintf( stderr,"\tinternalclient:%s\n", inet_ntoa(*((struct in_addr *)p->ipAddr)) );
		fprintf( stderr,"\tinternalport:%u\n", p->toPort );
		fprintf( stderr,"\tprotocol:%u\n", p->protoType ); /*PROTO_TCP=1, PROTO_UDP=2*/
		fprintf( stderr,"<end portfw_modify>\n" );
	}
#endif

	if( del==0 ) //add
	{
		char vCh=0;
		mib_get(MIB_PORT_FW_ENABLE, (void *)&vCh);
		if(vCh==0) return;
		
		if (!p->enable) return;
	}
	
/*	snprintf(intPort, 12, "%u", p->fromPort);

	if (p->externalport) {
		snprintf(extPort, sizeof(extPort), "%u", p->externalport);
		snprintf(intPort, sizeof(intPort), "%u", p->fromPort);
		snprintf(ipaddr, sizeof(ipaddr), "%s:%s", inet_ntoa(*((struct in_addr *)p->ipAddr)), intPort);
	} else {
		snprintf(intPort, sizeof(extPort), "%u", p->fromPort);				
		strncpy(extPort, intPort, sizeof(intPort));				
		strncpy(ipaddr, inet_ntoa(*((struct in_addr *)p->ipAddr)), 16);
	}
	*/
    if (p->fromPort) 
    {
        if (p->fromPort == p->toPort)
        {
            snprintf(intPort, sizeof(intPort), "%u", p->fromPort);
        }
        else
        {
            /* "%u-%u" is used by port forwarding */
            snprintf(intPort, sizeof(intPort), "%u-%u", p->fromPort, p->toPort);
        }

        snprintf(ipaddr, sizeof(ipaddr), "%s:%s", inet_ntoa(*((struct in_addr *)p->ipAddr)), intPort);
        
        if (p->fromPort != p->toPort)
        {
            /* "%u:%u" is used by filter */
            snprintf(intPort, sizeof(intPort), "%u:%u", p->fromPort, p->toPort);
        }
        hasLocalPort = 1;
    } 
    else
    {
        snprintf(ipaddr, sizeof(ipaddr), "%s", inet_ntoa(*((struct in_addr *)p->ipAddr)));
        hasLocalPort = 0;
    }

	if (p->externalfromport && p->externaltoport && (p->externalfromport != p->externaltoport)) {
		snprintf(extPort, sizeof(extPort), "%u:%u", p->externalfromport, p->externaltoport);
		hasExtPort = 1;
	} else if (p->externalfromport) {
		snprintf(extPort, sizeof(extPort), "%u", p->externalfromport);
		hasExtPort = 1;
	} else if (p->externaltoport) {
		snprintf(extPort, sizeof(extPort), "%u", p->externaltoport);
		hasExtPort = 1;
	} else {
		hasExtPort = 0;
	}
	//printf( "extPort:%s hasExtPort=%d\n",  extPort, hasExtPort);
	//printf( "entry.externalfromport:%d entry.externaltoport=%d\n",  p->externalfromport, p->externaltoport);
		
	if( p->ifIndex!=0xff ) {
		if( (p->ifIndex & 0xf0)==0xf0 ) //vc
			snprintf( ifname, sizeof(ifname), "vc%u", VC_INDEX(p->ifIndex)  );
		else
			snprintf( ifname, sizeof(ifname), "ppp%u", PPP_INDEX(p->ifIndex)  );				
		negate = 0;
	} else {
	
		strcpy(ifname, LANIF);
		negate = 1;
	}

	if (p->remotehost[0]) {
		snprintf(extra, sizeof(extra), "%s", inet_ntoa(*((struct in_addr *)p->remotehost)));
		hasRemote = 1;
	} else {
		hasRemote = 0;
	}
	
	//fprintf( stderr, "ipaddr:%s, intPort:%s\n", ipaddr, intPort );
	//check something
	//internalclient can't be zeroip
	if( strncmp(ipaddr,"0.0.0.0", 7)==0 ) return;
	//internalport can't be zero
//	if( strcmp(intPort,"0")==0 ) return;
	//fprintf( stderr, "Pass ipaddr:%s, intPort:%s\n", ipaddr, intPort );

	if (p->protoType == PROTO_TCP || p->protoType == PROTO_UDPTCP)
	{
		// iptables -t nat -A PREROUTING -i ! $LAN_IF -p TCP --dport dstPortRange -j DNAT --to-destination ipaddr
//		iptable_fw( del, negate, ifname, ARG_TCP, hasRemote ? extra : 0, extPort, ipaddr);
		iptable_fw( del, negate, ifname, ARG_TCP, hasRemote ? extra : 0, hasExtPort ? extPort : 0, ipaddr);
		// iptables -I ipfilter 3 -i ! $LAN_IF -o $LAN_IF -p TCP --dport dstPortRange -j RETURN
//		iptable_filter( del, negate, ifname, ARG_TCP, hasRemote ? extra : 0, intPort);
		iptable_filter( del, negate, ifname, ARG_TCP, hasRemote ? extra : 0, hasLocalPort ? intPort : 0);
	}
	
	if (p->protoType == PROTO_UDP || p->protoType == PROTO_UDPTCP)
	{				
//		iptable_fw( del, negate, ifname, ARG_UDP, hasRemote ? extra : 0, extPort, ipaddr);
		iptable_fw( del, negate, ifname, ARG_UDP, hasRemote ? extra : 0, hasExtPort ? extPort : 0, ipaddr);
		// iptables -I ipfilter 3 -i ! $LAN_IF -o $LAN_IF -p UDP --dport dstPortRange -j RETURN
//		iptable_filter( del, negate, ifname, ARG_UDP, hasRemote ? extra : 0, intPort);
		iptable_filter( del, negate, ifname, ARG_UDP, hasRemote ? extra : 0, hasLocalPort ? intPort : 0);
	}
}
/***end port forwarding APIs*******/
#ifdef SNTP_SUPPORT_ENABLE
int  setupNtp(int type)
{
	unsigned char ntpEnable;
	char firstip[MAX_NAME_LEN]={0};
	char secondip[MAX_NAME_LEN]={0};	
	int pid;
	DOCMDINIT;
	switch(type)
		{
		case SNTP_DISABLED:
			pid=getProcessPid(VSNTP_PID);
			if(pid)   {
				DOCMDARGVS("/bin/kill",DOWAIT,"%d",pid);
			}
			break;
		case SNTP_ENABLED:			
			mib_get(MIB_NTP_ENABLED,&ntpEnable);
			if(ntpEnable){
				mib_get(MIB_NTP_SERVER_HOST1,&firstip);
				mib_get(MIB_NTP_SERVER_HOST2,&secondip);
				if(secondip[0])
					{
					DOCMDARGVS(VSNTP,UNDOWAIT,"-s %s -s %s",firstip,secondip);	
					}
				else
					{
					DOCMDARGVS(VSNTP,UNDOWAIT,"-s %s",firstip);	
					}
				}
			break;		   
		}	
	return 0;
}
#endif
#if defined(TIME_ZONE) || defined(ZTE_GENERAL_ROUTER_SC)
// return value:
// 1  : successful
// -1 : failed
int startNTP(void)
{
	int status=1;
	char vChar;
	struct in_addr ipAddr;
	char sVal[16], sTZ[16], *pStr;
	FILE *fp;

	mib_get( MIB_NTP_ENABLED, (void *)&vChar);
	if (vChar == 1) 
	{
		// start vsntp and setup timezone
		mib_get(MIB_NTP_TIMEZONE, (void *)sVal);
		pStr = strstr(sVal, " ");
		if (pStr != NULL)
			pStr[0] = '\0';
		snprintf(sTZ, 16, "GMT%s", sVal);
		//setenv("TZ", sTZ, 1);
		if ((fp = fopen("/etc/TZ", "w")) != NULL) {
			fprintf(fp, "%s\n", sTZ);
			fclose(fp);
		}
		
		mib_get( MIB_NTP_SERVER_ID, (void *)&vChar);
		if (vChar==0)
			mib_get(MIB_NTP_SERVER_IP1, (void *)&ipAddr);
		else
			mib_get(MIB_NTP_SERVER_IP2, (void *)&ipAddr);
		
		strncpy(sVal, inet_ntoa(ipAddr), 16);
		sVal[15] = '\0';
		status|=va_cmd(SNTPC, 1, 0, sVal);
	}

	return status;
}

// return value:
// 1  : successful
// -1 : failed
int stopNTP(void)
{
	int ntp_pid=0;
	ntp_pid = read_pid((char *)SNTPC_PID);
	if (ntp_pid >= 1) 
	{
		printf("kill SIGKILL to NTP's pid '%d'\n", ntp_pid);
		// kill it
		if (kill(ntp_pid, SIGTERM) != 0) 
		{
			printf("Could not kill NTP's pid '%d'\n", ntp_pid);
			return -1;
		}
	}else
		printf( "Could not find NTP's pid\n" );
	return 1;
}
#endif //TIME_ZONE

#define DHCPSERVERPID  "/var/run/udhcpd.pid"
#define DHCPRELAYPID  "/var/run/dhcrelay.pid"

static const char DHCPD_CONF[] = "/var/udhcpd/udhcpd.conf";
static const char DHCPD_LEASE[] = "/var/udhcpd/udhcpd.leases";
// DHCP server configuration
// return value:
// 0  : not active
// 1  : active
// -1 : setup failed
int setupDhcpd()
{
	unsigned char value[32];
	unsigned int uInt, uLTime;
	DNS_TYPE_T dnsMode;
	FILE *fp, *fp2;
	char ipstart[16], ipend[16];
#ifdef IP_BASED_CLIENT_TYPE
	char pcipstart[16], pcipend[16];
	char cmripstart[16], cmripend[16];
	char stbipstart[16], stbipend[16];
	char phnipstart[16], phnipend[16];
	char hgwipstart[16], hgwipend[16];
#endif
	char subnet[16], ipaddr[16], ipaddr2[16];
	char dhcpip[16], dhcpsubnet[16];
	char dns1[16], dns2[16], dns3[16], dhcps[16];
	char domain[MAX_NAME_LEN];
	unsigned int entryNum, i, j;
	MIB_CE_MAC_BASE_DHCP_T Entry;		
#ifdef IP_PASSTHROUGH
	int ippt;
#endif
	int spc_enable, spc_ip;
	struct in_addr myip;
		
	// check if dhcp server on ?
	// Modified by Mason Yu for dhcpmode
	//if (mib_get(MIB_ADSL_LAN_DHCP, (void *)value) != 0)
	if (mib_get(MIB_DHCP_MODE, (void *)value) != 0)
	{
		uInt = (unsigned int)(*(unsigned char *)value);
		if (uInt != 2 )
		{
			return 0;	// dhcp Server not on
		}
	}		
	
#ifdef SECONDARY_IP
	mib_get(MIB_ADSL_LAN_ENABLE_IP2, (void *)value);
	if (value[0])
		mib_get(MIB_ADSL_LAN_DHCP_POOLUSE, (void *)value);
#else
	value[0] = 0;
#endif
	
	if (value[0] == 0) { // primary LAN
		if (mib_get(MIB_ADSL_LAN_SUBNET, (void *)value) != 0)
		{
			strncpy(dhcpsubnet, inet_ntoa(*((struct in_addr *)value)), 16);
			dhcpsubnet[15] = '\0';
		}
		else
			return -1;
		
		if (mib_get(MIB_ADSL_LAN_IP, (void *)value) != 0)
		{
			strncpy(dhcpip, inet_ntoa(*((struct in_addr *)value)), 16);
			dhcpip[15] = '\0';
		}
		else
			return -1;
	}
	else { // secondary LAN
		if (mib_get(MIB_ADSL_LAN_SUBNET2, (void *)value) != 0)
		{
			strncpy(dhcpsubnet, inet_ntoa(*((struct in_addr *)value)), 16);
			dhcpsubnet[15] = '\0';
		}
		else
			return -1;
		
		if (mib_get(MIB_ADSL_LAN_IP2, (void *)value) != 0)
		{
			strncpy(dhcpip, inet_ntoa(*((struct in_addr *)value)), 16);
			dhcpip[15] = '\0';
		}
		else
			return -1;
	}
	
	// IP pool start address
	// Kaohj
	#ifndef DHCPS_POOL_COMPLETE_IP
	if (mib_get(MIB_ADSL_LAN_CLIENT_START, (void *)&value[3]) != 0)
	{
		strncpy(ipstart, inet_ntoa(*((struct in_addr *)value)), 16);
		ipstart[15] = '\0';
	}
	else
		return -1;
	
	// IP pool end address
	if (mib_get(MIB_ADSL_LAN_CLIENT_END, (void *)&value[3]) != 0)
	{
		strncpy(ipend, inet_ntoa(*((struct in_addr *)value)), 16);
		ipend[15] = '\0';
	}
	else
		return -1;
	#else
	// IP Pool start
	mib_get(MIB_DHCP_POOL_START, (void *)value);
	strncpy(ipstart, inet_ntoa(*((struct in_addr *)value)), 16);
	// IP Pool end
	mib_get(MIB_DHCP_POOL_END, (void *)value);
	strncpy(ipend, inet_ntoa(*((struct in_addr *)value)), 16);
	#endif

	// Added by Mason Yu for MAC base assignment. Start			
	if ((fp2 = fopen("/var/dhcpdMacBase.txt", "w")) == NULL)
	{
		printf("***** Open file /var/dhcpdMacBase.txt failed !\n");	
		goto dhcpConf;		
	}

//star: reserve local ip for dhcp server
		MIB_CE_MAC_BASE_DHCP_T entry;
					
		strcpy(entry.macAddr, "localmac");
		//printf("entry.macAddr = %s\n", entry.macAddr);
		if (mib_get(MIB_ADSL_LAN_IP, (void *)value) != 0)
		{
			strncpy(entry.ipAddr, inet_ntoa(*((struct in_addr *)value)), 16);
			entry.ipAddr[15] = '\0';
		}	

		fprintf(fp2, "%s: %s\n", entry.macAddr, entry.ipAddr);
#ifdef SECONDARY_IP
		mib_get(MIB_ADSL_LAN_ENABLE_IP2, (void *)value);
		if (value[0] == 1) {
			strcpy(entry.macAddr, "localsecmac");
			//printf("entry.macAddr = %s\n", entry.macAddr);
			if (mib_get(MIB_ADSL_LAN_IP2, (void *)value) != 0)
			{
				strncpy(entry.ipAddr, inet_ntoa(*((struct in_addr *)value)), 16);
				entry.ipAddr[15] = '\0';
			}			
			
			fprintf(fp2, "%s: %s\n", entry.macAddr, entry.ipAddr);	
		}
	
#endif

//star: check mactbl
	struct in_addr poolstart,poolend,macip;
	inet_aton(ipstart, &poolstart);
	inet_aton(ipend, &poolend);
check_mactbl:	
	entryNum = mib_chain_total(MIB_MAC_BASE_DHCP_TBL);
	for (i=0; i<entryNum; i++) {
		if (!mib_chain_get(MIB_MAC_BASE_DHCP_TBL, i, (void *)&Entry))
		{
  			printf("setupDhcpd:Get chain(MIB_MAC_BASE_DHCP_TBL) record error!\n");			
		}
		inet_aton(Entry.ipAddr, &macip);
		if(macip.s_addr<poolstart.s_addr||macip.s_addr>poolend.s_addr)
		{
			if(mib_chain_delete(MIB_MAC_BASE_DHCP_TBL, i)!=1)
			{	
				printf("setupDhcpd:Delete chain(MIB_MAC_BASE_DHCP_TBL) record error!\n");
				return -1; 
			}
			break;
		}
	}
	if((int)i<((int)entryNum-1))
		goto check_mactbl;

	entryNum = mib_chain_total(MIB_MAC_BASE_DHCP_TBL);
	for (i=0; i<entryNum; i++) {

		if (!mib_chain_get(MIB_MAC_BASE_DHCP_TBL, i, (void *)&Entry))
		{
  			printf("setupDhcpd:Get chain(MIB_MAC_BASE_DHCP_TBL) record error!\n");			
		}
		
		for (j=0; j<17; j++){
			if ( Entry.macAddr[j] != '-' ) {
				Entry.macAddr[j] = tolower(Entry.macAddr[j]);
			}	
		}	
		
		fprintf(fp2, "%s: %s\n", Entry.macAddr, Entry.ipAddr);				
	}			
	fclose(fp2);
	// Added by Mason Yu for MAC base assignment. End	
	
dhcpConf:
#ifdef IP_BASED_CLIENT_TYPE
#if 0
	if (mib_get(MIB_ADSL_LAN_IP, (void *)value) != 0)
	{
		strncpy(ipaddr, inet_ntoa(*((struct in_addr *)value)), 16);
		ipaddr[15] = '\0';
	}
	else
		return -1;
#endif

	// PC IP pool 
	if (mib_get(CWMP_CT_PC_MINADDR, (void *)&value[0]) != 0)
	{
		strncpy(pcipstart, inet_ntoa(*((struct in_addr *)value)), 16);
		pcipstart[15] = '\0';
	}
	else
		return -1;


	if (mib_get(CWMP_CT_PC_MAXADDR, (void *)&value[0]) != 0)
	{
		strncpy(pcipend, inet_ntoa(*((struct in_addr *)value)), 16);
		pcipend[15] = '\0';
	}
	else
		return -1;

	// CMR IP pool
	if (mib_get(CWMP_CT_CMR_MINADDR, (void *)&value[0]) != 0)
	{
		strncpy(cmripstart, inet_ntoa(*((struct in_addr *)value)), 16);
		cmripstart[15] = '\0';
	}
	else
		return -1;

	if (mib_get(CWMP_CT_CMR_MAXADDR, (void *)&value[0]) != 0)
	{
		strncpy(cmripend, inet_ntoa(*((struct in_addr *)value)), 16);
		cmripend[15] = '\0';
	}
	else
		return -1;

	// STB IP 
	if (mib_get(CWMP_CT_STB_MINADDR, (void *)&value[0]) != 0)
	{
		strncpy(stbipstart, inet_ntoa(*((struct in_addr *)value)), 16);
		stbipstart[15] = '\0';
	}
	else
		return -1;

	if (mib_get(CWMP_CT_STB_MAXADDR, (void *)&value[0]) != 0)
	{
		strncpy(stbipend, inet_ntoa(*((struct in_addr *)value)), 16);
		stbipend[15] = '\0';
	}
	else
		return -1;

	// PHN IP pool 
	if (mib_get(CWMP_CT_PHN_MINADDR, (void *)&value[0]) != 0)
	{
		strncpy(phnipstart, inet_ntoa(*((struct in_addr *)value)), 16);
		phnipstart[15] = '\0';
	}
	else
		return -1;

	if (mib_get(CWMP_CT_PHN_MAXADDR, (void *)&value[0]) != 0)
	{
		strncpy(phnipend, inet_ntoa(*((struct in_addr *)value)), 16);
		phnipend[15] = '\0';
	}
	else
		return -1;

	// HGW IP pool 
	if (mib_get(CWMP_CT_HGW_MINADDR, (void *)&value[0]) != 0)
	{
		strncpy(hgwipstart, inet_ntoa(*((struct in_addr *)value)), 16);
		hgwipstart[15] = '\0';
	}
	else
		return -1;

	if (mib_get(CWMP_CT_HGW_MAXADDR, (void *)&value[0]) != 0)
	{
		strncpy(hgwipend, inet_ntoa(*((struct in_addr *)value)), 16);
		hgwipend[15] = '\0';
	}
	else
		return -1;
#endif

	
	// IP max lease time
	if (mib_get(MIB_ADSL_LAN_DHCP_LEASE, (void *)&uLTime) == 0)
		return -1;
	
	if (mib_get(MIB_ADSL_LAN_DHCP_DOMAIN, (void *)domain) == 0)
		return -1;
	
	// get DNS mode
	if (mib_get(MIB_ADSL_WAN_DNS_MODE, (void *)value) != 0)
	{
		dnsMode = (DNS_TYPE_T)(*(unsigned char *)value);
	}
	else
		return -1;

	// Commented by Mason Yu for LAN_IP as DNS Server
#if 0		
	if (mib_get(MIB_ADSL_WAN_DNS1, (void *)value) != 0)
	{
		if (((struct in_addr *)value)->s_addr != 0)
		{
			strncpy(dns1, inet_ntoa(*((struct in_addr *)value)), 16);
			dns1[15] = '\0';
		}
		else
			dns1[0] = '\0';
	}
	else
		return -1;
	
	if (mib_get(MIB_ADSL_WAN_DNS2, (void *)value) != 0)
	{
		if (((struct in_addr *)value)->s_addr != 0)
		{
			strncpy(dns2, inet_ntoa(*((struct in_addr *)value)), 16);
			dns2[15] = '\0';
		}
		else
			dns2[0] = '\0';
	}
	else
		return -1;
	
	if (mib_get(MIB_ADSL_WAN_DNS3, (void *)value) != 0)
	{
		if (((struct in_addr *)value)->s_addr != 0)
		{
			strncpy(dns3, inet_ntoa(*((struct in_addr *)value)), 16);
			dns3[15] = '\0';
		}
		else
			dns3[0] = '\0';
	}
	else
		return -1;
#endif
		
	
	if ((fp = fopen(DHCPD_CONF, "w")) == NULL)
	{
		printf("Open file %s failed !\n", DHCPD_CONF);
		return -1;
	}
	
	if (mib_get(MIB_SPC_ENABLE, (void *)value) != 0)
	{
		if (value[0])
		{
			spc_enable = 1;
			mib_get(MIB_SPC_IPTYPE, (void *)value);
			spc_ip = (unsigned int)(*(unsigned char *)value);
		}
		else
			spc_enable = 0;
	}
	
	fprintf(fp, "interface %s\n", LANIF);
	if (spc_enable)
	{
		if (spc_ip == 0) { // single private ip
			fprintf(fp, "start %s\n", ipstart);
			fprintf(fp, "end %s\n", ipstart);
		}
		//else { // single shared ip
	}
	else
	{
		fprintf(fp, "start %s\n", ipstart);
		fprintf(fp, "end %s\n", ipend);
	}

#ifdef IP_BASED_CLIENT_TYPE
	fprintf(fp, "pcstart %s\n", pcipstart);
	fprintf(fp, "pcend %s\n", pcipend);
	fprintf(fp, "cmrstart %s\n", cmripstart);
	fprintf(fp, "cmrend %s\n", cmripend);
	fprintf(fp, "stbstart %s\n", stbipstart);
	fprintf(fp, "stbend %s\n", stbipend);
	fprintf(fp, "phnstart %s\n", phnipstart);
	fprintf(fp, "phnend %s\n", phnipend);
	fprintf(fp, "hgwstart %s\n", hgwipstart);
	fprintf(fp, "hgwend %s\n", hgwipend);
#endif
	
#ifdef IP_PASSTHROUGH
	ippt = 0;
	if (mib_get(MIB_IPPT_ITF, (void *)value) != 0)
		if (value[0] != 255) // IP passthrough
			ippt = 1;
	
	if (ippt)
	{
		fprintf(fp, "ippt yes\n");
		mib_get(MIB_IPPT_LEASE, (void *)&uInt);
		fprintf(fp, "ipptlt %d\n", uInt);
	}
#endif
	
	fprintf(fp, "opt subnet %s\n", dhcpsubnet);
	
	// Added by Mason Yu
	if (mib_get(MIB_ADSL_LAN_DHCP_GATEWAY, (void *)value) != 0)
	{
		strncpy(ipaddr2, inet_ntoa(*((struct in_addr *)value)), 16);
		ipaddr2[15] = '\0';
	}
	else
		return -1;
	fprintf(fp, "opt router %s\n", ipaddr2);
	
	// Modified by Mason Yu for LAN_IP as DNS Server
#if 0	
	if (dnsMode == DNS_AUTO)
	{
		fprintf(fp, "opt dns %s\n", ipaddr);
	}
	else	// DNS_MANUAL
	{
		if (dns1[0])
			fprintf(fp, "opt dns %s\n", dns1);
		if (dns2[0])
			fprintf(fp, "opt dns %s\n", dns2);
		if (dns3[0])
			fprintf(fp, "opt dns %s\n", dns3);
	}
#endif
	
	// Kaohj
#ifdef DHCPS_DNS_OPTIONS
	mib_get(MIB_DHCP_DNS_OPTION, (void *)value);
	if (value[0] == 0)
	fprintf(fp, "opt dns %s\n", dhcpip);
	else { // check manual setting
		mib_get(MIB_DHCPS_DNS1, (void *)&myip);
		strncpy(ipaddr, inet_ntoa(myip), 16);
		ipaddr[15] = '\0';
		fprintf(fp, "opt dns %s\n", ipaddr);
		mib_get(MIB_DHCPS_DNS2, (void *)&myip);
		printf("dns21=%d\n", value[0]);
		if (myip.s_addr != 0xffffffff) { // not empty
			strncpy(ipaddr, inet_ntoa(myip), 16);
			ipaddr[15] = '\0';
			fprintf(fp, "opt dns %s\n", ipaddr);
			mib_get(MIB_DHCPS_DNS3, (void *)&myip);
			if (myip.s_addr != 0xffffffff) { // not empty
				strncpy(ipaddr, inet_ntoa(myip), 16);
				ipaddr[15] = '\0';
				printf("dns3=%s\n", ipaddr);
				fprintf(fp, "opt dns %s\n", ipaddr);
			}
		}
	}
#else
	fprintf(fp, "opt dns %s\n", dhcpip);
#endif
	fprintf(fp, "opt lease %u\n", uLTime);
	if (domain[0])
		fprintf(fp, "opt domain %s\n", domain);
	else
		// per TR-068, I-188
		fprintf(fp, "opt domain domain_not_set.invalid\n");

#ifdef _CWMP_MIB_ /*jiunming, for cwmp-tr069*/
{
	//format: opt venspec [enterprise-number] [sub-option code] [sub-option data] ...
	//opt vendspec: dhcp option 125 Vendor-Identifying Vendor-Specific
	//enterprise-number: 3561(ADSL Forum)
	//sub-option code: 4(GatewayManufacturerOUI)
	//sub-option code: 5(GatewaySerialNumber)
	//sub-option code: 6(GatewayProductClass)
#if 1
	char opt125_buf[160];
	char opt125_sn[65]="";
	char opt125_oui[]="00E04C";
	
	if(mib_get(CWMP_SERIALNUMBER, (void *)opt125_sn) != 0)
	{
		sprintf( opt125_buf, "opt venspec 3561 4 %s 5 %s 6 IGD\n", opt125_oui, opt125_sn );
		fprintf( fp, "%s", opt125_buf);
	}
#else
	fprintf( fp, "opt venspec 3561 4 00e0d4 5 00000001 6 IGD\n" );
#endif
}
#endif
	
	fclose(fp);

//star: retain the lease file between during dhcdp restart
	if((fp = fopen(DHCPD_LEASE, "r")) == NULL)
	{
		if ((fp = fopen(DHCPD_LEASE, "w")) == NULL)
		{
			printf("Open file %s failed !\n", DHCPD_LEASE);
			return -1;
		}
		fprintf(fp, "\n");
		fclose(fp);
	}
	else
		fclose(fp);
	
	return 1;
}



// Added by Mason Yu for Dhcp Relay
// return value:
// 0  : not active
// 1  : active
// -1 : setup failed
int startDhcpRelay(void)
{
	unsigned char value[32];
	unsigned int dhcpmode;	
	char dhcps[16];
	int status=0;
	
	
	if (mib_get(MIB_DHCP_MODE, (void *)value) != 0)
	{
		dhcpmode = (unsigned int)(*(unsigned char *)value);
		if (dhcpmode != 1 )
			return 0;	// dhcp Relay not on
	}
	
	// DHCP Relay is on
	if (dhcpmode == 1) {
		
		//printf("DHCP Relay is on\n");
		
		if (mib_get(MIB_ADSL_WAN_DHCPS, (void *)value) != 0)
		{
			if (((struct in_addr *)value)->s_addr != 0)
			{
				strncpy(dhcps, inet_ntoa(*((struct in_addr *)value)), 16);
				dhcps[15] = '\0';
			}
			else
				dhcps[0] = '\0';
		}
		else
			return -1;
		
		//printf("dhcps = %s\n", dhcps);
		status=va_cmd("/bin/dhcrelay", 1, 0, dhcps);
		status=(status==-1)?-1:1;
			
		return status;
		
	}
	
}
static const char RESOLV[] = "/var/resolv.conf";
static const char MANUAL_RESOLV[] = "/var/resolv.manual.conf";
static const char DNS_RESOLV[] = "/var/udhcpc/resolv.conf";
static const char PPP_RESOLV[] = "/etc/ppp/resolv.conf";
static const char HOSTS[] = "/etc/config/hosts";

// DNS relay server configuration
// return value:
// 1  : successful
// -1 : startup failed
int startDnsRelay(BOOT_TYPE_T mode)
{
	unsigned char value[32];
	FILE *fp;
	DNS_TYPE_T dnsMode;
	char *str;
	unsigned int i, vcTotal, resolvopt;
	char dns1[16], dns2[16], dns3[16];
	char domain[MAX_NAME_LEN];
	
	if (mode != BOOT_LAST)
		return 1;
	
	if (mib_get(MIB_ADSL_WAN_DNS1, (void *)value) != 0)
	{
		if (((struct in_addr *)value)->s_addr != INADDR_NONE && ((struct in_addr *)value)->s_addr != 0)
		{
			strncpy(dns1, inet_ntoa(*((struct in_addr *)value)), 16);
			dns1[15] = '\0';
		}
		else
			dns1[0] = '\0';
	}
	else
		return -1;
	
	if (mib_get(MIB_ADSL_WAN_DNS2, (void *)value) != 0)
	{
		if (((struct in_addr *)value)->s_addr != INADDR_NONE && ((struct in_addr *)value)->s_addr != 0)
		{
			strncpy(dns2, inet_ntoa(*((struct in_addr *)value)), 16);
			dns2[15] = '\0';
		}
		else
			dns2[0] = '\0';
	}
	else
		return -1;
	
	if (mib_get(MIB_ADSL_WAN_DNS3, (void *)value) != 0)
	{
		if (((struct in_addr *)value)->s_addr != INADDR_NONE && ((struct in_addr *)value)->s_addr != 0)
		{
			strncpy(dns3, inet_ntoa(*((struct in_addr *)value)), 16);
			dns3[15] = '\0';
		}
		else
			dns3[0] = '\0';
	}
	else
		return -1;
	
	// get DNS mode
	if (mib_get(MIB_ADSL_WAN_DNS_MODE, (void *)value) != 0)
	{
		dnsMode = (DNS_TYPE_T)(*(unsigned char *)value);
	}
	else
		return -1;
	
	if ((fp = fopen(MANUAL_RESOLV, "w")) == NULL)
	{
		printf("Open file %s failed !\n", MANUAL_RESOLV);
		return -1;
	}
	
	if (dns1[0])
		fprintf(fp, "nameserver %s\n", dns1);
	if (dns2[0])
		fprintf(fp, "nameserver %s\n", dns2);
	if (dns3[0])
		fprintf(fp, "nameserver %s\n", dns3);
	fclose(fp);
	
	if (dnsMode == DNS_MANUAL)
	{
		// dnsmasq -h -i LANIF -r MANUAL_RESOLV
		TRACE(STA_INFO, "get DNS from manual\n");
		str=(char *)MANUAL_RESOLV;
	}
	else	// DNS_AUTO
	{
		MIB_CE_ATM_VC_T Entry;
		
		resolvopt = 0;
		vcTotal = mib_chain_total(MIB_ATM_VC_TBL);
		
		for (i = 0; i < vcTotal; i++)
		{
			/* get the specified chain record */
			if (!mib_chain_get(MIB_ATM_VC_TBL, i, (void *)&Entry))
				return -1;
			
			if (Entry.enable == 0)
				continue;
			
			if ((REMOTE_ACCESS_T)Entry.cmode == ACC_PPPOE ||
				(REMOTE_ACCESS_T)Entry.cmode == ACC_PPPOA)
				resolvopt = 1;
			else if ((DHCP_T)Entry.ipDhcp == DHCP_CLIENT)
				resolvopt = 2;
		}
		
		if (resolvopt == 1) // get from PPP
		{
			// dnsmasq -h -i LANIF -r PPP_RESOLV
			TRACE(STA_INFO, "get DNS from PPP\n");
			str=(char *)PPP_RESOLV;
		}
		else if (resolvopt == 2) // get from DHCP client
		{
			// dnsmasq -h -i LANIF -r DNS_RESOLV
			TRACE(STA_INFO, "get DNS from DHCP client\n");
			str=(char *)DNS_RESOLV;
		}
		else	// get from manual
		{
			// dnsmasq -h -i LANIF -r MANUAL_RESOLV
			TRACE(STA_INFO, "get DNS from manual\n");
			str=(char *)MANUAL_RESOLV;
		}
	}
	
	// create hosts file
	if ((fp = fopen(HOSTS, "w")) == NULL)
	{
		printf("Open file %s failed !\n", HOSTS);
		return -1;
	}
	
	// add DNS entry "dsldevice" for its own address
	mib_get(MIB_ADSL_LAN_IP, (void *)value);
	fprintf(fp, "%s\t", inet_ntoa(*((struct in_addr *)value)));
	// Modified by Mason Yu for dhcpmode
	//mib_get(MIB_ADSL_LAN_DHCP, (void *)value);
	mib_get(MIB_DHCP_MODE, (void *)value);
	
	if (value[0] == DHCP_SERVER)
	{	// add domain
		mib_get(MIB_ADSL_LAN_DHCP_DOMAIN, (void *)domain);
		if (domain[0])
			fprintf(fp, "dsldevice.%s ", domain);
	}
	
	fprintf(fp, "dsldevice\n");
	fclose(fp);

	#if 0
	//va_cmd(DNSRELAY, 4, 0, (char *)ARG_I, (char *)LANIF, "-r", str);
	if (va_cmd(DNSRELAY, 2, 0, "-r", str))
	    return -1;
	#endif

//star: for the dns restart
	if(unlink(RESOLV))
		printf("\nthe file resolv.conf doesn't exist!\n");
		
	if (symlink(str, RESOLV)) {
			printf("failed to link %s --> %s\n", str, RESOLV);
			return -1;
	}
	
	if (va_cmd(DNSRELAY, 2, 0, "-r", RESOLV))
	    return -1;
	
	return 1;
}

//ql: set firewall grade
//not take effect immediately while modify/add/del pvc
#ifdef FIREWALL_GRADE
#ifdef EMBED
const char PROC_NET_ATM_BR[] = "/proc/net/atm/br2684";
const char PPPOE_CONF[] = "/var/ppp/pppoe.conf";
const char PPPOA_CONF[] = "/var/ppp/pppoa.conf";
const char PPP_PID[] = "/var/run/spppd.pid";
#endif

WAN_STATE_T wanState;
//use fw_state_t to reserve the set state of firewall grade
FW_GRADE_INIT_St fw_state_t;

/**
*** return value: 0- fail;  1- success
**/
int initFw()
{
	char grade;

	if (!mib_get(MIB_FW_GRADE, (void *)&grade)) {
		printf("get fw grade fail\n");
		return 0;
	}
	printf("current firewall grade:%d\n", grade);
	memset(&fw_state_t, 0, sizeof(FW_GRADE_INIT_St));
	fw_state_t.preFwGrade = grade;

	//Add Chain(fwinput) for firewall
	va_cmd(IPTABLES, 2, 1, "-N", "fwinput");
	//Add Chain(fwforward) for firewall
	va_cmd(IPTABLES, 2, 1, "-N", "fwforward");
	//Add Chain(fwoutput) for firewall
	va_cmd(IPTABLES, 2, 1, "-N", "fwoutput");

	//iptables -A INPUT -j fwinput
	va_cmd(IPTABLES, 4, 1, (char *)FW_ADD, (char *)FW_INPUT, "-j", "fwinput");
	//iptables -A INPUT -j fwforward
	va_cmd(IPTABLES, 4, 1, (char *)FW_ADD, (char *)FW_FORWARD, "-j", "fwforward");
	//iptables -A INPUT -j fwoutput
	va_cmd(IPTABLES, 4, 1, (char *)FW_ADD, "OUTPUT", "-j", "fwoutput");

	//clear all chain
	va_cmd(IPTABLES, 2, 1, "-F", "fwinput");
	va_cmd(IPTABLES, 2, 1, "-F", "fwforward");
	va_cmd(IPTABLES, 2, 1, "-F", "fwoutput");
	
	return 1;
}

#if 0
int initFwSet(int linkMode)
{
	int inAddr, inMask;
	char strLanIp[20];
	int i, maskBit;
	
	if (!linkMode)//link down
	{//initialize firewall
		//get br0 IP/MASK
		if ((getInAddr( "br0", IP_ADDR, (void *)&inAddr) == 1) &&
			(getInAddr( "br0", SUBNET_MASK, (void *)&inMask) == 1))
		{
			for (i=0; i<32; i++)
				if ((inMask>>i) & 0x01)
					break;
			maskBit = 32 - i;

			inAddr &= inMask;

			snprintf(strLanIp, 20, "%s/%d", inet_ntoa(*(struct in_addr *)&inAddr), maskBit);
		}
		//iptables -I FOWRARD 1 -i br1 -d 192.168.1.0/24 -j ACCEPT
		va_cmd(IPTABLES, 9, 1, (char *)FW_INSERT, (char *)FW_FORWARD, "1", (char *)ARG_I, 
			"br1", "-d", strLanIp, "-j", (char *)FW_ACCEPT);
		//iptables -I FORWARD 2 -i br1 -j DROP
		va_cmd(IPTABLES, 7, 1, (char *)FW_INSERT, (char *)FW_FORWARD, "2", (char *)ARG_I, 
			"br1", "-j", (char *)FW_DROP);
		
		fw_state_t.linkDownInit = 1;
	}
	else //link up
	{
		//iptables -A INPUT -p 2 -j ACCEPT
		va_cmd(IPTABLES, 6, 1, (char *)FW_ADD, (char *)FW_INPUT, "-p", "2", "-j", 
			(char *)FW_ACCEPT);
		//iptables -I FORWARD 1 -d 224.0.0.0/3 -j ACCEPT
		va_cmd(IPTABLES, 7, 1, (char *)FW_INSERT, (char *)FW_FORWARD, "1", "-d", 
			"224.0.0.0/3", "-j", (char *)FW_ACCEPT);

		fw_state_t.linkUpInit = 1;
	}

	return 1;
}
#endif
int initFwSet()
{
	int inAddr, inMask;
	char strLanIp[20];
	int i, maskBit;
	
	//get br0 IP/MASK
	if ((getInAddr( "br0", IP_ADDR, (void *)&inAddr) == 1) &&
		(getInAddr( "br0", SUBNET_MASK, (void *)&inMask) == 1))
	{
		for (i=0; i<32; i++)
			if ((inMask>>i) & 0x01)
				break;
		maskBit = 32 - i;

		inAddr &= inMask;
		snprintf(strLanIp, 20, "%s/%d", inet_ntoa(*(struct in_addr *)&inAddr), maskBit);
	}
	
	//iptables -A INPUT -p 2 -j ACCEPT
	va_cmd(IPTABLES, 6, 1, (char *)FW_ADD, "fwinput", "-p", "2", "-j", 
		(char *)FW_ACCEPT);

	//iptables -I FORWARD 1 -d 224.0.0.0/3 -j ACCEPT
	va_cmd(IPTABLES, 7, 1, (char *)FW_INSERT, "fwforward", "1", "-d", 
		"224.0.0.0/3", "-j", (char *)FW_ACCEPT);
	//iptables -I FOWRARD 2 -i br1 -d 192.168.1.0/24 -j ACCEPT
	va_cmd(IPTABLES, 9, 1, (char *)FW_INSERT, "fwforward", "2", (char *)ARG_I, 
		"br1", "-d", strLanIp, "-j", (char *)FW_ACCEPT);
	//iptables -I FORWARD 3 -i br1 -j DROP
	va_cmd(IPTABLES, 7, 1, (char *)FW_INSERT, "fwforward", "3", (char *)ARG_I, 
		"br1", "-j", (char *)FW_DROP);

	return 1;
}

int addDfGwInputRule(VC_STATE_Pt pEntry, int enable)
{
	if (enable) {
		//iptables -I INPUT 1 -i vc0 -p udp --dport 7070:7079 -j ACCEPT
		va_cmd(IPTABLES, 11, 1, (char *)FW_INSERT, "fwinput", "1", (char *)ARG_I, 
			pEntry->ifName, "-p", "udp", "--dport", "7070:7079", "-j", (char *)FW_ACCEPT);
		//iptables -I INPUT 2 -i vc0 -p udp --dport 5064 -j ACCEPT
		va_cmd(IPTABLES, 11, 1, (char *)FW_INSERT, "fwinput", "2", (char *)ARG_I, 
			pEntry->ifName, "-p", "udp", "--dport", "5064", "-j", (char *)FW_ACCEPT);
		//iptables -I INPUT 3 -i vc0 -p udp --dport 5060 -j ACCEPT
		va_cmd(IPTABLES, 11, 1, (char *)FW_INSERT, "fwinput", "3", (char *)ARG_I, 
			pEntry->ifName, "-p", "udp", "--dport", "5060", "-j", (char *)FW_ACCEPT);
	} else {
		//iptables -D INPUT -i vc0 -p udp --dport 7070:7079 -j ACCEPT
		va_cmd(IPTABLES, 10, 1, (char *)FW_DEL, "fwinput", (char *)ARG_I, 
			pEntry->ifName, "-p", "udp", "--dport", "7070:7079", "-j", (char *)FW_ACCEPT);
		//iptables -D INPUT -i vc0 -p udp --dport 5064 -j ACCEPT
		va_cmd(IPTABLES, 10, 1, (char *)FW_DEL, "fwinput", (char *)ARG_I, 
			pEntry->ifName, "-p", "udp", "--dport", "5064", "-j", (char *)FW_ACCEPT);
		//iptables -D INPUT -i vc0 -p udp --dport 5060 -j ACCEPT
		va_cmd(IPTABLES, 10, 1, (char *)FW_DEL, "fwinput", (char *)ARG_I, 
			pEntry->ifName, "-p", "udp", "--dport", "5060", "-j", (char *)FW_ACCEPT);
	}

	return 1;
}

int addFstPvcInputRule(VC_STATE_Pt pEntry, int enable)
{
	int inAddr, inMask;
	char strLanIp[20];
	int i, maskBit;

	//get br0 IP/MASK
	if ((getInAddr( "br0", IP_ADDR, (void *)&inAddr) == 1) &&
		(getInAddr( "br0", SUBNET_MASK, (void *)&inMask) == 1))
	{
		for (i=0; i<32; i++)
			if ((inMask>>i) & 0x01)
				break;
		maskBit = 32 - i;

		inAddr &= inMask;
		snprintf(strLanIp, 20, "%s/%d", inet_ntoa(*(struct in_addr *)&inAddr), maskBit);
	}

	if (enable) {
		//iptables -I INPUT 1 -i vc0 -p tcp --dport 9080 -j ACCEPT
		va_cmd(IPTABLES, 11, 1, (char *)FW_INSERT, "fwinput", "1", (char *)ARG_I, 
			pEntry->ifName, "-p", "tcp", "--dport", "9080", "-j", (char *)FW_ACCEPT);
		//iptables -I INPUT 2 -i vc0 -p udp -s 192.168.1.0/24 --dport 30006 -j ACCEPT
		va_cmd(IPTABLES, 13, 1, (char *)FW_INSERT, "fwinput", "2", (char *)ARG_I, 
			pEntry->ifName, "-p", "udp", "-s", strLanIp, "--dport", "30006", "-j", (char *)FW_ACCEPT);
		//iptables -I INPUT 3 -i vc0 -p tcp --dport 30005 -j ACCEPT
		va_cmd(IPTABLES, 11, 1, (char *)FW_INSERT, "fwinput", "3", (char *)ARG_I, 
			pEntry->ifName, "-p", "tcp", "--dport", "30005", "-j", (char *)FW_ACCEPT);
		//iptables -I INPUT 4 -i vc0 -p tcp --dport 21 -j ACCEPT
		//va_cmd(IPTABLES, 11, 1, (char *)FW_INSERT, "fwinput", "4", (char *)ARG_I, 
		//	pEntry->ifName, "-p", "tcp", "--dport", "21", "-j", (char *)FW_ACCEPT);
	} else {
		//iptables -D INPUT -i vc0 -p tcp --dport 9080 -j ACCEPT
		va_cmd(IPTABLES, 10, 1, (char *)FW_DEL, "fwinput", (char *)ARG_I, 
			pEntry->ifName, "-p", "tcp", "--dport", "9080", "-j", (char *)FW_ACCEPT);
		//iptables -D INPUT -i vc0 -p udp -s 192.168.1.0/24 --dport 30006 -j ACCEPT
		va_cmd(IPTABLES, 12, 1, (char *)FW_DEL, "fwinput", (char *)ARG_I, 
			pEntry->ifName, "-p", "udp", "-s", strLanIp, "--dport", "30006", "-j", (char *)FW_ACCEPT);
		//iptables -D INPUT -i vc0 -p tcp --dport 30005 -j ACCEPT
		va_cmd(IPTABLES, 10, 1, (char *)FW_DEL, "fwinput", (char *)ARG_I, 
			pEntry->ifName, "-p", "tcp", "--dport", "30005", "-j", (char *)FW_ACCEPT);
		//iptables -D INPUT -i vc0 -p tcp --dport 21 -j ACCEPT
		//va_cmd(IPTABLES, 10, 1, (char *)FW_DEL, "fwinput", (char *)ARG_I, 
		//	pEntry->ifName, "-p", "tcp", "--dport", "21", "-j", (char *)FW_ACCEPT);
	}

	return 1;
}

int addLowGradeRule(VC_STATE_Pt pEntry, int enable)
{
	if (enable) {
		//iptables -I INPUT 1 -i vc0 -p udp --dport 69 -j ACCEPT
		//va_cmd(IPTABLES, 11, 1, (char *)FW_INSERT, "fwinput", "1", (char *)ARG_I, 
		//	pEntry->ifName, "-p", "udp", "--dport", "69", "-j", (char *)FW_ACCEPT);
		//iptables -I INPUT 2 -i vc0 -p tcp --dport 23 -j ACCEPT
		//va_cmd(IPTABLES, 11, 1, (char *)FW_INSERT, "fwinput", "2", (char *)ARG_I, 
		//	pEntry->ifName, "-p", "tcp", "--dport", "23", "-j", (char *)FW_ACCEPT);
		//iptables -I INPUT 3 -i vc0 -p icmp --icmp-type 8 -j ACCEPT
		va_cmd(IPTABLES, 11, 1, (char *)FW_INSERT, "fwinput", "3", (char *)ARG_I, 
			pEntry->ifName, "-p", "icmp", "--icmp-type", "8", "-j", (char *)FW_ACCEPT);
		//iptables -I INPUT 4 -i vc0 -p tcp --dport 80 -j ACCEPT
		//va_cmd(IPTABLES, 11, 1, (char *)FW_INSERT, "fwinput", "4", (char *)ARG_I, 
		//	pEntry->ifName, "-p", "tcp", "--dport", "80", "-j", (char *)FW_ACCEPT);
	} else {
		//iptables -D INPUT -i vc0 -p udp --dport 69 -j ACCEPT
		//va_cmd(IPTABLES, 10, 1, (char *)FW_DEL, "fwinput", (char *)ARG_I, 
		//	pEntry->ifName, "-p", "udp", "--dport", "69", "-j", (char *)FW_ACCEPT);
		//iptables -D INPUT -i vc0 -p tcp --dport 23 -j ACCEPT
		//va_cmd(IPTABLES, 10, 1, (char *)FW_DEL, "fwinput", (char *)ARG_I, 
		//	pEntry->ifName, "-p", "tcp", "--dport", "23", "-j", (char *)FW_ACCEPT);
		//iptables -D INPUT -i vc0 -p icmp --icmp-type 8 -j ACCEPT
		va_cmd(IPTABLES, 10, 1, (char *)FW_DEL, "fwinput", (char *)ARG_I, 
			pEntry->ifName, "-p", "icmp", "--icmp-type", "8", "-j", (char *)FW_ACCEPT);
		//iptables -D INPUT -i vc0 -p tcp --dport 80 -j ACCEPT
		//va_cmd(IPTABLES, 10, 1, (char *)FW_DEL, "fwinput", (char *)ARG_I, 
		//	pEntry->ifName, "-p", "tcp", "--dport", "80", "-j", (char *)FW_ACCEPT);
	}

	return 1;
}

/**
*** parameters:
***    ifName: interface name
***    xDSLMode: show if is route only or route&bridge; see setFirewallGrade()
***   currGrade: firewall grade to be set;
***   enable: enable/disable one PVC
**/
int setupFWRule(VC_STATE_Pt pEntry, int enable)
{
	int inAddr, inMask;
	char strLanIp[20];
	int i, maskBit;
	char *pAction;
	int currGrade;
	char ipfilterEn;	//show if ip filter is enabled

	//check if ipfilter is enabled, set to 1 to test.
	ipfilterEn = 1;

	if (enable)
		pAction = (char *)FW_ADD;
	else
		pAction = (char *)FW_DEL;
	
	/************************  INPUT chain  ************************/
	if (!ipfilterEn) {//disable ip filter
		if (pEntry->dfGW) {//only add rules for default GW itf
			addDfGwInputRule(pEntry, enable);
		}
	} else {
		if (((char)PPPOE_ONLY == wanState.wanItf) || 
			((char)MER_ONLY == wanState.wanItf)) {//we consider first PVC to be default gw
			if (1 == pEntry->fstPvc)
			{
				addFstPvcInputRule(pEntry, enable);
				
				if (((wanState.ifNum > 1)&&((ADSL_PPPoE==pEntry->chMode)||(ADSL_PPPoA==pEntry->chMode))) ||
					((ADSL_MER1483==pEntry->chMode)&&(1==pEntry->dfGW))) {
					addDfGwInputRule(pEntry, enable);
				}
			}
			else
			{
				/*if (enable) {
					//iptables -I INPUT 4 -i vc0 -p tcp --dport 21 -j ACCEPT
					va_cmd(IPTABLES, 11, 1, (char *)FW_INSERT, "fwinput", 4, (char *)ARG_I, 
						pEntry->ifName, "-p", "tcp", "--dport", "21", "-j", (char *)FW_ACCEPT);
				} else {
					//iptables -D INPUT -i vc0 -p tcp --dport 21 -j ACCEPT
					va_cmd(IPTABLES, 10, 1, (char *)FW_DEL, "fwinput", (char *)ARG_I, 
						pEntry->ifName, "-p", "tcp", "--dport", "21", "-j", (char *)FW_ACCEPT);
				}*/
				
				if ((ADSL_MER1483 == pEntry->chMode) && (1 == pEntry->dfGW))
					addDfGwInputRule(pEntry, enable);
			}
		}
		else if ((char)PPP_MER == wanState.wanItf) {//we think first pvc to be default gw
			if (1 == pEntry->fstPvc)
			{
				addFstPvcInputRule(pEntry, enable);

				if ((ADSL_MER1483 == pEntry->fstPvc) && (1 == pEntry->dfGW)) {
					addDfGwInputRule(pEntry, enable);
				}
			}
			else
			{
				/*if (enable) {
					//iptables -I INPUT 1 -i vc0 -p tcp --dport 21 -j ACCEPT
					va_cmd(IPTABLES, 11, 1, (char *)FW_INSERT, "fwinput", "1", (char *)ARG_I, 
						pEntry->ifName, "-p", "tcp", "--dport", "21", "-j", (char *)FW_ACCEPT);
				} else {
					//iptables -D INPUT -i vc0 -p tcp --dport 21 -j ACCEPT
					va_cmd(IPTABLES, 10, 1, (char *)FW_DEL, "fwinput", (char *)ARG_I, 
						pEntry->ifName, "-p", "tcp", "--dport", "21", "-j", (char *)FW_ACCEPT);
				}*/
				
				if ((ADSL_MER1483 == pEntry->chMode) && (1 == pEntry->dfGW))
					addDfGwInputRule(pEntry, enable);
			}
		}
		//check firewall grade
		if (!mib_get(MIB_FW_GRADE, (void *)&currGrade))
			printf("fatal error %s %s %d\n", __FILE__, __FUNCTION__, __LINE__);
		if ((char)FW_HIGH != currGrade) {
			addLowGradeRule(pEntry, enable);
		}

		//iptables -A INPUT -i vc0 -m state --state RELATED,ESTABLISHED -J ACCEPT
		/*va_cmd(IPTABLES, 10, 1, pAction, "fwinput", (char *)ARG_I, pEntry->ifName, 
			"-m", "state", "--state", "RELATED,ESTABLISHED", "-j", (char *)FW_ACCEPT);*/
		//iptables -A INPUT -i vc0 -p tcp --tcp-flags SYN,RST,ACK SYN -m limit --limit 6/hour --limit-burst 5 
		// -j LOG --log-level alert --log-prefix "Intrusion -> "
		va_cmd(IPTABLES, 21, 1, pAction, "fwinput", (char *)ARG_I, pEntry->ifName, 
			"-p", "tcp", "--tcp-flags", "SYN,RST,ACK", "SYN", "-m", "limit", "--limit", 
			"6/hour", "--limit-burst", "5", "-j", "LOG", "--log-level", "alert", "--log-prefix", 
			"Intrusion -> ");
		//iptables -A INPUT -i vc0 -j DROP
		va_cmd(IPTABLES, 6, 1, pAction, "fwinput", (char *)ARG_I, pEntry->ifName, 
			"-j", (char *)FW_DROP);
	}

	/************************  FORWARD chain  ************************/
	if ((char)WAN_ROUTE == wanState.xDSLMode) {//no bridge
		if (enable) {
			//iptables -I FORWARD 1 -i vc0 -d 239.255.255.250 -j ACCEPT
			va_cmd(IPTABLES, 9, 1, (char *)FW_INSERT, "fwforward", "1", (char *)ARG_I, 
				pEntry->ifName, "-d", "239.255.255.250", "-j", (char *)FW_ACCEPT);
		} else {
			//iptables -D FORWARD -i vc0 -d 239.255.255.250 -j ACCEPT
			va_cmd(IPTABLES, 8, 1, (char *)FW_DEL, "fwforward", (char *)ARG_I, 
				pEntry->ifName, "-d", "239.255.255.250", "-j", (char *)FW_ACCEPT);
		}
	} else {//route&bridge
		if (enable) {
			//iptables -I FORWARD 1 -i vc0 -d 239.255.255.254 -j ACCEPT
			va_cmd(IPTABLES, 9, 1, (char *)FW_INSERT, "fwforward", "1", (char *)ARG_I, 
				pEntry->ifName, "-d", "239.255.255.254", "-j", (char *)FW_ACCEPT);
			//iptables -I FORWARD 2 -i vc0 -d 224.2.127.254 -j ACCEPT
			va_cmd(IPTABLES, 9, 1, (char *)FW_INSERT, "fwforward", "2", (char *)ARG_I, 
				pEntry->ifName, "-d", "224.2.127.254", "-j", (char *)FW_ACCEPT);
			//iptables -I FORWARD 3 -i vc0 -d 239.255.255.250 -j ACCEPT
			va_cmd(IPTABLES, 9, 1, (char *)FW_INSERT, "fwforward", "3", (char *)ARG_I, 
				pEntry->ifName, "-d", "239.255.255.250", "-j", (char *)FW_ACCEPT);
		} else {
			//iptables -D FORWARD -i vc0 -d 239.255.255.254 -j ACCEPT
			va_cmd(IPTABLES, 8, 1, (char *)FW_DEL, "fwforward", (char *)ARG_I, 
				pEntry->ifName, "-d", "239.255.255.254", "-j", (char *)FW_ACCEPT);
			//iptables -D FORWARD -i vc0 -d 224.2.127.254 -j ACCEPT
			va_cmd(IPTABLES, 8, 1, (char *)FW_DEL, "fwforward", (char *)ARG_I, 
				pEntry->ifName, "-d", "224.2.127.254", "-j", (char *)FW_ACCEPT);
			//iptables -D FORWARD -i vc0 -d 239.255.255.250 -j ACCEPT
			va_cmd(IPTABLES, 8, 1, (char *)FW_DEL, "fwforward", (char *)ARG_I, 
				pEntry->ifName, "-d", "239.255.255.250", "-j", (char *)FW_ACCEPT);
		}
		
		if ((char)PPPOE_ONLY != wanState.wanItf) {
			if (enable) {
				//iptables -I FORWARD 4 -i vc0 -d 224.0.0.251 -j ACCEPT
				va_cmd(IPTABLES, 9, 1, (char *)FW_INSERT, "fwforward", "4", (char *)ARG_I, 
					pEntry->ifName, "-d", "224.0.0.251", "-j", (char *)FW_ACCEPT);
			} else {
				//iptables -D FORWARD -i vc0 -d 224.0.0.251 -j ACCEPT
				va_cmd(IPTABLES, 8, 1, (char *)FW_DEL, "fwforward", (char *)ARG_I, 
					pEntry->ifName, "-d", "224.0.0.251", "-j", (char *)FW_ACCEPT);
			}
		}
	}

	//for PPP channel, we should set TCPMSS target
	if (ADSL_PPPoE==pEntry->chMode) {
		//iptables -A FORWARD -o vc0 -p tcp --tcp-flags SYN,RST SYN -j TCPMSS --clamp-mss-to-pmtu
		va_cmd(IPTABLES, 12, 1, pAction, "fwforward", (char *)ARG_O, pEntry->ifName, 
			"-p", "tcp", "--tcp-flags", "SYN,RST", "SYN", "-j", "TCPMSS", "--clamp-mss-to-pmtu");
		////iptables -A FORWARD -i vc0 -p tcp --tcp-flags SYN,RST SYN -j TCPMSS --clamp-mss-to-pmtu
		va_cmd(IPTABLES, 12, 1, pAction, "fwforward", (char *)ARG_I, pEntry->ifName, 
			"-p", "tcp", "--tcp-flags", "SYN,RST", "SYN", "-j", "TCPMSS", "--clamp-mss-to-pmtu");
	}
	//iptables -A FORWARD -i vc0 -m state --state RELATED,ESTABLISHED -J ACCEPT
	/*va_cmd(IPTABLES, 10, 1, pAction, "fwforward", (char *)ARG_I, pEntry->ifName, 
		"-m", "state", "--state", "RELATED,ESTABLISHED", "-j", (char *)FW_ACCEPT);*/
	//iptables -A FORWARD -i vc0 -p tcp --tcp-flags SYN,RST,ACK SYN -m limit --limit 6/hour --limit-burst 5 
	// -j LOG --log-level alert --log-prefix "Intrusion -> "
	va_cmd(IPTABLES, 21, 1, pAction, "fwforward", (char *)ARG_I, pEntry->ifName, 
		"-p", "tcp", "--tcp-flags", "SYN,RST,ACK", "SYN", "-m", "limit", "--limit", 
		"6/hour", "--limit-burst", "5", "-j", "LOG", "--log-level", "alert", "--log-prefix", 
		"Intrusion -> ");
	//iptables -A FORWARD -i vc0 -j DROP
	va_cmd(IPTABLES, 6, 1, pAction, "fwforward", (char *)ARG_I, pEntry->ifName, 
		"-j", (char *)FW_DROP);
	
	/************************  OUTPUT chain  ************************/
	if ((ADSL_MER1483 == pEntry->chMode) && (1 == pEntry->dfGW)) {
		//iptables -A OUTPUT -o vc0 -d 239.255.255.250 -j DROP
		va_cmd(IPTABLES, 8, 1, pAction, "fwoutput", (char *)ARG_O, pEntry->ifName, 
			"-d", "239.255.255.250", "-j", (char *)FW_DROP);
	}

	return 1;
}

#if 0
int setFirewallGrade()
{
	unsigned char pppItf=0;
	unsigned char merItf=0;
	unsigned char brgItf=0;
	char fstPvcSel=0;
	//char xDSLMode=0;	//0- no WAN interface;  1- bridge only;  2- route only;  3- bridge+route
	unsigned int data, data2;
	char	buff[256], tmp1[20], tmp2[20];
	int in_turn=0, vccount=0, ifcount=0;
	int i, ifindices[256], br_socket_fd, spid, adslflag=0;
	unsigned long arg[4];
	struct ifreq ifr;
	FILE *fp;
	struct flock flpoe, flpoa;
	int fdpoe, fdpoa;
	Modem_LinkSpeed vLs;
	char ifname[6];
	int mibCnt;
	int totalNum;
	MIB_CE_ATM_VC_T entry;
	VC_STATE_T vcState;
	struct status_info {
		char ifname[IFNAMSIZ];
		char devname[IFNAMSIZ];
		unsigned int tvpi;
		unsigned int tvci;
		char protocol[10];
		unsigned char cmode;
		unsigned char fstPvc;
		unsigned char dfGW;
	};
	struct status_info sEntry[MAX_VC_NUM+MAX_PPP_NUM];
	struct status_info vcEntry[MAX_VC_NUM];

	/** check if there is route mode PVC existed, if no available route PVC exists, dont start firewall.
	**  if link is down, dont start firewall
	*/
	//first, check for xDSL link
	if (!adsl_drv_get(RLCM_GET_LINK_SPEED, (void *)&vLs, RLCM_GET_LINK_SPEED_SIZE) || vLs.upstreamRate == 0)
		adslflag = 0;
	else
		adslflag = 1;

#ifdef EMBED
	// get spppd pid
	if ((fp = fopen(PPP_PID, "r"))) {
		fscanf(fp, "%d\n", &spid);
		fclose(fp);
	}
	else
		printf("spppd pidfile not exists\n");
	
	kill(spid, SIGUSR2);
#endif

	in_turn = 0;
#ifdef EMBED
	if (!(fp=fopen(PROC_NET_ATM_BR, "r"))) {
		printf("%s not exists.\n", PROC_NET_ATM_BR);
	} else {
		while ( fgets(buff, sizeof(buff), fp) != NULL ) {
			if (in_turn==0)
				if(sscanf(buff, "%*s%s", tmp1)!=1) {
					printf("Unsuported pvc configuration format\n");
					break;
				}
				else {
					vccount ++;
					tmp1[strlen(tmp1)-1]='\0';
					strcpy(vcEntry[vccount-1].ifname, tmp1);
					strcpy(vcEntry[vccount-1].devname, tmp1);
				}
			else
				if(sscanf(buff, "%*s%s%*s%s", tmp1, tmp2)!=2) {
					printf("Unsuported pvc configuration format\n");
					break;
				}
				else {
					sscanf(tmp1, "0.%u.%u:", &vcEntry[vccount-1].tvpi, &vcEntry[vccount-1].tvci);
					sscanf(tmp2, "%u,", &data);
					strcpy(vcEntry[vccount-1].protocol, "");
					if (data==3 || data==4) {
						strcpy(vcEntry[vccount-1].protocol, "rt1483");
						vcEntry[vccount-1].cmode = ADSL_RT1483;
						merItf++;
					}
					vcEntry[vccount-1].fstPvc = 0;
					vcEntry[vccount-1].dfGW = 0;
				}
			in_turn ^= 0x01;
		}
		fclose(fp);
	}
	if (0 == vccount) {//no wan interface
		wanState.xDSLMode = (char)WAN_INVALID;
		return 0;
	}

	//following only process the condition with wan interface...
	// file locking
	fdpoe = open(PPPOE_CONF, O_RDWR);
	fdpoa = open(PPPOA_CONF, O_RDWR);
	if ((fdpoe != -1) && (fdpoe != -1)) {
		flpoe.l_type = flpoa.l_type = F_RDLCK;
		flpoe.l_whence = flpoa.l_whence = SEEK_SET;
		flpoe.l_start = flpoa.l_start = 0;
		flpoe.l_len = flpoa.l_len = 0;
		flpoe.l_pid = flpoa.l_pid = getpid();
		if (fcntl(fdpoe, F_SETLKW, &flpoe) == -1)
			printf("pppoe read lock failed\n");
		if (fcntl(fdpoa, F_SETLKW, &flpoa) == -1)
			printf("pppoa read lock failed\n");
	}
	
	if (!(fp=fopen(PPPOA_CONF, "r")))
		printf("%s not exists.\n", PPPOA_CONF);
	else {
		fgets(buff, sizeof(buff), fp);
		while ( fgets(buff, sizeof(buff), fp) != NULL ) {
			if (sscanf(buff, "%s%u%u%*s%*s%*s%*d%*d%*d%*s%*s", tmp1, &data, &data2) != 3) {
				printf("Unsuported pppoa configuration format\n");
				break;
			}
			else {
				ifcount ++;
				strcpy(sEntry[ifcount-1].ifname, tmp1);
				strcpy(sEntry[ifcount-1].protocol, "PPPoA");
				sEntry[ifcount-1].cmode = ADSL_PPPoA;
				sEntry[ifcount-1].fstPvc = 0;
				sEntry[ifcount-1].dfGW = 0;
				sEntry[ifcount-1].tvpi = data;
				sEntry[ifcount-1].tvci = data2;
				pppItf++;
			}
		}
		fclose(fp);
	}

	if (!(fp=fopen(PPPOE_CONF, "r")))
		printf("%s not exists.\n", PPPOE_CONF);
	else {
		fgets(buff, sizeof(buff), fp);
		while ( fgets(buff, sizeof(buff), fp) != NULL )
			if(sscanf(buff, "%s%s%*s%*s%*s%*s%*s", tmp1, tmp2) != 2) {
				printf("Unsuported pppoe configuration format\n");
				break;
			} else {
				for (i=0; i<vccount; i++) {
					if (strcmp(vcEntry[i].devname, tmp2) == 0) {
						ifcount ++;
						strcpy(sEntry[ifcount-1].ifname, tmp1);
						strcpy(sEntry[ifcount-1].devname, vcEntry[i].devname);
						strcpy(sEntry[ifcount-1].protocol, "PPPoE");
						sEntry[ifcount-1].cmode = ADSL_PPPoE;
						sEntry[ifcount-1].fstPvc = 0;
						sEntry[ifcount-1].dfGW = 0;
						sEntry[ifcount-1].tvpi = vcEntry[i].tvpi;
						sEntry[ifcount-1].tvci = vcEntry[i].tvci;
						pppItf++;
					}
				}
			}
		fclose(fp);
	}

	// file unlocking
	if ((fdpoe != -1) && (fdpoe != -1)) {
		flpoe.l_type = flpoa.l_type = F_UNLCK;
		if (fcntl(fdpoe, F_SETLK, &flpoe) == -1)
			printf("pppoe read unlock failed\n");
		if (fcntl(fdpoa, F_SETLK, &flpoa) == -1)
			printf("pppoa read unlock failed\n");
		close(fdpoe);
		close(fdpoa);
	}
	
	for (i=0; i<vccount; i++) {
		int j, vcfound=0;
		for (j=0; j<ifcount; j++)
			if (strcmp(vcEntry[i].ifname, sEntry[j].devname) == 0) {	// PPPoE-used device
				vcfound = 1;
				break;
			}
		if (!vcfound) {	// VC not used for PPPoE, add to list
			ifcount ++;
			strcpy(sEntry[ifcount-1].ifname, vcEntry[i].ifname);
			strcpy(sEntry[ifcount-1].protocol, vcEntry[i].protocol);
			sEntry[ifcount-1].tvpi = vcEntry[i].tvpi;
			sEntry[ifcount-1].tvci = vcEntry[i].tvci;
			sEntry[ifcount-1].cmode = vcEntry[i].cmode;
		}
	}
#endif
	totalNum = mib_chain_total(MIB_ATM_VC_TBL);
	for (i=0; i<ifcount; i++) {
		if (!strcmp(sEntry[i].protocol, ""))
		{
			for(mibCnt=0; mibCnt<totalNum; mibCnt++)
			{
				if (!mib_chain_get(MIB_ATM_VC_TBL, mibCnt, (void *)&entry))
				{
					printf("get MIB chain error\n");
					return -1;
				}
				if(entry.cmode == ADSL_PPPoE || entry.cmode == ADSL_PPPoA)//star:for multi-ppp name
					snprintf(ifname, 6, "ppp%u", PPP_INDEX(entry.ifIndex));
				else
					snprintf(ifname, 6, "vc%u", VC_INDEX(entry.ifIndex));
				if(entry.vpi==sEntry[i].tvpi && entry.vci==sEntry[i].tvci && !strcmp(ifname,sEntry[i].ifname))
				{
					switch(entry.cmode) {
					case ADSL_MER1483:
						snprintf(sEntry[i].protocol, 10, "mer1483");
						sEntry[i].cmode = ADSL_MER1483;
						merItf++;
						break;
					case ADSL_BR1483:
						snprintf(sEntry[i].protocol, 10, "br1483");
						sEntry[i].cmode = ADSL_BR1483;
						brgItf++;
						break;
					default:
						break;
					}
					break;
				}
			}
		}
	}

	if (brgItf && !merItf && !pppItf)
		wanState.xDSLMode = (char)WAN_BRG; //bridge only
	else if (!brgItf && (merItf || pppItf))
		wanState.xDSLMode = (char)WAN_ROUTE; //route only
	else if (brgItf && (merItf || pppItf))
		wanState.xDSLMode = (char)BRG_RTE; //bridge+route
		
	if ((char)WAN_BRG == wanState.xDSLMode) //bridge only
		return 0;

	if (merItf && !pppItf)
		wanState.wanItf = (char)MER_ONLY;
	else if (!merItf && pppItf)
		wanState.wanItf = (char)PPPOE_ONLY;
	else
		wanState.wanItf = (char)PPP_MER;

	wanState.ifNum = merItf+pppItf;

	printf("begin to set firewall grade -> \n");
	if (adslflag == 0) {//xDSL link down
		if (!fw_state_t.linkDownInit)
			initFwSet(adslflag);
		return 1;
	} else {
		//xDSL link up
		if (!fw_state_t.linkDownInit)
			initFwSet(0);
		if (!fw_state_t.linkUpInit)
			initFwSet(1);
	}
	//check first pvc and df gw
	for (mibCnt=0; mibCnt<totalNum; mibCnt++)
	{
		int j;
		
		if (!mib_chain_get(MIB_ATM_VC_TBL, mibCnt, (void *)&entry))
		{
			printf("get MIB chain error\n");
			return -1;
		}
		if (entry.cmode == ADSL_BR1483)
			continue;
		
		if (!fstPvcSel) {
			if(entry.cmode == ADSL_PPPoE || entry.cmode == ADSL_PPPoA)//star:for multi-ppp name
				snprintf(ifname, 6, "ppp%u", PPP_INDEX(entry.ifIndex));
			else
				snprintf(ifname, 6, "vc%u", VC_INDEX(entry.ifIndex));
			for (j=0; j<ifcount; j++)
			{
				if(entry.vpi==sEntry[j].tvpi && entry.vci==sEntry[j].tvci && !strcmp(ifname,sEntry[j].ifname))
				{
					sEntry[j].fstPvc = 1;
					fstPvcSel = 1;
				}
			}
		}
		if (entry.dgw) {
			sEntry[j].dfGW = 1;
			break;
		}
	}
	//now we only process the condition that is route only or bridge&route
	for (i=0; i<ifcount; i++) {
		struct in_addr inAddr;
		int flags;
		
		// set status flag
		if (getInFlags( sEntry[i].ifname, &flags) == 1)
		{
			if (flags & IFF_UP) {
				if ( adslflag && strcmp(sEntry[i].protocol, "br1483"))
					if (getInAddr( sEntry[i].ifname, IP_ADDR, (void *)&inAddr) == 1) {
						//wan interface up now
						vcState.chMode = sEntry[i].cmode;
						vcState.fstPvc = sEntry[i].fstPvc;
						vcState.dfGW = sEntry[i].dfGW;
						strcpy(vcState.ifName, sEntry[i].ifname);

						setupFWRule(&vcState, 1);
					}
			}
		}
	}
	
	return 1;
}
#endif
int setFirewallGrade()
{
	unsigned char pppItf=0;
	unsigned char merItf=0;
	unsigned char brgItf=0;
	char fstPvcSel=0;
	//char xDSLMode=0;	//0- no WAN interface;  1- bridge only;  2- route only;  3- bridge+route
	int mibCnt;
	int totalNum;
	MIB_CE_ATM_VC_T entry;
	VC_STATE_T vcState;

	totalNum = mib_chain_total(MIB_ATM_VC_TBL);
	for(mibCnt=0; mibCnt<totalNum; mibCnt++)
	{
		if (!mib_chain_get(MIB_ATM_VC_TBL, mibCnt, (void *)&entry))
		{
			printf("get MIB chain error\n");
			return -1;
		}
		if (!entry.enable)
			continue;
		
		switch(entry.cmode) {
			case ADSL_RT1483:
			case ADSL_MER1483:
				merItf++;
				break;
			case ADSL_PPPoA:
			case ADSL_PPPoE:
				pppItf++;
				break;
			case ADSL_BR1483:
				brgItf++;
				break;
			default:
				break;
		}
	}

	if (brgItf && !merItf && !pppItf)
		wanState.xDSLMode = (char)WAN_BRG; //bridge only
	else if (!brgItf && (merItf || pppItf))
		wanState.xDSLMode = (char)WAN_ROUTE; //route only
	else if (brgItf && (merItf || pppItf))
		wanState.xDSLMode = (char)BRG_RTE; //bridge+route
		
	if ((char)WAN_BRG == wanState.xDSLMode) //bridge only
		return 0;

	if (merItf && !pppItf)
		wanState.wanItf = (char)MER_ONLY;
	else if (!merItf && pppItf)
		wanState.wanItf = (char)PPPOE_ONLY;
	else
		wanState.wanItf = (char)PPP_MER;

	wanState.ifNum = merItf+pppItf;

	printf("begin to set firewall grade -> \n");
	
	initFwSet();
	
	//check first pvc and df gw
	for (mibCnt=0; mibCnt<totalNum; mibCnt++)
	{
		memset(&vcState, 0, sizeof(VC_STATE_T));
		
		mib_chain_get(MIB_ATM_VC_TBL, mibCnt, (void *)&entry);
		
		if ((entry.cmode == ADSL_BR1483) || !entry.enable)
			continue;
		
		if(entry.cmode == ADSL_PPPoE || entry.cmode == ADSL_PPPoA)//star:for multi-ppp name
			snprintf(vcState.ifName, 6, "ppp%u", PPP_INDEX(entry.ifIndex));
		else
			snprintf(vcState.ifName, 6, "vc%u", VC_INDEX(entry.ifIndex));
		
		vcState.chMode = entry.cmode;
		if (!fstPvcSel) {
			vcState.fstPvc = 1;
			fstPvcSel = 1;
		}
		vcState.dfGW = entry.dgw;

		setupFWRule(&vcState, 1);
	}

	return 1;
}

#if 0
int changeFwGrade(int currGrade)
{
	int enable;
	unsigned int data, data2;
	char	buff[256], tmp1[20], tmp2[20];
	int in_turn=0, vccount=0, ifcount=0;
	int i, ifindices[256], br_socket_fd, spid;
	unsigned long arg[4];
	struct ifreq ifr;
	FILE *fp;
	struct flock flpoe, flpoa;
	int fdpoe, fdpoa;
	Modem_LinkSpeed vLs;
	char ifname[6];
	int mibCnt;
	int totalNum;
	MIB_CE_ATM_VC_T entry;
	VC_STATE_T vcState;
	struct status_info {
		char ifname[IFNAMSIZ];
		char devname[IFNAMSIZ];
		unsigned int tvpi;
		unsigned int tvci;
		char protocol[10];
	};
	struct status_info sEntry[MAX_VC_NUM+MAX_PPP_NUM];
	struct status_info vcEntry[MAX_VC_NUM];

	if (fw_state_t.preFwGrade == (char)FW_HIGH) {
		if (currGrade != (char)FW_HIGH)//HIGH->LOW
			enable = 1;
		else
			return 0;
	}
	else if (currGrade == (char)FW_HIGH) {
		if (fw_state_t.preFwGrade != FW_HIGH)//LOW->High
			enable = 0;
		else
			return 0;
	} else//don't change
		return 0;
		
	/** check if there is route mode PVC existed, if no available route PVC exists, dont start firewall.
	**  if link is down, dont start firewall
	*/
	//first, check for xDSL link
	if (!adsl_drv_get(RLCM_GET_LINK_SPEED, (void *)&vLs, RLCM_GET_LINK_SPEED_SIZE) || vLs.upstreamRate == 0)
		return 0;//if link down, do nothing

	if (((char)WAN_INVALID==wanState.xDSLMode) || ((char)WAN_BRG==wanState.xDSLMode))
		return 0;
	
#ifdef EMBED
	// get spppd pid
	if ((fp = fopen(PPP_PID, "r"))) {
		fscanf(fp, "%d\n", &spid);
		fclose(fp);
	}
	else
		printf("spppd pidfile not exists\n");
	
	kill(spid, SIGUSR2);
#endif

	in_turn = 0;
#ifdef EMBED
	if (!(fp=fopen(PROC_NET_ATM_BR, "r"))) {
		printf("%s not exists.\n", PROC_NET_ATM_BR);
	} else {
		while ( fgets(buff, sizeof(buff), fp) != NULL ) {
			if (in_turn==0)
				if(sscanf(buff, "%*s%s", tmp1)!=1) {
					printf("Unsuported pvc configuration format\n");
					break;
				}
				else {
					vccount ++;
					tmp1[strlen(tmp1)-1]='\0';
					strcpy(vcEntry[vccount-1].ifname, tmp1);
					strcpy(vcEntry[vccount-1].devname, tmp1);
				}
			else
				if(sscanf(buff, "%*s%s%*s%s", tmp1, tmp2)!=2) {
					printf("Unsuported pvc configuration format\n");
					break;
				}
				else {
					sscanf(tmp1, "0.%u.%u:", &vcEntry[vccount-1].tvpi, &vcEntry[vccount-1].tvci);
					sscanf(tmp2, "%u,", &data);
					strcpy(vcEntry[vccount-1].protocol, "");
					if (data==3 || data==4) {
						strcpy(vcEntry[vccount-1].protocol, "rt1483");
					}
				}
			in_turn ^= 0x01;
		}
		fclose(fp);
	}

	//following only process the condition with wan interface...
	// file locking
	fdpoe = open(PPPOE_CONF, O_RDWR);
	fdpoa = open(PPPOA_CONF, O_RDWR);
	if ((fdpoe != -1) && (fdpoe != -1)) {
		flpoe.l_type = flpoa.l_type = F_RDLCK;
		flpoe.l_whence = flpoa.l_whence = SEEK_SET;
		flpoe.l_start = flpoa.l_start = 0;
		flpoe.l_len = flpoa.l_len = 0;
		flpoe.l_pid = flpoa.l_pid = getpid();
		if (fcntl(fdpoe, F_SETLKW, &flpoe) == -1)
			printf("pppoe read lock failed\n");
		if (fcntl(fdpoa, F_SETLKW, &flpoa) == -1)
			printf("pppoa read lock failed\n");
	}
	
	if (!(fp=fopen(PPPOA_CONF, "r")))
		printf("%s not exists.\n", PPPOA_CONF);
	else {
		fgets(buff, sizeof(buff), fp);
		while ( fgets(buff, sizeof(buff), fp) != NULL ) {
			if (sscanf(buff, "%s%u%u%*s%*s%*s%*d%*d%*d%*s%*s", tmp1, &data, &data2) != 3) {
				printf("Unsuported pppoa configuration format\n");
				break;
			}
			else {
				ifcount ++;
				strcpy(sEntry[ifcount-1].ifname, tmp1);
				strcpy(sEntry[ifcount-1].protocol, "PPPoA");
				sEntry[ifcount-1].tvpi = data;
				sEntry[ifcount-1].tvci = data2;
			}
		}
		fclose(fp);
	}

	if (!(fp=fopen(PPPOE_CONF, "r")))
		printf("%s not exists.\n", PPPOE_CONF);
	else {
		fgets(buff, sizeof(buff), fp);
		while ( fgets(buff, sizeof(buff), fp) != NULL )
			if(sscanf(buff, "%s%s%*s%*s%*s%*s%*s", tmp1, tmp2) != 2) {
				printf("Unsuported pppoe configuration format\n");
				break;
			} else {
				for (i=0; i<vccount; i++) {
					if (strcmp(vcEntry[i].devname, tmp2) == 0) {
						ifcount ++;
						strcpy(sEntry[ifcount-1].ifname, tmp1);
						strcpy(sEntry[ifcount-1].devname, vcEntry[i].devname);
						strcpy(sEntry[ifcount-1].protocol, "PPPoE");
						sEntry[ifcount-1].tvpi = vcEntry[i].tvpi;
						sEntry[ifcount-1].tvci = vcEntry[i].tvci;
					}
				}
			}
		fclose(fp);
	}

	// file unlocking
	if ((fdpoe != -1) && (fdpoe != -1)) {
		flpoe.l_type = flpoa.l_type = F_UNLCK;
		if (fcntl(fdpoe, F_SETLK, &flpoe) == -1)
			printf("pppoe read unlock failed\n");
		if (fcntl(fdpoa, F_SETLK, &flpoa) == -1)
			printf("pppoa read unlock failed\n");
		close(fdpoe);
		close(fdpoa);
	}
	
	for (i=0; i<vccount; i++) {
		int j, vcfound=0;
		for (j=0; j<ifcount; j++)
			if (strcmp(vcEntry[i].ifname, sEntry[j].devname) == 0) {	// PPPoE-used device
				vcfound = 1;
				break;
			}
		if (!vcfound) {	// VC not used for PPPoE, add to list
			ifcount ++;
			strcpy(sEntry[ifcount-1].ifname, vcEntry[i].ifname);
			strcpy(sEntry[ifcount-1].protocol, vcEntry[i].protocol);
			sEntry[ifcount-1].tvpi = vcEntry[i].tvpi;
			sEntry[ifcount-1].tvci = vcEntry[i].tvci;
		}
	}
#endif
	totalNum = mib_chain_total(MIB_ATM_VC_TBL);
	for (i=0; i<ifcount; i++) {
		if (!strcmp(sEntry[i].protocol, ""))
		{
			for(mibCnt=0; mibCnt<totalNum; mibCnt++)
			{
				if (!mib_chain_get(MIB_ATM_VC_TBL, mibCnt, (void *)&entry))
				{
					printf("get MIB chain error\n");
					return -1;
				}
				if(entry.cmode == ADSL_PPPoE || entry.cmode == ADSL_PPPoA)//star:for multi-ppp name
					snprintf(ifname, 6, "ppp%u", PPP_INDEX(entry.ifIndex));
				else
					snprintf(ifname, 6, "vc%u", VC_INDEX(entry.ifIndex));
				if(entry.vpi==sEntry[i].tvpi && entry.vci==sEntry[i].tvci && !strcmp(ifname,sEntry[i].ifname))
				{
					switch(entry.cmode) {
					case ADSL_MER1483:
						snprintf(sEntry[i].protocol, 10, "mer1483");
						break;
					case ADSL_BR1483:
						snprintf(sEntry[i].protocol, 10, "br1483");
						break;
					default:
						break;
					}
					break;
				}
			}
		}
	}

	//now we only process the condition that is route only or bridge&route
	for (i=0; i<ifcount; i++) {
		struct in_addr inAddr;
		int flags;
		
		// set status flag
		if (getInFlags( sEntry[i].ifname, &flags) == 1)
		{
			if (flags & IFF_UP) {
				if (strcmp(sEntry[i].protocol, "br1483"))
					if (getInAddr( sEntry[i].ifname, IP_ADDR, (void *)&inAddr) == 1) {
						//wan interface up now
						strcpy(vcState.ifName, sEntry[i].ifname);
						addLowGradeRule(&vcState, enable);
					}
			}
		}
	}
	fw_state_t.preFwGrade = currGrade;
	
	return 1;
}
#endif
int changeFwGrade(int currGrade)
{
	int enable;
	int mibCnt;
	int totalNum;
	MIB_CE_ATM_VC_T entry;
	VC_STATE_T vcState;
	Modem_LinkSpeed vLs;

	if (fw_state_t.preFwGrade == (char)FW_HIGH) {
		if (currGrade != (char)FW_HIGH)//HIGH->LOW
			enable = 1;
		else
			return 0;
	}
	else if (currGrade == (char)FW_HIGH) {
		if (fw_state_t.preFwGrade != FW_HIGH)//LOW->High
			enable = 0;
		else
			return 0;
	} else//don't change
		return 0;
		
	//first, check for xDSL link
	if (!adsl_drv_get(RLCM_GET_LINK_SPEED, (void *)&vLs, RLCM_GET_LINK_SPEED_SIZE) || vLs.upstreamRate == 0)
		return 0;//if link down, do nothing

	if (((char)WAN_INVALID==wanState.xDSLMode) || ((char)WAN_BRG==wanState.xDSLMode))
		return 0;
	
	totalNum = mib_chain_total(MIB_ATM_VC_TBL);
	for(mibCnt=0; mibCnt<totalNum; mibCnt++)
	{
		memset(&vcState, 0, sizeof(VC_STATE_T));
		
		if (!mib_chain_get(MIB_ATM_VC_TBL, mibCnt, (void *)&entry))
		{
			printf("get MIB chain error\n");
			return -1;
		}
		if ((entry.cmode == ADSL_BR1483) || !entry.enable)
			continue;
		
		if(entry.cmode == ADSL_PPPoE || entry.cmode == ADSL_PPPoA)//star:for multi-ppp name
			snprintf(vcState.ifName, 6, "ppp%u", PPP_INDEX(entry.ifIndex));
		else
			snprintf(vcState.ifName, 6, "vc%u", VC_INDEX(entry.ifIndex));

		addLowGradeRule(&vcState, enable);
	}

	fw_state_t.preFwGrade = currGrade;
	
	return 1;
}
#endif

#ifdef CONFIG_BOA_WEB_E8B_CH
#define DOS_ENABLE		0x01
#define SYSFLOODSYN		0x02
#define SYSFLOODFIN		0x04
#define SYSFLOODUDP		0x08
#define SYSFLOODICMP	0x10
#define IPFLOODSYN		0x20
#define IPFLOODFIN		0x40
#define IPFLOODUDP		0x80
#define IPFLOODICMP		0x100
#define TCPUDPPORTSCAN	0x200
#define ICMPSMURFENABLED	0x400
#define IPLANDENABLED		0x800
#define IPSPOOFENABLED		0x1000
#define IPTEARDROPENABLED	0x2000
#define PINGOFDEATHENABLED	0x4000
#define TCPSCANENABLED		0x8000
#define TCPSynWithDataEnabled	0x10000
#define UDPBombEnabled			0x20000
#define UDPEchoChargenEnabled	0x40000
#define sourceIPblock		0x400000
#define DOS_ENABLE_ALL	(DOS_ENABLE|SYSFLOODSYN|SYSFLOODFIN|SYSFLOODUDP|SYSFLOODICMP|IPFLOODSYN|\
						IPFLOODFIN|IPFLOODUDP|IPFLOODICMP|TCPUDPPORTSCAN|ICMPSMURFENABLED|\
						IPLANDENABLED|IPSPOOFENABLED|IPTEARDROPENABLED|PINGOFDEATHENABLED|\
						TCPSCANENABLED|TCPSynWithDataEnabled|UDPBombEnabled|UDPEchoChargenEnabled|\
						sourceIPblock)
//#define DOS_ENABLE_E8B	DOS_ENABLE_ALL
#define DOS_ENABLE_E8B	(DOS_ENABLE|SYSFLOODSYN|SYSFLOODFIN|SYSFLOODUDP|SYSFLOODICMP|IPFLOODSYN|\
						IPFLOODFIN|IPFLOODUDP|IPFLOODICMP|TCPUDPPORTSCAN|ICMPSMURFENABLED|\
						IPLANDENABLED|IPSPOOFENABLED|IPTEARDROPENABLED|PINGOFDEATHENABLED|\
						TCPSCANENABLED|TCPSynWithDataEnabled|sourceIPblock)
void setupDos()
{
	unsigned int dos_enable=0;
	unsigned char buffer[256],dosstr[256];
	int dostmpip[4],dostmpmask[4];
	int dosip,dosmask;
	FILE *dosfp;

	if (!mib_get( MIB_DOS_ENABLED,  (void *)&dos_enable)){
		printf("DOS parameter failed!\n");
	}
	
	//get ip
	if(!mib_get( MIB_ADSL_LAN_IP, (void *)buffer)) {
		printf("get LAN IP failed!\n");
		return -1;
	}
	sscanf(inet_ntoa(*((struct in_addr *)buffer)),"%d.%d.%d.%d",&dostmpip[0],&dostmpip[1],&dostmpip[2],&dostmpip[3]);	
	dosip= dostmpip[0]<<24 | dostmpip[1]<<16 | dostmpip[2]<<8 | dostmpip[3];
	//get mask
	if(!mib_get( MIB_ADSL_LAN_SUBNET, (void *)buffer)) {
		printf("get LAN SUBNET failed!\n");
		return -1;
	}
	sscanf(inet_ntoa(*((struct in_addr *)buffer)),"%d.%d.%d.%d",&dostmpmask[0],&dostmpmask[1],&dostmpmask[2],&dostmpmask[3]);	
	dosmask= dostmpmask[0]<<24 | dostmpmask[1]<<16 | dostmpmask[2]<<8 | dostmpmask[3];
	dosip &= dosmask;
	if (dos_enable) {
		//printf("dos enable:%d\n", dos_enable);
		dos_enable = DOS_ENABLE_E8B;
	}
	sprintf(dosstr,"1 %x %x %d 100 100 100 100 100 100 100 100 300\n",
		dosip,dosmask,dos_enable);
	printf("dosstr:%s\n\n",dosstr);
	dosstr[strlen(dosstr)]=NULL;
	if (dosfp = fopen("/proc/enable_dos", "w"))
	{
		fprintf(dosfp, "%s",dosstr);
		fclose(dosfp);
	}

	return;
}
#endif

#ifdef IP_QOS
int _setupIPQoSRule(int enable, unsigned int i, MIB_CE_IP_QOS_T qEntry)
{
	MIB_CE_ATM_VC_T pvcEntry;
	char *argv[24], wanif[6];
	char *tc_action=NULL, *fw_action=NULL;
	
	if(enable)
	{
		tc_action = (char *)ARG_ADD;
		fw_action = (char *)FW_ADD;
	}else
	{
		tc_action = (char *)ARG_DEL;
		fw_action = (char *)FW_DEL;
	}
	
	{
		char phy[]="eth0_sw0";
		char saddr[20], daddr[20], sport[6], dport[6], mark[5], prio[4];
		char *psaddr, *pdaddr;
		int idx, tos, mark1p;
		int k, vcnum;
		
#ifdef _CWMP_MIB_
		if( enable )
			if( qEntry.enable==0 ) return 0;
#endif
		
		// source ip, mask
		snprintf(saddr, 20, "%s", inet_ntoa(*((struct in_addr *)qEntry.sip)));
		if (strcmp(saddr, ARG_0x4) == 0)
			psaddr = 0;
		else {
			if (qEntry.smaskbit!=0)
				snprintf(saddr, 20, "%s/%d", saddr, qEntry.smaskbit);
			psaddr = saddr;
		}
		// destination ip, mask
		snprintf(daddr, 20, "%s", inet_ntoa(*((struct in_addr *)qEntry.dip)));
		if (strcmp(daddr, ARG_0x4) == 0)
			pdaddr = 0;
		else {
			if (qEntry.dmaskbit!=0)
				snprintf(daddr, 20, "%s/%d", daddr, qEntry.dmaskbit);
			pdaddr = daddr;
		}
		snprintf(sport, 6, "%d", qEntry.sPort);
		snprintf(dport, 6, "%d", qEntry.dPort);

		mark1p = _get_classification_mark(i, &qEntry);		
		if (mark1p == 0) return 0;
		#if 0
		// mark the packet:  8-bits(high) |   8-bits(low)
		//                    class id    |  802.1p (if any)
		mark1p = ((i+1) << 8);	// class id
		if (qEntry.m_1p != 0)
			mark1p |= (qEntry.m_1p-1);	// 802.1p
		#endif
		//ql: modify length of mark from 4 to 5
		snprintf(mark, 5, "%d", mark1p);
		
		// Rule
		argv[1] = (char *)ARG_T;
		argv[2] = "mangle";
		argv[3] = (char *)fw_action;
		argv[4] = (char *)FW_PREROUTING;
		idx = 5;
		
		// lan port
		if (qEntry.phyPort != 0xff) {
#if (defined(CONFIG_EXT_SWITCH)  && defined (IP_QOS_VPORT))
//#ifdef CONFIG_EXT_SWITCH
			if (qEntry.phyPort <= SW_PORT_NUM) {
				phy[7]='0'+qEntry.phyPort;
				argv[idx++] = (char *)ARG_I;
				argv[idx++] = phy;
			}
#else
			if (qEntry.phyPort == 0) {
				argv[idx++] = (char *)ARG_I;
				argv[idx++] = (char *)ELANIF;
			}
#endif
#ifdef WLAN_SUPPORT
			else {
				argv[idx++] = (char *)ARG_I;
#if defined(ZTE_GENERAL_ROUTER_SC) && defined(WLAN_MBSSID)
				argv[idx++]=(char*)(WLANAPIF[qEntry.phyPort -5]);
#else			
				argv[idx++] = (char *)WLANIF;
#endif
			}
#endif
		}
		else { // all lan ports
			argv[idx++] = (char *)ARG_I;
			argv[idx++] = (char *)LANIF;
		}
		
		// protocol
		if (qEntry.protoType != PROTO_NONE) {
			argv[idx++] = "-p";
			if (qEntry.protoType == PROTO_TCP)
				argv[idx++] = (char *)ARG_TCP;
			else if (qEntry.protoType == PROTO_UDP)
				argv[idx++] = (char *)ARG_UDP;
			else //if (qEntry.protoType == PROTO_ICMP)
				argv[idx++] = (char *)ARG_ICMP;
		}
		
		// src ip
		if (psaddr != 0)
		{
			argv[idx++] = "-s";
			argv[idx++] = psaddr;
			
		}
		
		// src port
		if ((qEntry.protoType==PROTO_TCP ||
			qEntry.protoType==PROTO_UDP) &&
			qEntry.sPort != 0) {
			argv[idx++] = (char *)FW_SPORT;
			argv[idx++] = sport;
		}
		
		// dst ip
		if (pdaddr != 0)
		{
			argv[idx++] = "-d";
			argv[idx++] = pdaddr;
		}
		// dst port
		if ((qEntry.protoType==PROTO_TCP ||
			qEntry.protoType==PROTO_UDP) &&
			qEntry.dPort != 0) {
			argv[idx++] = (char *)FW_DPORT;
			argv[idx++] = dport;
		}
		
		// target/jump		
		argv[idx++] = "-j";
		
		// Mark traffic class
		//ql_xu commented.
		//argv[idx] = "MARK";
		//argv[idx+1] = "--set-mark";
		//argv[idx+2] = mark;
		//argv[idx+3] = NULL;
		
		// Mark traffic class
		// iptables -t mangle -A PREROUTING -i eth0_sw2
		//	-s 172.21.70.4/24
		//	-d 192.168.1.10/16 -p tcp --sport 25
		//	--dport 22 -j MARK --set-mark 22
		argv[idx] = "MARK";
		argv[idx+1] = "--set-mark";
		argv[idx+2] = mark;
		argv[idx+3] = NULL;
		TRACE(STA_SCRIPT, "%s %s %s %s %s %s %s ...--set-mark %s\n", IPTABLES, argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], mark);
		do_cmd(IPTABLES, argv, 1);
		
#if 0
		snprintf(prio, 4, "%d", (int)qEntry.prior);
		// tc filter add dev vc0 parent 1:0 prio 1 protocol ip handle 22 fw flowid 1:1
		va_cmd(TC, 15, 1, "filter", (char *)tc_action, "dev", wanif,
			"parent", "1:0", "prio", prio, "protocol", "ip", "handle", mark,
			"fw", "flowid", "1:1");
#endif
		
		// Mark ip tos
#ifdef QOS_DSCP
		if(qEntry.dscp==0) {
#endif
		if (qEntry.m_ipprio != 0 || qEntry.m_iptos != 0xff) {
			tos = 0;
			if (qEntry.m_ipprio != 0)
				tos = (qEntry.m_ipprio-1) << 5;
			if (qEntry.m_iptos != 0xff)
				tos |= qEntry.m_iptos;
			snprintf(prio, 4, "%d", tos);
			argv[idx] = "TOS";
			argv[idx+1] = "--set-tos";
			argv[idx+2] = prio;
			argv[idx+3] = NULL;
			TRACE(STA_SCRIPT, "%s %s %s %s %s %s %s ...--set-tos %s\n", IPTABLES, argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], prio);
			do_cmd(IPTABLES, argv, 1);
		}
#ifdef QOS_DSCP
		}
		else if (qEntry.dscp == 1) {
			if (qEntry.m_ipprio != 0 || qEntry.m_iptos != 0) {
				tos = 0;
				tos = qEntry.m_ipprio << 3;
				tos |= qEntry.m_iptos << 1;
				snprintf(prio, 4, "%d", tos);
				argv[idx] = "DSCP";
				argv[idx+1] = "--set-dscp";
				argv[idx+2] = prio;
				argv[idx+3] = NULL;
				TRACE(STA_SCRIPT, "%s %s %s %s %s %s %s ...--set-dscp %s\n", IPTABLES, argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], prio);
				do_cmd(IPTABLES, argv, 1);
			}
		}
#endif
		
		// Configure the filter to place the packets on class
		snprintf(prio, 4, "1:%d", (int)qEntry.prior+1);
		// tc filter add dev vc0 parent 1:0 prio 1 protocol ip handle 22 fw flowid 1:1
		vcnum = mib_chain_total(MIB_ATM_VC_TBL);
		// Create the root "prio" qdisc on wan interface
		for (k = 0; k < vcnum; k++) {
			/* get the specified chain record */
			if (!mib_chain_get(MIB_ATM_VC_TBL, k, (void *)&pvcEntry))
				continue;
			if (!pvcEntry.enable)
				continue;
			
			if (PPP_INDEX(pvcEntry.ifIndex) != 0x0f) {
				// PPP interface
				snprintf(wanif, 6, "ppp%u", PPP_INDEX(pvcEntry.ifIndex));
			}
			else {
				// vc interface
				snprintf(wanif, 6, "vc%u", VC_INDEX(pvcEntry.ifIndex));
			}
			va_cmd(TC, 15, 1, "filter", (char *)tc_action, "dev", wanif,
				"parent", "1:0", "prio", "1", "protocol", "ip", "handle", mark,
				"fw", "flowid", prio);
			#ifdef QOS_SPEED_LIMIT_SUPPORT
			if(qEntry.limitSpeedEnabled)
			{
			char lsParent[8]={0};
			char lsprio[8]={0};			
			int flowidindex=mib_qos_speed_limit_existed(qEntry.limitSpeedRank,qEntry.prior);
			sprintf(lsParent,"1%d:",(int)qEntry.prior+1);
			sprintf(lsprio,"1%d:%d",(int)qEntry.prior+1,flowidindex+12);				
			va_cmd(TC, 15, 1, "filter", (char *)tc_action, "dev", wanif,
				"parent",lsParent, "protocol","ip","prio", "1", "handle",mark,"fw","flowid", lsprio);			
			}
			#endif
		}
	}
	
	return 0;	
}

int setupIPQoSRule(int enable)
{
	unsigned int num, i;
	MIB_CE_IP_QOS_T qEntry;
	
	num = mib_chain_total(MIB_IP_QOS_TBL);
	// set IP QoS rule
	for (i=0; i<num; i++) 
	{
		if (!mib_chain_get(MIB_IP_QOS_TBL, i, (void *)&qEntry))
			continue;

		_setupIPQoSRule( enable, i, qEntry );
	}
	
	return 0;	
}

int stopIPQ(void)
{
	unsigned int num, i;
	MIB_CE_ATM_VC_T pvcEntry;
	char wanif[6];
	
	setupIPQoSRule( 0 );

	num = mib_chain_total(MIB_ATM_VC_TBL);
	// Create the root "prio" qdisc on wan interface
	for (i = 0; i < num; i++) 
	{
		if (!mib_chain_get(MIB_ATM_VC_TBL, i, (void *)&pvcEntry))
			continue;
		if (!pvcEntry.enable)
			continue;

		if (PPP_INDEX(pvcEntry.ifIndex) != 0x0f) {
			// PPP interface
			snprintf(wanif, 6, "ppp%u", PPP_INDEX(pvcEntry.ifIndex));
		}
		else {
			// vc interface
			snprintf(wanif, 6, "vc%u", VC_INDEX(pvcEntry.ifIndex));
		}

		va_cmd(TC, 5, 1, "qdisc", (char *)ARG_DEL, "dev", wanif, "root");
	}	

	// disable IPQoS
#ifdef CONFIG_EXT_SWITCH
	__dev_setupIPQoS(0);
#endif

	printf("IP QoS: stopped\n");
}

int setupIPQ(void)
{
	unsigned char enable;
	unsigned int num, i, k;
	MIB_CE_ATM_VC_T pvcEntry;
	MIB_CE_IP_QOS_T qEntry;
	char *argv[24], wanif[6];
#ifdef QOS_SPEED_LIMIT_SUPPORT
	unsigned short pvcbandwidth;
	unsigned int totalpvcbandwidth=0;
	char pvcbandwidthS[16]={0};
	mib_get(MIB_PVC_TOTAL_BANDWIDTH,&pvcbandwidth);	
	//totalpvcbandwidth=pvcbandwidth*1024;
	//sprintf(pvcbandwidthS,"%d",totalpvcbandwidth);
	//ql-- set parameter unit is KBps.
	sprintf(pvcbandwidthS, "%d", pvcbandwidth);
	va_cmd("/bin/sarctl",2,1,"tc",pvcbandwidthS);	
#endif
	num = mib_chain_total(MIB_ATM_VC_TBL);
	// Create the root "prio" qdisc on wan interface
	for (i = 0; i < num; i++) 
	{
		#ifdef QOS_SPEED_LIMIT_SUPPORT
		char s_level[]="0", s_classid[]="1:0", s_handle[]="11:";
		#else
		char s_level[]="0", s_classid[]="1:3", s_handle[]="3:";
		#endif
		char vChar;
		/* get the specified chain record */
		if (!mib_chain_get(MIB_ATM_VC_TBL, i, (void *)&pvcEntry))
			continue;
		if (!pvcEntry.enable)
			continue;
		
		if (PPP_INDEX(pvcEntry.ifIndex) != 0x0f) {
			// PPP interface
			snprintf(wanif, 6, "ppp%u", PPP_INDEX(pvcEntry.ifIndex));
		}
		else {
			// vc interface
			snprintf(wanif, 6, "vc%u", VC_INDEX(pvcEntry.ifIndex));
		}
		// tc qdisc add dev vc0 root handle 1: htb
		// tc qdisc add dev vc0 root handle 1: prio
		// By default, this command instantly create classes 1:1, 1:2
		// and 1:3 and each of them has its pfifo queue already installed.
		#if 0
		va_cmd(TC, 8, 1, "qdisc", (char *)ARG_ADD, "dev", wanif,
			"root", "handle", "1:", "prio");
		#endif
		s_level[0] += IPQOS_NUM_PRIOQ;
		va_cmd(TC, 10, 1, "qdisc", (char *)ARG_ADD, "dev", wanif,
			"root", "handle", "1:", "prio", "bands", s_level);
		// If more than 3 bands (default), the pfifo will not be installed at
		// class(es) 1:4, 1:5, and so forth automatically. We should installed
		// pfifo extrinsically.
		#ifdef QOS_SPEED_LIMIT_SUPPORT
		//tc qdisc add dev vc0 parent 1:0 handle 10: htb default 10
		char s_htbclassid[8]="10:1";
		char s_htbdefault[8]="11:11";
		memset(pvcbandwidthS,'\0',sizeof(pvcbandwidthS));
		sprintf(pvcbandwidthS,"%dkbps",pvcbandwidth);
		for (k=0; k<IPQOS_NUM_PRIOQ; k++) {
			s_classid[2]++;	
			s_htbclassid[1]++;
			va_cmd(TC, 11, 1, "qdisc", (char *)ARG_ADD, "dev", wanif,
				"parent", s_classid, "handle", s_handle, "htb","default","11");				
			va_cmd(TC, 13, 1, "class", (char *)ARG_ADD, "dev", wanif,
				"parent", s_handle, "classid", s_htbclassid, "htb","rate",pvcbandwidthS,"ceil",pvcbandwidthS);	
			///bin/tc class add dev vc0 parent 11: classid 11:11 htb rate 300kbit ceil 300kbit
			va_cmd(TC, 13, 1, "class", (char *)ARG_ADD, "dev", wanif,
				"parent", s_handle, "classid", s_htbdefault, "htb","rate",pvcbandwidthS,"ceil",pvcbandwidthS);	
			s_handle[1]++;
			s_htbdefault[1]++;
		}	
		//tc class add dev vc0 parent 10: classid 10:1 htb rate 300kbit ceil 300kbit 
		MIB_CE_IP_QOS_SPEEDRANK_T mibqosspeed;
		int mibqosspeedtotalnum=mib_chain_total(MIB_QOS_SPEED_LIMIT);
		for(k=0;k<mibqosspeedtotalnum;k++)
		{
			mib_chain_get(MIB_QOS_SPEED_LIMIT,k,&mibqosspeed);
			//printf("mibqosspeed:index=%d,count=%d,speed=%d,prior=%d\n",
			//	mibqosspeed.index,mibqosspeed.count,mibqosspeed.speed,mibqosspeed.prior);
			char parentid[8]={0};
			char classid[8]={0};
			char speedhtb[16]={0};
			sprintf(parentid,"1%d:",mibqosspeed.prior+1);
			sprintf(classid,"1%d:%d",mibqosspeed.prior+1,mibqosspeed.index+12);
			sprintf(speedhtb,"%dkbps",mibqosspeed.speed);
			//tc class add dev vc0 parent 12: classid 12:1 htb rate 300kbit ceil 300kbit 
			va_cmd(TC, 13, 1, "class", (char *)ARG_ADD, "dev", wanif,
				"parent", parentid, "classid", classid, "htb","rate",speedhtb,"ceil",speedhtb);	
			
		}
		#if 0
		#define QOSSPEEDRANK 5
		strcpy(s_htbclassid,"10:10");
		strcpy(s_handle,"11:");		
		int j=0;
		for(j=0;j<IPQOS_NUM_PRIOQ;j++)
		{
			int maxspeed=300;
			char speedRate[16]={0};
			s_htbclassid[1]++;
			s_htbclassid[4]='0';
			for(k=0;k<QOSSPEEDRANK;k++)
			{				
				s_htbclassid[4]++;
				memset(speedRate,'\0',sizeof(speedRate));		
				sprintf(speedRate,"%dkbit",maxspeed);
				maxspeed-=50;
				va_cmd(TC, 13, 1, "class", (char *)ARG_ADD, "dev", wanif,
				"parent", s_handle, "classid", s_htbclassid, "htb","rate",speedRate,"ceil",speedRate);	
			}
			s_handle[1]++;		
		}
		#endif
		#else
		if (IPQOS_NUM_PRIOQ >= 4) {
			for (k=0; k<=IPQOS_NUM_PRIOQ-4; k++) {
				s_classid[2]++;
				s_handle[0]++;
				va_cmd(TC, 9, 1, "qdisc", (char *)ARG_ADD, "dev", wanif,
				"parent", s_classid, "handle", s_handle, "pfifo");
			}
		}
		#endif
		// Set the default mapping of Precedence bit to prio classes
		// tc filter add dev vc0 parent 1:0 prio 2 protocol ip u32
		// match ip tos 0xc0 0xc0 flowid 1:1
		#if 0
		// Assign precedence 5 to high priority queue (bit 101)
		va_cmd(TC, 18, 1, "filter", (char *)ARG_ADD, "dev", wanif,
			"parent", "1:0", "prio", "2", "protocol", "ip", "u32",
			"match", "ip", "tos", "0xa0", "0xe0", "flowid", "1:1");
		// Assign precedence 6, 7 to high priority queue (bit 11x)
		va_cmd(TC, 18, 1, "filter", (char *)ARG_ADD, "dev", wanif,
			"parent", "1:0", "prio", "2", "protocol", "ip", "u32",
			"match", "ip", "tos", "0xc0", "0xc0", "flowid", "1:1");
		// Assign precedence 2, 3 to medium priority queue (bit 01x)
		va_cmd(TC, 18, 1, "filter", (char *)ARG_ADD, "dev", wanif,
			"parent", "1:0", "prio", "2", "protocol", "ip", "u32",
			"match", "ip", "tos", "0x40", "0xc0", "flowid", "1:2");
		// Assign precedence 4 to medium priority queue (bit 100)
		va_cmd(TC, 18, 1, "filter", (char *)ARG_ADD, "dev", wanif,
			"parent", "1:0", "prio", "2", "protocol", "ip", "u32",
			"match", "ip", "tos", "0x80", "0xe0", "flowid", "1:2");
		// Assign precedence 0, 1 to low priority queue (bit 00x)
		va_cmd(TC, 18, 1, "filter", (char *)ARG_ADD, "dev", wanif,
			"parent", "1:0", "prio", "2", "protocol", "ip", "u32",
			"match", "ip", "tos", "0x00", "0xc0", "flowid", "1:3");
		#endif
#ifdef CONFIG_RE8305
		for (k=0; k<=(IPQOS_NUM_PKT_PRIO-1); k++) {
			char flow[]="1:0";
			char pattern[]="0x00";
			int prio;

			flow[2] += priomap[k];
			prio = k<<1;
			if (prio<=9)
				pattern[2] += prio; // highest 3 bits
			else
				pattern[2] = 'a'+(prio-10);
			// match ip tos PATTERN MASK
			va_cmd(TC, 18, 1, "filter", (char *)ARG_ADD, "dev", wanif,
				"parent", "1:0", "prio", "2", "protocol", "ip", "u32",
				"match", "ip", "tos", pattern, "0xe0", "flowid", flow);
		}
#else
		mib_get(MIB_QOS_DOMAIN, (void *)&vChar);
		if (vChar == (char)PRIO_IP) {
			for (k=0; k<=(IPQOS_NUM_PKT_PRIO-1); k++) {
				char flow[]="1:0";
				char pattern[]="0x00";
				int prio;
                	
				flow[2] += priomap[k];
				prio = k<<1;
				if (prio<=9)
					pattern[2] += prio; // highest 3 bits
				else
					pattern[2] = 'a'+(prio-10);
				// match ip tos PATTERN MASK
				va_cmd(TC, 18, 1, "filter", (char *)ARG_ADD, "dev", wanif,
					"parent", "1:0", "prio", "2", "protocol", "ip", "u32",
					"match", "ip", "tos", pattern, "0xe0", "flowid", flow);
			}
		}
		else if(vChar == (char)PRIO_802_1p){ // PRIO_802_1p
#ifdef CONFIG_8021P_PRIO
			unsigned char value[IPQOS_NUM_PKT_PRIO];
			if(mib_get(MIB_8021P_PROI, (void *)value)== 0)
		       {
   			   printf("Get 8021P_PROI  error!\n");
			   return 0;
		        }        
#endif
			for (k=0; k<=(IPQOS_NUM_PKT_PRIO-1); k++) {
				char s_mark[]="0";
				char flow[]="1:0";
				
				s_mark[0] += (k+1);
#ifdef CONFIG_8021P_PRIO	 	
	                     flow[2] += value[k]+1;
//                              printf("flow ::::::::::%s \n",flow);
#else
	                     flow[2] += priomap[k];
#endif
	                    
				va_cmd(TC, 15, 1, "filter", (char *)ARG_ADD, "dev", wanif,
					"parent", "1:0", "prio", "2", "protocol", "ip", "handle", s_mark,
					"fw", "flowid", flow);
			}
		}
#endif
		
	}

	setupIPQoSRule(1);
	
	// register 8305-switch port into system
	//__dev_register_swport();
	
#if 0
	// add sw-port into br0
	for (i=0; i<SW_PORT_NUM; i++) {
		pPort = (MIB_CE_SW_PORT_Tp) mib_chain_get(MIB_SW_PORT_TBL,i);
		// set port to br mapping, used by add2br()
		brInfo[i].pvcIdx = pPort->pvcItf;
		brInfo[i].brid = 0;	// all ports belong to br0
	}
	add2br();
#endif
	// enable IPQoS
//#ifdef CONFIG_EXT_SWITCH    // Mason Yu, For Set IPQOS
	__dev_setupIPQoS(1);
//#endif                      // Mason Yu, For Set IPQOS
	
	printf("IP QoS: started\n");
}
#endif //#ifdef IP_QOS


// Added by Mason Yu for ILMI(PVC) community string
const char PVCREADSTR[] = "ADSL";
const char PVCWRITESTR[] = "ADSL";
// Added by Mason Yu for write community string
static const char SNMPCOMMSTR[] = "/var/snmpComStr.conf";
// return value:
// 1  : successful
// -1 : startup failed
int startSnmp(void)
{
	unsigned char value[16];
	unsigned char trapip[16];	
	unsigned char commRW[100], commRO[100], enterOID[100];
	FILE 	      *fp;
	
	// Get SNMP Trap Host IP Address
	if(!mib_get( MIB_SNMP_TRAP_IP,  (void *)value)){
		printf("Can no read MIB_SNMP_TRAP_IP\n");
	}
	
	if (((struct in_addr *)value)->s_addr != 0)
	{
		strncpy(trapip, inet_ntoa(*((struct in_addr *)value)), 16);
		trapip[15] = '\0';
	}
	else
		trapip[0] = '\0';		
	//printf("***** trapip = %s\n", trapip);	
	
	// Get CommunityRO String
	if(!mib_get( MIB_SNMP_COMM_RO,  (void *)commRO)) {
		printf("Can no read MIB_SNMP_COMM_RO\n");	
	}		
	//printf("*****buffer = %s\n", commRO);
	
			
	// Get CommunityRW String
	if(!mib_get( MIB_SNMP_COMM_RW,  (void *)commRW)) {
		printf("Can no read MIB_SNMP_COMM_RW\n");	
	}		
	//printf("*****commRW = %s\n", commRW);   
	
	
	// Get Enterprise OID
	if(!mib_get( MIB_SNMP_SYS_OID,  (void *)enterOID)) {
		printf("Can no read MIB_SNMP_SYS_OID\n");
	}
	//printf("*****enterOID = %s\n", enterOID); 
	
	
	// Write community string to file
	if ((fp = fopen(SNMPCOMMSTR, "w")) == NULL)
	{
		printf("Open file %s failed !\n", SNMPCOMMSTR);
		return -1;
	}
	
	if (commRO[0])
		fprintf(fp, "readStr %s\n", commRO);
	if (commRW[0])
		fprintf(fp, "writeStr %s\n", commRW);	
		
	// Add ILMI(PVC) community string
	fprintf(fp, "PvcReadStr %s\n", PVCREADSTR);
	fprintf(fp, "PvcWriteStr %s\n", PVCWRITESTR);	
	fclose(fp);
	
	// Mason Yu
	// ZyXEL Remote management does not verify the comm string, so we can limit the comm string as "ADSL"
	if (va_cmd("/bin/snmpd", 8, 0, "-p", "161", "-c", PVCREADSTR, "-th", trapip, "-te", enterOID))
	    return -1;
	return 1;
	
}	

#define SNMPPID  "/var/run/snmpd.pid"

int restart_snmp(int flag)
{
	unsigned char value[32];
	int snmppid=0;
	int status=0;

	snmppid = read_pid((char*)SNMPPID);

	printf("\nsnmppid=%d\n",snmppid);

	if(snmppid > 0)
		kill(snmppid, 9);

	unlink(SNMPPID);

	if(flag==1){
		status = startSnmp();
	}
	return status;
}
#ifdef _CWMP_MIB_ 
#define CWMPPID  "/var/run/cwmp.pid"
void off_tr069()
{   
	int cwmppid=0;
	int status;
	unsigned int conreq_port=0;
	char strPort[10];
#ifdef CONFIG_MIDDLEWARE
	int midware_intf_pid = 0;

	midware_intf_pid = read_pid((char*)MWINTF_MAIN_RUNFILE);
/*	
	sprintf(strPort, "%u", 9080 );
	va_cmd(IPTABLES, 15, 1, ARG_T, "mangle", "-D", (char *)FW_PREROUTING,
		(char *)ARG_I, "!", (char *)LANIF, "-p", (char *)ARG_TCP,
		(char *)FW_DPORT, strPort, "-j", (char *)"MARK", "--set-mark", RMACC_MARK);
*/
	if(midware_intf_pid > 0)
		kill(midware_intf_pid, SIGTERM);
#endif

	cwmppid = read_pid((char*)CWMPPID);

	printf("\ncwmppid=%d\n",cwmppid);

	/*del wan port to pass */
	mib_get(CWMP_CONREQ_PORT, (void *)&conreq_port);
	if(conreq_port==0) conreq_port=7547;
	sprintf(strPort, "%u", conreq_port );
	va_cmd(IPTABLES, 15, 1, ARG_T, "mangle", "-D", (char *)FW_PREROUTING,
		(char *)ARG_I, "!", (char *)LANIF, "-p", (char *)ARG_TCP,
		(char *)FW_DPORT, strPort, "-j", (char *)"MARK", "--set-mark", RMACC_MARK);
/*
	sprintf(strPort, "%u", 30005 );
	va_cmd(IPTABLES, 15, 1, ARG_T, "mangle", "-D", (char *)FW_PREROUTING,
		(char *)ARG_I, "!", (char *)LANIF, "-p", (char *)ARG_TCP,
		(char *)FW_DPORT, strPort, "-j", (char *)"MARK", "--set-mark", RMACC_MARK);
*/
	if(cwmppid > 0)
		kill(cwmppid, 15);

}
#endif

#ifdef IP_ACL
int restart_acl()
{
	unsigned char aclEnable;

	//va_cmd(IPTABLES, 2, 1, "-F", "aclblock");
	mib_get(MIB_ACL_CAPABILITY, (void *)&aclEnable);
	if (aclEnable == 1)  // ACL Capability is enabled
	{
		filter_set_acl(0);
		filter_set_acl(1);
	}
	else
		filter_set_acl(0);

	return 0;
}
#endif

#ifdef NAT_CONN_LIMIT
//ql_xu add
int restart_connlimit()
{
	unsigned char connlimitEn;

	va_cmd(IPTABLES, 2, 1, "-F", "connlimit");

	mib_get(MIB_NAT_CONN_LIMIT, (void *)&connlimitEn);
	if (connlimitEn == 1)
		set_conn_limit();
}
#endif
#ifdef TCP_UDP_CONN_LIMIT
int restart_connlimit()
{
	unsigned char connlimitEn;

	va_cmd(IPTABLES, 2, 1, "-F", "connlimit");

	mib_get(MIB_CONNLIMIT_ENABLE, (void *)&connlimitEn);
	if (connlimitEn == 1)
		set_conn_limit();
}
#endif 


#ifndef CONFIG_BOA_WEB_E8B_CH
#ifdef URL_BLOCKING_SUPPORT

int restart_urlblocking()
{		
	unsigned char urlEnable;	

	va_cmd(IPTABLES, 2, 1, "-F", "urlblock");		
	mib_get(MIB_URL_CAPABILITY, (void *)&urlEnable);
	if (urlEnable == 1)  // URL Capability enabled
		filter_set_url(1);
	else
		filter_set_url(0);	
	return 0;
}
#ifdef URL_ALLOWING_SUPPORT
int restart_url()
{
      
	unsigned char urlEnable;	

	va_cmd(IPTABLES, 2, 1, "-F", "urlallow");
	va_cmd(IPTABLES, 2, 1, "-F", "urlblock");
	mib_get(MIB_URL_CAPABILITY, (void *)&urlEnable);
	if (urlEnable == 1)  // URL Capability enabled
		filter_set_url(1);
	else if(urlEnable == 2) //URL allow
		set_url(2);

	return 0;
}
#endif
#endif
#endif

//Ip interface
int restart_lanip()
{
	char vChar=0;
	unsigned char ipaddr[32]="";
	unsigned char subnet[32]="";
	unsigned char value[6];
	int vInt;
	int status=0;
	FILE * fp;
#ifdef IP_PASSTHROUGH
	unsigned char ippt_addr[32]="";
	unsigned char ippt_itf;
	unsigned long myipaddr,hisipaddr;
	int ippt_flag = 0;
#endif
	
	itfcfg((char *)LANIF, 0);
#ifdef SECONDARY_IP
	itfcfg((char *)LAN_ALIAS, 0);
#endif
#ifdef IP_PASSTHROUGH
	itfcfg((char *)LAN_IPPT, 0);
	if (mib_get(MIB_IPPT_ITF, (void *)&ippt_itf) != 0) {
		if (ippt_itf != 255) {	// IP passthrough
			fp = fopen ("/tmp/PPPHalfBridge", "r");
			if (fp) {
				fread(&myipaddr, 4, 1, fp);
				// Added by Mason Yu. Access internet fail.
				fclose(fp);
				myipaddr+=1;
				strncpy(ippt_addr, inet_ntoa(*((struct in_addr *)(&myipaddr))), 16);
				ippt_addr[15] = '\0';
				ippt_flag =1;
			}
			
		}
	}
#endif

#ifdef _CWMP_MIB_
	mib_get(CWMP_LAN_IPIFENABLE, (void *)&vChar);
	if (vChar != 0)
#endif
	{
		if (mib_get(MIB_ADSL_LAN_IP, (void *)value) != 0)
		{
			strncpy(ipaddr, inet_ntoa(*((struct in_addr *)value)), 16);
			ipaddr[15] = '\0';
		}
		if (mib_get(MIB_ADSL_LAN_SUBNET, (void *)value) != 0)
		{
			strncpy(subnet, inet_ntoa(*((struct in_addr *)value)), 16);
			subnet[15] = '\0';
		}

		vInt = 1500;
		snprintf(value, 6, "%d", vInt);
		// set LAN-side MRU
		status|=va_cmd(IFCONFIG, 6, 1, (char*)LANIF, ipaddr, "netmask", subnet, "mtu", value);
	

#ifdef SECONDARY_IP
		mib_get(MIB_ADSL_LAN_ENABLE_IP2, (void *)value);
		if (value[0] == 1) {
			// ifconfig LANIF LAN_IP netmask LAN_SUBNET
			if (mib_get(MIB_ADSL_LAN_IP2, (void *)value) != 0)
			{
				strncpy(ipaddr, inet_ntoa(*((struct in_addr *)value)), 16);
				ipaddr[15] = '\0';
			}
			if (mib_get(MIB_ADSL_LAN_SUBNET2, (void *)value) != 0)
			{
				strncpy(subnet, inet_ntoa(*((struct in_addr *)value)), 16);
				subnet[15] = '\0';
			}
			snprintf(value, 6, "%d", vInt);
			// set LAN-side MRU
			status|=va_cmd(IFCONFIG, 6, 1, (char*)LAN_ALIAS, ipaddr, "netmask", subnet, "mtu", value);
		}
#endif
             
#ifdef IP_PASSTHROUGH
               if(ippt_flag)
			   status|=va_cmd(IFCONFIG, 2, 1, (char*)LAN_IPPT,ippt_addr);
#endif
	
		status|=restart_dhcp();
//		status|=restart_dnsrelay();

#ifdef QSETUP_WEB_REDIRECT
		/*
		unsigned char iptables_flag = 0;

		mib_get(MIB_QSETUP_REDIRECT, (void *)&iptables_flag);
		if (iptables_flag) {
			stop_qsetup_redirect();
			start_qsetup_redirect();
		}
		*/
		FILE *fp;
		int iptables_flag = 0;
		if ((fp = fopen("/tmp/QSetup", "r"))) {
			fscanf(fp, "%d\n", &iptables_flag);
			fclose(fp);
			if (iptables_flag) {
				stop_qsetup_redirect();
				start_qsetup_redirect();
			}
		}
#endif
		return status;
	}
	return -1;
}

//DHCP

int restart_dhcp()
{
	unsigned char value[32];
	unsigned int uInt;
	int dhcpserverpid=0,dhcprelaypid=0;
	int tmp_status, status=0;

	if (mib_get(MIB_DHCP_MODE, (void *)value) != 0)
	{
		uInt = (unsigned int)(*(unsigned char *)value);
//		if (uInt != 0 && uInt !=1 && uInt != 2 )
//			return -1;
	}

	dhcpserverpid = read_pid((char*)DHCPSERVERPID);
	dhcprelaypid = read_pid((char*)DHCPRELAYPID);

	//printf("\ndhcpserverpid=%d,dhcprelaypid=%d\n",dhcpserverpid,dhcprelaypid);

	if(dhcpserverpid > 0)
		kill(dhcpserverpid, 9);
	if(dhcprelaypid > 0)
		kill(dhcprelaypid, 9);

	if(uInt != DHCP_LAN_SERVER)
	{
		FILE *fp;
		//star:clean the lease file
		if ((fp = fopen(DHCPD_LEASE, "w")) == NULL)
		{
			printf("Open file %s failed !\n", DHCPD_LEASE);
			return -1;
		}
		fprintf(fp, "\n");
		fclose(fp);
	}
			

	if(uInt == DHCP_LAN_SERVER)
	{
		tmp_status = setupDhcpd();
		if (tmp_status == 1)
		{
			//printf("\nrestart dhcpserver!\n");
			status = va_cmd(DHCPD, 1, 0, DHCPD_CONF);
#ifndef ZTE_531B_BRIDGE_SC
			restart_dnsrelay();
#endif
		} 
		else if (tmp_status == -1)
	   	 	status = -1;
		return status;
	}
	else if(uInt == DHCP_LAN_RELAY)
	{
		startDhcpRelay();
#ifndef ZTE_531B_BRIDGE_SC
		restart_dnsrelay();
#endif
		status=(status==-1)?-1:0;
			
		return status;
	}
	else 
	{
#ifndef ZTE_531B_BRIDGE_SC
		restart_dnsrelay();
#endif
		return 0;
	}

	

	return -1;
}

//DNSRELAY

#define DNSRELAYPID  "/var/run/dnsmasq.pid"

int restart_dnsrelay()  
{
	unsigned char value[32];
	int dnsrelaypid=0;

	dnsrelaypid = read_pid((char*)DNSRELAYPID);

	//printf("\ndnsrelaypid=%d\n",dnsrelaypid);

	if(dnsrelaypid > 0)
		kill(dnsrelaypid, 9);

	if (startDnsRelay(BOOT_LAST) == -1)
	{
		printf("restart DNS relay failed !\n");
		return -1;
	}
	return 0;

}

int delPortForwarding( unsigned char ifindex )
{
	int total,i;
		
	total = mib_chain_total( MIB_PORT_FW_TBL );
	//for( i=0;i<total;i++ )
	for( i=total-1;i>=0;i-- )
	{
		MIB_CE_PORT_FW_T *c, port_entity;
		c = &port_entity;
		if( !mib_chain_get( MIB_PORT_FW_TBL, i, (void*)c ) )
			continue;

		if(c->ifIndex==ifindex)
			mib_chain_delete( MIB_PORT_FW_TBL, i );
	}	
	return 0;
}
int updatePortForwarding( unsigned char old_id, unsigned char new_id )
{
	unsigned int total,i;
	
	total = mib_chain_total( MIB_PORT_FW_TBL );
	for( i=0;i<total;i++ )
	{
		MIB_CE_PORT_FW_T *c, port_entity;
		c = &port_entity;
		if( !mib_chain_get( MIB_PORT_FW_TBL, i, (void*)c ) )
			continue;

		if(c->ifIndex==old_id)
		{
			c->ifIndex = new_id;
			mib_chain_update( MIB_PORT_FW_TBL, (unsigned char*)c, i );
		}
	}
	return 0;
}

//add by ramen to delete the rip rule 
int delRipTable(unsigned char ifindex)
{
int total,i;
MIB_CE_RIP_T Entry;
total=mib_chain_total(MIB_RIP_TBL);
for(i=total-1;i>=0;i--)
{
   mib_chain_get(MIB_RIP_TBL,i,&Entry);
   if(Entry.ifIndex!=ifindex) continue;
   mib_chain_delete(MIB_RIP_TBL,i);
}
}
int updateRipTable(unsigned char old_id,unsigned char new_id)
{
	int total,i;
	MIB_CE_RIP_T Entry;
	total=mib_chain_total(MIB_RIP_TBL);
	for(i=total-1;i>=0;i--)
	{
	   mib_chain_get(MIB_RIP_TBL,i,&Entry);
	   if(Entry.ifIndex!=old_id) continue;
	   Entry.ifIndex=new_id;
	   mib_chain_update(MIB_RIP_TBL,&Entry,i);
	}
}
int delRoutingTable( unsigned char ifindex )
{
	int total,i;
		
	total = mib_chain_total( MIB_IP_ROUTE_TBL );
	//for( i=0;i<total;i++ )
	for( i=total-1;i>=0;i-- )
	{
		MIB_CE_IP_ROUTE_T *c, entity;
		c = &entity;
		if( !mib_chain_get( MIB_IP_ROUTE_TBL, i, (void*)c ) )
			continue;

		if(c->ifIndex==ifindex)
			mib_chain_delete( MIB_IP_ROUTE_TBL, i );
	}	
	return 0;
}
int updateRoutingTable( unsigned char old_id, unsigned char new_id )
{
	unsigned int total,i;
	
	total = mib_chain_total( MIB_IP_ROUTE_TBL );
	for( i=0;i<total;i++ )
	{
		MIB_CE_IP_ROUTE_T *c, entity;
		c = &entity;
		if( !mib_chain_get( MIB_IP_ROUTE_TBL, i, (void*)c ) )
			continue;

		if(c->ifIndex==old_id)
		{
			c->ifIndex = new_id;
			mib_chain_update( MIB_IP_ROUTE_TBL, (unsigned char*)c, i );
		}
	}
	return 0;
}

#ifdef VIRTUAL_SERVER_SUPPORT

int apply_PortForwarding( int action_type, int id, void *olddata )
{	
	switch( action_type )
	{
	case ACT_RESTART:  //CWMP_RESTART:
	case ACT_START:    //CWMP_START:
	case ACT_STOP:     //CWMP_STOP:
		setupFirewall();
		break;
	default:
		return -1;
	}
	return 0;
}

#else
// Added by Mason Yu for take effect in real time.
int apply_PortForwarding( int action_type, int id, void *olddata )
{
	MIB_CE_PORT_FW_T *pOldPort=olddata;
	MIB_CE_PORT_FW_T PortEntry, *pNewPort=NULL;

	//got the lastest entry
	if( mib_chain_get( MIB_PORT_FW_TBL, id,  (void*)&PortEntry )!=0 ) //0:error
		pNewPort =  &PortEntry;
	
	switch( action_type )
	{
	case ACT_RESTART:  //CWMP_RESTART:
		if(pOldPort) portfw_modify( pOldPort, 1 );
	case ACT_START:    //CWMP_START:
		if(pNewPort) portfw_modify( pNewPort, 0 );
		break;
	case ACT_STOP:     //CWMP_STOP:
		if(pOldPort) 
			portfw_modify( pOldPort, 1 );
		else if(pNewPort)
			portfw_modify( pNewPort, 1 );
		break;
	default:
		return -1;
	}
	return 0;
}
#endif

#ifdef _CWMP_MIB_

unsigned int findMaxConDevInstNum(void)
{
	unsigned int ret=0, i,num;
	MIB_CE_ATM_VC_T *p,vc_entity;
	
	num = mib_chain_total( MIB_ATM_VC_TBL );
	for( i=0; i<num;i++ )
	{
		p = &vc_entity;
		if( !mib_chain_get( MIB_ATM_VC_TBL, i, (void*)p ))
			continue;
		if( p->ConDevInstNum > ret )
			ret = p->ConDevInstNum;
	}
	
	return ret;
}

unsigned int findConDevInstNumByPVC(unsigned char vpi, unsigned short vci)
{
	unsigned int ret=0, i,num;
	MIB_CE_ATM_VC_T *p,vc_entity;
	
	if( (vpi==0) && (vci==0) ) return ret;
	
	num = mib_chain_total( MIB_ATM_VC_TBL );
	for( i=0; i<num;i++ )
	{
		p = &vc_entity;
		if( !mib_chain_get( MIB_ATM_VC_TBL, i, (void*)p ))
			continue;
		if( p->vpi==vpi && p->vci==vci )
		{
			ret = p->ConDevInstNum;
			break;
		}
	}
	
	return ret;
}

unsigned int findMaxPPPConInstNum( unsigned int condev_inst )
{
	unsigned int ret=0, i,num;
	MIB_CE_ATM_VC_T *p,vc_entity;
	
	if(condev_inst==0) return ret;

	num = mib_chain_total( MIB_ATM_VC_TBL );
	for( i=0; i<num;i++ )
	{
		p = &vc_entity;
		if( !mib_chain_get( MIB_ATM_VC_TBL, i, (void*)p ))
			continue;
		if( p->ConDevInstNum == condev_inst )
		{
			if( (p->cmode==ADSL_PPPoE) ||
#ifdef PPPOE_PASSTHROUGH
			    ((p->cmode==ADSL_BR1483)&&(p->brmode==BRIDGE_PPPOE)) ||
#endif
			    (p->cmode==ADSL_PPPoA) )
			{
				if( p->ConPPPInstNum > ret )
					ret = p->ConPPPInstNum;
			}
		}
	}
	
	return ret;
}

unsigned int findMaxIPConInstNum( unsigned int condev_inst )
{
	unsigned int ret=0, i,num;
	MIB_CE_ATM_VC_T *p,vc_entity;
	
	if(condev_inst==0) return ret;

	num = mib_chain_total( MIB_ATM_VC_TBL );
	for( i=0; i<num;i++ )
	{
		p = &vc_entity;
		if( !mib_chain_get( MIB_ATM_VC_TBL, i, (void*)p ))
			continue;
		if( p->ConDevInstNum==condev_inst )
		{
			if( (p->cmode == ADSL_MER1483) || 
#ifdef PPPOE_PASSTHROUGH
			    ((p->cmode==ADSL_BR1483)&&(p->brmode!=BRIDGE_PPPOE)) ||
#else
			    (p->cmode == ADSL_BR1483) ||
#endif
			    (p->cmode == ADSL_RT1483) )
			{
				if( p->ConIPInstNum > ret )
					ret = p->ConIPInstNum;
			}
		}
	}
	
	return ret;
}

MIB_CE_ATM_VC_T *getATMVCByInstNum( unsigned int devnum, unsigned int ipnum, unsigned int pppnum, MIB_CE_ATM_VC_T *p, unsigned int *chainid )
{
	unsigned int i,num;
	
	if( (p==NULL) || (chainid==NULL) ) return NULL;

	num = mib_chain_total( MIB_ATM_VC_TBL );
	for( i=0; i<num;i++ )
	{
		if( !mib_chain_get( MIB_ATM_VC_TBL, i, (void*)p ))
			continue;

		if( (p->ConDevInstNum==devnum) &&
		    (p->ConIPInstNum==ipnum) &&
		    (p->ConPPPInstNum==pppnum) ) 
		{
			*chainid=i;
			return p;
		}
	}
	
	return NULL;
}

#ifdef _CWMP_APPLY_
#ifdef _PRMT_X_CT_COM_PORTALMNT_
#define TR069_FILE_PORTALMNT  "/proc/fp_tr069"
static void setPortalMNT()
{	
	char tmpstr[256+1];
	char urlstr[512];
	char vChar;
	FILE *fp;
	char on[3]="on";
	char off[3]="off";

	mib_get(MIB_FP_ENABLE,(void*)&vChar);
	fp=fopen(TR069_FILE_PORTALMNT,"w");
	if(vChar==1)
		fwrite(on,strlen(on),1,fp);
	else
		fwrite(off,strlen(off),1,fp);
	fclose(fp);

	mib_get(MIB_FP_PC_ADDR,(void*)tmpstr);
	fp=fopen(TR069_FILE_PORTALMNT,"w");
	sprintf(urlstr,"PC_addr:%s",tmpstr);
	if(tmpstr[0]!=0)
		fwrite(urlstr,strlen(urlstr),1,fp);
	fclose(fp);

	mib_get(MIB_FP_STB_ADDR,(void*)tmpstr);
	fp=fopen(TR069_FILE_PORTALMNT,"w");
	sprintf(urlstr,"STB_addr:%s",tmpstr);
	if(tmpstr[0]!=0)
		fwrite(urlstr,strlen(urlstr),1,fp);
	fclose(fp);

	mib_get(MIB_FP_MOB_ADDR,(void*)tmpstr);
	fp=fopen(TR069_FILE_PORTALMNT,"w");
	sprintf(urlstr,"MOB_addr:%s",tmpstr);
	if(tmpstr[0]!=0)
		fwrite(urlstr,strlen(urlstr),1,fp);
	fclose(fp);

}
int apply_PortalMNT( int action_type, int id, void *olddata )
{
	switch( action_type )
	{
	case CWMP_START:
	case CWMP_RESTART:
	case CWMP_STOP:
		setPortalMNT();
		break;
	default:
		return -1;
	}
	return 0;
}
#endif
//RIP
#ifdef _PRMT_X_CT_COM_SYSLOG_
void restartsyslog()
{
	setupSyslog(SYSLOG_DISABLED);
	setupSyslog(SYSLOG_ENABLED);
}
int apply_Syslog( int action_type, int id, void *olddata )
{
	switch( action_type )
	{
	case CWMP_START:
	case CWMP_RESTART:
	case CWMP_STOP:
		restartsyslog();
		break;
	default:
		return -1;
	}
	return 0;
}
#endif
int apply_RIP( int action_type, int id, void *olddata )
{
	//for RIP, id and olddata have no meaning
	switch( action_type )
	{
	case CWMP_START:
	case CWMP_RESTART:
	case CWMP_STOP:
		startRip();
		break;
	default:
		return -1;
	}
	return 0;
}

#ifdef ITF_GROUP
//PortMapping
int apply_PortMapping( int action_type, int id, void *olddata )
{
	
// set debug mode,jiunming test
//DEBUGMODE(STA_INFO|STA_SCRIPT|STA_WARNING|STA_ERR);

	//for PortMapping, id and olddata have no meaning
	switch( action_type )
	{
	case CWMP_RESTART:
		//stop portmapping? but for tr069, once enable, always enable!
	case CWMP_START:
		{
			unsigned char mode=0;
#ifdef CONFIG_EXT_SWITCH
			mib_get(MIB_MPMODE, (void *)&mode);
			if(mode&0x01) setupEth2pvc();
#endif
		}
		break;
	case CWMP_STOP:
		break;
	default:
		return -1;
	}
	return 0;
}
#endif //ITF_GROUP

//ROUTE
int apply_Layer3Forwarding( int action_type, int id, void *olddata )
{
	MIB_CE_IP_ROUTE_T *pOldRoute=olddata;
	MIB_CE_IP_ROUTE_T RouteEntry, *pNewRoute=NULL;

	//got the lastest entry
	if( mib_chain_get( MIB_IP_ROUTE_TBL, id,  (void*)&RouteEntry )!=0 ) //0:error
		pNewRoute =  &RouteEntry;
	
	switch( action_type )
	{
	case CWMP_RESTART:
		if( pOldRoute &&
		    pOldRoute->Enable &&
		    ( pOldRoute->ifIndex==0xff &&
		      pOldRoute->nextHop[0]==0 &&
		      pOldRoute->nextHop[0]==0 &&
		      pOldRoute->nextHop[0]==0 &&
		      pOldRoute->nextHop[0]==0 )
		  )
			route_cfg_modify( pOldRoute, 1 );
	case CWMP_START:
		if( pNewRoute &&
		    pNewRoute->Enable &&
		    ( pNewRoute->ifIndex==0xff &&
		      pNewRoute->nextHop[0]==0 &&
		      pNewRoute->nextHop[0]==0 &&
		      pNewRoute->nextHop[0]==0 &&
		      pNewRoute->nextHop[0]==0 )
		  )
			route_cfg_modify( pNewRoute, -1 );
		break;
	case CWMP_STOP:
		if( pOldRoute &&
		    pOldRoute->Enable &&
		    ( pOldRoute->ifIndex==0xff &&
		      pOldRoute->nextHop[0]==0 &&
		      pOldRoute->nextHop[0]==0 &&
		      pOldRoute->nextHop[0]==0 &&
		      pOldRoute->nextHop[0]==0 )
		  )
			route_cfg_modify( pOldRoute, 1 );
		break;
	default:
		return -1;
	}
	return 0;
}

int apply_DefaultRoute( int action_type, int id, void *olddata )
{
	//for DefaultRoute, id and olddata have no meaning
	switch( action_type )
	{
	case CWMP_RESTART:
		va_cmd(ROUTE, 2, 1, "delete", "default");
	case CWMP_START:
		{
#ifdef DEFAULT_GATEWAY_V2
			unsigned char dgw;
			if (mib_get(MIB_ADSL_WAN_DGW_ITF, (void *)&dgw) != 0)
			{
#ifdef AUTO_PPPOE_ROUTE
				if (dgw != DGW_AUTO)
#endif
				{
					char ifname[16] = "";
					if (ifGetName(dgw, ifname, sizeof(ifname)) != NULL)
						va_cmd(ROUTE, 3, 1, ARG_ADD, "default", ifname);
				}
			}
#else
			MIB_CE_ATM_VC_T *pEntry, vc_entity;
			int total,i;
			total = mib_chain_total(MIB_ATM_VC_TBL);
			for( i=0; i<total; i++ )
			{
				pEntry = &vc_entity;
				if( !mib_chain_get(MIB_ATM_VC_TBL, i, (void*)pEntry ) )
					continue;
				
				if( (pEntry->dgw==1) && (pEntry->enable==1) )
				{
					char ifname[16]="";
					if( ifGetName(pEntry->ifIndex, ifname, sizeof(ifname))!=NULL )
						va_cmd(ROUTE, 3, 1, ARG_ADD, "default", ifname );
				}
			}
#endif
		}
		break;
	case CWMP_STOP:
		va_cmd(ROUTE, 2, 1, "delete", "default");
		break;
	default:
		return -1;
	}
	return 0;
}

#if 0
int apply_PortForwarding( int action_type, int id, void *olddata )
{
	MIB_CE_PORT_FW_T *pOldPort=olddata;
	MIB_CE_PORT_FW_T PortEntry, *pNewPort=NULL;

	//got the lastest entry
	if( mib_chain_get( MIB_PORT_FW_TBL, id,  (void*)&PortEntry )!=0 ) //0:error
		pNewPort =  &PortEntry;
	
	switch( action_type )
	{
	case CWMP_RESTART:
		if(pOldPort) portfw_modify( pOldPort, 1 );
	case CWMP_START:
		if(pNewPort) portfw_modify( pNewPort, 0 );
		break;
	case CWMP_STOP:
		if(pOldPort) portfw_modify( pOldPort, 1 );
		break;
	default:
		return -1;
	}
	return 0;
}
#endif

#if defined(TIME_ZONE) || defined(ZTE_GENERAL_ROUTER_SC)
int apply_NTP( int action_type, int id, void *olddata )
{
	//for NTP, id and olddata have no meaning
	switch( action_type )
	{
	case CWMP_RESTART:
		stopNTP();
	case CWMP_START:
		startNTP();
		break;
	case CWMP_STOP:
		stopNTP();
		break;
	default:
		return -1;
	}
	return 0;
}
#endif //TIME_ZONE

int apply_RemoteAccess( int action_type, int id, void *olddata )
{
	MIB_CE_ACC_T *pOldAcc=olddata;
	MIB_CE_ACC_T AccEntry, *pNewAcc=NULL;

	//got the lastest entry
	if (mib_chain_get(MIB_ACC_TBL, 0, (void *)&AccEntry)) //0:error
		pNewAcc = &AccEntry;

	//void remote_access_modify(  MIB_CE_ACC_T accEntry, int enable)
	switch( action_type )
	{
	case CWMP_RESTART:
		if(pOldAcc) remote_access_modify( *pOldAcc, 0 );
	case CWMP_START:
		if(pNewAcc) remote_access_modify( *pNewAcc, 1 );
		break;
	case CWMP_STOP:
		if(pOldAcc) remote_access_modify( *pOldAcc, 0 );
		break;
	default:
		return -1;
	}
	return 0;
}


#ifdef IP_QOS
int apply_IPQoSRule( int action_type, int id, void *olddata )
{
	MIB_CE_IP_QOS_T *pOldQoS=olddata;

// set debug mode,jiunming test
//DEBUGMODE(STA_INFO|STA_SCRIPT|STA_WARNING|STA_ERR);

	//for IPQoSRule, 
	//id=-1 => take action for all rules, 
	//id>-1 => modify the specific entry 
	switch( action_type )
	{
	case CWMP_RESTART:
		if(id>-1)
			if(pOldQoS) _setupIPQoSRule(0, id, *pOldQoS);
		setupIPQoSRule(0);
	case CWMP_START:
		{
			unsigned char mode=0;
			mib_get(MIB_MPMODE, (void *)&mode);
			if (mode&0x02) setupIPQoSRule(1);
		}
		break;
	case CWMP_STOP:
		if(id>-1) 
			if(pOldQoS) _setupIPQoSRule(0, id, *pOldQoS);
		else
			setupIPQoSRule(0);
		break;
	default:
		return -1;
	}
	return 0;
}

int apply_IPQoS( int action_type, int id, void *olddata )
{
	
// set debug mode,jiunming test
//DEBUGMODE(STA_INFO|STA_SCRIPT|STA_WARNING|STA_ERR);

	//for IPQoS, id and olddata have no meaning
	switch( action_type )
	{
	case CWMP_RESTART:
		stopIPQ();
	case CWMP_START:
		{
			unsigned char mode=0;
			mib_get(MIB_MPMODE, (void *)&mode);
			if (mode&0x02) setupIPQ();
		}
		break;
	case CWMP_STOP:
		stopIPQ();
		break;
	default:
		return -1;
	}
	return 0;
}
#endif //#ifdef IP_QOS

int apply_DHCP( int action_type, int id, void *olddata )
{
	//for RIP, id and olddata have no meaning
	switch( action_type )
	{
	case CWMP_START:
	case CWMP_RESTART:
	case CWMP_STOP:
		restart_dhcp();
		break;
	default:
		return -1;
	}
	return 0;
}

int apply_DNS( int action_type, int id, void *olddata )
{
	//for RIP, id and olddata have no meaning
	switch( action_type )
	{
	case CWMP_START:
	case CWMP_RESTART:
	case CWMP_STOP:
		restart_dnsrelay();
		break;
	default:
		return -1;
	}
	return 0;
}

#ifdef CONFIG_IP_NF_ALG_ONOFF
int apply_ALGONOFF( int action_type, int id, void *olddata )
{
	switch( action_type )
	{
	case CWMP_START:
	case CWMP_RESTART:
	case CWMP_STOP:
		setupAlgOnOff();
		break;
	default:
		return -1;
	}
	return 0;

}
#endif
//WIRELESS
#ifdef WLAN_SUPPORT
/*
#define WIRELESSAUTHPID  "/var/run/auth-wlan0.pid"
#define IWCONTROLPID  "/var/run/iwcontrol.pid"

int restart_wlan(int wlaninst)
{
	char vChar;
	ENCRYPT_T encrypt;
	unsigned char no_wlan;
	unsigned char enable1x=0;
	int status = 0;
	int wirelessauthpid=0,iwcontrolpid=0;

// set debug mode,jiunming test
//DEBUGMODE(STA_INFO|STA_SCRIPT|STA_WARNING|STA_ERR);

	wirelessauthpid = read_pid((char*)WIRELESSAUTHPID);
	iwcontrolpid = read_pid((char*)IWCONTROLPID);

	printf("\nwirelessauthpid=%d\n",wirelessauthpid);
	printf("\niwcontrolpid=%d\n",iwcontrolpid);

	if(wirelessauthpid > 0)
		kill(wirelessauthpid, 9);
	if(iwcontrolpid > 0)
		kill(iwcontrolpid, 9);

	status |= va_cmd(IFCONFIG, 2, 1, "wlan0", "down");
#ifdef WLAN_MBSSID
	status |= va_cmd(IFCONFIG, 2, 1, "wlan0-vap0", "down");
	status |= va_cmd(IFCONFIG, 2, 1, "wlan0-vap1", "down");
	status |= va_cmd(IFCONFIG, 2, 1, "wlan0-vap2", "down");
	status |= va_cmd(IFCONFIG, 2, 1, "wlan0-vap3", "down");
#endif

	if (1) //no_wlan == 0)	// WLAN enabled
	{
		status |= startWLan();
		status = (status==-1)?-1:1;
		return status;
	}
	else 
		return 0;
	
	return -1;

}
*/
int apply_WLAN( int action_type, int id, void *olddata )
{
	//for RIP, id and olddata have no meaning
	switch( action_type )
	{
	case CWMP_START:
	case CWMP_RESTART:
	case CWMP_STOP:
		config_WLAN(ACT_RESTART);	
		break;
	default:
		return -1;
	}
	return 0;
}
#endif	// of WLAN_SUPPORT

// Mason Yu
#if 0
//Ethernet
#if defined(ELAN_LINK_MODE)
#include <linux/sockios.h>
struct mii_ioctl_data {
	unsigned short	phy_id;
	unsigned short	reg_num;
	unsigned short	val_in;
	unsigned short	val_out;
};
#endif


int restart_ethernet(int instnum)
{
	char vChar=0;
	int status=0;

	//eth0 interface enable or disable
	mib_get(CWMP_LAN_ETHIFENABLE, (void *)&vChar);	
	
	if(vChar==0)
	{
		va_cmd(IFCONFIG, 2, 1, "eth0", "down");
		printf("Disable eth0 interface\n");
		return 0;
	}
	else
	{
		va_cmd(IFCONFIG, 2, 1, "eth0", "up");
		printf("Enable eth0 interface\n");
#if defined(CONFIG_EXT_SWITCH) 
#if defined(ELAN_LINK_MODE) 
		if(instnum != 0)  //from the setupLinkMode() in startup.c
		{
			int skfd;
			struct ifreq ifr;
			struct mii_ioctl_data *mii = (struct mii_data *)&ifr.ifr_data;
			MIB_CE_SW_PORT_T Port;
			int i, k, total;
			
	
			strcpy(ifr.ifr_name, "eth0");
			
	
			if (!mib_chain_get(MIB_SW_PORT_TBL, instnum-1, (void *)&Port))
				return -1;
			mii->phy_id = instnum-1; // phy i
			mii->reg_num = 4; // register 4
			// set NWAY advertisement
			mii->val_in = 0x0401; // enable flow control capability and IEEE802.3
			if (Port.linkMode == LINK_10HALF || Port.linkMode == LINK_AUTO)
				mii->val_in |= (1<<(5+LINK_10HALF));
			if (Port.linkMode == LINK_10FULL || Port.linkMode == LINK_AUTO)
				mii->val_in |= (1<<(5+LINK_10FULL));
			if (Port.linkMode == LINK_100HALF || Port.linkMode == LINK_AUTO)
				mii->val_in |= (1<<(5+LINK_100HALF));
			if (Port.linkMode == LINK_100FULL || Port.linkMode == LINK_AUTO)
				mii->val_in |= (1<<(5+LINK_100FULL));
			skfd = socket(AF_INET, SOCK_DGRAM, 0);
			if(skfd == -1)
			{
				fprintf(stderr, "Socket Open failed Error\n");
				return -1;
			}
			if (ioctl(skfd, SIOCSMIIREG, &ifr) < 0) {
				fprintf(stderr, "SIOCSMIIREG on %s failed: %s\n", ifr.ifr_name,
					strerror(errno));
				status=-1;
			}

			// restart
			mii->reg_num = 0; // register 0
			mii->val_in = 0x1200; // enable auto-negotiation and restart it
			if (ioctl(skfd, SIOCSMIIREG, &ifr) < 0) {
				fprintf(stderr, "SIOCSMIIREG on %s failed: %s\n", ifr.ifr_name,
					strerror(errno));
				status=-1;
			}
			
			close(skfd);

		}
#endif // 
#else // CONFIG_EXT_SWITCH
#ifdef ELAN_LINK_MODE_INTRENAL_PHY
		int skfd;
		struct ifreq ifr;
		unsigned char mode;
		//struct mii_ioctl_data *mii = (struct mii_data *)&ifr.ifr_data;
		//MIB_CE_SW_PORT_T Port;
		//int i, k, total;
		struct ethtool_cmd ecmd;
			
	
		strcpy(ifr.ifr_name, "eth0");
		ifr.ifr_data = &ecmd;
			
	
		if (!mib_get(MIB_ETH_MODE, (void *)&mode))
			return -1;

		skfd = socket(AF_INET, SOCK_DGRAM, 0);
		if(skfd == -1)
		{
			fprintf(stderr, "Socket Open failed Error\n");
			return -1;
		}
		ecmd.cmd = ETHTOOL_GSET;
		if (ioctl(skfd, SIOCETHTOOL, &ifr) < 0) {
			fprintf(stderr, "ETHTOOL_GSET on %s failed: %s\n", ifr.ifr_name,
				strerror(errno));
			status=-1;
			goto error;
		}

		ecmd.autoneg = AUTONEG_DISABLE;
		switch(mode) {
		case LINK_10HALF:
			ecmd.speed = SPEED_10;
			ecmd.duplex = DUPLEX_HALF;
			break;
		case LINK_10FULL:
			ecmd.speed = SPEED_10;
			ecmd.duplex = DUPLEX_FULL;
			break;
		case LINK_100HALF:
			ecmd.speed = SPEED_100;
			ecmd.duplex = DUPLEX_HALF;
			break;
		case LINK_100FULL:
			ecmd.speed = SPEED_100;
			ecmd.duplex = DUPLEX_FULL;
			break;
		default:
			ecmd.autoneg = AUTONEG_ENABLE;
		}

		ecmd.cmd = ETHTOOL_SSET;
		if (ioctl(skfd, SIOCETHTOOL, &ifr) < 0) {
			fprintf(stderr, "ETHTOOL_SSET on %s failed: %s\n", ifr.ifr_name,
				strerror(errno));
			status=-1;
			goto error;
		}
		/*
		ecmd.cmd = ETHTOOL_NWAY_RST;
		if (ioctl(skfd, SIOCETHTOOL, &ifr) < 0) {
			fprintf(stderr, "ETHTOOL_SSET on %s failed: %s\n", ifr.ifr_name,
				strerror(errno));
			status=-1;
		}
		*/

		error:
		
		close(skfd);
#endif
#endif
		return status;
	}

	return -1;

}
#endif

int apply_ETHER( int action_type, int id, void *olddata )
{
	switch( action_type )
	{
	case CWMP_START:
	case CWMP_RESTART:
	case CWMP_STOP:
		restart_ethernet(id);
		break;
	default:
		return -1;
	}
	return 0;

}

int apply_LANIP( int action_type, int id, void *olddata )
{
	switch( action_type )
	{
	case CWMP_START:
	case CWMP_RESTART:
	case CWMP_STOP:
		restart_lanip();
		break;
	default:
		return -1;
	}
	return 0;

}

#ifdef MAC_FILTER
//jim luo, this function is only used for tr069
int restart_macfilter()   //from part of the setupFirewall() in startup.c
{
	unsigned char value[32];
	MIB_CE_MAC_FILTER_T MacEntry;
	MIB_CE_ATM_VC_T Entry;
	char mac_in_dft, mac_out_dft;
	char eth_mac_ctrl=0, wlan_mac_ctrl=0;
	int total,vcNum,vInt;
	char *policy;
	char srcmacaddr[18], dstmacaddr[18];
	char str_vc[] = "vc0";
	int i;

	total = ifWanNum("br");
	vInt = mib_chain_total(MIB_MAC_FILTER_TBL);
	mib_get(MIB_MACF_OUT_ACTION, (void *)&mac_out_dft);
	mib_get(MIB_MACF_IN_ACTION, (void *)&mac_in_dft);
	mib_get(MIB_ETH_MAC_CTRL, (void *)&eth_mac_ctrl);
	mib_get(MIB_WLAN_MAC_CTRL, (void *)&wlan_mac_ctrl);

	if(total >= 1 && ((mac_out_dft==0 || mac_in_dft==0) || vInt >= 1))
	 {
		// Enable Bridge Netfiltering					
		va_cmd("/bin/brctl", 2, 0, "brnf", "on");
	}else {
		// Disable Bridge Netfiltering
		va_cmd("/bin/brctl", 2, 0, "brnf", "off");
	}

	va_cmd(IPTABLES, 2, 1, "-F", (char *)FW_MACFILTER);

	{
		total = mib_chain_total(MIB_MAC_FILTER_TBL);
		vcNum = mib_chain_total(MIB_ATM_VC_TBL);
		
		// Commented by Mason Yu
		//if (total >= 1) {
			// Add chain for MAC filtering
			// iptables -N macfilter
			//va_cmd(IPTABLES, 2, 1, "-N", (char *)FW_MACFILTER);
		//}
		
		for (i = 0; i < total; i++)
		{
			if (!mib_chain_get(MIB_MAC_FILTER_TBL, i, (void *)&MacEntry))
				return -1;
			
			if (MacEntry.action == 0)
				policy = (char *)FW_DROP;
			else
				policy = (char *)FW_RETURN;
				
			
			snprintf(srcmacaddr, 18, "%02x:%02x:%02x:%02x:%02x:%02x",
				MacEntry.srcMac[0], MacEntry.srcMac[1],
				MacEntry.srcMac[2], MacEntry.srcMac[3],
				MacEntry.srcMac[4], MacEntry.srcMac[5]);
			
			
				
			snprintf(dstmacaddr, 18, "%02x:%02x:%02x:%02x:%02x:%02x",
				MacEntry.dstMac[0], MacEntry.dstMac[1],
				MacEntry.dstMac[2], MacEntry.dstMac[3],
				MacEntry.dstMac[4], MacEntry.dstMac[5]);	
			
			
			
			// Added by Mason Yu for Incoming MAC filtering
			if (MacEntry.dir == DIR_OUT) {
				if (   MacEntry.dstMac[0]==0 && MacEntry.dstMac[1]==0
			    	    && MacEntry.dstMac[2]==0 && MacEntry.dstMac[3]==0
		 	    	    && MacEntry.dstMac[4]==0 && MacEntry.dstMac[5]==0 ) {
					if(mac_out_dft || eth_mac_ctrl)
						// iptables -A macfilter -i eth0  -m mac --mac-source $MAC -j ACCEPT/DROP
						va_cmd(IPTABLES, 10, 1, (char *)FW_ADD, (char *)FW_MACFILTER,
							(char *)ARG_I, (char *)ELANIF, "-m", "mac",
							"--mac-source",  srcmacaddr, "-j", policy);	
					if(mac_out_dft ||wlan_mac_ctrl)
						// iptables -A macfilter -i wlan0  -m mac --mac-source $MAC -j ACCEPT/DROP
						va_cmd(IPTABLES, 10, 1, (char *)FW_ADD, (char *)FW_MACFILTER,
							(char *)ARG_I, (char *)WLANIF, "-m", "mac",
							"--mac-source",  srcmacaddr, "-j", policy);	
					
				}else if (   MacEntry.srcMac[0]==0 && MacEntry.srcMac[1]==0
			    	  	  && MacEntry.srcMac[2]==0 && MacEntry.srcMac[3]==0
		 	                  && MacEntry.srcMac[4]==0 && MacEntry.srcMac[5]==0 ) { 
				
					// iptables -A macfilter -i eth0  -m mac --mac-dst $MAC -j ACCEPT/DROP
					va_cmd(IPTABLES, 10, 1, (char *)FW_ADD, (char *)FW_MACFILTER,
						(char *)ARG_I, (char *)ELANIF, "-m", "mac",
						"--mac-dst",  dstmacaddr, "-j", policy);	
					// iptables -A macfilter -i wlan0  -m mac --mac-dst $MAC -j ACCEPT/DROP
					va_cmd(IPTABLES, 10, 1, (char *)FW_ADD, (char *)FW_MACFILTER,
						(char *)ARG_I, (char *)WLANIF, "-m", "mac",
						"--mac-dst",  dstmacaddr, "-j", policy);
				
				}else {
					// iptables -A macfilter -i eth0  -m mac --mac-source $MAC --mac-dst $MAC -j ACCEPT/DROP
					va_cmd(IPTABLES, 12, 1, (char *)FW_ADD, (char *)FW_MACFILTER,
						(char *)ARG_I, (char *)ELANIF, "-m", "mac",
						"--mac-source",  srcmacaddr, "--mac-dst",  dstmacaddr, "-j", policy);	
					// iptables -A macfilter -i wlan0  -m mac --mac-source $MAC --mac-dst $MAC -j ACCEPT/DROP
					va_cmd(IPTABLES, 12, 1, (char *)FW_ADD, (char *)FW_MACFILTER,
						(char *)ARG_I, (char *)WLANIF, "-m", "mac",
						"--mac-source",  srcmacaddr, "--mac-dst",  dstmacaddr, "-j", policy);
				}
					
			}
			else {
				for (vInt=0; vInt<vcNum; vInt++) {
					if (!mib_chain_get(MIB_ATM_VC_TBL, vInt, (void *)&Entry))
						continue;
					if (Entry.enable == 0)
						continue;
					
					if (Entry.cmode == ADSL_BR1483) {
						// vc index should be less than 10
						str_vc[2] = '0'+VC_INDEX(Entry.ifIndex);
						
						if (   MacEntry.dstMac[0]==0 && MacEntry.dstMac[1]==0
			    	    		    && MacEntry.dstMac[2]==0 && MacEntry.dstMac[3]==0
		 	    	    		    && MacEntry.dstMac[4]==0 && MacEntry.dstMac[5]==0 ) {
						
							// iptables -A macfilter -i vc0  -m mac --mac-source $MAC -j ACCEPT/DROP
							va_cmd(IPTABLES, 10, 1, (char *)FW_ADD, (char *)FW_MACFILTER,
								(char *)ARG_I, str_vc, "-m", "mac",
								"--mac-source",  srcmacaddr, "-j", policy);
								
						}else if (   MacEntry.srcMac[0]==0 && MacEntry.srcMac[1]==0
			    	  	  		  && MacEntry.srcMac[2]==0 && MacEntry.srcMac[3]==0
		 	                  		  && MacEntry.srcMac[4]==0 && MacEntry.srcMac[5]==0 ) { 
		 	                  		  		
							// iptables -A macfilter -i vc0  -m mac --mac-dst $MAC -j ACCEPT/DROP
							va_cmd(IPTABLES, 10, 1, (char *)FW_ADD, (char *)FW_MACFILTER,
								(char *)ARG_I, str_vc, "-m", "mac",
								"--mac-dst",  dstmacaddr, "-j", policy);
								
						}else {
							// iptables -A macfilter -i vc0  -m mac --mac-source $MAC --mac-dst $MAC -j ACCEPT/DROP
							va_cmd(IPTABLES, 12, 1, (char *)FW_ADD, (char *)FW_MACFILTER,
								(char *)ARG_I, str_vc, "-m", "mac",
								"--mac-source",  srcmacaddr, "--mac-dst",  dstmacaddr, "-j", policy);
						}	
						
							
					}
				}
			}
		}
		
		// Commented by Mason Yu
		//if (total >= 1) {
			// default action
			if (mib_get(MIB_MACF_OUT_ACTION, (void *)value) != 0)
			{
				vInt = (int)(*(unsigned char *)value);
				if (vInt == 0 && eth_mac_ctrl )
				{
					// iptables -A macfilter -i eth0 -j DROP
					va_cmd(IPTABLES, 6, 1, (char *)FW_ADD,
						(char *)FW_MACFILTER, (char *)ARG_I,
						(char *)ELANIF, "-j", (char *)FW_DROP);
				}
				if (vInt == 0 && wlan_mac_ctrl )
				{
					// iptables -A macfilter -i wlan0 -j DROP
					va_cmd(IPTABLES, 6, 1, (char *)FW_ADD,
						(char *)FW_MACFILTER, (char *)ARG_I,
						(char *)WLANIF, "-j", (char *)FW_DROP);
				}
			}
			
			if (mib_get(MIB_MACF_IN_ACTION, (void *)value) != 0)
			{
				vInt = (int)(*(unsigned char *)value);
				if (vInt == 0)	// DROP
				{
					for (vInt=0; vInt<vcNum; vInt++) {
						if (!mib_chain_get(MIB_ATM_VC_TBL, vInt, (void *)&Entry))
							continue;
						if (Entry.enable == 0)
							continue;
						
						if (Entry.cmode == ADSL_BR1483) {
							// vc index should be less than 10
							str_vc[2] = '0'+VC_INDEX(Entry.ifIndex);
							// iptables -A macfilter -i vc0 -j DROP
							va_cmd(IPTABLES, 6, 1, (char *)FW_ADD,
								(char *)FW_MACFILTER, (char *)ARG_I,
								str_vc, "-j", (char *)FW_DROP);
						}
					}
				}
			}
			// iptables -A FORWARD -j macfilter
			//va_cmd(IPTABLES, 4, 1, (char *)FW_ADD, (char *)FW_FORWARD, "-j", (char *)FW_MACFILTER);
		// Commented by Mason Yu
		//}
	}
	printf("\nRestart macfilter!\n");
	return 0;
}

int apply_MACFILTER( int action_type, int id, void *olddata )
{
	switch( action_type )
	{
	case CWMP_START:
	case CWMP_RESTART:
	case CWMP_STOP:
		restart_macfilter();
		break;
	default:
		return -1;
	}
	return 0;

}

#endif

#define DDNSPID "/var/run/ddns.pid"
int restart_ddns()
{
	int ddnspid=0;

	ddnspid = read_pid((char*)DDNSPID);

	printf("\nddnspid=%d\n",ddnspid);

	if(ddnspid > 0)
		kill(ddnspid, SIGUSR1);

	return 0;
}

int apply_DDNS( int action_type, int id, void *olddata )
{
	switch( action_type )
	{
	case CWMP_START:
	case CWMP_RESTART:
	case CWMP_STOP:
		restart_ddns();
		break;
	default:
		return -1;
	}
	return 0;

}

#endif //_CWMP_APPLY_

#ifdef CONFIG_CTC_E8_CLIENT_LIMIT
#define PROCFS_NAME    "/proc/ClientsMonitor"
int proc_write_for_mwband()
{	
	FILE *fp;
	unsigned int vInt;
	unsigned char Value;
	unsigned char curbuffer[1024];
	unsigned char *curptr = curbuffer;
	int len =0;

	if ((fp = fopen(PROCFS_NAME, "w")) == NULL)
	{
		printf("Open file %s failed !\n", PROCFS_NAME);
		return -1;
	}

	memset(curbuffer, 0, 1024);

	len=sprintf(curptr, "flagLimitOnAll "); // set ip to detect...
	 if(len < 0)
	  goto err;
	 curptr+=len;
	 mib_get( CWMP_CT_MWBAND_MODE, (void *)&vInt);
//	 printf("\nflagLimitOnAll=%d\n",vInt);
	 len=sprintf(curptr, "%d\n", vInt);            
	 curptr+=len;
	 
	 len=sprintf(curptr, "limitOnAll "); // set ip to detect...
	 if(len < 0)
	  goto err;
	 curptr+=len;
	 mib_get( CWMP_CT_MWBAND_NUMBER, (void *)&vInt);
//	 printf("\nlimitOnAll=%d\n",vInt);
	 len=sprintf(curptr, "%d\n", vInt);
	 curptr+=len;
	 
	 len=sprintf(curptr, "computerLimitEnable "); // set ip to detect...
	 if(len < 0)
	  goto err;
	 curptr+=len;
	 mib_get( CWMP_CT_MWBAND_PC_ENABLE, (void *)&Value);
//	 printf("\ncomputerLimitEnable=%d\n",Value);
	 len=sprintf(curptr, "%d\n", Value);
	 curptr+=len;
	 
	 len=sprintf(curptr, "limitOnComputer "); // set ip to detect...
	 if(len < 0)
	  goto err;
	 curptr+=len;
	 mib_get( CWMP_CT_MWBAND_PC_NUM, (void *)&vInt);
//	 printf("\nlimitOnComputer=%d\n",vInt);
	 len=sprintf(curptr, "%d\n", vInt);
	 curptr+=len;
	 
	 len=sprintf(curptr, "cameraLimitEnable "); // set ip to detect...
	 if(len < 0)
	  goto err;
	 curptr+=len;
	 mib_get( CWMP_CT_MWBAND_CMR_ENABLE, (void *)&Value);
//	 printf("\ncameraLimitEnable=%d\n",Value);
	 len=sprintf(curptr, "%d\n", Value);
	 curptr+=len;
	 
	 len=sprintf(curptr, "limitOnCamera "); // set ip to detect...
	 if(len < 0)
	  goto err;
	 curptr+=len;
	 mib_get( CWMP_CT_MWBAND_CMR_NUM, (void *)&vInt);
//	 printf("\nlimitOnCamera=%d\n",vInt);
	 len=sprintf(curptr, "%d\n", vInt);
	 curptr+=len;

    // set stb to detect...
    len = sprintf(curptr, "stbLimitEnable "); 
    if (len < 0)
    {
        goto err;
    }
    curptr += len;
    mib_get(CWMP_CT_MWBAND_STB_ENABLE, (void *)&Value);
    len = sprintf(curptr, "%d\n", Value);
    curptr += len;

    len = sprintf(curptr, "limitOnStb ");
    if (len < 0)
    {
        goto err;
    }
    curptr += len;
    mib_get(CWMP_CT_MWBAND_STB_NUM, (void *)&vInt);
    len = sprintf(curptr, "%d\n", vInt);
    curptr += len;

    // set phone to detect...
    len = sprintf(curptr, "phnLimitEnable "); 
    if (len < 0)
    {
        goto err;
    }
    curptr += len;
    mib_get(CWMP_CT_MWBAND_PHN_ENABLE, (void *)&Value);
    len = sprintf(curptr, "%d\n", Value);
    curptr += len;

    len = sprintf(curptr, "phnLimitEnable ");
    if (len < 0)
    {
        goto err;
    }
    curptr += len;
    mib_get(CWMP_CT_MWBAND_PHN_NUM, (void *)&vInt);
    len = sprintf(curptr, "%d\n", vInt);
    curptr += len;

	fwrite(curbuffer, 1024, 1, fp);
	fclose(fp);
	return 0;
err:
	fclose(fp);
	return -1;

}

#endif //CONFIG_CTC_E8_CLIENT_LIMIT
#endif //_CWMP_MIB_

   

//jim for china telecom auto-gen wan name.
#ifdef CTC_WAN_NAME
#ifdef _CWMP_MIB_
static void set_endpoint(char *newurl, char *acsurl) //star: remove "http://" from acs url string
{ 
	  register const char *s;
	  register size_t i, n;
	  newurl[0] = '\0';
;
	  if (!acsurl || !*acsurl)
	    return;
	  s = strchr(acsurl, ':');
	  if (s && s[1] == '/' && s[2] == '/')
	    s += 3;
	  else
	    s = acsurl;
	  n = strlen(s);
	  if(n>256)
	  	n=256;

	  for (i = 0; i < n; i++)
	  { newurl[i] = s[i];
	    if (s[i] == '/' || s[i] == ':')
	      break; 
	  }

	  newurl[i] = '\0';
}
void setapplicationtype_tr069(MIB_CE_ATM_VC_T *pEntry, int mode, char *urlvalue)
{
	char vStr[256+1];
	char acsurl[256+1];
	struct hostent *host;
	struct in_addr acsaddr;
	char* argv[7];
	char *operationMode[2]={"add","del"};
	char *iptablesopt[2]={"-A","-D"};

	if(pEntry->cmode!=0){
		if(urlvalue==NULL){
				mib_get(CWMP_ACS_URL,(void*)vStr);
				set_endpoint(acsurl,vStr);
		}else
				set_endpoint(acsurl,urlvalue);
		host=gethostbyname(acsurl);
		if(host==NULL)
			return;
		memcpy((char *) &(acsaddr.s_addr), host->h_addr_list[0], host->h_length);
	
		if(pEntry->applicationtype==2)//TR_069
		{			
				char interfaceName[8]={0};
				char DstIp[20]={0};
				//route del -host 192.168.2.241 dev vc0
				argv[1]=operationMode[mode];
				argv[2]="-host";
				strcpy(DstIp,inet_ntoa(acsaddr));
				argv[3]=DstIp;
				argv[4]="dev";
				if(pEntry->ifIndex>=0xf0) snprintf(interfaceName,sizeof(interfaceName),"vc%d",VC_INDEX(pEntry->ifIndex));
				else snprintf(interfaceName,sizeof(interfaceName),"ppp%d",PPP_INDEX(pEntry->ifIndex));
				argv[5]=interfaceName;
				argv[6]=NULL;
				printf("/bin/route %s %s %s %s  %s!\n",argv[1],argv[2],argv[3],argv[4],argv[5]);
				if((mode==0)&&(strstr(interfaceName,"ppp")!=0)){
					char file[20];
					FILE *fp;
					
					sprintf(file,"/etc/ppp/ifup_%s",interfaceName); //the ppp ifup script
					fp=fopen(file,"a+");
					if(fp){
						fprintf(fp,"/bin/route %s %s %s %s %s\n",argv[1],argv[2],argv[3],argv[4],argv[5]);
						fclose(fp);
					}
				}
				do_cmd("/bin/route",argv,1);
			
		}else if(pEntry->applicationtype==1){
			char DstIp[20]={0};
			char interfaceName[8]={0};
			
			strcpy(DstIp,inet_ntoa(acsaddr));
			if(pEntry->ifIndex>=0xf0) snprintf(interfaceName,sizeof(interfaceName),"vc%d",VC_INDEX(pEntry->ifIndex));
				else snprintf(interfaceName,sizeof(interfaceName),"ppp%d",PPP_INDEX(pEntry->ifIndex));
			//iptables -A OUTPUT -o vc0 -d acsip -j DROP
			printf("\n/bin/iptables %s %s %s %s %s %s %s %s\n",iptablesopt[mode], "OUTPUT", (char *)ARG_O, interfaceName, 
				"-d", DstIp, "-j", (char *)FW_DROP);
			va_cmd(IPTABLES, 8, 1, iptablesopt[mode], "OUTPUT", (char *)ARG_O, interfaceName, 
				"-d", DstIp, "-j", (char *)FW_DROP);
		}
	}
	return;

}

void set_acsurl_route_fw(int clearold) //clearold: 1: used in situation of reboot cwmp
									//         0:used in situation of reboot firewall
{
	MIB_CE_ATM_VC_T Entry;
	int total,i;
	char oldurl[256+1];
	char newurl[256+1];

	mib_get(CWMP_ACS_URL,(void*)newurl);
	if(clearold==0)
		strcpy(oldurl,newurl);
	else
		mib_get(CWMP_ACS_URL_OLD,(void*)oldurl);
	total = mib_chain_total(MIB_ATM_VC_TBL);
	for(i=0;i<total;i++){
		if(mib_chain_get(MIB_ATM_VC_TBL,i,&Entry)!=1)
			continue;
		if((Entry.applicationtype==2)||(Entry.applicationtype==1)){//TR069
			setapplicationtype_tr069(&Entry,1,oldurl); // del old acs url route rule
			setapplicationtype_tr069(&Entry,0,newurl); // add new acs url route rule
		}
	}
	return;
}
#endif
//jim: to get wan MIB by index... this index is combined index for ppp or vc...
int getWanEntrybyindex(MIB_CE_ATM_VC_T *pEntry, unsigned char ifIndex)
{
	if(pEntry==NULL)
		return -1;
	int mibtotal,i,num=0,totalnum=0;
	MIB_CE_ATM_VC_T Entry;
	mibtotal = mib_chain_total(MIB_ATM_VC_TBL);
	for(i=0;i<mibtotal;i++)
	{
		if(!mib_chain_get(MIB_ATM_VC_TBL, i, (void *)&Entry))
			continue;
		if(Entry.ifIndex == ifIndex)
			break;
	}
	if(i==mibtotal)
		return -1;
	memcpy(pEntry, &Entry, sizeof(Entry));
	return 0;
}

//star: to get ppp index for wanname
int getpppindex(MIB_CE_ATM_VC_T *pEntry)
{
	int ret=-1;
	int mibtotal,i,num=0,totalnum=0;
	unsigned char pppindex,tmpindex;
	MIB_CE_ATM_VC_T Entry;

	if(pEntry->cmode != ADSL_PPPoE && pEntry->cmode != ADSL_PPPoA)
		return ret;
	
	pppindex = (pEntry->ifIndex >> 4) & 0x0f;
	if(pppindex == 0x0f)
		return ret;

	mibtotal = mib_chain_total(MIB_ATM_VC_TBL);
	for(i=0;i<mibtotal;i++)
	{
		if(!mib_chain_get(MIB_ATM_VC_TBL, i, (void *)&Entry))
			continue;
		if(Entry.cmode != ADSL_PPPoE && Entry.cmode != ADSL_PPPoA)
			continue;
		tmpindex = (Entry.ifIndex >> 4) & 0x0f;
		if(tmpindex == 0x0f)
			continue;
		if(Entry.vpi == pEntry->vpi && Entry.vci == pEntry->vci)
		{
			totalnum++;
			if(tmpindex < pppindex)
				num++;
		}
	}

	if(totalnum > 1)
		ret = num;

	return ret;

}

int generateWanName(MIB_CE_ATM_VC_T *entry, char* wanname)
{
	char vpistr[6];
	char vcistr[6];
	int i, mibtotal;
	MIB_CE_ATM_VC_T tmpEntry;
	mibtotal = mib_chain_total(MIB_ATM_VC_TBL);
	for(i=0; i< mibtotal; i++)
	{
		mib_chain_get(MIB_ATM_VC_TBL, i, &tmpEntry);
		if(tmpEntry.ifIndex == entry->ifIndex)
			break;
	}
	if(i==mibtotal)
		return -1;
	i++;
	sprintf(wanname, "%d_", i);
	if(entry==NULL || wanname ==NULL)
		return -1;
	memset(vpistr, 0, sizeof(vpistr));
	memset(vcistr, 0, sizeof(vcistr));
	switch(entry->applicationtype)
	{
		//TR069_Internet
		case 0:
			strcat(wanname, "TR069_Internet_");
			break;
		//Internet
		case 1:
			strcat(wanname, "Internet_");
			break;
			//TR069
		case 2:
			strcat(wanname, "TR069_");
			break;
		//Others
		case 3:
			strcpy(wanname, "Other_");
			break;
		default:
			strcat(wanname, "Internet_");
			break;
	}	
	if(entry->cmode == ADSL_BR1483)
		strcat(wanname, "B_");
	else
		strcat(wanname, "R_");
	sprintf(vpistr, "%d", entry->vpi);
	sprintf(vcistr, "%d", entry->vci);
	strcat(wanname, vpistr);
	strcat(wanname, "_");
	strcat(wanname, vcistr);
	//star: for multi-ppp in one pvc
	/*
	if(entry->cmode == ADSL_PPPoE || entry->cmode == ADSL_PPPoA)
	{	
			char pppindex[6];
			int intindex;
			intindex = getpppindex(entry);
			if(intindex != -1){
					snprintf(pppindex,6,"%u",intindex);
					strcat(wanname, "_");
					strcat(wanname, pppindex);
			}
	}*/
	
	return 0;
}

int setWanName(char* str, int applicationtype)
{
	switch(applicationtype)
	{
		//Internet
		case 0:
			strcpy(str, "TR069_Internet_");
			break;
		//TR069_Internet
		case 1:
			strcpy(str, "Internet_");
			break;
			//TR069
		case 2:
			strcpy(str, "TR069_");
			break;
		//Others
		case 3:
			strcpy(str, "Other_");
			break;
		default:
			strcpy(str, "Internet_");
			break;
	}	
}

int getWanName(MIB_CE_ATM_VC_T *pEntry, char* name)
{
	if(pEntry==NULL || name==NULL)
		return 0;
#ifdef _CWMP_MIB_	
	if(*(pEntry->WanName))
		strcpy(name, pEntry->WanName);
	else		
#endif		
	{//if not set by ACS. then generate automaticly.  
		char wanname[40];
		memset(wanname, 0, sizeof(wanname));
		generateWanName(pEntry, wanname);
		strcpy(name, wanname);
	}
	return 1;
}
int getifIndexByWanName(const char *name)
{
	int index=0;
	int cnt=mib_chain_total(MIB_ATM_VC_TBL);
	MIB_CE_ATM_VC_T pvcEntry;
	for(index=0;index<cnt;index++)
		{
			char itfname[256]={0};
			mib_chain_get(MIB_ATM_VC_TBL,index,&pvcEntry);
			getWanName(&pvcEntry, itfname);
			if(!strncmp(name,itfname,strlen(name)))
				return pvcEntry.ifIndex;			
		}
     return -1;
}
int getRipItfName(MIB_CE_ATM_VC_T *pEntry, char* name)
{
	char vpistr[6];
	char vcistr[6];
	char wanname[40];

	if(pEntry==NULL || name==NULL)
		return 0;
	
	memset(vpistr, 0, sizeof(vpistr));
	memset(vcistr, 0, sizeof(vcistr));

	switch(pEntry->cmode)
	{
		case ADSL_MER1483:
		case ADSL_RT1483:
			strcpy(wanname, "nas_0_");
			break;
		case ADSL_PPPoE:
		case ADSL_PPPoA:
			strcpy(wanname, "ppp_0_");
			break;
		default:
			break;
	}
	
	sprintf(vpistr, "%d", pEntry->vpi);
	sprintf(vcistr, "%d", pEntry->vci);
	strcat(wanname, vpistr);
	strcat(wanname, "_");
	strcat(wanname, vcistr);
	//star: for multi-ppp in one pvc
	if(pEntry->cmode == ADSL_PPPoE || pEntry->cmode == ADSL_PPPoA)
	{	
		char pppindex[6];
		int intindex;
		intindex = getpppindex(pEntry);
		if(intindex != -1){
			snprintf(pppindex,6,"%u",intindex);
			strcat(wanname, "_");
			strcat(wanname, pppindex);
		}
	}
	strcpy(name, wanname);
	
	return 1;
}

#if 0
int updateWanName(int recordNum)
{
		MIB_CE_ATM_VC_T Entry;
		char vpistr[6];
		char vcistr[6];
		char interfacename[MAX_NAME_LEN];
		memset(vpistr, 0, sizeof(vpistr));
		memset(vcistr, 0, sizeof(vcistr));		
		memset(interfacename, 0, sizeof(interfacename));
			//first found the mib info...
	
		
		if (!mib_chain_get(MIB_ATM_VC_TBL, recordNum, (void *)&Entry))
		{
  			printf("Get chain record error!\n");
			return -1;
		}
		sprintf(vpistr, "%d", Entry.vpi);
		sprintf(vcistr, "%d", Entry.vci);
		setWanName(interfacename, Entry.applicationtype);
		if(Entry.cmode == ADSL_BR1483)
			strcat(interfacename, "B_");
		else
			strcat(interfacename, "R_");
		strcat(interfacename, vpistr);
		strcat(interfacename, "_");
		strcat(interfacename, vcistr);
		strcpy(Entry.WanName, interfacename);
		mib_chain_update(MIB_ATM_VC_TBL, (void *)&Entry, recordNum);		
		
}
int updateAllWanNames()
{
		MIB_CE_ATM_VC_T Entry;
		int entryNum;
		int mibcnt;
		char vpistr[6];
		char vcistr[6];
		char interfacename[MAX_NAME_LEN];
		entryNum = mib_chain_total(MIB_ATM_VC_TBL);
		memset(vpistr, 0, sizeof(vpistr));
		memset(vcistr, 0, sizeof(vcistr));		
		memset(interfacename, 0, sizeof(interfacename));
		printf("we just always enable Wan Name auto generated!\n");
			//first found the mib info...
		for(mibcnt=0; mibcnt<entryNum; mibcnt++)
		{
			updateWanName(mibcnt);
			/*
			if (!mib_chain_get(MIB_ATM_VC_TBL, mibcnt, (void *)&Entry))
			{
  				printf("Get chain record error!\n");
				return -1;
			}
			sprintf(vpistr, "%d", Entry.vpi);
			sprintf(vcistr, "%d", Entry.vci);
			setWanName(interfacename, Entry.applicationtype);
			if(Entry.cmode == ADSL_BR1483)
			
				strcat(interfacename, "B_");
			else
				strcat(interfacename, "R_");
			strcat(interfacename, vpistr);
			strcat(interfacename, "_");
			strcat(interfacename, vcistr);
			strcpy(Entry.WanName, interfacename);
			mib_chain_update(MIB_ATM_VC_TBL, (void *)&Entry, mibcnt);		*/
		}
	
}
#endif //if 0
#endif


#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
	//jim used for save/restore config files to distinguish bridge or router.
unsigned int ZTE_Bridge_Config_Keyword=0xB606FBE5;
unsigned int ZTE_Router_Config_Keyword=0xA606EAD5;
void ZTE_Encrypt(char * original, char *encrypted, char initial, int len)
{
	int i;
	//*encrypted=(initial + *original) & 0xFF;
	for(i=0/*1*/; i<len; i++)
	{
		//*(encrypted+i)=*( encrypted+i-1) + *(original+i)) & 0xFF;
		*(encrypted+i)=*(original+i)^0xFF;
	}
return;
} 


void ZTE_Deencrypt(char * original, char *encrypted, char initial, int len)
{
	int i;
	char previous_encrypted_byte;
	previous_encrypted_byte=*encrypted;
	//*original =(256*encrypted -initial) & 0xFF;
	for(i=0/*1*/; i<len; i++)
	{
		//char dup_previous_encrypted_byte;
		//dup_previous_encrypted_byte=*(encrypted+i);
		//*(original+i) =(256+dup_previous_encrypted_byte-previous_encrypted_byte) & 0xFF;
		//previous_encrypted_byte= dup_previous_encrypted_byte;
		*(original+i)=*(encrypted+i)^0xFF;
	}
return;
}

#endif

//#ifdef ZTE_LED_REQUEST
#include <linux/atmdev.h>

struct arg{
	unsigned char cmd;
	unsigned int cmd2;
	unsigned int cmd3;
	unsigned int cmd4;
}pass_arg;

#ifdef _LINUX_2_6_
#define SIOCETHTEST	0x89b1
#else
#define SIOCETHTEST	0x89a1
#endif
//star: for ZTE internet LED request
int Internet_status(int retflag)
{
#ifdef EMBED
	int skfd, i;
	struct atmif_sioc mysio;
	struct SAR_IOCTL_CFG cfg;
	struct ch_stat stat;
	int mibcnt,entryNum;
	int internet_flag=0;
	int adslflag;
	Modem_LinkSpeed vLs;
	MIB_CE_ATM_VC_T Entry;

	entryNum = mib_chain_total(MIB_ATM_VC_TBL);
	
	// check for xDSL link
	if (!adsl_drv_get(RLCM_GET_LINK_SPEED, (void *)&vLs, RLCM_GET_LINK_SPEED_SIZE) || vLs.upstreamRate == 0)
		adslflag = 0;
	else
		adslflag = 1;

	// pvc statistics
	if((skfd = socket(PF_ATMPVC, SOCK_DGRAM, 0)) < 0){
		perror("socket open error");
		return;
	}
	
	mysio.number = 0;

	for (i=0; i < MAX_VC_NUM; i++)
	{
		
		cfg.ch_no = i;
		mysio.arg = (void *)&cfg;
		if(ioctl(skfd, ATM_SAR_GETSTAT, &mysio)<0)
		{
			(void)close(skfd);
			return;
		}

		if (cfg.created == 0)
			continue;	
		
		//check mib chain to see the channel mode of the current channel.
		char ifname[10];
		int flags;
		struct in_addr inAddr;
		for(mibcnt=0; mibcnt<entryNum; mibcnt++)
		{
			if (!mib_chain_get(MIB_ATM_VC_TBL, mibcnt, (void *)&Entry))
			{
				printf("get MIB chain error\n");
				continue;
			}
			
			if(Entry.enable==0)
				continue;
			
			if(Entry.vpi==cfg.vpi && Entry.vci==cfg.vci)
			{
				//found entry in mibs, get channel mode
				cfg.rfc = Entry.cmode;
				{
					if(cfg.rfc != ADSL_BR1483)
					{ 
						if (PPP_INDEX(Entry.ifIndex) != 0x0f)
						{	// PPP interface
							snprintf(ifname, 6, "ppp%u", PPP_INDEX(Entry.ifIndex));
						}
						else
						{	// vc interface
							snprintf(ifname, 6, "vc%u", VC_INDEX(Entry.ifIndex));
						}
						if (getInFlags(ifname, &flags) == 1)
						{
							if (flags & IFF_UP) {
								if (adslflag) {
										if (getInAddr( ifname, IP_ADDR, (void *)&inAddr) == 1)
										{
	//										printf("\nvpi=%d,vci=%d,inAddr=%x,ifname=%s\n",Entry.vpi,Entry.vci,inAddr.s_addr,ifname);
											internet_flag = 1;
											break;
										}
								}
							}
						}
					}
				}
			}
		}
		if(internet_flag == 1)
			break;
	}
	
	(void)close(skfd);

	if(retflag==1)
		return internet_flag;
	
 	int fd=0;    
	struct ifreq		ifr1;

	fd = socket(AF_INET, SOCK_DGRAM, 0);
	  if(fd< 0){
		printf("LED control fail!\n");
		return;
	  }
	strncpy(ifr1.ifr_name, "eth0", IFNAMSIZ);
	ifr1.ifr_data = (void *)&pass_arg;
	if(internet_flag == 1)
		pass_arg.cmd = 15;
	else
		pass_arg.cmd = 16;
	pass_arg.cmd2 = 0;
	pass_arg.cmd3 = 0;
	pass_arg.cmd4 = 0;
	ioctl(fd, SIOCETHTEST, &ifr1);

	close(fd);

	return 0;
#endif	
}
//#endif

#ifdef QSETUP_WEB_REDIRECT
int reset_qsetup_redirect() {
	MIB_CE_ATM_VC_T Entry;
	int vcTotal, i,  redirectNum = 0;
//	unsigned char iptables_flag = 0;
	int iptables_flag = 0;
	FILE *fp;

	vcTotal = mib_chain_total(MIB_ATM_VC_TBL);

	for (i = 0; i < vcTotal; i++) {
		if (!mib_chain_get(MIB_ATM_VC_TBL, i, (void *)&Entry))
			return -1;
		if (Entry.enable == 0)
			continue;
		if ((REMOTE_ACCESS_T)Entry.cmode == ACC_PPPOE || (REMOTE_ACCESS_T)Entry.cmode == ACC_PPPOA)
			redirectNum ++;
	}

//	mib_get(MIB_QSETUP_REDIRECT, (void *)&iptables_flag);
	if ((fp = fopen("/tmp/QSetup", "r"))) {
		fscanf(fp, "%d\n", &iptables_flag);
		fclose(fp);
	}
	printf("reset_qsetup_redirect: startRedirect=%d\n", iptables_flag);
	if (redirectNum > 0) {
		struct data_to_pass_st msg;
		stop_qsetup_redirect();
		start_qsetup_redirect();
		snprintf(msg.data, BUF_SIZE, "spppctl show 0");
		TRACE(STA_SCRIPT, "%s\n", msg.data);
		write_to_pppd(&msg);
	}
	else if (redirectNum == 0 && iptables_flag)
		stop_qsetup_redirect();
	return 1;
}

int start_qsetup_redirect() {

	int status=0;
	char tmpbuf[6], ipaddr[16];
//	unsigned char startRedirect;	
	int startRedirect = 0;
	FILE *fp;
	
//	mib_get(MIB_QSETUP_REDIRECT, (void *)&startRedirect);
	if ((fp = fopen("/tmp/QSetup", "r"))) {
		fscanf(fp, "%d\n", &startRedirect);
		fclose(fp);
	}
	if (startRedirect)
		return status;

	ipaddr[0] = '\0';
	if (mib_get(MIB_ADSL_LAN_IP, (void *)tmpbuf) != 0) {
		strncpy(ipaddr, inet_ntoa(*((struct in_addr *)tmpbuf)), 16);
		ipaddr[15] = '\0';
	}

	/*
	startRedirect = 1;
	if (!mib_set(MIB_QSETUP_REDIRECT, (void *)&startRedirect)) {
		printf("Set quick setup redirect flag error!");
		return status;
	}
	*/

	//iptables -t nat -A PREROUTING -d ! 192.168.1.1 -p tcp --dport 80 -j REDIRECT --to-port 2046
	//status|=va_cmd(IPTABLES, 15, 1, (char *)ARG_T, "nat", (char *)FW_ADD, (char *)FW_PREROUTING,
	//	"-d", "!", ipaddr, "-p", (char *)ARG_TCP, (char *)FW_DPORT, "80", "-j", "REDIRECT", "--to-port", "2046");
//	printf("start_qsetup_redirect: startRedirect=%d\n", startRedirect);
	//iptables -t nat -N QSetup_Redirect
	status|=va_cmd(IPTABLES, 4, 1, (char *)ARG_T, "nat","-N","QSetup_Redirect");

	//iptables -t nat -A QSetup_Redirect -d 192.168.1.1 -j RETURN
	status|=va_cmd(IPTABLES, 8, 1, (char *)ARG_T, "nat", (char *)FW_ADD, "QSetup_Redirect",
		"-d", ipaddr, "-j", (char *)FW_RETURN);

	//iptables -t nat -A QSetup_Redirect -p tcp --dport 80 -j DNAT --to-destination 192.168.1.1:2046 
	//status|=va_cmd(IPTABLES, 12, 1, (char *)ARG_T, "nat", (char *)FW_ADD, "QSetup_Redirect",
	//	"-p", (char *)ARG_TCP, (char *)FW_DPORT, "80", "-j", "DNAT", "--to-destination", ip_port);
	//iptables -t nat -A QSetup_Redirect -p tcp --dport 80 -j REDIRECT --to-port  2046 
	status|=va_cmd(IPTABLES, 12, 1, (char *)ARG_T, "nat", (char *)FW_ADD, "QSetup_Redirect",
		"-p", (char *)ARG_TCP, (char *)FW_DPORT, "80", "-j", "REDIRECT", "--to-port", "2046");

	//iptables -t nat -A PREROUTING -p tcp --dport 80 -j QSetup_Redirect
	status|=va_cmd(IPTABLES, 10, 1, (char *)ARG_T, "nat", (char *)FW_ADD, (char *)FW_PREROUTING,
		"-p", (char *)ARG_TCP, (char *)FW_DPORT, "80", "-j", "QSetup_Redirect");

	startRedirect = 1;
	fp = fopen("/tmp/QSetup", "w");
	fprintf(fp, "%d", startRedirect);
	fclose(fp);

	printf("start_qsetup_redirect: startRedirect=%d\n", startRedirect);

	return status;	
}

int stop_qsetup_redirect() {

	int status=0;
	char tmpbuf[6], ipaddr[16];
//	unsigned char startRedirect;	
	int startRedirect = 0;
	FILE *fp;
	
//	mib_get(MIB_QSETUP_REDIRECT, (void *)&startRedirect);
	if ((fp = fopen("/tmp/QSetup", "r"))) {
		fscanf(fp, "%d\n", &startRedirect);
		fclose(fp);
	}
	if (!startRedirect)
		return status;

	ipaddr[0] = '\0';
	if (mib_get(MIB_ADSL_LAN_IP, (void *)tmpbuf) != 0) {
		strncpy(ipaddr, inet_ntoa(*((struct in_addr *)tmpbuf)), 16);
		ipaddr[15] = '\0';
	}

	/*
	startRedirect = 0;
	if (!mib_set(MIB_QSETUP_REDIRECT, (void *)&startRedirect)) {
		printf("Set quick setup redirect flag error!");
		return status;
	}
	*/

	//iptables -t nat -D PREROUTING -d ! 192.168.1.1 -p tcp --dport 80 -j REDIRECT --to-port 2046
	//status|=va_cmd(IPTABLES, 15, 1, (char *)ARG_T, "nat", (char *)FW_DEL, (char *)FW_PREROUTING,
	//	"-d", "!", ipaddr, "-p", (char *)ARG_TCP, (char *)FW_DPORT, "80", "-j", "REDIRECT", "--to-port", "2046");
//	printf("stop_qsetup_redirect: startRedirect=%d\n", startRedirect);
	//iptables -t nat -D PREROUTING -p tcp --dport 80 -j QSetup_Redirect
	status|=va_cmd(IPTABLES, 10, 1, (char *)ARG_T, "nat", (char *)FW_DEL, (char *)FW_PREROUTING,
		"-p", (char *)ARG_TCP, (char *)FW_DPORT, "80", "-j", "QSetup_Redirect");

	//iptables -t nat -F QSetup_Redirect
	status|=va_cmd(IPTABLES, 4, 1, (char *)ARG_T, "nat", "-F", "QSetup_Redirect");

	//iptables -t nat -X QSetup_Redirect
	status|=va_cmd(IPTABLES, 4, 1, (char *)ARG_T, "nat","-X","QSetup_Redirect");

	startRedirect = 0;
	fp = fopen("/tmp/QSetup", "w");
	fprintf(fp, "%d", startRedirect);
	fclose(fp);

	printf("stop_qsetup_redirect: startRedirect=%d\n", startRedirect);
//	va_cmd("/bin/ethctl", 2, 1, "conntrack", "killall");
	return status;	
}
#endif

#define DEFDATALEN	56
#define PINGCOUNT 3
#define PINGINTERVAL	1	/* second */
#define MAXWAIT		5

static struct sockaddr_in pingaddr;
static int pingsock = -1;
static long ntransmitted = 0, nreceived = 0, nrepeats = 0;
static int myid = 0;
static int finished = 0;

static int create_icmp_socket(void)
{
	struct protoent *proto;
	int sock;

	proto = getprotobyname("icmp");
	/* if getprotobyname failed, just silently force
	 * proto->p_proto to have the correct value for "icmp" */
	if ((sock = socket(AF_INET, SOCK_RAW,
			(proto ? proto->p_proto : 1))) < 0) {        /* 1 == ICMP */
		printf("cannot create raw socket\n");
	}

	return sock;
}
static int in_cksum(unsigned short *buf, int sz)
{
	int nleft = sz;
	int sum = 0;
	unsigned short *w = buf;
	unsigned short ans = 0;

	while (nleft > 1) {
		sum += *w++;
		nleft -= 2;
	}

	if (nleft == 1) {
		*(unsigned char *) (&ans) = *(unsigned char *) w;
		sum += ans;
	}

	sum = (sum >> 16) + (sum & 0xFFFF);
	sum += (sum >> 16);
	ans = ~sum;
	return (ans);
}

static void pingfinal()
{
	finished = 1;
}
static void sendping()
{
	struct icmp *pkt;
	int c;
	char packet[DEFDATALEN + 8];

	pkt = (struct icmp *) packet;
	pkt->icmp_type = ICMP_ECHO;
	pkt->icmp_code = 0;
	pkt->icmp_cksum = 0;
	pkt->icmp_seq = ntransmitted++;
	pkt->icmp_id = myid;
	pkt->icmp_cksum = in_cksum((unsigned short *) pkt, sizeof(packet));

	c = sendto(pingsock, packet, sizeof(packet), 0,
			   (struct sockaddr *) &pingaddr, sizeof(struct sockaddr_in));
	
	if (c < 0 || c != sizeof(packet)) {
		ntransmitted--;
		finished = 1;
		printf("sock: sendto fail !");
		return;
	}
	
	signal(SIGALRM, sendping);
	if (ntransmitted < PINGCOUNT) {	/* schedule next in 1s */
		alarm(PINGINTERVAL);
	} else {	/* done, wait for the last ping to come back */
		signal(SIGALRM, pingfinal);
		alarm(MAXWAIT);
	}
}

int utilping(char *str){
//	char *submitUrl;
	char tmpBuf[100];
	int c;
	struct hostent *h;
	struct icmp *pkt;
	struct iphdr *iphdr;
	char packet[DEFDATALEN + 8];
	int rcvdseq, ret=0;
	fd_set rset;
	struct timeval tv;
	
	if (str[0]) {
		if ((pingsock = create_icmp_socket()) < 0) {
			perror("socket");
			snprintf(tmpBuf, 100, "ping: socket create error");
			goto setErr_ping;
		}
	
		memset(&pingaddr, 0, sizeof(struct sockaddr_in));
		pingaddr.sin_family = AF_INET;
		
		if ((h = gethostbyname(str)) == NULL) {
			//herror("ping: ");
			//snprintf(tmpBuf, 100, "ping: %s: %s", str, hstrerror(h_errno));
			goto setErr_ping;
		}
		
		if (h->h_addrtype != AF_INET) {
			//strcpy(tmpBuf, T("unknown address type; only AF_INET is currently supported."));
			goto setErr_ping;
		}
	
		memcpy(&pingaddr.sin_addr, h->h_addr, sizeof(pingaddr.sin_addr));

		printf("PING %s (%s): %d data bytes\n",
		   h->h_name,inet_ntoa(*(struct in_addr *) &pingaddr.sin_addr.s_addr),DEFDATALEN);
		
		myid = getpid() & 0xFFFF;
		ntransmitted = nreceived = nrepeats = 0;
		finished = 0;
		rcvdseq=ntransmitted-1;
		FD_ZERO(&rset);
		FD_SET(pingsock, &rset);
		/* start the ping's going ... */
		sendping();
		
		/* listen for replies */
		while (1) {
			struct sockaddr_in from;
			socklen_t fromlen = (socklen_t) sizeof(from);
			int c, hlen, dupflag;
			
			if (finished)
				break;
			
			tv.tv_sec = 1;
			tv.tv_usec = 0;
			
			if (select(pingsock+1, &rset, NULL, NULL, &tv) > 0) {
				if ((c = recvfrom(pingsock, packet, sizeof(packet), 0,
								  (struct sockaddr *) &from, &fromlen)) < 0) {
					
					printf("sock: recvfrom fail !");
					continue;
				}
			}
			else // timeout or error
				continue;
			
			if (c < DEFDATALEN+ICMP_MINLEN)
				continue;
			
			iphdr = (struct iphdr *) packet;
			hlen = iphdr->ihl << 2;
			pkt = (struct icmp *) (packet + hlen);	/* skip ip hdr */
			if (pkt->icmp_id != myid) {
//				printf("not myid\n");
				continue;
			}
			if (pkt->icmp_type == ICMP_ECHOREPLY) {
				++nreceived;
				if (pkt->icmp_seq == rcvdseq) {
					// duplicate
					++nrepeats;
					--nreceived;
					dupflag = 1;
				} else {
					rcvdseq = pkt->icmp_seq;
					dupflag = 0;
					if (nreceived < PINGCOUNT)
					// reply received, send another immediately
						sendping();
				}
				printf("%d bytes from %s: icmp_seq=%u", c,
					   inet_ntoa(*(struct in_addr *) &from.sin_addr.s_addr),
					   pkt->icmp_seq);
				if (dupflag) {
					printf(" (DUP!)");
				}
				printf("\n");
			}
			if (nreceived >= PINGCOUNT) {
				ret = 1;
				break;
			}
		}
		FD_CLR(pingsock, &rset);
		close(pingsock);
		pingsock = -1;
	}
	printf("\n--- ping statistics ---\n");
	printf("%ld packets transmitted, ", ntransmitted);
	printf("%ld packets received\n\n", nreceived);
	if (nrepeats)
		printf("%ld duplicates, ", nrepeats);
	printf("\n");
	return ret;
setErr_ping:
	if (pingsock >= 0) {
		close(pingsock);
		pingsock = -1;
	}
	printf("Ping error!!\n\n");
	return ret;
}

void writeFlash(void){
	unsigned char no_wlan = 0;
	// wait for sar to finish processing all the queueing packets
	sleep(2);
	itfcfg("sar", 0);
	itfcfg((char *)ELANIF, 0);
#ifdef WLAN_SUPPORT
	mib_get(MIB_WLAN_DISABLED, (void *)&no_wlan);
	if (!no_wlan)
		//itfcfg((char *)WLANIF, 0);
		stopwlan();
#endif
	/* upgdate to flash */
	mib_update(CURRENT_SETTING, CONFIG_MIB_ALL);
	itfcfg("sar", 1);
	itfcfg((char *)ELANIF, 1);
#ifdef WLAN_SUPPORT
	mib_get(MIB_WLAN_DISABLED, (void *)&no_wlan);
	if(!no_wlan) {
		startWLan();
#if 0
		unsigned char encrypt, enable1x = 0;
		int auth_pid_fd = -1, status = -1;
		itfcfg((char *)WLANIF, 1);
		mib_get(MIB_WLAN_ENCRYPT, (void *)&encrypt);
#ifdef WLAN_1x
		mib_get( MIB_WLAN_ENABLE_1X, (void *)&enable1x);
#endif
		sleep(1);		

		if ((encrypt >= 2 || enable1x==1) && vChar == 0) {// 802.1x enabled			
			do {
				status = va_cmd(AUTH, 4, 1, WLANIF, LANIF, "auth", WLAN_AUTH_CONF);
				while ((auth_pid_fd = open(AUTH_PID, O_WRONLY)) == -1)
					usleep(30000);				
				close(auth_pid_fd);
				usleep(2000000);
				status |= va_cmd(IWCONTROL, 1, 1, WLANIF);
			} while (status != 0);
		}
#endif
	}
#endif
	sleep(1);
}

#ifdef ACCOUNT_CONFIG
//Jenny, get user account privilege
int getAccPriv(char *user)
{
	int totalEntry, i;
	MIB_CE_ACCOUNT_CONFIG_T Entry;
	char suName[MAX_NAME_LEN], usName[MAX_NAME_LEN];

	mib_get(MIB_SUSER_NAME, (void *)suName);
	mib_get(MIB_USER_NAME, (void *)usName);
	if (strcmp(suName, user) == 0)
		return (int)PRIV_ROOT;
	else if (strcmp(usName, user) == 0)
		return (int)PRIV_USER;
	totalEntry = mib_chain_total(MIB_ACCOUNT_CONFIG_TBL);
	for (i=0; i<totalEntry; i++)
	{
		if (!mib_chain_get(MIB_ACCOUNT_CONFIG_TBL, i, (void *)&Entry))
			continue;
		if (strcmp(Entry.userName, user) == 0)
			return Entry.privilege;
	}
	return -1;
}
#endif

//add by ramen

void DnsBindPvcRoute(int mode)
{
#ifdef DNS_BIND_PVC_SUPPORT
char *operationMode[2]={"add","del"};
unsigned char DnsBindPvcEnable,DnsBindPvc1;
struct in_addr dnsIP1;
char* argv[7];
int i=0;
mib_get(MIB_DNS_BIND_PVC_ENABLE,(void *)&DnsBindPvcEnable);
if(DnsBindPvcEnable)
{
for(i=0;i<3;i++)
	{
		mib_get(MIB_ADSL_WAN_DNS1+i, (void *)&dnsIP1);	
		mib_get(MIB_DNS_BIND_PVC1+i,&DnsBindPvc1);
		if(dnsIP1.s_addr&&(DnsBindPvc1!=255)){			
			char interfaceName[8]={0};
			char DnsIp[20]={0};
			//route del -host 192.168.2.241 dev vc0
			argv[1]=operationMode[mode];
			argv[2]="-host";
			strcpy(DnsIp,inet_ntoa(dnsIP1));
			printf("dnsip=%s DnsBindPvc1=%d\n",DnsIp,DnsBindPvc1);
			argv[3]=DnsIp;
			argv[4]="dev";
			if(DnsBindPvc1>=0xf0) snprintf(interfaceName,sizeof(interfaceName),"vc%d",VC_INDEX(DnsBindPvc1));
			else snprintf(interfaceName,sizeof(interfaceName),"ppp%d",PPP_INDEX(DnsBindPvc1));
			argv[5]=interfaceName;
			argv[6]=NULL;
			printf("/bin/route %s %s %s %s  %s!\n",argv[1],argv[2],argv[3],argv[4],argv[5]);
			do_cmd("/bin/route",argv,1);
			}
	}
}
#endif
return;
}
//jim support dsl disconnection when firmware upgrade from Local Side.....
//retrun value: 1-local        0 - wan         -1 - error
int isAccessFromLocal(unsigned int ip)
{
	unsigned int uLanIp;
	unsigned int uLanMask;
	char secondIpEn;
	unsigned int uSecondIp;
	unsigned int uSecondMask;

	if (!mib_get( MIB_ADSL_LAN_IP, (void *)&uLanIp ))
		return -1;
	if (!mib_get( MIB_ADSL_LAN_SUBNET, (void *)&uLanMask ))
		return -1;
	
	if ( (ip & uLanMask) == (uLanIp & uLanMask) ) {//in the same subnet with LAN port
		return 1;
	} else {
		if (!mib_get( MIB_ADSL_LAN_ENABLE_IP2, (void *)&secondIpEn ))
			return -1;
		
		if (secondIpEn == 1) {//second IP is enabled
			if (!mib_get( MIB_ADSL_LAN_IP2, (void *)&uSecondIp))
				return -1;
			if (!mib_get( MIB_ADSL_LAN_SUBNET2, (void *)&uSecondMask))
				return -1;

			if ( (ip & uSecondMask) == (uSecondIp & uSecondMask) )//in the same subnet with LAN port
				return 1;
		}
	}
	
	return 0;
}


#ifdef CONFIG_WIFI_SIMPLE_CONFIG //WPS
// this is a workaround for wscd to get MIB id without including "mib.h" (which causes compile error), andrew

const int gMIB_WSC_CONFIGURED         = MIB_WSC_CONFIGURED;           
const int gMIB_WLAN_SSID              = MIB_WLAN_SSID;
const int gMIB_WSC_SSID               = MIB_WSC_SSID;
const int gMIB_WLAN_AUTH_TYPE         = MIB_WLAN_AUTH_TYPE;
const int gMIB_WLAN_ENCRYPT           = MIB_WLAN_ENCRYPT;
const int gMIB_WSC_AUTH               = MIB_WSC_AUTH;
const int gMIB_WLAN_WPA_AUTH          = MIB_WLAN_WPA_AUTH;
const int gMIB_WLAN_WPA_PSK           = MIB_WLAN_WPA_PSK;
const int gMIB_WLAN_WPA_PSK_FORMAT    = MIB_WLAN_WPA_PSK_FORMAT;
const int gMIB_WSC_PSK                = MIB_WSC_PSK;
const int gMIB_WLAN_WPA_CIPHER_SUITE  = MIB_WLAN_WPA_CIPHER_SUITE;
const int gMIB_WLAN_WPA2_CIPHER_SUITE = MIB_WLAN_WPA2_CIPHER_SUITE;
const int gMIB_WLAN_WEP               = MIB_WLAN_WEP;
const int gMIB_WLAN_WEP64_KEY1        = MIB_WLAN_WEP64_KEY1;
const int gMIB_WLAN_WEP64_KEY2        = MIB_WLAN_WEP64_KEY2;
const int gMIB_WLAN_WEP64_KEY3        = MIB_WLAN_WEP64_KEY3;
const int gMIB_WLAN_WEP64_KEY4        = MIB_WLAN_WEP64_KEY4;
const int gMIB_WLAN_WEP128_KEY1       = MIB_WLAN_WEP128_KEY1;
const int gMIB_WLAN_WEP128_KEY2       = MIB_WLAN_WEP128_KEY2;
const int gMIB_WLAN_WEP128_KEY3       = MIB_WLAN_WEP128_KEY3;
const int gMIB_WLAN_WEP128_KEY4       = MIB_WLAN_WEP128_KEY4;
const int gMIB_WLAN_WEP_DEFAULT_KEY   = MIB_WLAN_WEP_DEFAULT_KEY;
const int gMIB_WLAN_WEP_KEY_TYPE      = MIB_WLAN_WEP_KEY_TYPE;
const int gMIB_WSC_ENC                = MIB_WSC_ENC;
const int gMIB_WSC_CONFIG_BY_EXT_REG  = MIB_WSC_CONFIG_BY_EXT_REG;
const int gMIB_WSC_PIN = MIB_WSC_PIN;
const int gMIB_ELAN_MAC_ADDR = MIB_ELAN_MAC_ADDR;
const int gMIB_WLAN_MODE = MIB_WLAN_MODE;
const int gMIB_WSC_REGISTRAR_ENABLED = MIB_WSC_REGISTRAR_ENABLED;
const int gMIB_WLAN_CHAN_NUM = MIB_WLAN_CHAN_NUM;
const int gMIB_WSC_UPNP_ENABLED = MIB_WSC_UPNP_ENABLED;
const int gMIB_WSC_METHOD = MIB_WSC_METHOD;
const int gMIB_WSC_MANUAL_ENABLED = MIB_WSC_MANUAL_ENABLED;
const int gMIB_SNMP_SYS_NAME = MIB_SNMP_SYS_NAME;
const int gMIB_WLAN_NETWORK_TYPE = MIB_WLAN_NETWORK_TYPE;
#ifdef MIB_WLAN_RESTART_SUPPORT
const int gMIB_WLAN_RESTART = MIB_WLAN_RESTART;
#endif
int mib_update_all()		
{
	return mib_update(CURRENT_SETTING, CONFIG_MIB_ALL);
}
#endif
#ifdef QOS_SPEED_LIMIT_SUPPORT
//return -1 --not existed
int mib_qos_speed_limit_existed(int speed,int prior)
{
	int entryTotalNum=mib_chain_total(MIB_QOS_SPEED_LIMIT);
	int i=0;
	MIB_CE_IP_QOS_SPEEDRANK_T entry;
	for(i=0;i<entryTotalNum;i++)
		{
		    mib_chain_get(MIB_QOS_SPEED_LIMIT, i, &entry);
		   if(entry.speed==speed&&entry.prior==prior)
		   	return entry.index;
		}
	return -1;
}
#endif

//Ethernet
#if defined(ELAN_LINK_MODE)
#include <linux/sockios.h>
struct mii_ioctl_data {
	unsigned short	phy_id;
	unsigned short	reg_num;
	unsigned short	val_in;
	unsigned short	val_out;
};
#endif

int restart_ethernet(int instnum)
{
	char vChar=0;
	int status=0;

#ifdef _CWMP_MIB_
#ifdef _CWMP_APPLY_

	//eth0 interface enable or disable
	mib_get(CWMP_LAN_ETHIFENABLE, (void *)&vChar);	
	
	if(vChar==0)
	{
		va_cmd(IFCONFIG, 2, 1, "eth0", "down");
		printf("Disable eth0 interface\n");
		return 0;
	}
	else
	{
#endif
#endif		
		va_cmd(IFCONFIG, 2, 1, "eth0", "up");
		printf("Enable eth0 interface\n");
#if defined(CONFIG_EXT_SWITCH) 
#if defined(ELAN_LINK_MODE) 
		if(instnum != 0)  //from the setupLinkMode() in startup.c
		{
			int skfd;
			struct ifreq ifr;
			struct mii_ioctl_data *mii = (struct mii_data *)&ifr.ifr_data;
			MIB_CE_SW_PORT_T Port;
			int i, k, total;
			
	
			strcpy(ifr.ifr_name, "eth0");
			
	
			if (!mib_chain_get(MIB_SW_PORT_TBL, instnum-1, (void *)&Port))
				return -1;
			mii->phy_id = instnum-1; // phy i
			mii->reg_num = 4; // register 4
			// set NWAY advertisement
			mii->val_in = 0x0401; // enable flow control capability and IEEE802.3
			if (Port.linkMode == LINK_10HALF || Port.linkMode == LINK_AUTO)
				mii->val_in |= (1<<(5+LINK_10HALF));
			if (Port.linkMode == LINK_10FULL || Port.linkMode == LINK_AUTO)
				mii->val_in |= (1<<(5+LINK_10FULL));
			if (Port.linkMode == LINK_100HALF || Port.linkMode == LINK_AUTO)
				mii->val_in |= (1<<(5+LINK_100HALF));
			if (Port.linkMode == LINK_100FULL || Port.linkMode == LINK_AUTO)
				mii->val_in |= (1<<(5+LINK_100FULL));
			skfd = socket(AF_INET, SOCK_DGRAM, 0);
			if(skfd == -1)
			{
				fprintf(stderr, "Socket Open failed Error\n");
				return -1;
			}
			if (ioctl(skfd, SIOCSMIIREG, &ifr) < 0) {
				fprintf(stderr, "SIOCSMIIREG on %s failed: %s\n", ifr.ifr_name,
					strerror(errno));
				status=-1;
			}

			// restart
			mii->reg_num = 0; // register 0
			mii->val_in = 0x1200; // enable auto-negotiation and restart it
			if (ioctl(skfd, SIOCSMIIREG, &ifr) < 0) {
				fprintf(stderr, "SIOCSMIIREG on %s failed: %s\n", ifr.ifr_name,
					strerror(errno));
				status=-1;
			}
			
			close(skfd);

		}
#endif // 
#else // CONFIG_EXT_SWITCH
#ifdef ELAN_LINK_MODE_INTRENAL_PHY
		int skfd;
		struct ifreq ifr;
		unsigned char mode;
		//struct mii_ioctl_data *mii = (struct mii_data *)&ifr.ifr_data;
		//MIB_CE_SW_PORT_T Port;
		//int i, k, total;
		struct ethtool_cmd ecmd;
			
	
		strcpy(ifr.ifr_name, "eth0");
		ifr.ifr_data = &ecmd;
			
	
		if (!mib_get(MIB_ETH_MODE, (void *)&mode))
			return -1;

		skfd = socket(AF_INET, SOCK_DGRAM, 0);
		if(skfd == -1)
		{
			fprintf(stderr, "Socket Open failed Error\n");
			return -1;
		}
		ecmd.cmd = ETHTOOL_GSET;
		if (ioctl(skfd, SIOCETHTOOL, &ifr) < 0) {
			fprintf(stderr, "ETHTOOL_GSET on %s failed: %s\n", ifr.ifr_name,
				strerror(errno));
			status=-1;
			goto error;
		}

		ecmd.autoneg = AUTONEG_DISABLE;
		switch(mode) {
		case LINK_10HALF:
			ecmd.speed = SPEED_10;
			ecmd.duplex = DUPLEX_HALF;
			break;
		case LINK_10FULL:
			ecmd.speed = SPEED_10;
			ecmd.duplex = DUPLEX_FULL;
			break;
		case LINK_100HALF:
			ecmd.speed = SPEED_100;
			ecmd.duplex = DUPLEX_HALF;
			break;
		case LINK_100FULL:
			ecmd.speed = SPEED_100;
			ecmd.duplex = DUPLEX_FULL;
			break;
		default:
			ecmd.autoneg = AUTONEG_ENABLE;
		}

		ecmd.cmd = ETHTOOL_SSET;
		if (ioctl(skfd, SIOCETHTOOL, &ifr) < 0) {
			fprintf(stderr, "ETHTOOL_SSET on %s failed: %s\n", ifr.ifr_name,
				strerror(errno));
			status=-1;
			goto error;
		}
		/*
		ecmd.cmd = ETHTOOL_NWAY_RST;
		if (ioctl(skfd, SIOCETHTOOL, &ifr) < 0) {
			fprintf(stderr, "ETHTOOL_SSET on %s failed: %s\n", ifr.ifr_name,
				strerror(errno));
			status=-1;
		}
		*/

		error:
		
		close(skfd);
#endif
#endif
		return status;
#ifdef _CWMP_MIB_
#ifdef _CWMP_APPLY_
	}
#endif
#endif

	return -1;

}

// Jenny, update PPPoE session information
void pppoe_session_update(void *t)
{
	unsigned int totalEntry;
	MIB_CE_PPPOE_SESSION_T Entry;
	int i, found=0, selected;
	PPPOE_DRV_CTRL *p = (PPPOE_DRV_CTRL *)t;

	totalEntry = mib_chain_total(MIB_PPPOE_SESSION_TBL); /* get chain record size */
	for (i=0; i<totalEntry; i++) {
		if (!mib_chain_get(MIB_PPPOE_SESSION_TBL, i, (void *)&Entry)) {
  			printf("Get chain record error!\n");
			return;
		}

		if (Entry.vpi == p->vpi && Entry.vci == p->vci) {
			if (found > 0)
				if (Entry.ifNo != p->ifno) {
					MIB_CE_PPPOE_SESSION_T pEntry;
					mib_chain_get(MIB_PPPOE_SESSION_TBL, selected, (void *)&pEntry);
					if (pEntry.ifNo == p->ifno)
						break;
				}
			selected = i;
			found ++;
		}
	}
	if (found != 0) {
		mib_chain_get(MIB_PPPOE_SESSION_TBL, selected, (void *)&Entry);
		memcpy((unsigned char *)Entry.acMac, (unsigned char *)p->remote.sll_addr, 6);
		Entry.sessionId = p->session;
		if (Entry.ifNo != p->ifno) {	// for mult-session support
			Entry.ifNo = p->ifno;
			Entry.vpi = p->vpi;
			Entry.vci = p->vci;
			mib_chain_add(MIB_PPPOE_SESSION_TBL, (unsigned char*)&Entry);
		}
		else
			mib_chain_update(MIB_PPPOE_SESSION_TBL, (void *)&Entry, selected);
	}
	else {
		Entry.ifNo = p->ifno;
		Entry.vpi = p->vpi;
		Entry.vci = p->vci;
		memcpy((unsigned char *)Entry.acMac, (unsigned char *)p->remote.sll_addr, 6);
		Entry.sessionId = p->session;
		mib_chain_add(MIB_PPPOE_SESSION_TBL, (unsigned char*)&Entry);
	}
}

void save_pppoe_sessionid(void *t)
{
#if 0
int totalEntry,i;
MIB_CE_ATM_VC_T Entry;
printf("%s###########################start\n",__FUNCTION__);
totalEntry = mib_chain_total(MIB_ATM_VC_TBL); 
for(i=0;i<totalEntry;i++)
{
   if(!mib_chain_get(MIB_ATM_VC_TBL,i,&Entry))
   	printf("error!!!!\n");
   else
   	printf("%d/%d vpi=%d,vci=%d\n",i,totalEntry,Entry.vpi,Entry.vci);
}
printf("%s###########################end\n",__FUNCTION__);
#endif
	PPPOE_DRV_CTRL *p = (PPPOE_DRV_CTRL *)t;
	int auth_pid_fd=-1;
	mib_backup(CONFIG_MIB_CHAIN);	// backup current MIB in RAM
	if(mib_load(CURRENT_SETTING, CONFIG_MIB_CHAIN)) {	//get valid setting from flash
		pppoe_session_update(t);
		itfcfg("eth0", 0);
		// wait for sar to finish processing all the queueing packets
		sleep(2);
		itfcfg("sar", 0);
#ifdef WLAN_SUPPORT
		//unsigned char encrypt, no_wlan;
		//unsigned char enable1x=0;
		//int status = -1;
		unsigned char no_wlan;
		mib_get(MIB_WLAN_DISABLED, (void *)&no_wlan);
		if (!no_wlan)
			//itfcfg((char *)WLANIF, 0);
			stopwlan();
#endif
		/* upgdate to flash */
		if(mib_update(CURRENT_SETTING, CONFIG_MIB_CHAIN) == 0)
			printf("CS Flash error! \n");		
		itfcfg("sar", 1);
		itfcfg("eth0", 1);
#ifdef WLAN_SUPPORT
		if (!no_wlan) {
			startWLan();
#if 0
			itfcfg((char *)WLANIF, 1);
			mib_get(MIB_WLAN_ENCRYPT, (void *)&encrypt);
#ifdef WLAN_1x
			mib_get( MIB_WLAN_ENABLE_1X, (void *)&enable1x);
#endif
			// Mason Yu
			sleep(1);		

			if ((encrypt >= 2 || enable1x==1) && no_wlan == 0) {// 802.1x enabled			
				do {
					status = va_cmd(AUTH, 4, 1, WLANIF, LANIF, "auth", WLAN_AUTH_CONF);
					while ((auth_pid_fd = open(AUTH_PID, O_WRONLY)) == -1)
						usleep(30000);				
					close(auth_pid_fd);
					usleep(2000000);
					status |= va_cmd(IWCONTROL, 1, 1, WLANIF);
				} while (status != 0);
			}
#endif
		}
#endif //WLAN_SUPPORT
	}
	else
  		printf("CS Flash load error! \n");
	mib_restore(CONFIG_MIB_CHAIN);	// restore previous MIB setting
	pppoe_session_update(t);
#if 0
printf("%s###########################start\n",__FUNCTION__);
totalEntry = mib_chain_total(MIB_ATM_VC_TBL); 
for(i=0;i<totalEntry;i++)
{
   if(!mib_chain_get(MIB_ATM_VC_TBL,i,&Entry))
   	printf("error!!!!\n");
   else
   	printf("%d/%d vpi=%d,vci=%d\n",i,totalEntry,Entry.vpi,Entry.vci);
}
printf("%s###########################end\n",__FUNCTION__);
	MIB_CE_PPPOE_SESSION_T Entryp;
	int  found=0, selected,totalEntryp;
          totalEntryp = mib_chain_total(MIB_PPPOE_SESSION_TBL); /* get chain record size */
	for (i=0; i<totalEntryp; i++) {
		if (!mib_chain_get(MIB_PPPOE_SESSION_TBL, i, (void *)&Entryp)) {
  			printf("Get chain record error!\n");
			return;
		}
		printf("vpi=%d vci=%d  sessionid=%d\n",Entryp.vpi,Entryp.vci,Entryp.sessionId);
	}
#endif
}
#ifdef DMZ_SUPPORT
int setupDMZ(int type)
{

	unsigned char vInt = 0;
	unsigned int dmzHost;
	mib_get(MIB_DMZ_ENABLE, (void *)&vInt);	
	if (vInt == 1)
	{				
		DOCMDINIT;		
		mib_get(MIB_DMZ_IP, (void *)&dmzHost);	
		// Don't forward SNMP to DMZ		
		// iptables -t nat -A PREROUTING -i ! $LAN_IF -p UDP --dport 161:162 -j ACCEPT
		DOCMDARGVS(IPTABLES, DOWAIT, "-t nat %s PREROUTING -i ! br0 -p UDP --dport 161:162 -j ACCEPT",DMZ_ACTION_APPEND(type));		
		//add by ramen to let the packet accessing tr069 can go through.
		#ifdef _CWMP_MIB_
		DOCMDARGVS(IPTABLES, DOWAIT, "-t nat %s PREROUTING -i ! br0 -p TCP --dport 9999 -j ACCEPT",DMZ_ACTION_APPEND(type));				
		#endif			
		// iptables -t nat -A PREROUTING -i ! $LAN_IF -j DNAT --to-destination $DMZ_IP
		DOCMDARGVS(IPTABLES, DOWAIT, "-t nat %s PREROUTING -i ! br0 -j DNAT --to-destination %s",DMZ_ACTION_APPEND(type),inet_ntoa(*(struct in_addr*)&dmzHost));		
		// Let's do IP Filtering before doing DMZ
#ifdef IP_FILTER_PRIORITY_HIGHEST
		int entryNum = mib_chain_total (MIB_IP_PORT_FILTER_TBL) + 3;	
#else
		int entryNum =  3;		
#endif
		// iptables -I ipfilter 3 -i ! $LAN_IF -o $LAN_IF -d $DMZ_IP -j RETURN
		DOCMDARGVS(IPTABLES, DOWAIT, "%s ipfilter %s -i ! br0 -o br0 -d %s -j ACCEPT",DMZ_ACTION_INSERT(type),DMZ_ACTION_PARAM_INT(type,entryNum),inet_ntoa(*(struct in_addr*)&dmzHost));
		
	}
}
#endif
#ifdef PORT_TRIGGER_SUPPORT
int setupPortTrigger(int type)
{
	int i, total;
	struct porttrigger_entry  entry;	
	total = mib_chain_total(MIB_PORT_TRIGGER_TBL);
	DOCMDINIT;
	for (i = 0; i < total; i++)
	{
		mib_chain_get(MIB_PORT_TRIGGER_TBL,i,&entry);
		//iptables -t nat -I POSTROUTING 1 -o ! br0 -j TRIGGER --trigger-type out --trigger-proto udp --trigger-match 69 --trigger-relate 1-65535		
		switch(entry.trigProto)
			{
			case 0://TCP/UDP
			DOCMDARGVS(IPTABLES, DOWAIT,"-t nat %s POSTROUTING -o ! br0 -j TRIGGER --trigger-type out --trigger-proto TCP --trigger-match %u-%u --trigger-relate %d-%d",PORT_TRIGGER_ACTION_INSERT(type),entry.trigStartPort,entry.trigEndPort,entry.openStartPort,entry.openEndPort);
			DOCMDARGVS(IPTABLES, DOWAIT,"-t nat %s POSTROUTING -o ! br0 -j TRIGGER --trigger-type out --trigger-proto UDP --trigger-match %u-%u --trigger-relate %d-%d",PORT_TRIGGER_ACTION_INSERT(type),entry.trigStartPort,entry.trigEndPort,entry.openStartPort,entry.openEndPort);
			break;
			case 1://TCP
			DOCMDARGVS(IPTABLES, DOWAIT,"-t nat %s POSTROUTING -o ! br0 -j TRIGGER --trigger-type out --trigger-proto TCP --trigger-match %u-%u --trigger-relate %d-%d",PORT_TRIGGER_ACTION_INSERT(type),entry.trigStartPort,entry.trigEndPort,entry.openStartPort,entry.openEndPort);
			break;
			case 2://UDP
			DOCMDARGVS(IPTABLES, DOWAIT,"-t nat %s POSTROUTING -o ! br0 -j TRIGGER --trigger-type out --trigger-proto UDP --trigger-match %u-%u --trigger-relate %d-%d",PORT_TRIGGER_ACTION_INSERT(type),entry.trigStartPort,entry.trigEndPort,entry.openStartPort,entry.openEndPort);
			break;
			}	
		switch(entry.openProto)
			{
			case 0://TCP/UDP
			DOCMDARGVS(IPTABLES, DOWAIT,"-t nat %s PREROUTING -i ! br0 -p TCP --dport %u:%u -j TRIGGER --trigger-type dnat",PORT_TRIGGER_ACTION_INSERT(type),entry.openStartPort,entry.openEndPort);
			DOCMDARGVS(IPTABLES, DOWAIT,"-t nat %s PREROUTING -i ! br0 -p UDP --dport %u:%u -j TRIGGER --trigger-type dnat",PORT_TRIGGER_ACTION_INSERT(type),entry.openStartPort,entry.openEndPort);
			break;
			case 1://TCP
			DOCMDARGVS(IPTABLES, DOWAIT,"-t nat %s PREROUTING -i ! br0 -p TCP --dport %u:%u -j TRIGGER --trigger-type dnat",PORT_TRIGGER_ACTION_INSERT(type),entry.openStartPort,entry.openEndPort);
			break;
			break;
			case 2://UDP
			DOCMDARGVS(IPTABLES, DOWAIT,"-t nat %s PREROUTING -i ! br0 -p UDP --dport %u:%u -j TRIGGER --trigger-type dnat",PORT_TRIGGER_ACTION_INSERT(type),entry.openStartPort,entry.openEndPort);
			break;
			}		
	}	
	
}
#endif
char* int2str(int d)
{
	static char buf[8];
	snprintf(buf,sizeof(buf),"%d",d);
	return buf;
}
int getProcessPid(const char *pidfile)
{
    	FILE *f;
	int pid=0;
	//fprintf(stderr,"pidfile=%s\n",pidfile);
	if((f = fopen(pidfile, "r")) == NULL)
		return 0;
	fscanf(f, "%d\n", &pid);
	fclose(f);
	//fprintf(stderr,"pid=%d\n",pid);
	return pid;
}
#ifdef SYSLOG_SUPPORT_ENABLE
//add by ramen
int setupSyslog(int type)
{
	unsigned char syslogEnable;
	unsigned char sysMode;
	unsigned char recordLevel;
	unsigned char displayLevel;
	unsigned int server;
	unsigned short sport;
	unsigned int pid;
	DOCMDINIT;
	switch(type)
		{
		case SYSLOG_DISABLED:
		REKILLSYSLOGD:
			pid=getProcessPid(SYSLOGD_PID);
			if(pid)   {
				DOCMDARGVS("/bin/kill",DOWAIT,"%d",pid);
				goto REKILLSYSLOGD;
			}
		REKILLKLOGD:
			pid=getProcessPid(KLOGD_PID);
			if(pid)   {
				DOCMDARGVS("/bin/kill",DOWAIT,"%d",pid);
				goto REKILLKLOGD;
			}
			break;
		case SYSLOG_ENABLED:			
			mib_get(MIB_SYSLOG_ENABLE,(void*)&syslogEnable);
			fprintf(stderr,"syslogenable=%d\n",syslogEnable);
			if(syslogEnable) 
				{	
					mib_get(MIB_SYSLOG_MODE,(void*)&sysMode);
					mib_get(MIB_SYSLOG_RECORDE_GRADE,(void*)&recordLevel);					
					switch(sysMode){
						case 0://local
							DOCMDARGVS(SYSLOGD,UNDOWAIT,"-l %d -L -w",recordLevel);
							//DOCMDARGVS(KLOGD,DOWAIT,"","");
							va_cmd(KLOGD,0,0);
							break;
						case 1://remote
							mib_get(MIB_SYSLOG_REMOTE_IP,(void*)&server);
							mib_get(MIB_SYSLOG_REMOTE_PORT,(void*)&sport);
							DOCMDARGVS(SYSLOGD,UNDOWAIT,"-l %d -w -R %s:%d ",recordLevel,inet_ntoa(*(struct in_addr*)&server),sport);
							//DOCMDARGVS(KLOGD,DOWAIT,"","");
							va_cmd(KLOGD,0,0);
							break;
						case 2://both
							mib_get(MIB_SYSLOG_REMOTE_IP,(void*)&server);
							mib_get(MIB_SYSLOG_REMOTE_PORT,(void*)&sport);
							DOCMDARGVS(SYSLOGD,UNDOWAIT,"-l %d -w -R %s:%d -L",recordLevel,inet_ntoa(*(struct in_addr*)&server),sport);
							//DOCMDARGVS(KLOGD,DOWAIT,"","");
							va_cmd(KLOGD,0,0);
							break;
						}
			
				}
			break;
		   
		}
	//close the syslogd 	
	return 0;
}
#endif

#ifdef  MAC_FILTER_EBTABLES_SUPPORT
/*typedef enum macfilter_protocol{
	PROTO_ALL,
	PROTO_PPPOE,
	PROTO_IPV4,
	PROTO_IPV6,
	PROTO_APPLETALK,
	PROTO_IPX,
	PROTO_NETBEUI,
	PROTO_IGMP
}MACFILTER_PROTOCOL;*/
char *getEbtablesProtocol(int type)
{
	const static char *ebproto[]={
		"",
		"PPP_DISC",
		"IPv4",
		"IPv6",
		"ATALK",
		"IPX",
		"NetBEUI",
		"IGMP"
		};
	return ebproto[type];
}
int setupRouteEbtables()
{
    struct routemac_entry entry;
    int cnt,index;
    cnt=mib_chain_total(MIB_MAC_FILTER_ROUTER_TBL);
    DOCMDINIT
    for(index=0;index<cnt;index++)
    	{
    	 mib_chain_get(MIB_MAC_FILTER_ROUTER_TBL,index,&entry);
    	 DOCMDARGVS(EBTABLES,DOWAIT,"-A FORWARD -i eth0 -s %s -j DROP",entry.mac);
	 DOCMDARGVS(EBTABLES,DOWAIT,"-A FORWARD -i wlan0 -s %s -j DROP",entry.mac);
    	}   
}
int setupEbtables(int type)
{
	unsigned char macFilterMode=0;
	unsigned char macFilterEnable=0;
	struct brgmac_entry  entry;
	int cnt;
	int index;
	DOCMDINIT;	
	DOCMDARGVS(EBTABLES,DOWAIT,"%s","-F");
	switch(type)
		{
		case EBTABLES_ENABLED:			
			mib_get(MIB_MAC_FILTER_EBTABLES_ENABLE,&macFilterEnable);
			mib_get(MIB_MAC_FILTER_EBTABLES_MODE,&macFilterMode);
			//printf("macFilterEnable=%d,macFilterMode=%d\n",macFilterEnable,macFilterMode);
			if(macFilterEnable)
				{
				    cnt=mib_chain_total(MIB_MAC_FILTER_EBTABLES_TBL);		    
			             for(index=0;index<cnt;index++)	    	
				    {
				    char protoParm[256]={0};
				    char smacParm[256]={0};
				    char dmacParm[256]={0};	
				   
				   memset(&entry,0,sizeof(entry));
				    mib_chain_get(MIB_MAC_FILTER_EBTABLES_TBL,index,&entry);
					
				    if(entry.protoType)
				    snprintf(protoParm,sizeof(protoParm),"-p %s",getEbtablesProtocol(entry.protoType));
				    if(strlen(entry.smac))	
				    snprintf(smacParm,sizeof(smacParm),"-s %s",entry.smac);	
				   if(strlen(entry.dmac))	
				    snprintf(dmacParm,sizeof(dmacParm),"-d %s",entry.dmac);				   				 				    
				   int itfindex=0;
				   for(itfindex=0;itfindex<entry.portNum;itfindex++)
					 {
					 char itfParm[256]={0};						
					 switch(entry.direction)
					 	{
					 	case 0://lan-->wan
					 		snprintf(itfParm,sizeof(itfParm),"-o vc%d",VC_INDEX(entry.ifIndex[itfindex]));
					 		DOCMDARGVS(EBTABLES,DOWAIT,"-A FORWARD %s %s  %s %s -j %s",
							itfParm,protoParm,smacParm,dmacParm,(macFilterMode?"ACCEPT":"DROP"));
							break;
						case 1://wan-->lan
							snprintf(itfParm,sizeof(itfParm),"-i vc%d",VC_INDEX(entry.ifIndex[itfindex]));
							DOCMDARGVS(EBTABLES,DOWAIT,"-A FORWARD %s %s  %s %s -j %s",
							itfParm,protoParm,smacParm,dmacParm,(macFilterMode?"ACCEPT":"DROP"));
							break;
						case 2://lan<-->wan
							snprintf(itfParm,sizeof(itfParm),"-o vc%d",VC_INDEX(entry.ifIndex[itfindex]));
							DOCMDARGVS(EBTABLES,DOWAIT,"-A FORWARD %s %s  %s %s -j %s",
							itfParm,protoParm,smacParm,dmacParm,(macFilterMode?"ACCEPT":"DROP"));
							memset(itfParm,0,sizeof(itfParm));
							snprintf(itfParm,sizeof(itfParm),"-i vc%d",VC_INDEX(entry.ifIndex[itfindex]));
							DOCMDARGVS(EBTABLES,DOWAIT,"-A FORWARD %s %s  %s %s -j %s",
							itfParm,protoParm,dmacParm,smacParm,(macFilterMode?"ACCEPT":"DROP"));
							break;								
					 	}
					 
				   	}
			             }
				DOCMDARGVS(EBTABLES,DOWAIT,"-P FORWARD %s",(macFilterMode?"DROP":"ACCEPT"));							 
				}
						
			break;
		case EBTABLES_DISABLED:
			DOCMDARGVS(EBTABLES,DOWAIT,"-F FORWARD");
			DOCMDARGVS(EBTABLES,DOWAIT,"-P FORWARD ACCEPT");
			break;
		}
	setupRouteEbtables();
}
#endif

/*
 * Added by penggenyao, to support QOS setting
 */ 

/*
 * MACROs used in qos
 */
#define QOS_SETUP_DEBUG   1// for qos debug
#define QOS_CMD_BUF_LEN 1024
#define QOS_ERR_MSG_LEN 512
const char QOS_CHAIN[] =  "qos_rules";
const char QOS_TABLE[] =  "broute";

#define QOS_SETUP_EBTABLES

static unsigned int qos_setup_debug = 3;
static char err_msg[QOS_ERR_MSG_LEN]={0}; 

#define QOS_ERR_REPORT(fmt, args...)           \
    do {                                       \
        err_msg[0]='\0';                               \
	    snprintf(err_msg, QOS_ERR_MSG_LEN, fmt, ##args);        \
	    goto qos_err_report;                              \
    }while(0)
#define QOS_ERR_LABEL  \
    qos_err_report: printf("qos setup error: %s\n", err_msg);

#define MAX_PORT(val1, val2) val1>val2?val1:val2
#define MIN_PORT(val1, val2) val1<val2?val1:val2

//added by penggenyao
#ifdef QOS_SETUP_EBTABLES
#define setup_queue_rules  setup_qos_rules_by_ebtables
#define setup_traffic_rule setup_traffic_rule_by_ebtables
#else
#define setup_queue_rules  setup_qos_rules_by_iptables
#define setup_traffic_rule setup_traffic_rule_by_iptables
#endif

#ifdef QOS_SETUP_DEBUG
#define QOS_SETUP_PRINT_FUNCTION                    \
    do{if(qos_setup_debug&0x1) printf("%s: %s\n", __FILE__, __FUNCTION__);}while(0);
    
#define QOS_SETUP_PRINT(fmt, args...)        \
    do{if(qos_setup_debug&0x2) printf(fmt, ##args);}while(0)
#else
#define QOS_SETUP_PRINT_FUNCTION do{}while(0);
#define QOS_SETUP_PRINT(fmt, args...) do{}while(0)
#endif

//[]4"-p tcp/udp", not supported by iptables, deal with is seperately
static char* proto2str[] = {
    [0]" ",
    [1]"-p ICMP",
    [2]"-p TCP",
    [3]"-p UDP",
};

static char* proto2str2layer[] = {
    [0]" ",
    [1]"--ip-proto 1",
    [2]"--ip-proto 6",
    [3]"--ip-proto 17",
};

#if 0//commented by penggenyao, no need this function
/********************************************************************
 * NAME:    getmaskbits
 * DESC:    get bit number of subnet mask
 * ARGS:
 * RETURN:  the bit number of subnet mask, or zero if the subnet mask 
 *          is wrong
 ********************************************************************/ 
int getmaskbits(unsigned int netmask)
{
    int offset= 0, maskbits = 0;
    while((netmask<<offset)&0x80000000)
	++maskbits;
    return maskbits;
}
#endif

/*********************************************************************
 * NAME:    do_str_cmd
 * DESC:    execute the command based on string, the first word is the 
 *          command name.
 * ARGS:
 * RETURN:  0 success, others fail
 *********************************************************************/
static int do_str_cmd(char* cmd, int dowait)
{
    char args[24][64];
    char* argv[24];
    char filename[128] = {0};
    char* p = NULL;
    int index = 1, ret =1;

    QOS_SETUP_PRINT("command: %s\n", cmd);

    snprintf(filename, 128, "%s", strtok(cmd, " "));
    while( ((p = strtok(NULL, " ") )!= NULL) && index<24)
    {
	snprintf(args[index], 64, "%s", p);
	argv[index] = args[index];
	index++;
    }
    ret = do_cmd(filename, argv, 0);
    usleep(1000);//wait 2 seconds for child proccess
    //QOS_SETUP_PRINT("complete to execute cmd! The exited code:%d.\n", ret);
    return ret;
}
//function: setup_lan_port(int flag)
//code from __dev_setupIPQoS function, 
//because we dont want to use the old qos code(IP_QOS macro), so copy the code here
static int setup_lan_port(int flag)
{
    struct ifreq ifr;
    struct ifvlan ifvl;
    int ret = 0;

    QOS_SETUP_PRINT_FUNCTION

    strcpy(ifr.ifr_name, "eth0");
    ifr.ifr_data = (char *)&ifvl;
    ifvl.cmd=VLAN_SETIPQOS;
    ifvl.enable=flag;
    setVlan(&ifr);
}

/*
 *Clean up the qos rules, all of them, no matter whether they are set.
 */
static void cleanup_qos_setting()
{
    MIB_CE_ATM_VC_T entry;
    int i = 0, entryNum = 0;
    
    entryNum = mib_chain_total(MIB_ATM_VC_TBL);
    for(i=0; i<entryNum; i++)
    {
	char ifname[6] = {0};

	if(!mib_chain_get(MIB_ATM_VC_TBL, i, &entry))
	    continue;
	//get the interface name
	if (PPP_INDEX(entry.ifIndex) != 0x0f)//PPP interface
	    snprintf(ifname, 6, "ppp%u", PPP_INDEX(entry.ifIndex));
	else//vc interface
	    snprintf(ifname, 6, "vc%u", VC_INDEX(entry.ifIndex));

	//clean up prio queues
	va_cmd(TC, 10, 1, "qdisc", "del", "dev", ifname, "root", "handle", "1:", "prio", "bands", "4");
	//clean up wrr queues
	va_cmd(TC, 10, 1, "qdisc", "del", "dev", ifname, "root", "handle", "1:", "htb", "default", "1");
	//clean up traffic contolling queue
	va_cmd(TC, 10, 1, "qdisc", "del", "dev", ifname, "root", "handle", "10:", "htb", "default", "1");
    }
    //clean up ebtables rules
    va_cmd(EBTABLES, 4, 1, "-t", QOS_TABLE, "-F", QOS_CHAIN);
}

static void setup_qos_setting()
{
    int queue_num = 0, traffictl_rule_num=0;
    unsigned char policy=0;
        
    mib_get(MIB_QOS_QUEUE_POLICY, (void*)&policy);
    queue_num = mib_chain_total(MIB_IP_QUEUE_CFG_TBL);
    traffictl_rule_num = mib_chain_total(MIB_TRAFFICTL_TBL);

    //if no queue and traffic controlling rule is not empty,
    //setup traffic controlling else setup priority queue if
    //policy is set to 0, and setup wrr when dsl is up if policy=1
    if(0 == queue_num&&0!=traffictl_rule_num){
	setup_traffic_control();
    }
    else{
	if(0==policy) {
	    setup_prio_queue();
	} else {
	    Modem_LinkSpeed vLs;
	    unsigned char  ret = 0;
	    ret = adsl_drv_get(RLCM_GET_LINK_SPEED, (void *)&vLs, RLCM_GET_LINK_SPEED_SIZE);
	    if(ret&&0 != vLs.upstreamRate) setup_wrr_queue(vLs.upstreamRate);
	}
    }
}

void take_qos_effect()
{
    //clean up old setting
    cleanup_qos_setting();
    //setup new one
    setup_qos_setting();
}

static int setup_traffic_rule_by_ebtables(MIB_CE_IP_TC_Tp entry, unsigned char action)
{
   char ifname[6];
   char* tc_act = NULL, *fw_act=NULL;
   char* proto1 = NULL, *proto2 = NULL;
   char  saddr[48], daddr[48], sport[48], dport[48]; 
   int upLinkRate = 0;
   DOCMDINIT

   QOS_SETUP_PRINT_FUNCTION

   if(0!=action){
        tc_act = (char*)ARG_ADD;
        fw_act = (char*)FW_ADD;
   }
   else{
        tc_act = (char*)ARG_DEL;
        fw_act = (char*)FW_DEL;
   }
   
   if(NULL == entry)
       QOS_ERR_REPORT("Invalid traffic contolling rule!\n");
   
   if (PPP_INDEX(entry->ifIndex) != 0x0f) { // PPP interface
       snprintf(ifname, 6, "ppp%u", PPP_INDEX(entry->ifIndex));
   } else { // vc interface
       snprintf(ifname, 6, "vc%u", VC_INDEX(entry->ifIndex));
   }

   //source address and netmask
   if(0 != entry->srcip)
   {
       if(0 != entry->smaskbits)
	        snprintf(saddr, 48, "--ip-src %s/%d", inet_ntoa(*((struct in_addr*)(&entry->srcip))), entry->smaskbits);
       else
	        snprintf(saddr, 48, "--ip-src %s", inet_ntoa(*((struct in_addr*)(&entry->srcip))));
   }
   else//if not specify the source ip
       saddr[0] = '\0';

   //destination address and netmask
   if(0 != entry->dstip)
       if(0 != entry->dmaskbits)
	   snprintf(daddr, 48, "--ip-dst %s/%d", inet_ntoa(*((struct in_addr*)(&entry->dstip))), entry->dmaskbits);
       else
	   snprintf(daddr, 48, "--ip-dst %s", inet_ntoa(*((struct in_addr*)(&entry->srcip))));
   else//if not specify the dest ip
       daddr[0] = '\0';

   //protocol
   if(entry->protoType<0||entry->protoType>4)//wrong protocol index
   {
       QOS_ERR_REPORT("Wrong protocol\n");
   }
   else if(entry->protoType==4)/*TCP/UDP, added by penggenyao, support two proto at the same time*/
   {
       proto1 = "--ip-proto 6";
       proto2 = "--ip-proto 17";
   }
   else
       proto1 = proto2str2layer[entry->protoType];
   
   //source port,just for tcp and udp protocol 
   if(0 != entry->sport&&entry->protoType>=2&&entry->protoType<=4)
       snprintf(sport, 48, "--ip-source-port %d", entry->sport);
   else
       sport[0] = '\0';

   //destination port,just for tcp and udp protocol 
   if(0 != entry->dport&&entry->protoType>=2&&entry->protoType<=4)
       snprintf(dport, 48, "--ip-destination-port %d", entry->dport);
   else
       dport[0] = '\0';
   
   upLinkRate = entry->limitSpeed;
   if(0 != upLinkRate)
   {
       DOCMDARGVS(TC, DOWAIT, "class %s dev %s parent 10:1 classid 10:%d0 htb rate %dkbit ceil %dkbit",
	        tc_act, ifname, entry->entryid, upLinkRate, upLinkRate);

       DOCMDARGVS(TC, DOWAIT, "filter %s dev %s parent 10: protocol ip prio 0 handle 0x%x000 fw classid 10:%d0",
	       tc_act, ifname, entry->entryid, entry->entryid);

       DOCMDARGVS(EBTABLES, DOWAIT,  "-t %s %s %s -p 0x0800 %s %s %s %s %s -j mark --set-mark 0x%x000", QOS_TABLE,
	         fw_act, QOS_CHAIN, proto1, saddr, daddr, sport, dport, entry->entryid);

       /*TCP/UDP?*/
       if(proto2)//setup the other protocol
       {
	        DOCMDARGVS(EBTABLES, DOWAIT, "-t %s %s %s -p 0x0800 %s %s %s %s %s -j mark --set-mark 0x%x000", QOS_TABLE,
		        fw_act, QOS_CHAIN, proto2, saddr, daddr, sport, dport, entry->entryid);
       }
   }
   else
   {//if uprate=0, forbid traffic matching the rules
        DOCMDARGVS(EBTABLES, DOWAIT, "-t filter %s FORWARD -p 0x0800 %s %s %s %s %s -j DROP",
	        fw_act, proto1, saddr, daddr, sport, dport);

       /*TCP/UDP again*/
       if(proto2)
       {
	   DOCMDARGVS(EBTABLES, DOWAIT, "%s -t filter %s FORWARD -p 0x0800 %s %s %s %s %s -j DROP",
		   fw_act, proto2, saddr, daddr, sport, dport);
       }
   }

   return 0;

QOS_ERR_LABEL
   return 1;
}


/****************************************************************
 *NAME:      setup_traffic_rule
 *DESC:      tc class add dev $DEV parent 10:1 handle 10:$SUBID htb rate $RATE ceil $CEIL
 *           tc filter add dev $DEV parent 10: protocol ip prio 0 handle $HANDLE fw classid 10:$SUBID
 *           iptables -p $PROTO -s $SADDR -d $DADDR --sport $SPORT --dport $DPORT -j MARK --set-mark $HANDLE
 *           setup traffic control for every configuration 
 *ARGS:      index, start from 1
 *RETURN:    0 success, others  fail
 ****************************************************************/
static int setup_traffic_rule_by_iptables(MIB_CE_IP_TC_Tp entry, unsigned char action)
{
   char ifname[6];
   char* tc_act = NULL, *fw_act=NULL;
   char* proto1 = NULL, *proto2 = NULL;
   char  saddr[24], daddr[24], sport[16], dport[16]; 
   int upLinkRate = 0;
   DOCMDINIT

   QOS_SETUP_PRINT_FUNCTION

   if(0!=action){
        tc_act = (char*)ARG_ADD;
        fw_act = (char*)FW_ADD;
   }
   else{
        tc_act = (char*)ARG_DEL;
        fw_act = (char*)FW_DEL;
   }
   
   if(NULL == entry)
       QOS_ERR_REPORT("Invalid traffic contolling rule!\n");
   
   if (PPP_INDEX(entry->ifIndex) != 0x0f) { // PPP interface
       snprintf(ifname, 6, "ppp%u", PPP_INDEX(entry->ifIndex));
   } else { // vc interface
       snprintf(ifname, 6, "vc%u", VC_INDEX(entry->ifIndex));
   }

   //source address and netmask
   if(0 != entry->srcip)
   {
       if(0 != entry->smaskbits)
	        snprintf(saddr, 24, "-s %s/%d", inet_ntoa(*((struct in_addr*)(&entry->srcip))), entry->smaskbits);
       else
	        snprintf(saddr, 24, "-s %s", inet_ntoa(*((struct in_addr*)(&entry->srcip))));
   }
   else//if not specify the source ip
       saddr[0] = '\0';

   //destination address and netmask
   if(0 != entry->dstip)
       if(0 != entry->dmaskbits)
	   snprintf(daddr, 24, "-d %s/%d", inet_ntoa(*((struct in_addr*)(&entry->dstip))), entry->dmaskbits);
       else
	   snprintf(daddr, 24, "-d %s", inet_ntoa(*((struct in_addr*)(&entry->srcip))));
   else//if not specify the dest ip
       daddr[0] = '\0';

   //source port
   if(0 != entry->sport)
       snprintf(sport, 16, "--sport %d", entry->sport);
   else
       sport[0] = '\0';

   //destination port
   if(0 != entry->dport)
       snprintf(dport, 16, "--dport %d", entry->dport);
   else
       dport[0] = '\0';

   //protocol
   if(entry->protoType<0||entry->protoType>4)//wrong protocol index
   {
       QOS_ERR_REPORT("Wrong protocol\n");
   }
   else if(entry->protoType==4)/*TCP/UDP, added by penggenyao, support two proto at the same time*/
   {
       proto1 = "-p TCP";
       proto2 = "-p UDP";
   }
   else
       proto1 = proto2str[entry->protoType];

   upLinkRate = entry->limitSpeed;
   if(0 != upLinkRate)
   {
       DOCMDARGVS(TC, DOWAIT, "class %s dev %s parent 10:1 classid 10:%d0 htb rate %dkbit ceil %dkbit",
	        tc_act, ifname, entry->entryid, upLinkRate, upLinkRate);

       DOCMDARGVS(TC, DOWAIT, "filter %s dev %s parent 10: protocol ip prio 0 handle 0x%x000 fw classid 10:%d0",
	       tc_act, ifname, entry->entryid, entry->entryid);

       DOCMDARGVS(IPTABLES, DOWAIT,  "-t mangle %s PREROUTING %s %s %s %s %s -j MARK --set-mark 0x%x000",
	         fw_act, proto1, saddr, daddr, sport, dport, entry->entryid);

       /*TCP/UDP?*/
       if(proto2)//setup the other protocol
       {
	        DOCMDARGVS(IPTABLES, DOWAIT, "%-t mangle %s PREROUTING %s %s %s %s %s -j MARK --set-mark 0x%x000",
		        fw_act, proto2, saddr, daddr, sport, dport, entry->entryid);
       }
   }
   else
   {//if uprate=0, forbid traffic matching the rules
        DOCMDARGVS(IPTABLES, DOWAIT, "-t filter %s FORWARD %s %s %s %s %s -j DROP",
	        fw_act, proto1, saddr, daddr, sport, dport);

       /*TCP/UDP again*/
       if(proto2)
       {
	   DOCMDARGVS(IPTABLES, DOWAIT, "%s -t filter %s FORWARD %s %s %s %s %s -j DROP",
		   fw_act, proto2, saddr, daddr, sport, dport);
       }
   }

   return 0;

QOS_ERR_LABEL
   return 1;
}

/**************************************************************************
 * NAME: setup_traffic_basic
 * DESC: create root qdisc and root class using HTB for every wan interface
 * ARGS: NONE
 * RETURN: 0 success, others fail
 **************************************************************************/
static int setup_traffic_basic()
{
    MIB_CE_ATM_VC_T entry;
    int i=0, entrynum = 0;
    unsigned short total_bandwidth = 0;
    char ifname[16] = {0};
    
    DOCMDINIT
        
    QOS_SETUP_PRINT_FUNCTION
        
    entrynum = mib_chain_total(MIB_ATM_VC_TBL);
    
    if(!mib_get(MIB_TOTAL_BANDWIDTH, (void*)&total_bandwidth)||0 == total_bandwidth)
    {
        printf("Warning: cannot get total bandwidth, set it to 1024\n");
	    total_bandwidth = 1024;//default
    }
    
    QOS_SETUP_PRINT("total bandwidth: %d\n", total_bandwidth);

    //setup default setting for every wan interface
    for(;i<entrynum; i++)
    {
	if(!mib_chain_get(MIB_ATM_VC_TBL, i, (void*)&entry)||!entry.qosenable)
	    continue;
    
	if (PPP_INDEX(entry.ifIndex) != 0x0f)//PPP interface
	    snprintf(ifname, 16, "ppp%u", PPP_INDEX(entry.ifIndex));
	else//vc interface
	    snprintf(ifname, 16, "vc%u", VC_INDEX(entry.ifIndex));

	//tc qdisc add dev $DEV root handle 10: htb default 1
	DOCMDARGVS(TC, DOWAIT, "qdisc add dev %s root handle 10: htb default 1", ifname);

	//tc class add dev $DEV parent 10: classid 10:1 htb rate $RATE ceil $CEIL
	DOCMDARGVS(TC, DOWAIT, "class add dev %s parent 10: classid 10:1 htb rate %dkbit ceil %dkbit",
		ifname, total_bandwidth, total_bandwidth);
    }
    
    return 0;
}


/*******************************************************************************
 * NAME:    setup_traffic_control
 * DESC:    main function to complte trafice controlling, 
 *          setup the basic setting by calling setup_traffic_basic,
 *          and for every configuration by calling setup_traffic_cfg(),
 *          the basic setting includes one root qdisc and root
 *          class, the setting looks like below:
 *                              HTB(root qdisc, handle 10:)
 *                               |
 *                              HTB(root class, classid 10:1)
 *            ___________________|_____________________
 *            |         |        |          |          |
 *           HTB       HTB      HTB        HTB        HTB
 *(subclass id 10:10 rate Xkbit)........       (sub class id 10:N0 rate Ykbit)
 *ARGS:    none
 *RETURN:  0 success, others fail
 *******************************************************************************/
static int setup_traffic_control()
{
    MIB_CE_IP_TC_T  entry;
    int i = 0, entry_num =0;
    
    DOCMDINIT
        
    QOS_SETUP_PRINT_FUNCTION
        
    //for every wan interface
    if(0!=setup_traffic_basic())
        QOS_ERR_REPORT("Cannot setup traffic controlling basic rules.");

    entry_num = mib_chain_total(MIB_TRAFFICTL_TBL);
    
    for(i=0; i<entry_num; i++)
    {
	if(!mib_chain_get(MIB_TRAFFICTL_TBL, i, (void*)&entry))
		continue;

	if(0 != setup_traffic_rule(&entry, 1))
	     QOS_ERR_REPORT("Cannot setup traffic controlling rules, rule id: %d.", 
		     entry.entryid);
    }
    return 0;
    
QOS_ERR_LABEL
    return 1;
}


#define QOS_WAN_ENABLE      0x01
#define QOS_WAN_VLAN_ENABLE 0x02
//get state about qos from pvc interface, 0: false, 1: true
unsigned int get_pvc_qos_state(unsigned char ifIndex)
{
    MIB_CE_ATM_VC_T entry;
    int i, entryNum = 0;
    unsigned int ret = 0;

    entryNum = mib_chain_total(MIB_ATM_VC_TBL);
    for(i = 0; i< entryNum; i++)
    {
	if(!mib_chain_get(MIB_ATM_VC_TBL, i, &entry))
	    continue;
	if(entry.ifIndex == ifIndex)
	{
	    if(entry.qosenable)
		ret |= QOS_WAN_ENABLE;
	    if(entry.vlan)
		ret |= QOS_WAN_VLAN_ENABLE;
	    break;
	}
    }

    return ret;
}

/*********************************************************************
 * NAME:    setup_qos_rules_by_ebtables
 * DESC:    Using ebtables to setup rules for queue, including packet
 *          marking(dscp, 802.1p).
 * ARGS:    policy: 0 prio, 1 wrr.
 * RETURN:  0 success, others fail 
 *********************************************************************/
static int setup_qos_rules_by_ebtables(unsigned char policy)
{
    MIB_CE_IP_QUEUE_RULE_T entry;
    int i = 0, EntryNum = 0;

    DOCMDINIT
        
    QOS_SETUP_PRINT_FUNCTION

    EntryNum = mib_chain_total(MIB_IP_QUEUE_RULE_TBL);

    for(; i<EntryNum; i++)
    {
	char ifname[6]={0}, phyPort[16]={0};
	char sport[48]={0}, dport[48]={0}, saddr[48]={0}, daddr[48]={0},strvlan1p[48]={0};
	char *ip_proto1=NULL, *ip_proto2 = NULL, *eth_proto = NULL;
	char m_iptos[20] = {0};
	unsigned int mark=0;
	unsigned int wan_qos_state = 0;
        unsigned int wan_qos_enable = 0, wan_vlan_enable = 0;

	if(!mib_chain_get(MIB_IP_QUEUE_RULE_TBL, i, (void*)&entry)||!entry.state)
	    continue;
        wan_qos_state = get_pvc_qos_state(entry.ifIndex);
	wan_qos_enable = wan_qos_state&QOS_WAN_ENABLE;
	wan_vlan_enable = wan_qos_state&QOS_WAN_VLAN_ENABLE;

	//if source ip type is 1, meaning the source ip value is DHCP
	//option 60, it proccessed in the dhcp, not here, so skip it.
	//and if the wan interface qos is disabled, dont setup rules
	if(1==entry.srcType||!wan_qos_enable)
	    continue;
    
	//interface
	if (PPP_INDEX(entry.ifIndex) != 0x0f)//PPP interface
	    snprintf(ifname, 6, "ppp%u", PPP_INDEX(entry.ifIndex));
	else//vc interface
	    snprintf(ifname, 6, "vc%u", VC_INDEX(entry.ifIndex));

	//phy port
	if(entry.phyPort>=1&&entry.phyPort<=4)
	    snprintf(phyPort, 16, "-i eth0_sw%d", entry.phyPort-1);
	else
	    phyPort[0] = '\0';

	//dscp match
	if(0 != entry.dscp)
	{
	    snprintf(m_iptos, 20, "--ip-tos 0x%x", entry.dscp&0xFF);
	}else{
	    m_iptos[0]='\0';
	}

	//protocol
	if(entry.protoType <0|| entry.protoType>4)//invalid protocol index
	    ip_proto1=NULL;
	else if(entry.protoType == 4)//add by penggenyao, support two protos at the same time
	{
	    ip_proto1 = "--ip-proto 6";
	    ip_proto2 = "--ip-proto 17";
	}
	else
	    ip_proto1 = proto2str2layer[entry.protoType];

	//source port (range)
	if(0 == entry.protoType||1 == entry.protoType||0 == entry.dstPortStart)
	{//if protocol is icmp or none or port not set, ignore the port
	    sport[0] = '\0';
	}
	else
	{
	    if(0 != entry.srcPortEnd)
		snprintf(sport, 48, "--ip-source-port %d:%d", MIN_PORT(entry.srcPortStart, entry.srcPortEnd),
		    MAX_PORT(entry.srcPortStart, entry.srcPortEnd));
	    else
		snprintf(sport, 48, "--ip-source-port %d", entry.srcPortStart);
	}

	//dest port (range)
	if(0 == entry.protoType||1 == entry.protoType||0 == entry.dstPortStart)
	{//if protocol is icmp or none or port not set, ignore the port
	    dport[0] = '\0';
	}
	else
	{
	    if(0 != entry.dstPortEnd)
		snprintf(dport, 48, "--ip-destination-port %d:%d", MIN_PORT(entry.dstPortStart, entry.dstPortEnd),
		    MAX_PORT(entry.dstPortStart, entry.dstPortEnd));
	    else
		snprintf(dport, 48, "--ip-destination-port %d", entry.dstPortStart);
	}

	//source address
	if(0 != entry.srcip)
	    if(0 != entry.smaskbits)
		snprintf(saddr, 48, "--ip-source %s/%d", 
			inet_ntoa(*((struct in_addr*)(&entry.srcip))), entry.smaskbits );
	    else
		snprintf(saddr, 48, "--ip-source %s", inet_ntoa(*((struct in_addr*)(&entry.srcip))));
	else
	    saddr[0]='\0';

	//dest address
	if(0 != entry.dstip)
	    if(0 != entry.dmaskbits)
		snprintf(daddr, 48, "--ip-destination %s/%d", 
			inet_ntoa(*((struct in_addr*)(&entry.dstip))), entry.dmaskbits );
	    else
		snprintf(daddr, 48, "--ip-destination %s", inet_ntoa(*((struct in_addr*)(&entry.dstip))));
	else
	    daddr[0]='\0';

	//lan 802.1p mark, 0-7 bit
	if(0 != entry.vlan1p)
	    snprintf(strvlan1p, 32, "--vlan-prio %d", entry.vlan1p&0xff);
	else
	    strvlan1p[0] = '\0';

    if(strvlan1p[0] != '\0')//vlan 802.1p priority, use 802.1Q ethernet protocol
    {
        eth_proto = "-p 0x8100";
    }else {//use ipv4 for ethernet protocol
        eth_proto = "-p 0x0800";
    }
    
	//wan 802.1p mark 0-7 bit: 802.1p, 8-15 bit: queue id
	//and the wan vlan is enabled
	if(0 != entry.m_1p&&wan_vlan_enable)
	    mark = entry.m_1p&0xff;
	mark |= (entry.queueKey << 8);

	//set dscp
	if( 0 != entry.m_dscp)
	{
	    DOCMDARGVS(EBTABLES, DOWAIT, "-t %s -A %s %s %s %s %s %s %s %s %s %s -j ftos --set-ftos 0x%x", QOS_TABLE,
		    QOS_CHAIN, phyPort, eth_proto, ip_proto1, saddr, sport, daddr, dport, m_iptos, strvlan1p, entry.m_dscp);

	    if(ip_proto2)/* TCP/UDP, bored, why not set twice, any other wise idea? */
	    {
             DOCMDARGVS(EBTABLES, DOWAIT, "-t %s -A %s %s %s %s %s %s %s %s %s %s -j ftos --set-ftos 0x%x", QOS_TABLE,
		         QOS_CHAIN, phyPort, eth_proto, ip_proto2, saddr, sport, daddr, dport, m_iptos, strvlan1p, entry.m_dscp);
	    }
	}

	//set the mark
	DOCMDARGVS(EBTABLES, DOWAIT, 	"-t %s -A %s %s %s %s %s %s %s %s %s %s -j mark --set-mark 0x%x", QOS_TABLE,
		QOS_CHAIN, phyPort, eth_proto, ip_proto1, saddr, sport, daddr, dport, m_iptos, strvlan1p, mark);
	if(ip_proto2) /*OK, Here it comes again. TCP/UDP*/
	{
	  DOCMDARGVS(EBTABLES, DOWAIT, "-t %s -A %s %s %s %s %s %s %s %s %s %s -j mark --set-mark 0x%x", QOS_TABLE,
		    QOS_CHAIN, phyPort, eth_proto, ip_proto2, saddr, sport, daddr, dport, m_iptos, strvlan1p, mark);
	}

	//add filter to queue
	if(0==policy)//priority queue
	{
	     DOCMDARGVS(TC, DOWAIT, "filter add dev %s parent 1: protocol ip handle 0x%x fw classid 1:%d",
		    ifname, mark, entry.prio);
	}
	else if(1==policy)//weighted round robin
	{
	    DOCMDARGVS(TC, DOWAIT, "filter add dev %s parent 1: protocol ip handle 0x%x fw classid 1:%d00",
		    ifname, mark, entry.prio);
	}
    }

    return 0;

QOS_ERR_LABEL
    return 1;

}

/*********************************************************************
 * NAME:    setup_queue_rules
 * DESC:    Using iptables to setup rules for queue, including packet
 *          marking(dscp, 802.1p). This function doesn't affect traffic
 *          controlling, just for priority and weighted round robin
 *          queue. Suppose that the mib setting is well-formated and right.
 * ARGS:    none
 * RETURN:  0 success, others fail 
 *********************************************************************/
static int setup_qos_rules_by_iptables(unsigned char policy)
{
    MIB_CE_IP_QUEUE_RULE_T entry;
    int i = 0, EntryNum = 0;

    DOCMDINIT

    QOS_SETUP_PRINT_FUNCTION
        
    EntryNum = mib_chain_total(MIB_IP_QUEUE_RULE_TBL);

    for(; i<EntryNum; i++)
    {
	char ifname[6], phyPort[16]={0};
	char sport[20], dport[20], saddr[24], daddr[20], strmark[32];
	char *proto1=NULL, *proto2 = NULL;
	char dscp[20] = {0};
	unsigned int mark=0;

	if(!mib_chain_get(MIB_IP_QUEUE_RULE_TBL, i, (void*)&entry)||!entry.state)
	    continue;
    
	//if source ip type is 1, meaning the source ip value is DHCP
	//option 60, it proccessed in the dhcp, not here, so skip it.
	if(1==entry.srcType)
	    continue;
    
	//interface
	if (PPP_INDEX(entry.ifIndex) != 0x0f)//PPP interface
	    snprintf(ifname, 6, "ppp%u", PPP_INDEX(entry.ifIndex));
	else//vc interface
	    snprintf(ifname, 6, "vc%u", VC_INDEX(entry.ifIndex));

	//phy port, 0: none, range:1-4
	if(entry.phyPort<=4&&entry.phyPort>=1)
	    snprintf(phyPort, 16, "-i eth0_sw%d", entry.phyPort-1);
	else
	    phyPort[0] = '\0';

	//dscp match
	if(0 != entry.dscp)
	{
	    snprintf(dscp, 20, "-m dscp --dscp 0x%x", entry.dscp);
	}else{
	    dscp[0]='\0';
	}
    
	//protocol
	if(entry.protoType <0|| entry.protoType>4)//invalid protocol index
	    return 1;
	else if(entry.protoType == 4)//add by penggenyao, support two protos at the same time
	{
	    proto1 = "-p TCP";
	    proto2 = "-p UDP";
	}
	else
	    proto1 = proto2str[entry.protoType];

	//source port (range)
	if(0 == entry.protoType||1 == entry.protoType||0 == entry.dstPortStart)
	{//if protocol is icmp or none or port not set, ignore the port
	    sport[0] = '\0';
	}
	else
	{
	    if(0 != entry.srcPortEnd)
		snprintf(sport, 20, "--sport %d:%d", MIN_PORT(entry.srcPortStart, entry.srcPortEnd),
		MAX_PORT(entry.srcPortStart, entry.srcPortEnd));
	    else
		snprintf(sport, 20, "--sport %d", entry.srcPortStart);
	}

	//dest port (range)
	if(0 == entry.protoType||1 == entry.protoType||0 == entry.dstPortStart)
	{//if protocol is icmp or none or port not set, ignore the port
	    dport[0] = '\0';
	}
	else
	{
	    if(0 != entry.dstPortEnd)
		snprintf(dport, 20, "--dport %d:%d", MIN_PORT(entry.dstPortStart, entry.dstPortEnd),
		MAX_PORT(entry.dstPortStart, entry.dstPortEnd));
	    else
		snprintf(dport, 20, "--dport %d", entry.dstPortStart);
	}

	//source address
	if(0 != entry.srcip)
	    if(0 != entry.smaskbits)
		snprintf(saddr, 24, "-s %s/%d", 
			inet_ntoa(*((struct in_addr*)(&entry.srcip))), entry.smaskbits );
	    else
		snprintf(saddr, 24, "-s %s", inet_ntoa(*((struct in_addr*)(&entry.srcip))));
	else
	    saddr[0]='\0';

	//dest address
	if(0 != entry.dstip)
	    if(0 != entry.dmaskbits)
		snprintf(daddr, 24, "-d %s/%d", 
			inet_ntoa(*((struct in_addr*)(&entry.dstip))), entry.dmaskbits );
	    else
		snprintf(daddr, 24, "-d %s", inet_ntoa(*((struct in_addr*)(&entry.dstip))));
	else
	    daddr[0]='\0';

	//lan 802.1p mark, 0-7 bit
	if(0 != entry.vlan1p)
	    snprintf(strmark, 32, "-m mark --mark 0x%x", entry.vlan1p&0xff);
	else
	    strmark[0] = '\0';

	//wan 802.1p mark 0-7 bit: 802.1p, 8-15 bit: queue id
	if(0 != entry.m_1p)
	    mark = entry.m_1p&0xff;
	mark |= (entry.queueKey << 8);

	//set dscp
	if( 0 != entry.m_dscp)
	{
	    DOCMDARGVS(IPTABLES, DOWAIT, "-t mangle -A PREROUTING %s %s %s %s %s %s %s -j DSCP --set-dscp 0x%x",
		   phyPort, proto1, saddr, sport, daddr, dport, strmark, entry.m_dscp);

	    if(proto2)/* TCP/UDP, bored, why not set twice, any other wise idea? */
	    {
		    DOCMDARGVS(IPTABLES, DOWAIT, "-t mangle -A PREROUTING %s %s %s %s %s %s %s -j DSCP --set-dscp 0x%x",
		        phyPort, proto2, saddr, sport, daddr, dport, strmark, entry.m_dscp);
	    }
	}
    
	//set the mark
	DOCMDARGVS(IPTABLES, DOWAIT, "-t mangle -A PREROUTING %s %s %s %s %s %s %s -j MARK --set-mark 0x%x",
		    phyPort, proto1, saddr, sport, daddr, dport, strmark, mark);
	
	if(proto2) /*OK, Here it comes again. TCP/UDP*/
	{
	    DOCMDARGVS(IPTABLES, DOWAIT, "-t mangle -A PREROUTING %s %s %s %s %s %s %s -j MARK --set-mark 0x%x",
		    phyPort, proto2, saddr, sport, daddr, dport, strmark, mark);
	}

	//add filter to queue
	if(0==policy)//priority queue
	{
	   DOCMDARGVS(TC, DOWAIT,  "%s filter add dev %s parent 1: protocol ip handle 0x%x fw classid 1:%d",ifname, mark, entry.prio);
	}
	else if(1==policy)//weighted round robin
	{
	     DOCMDARGVS(TC, DOWAIT, "%s filter add dev %s parent 1: protocol ip handle 0x%x fw classid 1:%d00",ifname, mark, entry.prio);
	}
    }

    return 0;
}

/****************************************************************************
 * NAME:    calc_get_rate
 * DESC:    calcute the sum of priority once;
 * ARGS:    IfIndex: interface index
 * RETURN:  the num of priority, or 0 failed
 ****************************************************************************/
static int calc_get_rate(unsigned char ifIndex)
{
    MIB_CE_IP_QUEUE_CFG_T qEntry;
    int qEntryNum = 0, i = 0;
    static int rtbl[256] = {0}; 
    static int initialized = 0;
    if(0 != initialized)
	return rtbl[ifIndex];

    //initialization
    initialized = 1;
    qEntryNum = mib_chain_total(MIB_IP_QUEUE_CFG_TBL);
    for(i=0; i<qEntryNum; i++)
    {
	if(!mib_chain_get(MIB_IP_QUEUE_CFG_TBL, i, (void*)&qEntry))
	    continue;
#if 0
	if(qEntry.ifIndex <0 || qEntry.ifIndex>255)
	    continue;
#endif
	rtbl[qEntry.ifIndex] += qEntry.prio;
    }
    return rtbl[ifIndex];
}

/**************************************************************************
 * NAME:    setup_wrr_queue
 * DESC:    Using the htb qdisc to implement the wrr qdisc(surprised?), not
 *          CBQ, because the CBQ qdisc is so complicated and not very accurate.
 *          The skeleton of wrr(htb):
 *                                     HTB(root qdisc,1:)
 *                                      |
 *                                     HTB(root class,1:1)
 *                  ____________________|________________
 *                 |            |            |           |
 *                HTB          HTB          HTB         HTB
 *         (sub-cls,1:10) (sub-cls,1:20)(sub-cls,1:30)(sub-cls,1:40)
 *
 *         for example, bandwidth is 1024Kbit/s, there are three queues with 
 *         priority 3:2:1, then these queues are allocated rate and ceil is 
 *         1/2, 1/3, 1/6 of total bandwidth.
 *         This function is called when dsl synchronization is completed.
 *ARGS:    upLinkRate: dsl upstream rate.
 *RETURN:  0 success, 1 fail. 
 **************************************************************************/
static int setup_wrr_queue(unsigned int upLinkRate)
{
    MIB_CE_IP_QUEUE_CFG_T qEntry;
    MIB_CE_ATM_VC_T vcEntry;
    int i=0, qEntryNum = 0, vcEntryNum = 0;

    DOCMDINIT

    QOS_SETUP_PRINT_FUNCTION
        
    vcEntryNum = mib_chain_total(MIB_ATM_VC_TBL);
    qEntryNum  = mib_chain_total(MIB_IP_QUEUE_CFG_TBL);

    //setup basic config for every wan interface
    for(; i<vcEntryNum;i++)
    {
	char ifname[6]={0};
	char uprate[10] = {0};
	if(!mib_chain_get(MIB_ATM_VC_TBL, i, (void*)&vcEntry)||!vcEntry.qosenable)
	    continue;

	if (PPP_INDEX(vcEntry.ifIndex) != 0x0f)//PPP interface
	    snprintf(ifname, 6, "ppp%u", PPP_INDEX(vcEntry.ifIndex));
	else//vc interface
	    snprintf(ifname, 6, "vc%u", VC_INDEX(vcEntry.ifIndex));
    
	DOCMDARGVS(TC, DOWAIT, "qdisc add dev %s root handle 1: htb default 1", ifname);
	DOCMDARGVS(TC, DOWAIT, "class add dev %s parent 1: classid 1:1 htb rate %dKbit ceil %dKbit",
		ifname, upLinkRate, upLinkRate);
    }

    for(i=0; i<qEntryNum; i++)
    {
	char ifname[6];
	int prio_sum, rate = 0;

	if(!mib_chain_get(MIB_IP_QUEUE_CFG_TBL, i, (void*)&qEntry))
	    continue;

	if(0 == qEntry.enable)//disabled
	    continue;

	if (PPP_INDEX(vcEntry.ifIndex) != 0x0f)//PPP interface
	    snprintf(ifname, 6, "ppp%u", PPP_INDEX(qEntry.ifIndex));
	else//vc interface
	    snprintf(ifname, 6, "vc%u", VC_INDEX(qEntry.ifIndex));

	prio_sum = calc_get_rate(qEntry.ifIndex);
	rate     = upLinkRate*qEntry.prio/prio_sum;

	//add subclass for one queue config
	//tc class add dev $DEV parent 1:1 classid 1:$SUBID htb rate $RATE ceil $RATE
	DOCMDARGVS(TC, DOWAIT, "class add dev %s parent 1:1 classid 1:%d00 htb rate %dKbit ceil %dKbit",ifname, qEntry.prio, rate, rate);

#if 0 //commented by penggenyao, no need to add leaf qdisc, use the default?
	cmd[0] = '\0';
	//add leaf qdisc for every subclass
	//tc qdisc add dev $DEV parent 1:$SUBID handle $SUBID0 pfifo limit 10
	snprintf(cmd, QOS_CMD_BUF_LEN, "%s qdisc %s dev %s parent 1:%d0 handle %d00: pfifo limit 10",
		TC, action, ifname, qEntry.prio, qEntry.prio);
	if(0 != do_str_cmd(cmd, 1))
	    QOS_ERR_REPORT("Failed to execute %s qdisc add dev %s ... %d00 pfifo...", 
		    TC, ifname, qEntry.prio);
#endif

#if 0//COMMENTED by penggenyao, move to setup_queue_rules
	cmd[0] = '\0';
	//add filter for each class
	//tc filter add dev $DEV parent 1: protocol ip prio 0 handle $ID fw classid $CLASSID 
	snprintf(cmd, QOS_CMD_BUF_LEN, "%s filter %s dev %s parent 1: protocol ip handle %d fw classid 1:%d0",
		TC, action, ifname, qEntry.queueKey, qEntry.prio);
	if(0 != do_str_cmd(cmd, 1))
	    QOS_ERR_REPORT("Failed to execute %s filter add dev %s ... handle %d fw classid 1:%d0", 
		    TC, ifname, qEntry.queueKey, qEntry.prio);
#endif
    }
    
    //now, setup queue rules for wrr qdisc
    setup_queue_rules(1);
    return 0;
}


static int stop_wrr_queue()
{
    MIB_CE_ATM_VC_T vcEntry;
    int i=0, vcEntryNum = 0;

    DOCMDINIT
    
    QOS_SETUP_PRINT_FUNCTION
        
    vcEntryNum = mib_chain_total(MIB_ATM_VC_TBL);

    for(; i<vcEntryNum;i++)
    {
	char ifname[6]={0};
	if(!mib_chain_get(MIB_ATM_VC_TBL, i, (void*)&vcEntry))
	    continue;

	if (PPP_INDEX(vcEntry.ifIndex) != 0x0f)//PPP interface
	    snprintf(ifname, 6, "ppp%u", PPP_INDEX(vcEntry.ifIndex));
	else//vc interface
	    snprintf(ifname, 6, "vc%u", VC_INDEX(vcEntry.ifIndex));

	DOCMDARGVS(TC, DOWAIT, "qdisc del dev %s root handle 1: htb default 1", ifname);
    }

    //clean up ebtables rules
    DOCMDARGVS(EBTABLES, DOWAIT, "-t %s -F %s", QOS_TABLE, QOS_CHAIN);
    return 0;
}

//return value: 1, some errors happen, 0 sucessful
int setup_wrr()
{
    Modem_LinkSpeed vLs;
    unsigned char policy = 0, ret = 0;
    static int once = 0;
    static unsigned int dsl_uprate = 0;

    // QOS_SETUP_PRINT_FUNCTION

    //policy==0, priority queue, dont setup, quit function
    if(!mib_get(MIB_QOS_QUEUE_POLICY, &policy)||0==policy)
	return 0;

    ret = adsl_drv_get(RLCM_GET_LINK_SPEED, (void *)&vLs, RLCM_GET_LINK_SPEED_SIZE);
    //QOS_SETUP_PRINT("ret=%d, policy=%d, DSL upstream rate: %d\n", ret, policy, vLs.upstreamRate);

    if (ret)
    {
	if(0 != vLs.upstreamRate)//setup
	{
	    if(dsl_uprate == vLs.upstreamRate)//need not setup
		return 0;
	    if(0==dsl_uprate)//first setuping
	    {
setup:
		if(setup_wrr_queue(vLs.upstreamRate))
		{
		    //cleanup
		    stop_wrr_queue();
		    return 1;
		}
		dsl_uprate = vLs.upstreamRate;
	    } else if( dsl_uprate != vLs.upstreamRate) {//resetup 
		stop_wrr_queue();
		goto setup;
	    }
	} else if( 0!= dsl_uprate){//stop wrr 
	    stop_wrr_queue();
	    dsl_uprate == vLs.upstreamRate;
	}
    }
    return 0;
}
/*******************************************************************************
 *NAME:    setup_prio_queue
 *DESC:    if configurating policy to priority queue,
 *         create priority queues based on struct MIB_CE_IP_QUEUE_CFG_T setting,
 *         The default number of queue is four,1-4. 
 *ARGS:    None
 *RETURN:  0 success, others fail
 *******************************************************************************/
int setup_prio_queue()
{
    MIB_CE_IP_QUEUE_CFG_T qEntry;
    MIB_CE_ATM_VC_T       vcEntry;
    int i=0, qEntryNum = 0, vcEntryNum = 0;
    char ifname[6];

    DOCMDINIT
        
    QOS_SETUP_PRINT_FUNCTION
        
    vcEntryNum = mib_chain_total(MIB_ATM_VC_TBL);
    qEntryNum  = mib_chain_total(MIB_IP_QUEUE_CFG_TBL);

    //setup basic config for every wan interface
    for(; i<vcEntryNum;i++)
    {
	if(!mib_chain_get(MIB_ATM_VC_TBL, i, (void*)&vcEntry)||!vcEntry.qosenable)
	    continue;

	//get the interface name(?)
	if (PPP_INDEX(vcEntry.ifIndex) != 0x0f)//PPP interface
	    snprintf(ifname, 6, "ppp%u", PPP_INDEX(vcEntry.ifIndex));
	else//vc interface
	    snprintf(ifname, 6, "vc%u", VC_INDEX(vcEntry.ifIndex));

	// other args? Dont care now, maybe modified in future
	DOCMDARGVS(TC,DOWAIT, "qdisc add dev %s root handle 1: prio bands 4",ifname);
	
    }

#if 0
    for(i=0; i<qEntryNum; i++)
    {
	if(!mib_chain_get(MIB_IP_QUEUE_CFG_TBL, i, (void*)&qEntry))
	    continue;

	if (PPP_INDEX(vcEntry.ifIndex) != 0x0f)//PPP interface
	    snprintf(ifname, 6, "ppp%u", PPP_INDEX(vcEntry.ifIndex));
	else//vc interface
	    snprintf(ifname, 6, "vc%u", VC_INDEX(vcEntry.ifIndex));

	//setup the queue, not include the filter rules of the queue
	if(qEntry.prio<1 || qEntry.prio>4)
	    QOS_ERR_REPORT("The priority of queue %d(queue key) less than 1 or more than 4.", qEntry.queueKey);
	cmd[0] = '\0';
	snprintf(cmd, QOS_CMD_BUF_LEN, "%s filter add dev %s parent 1: protocol ip handle %d fw classid 1:%d",
		TC, qEntry.ifname, qEntry.queueKey, qEntry.prio);
	if(0!=do_str_cmd(cmd,1))
	    QOS_ERR_REPORT("Failed to execute %s filter add dev %s ... fw classid 1:%d", 
		    TC, qEntry.ifname, qEntry.prio);
    } 
#endif

    //setup ip qos queue rules for pq
    setup_queue_rules(0);

    return 0;

err:
    printf("ERROR: %s\n", err_msg);
    return 1;
}


/**************************************************************************
 * NAME:    setupIPQos
 * DESC:    if no queue config, setup traffic controlling, if any setup
 *          priority queues and the queue rules, NOTE that we don't setup
 *          the wrr queues here, we need the DSL upstream rate, so deal with
 *          it in the startup proccess while loop, see that.
 *ARGS:     NONE
 *RETURN:   NONE
 **************************************************************************/ 
void setupIPQos()
{
    int queue_num = 0, traffictl_rule_num=0;
    unsigned char policy=0;

    QOS_SETUP_PRINT_FUNCTION

	queue_num = mib_chain_total(MIB_IP_QUEUE_CFG_TBL);
    traffictl_rule_num = mib_chain_total(MIB_TRAFFICTL_TBL);
    mib_get(MIB_QOS_QUEUE_POLICY, (void*)&policy);

    //create the qos chain for easy operation
    //ebtables -t broute -N qos_chain
    va_cmd(EBTABLES, 4, 1, "-t", QOS_TABLE, "-N", QOS_CHAIN);
    //insert into BROUTING chain
    va_cmd(EBTABLES, 7, 1, "-t", QOS_TABLE, "-I", "BROUTING", "1", "-j", QOS_CHAIN);

    //set up vlan qos
    setup_lan_port(1);

    //if no queue and traffic controlling rule is not empty,
    //setup traffic controlling else setup priority queue if
    //policy is set to 0, and setup wrr when dsl is up if policy=1
    if(0 == queue_num&&0!=traffictl_rule_num)
    {
	setup_traffic_control();
    } else {
	if(0==policy) 
	    setup_prio_queue();
    }

    return;
}


unsigned int file_read_number(const char *filename) 
{
	FILE *fp;
	char buffer[10];
	unsigned int mask = 0;
	
	fp = fopen(filename, "r");
	
	if (!fp) {		
		return 0;
	}

	fgets(buffer, sizeof(buffer), fp);
	if (1 != sscanf(buffer, "%u", &mask)) {
		goto out;
	}
	fclose(fp);
	return mask;
	
out:
	fclose(fp);
	return 0;
	
}

int usb_get_partition_name(int id, char *namebuf, int buflen) 
{
#ifdef CONFIG_CT_USBMOUNT_DIRECTORY
	if (id <16) {
		return snprintf(namebuf, buflen, "usb1_%d",id);
	}else{
		return snprintf(namebuf, buflen, "usb2_%d", id - 16);
	}
#else
	if (id == 0) {
		return snprintf(namebuf, buflen, "sda");
	} else if (id == 16) {
		return snprintf(namebuf, buflen, "sdb");
	} if (id < 16) {
		return snprintf(namebuf, buflen, "sda%d", id);
	} else if ((id > 16) && (id < 32)) {
		return snprintf(namebuf, buflen, "sdb%d", id - 16);
	}
#endif
	return -1;
}


//const char USB_CFG_FILENAME[] = "ctce8_device.cfg";
const char USB_CFG_FILENAME[] = "ctce8.cfg";

static unsigned long sn_matrix[8][8] = {
{0x111C3D60, 0x0B5D60DC, 0x05C94DB0, 0x08A9F558, 0x154848D0, 0x001504A2, 0x0D0C652A, 0x141BE95C},
{0x034EAC58, 0x3B079DAA, 0x09FFFBFA, 0x003F9E94, 0x11618D09, 0x0D5E558A, 0x2577BE5C, 0x003E7AF8},
{0x008AE4C9, 0x0855C770, 0x34143744, 0x1AF6F0A8, 0x05686380, 0x11BCF974, 0x1F96A973, 0x0D81EFE7},
{0x2DB9F622, 0x26218B68, 0x16F02844, 0x09B62188, 0x2524312E, 0x0AF9AB28, 0x2360D510, 0x0018C501},
{0x024CCE7F, 0x0568C990, 0x03AEA55A, 0x0B6AD558, 0x0FDA28A2, 0x12F9E4FC, 0x24252765, 0x111D6B0F},
{0x15D4E175, 0x10AA5B93, 0x13C6CDA0, 0x1473DF94, 0x1AAEE3E0, 0x258EDC1B, 0x19F410CF, 0x000654B8},
{0x04D697F6, 0x141C44B1, 0x0E32F287, 0x0622CA9C, 0x1186804E, 0x0031FD64, 0x101ED862, 0x20197942},
{0x0030AC6E, 0x2A8F8EBD, 0x01918510, 0x02BDF1FC, 0x0C551F68, 0x0C330868, 0x0C0434B6, 0x08CD55A6}};

void encode(char *buf, size_t *buflen) 
{
	/* do some encode task here... */
	int		pd = 0;
	char*	p = buf;
	if(p == NULL || buflen == 0)return;
	while(pd <= *buflen){*p ^= ((unsigned char*)sn_matrix)[pd%256] ; p++; pd++;}
}

static void decode(char *buf, size_t *buflen) 
{
	/* do some decode task here... */
	encode(buf, buflen);
}

/**************************************************************************
 * NAME:    usbRestore
 * DESC:    check if USB is mounted and config file exist. If yes, then go ahead and use it 
 *          for restore configuration.
 *ARGS:     NONE
 *RETURN:   NONE
 **************************************************************************/ 
int usbRestore(void) {
	
	int tmp, rv;
	char buffer[10], dstname[60];
	char cpbuf[256];
	struct file_pipe	pipe;
	unsigned int mask;

	fprintf(stderr, "ENTER %s\n", __FUNCTION__);
	mask = file_read_number(USB_MNT_FILE);

	for (tmp = 0; tmp < 32; tmp++) {
		if (!(mask & (1 << tmp)))
			continue;		
		usb_get_partition_name(tmp, buffer, sizeof(buffer));
		//snprintf(dstname, sizeof(dstname), "%s/%s/%s/%s", USB_MNT_DIR, buffer, BACKUP_DIRNAME, USB_CFG_FILENAME);
		snprintf(dstname, sizeof(dstname), "%s/%s/%s", USB_MNT_DIR, buffer, USB_CFG_FILENAME);
		if (!is_file(dstname))
			continue;
		fprintf(stderr, "USB: found %s\n", dstname);
		pipe.buffer = cpbuf;
		pipe.bufsize = sizeof cpbuf;
		pipe.func = decode;
	
		rv = file_copy_pipe(dstname, CONFIG_XMLFILE, &pipe);
		//fprintf(stderr, "USB: mv %s -> %s\n", dstname, CONFIG_XMLFILE);
		if (rv != 0) {
			fprintf(stderr, "copy failed (%d)\n",rv);
			goto err_file;
		}

		// do restore here...
		fprintf(stderr, "USB: start restore...");
		rv = call_cmd("/bin/LoadxmlConfig", 0, 1);
		fprintf(stderr, "\n\n\nUSB_Resore ");
		if (rv) {
			fprintf(stderr, "failed! (%d)\n",rv);
		} else {
			fprintf(stderr, "OK! Rebooting\n\n\n");
		}
		sync();
		cmd_reboot();
		return 0;
	}

err_file:
	// 
	return -1;	

}


